/*! For license information please see module.js.LICENSE.txt */
define(["@grafana/data","react","@emotion/css","@grafana/ui","rxjs","@grafana/runtime","lodash","moment","redux","react-redux"],((e,t,r,n,o,i,a,s,l,u)=>(()=>{var c={8572:(e,t,r)=>{"use strict";r.r(t),r.d(t,{AND:()=>v,AS:()=>f,ASC:()=>c,BY:()=>l,COMPARISON_OPERATORS:()=>O,DESC:()=>u,EQUALS:()=>m,FROM:()=>o,GROUP:()=>a,LIMIT:()=>d,LOGICAL_OPERATORS:()=>y,NOT_EQUALS:()=>b,OR:()=>g,ORDER:()=>s,SCHEMA:()=>h,SELECT:()=>n,STD_OPERATORS:()=>E,WHERE:()=>i,WITH:()=>p,conf:()=>S,language:()=>T});const n="select",o="from",i="where",a="group",s="order",l="by",u="desc",c="asc",d="limit",p="with",f="as",h="schema",v="AND",g="OR",y=[v,g],m="=",b="!=",O=[m,b],E=[...O],S={comments:{lineComment:"--",blockComment:["/*","*/"]},brackets:[["{","}"],["[","]"],["(",")"]],autoClosingPairs:[{open:"{",close:"}"},{open:"[",close:"]"},{open:"(",close:")"},{open:'"',close:'"'},{open:"'",close:"'"}],surroundingPairs:[{open:"{",close:"}"},{open:"[",close:"]"},{open:"(",close:")"},{open:'"',close:'"'},{open:"'",close:"'"}]},T={defaultToken:"",tokenPostfix:".sql",ignoreCase:!0,brackets:[{open:"[",close:"]",token:"delimiter.square"},{open:"(",close:")",token:"delimiter.parenthesis"}],keywords:["ABORT","ABSOLUTE","ACTION","ADA","ADD","AFTER","ALL","ALLOCATE","ALTER","ALWAYS","ANALYZE","AND","ANY","ARE","AS","ASC","ASSERTION","AT","ATTACH","AUTHORIZATION","AUTOINCREMENT","AVG","BACKUP","BEFORE","BEGIN","BETWEEN","BIT","BIT_LENGTH","BOTH","BREAK","BROWSE","BULK","BY","CASCADE","CASCADED","CASE","CAST","CATALOG","CHAR","CHARACTER","CHARACTER_LENGTH","CHAR_LENGTH","CHECK","CHECKPOINT","CLOSE","CLUSTERED","COALESCE","COLLATE","COLLATION","COLUMN","COMMIT","COMPUTE","CONFLICT","CONNECT","CONNECTION","CONSTRAINT","CONSTRAINTS","CONTAINS","CONTAINSTABLE","CONTINUE","CONVERT","CORRESPONDING","COUNT","CREATE","CROSS","CURRENT","CURRENT_DATE","CURRENT_TIME","CURRENT_TIMESTAMP","CURRENT_USER","CURSOR","DATABASE","DATE","DAY","DBCC","DEALLOCATE","DEC","DECIMAL","DECLARE","DEFAULT","DEFERRABLE","DEFERRED","DELETE","DENY","DESC","DESCRIBE","DESCRIPTOR","DETACH","DIAGNOSTICS","DISCONNECT","DISK","DISTINCT","DISTRIBUTED","DO","DOMAIN","DOUBLE","DROP","DUMP","EACH","ELSE","END","END-EXEC","ERRLVL","ESCAPE","EXCEPT","EXCEPTION","EXCLUDE","EXCLUSIVE","EXEC","EXECUTE","EXISTS","EXIT","EXPLAIN","EXTERNAL","EXTRACT","FAIL","FALSE","FETCH","FILE","FILLFACTOR","FILTER","FIRST","FLOAT","FOLLOWING","FOR","FOREIGN","FORTRAN","FOUND","FREETEXT","FREETEXTTABLE","FROM","FULL","FUNCTION","GENERATED","GET","GLOB","GLOBAL","GO","GOTO","GRANT","GROUP","GROUPS","HAVING","HOLDLOCK","HOUR","IDENTITY","IDENTITYCOL","IDENTITY_INSERT","IF","IGNORE","IMMEDIATE","IN","INCLUDE","INDEX","INDEXED","INDICATOR","INITIALLY","INNER","INPUT","INSENSITIVE","INSERT","INSTEAD","INT","INTEGER","INTERSECT","INTERVAL","INTO","IS","ISNULL","ISOLATION","JOIN","KEY","KILL","LANGUAGE","LAST","LEADING","LEFT","LEVEL","LIKE","LIMIT","LINENO","LOAD","LOCAL","LOWER","MATCH","MATERIALIZED","MAX","MERGE","MIN","MINUTE","MODULE","MONTH","NAMES","NATIONAL","NATURAL","NCHAR","NEXT","NO","NOCHECK","NONCLUSTERED","NONE","NOT","NOTHING","NOTNULL","NULL","NULLIF","NULLS","NUMERIC","OCTET_LENGTH","OF","OFF","OFFSET","OFFSETS","ON","ONLY","OPEN","OPENDATASOURCE","OPENQUERY","OPENROWSET","OPENXML","OPTION","OR","ORDER","OTHERS","OUTER","OUTPUT","OVER","OVERLAPS","PAD","PARTIAL","PARTITION","PASCAL","PERCENT","PIVOT","PLAN","POSITION","PRAGMA","PRECEDING","PRECISION","PREPARE","PRESERVE","PRIMARY","PRINT","PRIOR","PRIVILEGES","PROC","PROCEDURE","PUBLIC","QUERY","RAISE","RAISERROR","RANGE","READ","READTEXT","REAL","RECONFIGURE","RECURSIVE","REFERENCES","REGEXP","REINDEX","RELATIVE","RELEASE","RENAME","REPLACE","REPLICATION","RESTORE","RESTRICT","RETURN","RETURNING","REVERT","REVOKE","RIGHT","ROLLBACK","ROW","ROWCOUNT","ROWGUIDCOL","ROWS","RULE","SAVE","SAVEPOINT","SCHEMA","SCROLL","SECOND","SECTION","SECURITYAUDIT","SELECT","SEMANTICKEYPHRASETABLE","SEMANTICSIMILARITYDETAILSTABLE","SEMANTICSIMILARITYTABLE","SESSION","SESSION_USER","SET","SETUSER","SHUTDOWN","SIZE","SMALLINT","SOME","SPACE","SQL","SQLCA","SQLCODE","SQLERROR","SQLSTATE","SQLWARNING","STATISTICS","SUBSTRING","SUM","SYSTEM_USER","TABLE","TABLESAMPLE","TEMP","TEMPORARY","TEXTSIZE","THEN","TIES","TIME","TIMESTAMP","TIMEZONE_HOUR","TIMEZONE_MINUTE","TO","TOP","TRAILING","TRAN","TRANSACTION","TRANSLATE","TRANSLATION","TRIGGER","TRIM","TRUE","TRUNCATE","TRY_CONVERT","TSEQUAL","UNBOUNDED","UNION","UNIQUE","UNKNOWN","UNPIVOT","UPDATE","UPDATETEXT","UPPER","USAGE","USE","USER","USING","VACUUM","VALUE","VALUES","VARCHAR","VARYING","VIEW","VIRTUAL","WAITFOR","WHEN","WHENEVER","WHERE","WHILE","WINDOW","WITH","WITHIN GROUP","WITHOUT","WORK","WRITE","WRITETEXT","YEAR","ZONE"],operators:["EXCEPT","INTERSECT","UNION","APPLY","CROSS","FULL","INNER","JOIN","LEFT","OUTER","RIGHT","CONTAINS","FREETEXT","IS","NULL","PIVOT","UNPIVOT","MATCHED"],logicalOperators:["ALL","AND","ANY","BETWEEN","EXISTS","IN","LIKE","NOT","OR","SOME"],comparisonOperators:["<>",">","<",">=","<=","=","!=","&","~","^","%"],builtinFunctions:["AVG","CHECKSUM_AGG","COUNT","COUNT_BIG","GROUPING","GROUPING_ID","MAX","MIN","SUM","STDEV","STDEVP","VAR","VARP","CUME_DIST","FIRST_VALUE","LAG","LAST_VALUE","LEAD","PERCENTILE_CONT","PERCENTILE_DISC","PERCENT_RANK","COLLATE","COLLATIONPROPERTY","TERTIARY_WEIGHTS","FEDERATION_FILTERING_VALUE","CAST","CONVERT","PARSE","TRY_CAST","TRY_CONVERT","TRY_PARSE","ASYMKEY_ID","ASYMKEYPROPERTY","CERTPROPERTY","CERT_ID","CRYPT_GEN_RANDOM","DECRYPTBYASYMKEY","DECRYPTBYCERT","DECRYPTBYKEY","DECRYPTBYKEYAUTOASYMKEY","DECRYPTBYKEYAUTOCERT","DECRYPTBYPASSPHRASE","ENCRYPTBYASYMKEY","ENCRYPTBYCERT","ENCRYPTBYKEY","ENCRYPTBYPASSPHRASE","HASHBYTES","IS_OBJECTSIGNED","KEY_GUID","KEY_ID","KEY_NAME","SIGNBYASYMKEY","SIGNBYCERT","SYMKEYPROPERTY","VERIFYSIGNEDBYCERT","VERIFYSIGNEDBYASYMKEY","CURSOR_STATUS","DATALENGTH","IDENT_CURRENT","IDENT_INCR","IDENT_SEED","IDENTITY","SQL_VARIANT_PROPERTY","CURRENT_TIMESTAMP","DATEADD","DATEDIFF","DATEFROMPARTS","DATENAME","DATEPART","DATETIME2FROMPARTS","DATETIMEFROMPARTS","DATETIMEOFFSETFROMPARTS","DAY","EOMONTH","GETDATE","GETUTCDATE","ISDATE","MONTH","SMALLDATETIMEFROMPARTS","SWITCHOFFSET","SYSDATETIME","SYSDATETIMEOFFSET","SYSUTCDATETIME","TIMEFROMPARTS","TODATETIMEOFFSET","YEAR","CHOOSE","COALESCE","IIF","NULLIF","ABS","ACOS","ASIN","ATAN","ATN2","CEILING","COS","COT","DEGREES","EXP","FLOOR","LOG","LOG10","PI","POWER","RADIANS","RAND","ROUND","SIGN","SIN","SQRT","SQUARE","TAN","APP_NAME","APPLOCK_MODE","APPLOCK_TEST","ASSEMBLYPROPERTY","COL_LENGTH","COL_NAME","COLUMNPROPERTY","DATABASE_PRINCIPAL_ID","DATABASEPROPERTYEX","DB_ID","DB_NAME","FILE_ID","FILE_IDEX","FILE_NAME","FILEGROUP_ID","FILEGROUP_NAME","FILEGROUPPROPERTY","FILEPROPERTY","FULLTEXTCATALOGPROPERTY","FULLTEXTSERVICEPROPERTY","INDEX_COL","INDEXKEY_PROPERTY","INDEXPROPERTY","OBJECT_DEFINITION","OBJECT_ID","OBJECT_NAME","OBJECT_SCHEMA_NAME","OBJECTPROPERTY","OBJECTPROPERTYEX","ORIGINAL_DB_NAME","PARSENAME","SCHEMA_ID","SCHEMA_NAME","SCOPE_IDENTITY","SERVERPROPERTY","STATS_DATE","TYPE_ID","TYPE_NAME","TYPEPROPERTY","DENSE_RANK","NTILE","RANK","ROW_NUMBER","PUBLISHINGSERVERNAME","OPENDATASOURCE","OPENQUERY","OPENROWSET","OPENXML","CERTENCODED","CERTPRIVATEKEY","CURRENT_USER","HAS_DBACCESS","HAS_PERMS_BY_NAME","IS_MEMBER","IS_ROLEMEMBER","IS_SRVROLEMEMBER","LOGINPROPERTY","ORIGINAL_LOGIN","PERMISSIONS","PWDENCRYPT","PWDCOMPARE","SESSION_USER","SESSIONPROPERTY","SUSER_ID","SUSER_NAME","SUSER_SID","SUSER_SNAME","SYSTEM_USER","USER","USER_ID","USER_NAME","ASCII","CHAR","CHARINDEX","CONCAT","DIFFERENCE","FORMAT","LEFT","LEN","LOWER","LTRIM","NCHAR","PATINDEX","QUOTENAME","REPLACE","REPLICATE","REVERSE","RIGHT","RTRIM","SOUNDEX","SPACE","STR","STUFF","SUBSTRING","UNICODE","UPPER","BINARY_CHECKSUM","CHECKSUM","CONNECTIONPROPERTY","CONTEXT_INFO","CURRENT_REQUEST_ID","ERROR_LINE","ERROR_NUMBER","ERROR_MESSAGE","ERROR_PROCEDURE","ERROR_SEVERITY","ERROR_STATE","FORMATMESSAGE","GETANSINULL","GET_FILESTREAM_TRANSACTION_CONTEXT","HOST_ID","HOST_NAME","ISNULL","ISNUMERIC","MIN_ACTIVE_ROWVERSION","NEWID","NEWSEQUENTIALID","ROWCOUNT_BIG","XACT_STATE","TEXTPTR","TEXTVALID","COLUMNS_UPDATED","EVENTDATA","TRIGGER_NESTLEVEL","UPDATE","CHANGETABLE","CHANGE_TRACKING_CONTEXT","CHANGE_TRACKING_CURRENT_VERSION","CHANGE_TRACKING_IS_COLUMN_IN_MASK","CHANGE_TRACKING_MIN_VALID_VERSION","CONTAINSTABLE","FREETEXTTABLE","SEMANTICKEYPHRASETABLE","SEMANTICSIMILARITYDETAILSTABLE","SEMANTICSIMILARITYTABLE","FILETABLEROOTPATH","GETFILENAMESPACEPATH","GETPATHLOCATOR","PATHNAME","GET_TRANSMISSION_STATUS"],builtinVariables:["@@DATEFIRST","@@DBTS","@@LANGID","@@LANGUAGE","@@LOCK_TIMEOUT","@@MAX_CONNECTIONS","@@MAX_PRECISION","@@NESTLEVEL","@@OPTIONS","@@REMSERVER","@@SERVERNAME","@@SERVICENAME","@@SPID","@@TEXTSIZE","@@VERSION","@@CURSOR_ROWS","@@FETCH_STATUS","@@DATEFIRST","@@PROCID","@@ERROR","@@IDENTITY","@@ROWCOUNT","@@TRANCOUNT","@@CONNECTIONS","@@CPU_BUSY","@@IDLE","@@IO_BUSY","@@PACKET_ERRORS","@@PACK_RECEIVED","@@PACK_SENT","@@TIMETICKS","@@TOTAL_ERRORS","@@TOTAL_READ","@@TOTAL_WRITE"],pseudoColumns:["$ACTION","$IDENTITY","$ROWGUID","$PARTITION"],tokenizer:{root:[{include:"@templateVariables"},{include:"@macros"},{include:"@comments"},{include:"@whitespace"},{include:"@pseudoColumns"},{include:"@numbers"},{include:"@strings"},{include:"@complexIdentifiers"},{include:"@scopes"},{include:"@schemaTable"},[/[;,.]/,"delimiter"],[/[()]/,"@brackets"],[/[\w@#$|<|>|=|!|%|&|+|\|-|*|/|~|^]+/,{cases:{"@operators":"operator","@comparisonOperators":"operator","@logicalOperators":"operator","@builtinVariables":"predefined","@builtinFunctions":"predefined","@keywords":"keyword","@default":"identifier"}}]],templateVariables:[[/\$[a-zA-Z0-9]+/,"variable"]],macros:[[/\$__[a-zA-Z0-9-_]+/,"type"]],schemaTable:[[/(\w+)\./,"identifier"],[/(\w+\.\w+)/,"identifier"]],whitespace:[[/\s+/,"white"]],comments:[[/--+.*/,"comment"],[/\/\*/,{token:"comment.quote",next:"@comment"}]],comment:[[/[^*/]+/,"comment"],[/\*\//,{token:"comment.quote",next:"@pop"}],[/./,"comment"]],pseudoColumns:[[/[$][A-Za-z_][\w@#$]*/,{cases:{"@pseudoColumns":"predefined","@default":"identifier"}}]],numbers:[[/0[xX][0-9a-fA-F]*/,"number"],[/[$][+-]*\d*(\.\d*)?/,"number"],[/((\d+(\.\d*)?)|(\.\d+))([eE][\-+]?\d+)?/,"number"]],strings:[[/N'/,{token:"string",next:"@string"}],[/'/,{token:"string",next:"@string"}]],string:[[/[^']+/,"string"],[/''/,"string"],[/'/,{token:"string",next:"@pop"}]],complexIdentifiers:[[/\[/,{token:"identifier.quote",next:"@bracketedIdentifier"}],[/"/,{token:"identifier.quote",next:"@quotedIdentifier"}]],bracketedIdentifier:[[/[^\]]+/,"identifier"],[/]]/,"identifier"],[/]/,{token:"identifier.quote",next:"@pop"}]],quotedIdentifier:[[/[^"]+/,"identifier"],[/""/,"identifier"],[/"/,{token:"identifier.quote",next:"@pop"}]],scopes:[[/BEGIN\s+(DISTRIBUTED\s+)?TRAN(SACTION)?\b/i,"keyword"],[/BEGIN\s+TRY\b/i,{token:"keyword.try"}],[/END\s+TRY\b/i,{token:"keyword.try"}],[/BEGIN\s+CATCH\b/i,{token:"keyword.catch"}],[/END\s+CATCH\b/i,{token:"keyword.catch"}],[/(BEGIN|CASE)\b/i,{token:"keyword.block"}],[/END\b/i,{token:"keyword.block"}],[/WHEN\b/i,{token:"keyword.choice"}],[/THEN\b/i,{token:"keyword.choice"}]]}}},3523:e=>{var t=function(){"use strict";function e(e,t){return null!=t&&e instanceof t}var t,r,n;try{t=Map}catch(e){t=function(){}}try{r=Set}catch(e){r=function(){}}try{n=Promise}catch(e){n=function(){}}function o(i,s,l,u,c){"object"==typeof s&&(l=s.depth,u=s.prototype,c=s.includeNonEnumerable,s=s.circular);var d=[],p=[],f="undefined"!=typeof Buffer;return void 0===s&&(s=!0),void 0===l&&(l=1/0),function i(l,h){if(null===l)return null;if(0===h)return l;var v,g;if("object"!=typeof l)return l;if(e(l,t))v=new t;else if(e(l,r))v=new r;else if(e(l,n))v=new n((function(e,t){l.then((function(t){e(i(t,h-1))}),(function(e){t(i(e,h-1))}))}));else if(o.__isArray(l))v=[];else if(o.__isRegExp(l))v=new RegExp(l.source,a(l)),l.lastIndex&&(v.lastIndex=l.lastIndex);else if(o.__isDate(l))v=new Date(l.getTime());else{if(f&&Buffer.isBuffer(l))return v=Buffer.allocUnsafe?Buffer.allocUnsafe(l.length):new Buffer(l.length),l.copy(v),v;e(l,Error)?v=Object.create(l):void 0===u?(g=Object.getPrototypeOf(l),v=Object.create(g)):(v=Object.create(u),g=u)}if(s){var y=d.indexOf(l);if(-1!=y)return p[y];d.push(l),p.push(v)}for(var m in e(l,t)&&l.forEach((function(e,t){var r=i(t,h-1),n=i(e,h-1);v.set(r,n)})),e(l,r)&&l.forEach((function(e){var t=i(e,h-1);v.add(t)})),l){var b;g&&(b=Object.getOwnPropertyDescriptor(g,m)),b&&null==b.set||(v[m]=i(l[m],h-1))}if(Object.getOwnPropertySymbols){var O=Object.getOwnPropertySymbols(l);for(m=0;m<O.length;m++){var E=O[m];(!(T=Object.getOwnPropertyDescriptor(l,E))||T.enumerable||c)&&(v[E]=i(l[E],h-1),T.enumerable||Object.defineProperty(v,E,{enumerable:!1}))}}if(c){var S=Object.getOwnPropertyNames(l);for(m=0;m<S.length;m++){var T,_=S[m];(T=Object.getOwnPropertyDescriptor(l,_))&&T.enumerable||(v[_]=i(l[_],h-1),Object.defineProperty(v,_,{enumerable:!1}))}}return v}(i,l)}function i(e){return Object.prototype.toString.call(e)}function a(e){var t="";return e.global&&(t+="g"),e.ignoreCase&&(t+="i"),e.multiline&&(t+="m"),t}return o.clonePrototype=function(e){if(null===e)return null;var t=function(){};return t.prototype=e,new t},o.__objToStr=i,o.__isDate=function(e){return"object"==typeof e&&"[object Date]"===i(e)},o.__isArray=function(e){return"object"==typeof e&&"[object Array]"===i(e)},o.__isRegExp=function(e){return"object"==typeof e&&"[object RegExp]"===i(e)},o.__getRegExpFlags=a,o}();e.exports&&(e.exports=t)},4221:(e,t,r)=>{"use strict";var n=r(1882),o={"text/plain":"Text","text/html":"Url",default:"Text"};e.exports=function(e,t){var r,i,a,s,l,u,c=!1;t||(t={}),r=t.debug||!1;try{if(a=n(),s=document.createRange(),l=document.getSelection(),(u=document.createElement("span")).textContent=e,u.style.all="unset",u.style.position="fixed",u.style.top=0,u.style.clip="rect(0, 0, 0, 0)",u.style.whiteSpace="pre",u.style.webkitUserSelect="text",u.style.MozUserSelect="text",u.style.msUserSelect="text",u.style.userSelect="text",u.addEventListener("copy",(function(n){if(n.stopPropagation(),t.format)if(n.preventDefault(),void 0===n.clipboardData){r&&console.warn("unable to use e.clipboardData"),r&&console.warn("trying IE specific stuff"),window.clipboardData.clearData();var i=o[t.format]||o.default;window.clipboardData.setData(i,e)}else n.clipboardData.clearData(),n.clipboardData.setData(t.format,e);t.onCopy&&(n.preventDefault(),t.onCopy(n.clipboardData))})),document.body.appendChild(u),s.selectNodeContents(u),l.addRange(s),!document.execCommand("copy"))throw new Error("copy command was unsuccessful");c=!0}catch(n){r&&console.error("unable to copy using execCommand: ",n),r&&console.warn("trying IE specific stuff");try{window.clipboardData.setData(t.format||"text",e),t.onCopy&&t.onCopy(window.clipboardData),c=!0}catch(n){r&&console.error("unable to copy using clipboardData: ",n),r&&console.error("falling back to prompt"),i=function(e){var t=(/mac os x/i.test(navigator.userAgent)?"⌘":"Ctrl")+"+C";return e.replace(/#{\s*key\s*}/g,t)}("message"in t?t.message:"Copy to clipboard: #{key}, Enter"),window.prompt(i,e)}}finally{l&&("function"==typeof l.removeRange?l.removeRange(s):l.removeAllRanges()),u&&document.body.removeChild(u),a()}return c}},9083:(e,t,r)=>{var n;!function(){"use strict";var o=!("undefined"==typeof window||!window.document||!window.document.createElement),i={canUseDOM:o,canUseWorkers:"undefined"!=typeof Worker,canUseEventListeners:o&&!(!window.addEventListener&&!window.attachEvent),canUseViewport:o&&!!window.screen};void 0===(n=function(){return i}.call(t,r,t,e))||(e.exports=n)}()},1510:e=>{"use strict";e.exports=function e(t,r){if(t===r)return!0;if(t&&r&&"object"==typeof t&&"object"==typeof r){if(t.constructor!==r.constructor)return!1;var n,o,i;if(Array.isArray(t)){if((n=t.length)!=r.length)return!1;for(o=n;0!=o--;)if(!e(t[o],r[o]))return!1;return!0}if(t.constructor===RegExp)return t.source===r.source&&t.flags===r.flags;if(t.valueOf!==Object.prototype.valueOf)return t.valueOf()===r.valueOf();if(t.toString!==Object.prototype.toString)return t.toString()===r.toString();if((n=(i=Object.keys(t)).length)!==Object.keys(r).length)return!1;for(o=n;0!=o--;)if(!Object.prototype.hasOwnProperty.call(r,i[o]))return!1;for(o=n;0!=o--;){var a=i[o];if(!("_owner"===a&&t.$$typeof||e(t[a],r[a])))return!1}return!0}return t!=t&&r!=r}},9874:(e,t,r)=>{"use strict";var n=r(300),o={childContextTypes:!0,contextType:!0,contextTypes:!0,defaultProps:!0,displayName:!0,getDefaultProps:!0,getDerivedStateFromError:!0,getDerivedStateFromProps:!0,mixins:!0,propTypes:!0,type:!0},i={name:!0,length:!0,prototype:!0,caller:!0,callee:!0,arguments:!0,arity:!0},a={$$typeof:!0,compare:!0,defaultProps:!0,displayName:!0,propTypes:!0,type:!0},s={};function l(e){return n.isMemo(e)?a:s[e.$$typeof]||o}s[n.ForwardRef]={$$typeof:!0,render:!0,defaultProps:!0,displayName:!0,propTypes:!0},s[n.Memo]=a;var u=Object.defineProperty,c=Object.getOwnPropertyNames,d=Object.getOwnPropertySymbols,p=Object.getOwnPropertyDescriptor,f=Object.getPrototypeOf,h=Object.prototype;e.exports=function e(t,r,n){if("string"!=typeof r){if(h){var o=f(r);o&&o!==h&&e(t,o,n)}var a=c(r);d&&(a=a.concat(d(r)));for(var s=l(t),v=l(r),g=0;g<a.length;++g){var y=a[g];if(!(i[y]||n&&n[y]||v&&v[y]||s&&s[y])){var m=p(r,y);try{u(t,y,m)}catch(e){}}}}return t}},3520:(e,t)=>{"use strict";var r="function"==typeof Symbol&&Symbol.for,n=r?Symbol.for("react.element"):60103,o=r?Symbol.for("react.portal"):60106,i=r?Symbol.for("react.fragment"):60107,a=r?Symbol.for("react.strict_mode"):60108,s=r?Symbol.for("react.profiler"):60114,l=r?Symbol.for("react.provider"):60109,u=r?Symbol.for("react.context"):60110,c=r?Symbol.for("react.async_mode"):60111,d=r?Symbol.for("react.concurrent_mode"):60111,p=r?Symbol.for("react.forward_ref"):60112,f=r?Symbol.for("react.suspense"):60113,h=r?Symbol.for("react.suspense_list"):60120,v=r?Symbol.for("react.memo"):60115,g=r?Symbol.for("react.lazy"):60116,y=r?Symbol.for("react.block"):60121,m=r?Symbol.for("react.fundamental"):60117,b=r?Symbol.for("react.responder"):60118,O=r?Symbol.for("react.scope"):60119;function E(e){if("object"==typeof e&&null!==e){var t=e.$$typeof;switch(t){case n:switch(e=e.type){case c:case d:case i:case s:case a:case f:return e;default:switch(e=e&&e.$$typeof){case u:case p:case g:case v:case l:return e;default:return t}}case o:return t}}}function S(e){return E(e)===d}t.AsyncMode=c,t.ConcurrentMode=d,t.ContextConsumer=u,t.ContextProvider=l,t.Element=n,t.ForwardRef=p,t.Fragment=i,t.Lazy=g,t.Memo=v,t.Portal=o,t.Profiler=s,t.StrictMode=a,t.Suspense=f,t.isAsyncMode=function(e){return S(e)||E(e)===c},t.isConcurrentMode=S,t.isContextConsumer=function(e){return E(e)===u},t.isContextProvider=function(e){return E(e)===l},t.isElement=function(e){return"object"==typeof e&&null!==e&&e.$$typeof===n},t.isForwardRef=function(e){return E(e)===p},t.isFragment=function(e){return E(e)===i},t.isLazy=function(e){return E(e)===g},t.isMemo=function(e){return E(e)===v},t.isPortal=function(e){return E(e)===o},t.isProfiler=function(e){return E(e)===s},t.isStrictMode=function(e){return E(e)===a},t.isSuspense=function(e){return E(e)===f},t.isValidElementType=function(e){return"string"==typeof e||"function"==typeof e||e===i||e===d||e===s||e===a||e===f||e===h||"object"==typeof e&&null!==e&&(e.$$typeof===g||e.$$typeof===v||e.$$typeof===l||e.$$typeof===u||e.$$typeof===p||e.$$typeof===m||e.$$typeof===b||e.$$typeof===O||e.$$typeof===y)},t.typeOf=E},300:(e,t,r)=>{"use strict";e.exports=r(3520)},502:function(e,t,r){var n,o;n=function(){"use strict";Array.isArray||(Array.isArray=function(e){return"[object Array]"===Object.prototype.toString.call(e)});var e={},t={"==":function(e,t){return e==t},"===":function(e,t){return e===t},"!=":function(e,t){return e!=t},"!==":function(e,t){return e!==t},">":function(e,t){return e>t},">=":function(e,t){return e>=t},"<":function(e,t,r){return void 0===r?e<t:e<t&&t<r},"<=":function(e,t,r){return void 0===r?e<=t:e<=t&&t<=r},"!!":function(t){return e.truthy(t)},"!":function(t){return!e.truthy(t)},"%":function(e,t){return e%t},log:function(e){return console.log(e),e},in:function(e,t){return!(!t||void 0===t.indexOf)&&-1!==t.indexOf(e)},cat:function(){return Array.prototype.join.call(arguments,"")},substr:function(e,t,r){if(r<0){var n=String(e).substr(t);return n.substr(0,n.length+r)}return String(e).substr(t,r)},"+":function(){return Array.prototype.reduce.call(arguments,(function(e,t){return parseFloat(e,10)+parseFloat(t,10)}),0)},"*":function(){return Array.prototype.reduce.call(arguments,(function(e,t){return parseFloat(e,10)*parseFloat(t,10)}))},"-":function(e,t){return void 0===t?-e:e-t},"/":function(e,t){return e/t},min:function(){return Math.min.apply(this,arguments)},max:function(){return Math.max.apply(this,arguments)},merge:function(){return Array.prototype.reduce.call(arguments,(function(e,t){return e.concat(t)}),[])},var:function(e,t){var r=void 0===t?null:t,n=this;if(void 0===e||""===e||null===e)return n;for(var o=String(e).split("."),i=0;i<o.length;i++){if(null==n)return r;if(void 0===(n=n[o[i]]))return r}return n},missing:function(){for(var t=[],r=Array.isArray(arguments[0])?arguments[0]:arguments,n=0;n<r.length;n++){var o=r[n],i=e.apply({var:o},this);null!==i&&""!==i||t.push(o)}return t},missing_some:function(t,r){var n=e.apply({missing:r},this);return r.length-n.length>=t?[]:n}};return e.is_logic=function(e){return"object"==typeof e&&null!==e&&!Array.isArray(e)&&1===Object.keys(e).length},e.truthy=function(e){return!(Array.isArray(e)&&0===e.length||!e)},e.get_operator=function(e){return Object.keys(e)[0]},e.get_values=function(t){return t[e.get_operator(t)]},e.apply=function(r,n){if(Array.isArray(r))return r.map((function(t){return e.apply(t,n)}));if(!e.is_logic(r))return r;var o,i,a,s,l,u=e.get_operator(r),c=r[u];if(Array.isArray(c)||(c=[c]),"if"===u||"?:"==u){for(o=0;o<c.length-1;o+=2)if(e.truthy(e.apply(c[o],n)))return e.apply(c[o+1],n);return c.length===o+1?e.apply(c[o],n):null}if("and"===u){for(o=0;o<c.length;o+=1)if(i=e.apply(c[o],n),!e.truthy(i))return i;return i}if("or"===u){for(o=0;o<c.length;o+=1)if(i=e.apply(c[o],n),e.truthy(i))return i;return i}if("filter"===u)return s=e.apply(c[0],n),a=c[1],Array.isArray(s)?s.filter((function(t){return e.truthy(e.apply(a,t))})):[];if("map"===u)return s=e.apply(c[0],n),a=c[1],Array.isArray(s)?s.map((function(t){return e.apply(a,t)})):[];if("reduce"===u)return s=e.apply(c[0],n),a=c[1],l=void 0!==c[2]?c[2]:null,Array.isArray(s)?s.reduce((function(t,r){return e.apply(a,{current:r,accumulator:t})}),l):l;if("all"===u){if(s=e.apply(c[0],n),a=c[1],!Array.isArray(s)||!s.length)return!1;for(o=0;o<s.length;o+=1)if(!e.truthy(e.apply(a,s[o])))return!1;return!0}if("none"===u){if(s=e.apply(c[0],n),a=c[1],!Array.isArray(s)||!s.length)return!0;for(o=0;o<s.length;o+=1)if(e.truthy(e.apply(a,s[o])))return!1;return!0}if("some"===u){if(s=e.apply(c[0],n),a=c[1],!Array.isArray(s)||!s.length)return!1;for(o=0;o<s.length;o+=1)if(e.truthy(e.apply(a,s[o])))return!0;return!1}if(c=c.map((function(t){return e.apply(t,n)})),t.hasOwnProperty(u)&&"function"==typeof t[u])return t[u].apply(n,c);if(u.indexOf(".")>0){var d=String(u).split("."),p=t;for(o=0;o<d.length;o++){if(!p.hasOwnProperty(d[o]))throw new Error("Unrecognized operation "+u+" (failed at "+d.slice(0,o+1).join(".")+")");p=p[d[o]]}return p.apply(n,c)}throw new Error("Unrecognized operation "+u)},e.uses_data=function(t){var r=[];if(e.is_logic(t)){var n=e.get_operator(t),o=t[n];Array.isArray(o)||(o=[o]),"var"===n?r.push(o[0]):o.forEach((function(t){r.push.apply(r,e.uses_data(t))}))}return function(e){for(var t=[],r=0,n=e.length;r<n;r++)-1===t.indexOf(e[r])&&t.push(e[r]);return t}(r)},e.add_operation=function(e,r){t[e]=r},e.rm_operation=function(e){delete t[e]},e.rule_like=function(t,r){if(r===t)return!0;if("@"===r)return!0;if("number"===r)return"number"==typeof t;if("string"===r)return"string"==typeof t;if("array"===r)return Array.isArray(t)&&!e.is_logic(t);if(e.is_logic(r)){if(e.is_logic(t)){var n=e.get_operator(r),o=e.get_operator(t);if("@"===n||n===o)return e.rule_like(e.get_values(t,!1),e.get_values(r,!1))}return!1}if(Array.isArray(r)){if(Array.isArray(t)){if(r.length!==t.length)return!1;for(var i=0;i<r.length;i+=1)if(!e.rule_like(t[i],r[i]))return!1;return!0}return!1}return!1},e},void 0===(o=n.call(t,r,t,e))||(e.exports=o)},5948:(e,t,r)=>{var n=r(2062)(r(9965),"DataView");e.exports=n},4845:(e,t,r)=>{var n=r(5504),o=r(5270),i=r(7150),a=r(2637),s=r(1077);function l(e){var t=-1,r=null==e?0:e.length;for(this.clear();++t<r;){var n=e[t];this.set(n[0],n[1])}}l.prototype.clear=n,l.prototype.delete=o,l.prototype.get=i,l.prototype.has=a,l.prototype.set=s,e.exports=l},1999:(e,t,r)=>{var n=r(7718),o=r(4272),i=r(5107),a=r(1055),s=r(4647);function l(e){var t=-1,r=null==e?0:e.length;for(this.clear();++t<r;){var n=e[t];this.set(n[0],n[1])}}l.prototype.clear=n,l.prototype.delete=o,l.prototype.get=i,l.prototype.has=a,l.prototype.set=s,e.exports=l},5455:(e,t,r)=>{var n=r(2062)(r(9965),"Map");e.exports=n},1549:(e,t,r)=>{var n=r(6400),o=r(7014),i=r(1793),a=r(6429),s=r(821);function l(e){var t=-1,r=null==e?0:e.length;for(this.clear();++t<r;){var n=e[t];this.set(n[0],n[1])}}l.prototype.clear=n,l.prototype.delete=o,l.prototype.get=i,l.prototype.has=a,l.prototype.set=s,e.exports=l},6420:(e,t,r)=>{var n=r(2062)(r(9965),"Promise");e.exports=n},2833:(e,t,r)=>{var n=r(2062)(r(9965),"Set");e.exports=n},8283:(e,t,r)=>{var n=r(1549),o=r(228),i=r(3683);function a(e){var t=-1,r=null==e?0:e.length;for(this.__data__=new n;++t<r;)this.add(e[t])}a.prototype.add=a.prototype.push=o,a.prototype.has=i,e.exports=a},8545:(e,t,r)=>{var n=r(1999),o=r(5052),i=r(4250),a=r(4773),s=r(6921),l=r(5745);function u(e){var t=this.__data__=new n(e);this.size=t.size}u.prototype.clear=o,u.prototype.delete=i,u.prototype.get=a,u.prototype.has=s,u.prototype.set=l,e.exports=u},2609:(e,t,r)=>{var n=r(9965).Symbol;e.exports=n},3604:(e,t,r)=>{var n=r(9965).Uint8Array;e.exports=n},8143:(e,t,r)=>{var n=r(2062)(r(9965),"WeakMap");e.exports=n},1929:e=>{e.exports=function(e,t,r){switch(r.length){case 0:return e.call(t);case 1:return e.call(t,r[0]);case 2:return e.call(t,r[0],r[1]);case 3:return e.call(t,r[0],r[1],r[2])}return e.apply(t,r)}},6433:e=>{e.exports=function(e,t){for(var r=-1,n=null==e?0:e.length;++r<n&&!1!==t(e[r],r,e););return e}},9386:e=>{e.exports=function(e,t){for(var r=-1,n=null==e?0:e.length,o=0,i=[];++r<n;){var a=e[r];t(a,r,e)&&(i[o++]=a)}return i}},6791:(e,t,r)=>{var n=r(2784),o=r(5196),i=r(4913),a=r(4264),s=r(6665),l=r(5087),u=Object.prototype.hasOwnProperty;e.exports=function(e,t){var r=i(e),c=!r&&o(e),d=!r&&!c&&a(e),p=!r&&!c&&!d&&l(e),f=r||c||d||p,h=f?n(e.length,String):[],v=h.length;for(var g in e)!t&&!u.call(e,g)||f&&("length"==g||d&&("offset"==g||"parent"==g)||p&&("buffer"==g||"byteLength"==g||"byteOffset"==g)||s(g,v))||h.push(g);return h}},1428:e=>{e.exports=function(e,t){for(var r=-1,n=null==e?0:e.length,o=Array(n);++r<n;)o[r]=t(e[r],r,e);return o}},8256:e=>{e.exports=function(e,t){for(var r=-1,n=t.length,o=e.length;++r<n;)e[o+r]=t[r];return e}},9272:e=>{e.exports=function(e,t){for(var r=-1,n=null==e?0:e.length;++r<n;)if(t(e[r],r,e))return!0;return!1}},237:(e,t,r)=>{var n=r(2464),o=r(6424);e.exports=function(e,t,r){(void 0!==r&&!o(e[t],r)||void 0===r&&!(t in e))&&n(e,t,r)}},8131:(e,t,r)=>{var n=r(2464),o=r(6424),i=Object.prototype.hasOwnProperty;e.exports=function(e,t,r){var a=e[t];i.call(e,t)&&o(a,r)&&(void 0!==r||t in e)||n(e,t,r)}},3481:(e,t,r)=>{var n=r(6424);e.exports=function(e,t){for(var r=e.length;r--;)if(n(e[r][0],t))return r;return-1}},4861:(e,t,r)=>{var n=r(4735),o=r(3790);e.exports=function(e,t){return e&&n(t,o(t),e)}},7838:(e,t,r)=>{var n=r(4735),o=r(5961);e.exports=function(e,t){return e&&n(t,o(t),e)}},2464:(e,t,r)=>{var n=r(9611);e.exports=function(e,t,r){"__proto__"==t&&n?n(e,t,{configurable:!0,enumerable:!0,value:r,writable:!0}):e[t]=r}},5725:e=>{e.exports=function(e,t,r){return e==e&&(void 0!==r&&(e=e<=r?e:r),void 0!==t&&(e=e>=t?e:t)),e}},6575:(e,t,r)=>{var n=r(8545),o=r(6433),i=r(8131),a=r(4861),s=r(7838),l=r(8986),u=r(1231),c=r(1711),d=r(1476),p=r(130),f=r(869),h=r(6053),v=r(509),g=r(1343),y=r(1225),m=r(4913),b=r(4264),O=r(146),E=r(7453),S=r(8696),T=r(3790),_=r(5961),w="[object Arguments]",R="[object Function]",A="[object Object]",C={};C[w]=C["[object Array]"]=C["[object ArrayBuffer]"]=C["[object DataView]"]=C["[object Boolean]"]=C["[object Date]"]=C["[object Float32Array]"]=C["[object Float64Array]"]=C["[object Int8Array]"]=C["[object Int16Array]"]=C["[object Int32Array]"]=C["[object Map]"]=C["[object Number]"]=C[A]=C["[object RegExp]"]=C["[object Set]"]=C["[object String]"]=C["[object Symbol]"]=C["[object Uint8Array]"]=C["[object Uint8ClampedArray]"]=C["[object Uint16Array]"]=C["[object Uint32Array]"]=!0,C["[object Error]"]=C[R]=C["[object WeakMap]"]=!1,e.exports=function e(t,r,I,x,L,N){var j,P=1&r,k=2&r,F=4&r;if(I&&(j=L?I(t,x,L,N):I(t)),void 0!==j)return j;if(!E(t))return t;var D=m(t);if(D){if(j=v(t),!P)return u(t,j)}else{var M=h(t),V=M==R||"[object GeneratorFunction]"==M;if(b(t))return l(t,P);if(M==A||M==w||V&&!L){if(j=k||V?{}:y(t),!P)return k?d(t,s(j,t)):c(t,a(j,t))}else{if(!C[M])return L?t:{};j=g(t,M,P)}}N||(N=new n);var U=N.get(t);if(U)return U;N.set(t,j),S(t)?t.forEach((function(n){j.add(e(n,r,I,n,t,N))})):O(t)&&t.forEach((function(n,o){j.set(o,e(n,r,I,o,t,N))}));var B=D?void 0:(F?k?f:p:k?_:T)(t);return o(B||t,(function(n,o){B&&(n=t[o=n]),i(j,o,e(n,r,I,o,t,N))})),j}},3088:(e,t,r)=>{var n=r(7453),o=Object.create,i=function(){function e(){}return function(t){if(!n(t))return{};if(o)return o(t);e.prototype=t;var r=new e;return e.prototype=void 0,r}}();e.exports=i},3323:e=>{e.exports=function(e,t,r,n){for(var o=e.length,i=r+(n?1:-1);n?i--:++i<o;)if(t(e[i],i,e))return i;return-1}},1360:(e,t,r)=>{var n=r(8256),o=r(5043);e.exports=function e(t,r,i,a,s){var l=-1,u=t.length;for(i||(i=o),s||(s=[]);++l<u;){var c=t[l];r>0&&i(c)?r>1?e(c,r-1,i,a,s):n(s,c):a||(s[s.length]=c)}return s}},6057:(e,t,r)=>{var n=r(5845)();e.exports=n},5473:(e,t,r)=>{var n=r(6057),o=r(3790);e.exports=function(e,t){return e&&n(e,t,o)}},2718:(e,t,r)=>{var n=r(2361),o=r(8197);e.exports=function(e,t){for(var r=0,i=(t=n(t,e)).length;null!=e&&r<i;)e=e[o(t[r++])];return r&&r==i?e:void 0}},8359:(e,t,r)=>{var n=r(8256),o=r(4913);e.exports=function(e,t,r){var i=t(e);return o(e)?i:n(i,r(e))}},9048:(e,t,r)=>{var n=r(2609),o=r(2899),i=r(7222),a=n?n.toStringTag:void 0;e.exports=function(e){return null==e?void 0===e?"[object Undefined]":"[object Null]":a&&a in Object(e)?o(e):i(e)}},3613:e=>{e.exports=function(e,t){return null!=e&&t in Object(e)}},9555:(e,t,r)=>{var n=r(3323),o=r(8967),i=r(5951);e.exports=function(e,t,r){return t==t?i(e,t,r):n(e,o,r)}},3070:(e,t,r)=>{var n=r(9048),o=r(9466);e.exports=function(e){return o(e)&&"[object Arguments]"==n(e)}},590:(e,t,r)=>{var n=r(9132),o=r(9466);e.exports=function e(t,r,i,a,s){return t===r||(null==t||null==r||!o(t)&&!o(r)?t!=t&&r!=r:n(t,r,i,a,e,s))}},9132:(e,t,r)=>{var n=r(8545),o=r(4807),i=r(898),a=r(3409),s=r(6053),l=r(4913),u=r(4264),c=r(5087),d="[object Arguments]",p="[object Array]",f="[object Object]",h=Object.prototype.hasOwnProperty;e.exports=function(e,t,r,v,g,y){var m=l(e),b=l(t),O=m?p:s(e),E=b?p:s(t),S=(O=O==d?f:O)==f,T=(E=E==d?f:E)==f,_=O==E;if(_&&u(e)){if(!u(t))return!1;m=!0,S=!1}if(_&&!S)return y||(y=new n),m||c(e)?o(e,t,r,v,g,y):i(e,t,O,r,v,g,y);if(!(1&r)){var w=S&&h.call(e,"__wrapped__"),R=T&&h.call(t,"__wrapped__");if(w||R){var A=w?e.value():e,C=R?t.value():t;return y||(y=new n),g(A,C,r,v,y)}}return!!_&&(y||(y=new n),a(e,t,r,v,g,y))}},2052:(e,t,r)=>{var n=r(6053),o=r(9466);e.exports=function(e){return o(e)&&"[object Map]"==n(e)}},7799:(e,t,r)=>{var n=r(8545),o=r(590);e.exports=function(e,t,r,i){var a=r.length,s=a,l=!i;if(null==e)return!s;for(e=Object(e);a--;){var u=r[a];if(l&&u[2]?u[1]!==e[u[0]]:!(u[0]in e))return!1}for(;++a<s;){var c=(u=r[a])[0],d=e[c],p=u[1];if(l&&u[2]){if(void 0===d&&!(c in e))return!1}else{var f=new n;if(i)var h=i(d,p,c,e,t,f);if(!(void 0===h?o(p,d,3,i,f):h))return!1}}return!0}},8967:e=>{e.exports=function(e){return e!=e}},4363:(e,t,r)=>{var n=r(1866),o=r(3248),i=r(7453),a=r(3761),s=/^\[object .+?Constructor\]$/,l=Function.prototype,u=Object.prototype,c=l.toString,d=u.hasOwnProperty,p=RegExp("^"+c.call(d).replace(/[\\^$.*+?()[\]{}|]/g,"\\$&").replace(/hasOwnProperty|(function).*?(?=\\\()| for .+?(?=\\\])/g,"$1.*?")+"$");e.exports=function(e){return!(!i(e)||o(e))&&(n(e)?p:s).test(a(e))}},5206:(e,t,r)=>{var n=r(6053),o=r(9466);e.exports=function(e){return o(e)&&"[object Set]"==n(e)}},9653:(e,t,r)=>{var n=r(9048),o=r(582),i=r(9466),a={};a["[object Float32Array]"]=a["[object Float64Array]"]=a["[object Int8Array]"]=a["[object Int16Array]"]=a["[object Int32Array]"]=a["[object Uint8Array]"]=a["[object Uint8ClampedArray]"]=a["[object Uint16Array]"]=a["[object Uint32Array]"]=!0,a["[object Arguments]"]=a["[object Array]"]=a["[object ArrayBuffer]"]=a["[object Boolean]"]=a["[object DataView]"]=a["[object Date]"]=a["[object Error]"]=a["[object Function]"]=a["[object Map]"]=a["[object Number]"]=a["[object Object]"]=a["[object RegExp]"]=a["[object Set]"]=a["[object String]"]=a["[object WeakMap]"]=!1,e.exports=function(e){return i(e)&&o(e.length)&&!!a[n(e)]}},3245:(e,t,r)=>{var n=r(8271),o=r(4458),i=r(912),a=r(4913),s=r(6711);e.exports=function(e){return"function"==typeof e?e:null==e?i:"object"==typeof e?a(e)?o(e[0],e[1]):n(e):s(e)}},6504:(e,t,r)=>{var n=r(5735),o=r(9458),i=Object.prototype.hasOwnProperty;e.exports=function(e){if(!n(e))return o(e);var t=[];for(var r in Object(e))i.call(e,r)&&"constructor"!=r&&t.push(r);return t}},9399:(e,t,r)=>{var n=r(7453),o=r(5735),i=r(2693),a=Object.prototype.hasOwnProperty;e.exports=function(e){if(!n(e))return i(e);var t=o(e),r=[];for(var s in e)("constructor"!=s||!t&&a.call(e,s))&&r.push(s);return r}},8271:(e,t,r)=>{var n=r(7799),o=r(520),i=r(7405);e.exports=function(e){var t=o(e);return 1==t.length&&t[0][2]?i(t[0][0],t[0][1]):function(r){return r===e||n(r,e,t)}}},4458:(e,t,r)=>{var n=r(590),o=r(5612),i=r(4055),a=r(6394),s=r(2308),l=r(7405),u=r(8197);e.exports=function(e,t){return a(e)&&s(t)?l(u(e),t):function(r){var a=o(r,e);return void 0===a&&a===t?i(r,e):n(t,a,3)}}},9058:(e,t,r)=>{var n=r(8545),o=r(237),i=r(6057),a=r(8120),s=r(7453),l=r(5961),u=r(4302);e.exports=function e(t,r,c,d,p){t!==r&&i(r,(function(i,l){if(p||(p=new n),s(i))a(t,r,l,c,e,d,p);else{var f=d?d(u(t,l),i,l+"",t,r,p):void 0;void 0===f&&(f=i),o(t,l,f)}}),l)}},8120:(e,t,r)=>{var n=r(237),o=r(8986),i=r(7961),a=r(1231),s=r(1225),l=r(5196),u=r(4913),c=r(7965),d=r(4264),p=r(1866),f=r(7453),h=r(5219),v=r(5087),g=r(4302),y=r(5148);e.exports=function(e,t,r,m,b,O,E){var S=g(e,r),T=g(t,r),_=E.get(T);if(_)n(e,r,_);else{var w=O?O(S,T,r+"",e,t,E):void 0,R=void 0===w;if(R){var A=u(T),C=!A&&d(T),I=!A&&!C&&v(T);w=T,A||C||I?u(S)?w=S:c(S)?w=a(S):C?(R=!1,w=o(T,!0)):I?(R=!1,w=i(T,!0)):w=[]:h(T)||l(T)?(w=S,l(S)?w=y(S):f(S)&&!p(S)||(w=s(T))):R=!1}R&&(E.set(T,w),b(w,T,m,O,E),E.delete(T)),n(e,r,w)}}},1:(e,t,r)=>{var n=r(9916),o=r(4055);e.exports=function(e,t){return n(e,t,(function(t,r){return o(e,r)}))}},9916:(e,t,r)=>{var n=r(2718),o=r(3746),i=r(2361);e.exports=function(e,t,r){for(var a=-1,s=t.length,l={};++a<s;){var u=t[a],c=n(e,u);r(c,u)&&o(l,i(u,e),c)}return l}},645:e=>{e.exports=function(e){return function(t){return null==t?void 0:t[e]}}},5319:(e,t,r)=>{var n=r(2718);e.exports=function(e){return function(t){return n(t,e)}}},9383:e=>{var t=Math.ceil,r=Math.max;e.exports=function(e,n,o,i){for(var a=-1,s=r(t((n-e)/(o||1)),0),l=Array(s);s--;)l[i?s:++a]=e,e+=o;return l}},1459:e=>{var t=Math.floor;e.exports=function(e,r){var n="";if(!e||r<1||r>9007199254740991)return n;do{r%2&&(n+=e),(r=t(r/2))&&(e+=e)}while(r);return n}},1110:(e,t,r)=>{var n=r(912),o=r(709),i=r(7281);e.exports=function(e,t){return i(o(e,t,n),e+"")}},3746:(e,t,r)=>{var n=r(8131),o=r(2361),i=r(6665),a=r(7453),s=r(8197);e.exports=function(e,t,r,l){if(!a(e))return e;for(var u=-1,c=(t=o(t,e)).length,d=c-1,p=e;null!=p&&++u<c;){var f=s(t[u]),h=r;if("__proto__"===f||"constructor"===f||"prototype"===f)return e;if(u!=d){var v=p[f];void 0===(h=l?l(v,f,p):void 0)&&(h=a(v)?v:i(t[u+1])?[]:{})}n(p,f,h),p=p[f]}return e}},4450:(e,t,r)=>{var n=r(6534),o=r(9611),i=r(912),a=o?function(e,t){return o(e,"toString",{configurable:!0,enumerable:!1,value:n(t),writable:!0})}:i;e.exports=a},312:e=>{e.exports=function(e,t,r){var n=-1,o=e.length;t<0&&(t=-t>o?0:o+t),(r=r>o?o:r)<0&&(r+=o),o=t>r?0:r-t>>>0,t>>>=0;for(var i=Array(o);++n<o;)i[n]=e[n+t];return i}},2784:e=>{e.exports=function(e,t){for(var r=-1,n=Array(e);++r<e;)n[r]=t(r);return n}},9764:(e,t,r)=>{var n=r(2609),o=r(1428),i=r(4913),a=r(7386),s=n?n.prototype:void 0,l=s?s.toString:void 0;e.exports=function e(t){if("string"==typeof t)return t;if(i(t))return o(t,e)+"";if(a(t))return l?l.call(t):"";var r=t+"";return"0"==r&&1/t==-1/0?"-0":r}},7248:(e,t,r)=>{var n=r(1272),o=/^\s+/;e.exports=function(e){return e?e.slice(0,n(e)+1).replace(o,""):e}},277:e=>{e.exports=function(e){return function(t){return e(t)}}},6744:(e,t,r)=>{var n=r(2361),o=r(8906),i=r(2473),a=r(8197);e.exports=function(e,t){return t=n(t,e),null==(e=i(e,t))||delete e[a(o(t))]}},1282:(e,t,r)=>{var n=r(1428);e.exports=function(e,t){return n(t,(function(t){return e[t]}))}},3840:e=>{e.exports=function(e,t){return e.has(t)}},2361:(e,t,r)=>{var n=r(4913),o=r(6394),i=r(266),a=r(3158);e.exports=function(e,t){return n(e)?e:o(e,t)?[e]:i(a(e))}},7749:(e,t,r)=>{var n=r(3604);e.exports=function(e){var t=new e.constructor(e.byteLength);return new n(t).set(new n(e)),t}},8986:(e,t,r)=>{e=r.nmd(e);var n=r(9965),o=t&&!t.nodeType&&t,i=o&&e&&!e.nodeType&&e,a=i&&i.exports===o?n.Buffer:void 0,s=a?a.allocUnsafe:void 0;e.exports=function(e,t){if(t)return e.slice();var r=e.length,n=s?s(r):new e.constructor(r);return e.copy(n),n}},3081:(e,t,r)=>{var n=r(7749);e.exports=function(e,t){var r=t?n(e.buffer):e.buffer;return new e.constructor(r,e.byteOffset,e.byteLength)}},6945:e=>{var t=/\w*$/;e.exports=function(e){var r=new e.constructor(e.source,t.exec(e));return r.lastIndex=e.lastIndex,r}},6952:(e,t,r)=>{var n=r(2609),o=n?n.prototype:void 0,i=o?o.valueOf:void 0;e.exports=function(e){return i?Object(i.call(e)):{}}},7961:(e,t,r)=>{var n=r(7749);e.exports=function(e,t){var r=t?n(e.buffer):e.buffer;return new e.constructor(r,e.byteOffset,e.length)}},1231:e=>{e.exports=function(e,t){var r=-1,n=e.length;for(t||(t=Array(n));++r<n;)t[r]=e[r];return t}},4735:(e,t,r)=>{var n=r(8131),o=r(2464);e.exports=function(e,t,r,i){var a=!r;r||(r={});for(var s=-1,l=t.length;++s<l;){var u=t[s],c=i?i(r[u],e[u],u,r,e):void 0;void 0===c&&(c=e[u]),a?o(r,u,c):n(r,u,c)}return r}},1711:(e,t,r)=>{var n=r(4735),o=r(6600);e.exports=function(e,t){return n(e,o(e),t)}},1476:(e,t,r)=>{var n=r(4735),o=r(8455);e.exports=function(e,t){return n(e,o(e),t)}},2489:(e,t,r)=>{var n=r(9965)["__core-js_shared__"];e.exports=n},9511:(e,t,r)=>{var n=r(1110),o=r(3632);e.exports=function(e){return n((function(t,r){var n=-1,i=r.length,a=i>1?r[i-1]:void 0,s=i>2?r[2]:void 0;for(a=e.length>3&&"function"==typeof a?(i--,a):void 0,s&&o(r[0],r[1],s)&&(a=i<3?void 0:a,i=1),t=Object(t);++n<i;){var l=r[n];l&&e(t,l,n,a)}return t}))}},5845:e=>{e.exports=function(e){return function(t,r,n){for(var o=-1,i=Object(t),a=n(t),s=a.length;s--;){var l=a[e?s:++o];if(!1===r(i[l],l,i))break}return t}}},8580:(e,t,r)=>{var n=r(9383),o=r(3632),i=r(1144);e.exports=function(e){return function(t,r,a){return a&&"number"!=typeof a&&o(t,r,a)&&(r=a=void 0),t=i(t),void 0===r?(r=t,t=0):r=i(r),a=void 0===a?t<r?1:-1:i(a),n(t,r,a,e)}}},2050:(e,t,r)=>{var n=r(5219);e.exports=function(e){return n(e)?void 0:e}},9611:(e,t,r)=>{var n=r(2062),o=function(){try{var e=n(Object,"defineProperty");return e({},"",{}),e}catch(e){}}();e.exports=o},4807:(e,t,r)=>{var n=r(8283),o=r(9272),i=r(3840);e.exports=function(e,t,r,a,s,l){var u=1&r,c=e.length,d=t.length;if(c!=d&&!(u&&d>c))return!1;var p=l.get(e),f=l.get(t);if(p&&f)return p==t&&f==e;var h=-1,v=!0,g=2&r?new n:void 0;for(l.set(e,t),l.set(t,e);++h<c;){var y=e[h],m=t[h];if(a)var b=u?a(m,y,h,t,e,l):a(y,m,h,e,t,l);if(void 0!==b){if(b)continue;v=!1;break}if(g){if(!o(t,(function(e,t){if(!i(g,t)&&(y===e||s(y,e,r,a,l)))return g.push(t)}))){v=!1;break}}else if(y!==m&&!s(y,m,r,a,l)){v=!1;break}}return l.delete(e),l.delete(t),v}},898:(e,t,r)=>{var n=r(2609),o=r(3604),i=r(6424),a=r(4807),s=r(9885),l=r(6295),u=n?n.prototype:void 0,c=u?u.valueOf:void 0;e.exports=function(e,t,r,n,u,d,p){switch(r){case"[object DataView]":if(e.byteLength!=t.byteLength||e.byteOffset!=t.byteOffset)return!1;e=e.buffer,t=t.buffer;case"[object ArrayBuffer]":return!(e.byteLength!=t.byteLength||!d(new o(e),new o(t)));case"[object Boolean]":case"[object Date]":case"[object Number]":return i(+e,+t);case"[object Error]":return e.name==t.name&&e.message==t.message;case"[object RegExp]":case"[object String]":return e==t+"";case"[object Map]":var f=s;case"[object Set]":var h=1&n;if(f||(f=l),e.size!=t.size&&!h)return!1;var v=p.get(e);if(v)return v==t;n|=2,p.set(e,t);var g=a(f(e),f(t),n,u,d,p);return p.delete(e),g;case"[object Symbol]":if(c)return c.call(e)==c.call(t)}return!1}},3409:(e,t,r)=>{var n=r(130),o=Object.prototype.hasOwnProperty;e.exports=function(e,t,r,i,a,s){var l=1&r,u=n(e),c=u.length;if(c!=n(t).length&&!l)return!1;for(var d=c;d--;){var p=u[d];if(!(l?p in t:o.call(t,p)))return!1}var f=s.get(e),h=s.get(t);if(f&&h)return f==t&&h==e;var v=!0;s.set(e,t),s.set(t,e);for(var g=l;++d<c;){var y=e[p=u[d]],m=t[p];if(i)var b=l?i(m,y,p,t,e,s):i(y,m,p,e,t,s);if(!(void 0===b?y===m||a(y,m,r,i,s):b)){v=!1;break}g||(g="constructor"==p)}if(v&&!g){var O=e.constructor,E=t.constructor;O==E||!("constructor"in e)||!("constructor"in t)||"function"==typeof O&&O instanceof O&&"function"==typeof E&&E instanceof E||(v=!1)}return s.delete(e),s.delete(t),v}},8496:(e,t,r)=>{var n=r(9234),o=r(709),i=r(7281);e.exports=function(e){return i(o(e,void 0,n),e+"")}},6392:(e,t,r)=>{var n="object"==typeof r.g&&r.g&&r.g.Object===Object&&r.g;e.exports=n},130:(e,t,r)=>{var n=r(8359),o=r(6600),i=r(3790);e.exports=function(e){return n(e,i,o)}},869:(e,t,r)=>{var n=r(8359),o=r(8455),i=r(5961);e.exports=function(e){return n(e,i,o)}},3707:(e,t,r)=>{var n=r(9178);e.exports=function(e,t){var r=e.__data__;return n(t)?r["string"==typeof t?"string":"hash"]:r.map}},520:(e,t,r)=>{var n=r(2308),o=r(3790);e.exports=function(e){for(var t=o(e),r=t.length;r--;){var i=t[r],a=e[i];t[r]=[i,a,n(a)]}return t}},2062:(e,t,r)=>{var n=r(4363),o=r(5240);e.exports=function(e,t){var r=o(e,t);return n(r)?r:void 0}},6607:(e,t,r)=>{var n=r(8303)(Object.getPrototypeOf,Object);e.exports=n},2899:(e,t,r)=>{var n=r(2609),o=Object.prototype,i=o.hasOwnProperty,a=o.toString,s=n?n.toStringTag:void 0;e.exports=function(e){var t=i.call(e,s),r=e[s];try{e[s]=void 0;var n=!0}catch(e){}var o=a.call(e);return n&&(t?e[s]=r:delete e[s]),o}},6600:(e,t,r)=>{var n=r(9386),o=r(8721),i=Object.prototype.propertyIsEnumerable,a=Object.getOwnPropertySymbols,s=a?function(e){return null==e?[]:(e=Object(e),n(a(e),(function(t){return i.call(e,t)})))}:o;e.exports=s},8455:(e,t,r)=>{var n=r(8256),o=r(6607),i=r(6600),a=r(8721),s=Object.getOwnPropertySymbols?function(e){for(var t=[];e;)n(t,i(e)),e=o(e);return t}:a;e.exports=s},6053:(e,t,r)=>{var n=r(5948),o=r(5455),i=r(6420),a=r(2833),s=r(8143),l=r(9048),u=r(3761),c="[object Map]",d="[object Promise]",p="[object Set]",f="[object WeakMap]",h="[object DataView]",v=u(n),g=u(o),y=u(i),m=u(a),b=u(s),O=l;(n&&O(new n(new ArrayBuffer(1)))!=h||o&&O(new o)!=c||i&&O(i.resolve())!=d||a&&O(new a)!=p||s&&O(new s)!=f)&&(O=function(e){var t=l(e),r="[object Object]"==t?e.constructor:void 0,n=r?u(r):"";if(n)switch(n){case v:return h;case g:return c;case y:return d;case m:return p;case b:return f}return t}),e.exports=O},5240:e=>{e.exports=function(e,t){return null==e?void 0:e[t]}},1518:(e,t,r)=>{var n=r(2361),o=r(5196),i=r(4913),a=r(6665),s=r(582),l=r(8197);e.exports=function(e,t,r){for(var u=-1,c=(t=n(t,e)).length,d=!1;++u<c;){var p=l(t[u]);if(!(d=null!=e&&r(e,p)))break;e=e[p]}return d||++u!=c?d:!!(c=null==e?0:e.length)&&s(c)&&a(p,c)&&(i(e)||o(e))}},5504:(e,t,r)=>{var n=r(8034);e.exports=function(){this.__data__=n?n(null):{},this.size=0}},5270:e=>{e.exports=function(e){var t=this.has(e)&&delete this.__data__[e];return this.size-=t?1:0,t}},7150:(e,t,r)=>{var n=r(8034),o=Object.prototype.hasOwnProperty;e.exports=function(e){var t=this.__data__;if(n){var r=t[e];return"__lodash_hash_undefined__"===r?void 0:r}return o.call(t,e)?t[e]:void 0}},2637:(e,t,r)=>{var n=r(8034),o=Object.prototype.hasOwnProperty;e.exports=function(e){var t=this.__data__;return n?void 0!==t[e]:o.call(t,e)}},1077:(e,t,r)=>{var n=r(8034);e.exports=function(e,t){var r=this.__data__;return this.size+=this.has(e)?0:1,r[e]=n&&void 0===t?"__lodash_hash_undefined__":t,this}},509:e=>{var t=Object.prototype.hasOwnProperty;e.exports=function(e){var r=e.length,n=new e.constructor(r);return r&&"string"==typeof e[0]&&t.call(e,"index")&&(n.index=e.index,n.input=e.input),n}},1343:(e,t,r)=>{var n=r(7749),o=r(3081),i=r(6945),a=r(6952),s=r(7961);e.exports=function(e,t,r){var l=e.constructor;switch(t){case"[object ArrayBuffer]":return n(e);case"[object Boolean]":case"[object Date]":return new l(+e);case"[object DataView]":return o(e,r);case"[object Float32Array]":case"[object Float64Array]":case"[object Int8Array]":case"[object Int16Array]":case"[object Int32Array]":case"[object Uint8Array]":case"[object Uint8ClampedArray]":case"[object Uint16Array]":case"[object Uint32Array]":return s(e,r);case"[object Map]":case"[object Set]":return new l;case"[object Number]":case"[object String]":return new l(e);case"[object RegExp]":return i(e);case"[object Symbol]":return a(e)}}},1225:(e,t,r)=>{var n=r(3088),o=r(6607),i=r(5735);e.exports=function(e){return"function"!=typeof e.constructor||i(e)?{}:n(o(e))}},5043:(e,t,r)=>{var n=r(2609),o=r(5196),i=r(4913),a=n?n.isConcatSpreadable:void 0;e.exports=function(e){return i(e)||o(e)||!!(a&&e&&e[a])}},6665:e=>{var t=/^(?:0|[1-9]\d*)$/;e.exports=function(e,r){var n=typeof e;return!!(r=null==r?9007199254740991:r)&&("number"==n||"symbol"!=n&&t.test(e))&&e>-1&&e%1==0&&e<r}},3632:(e,t,r)=>{var n=r(6424),o=r(7134),i=r(6665),a=r(7453);e.exports=function(e,t,r){if(!a(r))return!1;var s=typeof t;return!!("number"==s?o(r)&&i(t,r.length):"string"==s&&t in r)&&n(r[t],e)}},6394:(e,t,r)=>{var n=r(4913),o=r(7386),i=/\.|\[(?:[^[\]]*|(["'])(?:(?!\1)[^\\]|\\.)*?\1)\]/,a=/^\w*$/;e.exports=function(e,t){if(n(e))return!1;var r=typeof e;return!("number"!=r&&"symbol"!=r&&"boolean"!=r&&null!=e&&!o(e))||a.test(e)||!i.test(e)||null!=t&&e in Object(t)}},9178:e=>{e.exports=function(e){var t=typeof e;return"string"==t||"number"==t||"symbol"==t||"boolean"==t?"__proto__"!==e:null===e}},3248:(e,t,r)=>{var n,o=r(2489),i=(n=/[^.]+$/.exec(o&&o.keys&&o.keys.IE_PROTO||""))?"Symbol(src)_1."+n:"";e.exports=function(e){return!!i&&i in e}},5735:e=>{var t=Object.prototype;e.exports=function(e){var r=e&&e.constructor;return e===("function"==typeof r&&r.prototype||t)}},2308:(e,t,r)=>{var n=r(7453);e.exports=function(e){return e==e&&!n(e)}},7718:e=>{e.exports=function(){this.__data__=[],this.size=0}},4272:(e,t,r)=>{var n=r(3481),o=Array.prototype.splice;e.exports=function(e){var t=this.__data__,r=n(t,e);return!(r<0||(r==t.length-1?t.pop():o.call(t,r,1),--this.size,0))}},5107:(e,t,r)=>{var n=r(3481);e.exports=function(e){var t=this.__data__,r=n(t,e);return r<0?void 0:t[r][1]}},1055:(e,t,r)=>{var n=r(3481);e.exports=function(e){return n(this.__data__,e)>-1}},4647:(e,t,r)=>{var n=r(3481);e.exports=function(e,t){var r=this.__data__,o=n(r,e);return o<0?(++this.size,r.push([e,t])):r[o][1]=t,this}},6400:(e,t,r)=>{var n=r(4845),o=r(1999),i=r(5455);e.exports=function(){this.size=0,this.__data__={hash:new n,map:new(i||o),string:new n}}},7014:(e,t,r)=>{var n=r(3707);e.exports=function(e){var t=n(this,e).delete(e);return this.size-=t?1:0,t}},1793:(e,t,r)=>{var n=r(3707);e.exports=function(e){return n(this,e).get(e)}},6429:(e,t,r)=>{var n=r(3707);e.exports=function(e){return n(this,e).has(e)}},821:(e,t,r)=>{var n=r(3707);e.exports=function(e,t){var r=n(this,e),o=r.size;return r.set(e,t),this.size+=r.size==o?0:1,this}},9885:e=>{e.exports=function(e){var t=-1,r=Array(e.size);return e.forEach((function(e,n){r[++t]=[n,e]})),r}},7405:e=>{e.exports=function(e,t){return function(r){return null!=r&&r[e]===t&&(void 0!==t||e in Object(r))}}},2848:(e,t,r)=>{var n=r(3272);e.exports=function(e){var t=n(e,(function(e){return 500===r.size&&r.clear(),e})),r=t.cache;return t}},8034:(e,t,r)=>{var n=r(2062)(Object,"create");e.exports=n},9458:(e,t,r)=>{var n=r(8303)(Object.keys,Object);e.exports=n},2693:e=>{e.exports=function(e){var t=[];if(null!=e)for(var r in Object(e))t.push(r);return t}},1977:(e,t,r)=>{e=r.nmd(e);var n=r(6392),o=t&&!t.nodeType&&t,i=o&&e&&!e.nodeType&&e,a=i&&i.exports===o&&n.process,s=function(){try{return i&&i.require&&i.require("util").types||a&&a.binding&&a.binding("util")}catch(e){}}();e.exports=s},7222:e=>{var t=Object.prototype.toString;e.exports=function(e){return t.call(e)}},8303:e=>{e.exports=function(e,t){return function(r){return e(t(r))}}},709:(e,t,r)=>{var n=r(1929),o=Math.max;e.exports=function(e,t,r){return t=o(void 0===t?e.length-1:t,0),function(){for(var i=arguments,a=-1,s=o(i.length-t,0),l=Array(s);++a<s;)l[a]=i[t+a];a=-1;for(var u=Array(t+1);++a<t;)u[a]=i[a];return u[t]=r(l),n(e,this,u)}}},2473:(e,t,r)=>{var n=r(2718),o=r(312);e.exports=function(e,t){return t.length<2?e:n(e,o(t,0,-1))}},9965:(e,t,r)=>{var n=r(6392),o="object"==typeof self&&self&&self.Object===Object&&self,i=n||o||Function("return this")();e.exports=i},4302:e=>{e.exports=function(e,t){if(("constructor"!==t||"function"!=typeof e[t])&&"__proto__"!=t)return e[t]}},228:e=>{e.exports=function(e){return this.__data__.set(e,"__lodash_hash_undefined__"),this}},3683:e=>{e.exports=function(e){return this.__data__.has(e)}},6295:e=>{e.exports=function(e){var t=-1,r=Array(e.size);return e.forEach((function(e){r[++t]=e})),r}},7281:(e,t,r)=>{var n=r(4450),o=r(435)(n);e.exports=o},435:e=>{var t=Date.now;e.exports=function(e){var r=0,n=0;return function(){var o=t(),i=16-(o-n);if(n=o,i>0){if(++r>=800)return arguments[0]}else r=0;return e.apply(void 0,arguments)}}},5052:(e,t,r)=>{var n=r(1999);e.exports=function(){this.__data__=new n,this.size=0}},4250:e=>{e.exports=function(e){var t=this.__data__,r=t.delete(e);return this.size=t.size,r}},4773:e=>{e.exports=function(e){return this.__data__.get(e)}},6921:e=>{e.exports=function(e){return this.__data__.has(e)}},5745:(e,t,r)=>{var n=r(1999),o=r(5455),i=r(1549);e.exports=function(e,t){var r=this.__data__;if(r instanceof n){var a=r.__data__;if(!o||a.length<199)return a.push([e,t]),this.size=++r.size,this;r=this.__data__=new i(a)}return r.set(e,t),this.size=r.size,this}},5951:e=>{e.exports=function(e,t,r){for(var n=r-1,o=e.length;++n<o;)if(e[n]===t)return n;return-1}},266:(e,t,r)=>{var n=r(2848),o=/[^.[\]]+|\[(?:(-?\d+(?:\.\d+)?)|(["'])((?:(?!\2)[^\\]|\\.)*?)\2)\]|(?=(?:\.|\[\])(?:\.|\[\]|$))/g,i=/\\(\\)?/g,a=n((function(e){var t=[];return 46===e.charCodeAt(0)&&t.push(""),e.replace(o,(function(e,r,n,o){t.push(n?o.replace(i,"$1"):r||e)})),t}));e.exports=a},8197:(e,t,r)=>{var n=r(7386);e.exports=function(e){if("string"==typeof e||n(e))return e;var t=e+"";return"0"==t&&1/e==-1/0?"-0":t}},3761:e=>{var t=Function.prototype.toString;e.exports=function(e){if(null!=e){try{return t.call(e)}catch(e){}try{return e+""}catch(e){}}return""}},1272:e=>{var t=/\s/;e.exports=function(e){for(var r=e.length;r--&&t.test(e.charAt(r)););return r}},6534:e=>{e.exports=function(e){return function(){return e}}},9517:(e,t,r)=>{var n=r(7453),o=r(2220),i=r(3662),a=Math.max,s=Math.min;e.exports=function(e,t,r){var l,u,c,d,p,f,h=0,v=!1,g=!1,y=!0;if("function"!=typeof e)throw new TypeError("Expected a function");function m(t){var r=l,n=u;return l=u=void 0,h=t,d=e.apply(n,r)}function b(e){var r=e-f;return void 0===f||r>=t||r<0||g&&e-h>=c}function O(){var e=o();if(b(e))return E(e);p=setTimeout(O,function(e){var r=t-(e-f);return g?s(r,c-(e-h)):r}(e))}function E(e){return p=void 0,y&&l?m(e):(l=u=void 0,d)}function S(){var e=o(),r=b(e);if(l=arguments,u=this,f=e,r){if(void 0===p)return function(e){return h=e,p=setTimeout(O,t),v?m(e):d}(f);if(g)return clearTimeout(p),p=setTimeout(O,t),m(f)}return void 0===p&&(p=setTimeout(O,t)),d}return t=i(t)||0,n(r)&&(v=!!r.leading,c=(g="maxWait"in r)?a(i(r.maxWait)||0,t):c,y="trailing"in r?!!r.trailing:y),S.cancel=function(){void 0!==p&&clearTimeout(p),h=0,l=f=u=p=void 0},S.flush=function(){return void 0===p?d:E(o())},S}},6424:e=>{e.exports=function(e,t){return e===t||e!=e&&t!=t}},8472:(e,t,r)=>{var n=r(3158),o=/[\\^$.*+?()[\]{}|]/g,i=RegExp(o.source);e.exports=function(e){return(e=n(e))&&i.test(e)?e.replace(o,"\\$&"):e}},9234:(e,t,r)=>{var n=r(1360);e.exports=function(e){return null!=e&&e.length?n(e,1):[]}},5612:(e,t,r)=>{var n=r(2718);e.exports=function(e,t,r){var o=null==e?void 0:n(e,t);return void 0===o?r:o}},4055:(e,t,r)=>{var n=r(3613),o=r(1518);e.exports=function(e,t){return null!=e&&o(e,t,n)}},912:e=>{e.exports=function(e){return e}},1283:(e,t,r)=>{var n=r(9555),o=r(7134),i=r(8951),a=r(5729),s=r(1624),l=Math.max;e.exports=function(e,t,r,u){e=o(e)?e:s(e),r=r&&!u?a(r):0;var c=e.length;return r<0&&(r=l(c+r,0)),i(e)?r<=c&&e.indexOf(t,r)>-1:!!c&&n(e,t,r)>-1}},5196:(e,t,r)=>{var n=r(3070),o=r(9466),i=Object.prototype,a=i.hasOwnProperty,s=i.propertyIsEnumerable,l=n(function(){return arguments}())?n:function(e){return o(e)&&a.call(e,"callee")&&!s.call(e,"callee")};e.exports=l},4913:e=>{var t=Array.isArray;e.exports=t},7134:(e,t,r)=>{var n=r(1866),o=r(582);e.exports=function(e){return null!=e&&o(e.length)&&!n(e)}},7965:(e,t,r)=>{var n=r(7134),o=r(9466);e.exports=function(e){return o(e)&&n(e)}},4264:(e,t,r)=>{e=r.nmd(e);var n=r(9965),o=r(9375),i=t&&!t.nodeType&&t,a=i&&e&&!e.nodeType&&e,s=a&&a.exports===i?n.Buffer:void 0,l=(s?s.isBuffer:void 0)||o;e.exports=l},7969:(e,t,r)=>{var n=r(6504),o=r(6053),i=r(5196),a=r(4913),s=r(7134),l=r(4264),u=r(5735),c=r(5087),d=Object.prototype.hasOwnProperty;e.exports=function(e){if(null==e)return!0;if(s(e)&&(a(e)||"string"==typeof e||"function"==typeof e.splice||l(e)||c(e)||i(e)))return!e.length;var t=o(e);if("[object Map]"==t||"[object Set]"==t)return!e.size;if(u(e))return!n(e).length;for(var r in e)if(d.call(e,r))return!1;return!0}},1866:(e,t,r)=>{var n=r(9048),o=r(7453);e.exports=function(e){if(!o(e))return!1;var t=n(e);return"[object Function]"==t||"[object GeneratorFunction]"==t||"[object AsyncFunction]"==t||"[object Proxy]"==t}},582:e=>{e.exports=function(e){return"number"==typeof e&&e>-1&&e%1==0&&e<=9007199254740991}},146:(e,t,r)=>{var n=r(2052),o=r(277),i=r(1977),a=i&&i.isMap,s=a?o(a):n;e.exports=s},7453:e=>{e.exports=function(e){var t=typeof e;return null!=e&&("object"==t||"function"==t)}},9466:e=>{e.exports=function(e){return null!=e&&"object"==typeof e}},5219:(e,t,r)=>{var n=r(9048),o=r(6607),i=r(9466),a=Function.prototype,s=Object.prototype,l=a.toString,u=s.hasOwnProperty,c=l.call(Object);e.exports=function(e){if(!i(e)||"[object Object]"!=n(e))return!1;var t=o(e);if(null===t)return!0;var r=u.call(t,"constructor")&&t.constructor;return"function"==typeof r&&r instanceof r&&l.call(r)==c}},8696:(e,t,r)=>{var n=r(5206),o=r(277),i=r(1977),a=i&&i.isSet,s=a?o(a):n;e.exports=s},8951:(e,t,r)=>{var n=r(9048),o=r(4913),i=r(9466);e.exports=function(e){return"string"==typeof e||!o(e)&&i(e)&&"[object String]"==n(e)}},7386:(e,t,r)=>{var n=r(9048),o=r(9466);e.exports=function(e){return"symbol"==typeof e||o(e)&&"[object Symbol]"==n(e)}},5087:(e,t,r)=>{var n=r(9653),o=r(277),i=r(1977),a=i&&i.isTypedArray,s=a?o(a):n;e.exports=s},3790:(e,t,r)=>{var n=r(6791),o=r(6504),i=r(7134);e.exports=function(e){return i(e)?n(e):o(e)}},5961:(e,t,r)=>{var n=r(6791),o=r(9399),i=r(7134);e.exports=function(e){return i(e)?n(e,!0):o(e)}},8906:e=>{e.exports=function(e){var t=null==e?0:e.length;return t?e[t-1]:void 0}},1612:(e,t,r)=>{var n=r(2464),o=r(5473),i=r(3245);e.exports=function(e,t){var r={};return t=i(t,3),o(e,(function(e,o,i){n(r,o,t(e,o,i))})),r}},3272:(e,t,r)=>{var n=r(1549);function o(e,t){if("function"!=typeof e||null!=t&&"function"!=typeof t)throw new TypeError("Expected a function");var r=function(){var n=arguments,o=t?t.apply(this,n):n[0],i=r.cache;if(i.has(o))return i.get(o);var a=e.apply(this,n);return r.cache=i.set(o,a)||i,a};return r.cache=new(o.Cache||n),r}o.Cache=n,e.exports=o},4308:(e,t,r)=>{var n=r(9058),o=r(9511)((function(e,t,r){n(e,t,r)}));e.exports=o},2815:(e,t,r)=>{var n=r(9058),o=r(9511)((function(e,t,r,o){n(e,t,r,o)}));e.exports=o},2220:(e,t,r)=>{var n=r(9965);e.exports=function(){return n.Date.now()}},7027:(e,t,r)=>{var n=r(1428),o=r(6575),i=r(6744),a=r(2361),s=r(4735),l=r(2050),u=r(8496),c=r(869),d=u((function(e,t){var r={};if(null==e)return r;var u=!1;t=n(t,(function(t){return t=a(t,e),u||(u=t.length>1),t})),s(e,c(e),r),u&&(r=o(r,7,l));for(var d=t.length;d--;)i(r,t[d]);return r}));e.exports=d},8831:(e,t,r)=>{var n=r(1),o=r(8496)((function(e,t){return null==e?{}:n(e,t)}));e.exports=o},350:(e,t,r)=>{var n=r(1428),o=r(3245),i=r(9916),a=r(869);e.exports=function(e,t){if(null==e)return{};var r=n(a(e),(function(e){return[e]}));return t=o(t),i(e,r,(function(e,r){return t(e,r[0])}))}},6711:(e,t,r)=>{var n=r(645),o=r(5319),i=r(6394),a=r(8197);e.exports=function(e){return i(e)?n(a(e)):o(e)}},2285:(e,t,r)=>{var n=r(8580)();e.exports=n},9901:(e,t,r)=>{var n=r(1459),o=r(3632),i=r(5729),a=r(3158);e.exports=function(e,t,r){return t=(r?o(e,t,r):void 0===t)?1:i(t),n(a(e),t)}},3547:(e,t,r)=>{var n=r(5725),o=r(9764),i=r(5729),a=r(3158);e.exports=function(e,t,r){return e=a(e),r=null==r?0:n(i(r),0,e.length),t=o(t),e.slice(r,r+t.length)==t}},8721:e=>{e.exports=function(){return[]}},9375:e=>{e.exports=function(){return!1}},1144:(e,t,r)=>{var n=r(3662),o=1/0;e.exports=function(e){return e?(e=n(e))===o||e===-1/0?17976931348623157e292*(e<0?-1:1):e==e?e:0:0===e?e:0}},5729:(e,t,r)=>{var n=r(1144);e.exports=function(e){var t=n(e),r=t%1;return t==t?r?t-r:t:0}},3662:(e,t,r)=>{var n=r(7248),o=r(7453),i=r(7386),a=/^[-+]0x[0-9a-f]+$/i,s=/^0b[01]+$/i,l=/^0o[0-7]+$/i,u=parseInt;e.exports=function(e){if("number"==typeof e)return e;if(i(e))return NaN;if(o(e)){var t="function"==typeof e.valueOf?e.valueOf():e;e=o(t)?t+"":t}if("string"!=typeof e)return 0===e?e:+e;e=n(e);var r=s.test(e);return r||l.test(e)?u(e.slice(2),r?2:8):a.test(e)?NaN:+e}},5148:(e,t,r)=>{var n=r(4735),o=r(5961);e.exports=function(e){return n(e,o(e))}},3158:(e,t,r)=>{var n=r(9764);e.exports=function(e){return null==e?"":n(e)}},1624:(e,t,r)=>{var n=r(1282),o=r(3790);e.exports=function(e){return null==e?[]:n(e,o(e))}},3238:function(e){e.exports=function(){"use strict";var e={isEqual:!0,isMatchingKey:!0,isPromise:!0,maxSize:!0,onCacheAdd:!0,onCacheChange:!0,onCacheHit:!0,transformKey:!0},t=Array.prototype.slice;function r(e){var r=e.length;return r?1===r?[e[0]]:2===r?[e[0],e[1]]:3===r?[e[0],e[1],e[2]]:t.call(e,0):[]}function n(e,t){return e===t||e!=e&&t!=t}function o(e,t){var r={};for(var n in e)r[n]=e[n];for(var n in t)r[n]=t[n];return r}var i=function(){function e(e){this.keys=[],this.values=[],this.options=e;var t="function"==typeof e.isMatchingKey;t?this.getKeyIndex=this._getKeyIndexFromMatchingKey:e.maxSize>1?this.getKeyIndex=this._getKeyIndexForMany:this.getKeyIndex=this._getKeyIndexForSingle,this.canTransformKey="function"==typeof e.transformKey,this.shouldCloneArguments=this.canTransformKey||t,this.shouldUpdateOnAdd="function"==typeof e.onCacheAdd,this.shouldUpdateOnChange="function"==typeof e.onCacheChange,this.shouldUpdateOnHit="function"==typeof e.onCacheHit}return Object.defineProperty(e.prototype,"size",{get:function(){return this.keys.length},enumerable:!1,configurable:!0}),Object.defineProperty(e.prototype,"snapshot",{get:function(){return{keys:r(this.keys),size:this.size,values:r(this.values)}},enumerable:!1,configurable:!0}),e.prototype._getKeyIndexFromMatchingKey=function(e){var t=this.options,r=t.isMatchingKey,n=t.maxSize,o=this.keys,i=o.length;if(!i)return-1;if(r(o[0],e))return 0;if(n>1)for(var a=1;a<i;a++)if(r(o[a],e))return a;return-1},e.prototype._getKeyIndexForMany=function(e){var t=this.options.isEqual,r=this.keys,n=r.length;if(!n)return-1;if(1===n)return this._getKeyIndexForSingle(e);var o,i,a=e.length;if(a>1){for(var s=0;s<n;s++)if((o=r[s]).length===a){for(i=0;i<a&&t(o[i],e[i]);i++);if(i===a)return s}}else for(s=0;s<n;s++)if((o=r[s]).length===a&&t(o[0],e[0]))return s;return-1},e.prototype._getKeyIndexForSingle=function(e){var t=this.keys;if(!t.length)return-1;var r=t[0],n=r.length;if(e.length!==n)return-1;var o=this.options.isEqual;if(n>1){for(var i=0;i<n;i++)if(!o(r[i],e[i]))return-1;return 0}return o(r[0],e[0])?0:-1},e.prototype.orderByLru=function(e,t,r){for(var n=this.keys,o=this.values,i=n.length,a=r;a--;)n[a+1]=n[a],o[a+1]=o[a];n[0]=e,o[0]=t;var s=this.options.maxSize;i===s&&r===i?(n.pop(),o.pop()):r>=s&&(n.length=o.length=s)},e.prototype.updateAsyncCache=function(e){var t=this,r=this.options,n=r.onCacheChange,o=r.onCacheHit,i=this.keys[0],a=this.values[0];this.values[0]=a.then((function(r){return t.shouldUpdateOnHit&&o(t,t.options,e),t.shouldUpdateOnChange&&n(t,t.options,e),r}),(function(e){var r=t.getKeyIndex(i);throw-1!==r&&(t.keys.splice(r,1),t.values.splice(r,1)),e}))},e}();return function t(a,s){if(void 0===s&&(s={}),function(e){return"function"==typeof e&&e.isMemoized}(a))return t(a.fn,o(a.options,s));if("function"!=typeof a)throw new TypeError("You must pass a function to `memoize`.");var l=s.isEqual,u=void 0===l?n:l,c=s.isMatchingKey,d=s.isPromise,p=void 0!==d&&d,f=s.maxSize,h=void 0===f?1:f,v=s.onCacheAdd,g=s.onCacheChange,y=s.onCacheHit,m=s.transformKey,b=o({isEqual:u,isMatchingKey:c,isPromise:p,maxSize:h,onCacheAdd:v,onCacheChange:g,onCacheHit:y,transformKey:m},function(t){var r={};for(var n in t)e[n]||(r[n]=t[n]);return r}(s)),O=new i(b),E=O.keys,S=O.values,T=O.canTransformKey,_=O.shouldCloneArguments,w=O.shouldUpdateOnAdd,R=O.shouldUpdateOnChange,A=O.shouldUpdateOnHit,C=function(){var e=_?r(arguments):arguments;T&&(e=m(e));var t=E.length?O.getKeyIndex(e):-1;if(-1!==t)A&&y(O,b,C),t&&(O.orderByLru(E[t],S[t],t),R&&g(O,b,C));else{var n=a.apply(this,arguments),o=_?e:r(arguments);O.orderByLru(o,n,E.length),p&&O.updateAsyncCache(C),w&&v(O,b,C),R&&g(O,b,C)}return S[0]};return C.cache=O,C.fn=a,C.isMemoized=!0,C.options=b,C}}()},4790:(e,t,r)=>{"use strict";var n=r(4621);function o(){}function i(){}i.resetWarningCache=o,e.exports=function(){function e(e,t,r,o,i,a){if(a!==n){var s=new Error("Calling PropTypes validators directly is not supported by the `prop-types` package. Use PropTypes.checkPropTypes() to call them. Read more at http://fb.me/use-check-prop-types");throw s.name="Invariant Violation",s}}function t(){return e}e.isRequired=e;var r={array:e,bigint:e,bool:e,func:e,number:e,object:e,string:e,symbol:e,any:e,arrayOf:t,element:e,elementType:e,instanceOf:t,node:e,objectOf:t,oneOf:t,oneOfType:t,shape:t,exact:t,checkPropTypes:i,resetWarningCache:o};return r.PropTypes=r,r}},7028:(e,t,r)=>{e.exports=r(4790)()},4621:e=>{"use strict";e.exports="SECRET_DO_NOT_PASS_THIS_OR_YOU_WILL_BE_FIRED"},6563:(e,t)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isNavigator=t.isBrowser=t.off=t.on=t.noop=void 0,t.noop=function(){},t.on=function(e){for(var t=[],r=1;r<arguments.length;r++)t[r-1]=arguments[r];e&&e.addEventListener&&e.addEventListener.apply(e,t)},t.off=function(e){for(var t=[],r=1;r<arguments.length;r++)t[r-1]=arguments[r];e&&e.removeEventListener&&e.removeEventListener.apply(e,t)},t.isBrowser="undefined"!=typeof window,t.isNavigator="undefined"!=typeof navigator},1777:(e,t,r)=>{"use strict";var n=r(4769),o=r(5959),i=n.__importDefault(r(5053));t.A=function(e,t){void 0===t&&(t=[]);var r=i.default(e,t,{loading:!0}),n=r[0],a=r[1];return o.useEffect((function(){a()}),[a]),n}},5053:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0});var n=r(4769),o=r(5959),i=n.__importDefault(r(9812));t.default=function(e,t,r){void 0===t&&(t=[]),void 0===r&&(r={loading:!1});var a=o.useRef(0),s=i.default(),l=o.useState(r),u=l[0],c=l[1],d=o.useCallback((function(){for(var t=[],r=0;r<arguments.length;r++)t[r]=arguments[r];var o=++a.current;return u.loading||c((function(e){return n.__assign(n.__assign({},e),{loading:!0})})),e.apply(void 0,t).then((function(e){return s()&&o===a.current&&c({value:e,loading:!1}),e}),(function(e){return s()&&o===a.current&&c({error:e,loading:!1}),e}))}),t);return[u,d]}},990:(e,t,r)=>{"use strict";var n=r(4769),o=r(5959),i=n.__importDefault(r(1854));t.A=function(e,t,r){void 0===t&&(t=0),void 0===r&&(r=[]);var n=i.default(e,t),a=n[0],s=n[1],l=n[2];return o.useEffect(l,r),[a,s]}},6943:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0});var n=r(5959),o=r(6563).isBrowser?n.useLayoutEffect:n.useEffect;t.default=o},8145:(e,t,r)=>{"use strict";var n=r(4769),o=r(5959),i=n.__importDefault(r(6943)),a=r(6563),s={x:0,y:0,width:0,height:0,top:0,left:0,bottom:0,right:0};t.A=a.isBrowser&&void 0!==window.ResizeObserver?function(){var e=o.useState(null),t=e[0],r=e[1],n=o.useState(s),a=n[0],l=n[1],u=o.useMemo((function(){return new window.ResizeObserver((function(e){if(e[0]){var t=e[0].contentRect,r=t.x,n=t.y,o=t.width,i=t.height,a=t.top,s=t.left,u=t.bottom,c=t.right;l({x:r,y:n,width:o,height:i,top:a,left:s,bottom:u,right:c})}}))}),[]);return i.default((function(){if(t)return u.observe(t),function(){u.disconnect()}}),[t]),[r,a]}:function(){return[a.noop,s]}},9812:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0});var n=r(5959);t.default=function(){var e=n.useRef(!1),t=n.useCallback((function(){return e.current}),[]);return n.useEffect((function(){return e.current=!0,function(){e.current=!1}}),[]),t}},1854:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0});var n=r(5959);t.default=function(e,t){void 0===t&&(t=0);var r=n.useRef(!1),o=n.useRef(),i=n.useRef(e),a=n.useCallback((function(){return r.current}),[]),s=n.useCallback((function(){r.current=!1,o.current&&clearTimeout(o.current),o.current=setTimeout((function(){r.current=!0,i.current()}),t)}),[t]),l=n.useCallback((function(){r.current=null,o.current&&clearTimeout(o.current)}),[]);return n.useEffect((function(){i.current=e}),[e]),n.useEffect((function(){return s(),l}),[t]),[a,l,s]}},8044:(e,t,r)=>{"use strict";var n=r(5959),o=Symbol.for("react.element"),i=Symbol.for("react.fragment"),a=Object.prototype.hasOwnProperty,s=n.__SECRET_INTERNALS_DO_NOT_USE_OR_YOU_WILL_BE_FIRED.ReactCurrentOwner,l={key:!0,ref:!0,__self:!0,__source:!0};function u(e,t,r){var n,i={},u=null,c=null;for(n in void 0!==r&&(u=""+r),void 0!==t.key&&(u=""+t.key),void 0!==t.ref&&(c=t.ref),t)a.call(t,n)&&!l.hasOwnProperty(n)&&(i[n]=t[n]);if(e&&e.defaultProps)for(n in t=e.defaultProps)void 0===i[n]&&(i[n]=t[n]);return{$$typeof:o,type:e,key:u,ref:c,props:i,_owner:s.current}}t.Fragment=i,t.jsx=u,t.jsxs=u},9728:(e,t,r)=>{"use strict";e.exports=r(8044)},138:function(e){var t;t=function(){return function(e){var t={};function r(n){if(t[n])return t[n].exports;var o=t[n]={i:n,l:!1,exports:{}};return e[n].call(o.exports,o,o.exports,r),o.l=!0,o.exports}return r.m=e,r.c=t,r.d=function(e,t,n){r.o(e,t)||Object.defineProperty(e,t,{configurable:!1,enumerable:!0,get:n})},r.n=function(e){var t=e&&e.__esModule?function(){return e.default}:function(){return e};return r.d(t,"a",t),t},r.o=function(e,t){return Object.prototype.hasOwnProperty.call(e,t)},r.p="",r(r.s=3)}([function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SpelNode={create:function(e,t){var r,n={},o=e||"Abstract",i=[],a=null;if(n._type=o,n.getType=function(){return o},n.setType=function(e){o=e},n.getChildren=function(){return i},n.addChild=function(e){if(e){if(!e.setParent)throw{name:"Error",message:"Trying to add a child which is not a node: "+JSON.stringify(e)};e.setParent(n),i.push(e)}},n.getParent=function(){return a},n.setParent=function(e){a=e},n.getContext=function(e){return r||e.activeContext.peek()},n.setContext=function(e){r=e},n.getStartPosition=function(){return t>>16},n.getEndPosition=function(){return 65535&t},n.getValue=function(){throw{name:"MethodNotImplementedException",message:"SpelNode#getValue() must be overridden."}},n.toString=function(){var e="Kind: "+n.getType();e+=", Children: [";for(var t=0,r=n.getChildren().length;t<r;t+=1)e+="{"+n.getChildren()[t]+"}, ";return e+"]"},0===t)throw{name:"Error",message:"Position cannot be 0"};for(var s=arguments.length,l=Array(s>2?s-2:0),u=2;u<s;u++)l[u-2]=arguments[u];return l&&l.forEach((function(e){n.addChild(e)})),n}}},function(e,t,r){"use strict";function n(e){this.elements=e||[]}Object.defineProperty(t,"__esModule",{value:!0}),t.Stack=n,n.prototype.push=function(e){return this.elements.push(e),e},n.prototype.pop=function(){return this.elements.pop()},n.prototype.peek=function(){return this.elements[this.elements.length-1]},n.prototype.empty=function(){return this.elements.length>0},n.prototype.search=function(e){return this.elements.length-this.elements.indexOf(e)}},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var n={LITERAL_INT:1,LITERAL_LONG:2,LITERAL_HEXINT:3,LITERAL_HEXLONG:4,LITERAL_STRING:5,LITERAL_REAL:6,LITERAL_REAL_FLOAT:7,LPAREN:"(",RPAREN:")",COMMA:",",IDENTIFIER:0,COLON:":",HASH:"#",RSQUARE:"]",LSQUARE:"[",LCURLY:"{",RCURLY:"}",DOT:".",PLUS:"+",STAR:"*",MINUS:"-",SELECT_FIRST:"^[",SELECT_LAST:"$[",QMARK:"?",PROJECT:"![",DIV:"/",GE:">=",GT:">",LE:"<=",LT:"<",EQ:"==",NE:"!=",MOD:"%",NOT:"!",ASSIGN:"=",INSTANCEOF:"instanceof",MATCHES:"matches",BETWEEN:"between",SELECT:"?[",POWER:"^",ELVIS:"?:",SAFE_NAVI:"?.",BEAN_REF:"@",SYMBOLIC_OR:"||",SYMBOLIC_AND:"&&",INC:"++",DEC:"--"};function o(e){this.type=e,this.tokenChars=n[e],this._hasPayload="string"!=typeof n[e],"number"==typeof n[e]&&(this._ordinal=n[e])}for(var i in n)n.hasOwnProperty(i)&&(o[i]=new o(i));o.prototype.toString=function(){return this.type+(0!==this.tokenChars.length?"("+this.tokenChars+")":"")},o.prototype.getLength=function(){return this.tokenChars.length},o.prototype.hasPayload=function(){return this._hasPayload},o.prototype.valueOf=function(e){for(var t in n)if(n.hasOwnProperty(t)&&n[t]===e)return o[t]},o.prototype.ordinal=function(){return this._ordinal},t.TokenKind=o},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StandardContext=t.SpelExpressionEvaluator=void 0;var n=r(4),o=r(50);t.SpelExpressionEvaluator=n.SpelExpressionEvaluator,t.StandardContext=o.StandardContext},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SpelExpressionEvaluator=void 0;var n=r(5),o=r(1),i={compile:function(e){var t=(0,n.SpelExpressionParser)().parse(e);return{eval:function(e,r){return function(e,t,r){var n,i=new o.Stack;return t||(t={}),i.push(t),n={rootContext:t,activeContext:i,locals:r},e.getValue(n)}(t,e,r)},_compiledExpression:t}},eval:function(e,t,r){return i.compile(e).eval(t,r)}};t.SpelExpressionEvaluator=i},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SpelExpressionParser=void 0;var n=r(2),o=r(6),i=r(8),a=r(9),s=r(10),l=r(11),u=r(12),c=r(13),d=r(14),p=r(15),f=r(16),h=r(17),v=r(18),g=r(19),y=r(20),m=r(21),b=r(22),O=r(23),E=r(24),S=r(25),T=r(26),_=r(27),w=r(28),R=r(29),A=r(30),C=r(31),I=r(32),x=r(33),L=r(34),N=r(35),j=r(36),P=r(37),k=r(38),F=r(39),D=r(40),M=r(41),V=r(42),U=r(43),B=r(44),q=r(45),G=r(46),K=r(47),W=r(48),z=r(49);t.SpelExpressionParser=function(){var e,t,r,$,H=new RegExp("[\\p{L}\\p{N}_$]+"),Y=[];function Q(){var e=X();if(Se()){var t=_e();if(t.getKind()===n.TokenKind.ASSIGN){null===e&&(e=l.NullLiteral.create(Ie(t.startPos-1,t.endPos-1))),Te();var r=X();return v.Assign.create(Ce(t),e,r)}if(t.getKind()===n.TokenKind.ELVIS){null===e&&(e=l.NullLiteral.create(Ie(t.startPos-1,t.endPos-2))),Te();var o=Q();return null===o&&(o=l.NullLiteral.create(Ie(t.startPos+1,t.endPos+1))),k.Elvis.create(Ce(t),e,o)}if(t.getKind()===n.TokenKind.QMARK){null===e&&(e=l.NullLiteral.create(Ie(t.startPos-1,t.endPos-1))),Te();var i=Q();ye(n.TokenKind.COLON);var a=Q();return P.Ternary.create(Ce(t),e,i,a)}}return e}function X(){for(var e=J();Ee("or")||me(n.TokenKind.SYMBOLIC_OR);){var t=Te(),r=J();Re(t,e,r),e=N.OpOr.create(Ce(t),e,r)}return e}function J(){for(var e=Z();Ee("and")||me(n.TokenKind.SYMBOLIC_AND);){var t=Te(),r=Z();Re(t,e,r),e=L.OpAnd.create(Ce(t),e,r)}return e}function Z(){var e=ee(),t=function(){var e=_e();if(null===e)return null;if(e.isNumericRelationalOperator())return e;if(e.isIdentifier()){var t=e.stringValue();if("instanceof"===t.toLowerCase())return e.asInstanceOfToken();if("matches"===t.toLowerCase())return e.asMatchesToken();if("between"===t.toLowerCase())return e.asBetweenToken()}return null}();if(null!==t){var r=Te(),o=ee();Re(r,e,o);var i=t.kind;if(t.isNumericRelationalOperator()){var a=Ce(r);return i===n.TokenKind.GT?b.OpGT.create(a,e,o):i===n.TokenKind.LT?E.OpLT.create(a,e,o):i===n.TokenKind.LE?O.OpLE.create(a,e,o):i===n.TokenKind.GE?m.OpGE.create(a,e,o):i===n.TokenKind.EQ?g.OpEQ.create(a,e,o):y.OpNE.create(a,e,o)}return i===n.TokenKind.INSTANCEOF?U.OpInstanceof.create(Ce(r),e,o):i===n.TokenKind.MATCHES?j.OpMatches.create(Ce(r),e,o):B.OpBetween.create(Ce(r),e,o)}return e}function ee(){for(var e=te();Oe(n.TokenKind.PLUS,n.TokenKind.MINUS,n.TokenKind.INC);){var t=Te(),r=te();Ae(t,r),t.getKind()===n.TokenKind.PLUS?e=S.OpPlus.create(Ce(t),e,r):t.getKind()===n.TokenKind.MINUS&&(e=T.OpMinus.create(Ce(t),e,r))}return e}function te(){for(var e=re();Oe(n.TokenKind.STAR,n.TokenKind.DIV,n.TokenKind.MOD);){var t=Te(),r=re();Re(t,e,r),e=t.getKind()===n.TokenKind.STAR?_.OpMultiply.create(Ce(t),e,r):t.getKind()===n.TokenKind.DIV?w.OpDivide.create(Ce(t),e,r):R.OpModulus.create(Ce(t),e,r)}return e}function re(){var e,t=ne();if(me(n.TokenKind.POWER)){e=Te();var r=ne();return Ae(e,r),A.OpPower.create(Ce(e),t,r)}return null!==t&&Oe(n.TokenKind.INC,n.TokenKind.DEC)?(e=Te()).getKind()===n.TokenKind.INC?C.OpInc.create(Ce(e),!0,t):I.OpDec.create(Ce(e),!0,t):t}function ne(){var e,t;return Oe(n.TokenKind.PLUS,n.TokenKind.MINUS,n.TokenKind.NOT)?(e=Te(),t=ne(),e.getKind()===n.TokenKind.NOT?x.OpNot.create(Ce(e),t):e.getKind()===n.TokenKind.PLUS?S.OpPlus.create(Ce(e),t):T.OpMinus.create(Ce(e),t)):Oe(n.TokenKind.INC,n.TokenKind.DEC)?(e=Te(),t=ne(),e.getKind()===n.TokenKind.INC?C.OpInc.create(Ce(e),!1,t):I.OpDec.create(Ce(e),!1,t)):function(){var e=[],t=function(){var e=_e();if(null===e)return!1;if(e.getKind()===n.TokenKind.LITERAL_INT||e.getKind()===n.TokenKind.LITERAL_LONG)ve(a.NumberLiteral.create(parseInt(e.stringValue(),10),Ce(e)));else if(e.getKind()===n.TokenKind.LITERAL_REAL||e.getKind()===n.TokenKind.LITERAL_REAL_FLOAT)ve(a.NumberLiteral.create(parseFloat(e.stringValue()),Ce(e)));else if(e.getKind()===n.TokenKind.LITERAL_HEXINT||e.getKind()===n.TokenKind.LITERAL_HEXLONG)ve(a.NumberLiteral.create(parseInt(e.stringValue(),16),Ce(e)));else if(Ee("true"))ve(i.BooleanLiteral.create(!0,Ce(e)));else if(Ee("false"))ve(i.BooleanLiteral.create(!1,Ce(e)));else{if(e.getKind()!==n.TokenKind.LITERAL_STRING)return!1;ve(s.StringLiteral.create(e.stringValue(),Ce(e)))}return Te(),!0}()||function(){if(me(n.TokenKind.LPAREN)){Te();var e=Q();return ye(n.TokenKind.RPAREN),ve(e),!0}return!1}()||function(){if(me(n.TokenKind.IDENTIFIER)){var e=_e();if("T"!==e.stringValue())return!1;var t=Te();if(me(n.TokenKind.RSQUARE))return ve(d.PropertyReference.create(t.stringValue(),Ce(t))),!0;ye(n.TokenKind.LPAREN);for(var r=pe(),o=0;be(n.TokenKind.LSQUARE,!0);)ye(n.TokenKind.RSQUARE),o++;return ye(n.TokenKind.RPAREN),ve(q.TypeReference.create(Ce(e),r,o)),!0}return!1}()||function(){if(me(n.TokenKind.IDENTIFIER)){var e=_e();return"null"===e.stringValue().toLowerCase()&&(Te(),ve(l.NullLiteral.create(Ce(e))),!0)}return!1}()||function(){if(Ee("new")){var e=Te();if(me(n.TokenKind.RSQUARE))return ve(d.PropertyReference.create(e.stringValue(),Ce(e))),!0;var t=pe(),r=[];if(r.push(t),me(n.TokenKind.LSQUARE)){for(var o=[];be(n.TokenKind.LSQUARE,!0);)me(n.TokenKind.RSQUARE)?o.push(null):o.push(Q()),ye(n.TokenKind.RSQUARE);ue()&&r.push(ge()),ve(z.ConstructorReference.create(Ce(e),o,r))}else i=r,me(n.TokenKind.LPAREN)||we(Ce(_e()),"MISSING_CONSTRUCTOR_ARGS"),se(i),ye(n.TokenKind.RPAREN),ve(z.ConstructorReference.create(Ce(e),r));return!0}var i;return!1}()||he(!1)||ie()||function(){if(me(n.TokenKind.BEAN_REF)){var e=Te(),t=null,r=null;return me(n.TokenKind.IDENTIFIER)?r=(t=ye(n.TokenKind.IDENTIFIER)).data:me(n.TokenKind.LITERAL_STRING)?r=(r=(t=ye(n.TokenKind.LITERAL_STRING)).stringValue()).substring(1,r.length()-1):we(e.startPos,"INVALID_BEAN_REFERENCE"),ve(G.BeanReference.create(Ce(t),r)),!0}return!1}()||le(!1)||de(!1)||ce()||ue()?ge():null;for(e.push(t);oe();)e.push(ge());return 1===e.length?e[0]:f.CompoundExpression.create(Ie(t.getStartPosition(),e[e.length-1].getEndPosition()),e)}()}function oe(){var e,t,r;return null!==(r=Oe(n.TokenKind.DOT,n.TokenKind.SAFE_NAVI)?he(t=(e=Te()).getKind()===n.TokenKind.SAFE_NAVI)||ie()||le(t)||de(t)?ge():(null===_e()?we(e.startPos,"OOD"):we(e.startPos,"UNEXPECTED_DATA_AFTER_DOT",function(e){return e.getKind().hasPayload()?e.stringValue():e.getKind().toString().toLowerCase()}(_e())),null):me(n.TokenKind.LSQUARE)&&ce()?ge():null)&&(ve(r),!0)}function ie(){if(!me(n.TokenKind.HASH))return!1;var e=Te(),t=ye(n.TokenKind.IDENTIFIER),r=ae();return null===r?(ve(p.VariableReference.create(t.data,Ie(e.startPos,t.endPos))),!0):(ve(u.FunctionReference.create(t.data,Ie(e.startPos,t.endPos),r)),!0)}function ae(){if(!me(n.TokenKind.LPAREN))return null;var e=[];return se(e),ye(n.TokenKind.RPAREN),e}function se(e){var t,r=_e().startPos;do{Te();var o=_e();null===o&&we(r,"RUN_OUT_OF_ARGUMENTS"),o.getKind()!==n.TokenKind.RPAREN&&e.push(Q()),t=_e()}while(null!==t&&t.kind===n.TokenKind.COMMA);null===t&&we(r,"RUN_OUT_OF_ARGUMENTS")}function le(e){var t=_e();if(!be(n.TokenKind.PROJECT,!0))return!1;var r=Q();return ye(n.TokenKind.RSQUARE),ve(V.Projection.create(e,Ce(t),r)),!0}function ue(){var e=_e(),t=[];if(!be(n.TokenKind.LCURLY,!0))return!1;var r=null,o=_e();if(be(n.TokenKind.RCURLY,!0))r=F.InlineList.create(Ie(e.startPos,o.endPos));else if(be(n.TokenKind.COLON,!0))o=ye(n.TokenKind.RCURLY),r=D.InlineMap.create(Ie(e.startPos,o.endPos));else{var i=Q();if(me(n.TokenKind.RCURLY))t.push(i),o=ye(n.TokenKind.RCURLY),r=F.InlineList.create(Ie(e.startPos,o.endPos),t);else if(be(n.TokenKind.COMMA,!0)){t.push(i);do{t.push(Q())}while(be(n.TokenKind.COMMA,!0));o=ye(n.TokenKind.RCURLY),r=F.InlineList.create(Ce(e.startPos,o.endPos),t)}else if(be(n.TokenKind.COLON,!0)){var a=[];for(a.push(i),a.push(Q());be(n.TokenKind.COMMA,!0);)a.push(Q()),ye(n.TokenKind.COLON),a.push(Q());o=ye(n.TokenKind.RCURLY),r=D.InlineMap.create(Ie(e.startPos,o.endPos),a)}else we(e.startPos,"OOD")}return ve(r),!0}function ce(){var e=_e();if(!be(n.TokenKind.LSQUARE,!0))return!1;var t=Q();return ye(n.TokenKind.RSQUARE),ve(h.Indexer.create(Ce(e),t)),!0}function de(e){var t=_e();if(!function(){if(!Se())return!1;var e=_e();return e.getKind()===n.TokenKind.SELECT||e.getKind()===n.TokenKind.SELECT_FIRST||e.getKind()===n.TokenKind.SELECT_LAST}())return!1;Te();var r=Q();return null===r&&we(Ce(t),"MISSING_SELECTION_EXPRESSION"),ye(n.TokenKind.RSQUARE),t.getKind()===n.TokenKind.SELECT_FIRST?ve(M.Selection.create(e,M.Selection.FIRST,Ce(t),r)):t.getKind()===n.TokenKind.SELECT_LAST?ve(M.Selection.create(e,M.Selection.LAST,Ce(t),r)):ve(M.Selection.create(e,M.Selection.ALL,Ce(t),r)),!0}function pe(){for(var t=[],r=_e();fe(r);)Te(),r.kind!==n.TokenKind.DOT&&t.push(K.Identifier.create(r.stringValue(),Ce(r))),r=_e();t.length||(null===r&&we(e.length(),"OOD"),we(r.startPos,"NOT_EXPECTED_TOKEN","qualified ID",r.getKind().toString().toLowerCase()));var o=Ie(t[0].getStartPosition(),t[t.length-1].getEndPosition());return W.QualifiedIdentifier.create(o,t)}function fe(e){if(null===e||e.kind===n.TokenKind.LITERAL_STRING)return!1;if(e.kind===n.TokenKind.DOT||e.kind===n.TokenKind.IDENTIFIER)return!0;var t=e.stringValue();return t&&t.length&&H.test(t)}function he(e){if(me(n.TokenKind.IDENTIFIER)){var t=Te(),r=ae();return null===r?(ve(d.PropertyReference.create(e,t.stringValue(),Ce(t))),!0):(ve(c.MethodReference.create(e,t.stringValue(),Ce(t),r)),!0)}return!1}function ve(e){Y.push(e)}function ge(){return Y.pop()}function ye(t){var r=Te();return null===r&&we(e.length,"OOD"),r.getKind()!==t&&we(r.startPos,"NOT_EXPECTED_TOKEN",t.toString().toLowerCase(),r.getKind().toString().toLowerCase()),r}function me(e){return be(e,!1)}function be(e,t){if(!Se())return!1;var r=_e();return r.getKind()===e?(t&&$++,!0):e===n.TokenKind.IDENTIFIER&&r.getKind().ordinal()>=n.TokenKind.DIV.ordinal()&&r.getKind().ordinal()<=n.TokenKind.NOT.ordinal()&&null!==r.data}function Oe(){if(!Se())return!1;for(var e=_e(),t=Array.prototype.slice.call(arguments),r=0,n=t.length;r<n;r+=1)if(e.getKind()===t[r])return!0;return!1}function Ee(e){if(!Se())return!1;var t=_e();return t.getKind()===n.TokenKind.IDENTIFIER&&t.stringValue().toLowerCase()===e.toLowerCase()}function Se(){return $<t.length}function Te(){return $>=r?null:t[$++]}function _e(){return $>=r?null:t[$]}function we(t,r,n,o){throw n&&(r+="\nExpected: "+n),o&&(r+="\nActual: "+o),{name:"InternalParseException",message:"Error occurred while attempting to parse expression '"+e+"' at position "+t+". Message: "+r}}function Re(e,t,r){!function(e,t){null===t&&we(e.startPos,"LEFT_OPERAND_PROBLEM")}(e,t),Ae(e,r)}function Ae(e,t){null===t&&we(e.startPos,"RIGHT_OPERAND_PROBLEM")}function Ce(e){return(e.startPos<<16)+e.endPos}function Ie(e,t){return(e<<16)+t}return{setConfiguration:function(e){},parse:function(n,i){try{e=n,t=o.Tokenizer.tokenize(n),r=t.length,$=0,Y=[];var a=Q();return Se()&&we(_e().startPos,"MORE_INPUT",Te().toString()),a}catch(e){throw e.message}}}}},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Tokenizer=void 0;var n=r(7),o=r(2),i=["DIV","EQ","GE","GT","LE","LT","MOD","NE","NOT"],a=[];!function(){var e;for(e="0".charCodeAt(0);e<="9".charCodeAt(0);e+=1)a[e]|=3;for(e="A".charCodeAt(0);e<="F".charCodeAt(0);e+=1)a[e]|=2;for(e="a".charCodeAt(0);e<="f".charCodeAt(0);e+=1)a[e]|=2;for(e="A".charCodeAt(0);e<="Z".charCodeAt(0);e+=1)a[e]|=4;for(e="a".charCodeAt(0);e<="z".charCodeAt(0);e+=1)a[e]|=4}(),t.Tokenizer={tokenize:function(e){var t=e,r=e+"\0",s=r.length,l=0,u=[];function c(){for(var e,i=l,a=!1;!a;)if("'"===(e=r[l+=1])&&("'"===r[l+1]?l+=1:a=!0),0===e.charCodeAt(0))throw{name:"SpelParseException",message:"Non-terminating quoted string in expression ("+t+") at position "+l};l+=1,u.push(new n.Token(o.TokenKind.LITERAL_STRING,y(i,l),i,l))}function d(){for(var e,i=l,a=!1;!a;)if('"'===(e=r[l+=1])&&('"'===r[l+1]?l+=1:a=!0),0===e.charCodeAt(0))throw{name:"SpelParseException",message:"Non-terminating double-quoted string in expression ("+t+") at position "+l};l+=1,u.push(new n.Token(o.TokenKind.LITERAL_STRING,y(i,l),i,l))}function p(e){var n,o,i,a=!1,s=l,u=r[l+1];if(!e||"x"!==u&&"X"!==u){do{l+=1}while(_(r[l]));if("."===(u=r[l])){a=!0,n=l;do{l+=1}while(_(r[l]));if(l===n+1)return void h(y(s,l=n),!1,s,l)}if(o=l,E("L","l")){if(a)throw{name:"SpelParseException",message:"Real cannot be long in expression ("+t+") at position "+l};h(y(s,o),!0,s,o),l+=1}else if(function(e){return"e"===e||"E"===e}(r[l])){a=!0,function(e){return"+"===e||"-"===e}(r[l+=1])&&(l+=1);do{l+=1}while(_(r[l]));i=!1,S(r[l])?(i=!0,o=l+=1):T(r[l])&&(o=l+=1),g(y(s,l),i,s,l)}else i=!1,S(u=r[l])?(a=!0,i=!0,o=l+=1):T(u)&&(a=!0,o=l+=1),a?g(y(s,o),i,s,o):h(y(s,o),!1,s,o)}else{l+=1;do{l+=1}while(R(r[l]));E("L","l")?(v(y(s+2,l),!0,s,l),l+=1):v(y(s+2,l),!1,s,l)}}function f(){var e,t,a,s=l;do{l+=1}while(w(a=r[l])||_(a)||"_"===a||"$"===a);e=y(s,l),(l-s==2||l-s==3)&&(t=e.toUpperCase(),i.indexOf(t)>=0)?function(e,t,r){u.push(new n.Token(e,r,t,t+e.getLength()))}(o.TokenKind.valueOf(t),s,e):u.push(new n.Token(o.TokenKind.IDENTIFIER,e.replace("\0",""),s,l))}function h(e,t,r,i){t?u.push(new n.Token(o.TokenKind.LITERAL_LONG,e,r,i)):u.push(new n.Token(o.TokenKind.LITERAL_INT,e,r,i))}function v(e,r,i,a){if(0===e.length)throw r?{name:"SpelParseException",message:"Not a long in expression ("+t+") at position "+l}:{name:"SpelParseException",message:"Not an int in expression ("+t+") at position "+l};r?u.push(new n.Token(o.TokenKind.LITERAL_HEXLONG,e,i,a)):u.push(new n.Token(o.TokenKind.LITERAL_HEXINT,e,i,a))}function g(e,t,r,i){t?u.push(new n.Token(o.TokenKind.LITERAL_REAL_FLOAT,e,r,i)):u.push(new n.Token(o.TokenKind.LITERAL_REAL,e,r,i))}function y(e,t){return r.substring(e,t)}function m(e){return 2===e.tokenChars.length&&r[l]===e.tokenChars[0]&&r[l+1]===e.tokenChars[1]}function b(e){u.push(new n.Token(e,null,l,l+1)),l+=1}function O(e){u.push(new n.Token(e,null,l,l+2)),l+=2}function E(e,t){var n=r[l];return n===e||n===t}function S(e){return"f"===e||"F"===e}function T(e){return"d"===e||"D"===e}function _(e){return!(e.charCodeAt(0)>255||!(1&a[e.charCodeAt(0)]))}function w(e){return!(e.charCodeAt(0)>255||!(4&a[e.charCodeAt(0)]))}function R(e){return!(e.charCodeAt(0)>255||!(2&a[e.charCodeAt(0)]))}return function(){for(var e;l<s;)if(w(e=r[l]))f();else switch(e){case"+":m(o.TokenKind.INC)?O(o.TokenKind.INC):b(o.TokenKind.PLUS);break;case"_":f();break;case"-":m(o.TokenKind.DEC)?O(o.TokenKind.DEC):b(o.TokenKind.MINUS);break;case":":b(o.TokenKind.COLON);break;case".":b(o.TokenKind.DOT);break;case",":b(o.TokenKind.COMMA);break;case"*":b(o.TokenKind.STAR);break;case"/":b(o.TokenKind.DIV);break;case"%":b(o.TokenKind.MOD);break;case"(":b(o.TokenKind.LPAREN);break;case")":b(o.TokenKind.RPAREN);break;case"[":b(o.TokenKind.LSQUARE);break;case"#":b(o.TokenKind.HASH);break;case"]":b(o.TokenKind.RSQUARE);break;case"{":b(o.TokenKind.LCURLY);break;case"}":b(o.TokenKind.RCURLY);break;case"@":b(o.TokenKind.BEAN_REF);break;case"^":m(o.TokenKind.SELECT_FIRST)?O(o.TokenKind.SELECT_FIRST):b(o.TokenKind.POWER);break;case"!":m(o.TokenKind.NE)?O(o.TokenKind.NE):m(o.TokenKind.PROJECT)?O(o.TokenKind.PROJECT):b(o.TokenKind.NOT);break;case"=":m(o.TokenKind.EQ)?O(o.TokenKind.EQ):b(o.TokenKind.ASSIGN);break;case"&":if(!m(o.TokenKind.SYMBOLIC_AND))throw{name:"SpelParseException",message:"Missing character '&' in expression ("+t+") at position "+l};O(o.TokenKind.SYMBOLIC_AND);break;case"|":if(!m(o.TokenKind.SYMBOLIC_OR))throw{name:"SpelParseException",message:"Missing character '|' in expression ("+t+") at position "+l};O(o.TokenKind.SYMBOLIC_OR);break;case"?":m(o.TokenKind.SELECT)?O(o.TokenKind.SELECT):m(o.TokenKind.ELVIS)?O(o.TokenKind.ELVIS):m(o.TokenKind.SAFE_NAVI)?O(o.TokenKind.SAFE_NAVI):b(o.TokenKind.QMARK);break;case"$":m(o.TokenKind.SELECT_LAST)?O(o.TokenKind.SELECT_LAST):f();break;case">":m(o.TokenKind.GE)?O(o.TokenKind.GE):b(o.TokenKind.GT);break;case"<":m(o.TokenKind.LE)?O(o.TokenKind.LE):b(o.TokenKind.LT);break;case"0":case"1":case"2":case"3":case"4":case"5":case"6":case"7":case"8":case"9":p("0"===e);break;case" ":case"\t":case"\r":case"\n":case"\0":l+=1;break;case"'":c();break;case'"':d();break;case"\\":throw{name:"SpelParseException",message:"Unexpected escape character in expression ("+t+") at position "+l};default:throw{name:"SpelParseException",message:"Cannot handle character '"+e+"' in expression ("+t+") at position "+l}}}(),u}}},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Token=void 0;var n=r(2);function o(e,t,r,n){this.kind=e,this.startPos=r,this.endPos=n,t&&(this.data=t)}o.prototype.getKind=function(){return this.kind},o.prototype.toString=function(){var e="[";return e+=this.kind.toString(),this.kind.hasPayload()&&(e+=":"+this.data),(e+="]")+"("+this.startPos+","+this.endPos+")"},o.prototype.isIdentifier=function(){return this.kind===n.TokenKind.IDENTIFIER},o.prototype.isNumericRelationalOperator=function(){return this.kind===n.TokenKind.GT||this.kind===n.TokenKind.GE||this.kind===n.TokenKind.LT||this.kind===n.TokenKind.LE||this.kind===n.TokenKind.EQ||this.kind===n.TokenKind.NE},o.prototype.stringValue=function(){return this.data},o.prototype.asInstanceOfToken=function(){return new o(n.TokenKind.INSTANCEOF,this.startPos,this.endPos)},o.prototype.asMatchesToken=function(){return new o(n.TokenKind.MATCHES,this.startPos,this.endPos)},o.prototype.asBetweenToken=function(){return new o(n.TokenKind.BETWEEN,this.startPos,this.endPos)},o.prototype.getStartPosition=function(){return this.startPos},o.prototype.getEndPosition=function(){return this.endPos},t.Token=o},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.BooleanLiteral=void 0;var n=r(0);t.BooleanLiteral={create:function(e,t){var r=n.SpelNode.create("boolean",t);return r.getValue=function(){return e},r.setValue=function(t){return e=t},r}}},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.NumberLiteral=void 0;var n=r(0);t.NumberLiteral={create:function(e,t){var r=n.SpelNode.create("number",t);return r.getValue=function(){return e},r.setValue=function(t){return e=t},r}}},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StringLiteral=void 0;var n=r(0);t.StringLiteral={create:function(e,t){var r=n.SpelNode.create("string",t);return e=function(e){return("'"===e[0]&&"'"===e[e.length-1]||'"'===e[0]&&'"'===e[e.length-1])&&(e=e.substring(1,e.length-1)),e.replace(/''/g,"'").replace(/""/g,'"')}(e),r.getValue=function(){return e},r.setValue=function(t){return e=t},r}}},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.NullLiteral=void 0;var n=r(0);t.NullLiteral={create:function(e,t){var r=n.SpelNode.create("null",t);return r.getValue=function(){return null},r}}},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FunctionReference=void 0;var n=r(0),o=r(1);t.FunctionReference={create:function(e,t,r){var i=n.SpelNode.create("function",t);return i.getRaw=function(){return{functionName:e,args:r}},i.getValue=function(t){var n=t.locals||{},i=t.rootContext,a=[];if(r.forEach((function(e){var r=t.activeContext;t.activeContext=new o.Stack,t.activeContext.push(t.rootContext),a.push(e.getValue(t)),t.activeContext=r})),n[e])return n[e].apply(i,a);throw{name:"FunctionDoesNotExistException",message:"Function '"+e+"' does not exist."}},i}}},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.MethodReference=void 0;var n=r(0),o=r(1);t.MethodReference={create:function(e,t,r,i){var a=n.SpelNode.create("method",r);return a.getRaw=function(){return{methodName:t,args:i}},a.getValue=function(r){var n,a=r.activeContext.peek(),s=[];if(!a)throw{name:"ContextDoesNotExistException",message:"Attempting to look up property '"+t+"' for an undefined context."};function l(r){if(null==r){if(e)return null;throw{name:"NullPointerException",message:"Method "+t+" does not exist."}}return r}if(i.forEach((function(e){var t=r.activeContext;r.activeContext=new o.Stack,r.activeContext.push(r.rootContext),s.push(e.getValue(r)),r.activeContext=t})),"get"===t.substr(0,3)&&!a[t])return l(a[t.charAt(3).toLowerCase()+t.substring(4)]);if("set"===t.substr(0,3)&&!a[t])return a[t.charAt(3).toLowerCase()+t.substring(4)]=s[0];if(Array.isArray(a)){if("size"===t)return a.length;if("contains"===t)return a.includes(s[0])}return(n=l(a[t]))?n.apply(a,s):null},a}}},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.PropertyReference=void 0;var n=r(0);t.PropertyReference={create:function(e,t,r){var o=n.SpelNode.create("property",r);return o.getRaw=function(){return t},o.getValue=function(r){var n=r.activeContext.peek();if(!n){if(e)return null;throw{name:"ContextDoesNotExistException",message:"Attempting to look up property '"+t+"' for an undefined context."}}if(void 0===n[t]||null===n[t]){if(e)return null;if("size"===t&&Array.isArray(n))return n.length;throw{name:"NullPointerException",message:"Property '"+t+"' does not exist."}}return n[t]},o.setValue=function(e,r){var n=r.activeContext.peek();if(!n)throw{name:"ContextDoesNotExistException",message:"Attempting to assign property '"+t+"' for an undefined context."};return n[t]=e},o.getName=function(){return t},o}}},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.VariableReference=void 0;var n=r(0);t.VariableReference={create:function(e,t){var r=n.SpelNode.create("variable",t);return r.getRaw=function(){return e},r.getValue=function(t){var r=t.activeContext.peek(),n=t.locals;if(!r)throw{name:"ContextDoesNotExistException",message:"Attempting to look up variable '"+e+"' for an undefined context."};return"this"===e?r:"root"===e?t.rootContext:n[e]},r.setValue=function(t,r){return r.locals[e]=t},r}}},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CompoundExpression=void 0;var n=r(0);t.CompoundExpression={create:function(e,t){var r=n.SpelNode.create.apply(null,["compound",e].concat(t));function o(e){var t,n=r.getChildren().length;for(t=0;t<n;t+=1)"indexer"===r.getChildren()[t].getType()?e.activeContext.push(e.activeContext.peek()[r.getChildren()[t].getValue(e)]):e.activeContext.push(r.getChildren()[t].getValue(e));return function(){for(t=0;t<n;t+=1)e.activeContext.pop()}}return r.getValue=function(e){var t;if(!e.activeContext.peek())throw{name:"ContextDoesNotExistException",message:"Attempting to evaluate compound expression with an undefined context."};var r=o(e);return t=e.activeContext.peek(),r(),t},r.setValue=function(e,t){var n=o(t),i=r.getChildren().length;return t.activeContext.pop(),e=r.getChildren()[i-1].setValue(e,t),t.activeContext.push(null),n(),e},r}}},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Indexer=void 0;var n=r(0),o=r(1);t.Indexer={create:function(e,t){var r=n.SpelNode.create.apply(null,["indexer",e].concat(t));return r.getValue=function(e){var t,n,i=e.activeContext,a=r.getChildren().length;if(e.activeContext=new o.Stack,e.activeContext.push(e.rootContext),!e.activeContext.peek())throw{name:"ContextDoesNotExistException",message:"Attempting to evaluate compound expression with an undefined context."};for(t=0;t<a;t+=1)e.activeContext.push(r.getChildren()[t].getValue(e));for(n=e.activeContext.peek(),t=0;t<a;t+=1)e.activeContext.pop();return e.activeContext=i,n},r}}},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Assign=void 0;var n=r(0);t.Assign={create:function(e,t,r){var o=n.SpelNode.create("assign",e,t,r);return o.getValue=function(e){if(!e.activeContext.peek())throw{name:"ContextDoesNotExistException",message:"Attempting to assign property '"+t.getValue(e)+"' for an undefined context."};return t.setValue(r.getValue(e),e)},o}}},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.OpEQ=void 0;var n=r(0);t.OpEQ={create:function(e,t,r){var o=n.SpelNode.create("op-eq",e,t,r);return o.getValue=function(e){return t.getValue(e)===r.getValue(e)},o}}},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.OpNE=void 0;var n=r(0);t.OpNE={create:function(e,t,r){var o=n.SpelNode.create("op-ne",e,t,r);return o.getValue=function(e){return t.getValue(e)!==r.getValue(e)},o}}},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.OpGE=void 0;var n=r(0);t.OpGE={create:function(e,t,r){var o=n.SpelNode.create("op-ge",e,t,r);return o.getValue=function(e){return t.getValue(e)>=r.getValue(e)},o}}},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.OpGT=void 0;var n=r(0);t.OpGT={create:function(e,t,r){var o=n.SpelNode.create("op-gt",e,t,r);return o.getValue=function(e){return t.getValue(e)>r.getValue(e)},o}}},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.OpLE=void 0;var n=r(0);t.OpLE={create:function(e,t,r){var o=n.SpelNode.create("op-le",e,t,r);return o.getValue=function(e){return t.getValue(e)<=r.getValue(e)},o}}},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.OpLT=void 0;var n=r(0);t.OpLT={create:function(e,t,r){var o=n.SpelNode.create("op-lt",e,t,r);return o.getValue=function(e){return t.getValue(e)<r.getValue(e)},o}}},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.OpPlus=void 0;var n=r(0);t.OpPlus={create:function(e,t,r){var o=n.SpelNode.create("op-plus",e,t,r);return o.getValue=function(e){return r?t.getValue(e)+r.getValue(e):+t.getValue(e)},o}}},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.OpMinus=void 0;var n=r(0);t.OpMinus={create:function(e,t,r){var o=n.SpelNode.create("op-minus",e,t,r);return o.getValue=function(e){return r?t.getValue(e)-r.getValue(e):-t.getValue(e)},o}}},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.OpMultiply=void 0;var n=r(0);t.OpMultiply={create:function(e,t,r){var o=n.SpelNode.create("op-multiply",e,t,r);return o.getValue=function(e){var n=t.getValue(e),o=r.getValue(e);if("number"==typeof n&&"number"==typeof o)return n*o;if("string"==typeof n&&"number"==typeof o){for(var i="",a=0;a<o;a+=1)i+=n;return i}return null},o}}},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.OpDivide=void 0;var n=r(0);t.OpDivide={create:function(e,t,r){var o=n.SpelNode.create("op-divide",e,t,r);return o.getValue=function(e){return t.getValue(e)/r.getValue(e)},o}}},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.OpModulus=void 0;var n=r(0);t.OpModulus={create:function(e,t,r){var o=n.SpelNode.create("op-modulus",e,t,r);return o.getValue=function(e){return t.getValue(e)%r.getValue(e)},o}}},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.OpPower=void 0;var n=r(0);t.OpPower={create:function(e,t,r){var o=n.SpelNode.create("op-power",e,t,r);return o.getValue=function(e){return Math.pow(t.getValue(e),r.getValue(e))},o}}},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.OpInc=void 0;var n=r(0);t.OpInc={create:function(e,t,r){var o=n.SpelNode.create("op-inc",e,r);return o.getValue=function(e){var n=r.getValue(e);return r.setValue(n+1,e),t?n:n+1},o}}},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.OpDec=void 0;var n=r(0);t.OpDec={create:function(e,t,r){var o=n.SpelNode.create("op-dec",e,r);return o.getValue=function(e){var n=r.getValue(e);return r.setValue(n-1,e),t?n:n-1},o}}},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.OpNot=void 0;var n=r(0);t.OpNot={create:function(e,t){var r=n.SpelNode.create("op-not",e,t);return r.getValue=function(e){return!t.getValue(e)},r}}},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.OpAnd=void 0;var n=r(0);t.OpAnd={create:function(e,t,r){var o=n.SpelNode.create("op-and",e,t,r);return o.getValue=function(e){return!!t.getValue(e)&&!!r.getValue(e)},o}}},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.OpOr=void 0;var n=r(0);t.OpOr={create:function(e,t,r){var o=n.SpelNode.create("op-or",e,t,r);return o.getValue=function(e){return!!t.getValue(e)||!!r.getValue(e)},o}}},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.OpMatches=void 0;var n=r(0);t.OpMatches={create:function(e,t,r){var o=n.SpelNode.create("matches",e,t,r);return o.getValue=function(e){var n=t.getValue(e),o=r.getValue(e);try{return!!new RegExp(o).exec(n)}catch(e){throw{name:"EvaluationException",message:e.toString()}}},o}}},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Ternary=void 0;var n=r(0);t.Ternary={create:function(e,t,r,o){var i=n.SpelNode.create("ternary",e,t,r,o);return i.getValue=function(e){return t.getValue(e)?r.getValue(e):o.getValue(e)},i}}},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Elvis=void 0;var n=r(0);t.Elvis={create:function(e,t,r){var o=n.SpelNode.create("elvis",e,t,r);return o.getValue=function(e){return null!==t.getValue(e)?t.getValue(e):r.getValue(e)},o}}},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.InlineList=void 0;var n=r(0);t.InlineList={create:function(e,t){var r=n.SpelNode.create("list",e),o=[].concat(t||[]);return r.getRaw=function(){return o},r.getValue=function(e){return o.map((function(t){return t.getValue(e)}))},r}}},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.InlineMap=void 0;var n=r(0);t.InlineMap={create:function(e,t){var r=n.SpelNode.create("map",e),o=[].concat(t||[]);return r.getValue=function(e){var t=!0,r=null,n={};return o.forEach((function(o){t?r="property"===o.getType()?o.getName():o.getValue(e):n[r]=o.getValue(e),t=!t})),n},r}}},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Selection=void 0;var n="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(e){return typeof e}:function(e){return e&&"function"==typeof Symbol&&e.constructor===Symbol&&e!==Symbol.prototype?"symbol":typeof e},o=r(0);function i(e,t,r){var n;return r.activeContext.push(e),n=t.getValue(r),r.activeContext.pop(),n}t.Selection={create:function(e,t,r,a){var s=o.SpelNode.create("selection",r,a);return s.getValue=function(e){var r=e.activeContext.peek();if(r){if(Array.isArray(r))return function(e,t,r,n){var o=e.filter((function(e){return i(e,r,n)}));switch(t){case"ALL":return o;case"FIRST":return o[0]||null;case"LAST":return o.length?o[o.length-1]:null}}(r,t,a,e);if("object"===(void 0===r?"undefined":n(r)))return function(e,t,r,n){var o,a,s={},l=[],u={};for(a in e)e.hasOwnProperty(a)&&i(o={key:a,value:e[a]},r,n)&&l.push(o);switch(t){case"ALL":return l.forEach((function(e){s[e.key]=e.value})),s;case"FIRST":return l.length?(u[l[0].key]=l[0].value,u):null;case"LAST":return l.length?(u[l[l.length-1].key]=l[l.length-1].value,u):null}l.forEach((function(e){s[e.key]=e.value}))}(r,t,a,e)}return null},s},FIRST:"FIRST",LAST:"LAST",ALL:"ALL"}},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Projection=void 0;var n="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(e){return typeof e}:function(e){return e&&"function"==typeof Symbol&&e.constructor===Symbol&&e!==Symbol.prototype?"symbol":typeof e},o=r(0);function i(e,t,r){return e.map((function(e){var n;return r.activeContext.push(e),n=t.getValue(r),r.activeContext.pop(),n}))}t.Projection={create:function(e,t,r){var a=o.SpelNode.create("projection",t,r);return a.getValue=function(e){var t,o=e.activeContext.peek(),a=[];if(Array.isArray(o))return i(o,r,e);if("object"===(void 0===o?"undefined":n(o))){for(t in o)o.hasOwnProperty(t)&&a.push(o[t]);return i(a,r,e)}return null},a}}},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.OpInstanceof=void 0;var n=r(0);t.OpInstanceof={create:function(e,t,r){var o=n.SpelNode.create("instanceof",e,t,r);return o.getValue=function(e){throw{name:"MethodNotImplementedException",message:"OpInstanceOf: Not implemented"}},o}}},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.OpBetween=void 0;var n=r(0);t.OpBetween={create:function(e,t,r){var o=n.SpelNode.create("between",e,t,r);return o.getValue=function(e){throw{name:"MethodNotImplementedException",message:"OpBetween: Not implemented"}},o}}},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.TypeReference=void 0;var n=r(0);t.TypeReference={create:function(e,t,r){return(t=n.SpelNode.create("typeref",e,t)).getValue=function(e){throw{name:"MethodNotImplementedException",message:"TypeReference: Not implemented"}},t}}},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.BeanReference=void 0;var n=r(0);t.BeanReference={create:function(e,t){var r=n.SpelNode.create("beanref",e);return r.getValue=function(e){throw{name:"MethodNotImplementedException",message:"BeanReference: Not implemented"}},r}}},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Identifier=void 0;var n=r(0);t.Identifier={create:function(e,t){var r=n.SpelNode.create("identifier",t);return r.getRaw=function(){return e},r.getValue=function(e){throw{name:"MethodNotImplementedException",message:"Identifier: Not implemented"}},r}}},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.QualifiedIdentifier=void 0;var n=r(0);t.QualifiedIdentifier={create:function(e,t){var r=n.SpelNode.create.apply(n.SpelNode,["qualifiedidentifier",e].concat(function(e){if(Array.isArray(e)){for(var t=0,r=Array(e.length);t<e.length;t++)r[t]=e[t];return r}return Array.from(e)}(t)));return r.getRaw=function(){return t.map((function(e){return e.getRaw()}))},r.getValue=function(e){throw{name:"MethodNotImplementedException",message:"QualifiedIdentifier: Not implemented"}},r}}},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ConstructorReference=void 0;var n=r(0),o=r(1);t.ConstructorReference={create:function(e,t,r){var i,a=void 0!==r;a?i=t.length&&t[0]&&"number"===t[0].getType()?t[0].getValue():null:(r=t,t=void 0);var s,l=(s=r,Array.isArray(s)?s:Array.from(s)),u=(l[0],l.slice(1)),c=n.SpelNode.create.apply(n.SpelNode,["constructorref",e].concat(function(e){if(Array.isArray(e)){for(var t=0,r=Array(e.length);t<e.length;t++)r[t]=e[t];return r}return Array.from(e)}(r)));return c.getRaw=function(){return i},c.getValue=function(e){if(a&&u.length<=1){var t=[];return u.forEach((function(r){var n=e.activeContext;e.activeContext=new o.Stack,e.activeContext.push(e.rootContext),t.push(r.getValue(e)),e.activeContext=n})),1===u.length?t[0]:i?new Array(i):[]}throw{name:"MethodNotImplementedException",message:"ConstructorReference: Not implemented"}},c}}},function(e,t,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StandardContext={create:function(e,t){var r={};return r.authentication=e||{},r.principal=t||{},r.hasRole=function(e){var t=!1;return!!e&&!(!r.authentication&&!Array.isArray(r.authentication.authorities))&&(r.authentication.authorities.forEach((function(r){r.authority.toLowerCase()===e.toLowerCase()&&(t=!0)})),t)},r.hasPermission=function(){var e=Array.prototype.slice.call(arguments);if(1===e.length)return r.hasRole(e[0])},r}}}])},e.exports=t()},9157:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.default=void 0;var n=l(r(1283)),o=l(r(1025)),i=l(r(2520)),a=l(r(9137)),s=l(r(9429));function l(e){return e&&e.__esModule?e:{default:e}}function u(e,t){for(var r=0;r<t.length;r++){var n=t[r];n.enumerable=n.enumerable||!1,n.configurable=!0,"value"in n&&(n.writable=!0),Object.defineProperty(e,n.key,n)}}var c=function(e){return e.replace(/[\t ]+$/,"")},d=function(){function e(t,r,n){!function(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}(this,e),this.cfg=t||{},this.indentation=new i.default(this.cfg.indent),this.inlineBlock=new a.default,this.params=new s.default(this.cfg.params),this.tokenizer=r,this.tokenOverride=n,this.previousReservedWord={},this.tokens=[],this.index=0}var t,r;return t=e,r=[{key:"format",value:function(e){return this.tokens=this.tokenizer.tokenize(e),this.getFormattedQueryFromTokens().trim()}},{key:"getFormattedQueryFromTokens",value:function(){var e=this,t="";return this.tokens.forEach((function(r,n){e.index=n,e.tokenOverride&&(r=e.tokenOverride(r,e.previousReservedWord)||r),r.type===o.default.WHITESPACE||(r.type===o.default.LINE_COMMENT?t=e.formatLineComment(r,t):r.type===o.default.BLOCK_COMMENT?t=e.formatBlockComment(r,t):r.type===o.default.RESERVED_TOP_LEVEL?(t=e.formatTopLevelReservedWord(r,t),e.previousReservedWord=r):r.type===o.default.RESERVED_TOP_LEVEL_NO_INDENT?(t=e.formatTopLevelReservedWordNoIndent(r,t),e.previousReservedWord=r):r.type===o.default.RESERVED_NEWLINE?(t=e.formatNewlineReservedWord(r,t),e.previousReservedWord=r):r.type===o.default.RESERVED?(t=e.formatWithSpaces(r,t),e.previousReservedWord=r):t=r.type===o.default.OPEN_PAREN?e.formatOpeningParentheses(r,t):r.type===o.default.CLOSE_PAREN?e.formatClosingParentheses(r,t):r.type===o.default.PLACEHOLDER?e.formatPlaceholder(r,t):","===r.value?e.formatComma(r,t):":"===r.value?e.formatWithSpaceAfter(r,t):"."===r.value?e.formatWithoutSpaces(r,t):";"===r.value?e.formatQuerySeparator(r,t):e.formatWithSpaces(r,t))})),t}},{key:"formatLineComment",value:function(e,t){return this.addNewline(t+e.value)}},{key:"formatBlockComment",value:function(e,t){return this.addNewline(this.addNewline(t)+this.indentComment(e.value))}},{key:"indentComment",value:function(e){return e.replace(/\n[\t ]*/g,"\n"+this.indentation.getIndent()+" ")}},{key:"formatTopLevelReservedWordNoIndent",value:function(e,t){return this.indentation.decreaseTopLevel(),t=this.addNewline(t)+this.equalizeWhitespace(this.formatReservedWord(e.value)),this.addNewline(t)}},{key:"formatTopLevelReservedWord",value:function(e,t){return this.indentation.decreaseTopLevel(),t=this.addNewline(t),this.indentation.increaseTopLevel(),t+=this.equalizeWhitespace(this.formatReservedWord(e.value)),this.addNewline(t)}},{key:"formatNewlineReservedWord",value:function(e,t){return this.addNewline(t)+this.equalizeWhitespace(this.formatReservedWord(e.value))+" "}},{key:"equalizeWhitespace",value:function(e){return e.replace(/[\t-\r \xA0\u1680\u2000-\u200A\u2028\u2029\u202F\u205F\u3000\uFEFF]+/g," ")}},{key:"formatOpeningParentheses",value:function(e,t){var r=[o.default.WHITESPACE,o.default.OPEN_PAREN,o.default.LINE_COMMENT];return(0,n.default)(r,this.previousToken().type)||(t=c(t)),t+=this.cfg.uppercase?e.value.toUpperCase():e.value,this.inlineBlock.beginIfPossible(this.tokens,this.index),this.inlineBlock.isActive()||(this.indentation.increaseBlockLevel(),t=this.addNewline(t)),t}},{key:"formatClosingParentheses",value:function(e,t){return e.value=this.cfg.uppercase?e.value.toUpperCase():e.value,this.inlineBlock.isActive()?(this.inlineBlock.end(),this.formatWithSpaceAfter(e,t)):(this.indentation.decreaseBlockLevel(),this.formatWithSpaces(e,this.addNewline(t)))}},{key:"formatPlaceholder",value:function(e,t){return t+this.params.get(e)+" "}},{key:"formatComma",value:function(e,t){return t=c(t)+e.value+" ",this.inlineBlock.isActive()||/^LIMIT$/i.test(this.previousReservedWord.value)?t:this.addNewline(t)}},{key:"formatWithSpaceAfter",value:function(e,t){return c(t)+e.value+" "}},{key:"formatWithoutSpaces",value:function(e,t){return c(t)+e.value}},{key:"formatWithSpaces",value:function(e,t){return t+("reserved"===e.type?this.formatReservedWord(e.value):e.value)+" "}},{key:"formatReservedWord",value:function(e){return this.cfg.uppercase?e.toUpperCase():e}},{key:"formatQuerySeparator",value:function(e,t){return this.indentation.resetIndentation(),c(t)+e.value+"\n".repeat(this.cfg.linesBetweenQueries||1)}},{key:"addNewline",value:function(e){return(e=c(e)).endsWith("\n")||(e+="\n"),e+this.indentation.getIndent()}},{key:"previousToken",value:function(){var e=arguments.length>0&&void 0!==arguments[0]?arguments[0]:1;return this.tokens[this.index-e]||{}}}],r&&u(t.prototype,r),e}();t.default=d,e.exports=t.default},2520:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.default=void 0;var n=i(r(9901)),o=i(r(8906));function i(e){return e&&e.__esModule?e:{default:e}}function a(e,t){for(var r=0;r<t.length;r++){var n=t[r];n.enumerable=n.enumerable||!1,n.configurable=!0,"value"in n&&(n.writable=!0),Object.defineProperty(e,n.key,n)}}var s="top-level",l=function(){function e(t){!function(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}(this,e),this.indent=t||"  ",this.indentTypes=[]}var t,r;return t=e,(r=[{key:"getIndent",value:function(){return(0,n.default)(this.indent,this.indentTypes.length)}},{key:"increaseTopLevel",value:function(){this.indentTypes.push(s)}},{key:"increaseBlockLevel",value:function(){this.indentTypes.push("block-level")}},{key:"decreaseTopLevel",value:function(){(0,o.default)(this.indentTypes)===s&&this.indentTypes.pop()}},{key:"decreaseBlockLevel",value:function(){for(;this.indentTypes.length>0&&this.indentTypes.pop()===s;);}},{key:"resetIndentation",value:function(){this.indentTypes=[]}}])&&a(t.prototype,r),e}();t.default=l,e.exports=t.default},9137:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.default=void 0;var n,o=(n=r(1025))&&n.__esModule?n:{default:n};function i(e,t){for(var r=0;r<t.length;r++){var n=t[r];n.enumerable=n.enumerable||!1,n.configurable=!0,"value"in n&&(n.writable=!0),Object.defineProperty(e,n.key,n)}}var a=function(){function e(){!function(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}(this,e),this.level=0}var t,r;return t=e,(r=[{key:"beginIfPossible",value:function(e,t){0===this.level&&this.isInlineBlock(e,t)?this.level=1:this.level>0?this.level++:this.level=0}},{key:"end",value:function(){this.level--}},{key:"isActive",value:function(){return this.level>0}},{key:"isInlineBlock",value:function(e,t){for(var r=0,n=0,i=t;i<e.length;i++){var a=e[i];if((r+=a.value.length)>50)return!1;if(a.type===o.default.OPEN_PAREN)n++;else if(a.type===o.default.CLOSE_PAREN&&0==--n)return!0;if(this.isForbiddenToken(a))return!1}return!1}},{key:"isForbiddenToken",value:function(e){var t=e.type,r=e.value;return t===o.default.RESERVED_TOP_LEVEL||t===o.default.RESERVED_NEWLINE||t===o.default.COMMENT||t===o.default.BLOCK_COMMENT||";"===r}}])&&i(t.prototype,r),e}();t.default=a,e.exports=t.default},9429:(e,t)=>{"use strict";function r(e,t){for(var r=0;r<t.length;r++){var n=t[r];n.enumerable=n.enumerable||!1,n.configurable=!0,"value"in n&&(n.writable=!0),Object.defineProperty(e,n.key,n)}}Object.defineProperty(t,"__esModule",{value:!0}),t.default=void 0;var n=function(){function e(t){!function(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}(this,e),this.params=t,this.index=0}var t,n;return t=e,(n=[{key:"get",value:function(e){var t=e.key,r=e.value;return this.params?t?this.params[t]:this.params[this.index++]:r}}])&&r(t.prototype,n),e}();t.default=n,e.exports=t.default},3202:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.default=void 0;var n=a(r(7969)),o=a(r(8472)),i=a(r(1025));function a(e){return e&&e.__esModule?e:{default:e}}function s(e,t){for(var r=0;r<t.length;r++){var n=t[r];n.enumerable=n.enumerable||!1,n.configurable=!0,"value"in n&&(n.writable=!0),Object.defineProperty(e,n.key,n)}}var l=function(){function e(t){!function(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}(this,e),this.WHITESPACE_REGEX=/^([\t-\r \xA0\u1680\u2000-\u200A\u2028\u2029\u202F\u205F\u3000\uFEFF]+)/,this.NUMBER_REGEX=/^((\x2D[\t-\r \xA0\u1680\u2000-\u200A\u2028\u2029\u202F\u205F\u3000\uFEFF]*)?[0-9]+(\.[0-9]+)?|0x[0-9A-Fa-f]+|0b[01]+)\b/,this.OPERATOR_REGEX=/^(!=|<>|==|<=|>=|!<|!>|\|\||::|\x2D>>|\x2D>|~~\*|~~|!~~\*|!~~|~\*|!~\*|!~|:=|(?:[\0-\t\x0B\f\x0E-\u2027\u202A-\uD7FF\uE000-\uFFFF]|[\uD800-\uDBFF][\uDC00-\uDFFF]|[\uD800-\uDBFF](?![\uDC00-\uDFFF])|(?:[^\uD800-\uDBFF]|^)[\uDC00-\uDFFF]))/,this.BLOCK_COMMENT_REGEX=/^(\/\*(?:[\0-\uD7FF\uE000-\uFFFF]|[\uD800-\uDBFF][\uDC00-\uDFFF]|[\uD800-\uDBFF](?![\uDC00-\uDFFF])|(?:[^\uD800-\uDBFF]|^)[\uDC00-\uDFFF])*?(?:\*\/|$))/,this.LINE_COMMENT_REGEX=this.createLineCommentRegex(t.lineCommentTypes),this.RESERVED_TOP_LEVEL_REGEX=this.createReservedWordRegex(t.reservedTopLevelWords),this.RESERVED_TOP_LEVEL_NO_INDENT_REGEX=this.createReservedWordRegex(t.reservedTopLevelWordsNoIndent),this.RESERVED_NEWLINE_REGEX=this.createReservedWordRegex(t.reservedNewlineWords),this.RESERVED_PLAIN_REGEX=this.createReservedWordRegex(t.reservedWords),this.WORD_REGEX=this.createWordRegex(t.specialWordChars),this.STRING_REGEX=this.createStringRegex(t.stringTypes),this.OPEN_PAREN_REGEX=this.createParenRegex(t.openParens),this.CLOSE_PAREN_REGEX=this.createParenRegex(t.closeParens),this.INDEXED_PLACEHOLDER_REGEX=this.createPlaceholderRegex(t.indexedPlaceholderTypes,"[0-9]*"),this.IDENT_NAMED_PLACEHOLDER_REGEX=this.createPlaceholderRegex(t.namedPlaceholderTypes,"[a-zA-Z0-9._$]+"),this.STRING_NAMED_PLACEHOLDER_REGEX=this.createPlaceholderRegex(t.namedPlaceholderTypes,this.createStringPattern(t.stringTypes))}var t,r;return t=e,r=[{key:"createLineCommentRegex",value:function(e){return new RegExp("^((?:".concat(e.map((function(e){return(0,o.default)(e)})).join("|"),").*?(?:\r\n|\r|\n|$))"),"u")}},{key:"createReservedWordRegex",value:function(e){var t=e.join("|").replace(/ /g,"\\s+");return new RegExp("^(".concat(t,")\\b"),"iu")}},{key:"createWordRegex",value:function(){return new RegExp("^([\\p{Alphabetic}\\p{Mark}\\p{Decimal_Number}\\p{Connector_Punctuation}\\p{Join_Control}".concat((arguments.length>0&&void 0!==arguments[0]?arguments[0]:[]).join(""),"]+)"),"u")}},{key:"createStringRegex",value:function(e){return new RegExp("^("+this.createStringPattern(e)+")","u")}},{key:"createStringPattern",value:function(e){var t={"``":"((`[^`]*($|`))+)","[]":"((\\[[^\\]]*($|\\]))(\\][^\\]]*($|\\]))*)",'""':'(("[^"\\\\]*(?:\\\\.[^"\\\\]*)*("|$))+)',"''":"(('[^'\\\\]*(?:\\\\.[^'\\\\]*)*('|$))+)","N''":"((N'[^N'\\\\]*(?:\\\\.[^N'\\\\]*)*('|$))+)"};return e.map((function(e){return t[e]})).join("|")}},{key:"createParenRegex",value:function(e){var t=this;return new RegExp("^("+e.map((function(e){return t.escapeParen(e)})).join("|")+")","iu")}},{key:"escapeParen",value:function(e){return 1===e.length?(0,o.default)(e):"\\b"+e+"\\b"}},{key:"createPlaceholderRegex",value:function(e,t){if((0,n.default)(e))return!1;var r=e.map(o.default).join("|");return new RegExp("^((?:".concat(r,")(?:").concat(t,"))"),"u")}},{key:"tokenize",value:function(e){if(!e)return[];for(var t,r=[];e.length;)t=this.getNextToken(e,t),e=e.substring(t.value.length),r.push(t);return r}},{key:"getNextToken",value:function(e,t){return this.getWhitespaceToken(e)||this.getCommentToken(e)||this.getStringToken(e)||this.getOpenParenToken(e)||this.getCloseParenToken(e)||this.getPlaceholderToken(e)||this.getNumberToken(e)||this.getReservedWordToken(e,t)||this.getWordToken(e)||this.getOperatorToken(e)}},{key:"getWhitespaceToken",value:function(e){return this.getTokenOnFirstMatch({input:e,type:i.default.WHITESPACE,regex:this.WHITESPACE_REGEX})}},{key:"getCommentToken",value:function(e){return this.getLineCommentToken(e)||this.getBlockCommentToken(e)}},{key:"getLineCommentToken",value:function(e){return this.getTokenOnFirstMatch({input:e,type:i.default.LINE_COMMENT,regex:this.LINE_COMMENT_REGEX})}},{key:"getBlockCommentToken",value:function(e){return this.getTokenOnFirstMatch({input:e,type:i.default.BLOCK_COMMENT,regex:this.BLOCK_COMMENT_REGEX})}},{key:"getStringToken",value:function(e){return this.getTokenOnFirstMatch({input:e,type:i.default.STRING,regex:this.STRING_REGEX})}},{key:"getOpenParenToken",value:function(e){return this.getTokenOnFirstMatch({input:e,type:i.default.OPEN_PAREN,regex:this.OPEN_PAREN_REGEX})}},{key:"getCloseParenToken",value:function(e){return this.getTokenOnFirstMatch({input:e,type:i.default.CLOSE_PAREN,regex:this.CLOSE_PAREN_REGEX})}},{key:"getPlaceholderToken",value:function(e){return this.getIdentNamedPlaceholderToken(e)||this.getStringNamedPlaceholderToken(e)||this.getIndexedPlaceholderToken(e)}},{key:"getIdentNamedPlaceholderToken",value:function(e){return this.getPlaceholderTokenWithKey({input:e,regex:this.IDENT_NAMED_PLACEHOLDER_REGEX,parseKey:function(e){return e.slice(1)}})}},{key:"getStringNamedPlaceholderToken",value:function(e){var t=this;return this.getPlaceholderTokenWithKey({input:e,regex:this.STRING_NAMED_PLACEHOLDER_REGEX,parseKey:function(e){return t.getEscapedPlaceholderKey({key:e.slice(2,-1),quoteChar:e.slice(-1)})}})}},{key:"getIndexedPlaceholderToken",value:function(e){return this.getPlaceholderTokenWithKey({input:e,regex:this.INDEXED_PLACEHOLDER_REGEX,parseKey:function(e){return e.slice(1)}})}},{key:"getPlaceholderTokenWithKey",value:function(e){var t=e.input,r=e.regex,n=e.parseKey,o=this.getTokenOnFirstMatch({input:t,regex:r,type:i.default.PLACEHOLDER});return o&&(o.key=n(o.value)),o}},{key:"getEscapedPlaceholderKey",value:function(e){var t=e.key,r=e.quoteChar;return t.replace(new RegExp((0,o.default)("\\"+r),"gu"),r)}},{key:"getNumberToken",value:function(e){return this.getTokenOnFirstMatch({input:e,type:i.default.NUMBER,regex:this.NUMBER_REGEX})}},{key:"getOperatorToken",value:function(e){return this.getTokenOnFirstMatch({input:e,type:i.default.OPERATOR,regex:this.OPERATOR_REGEX})}},{key:"getReservedWordToken",value:function(e,t){if(!t||!t.value||"."!==t.value)return this.getTopLevelReservedToken(e)||this.getNewlineReservedToken(e)||this.getTopLevelReservedTokenNoIndent(e)||this.getPlainReservedToken(e)}},{key:"getTopLevelReservedToken",value:function(e){return this.getTokenOnFirstMatch({input:e,type:i.default.RESERVED_TOP_LEVEL,regex:this.RESERVED_TOP_LEVEL_REGEX})}},{key:"getNewlineReservedToken",value:function(e){return this.getTokenOnFirstMatch({input:e,type:i.default.RESERVED_NEWLINE,regex:this.RESERVED_NEWLINE_REGEX})}},{key:"getTopLevelReservedTokenNoIndent",value:function(e){return this.getTokenOnFirstMatch({input:e,type:i.default.RESERVED_TOP_LEVEL_NO_INDENT,regex:this.RESERVED_TOP_LEVEL_NO_INDENT_REGEX})}},{key:"getPlainReservedToken",value:function(e){return this.getTokenOnFirstMatch({input:e,type:i.default.RESERVED,regex:this.RESERVED_PLAIN_REGEX})}},{key:"getWordToken",value:function(e){return this.getTokenOnFirstMatch({input:e,type:i.default.WORD,regex:this.WORD_REGEX})}},{key:"getTokenOnFirstMatch",value:function(e){var t=e.input,r=e.type,n=e.regex,o=t.match(n);if(o)return{type:r,value:o[1]}}}],r&&s(t.prototype,r),e}();t.default=l,e.exports=t.default},1025:(e,t)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.default=void 0,t.default={WHITESPACE:"whitespace",WORD:"word",STRING:"string",RESERVED:"reserved",RESERVED_TOP_LEVEL:"reserved-top-level",RESERVED_TOP_LEVEL_NO_INDENT:"reserved-top-level-no-indent",RESERVED_NEWLINE:"reserved-newline",OPERATOR:"operator",OPEN_PAREN:"open-paren",CLOSE_PAREN:"close-paren",LINE_COMMENT:"line-comment",BLOCK_COMMENT:"block-comment",NUMBER:"number",PLACEHOLDER:"placeholder"},e.exports=t.default},4377:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.default=void 0;var n=i(r(9157)),o=i(r(3202));function i(e){return e&&e.__esModule?e:{default:e}}function a(e,t){for(var r=0;r<t.length;r++){var n=t[r];n.enumerable=n.enumerable||!1,n.configurable=!0,"value"in n&&(n.writable=!0),Object.defineProperty(e,n.key,n)}}var s,l=["ABS","ACTIVATE","ALIAS","ALL","ALLOCATE","ALLOW","ALTER","ANY","ARE","ARRAY","AS","ASC","ASENSITIVE","ASSOCIATE","ASUTIME","ASYMMETRIC","AT","ATOMIC","ATTRIBUTES","AUDIT","AUTHORIZATION","AUX","AUXILIARY","AVG","BEFORE","BEGIN","BETWEEN","BIGINT","BINARY","BLOB","BOOLEAN","BOTH","BUFFERPOOL","BY","CACHE","CALL","CALLED","CAPTURE","CARDINALITY","CASCADED","CASE","CAST","CCSID","CEIL","CEILING","CHAR","CHARACTER","CHARACTER_LENGTH","CHAR_LENGTH","CHECK","CLOB","CLONE","CLOSE","CLUSTER","COALESCE","COLLATE","COLLECT","COLLECTION","COLLID","COLUMN","COMMENT","COMMIT","CONCAT","CONDITION","CONNECT","CONNECTION","CONSTRAINT","CONTAINS","CONTINUE","CONVERT","CORR","CORRESPONDING","COUNT","COUNT_BIG","COVAR_POP","COVAR_SAMP","CREATE","CROSS","CUBE","CUME_DIST","CURRENT","CURRENT_DATE","CURRENT_DEFAULT_TRANSFORM_GROUP","CURRENT_LC_CTYPE","CURRENT_PATH","CURRENT_ROLE","CURRENT_SCHEMA","CURRENT_SERVER","CURRENT_TIME","CURRENT_TIMESTAMP","CURRENT_TIMEZONE","CURRENT_TRANSFORM_GROUP_FOR_TYPE","CURRENT_USER","CURSOR","CYCLE","DATA","DATABASE","DATAPARTITIONNAME","DATAPARTITIONNUM","DATE","DAY","DAYS","DB2GENERAL","DB2GENRL","DB2SQL","DBINFO","DBPARTITIONNAME","DBPARTITIONNUM","DEALLOCATE","DEC","DECIMAL","DECLARE","DEFAULT","DEFAULTS","DEFINITION","DELETE","DENSERANK","DENSE_RANK","DEREF","DESCRIBE","DESCRIPTOR","DETERMINISTIC","DIAGNOSTICS","DISABLE","DISALLOW","DISCONNECT","DISTINCT","DO","DOCUMENT","DOUBLE","DROP","DSSIZE","DYNAMIC","EACH","EDITPROC","ELEMENT","ELSE","ELSEIF","ENABLE","ENCODING","ENCRYPTION","END","END-EXEC","ENDING","ERASE","ESCAPE","EVERY","EXCEPTION","EXCLUDING","EXCLUSIVE","EXEC","EXECUTE","EXISTS","EXIT","EXP","EXPLAIN","EXTENDED","EXTERNAL","EXTRACT","FALSE","FENCED","FETCH","FIELDPROC","FILE","FILTER","FINAL","FIRST","FLOAT","FLOOR","FOR","FOREIGN","FREE","FULL","FUNCTION","FUSION","GENERAL","GENERATED","GET","GLOBAL","GOTO","GRANT","GRAPHIC","GROUP","GROUPING","HANDLER","HASH","HASHED_VALUE","HINT","HOLD","HOUR","HOURS","IDENTITY","IF","IMMEDIATE","IN","INCLUDING","INCLUSIVE","INCREMENT","INDEX","INDICATOR","INDICATORS","INF","INFINITY","INHERIT","INNER","INOUT","INSENSITIVE","INSERT","INT","INTEGER","INTEGRITY","INTERSECTION","INTERVAL","INTO","IS","ISOBID","ISOLATION","ITERATE","JAR","JAVA","KEEP","KEY","LABEL","LANGUAGE","LARGE","LATERAL","LC_CTYPE","LEADING","LEAVE","LEFT","LIKE","LINKTYPE","LN","LOCAL","LOCALDATE","LOCALE","LOCALTIME","LOCALTIMESTAMP","LOCATOR","LOCATORS","LOCK","LOCKMAX","LOCKSIZE","LONG","LOOP","LOWER","MAINTAINED","MATCH","MATERIALIZED","MAX","MAXVALUE","MEMBER","MERGE","METHOD","MICROSECOND","MICROSECONDS","MIN","MINUTE","MINUTES","MINVALUE","MOD","MODE","MODIFIES","MODULE","MONTH","MONTHS","MULTISET","NAN","NATIONAL","NATURAL","NCHAR","NCLOB","NEW","NEW_TABLE","NEXTVAL","NO","NOCACHE","NOCYCLE","NODENAME","NODENUMBER","NOMAXVALUE","NOMINVALUE","NONE","NOORDER","NORMALIZE","NORMALIZED","NOT","NULL","NULLIF","NULLS","NUMERIC","NUMPARTS","OBID","OCTET_LENGTH","OF","OFFSET","OLD","OLD_TABLE","ON","ONLY","OPEN","OPTIMIZATION","OPTIMIZE","OPTION","ORDER","OUT","OUTER","OVER","OVERLAPS","OVERLAY","OVERRIDING","PACKAGE","PADDED","PAGESIZE","PARAMETER","PART","PARTITION","PARTITIONED","PARTITIONING","PARTITIONS","PASSWORD","PATH","PERCENTILE_CONT","PERCENTILE_DISC","PERCENT_RANK","PIECESIZE","PLAN","POSITION","POWER","PRECISION","PREPARE","PREVVAL","PRIMARY","PRIQTY","PRIVILEGES","PROCEDURE","PROGRAM","PSID","PUBLIC","QUERY","QUERYNO","RANGE","RANK","READ","READS","REAL","RECOVERY","RECURSIVE","REF","REFERENCES","REFERENCING","REFRESH","REGR_AVGX","REGR_AVGY","REGR_COUNT","REGR_INTERCEPT","REGR_R2","REGR_SLOPE","REGR_SXX","REGR_SXY","REGR_SYY","RELEASE","RENAME","REPEAT","RESET","RESIGNAL","RESTART","RESTRICT","RESULT","RESULT_SET_LOCATOR","RETURN","RETURNS","REVOKE","RIGHT","ROLE","ROLLBACK","ROLLUP","ROUND_CEILING","ROUND_DOWN","ROUND_FLOOR","ROUND_HALF_DOWN","ROUND_HALF_EVEN","ROUND_HALF_UP","ROUND_UP","ROUTINE","ROW","ROWNUMBER","ROWS","ROWSET","ROW_NUMBER","RRN","RUN","SAVEPOINT","SCHEMA","SCOPE","SCRATCHPAD","SCROLL","SEARCH","SECOND","SECONDS","SECQTY","SECURITY","SENSITIVE","SEQUENCE","SESSION","SESSION_USER","SIGNAL","SIMILAR","SIMPLE","SMALLINT","SNAN","SOME","SOURCE","SPECIFIC","SPECIFICTYPE","SQL","SQLEXCEPTION","SQLID","SQLSTATE","SQLWARNING","SQRT","STACKED","STANDARD","START","STARTING","STATEMENT","STATIC","STATMENT","STAY","STDDEV_POP","STDDEV_SAMP","STOGROUP","STORES","STYLE","SUBMULTISET","SUBSTRING","SUM","SUMMARY","SYMMETRIC","SYNONYM","SYSFUN","SYSIBM","SYSPROC","SYSTEM","SYSTEM_USER","TABLE","TABLESAMPLE","TABLESPACE","THEN","TIME","TIMESTAMP","TIMEZONE_HOUR","TIMEZONE_MINUTE","TO","TRAILING","TRANSACTION","TRANSLATE","TRANSLATION","TREAT","TRIGGER","TRIM","TRUE","TRUNCATE","TYPE","UESCAPE","UNDO","UNIQUE","UNKNOWN","UNNEST","UNTIL","UPPER","USAGE","USER","USING","VALIDPROC","VALUE","VARCHAR","VARIABLE","VARIANT","VARYING","VAR_POP","VAR_SAMP","VCAT","VERSION","VIEW","VOLATILE","VOLUMES","WHEN","WHENEVER","WHILE","WIDTH_BUCKET","WINDOW","WITH","WITHIN","WITHOUT","WLM","WRITE","XMLELEMENT","XMLEXISTS","XMLNAMESPACES","YEAR","YEARS"],u=["ADD","AFTER","ALTER COLUMN","ALTER TABLE","DELETE FROM","EXCEPT","FETCH FIRST","FROM","GROUP BY","GO","HAVING","INSERT INTO","INTERSECT","LIMIT","ORDER BY","SELECT","SET CURRENT SCHEMA","SET SCHEMA","SET","UPDATE","VALUES","WHERE"],c=["INTERSECT","INTERSECT ALL","MINUS","UNION","UNION ALL"],d=["AND","CROSS JOIN","INNER JOIN","JOIN","LEFT JOIN","LEFT OUTER JOIN","OR","OUTER JOIN","RIGHT JOIN","RIGHT OUTER JOIN"],p=function(){function e(t){!function(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}(this,e),this.cfg=t}var t,r;return t=e,(r=[{key:"format",value:function(e){return s||(s=new o.default({reservedWords:l,reservedTopLevelWords:u,reservedNewlineWords:d,reservedTopLevelWordsNoIndent:c,stringTypes:['""',"''","``","[]"],openParens:["("],closeParens:[")"],indexedPlaceholderTypes:["?"],namedPlaceholderTypes:[":"],lineCommentTypes:["--"],specialWordChars:["#","@"]})),new n.default(this.cfg,s).format(e)}}])&&a(t.prototype,r),e}();t.default=p,e.exports=t.default},9445:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.default=void 0;var n=i(r(9157)),o=i(r(3202));function i(e){return e&&e.__esModule?e:{default:e}}function a(e,t){for(var r=0;r<t.length;r++){var n=t[r];n.enumerable=n.enumerable||!1,n.configurable=!0,"value"in n&&(n.writable=!0),Object.defineProperty(e,n.key,n)}}var s,l=["ALL","ALTER","ANALYZE","AND","ANY","ARRAY","AS","ASC","BEGIN","BETWEEN","BINARY","BOOLEAN","BREAK","BUCKET","BUILD","BY","CALL","CASE","CAST","CLUSTER","COLLATE","COLLECTION","COMMIT","CONNECT","CONTINUE","CORRELATE","COVER","CREATE","DATABASE","DATASET","DATASTORE","DECLARE","DECREMENT","DELETE","DERIVED","DESC","DESCRIBE","DISTINCT","DO","DROP","EACH","ELEMENT","ELSE","END","EVERY","EXCEPT","EXCLUDE","EXECUTE","EXISTS","EXPLAIN","FALSE","FETCH","FIRST","FLATTEN","FOR","FORCE","FROM","FUNCTION","GRANT","GROUP","GSI","HAVING","IF","IGNORE","ILIKE","IN","INCLUDE","INCREMENT","INDEX","INFER","INLINE","INNER","INSERT","INTERSECT","INTO","IS","JOIN","KEY","KEYS","KEYSPACE","KNOWN","LAST","LEFT","LET","LETTING","LIKE","LIMIT","LSM","MAP","MAPPING","MATCHED","MATERIALIZED","MERGE","MISSING","NAMESPACE","NEST","NOT","NULL","NUMBER","OBJECT","OFFSET","ON","OPTION","OR","ORDER","OUTER","OVER","PARSE","PARTITION","PASSWORD","PATH","POOL","PREPARE","PRIMARY","PRIVATE","PRIVILEGE","PROCEDURE","PUBLIC","RAW","REALM","REDUCE","RENAME","RETURN","RETURNING","REVOKE","RIGHT","ROLE","ROLLBACK","SATISFIES","SCHEMA","SELECT","SELF","SEMI","SET","SHOW","SOME","START","STATISTICS","STRING","SYSTEM","THEN","TO","TRANSACTION","TRIGGER","TRUE","TRUNCATE","UNDER","UNION","UNIQUE","UNKNOWN","UNNEST","UNSET","UPDATE","UPSERT","USE","USER","USING","VALIDATE","VALUE","VALUED","VALUES","VIA","VIEW","WHEN","WHERE","WHILE","WITH","WITHIN","WORK","XOR"],u=["DELETE FROM","EXCEPT ALL","EXCEPT","EXPLAIN DELETE FROM","EXPLAIN UPDATE","EXPLAIN UPSERT","FROM","GROUP BY","HAVING","INFER","INSERT INTO","LET","LIMIT","MERGE","NEST","ORDER BY","PREPARE","SELECT","SET CURRENT SCHEMA","SET SCHEMA","SET","UNNEST","UPDATE","UPSERT","USE KEYS","VALUES","WHERE"],c=["INTERSECT","INTERSECT ALL","MINUS","UNION","UNION ALL"],d=["AND","INNER JOIN","JOIN","LEFT JOIN","LEFT OUTER JOIN","OR","OUTER JOIN","RIGHT JOIN","RIGHT OUTER JOIN","XOR"],p=function(){function e(t){!function(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}(this,e),this.cfg=t}var t,r;return t=e,(r=[{key:"format",value:function(e){return s||(s=new o.default({reservedWords:l,reservedTopLevelWords:u,reservedNewlineWords:d,reservedTopLevelWordsNoIndent:c,stringTypes:['""',"''","``"],openParens:["(","[","{"],closeParens:[")","]","}"],namedPlaceholderTypes:["$"],lineCommentTypes:["#","--"]})),new n.default(this.cfg,s).format(e)}}])&&a(t.prototype,r),e}();t.default=p,e.exports=t.default},7881:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.default=void 0;var n=a(r(9157)),o=a(r(3202)),i=a(r(1025));function a(e){return e&&e.__esModule?e:{default:e}}function s(e,t){for(var r=0;r<t.length;r++){var n=t[r];n.enumerable=n.enumerable||!1,n.configurable=!0,"value"in n&&(n.writable=!0),Object.defineProperty(e,n.key,n)}}var l,u=["A","ACCESSIBLE","AGENT","AGGREGATE","ALL","ALTER","ANY","ARRAY","AS","ASC","AT","ATTRIBUTE","AUTHID","AVG","BETWEEN","BFILE_BASE","BINARY_INTEGER","BINARY","BLOB_BASE","BLOCK","BODY","BOOLEAN","BOTH","BOUND","BREADTH","BULK","BY","BYTE","C","CALL","CALLING","CASCADE","CASE","CHAR_BASE","CHAR","CHARACTER","CHARSET","CHARSETFORM","CHARSETID","CHECK","CLOB_BASE","CLONE","CLOSE","CLUSTER","CLUSTERS","COALESCE","COLAUTH","COLLECT","COLUMNS","COMMENT","COMMIT","COMMITTED","COMPILED","COMPRESS","CONNECT","CONSTANT","CONSTRUCTOR","CONTEXT","CONTINUE","CONVERT","COUNT","CRASH","CREATE","CREDENTIAL","CURRENT","CURRVAL","CURSOR","CUSTOMDATUM","DANGLING","DATA","DATE_BASE","DATE","DAY","DECIMAL","DEFAULT","DEFINE","DELETE","DEPTH","DESC","DETERMINISTIC","DIRECTORY","DISTINCT","DO","DOUBLE","DROP","DURATION","ELEMENT","ELSIF","EMPTY","END","ESCAPE","EXCEPTIONS","EXCLUSIVE","EXECUTE","EXISTS","EXIT","EXTENDS","EXTERNAL","EXTRACT","FALSE","FETCH","FINAL","FIRST","FIXED","FLOAT","FOR","FORALL","FORCE","FROM","FUNCTION","GENERAL","GOTO","GRANT","GROUP","HASH","HEAP","HIDDEN","HOUR","IDENTIFIED","IF","IMMEDIATE","IN","INCLUDING","INDEX","INDEXES","INDICATOR","INDICES","INFINITE","INSTANTIABLE","INT","INTEGER","INTERFACE","INTERVAL","INTO","INVALIDATE","IS","ISOLATION","JAVA","LANGUAGE","LARGE","LEADING","LENGTH","LEVEL","LIBRARY","LIKE","LIKE2","LIKE4","LIKEC","LIMITED","LOCAL","LOCK","LONG","MAP","MAX","MAXLEN","MEMBER","MERGE","MIN","MINUTE","MLSLABEL","MOD","MODE","MONTH","MULTISET","NAME","NAN","NATIONAL","NATIVE","NATURAL","NATURALN","NCHAR","NEW","NEXTVAL","NOCOMPRESS","NOCOPY","NOT","NOWAIT","NULL","NULLIF","NUMBER_BASE","NUMBER","OBJECT","OCICOLL","OCIDATE","OCIDATETIME","OCIDURATION","OCIINTERVAL","OCILOBLOCATOR","OCINUMBER","OCIRAW","OCIREF","OCIREFCURSOR","OCIROWID","OCISTRING","OCITYPE","OF","OLD","ON","ONLY","OPAQUE","OPEN","OPERATOR","OPTION","ORACLE","ORADATA","ORDER","ORGANIZATION","ORLANY","ORLVARY","OTHERS","OUT","OVERLAPS","OVERRIDING","PACKAGE","PARALLEL_ENABLE","PARAMETER","PARAMETERS","PARENT","PARTITION","PASCAL","PCTFREE","PIPE","PIPELINED","PLS_INTEGER","PLUGGABLE","POSITIVE","POSITIVEN","PRAGMA","PRECISION","PRIOR","PRIVATE","PROCEDURE","PUBLIC","RAISE","RANGE","RAW","READ","REAL","RECORD","REF","REFERENCE","RELEASE","RELIES_ON","REM","REMAINDER","RENAME","RESOURCE","RESULT_CACHE","RESULT","RETURN","RETURNING","REVERSE","REVOKE","ROLLBACK","ROW","ROWID","ROWNUM","ROWTYPE","SAMPLE","SAVE","SAVEPOINT","SB1","SB2","SB4","SEARCH","SECOND","SEGMENT","SELF","SEPARATE","SEQUENCE","SERIALIZABLE","SHARE","SHORT","SIZE_T","SIZE","SMALLINT","SOME","SPACE","SPARSE","SQL","SQLCODE","SQLDATA","SQLERRM","SQLNAME","SQLSTATE","STANDARD","START","STATIC","STDDEV","STORED","STRING","STRUCT","STYLE","SUBMULTISET","SUBPARTITION","SUBSTITUTABLE","SUBTYPE","SUCCESSFUL","SUM","SYNONYM","SYSDATE","TABAUTH","TABLE","TDO","THE","THEN","TIME","TIMESTAMP","TIMEZONE_ABBR","TIMEZONE_HOUR","TIMEZONE_MINUTE","TIMEZONE_REGION","TO","TRAILING","TRANSACTION","TRANSACTIONAL","TRIGGER","TRUE","TRUSTED","TYPE","UB1","UB2","UB4","UID","UNDER","UNIQUE","UNPLUG","UNSIGNED","UNTRUSTED","USE","USER","USING","VALIDATE","VALIST","VALUE","VARCHAR","VARCHAR2","VARIABLE","VARIANCE","VARRAY","VARYING","VIEW","VIEWS","VOID","WHENEVER","WHILE","WITH","WORK","WRAPPED","WRITE","YEAR","ZONE"],c=["ADD","ALTER COLUMN","ALTER TABLE","BEGIN","CONNECT BY","DECLARE","DELETE FROM","DELETE","END","EXCEPT","EXCEPTION","FETCH FIRST","FROM","GROUP BY","HAVING","INSERT INTO","INSERT","LIMIT","LOOP","MODIFY","ORDER BY","SELECT","SET CURRENT SCHEMA","SET SCHEMA","SET","START WITH","UPDATE","VALUES","WHERE"],d=["INTERSECT","INTERSECT ALL","MINUS","UNION","UNION ALL"],p=["AND","CROSS APPLY","CROSS JOIN","ELSE","END","INNER JOIN","JOIN","LEFT JOIN","LEFT OUTER JOIN","OR","OUTER APPLY","OUTER JOIN","RIGHT JOIN","RIGHT OUTER JOIN","WHEN","XOR"],f=function(e,t){if(e.type===i.default.RESERVED_TOP_LEVEL&&"SET"===e.value&&"BY"===t.value)return e.type=i.default.RESERVED,e},h=function(){function e(t){!function(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}(this,e),this.cfg=t}var t,r;return t=e,(r=[{key:"format",value:function(e){return l||(l=new o.default({reservedWords:u,reservedTopLevelWords:c,reservedNewlineWords:p,reservedTopLevelWordsNoIndent:d,stringTypes:['""',"N''","''","``"],openParens:["(","CASE","BEGIN"],closeParens:[")","END"],indexedPlaceholderTypes:["?"],namedPlaceholderTypes:[":"],lineCommentTypes:["--"],specialWordChars:["_","$","#",".","@"]})),new n.default(this.cfg,l,f).format(e)}}])&&s(t.prototype,r),e}();t.default=h,e.exports=t.default},1432:(e,t,r)=>{"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.default=void 0;var n=i(r(9157)),o=i(r(3202));function i(e){return e&&e.__esModule?e:{default:e}}function a(e,t){for(var r=0;r<t.length;r++){var n=t[r];n.enumerable=n.enumerable||!1,n.configurable=!0,"value"in n&&(n.writable=!0),Object.defineProperty(e,n.key,n)}}var s,l=["ACCESSIBLE","ACTION","AGAINST","AGGREGATE","ALGORITHM","ALL","ALTER","ANALYSE","ANALYZE","AS","ASC","AUTOCOMMIT","AUTO_INCREMENT","BACKUP","BEGIN","BETWEEN","BINLOG","BOTH","CASCADE","CASE","CHANGE","CHANGED","CHARACTER SET","CHARSET","CHECK","CHECKSUM","COLLATE","COLLATION","COLUMN","COLUMNS","COMMENT","COMMIT","COMMITTED","COMPRESSED","CONCURRENT","CONSTRAINT","CONTAINS","CONVERT","CREATE","CROSS","CURRENT_TIMESTAMP","DATABASE","DATABASES","DAY","DAY_HOUR","DAY_MINUTE","DAY_SECOND","DEFAULT","DEFINER","DELAYED","DELETE","DESC","DESCRIBE","DETERMINISTIC","DISTINCT","DISTINCTROW","DIV","DO","DROP","DUMPFILE","DUPLICATE","DYNAMIC","ELSE","ENCLOSED","END","ENGINE","ENGINES","ENGINE_TYPE","ESCAPE","ESCAPED","EVENTS","EXEC","EXECUTE","EXISTS","EXPLAIN","EXTENDED","FAST","FETCH","FIELDS","FILE","FIRST","FIXED","FLUSH","FOR","FORCE","FOREIGN","FULL","FULLTEXT","FUNCTION","GLOBAL","GRANT","GRANTS","GROUP_CONCAT","HEAP","HIGH_PRIORITY","HOSTS","HOUR","HOUR_MINUTE","HOUR_SECOND","IDENTIFIED","IF","IFNULL","IGNORE","IN","INDEX","INDEXES","INFILE","INSERT","INSERT_ID","INSERT_METHOD","INTERVAL","INTO","INVOKER","IS","ISOLATION","KEY","KEYS","KILL","LAST_INSERT_ID","LEADING","LEVEL","LIKE","LINEAR","LINES","LOAD","LOCAL","LOCK","LOCKS","LOGS","LOW_PRIORITY","MARIA","MASTER","MASTER_CONNECT_RETRY","MASTER_HOST","MASTER_LOG_FILE","MATCH","MAX_CONNECTIONS_PER_HOUR","MAX_QUERIES_PER_HOUR","MAX_ROWS","MAX_UPDATES_PER_HOUR","MAX_USER_CONNECTIONS","MEDIUM","MERGE","MINUTE","MINUTE_SECOND","MIN_ROWS","MODE","MODIFY","MONTH","MRG_MYISAM","MYISAM","NAMES","NATURAL","NOT","NOW()","NULL","OFFSET","ON DELETE","ON UPDATE","ON","ONLY","OPEN","OPTIMIZE","OPTION","OPTIONALLY","OUTFILE","PACK_KEYS","PAGE","PARTIAL","PARTITION","PARTITIONS","PASSWORD","PRIMARY","PRIVILEGES","PROCEDURE","PROCESS","PROCESSLIST","PURGE","QUICK","RAID0","RAID_CHUNKS","RAID_CHUNKSIZE","RAID_TYPE","RANGE","READ","READ_ONLY","READ_WRITE","REFERENCES","REGEXP","RELOAD","RENAME","REPAIR","REPEATABLE","REPLACE","REPLICATION","RESET","RESTORE","RESTRICT","RETURN","RETURNS","REVOKE","RLIKE","ROLLBACK","ROW","ROWS","ROW_FORMAT","SECOND","SECURITY","SEPARATOR","SERIALIZABLE","SESSION","SHARE","SHOW","SHUTDOWN","SLAVE","SONAME","SOUNDS","SQL","SQL_AUTO_IS_NULL","SQL_BIG_RESULT","SQL_BIG_SELECTS","SQL_BIG_TABLES","SQL_BUFFER_RESULT","SQL_CACHE","SQL_CALC_FOUND_ROWS","SQL_LOG_BIN","SQL_LOG_OFF","SQL_LOG_UPDATE","SQL_LOW_PRIORITY_UPDATES","SQL_MAX_JOIN_SIZE","SQL_NO_CACHE","SQL_QUOTE_SHOW_CREATE","SQL_SAFE_UPDATES","SQL_SELECT_LIMIT","SQL_SLAVE_SKIP_COUNTER","SQL_SMALL_RESULT","SQL_WARNINGS","START","STARTING","STATUS","STOP","STORAGE","STRAIGHT_JOIN","STRING","STRIPED","SUPER","TABLE","TABLES","TEMPORARY","TERMINATED","THEN","TO","TRAILING","TRANSACTIONAL","TRUE","TRUNCATE","TYPE","TYPES","UNCOMMITTED","UNIQUE","UNLOCK","UNSIGNED","USAGE","USE","USING","VARIABLES","VIEW","WHEN","WITH","WORK","WRITE","YEAR_MONTH"],u=["ADD","AFTER","ALTER COLUMN","ALTER TABLE","DELETE FROM","EXCEPT","FETCH FIRST","FROM","GROUP BY","GO","HAVING","INSERT INTO","INSERT","LIMIT","MODIFY","ORDER BY","SELECT","SET CURRENT SCHEMA","SET SCHEMA","SET","UPDATE","VALUES","WHERE"],c=["INTERSECT","INTERSECT ALL","MINUS","UNION","UNION ALL"],d=["AND","CROSS APPLY","CROSS JOIN","ELSE","INNER JOIN","JOIN","LEFT JOIN","LEFT OUTER JOIN","OR","OUTER APPLY","OUTER JOIN","RIGHT JOIN","RIGHT OUTER JOIN","WHEN","XOR"],p=function(){function e(t){!function(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}(this,e),this.cfg=t}var t,r;return t=e,(r=[{key:"format",value:function(e){return s||(s=new o.default({reservedWords:l,reservedTopLevelWords:u,reservedNewlineWords:d,reservedTopLevelWordsNoIndent:c,stringTypes:['""',"N''","''","``","[]"],openParens:["(","CASE"],closeParens:[")","END"],indexedPlaceholderTypes:["?"],namedPlaceholderTypes:["@",":"],lineCommentTypes:["#","--"]})),new n.default(this.cfg,s).format(e)}}])&&a(t.prototype,r),e}();t.default=p,e.exports=t.default},7409:(e,t,r)=>{"use strict";t.Ay=void 0;var n=s(r(4377)),o=s(r(9445)),i=s(r(7881)),a=s(r(1432));function s(e){return e&&e.__esModule?e:{default:e}}var l={format:function(e){var t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:{};switch(t.language){case"db2":return new n.default(t).format(e);case"n1ql":return new o.default(t).format(e);case"pl/sql":return new i.default(t).format(e);case"sql":case void 0:return new a.default(t).format(e);default:throw Error("Unsupported SQL dialect: ".concat(t.language))}}};t.Ay=l},358:(e,t,r)=>{e.exports=r(3231)},3231:(e,t)=>{var r=t,n=/`/g,o=/\./g,i=/[\0\b\t\n\r\x1a\"\'\\]/g,a={"\0":"\\0","\b":"\\b","\t":"\\t","\n":"\\n","\r":"\\r","":"\\Z",'"':'\\"',"'":"\\'","\\":"\\\\"};function s(e){for(var t,r=i.lastIndex=0,n="";t=i.exec(e);)n+=e.slice(r,t.index)+a[t[0]],r=i.lastIndex;return 0===r?"'"+e+"'":r<e.length?"'"+n+e.slice(r)+"'":"'"+n+"'"}function l(e,t){for(e=e.toString();e.length<t;)e="0"+e;return e}r.escapeId=function(e,t){if(Array.isArray(e)){for(var i="",a=0;a<e.length;a++)i+=(0===a?"":", ")+r.escapeId(e[a],t);return i}return t?"`"+String(e).replace(n,"``")+"`":"`"+String(e).replace(n,"``").replace(o,"`.`")+"`"},r.escape=function(e,t,n){if(null==e)return"NULL";switch(typeof e){case"boolean":return e?"true":"false";case"number":return e+"";case"object":return"[object Date]"===Object.prototype.toString.call(e)?r.dateToString(e,n||"local"):Array.isArray(e)?r.arrayToList(e,n):Buffer.isBuffer(e)?r.bufferToString(e):"function"==typeof e.toSqlString?String(e.toSqlString()):t?s(e.toString()):r.objectToValues(e,n);default:return s(e)}},r.arrayToList=function(e,t){for(var n="",o=0;o<e.length;o++){var i=e[o];Array.isArray(i)?n+=(0===o?"":", ")+"("+r.arrayToList(i,t)+")":n+=(0===o?"":", ")+r.escape(i,!0,t)}return n},r.format=function(e,t,n,o){if(null==t)return e;Array.isArray(t)||(t=[t]);for(var i,a=0,s=/\?+/g,l="",u=0;u<t.length&&(i=s.exec(e));){var c=i[0].length;if(!(c>2)){var d=2===c?r.escapeId(t[u]):r.escape(t[u],n,o);l+=e.slice(a,i.index)+d,a=s.lastIndex,u++}}return 0===a?e:a<e.length?l+e.slice(a):l},r.dateToString=function(e,t){var r,n,o,i,a,u,c,d=new Date(e);if(isNaN(d.getTime()))return"NULL";if("local"===t)r=d.getFullYear(),n=d.getMonth()+1,o=d.getDate(),i=d.getHours(),a=d.getMinutes(),u=d.getSeconds(),c=d.getMilliseconds();else{var p=function(e){if("Z"===e)return 0;var t=e.match(/([\+\-\s])(\d\d):?(\d\d)?/);return!!t&&("-"===t[1]?-1:1)*(parseInt(t[2],10)+(t[3]?parseInt(t[3],10):0)/60)*60}(t);!1!==p&&0!==p&&d.setTime(d.getTime()+6e4*p),r=d.getUTCFullYear(),n=d.getUTCMonth()+1,o=d.getUTCDate(),i=d.getUTCHours(),a=d.getUTCMinutes(),u=d.getUTCSeconds(),c=d.getUTCMilliseconds()}return s(l(r,4)+"-"+l(n,2)+"-"+l(o,2)+" "+l(i,2)+":"+l(a,2)+":"+l(u,2)+"."+l(c,3))},r.bufferToString=function(e){return"X"+s(e.toString("hex"))},r.objectToValues=function(e,t){var n="";for(var o in e){var i=e[o];"function"!=typeof i&&(n+=(0===n.length?"":", ")+r.escapeId(o)+" = "+r.escape(i,!0,t))}return n},r.raw=function(e){if("string"!=typeof e)throw new TypeError("argument sql must be a string");return{toSqlString:function(){return e}}}},1882:e=>{e.exports=function(){var e=document.getSelection();if(!e.rangeCount)return function(){};for(var t=document.activeElement,r=[],n=0;n<e.rangeCount;n++)r.push(e.getRangeAt(n));switch(t.tagName.toUpperCase()){case"INPUT":case"TEXTAREA":t.blur();break;default:t=null}return e.removeAllRanges(),function(){"Caret"===e.type&&e.removeAllRanges(),e.rangeCount||r.forEach((function(t){e.addRange(t)})),t&&t.focus()}}},627:e=>{e.exports={area:!0,base:!0,br:!0,col:!0,embed:!0,hr:!0,img:!0,input:!0,link:!0,meta:!0,param:!0,source:!0,track:!0,wbr:!0}},6089:e=>{"use strict";e.exports=r},7781:t=>{"use strict";t.exports=e},8531:e=>{"use strict";e.exports=i},2007:e=>{"use strict";e.exports=n},3241:e=>{"use strict";e.exports=a},2468:e=>{"use strict";e.exports=s},5959:e=>{"use strict";e.exports=t},200:e=>{"use strict";e.exports=u},7694:e=>{"use strict";e.exports=l},1269:e=>{"use strict";e.exports=o},8911:(e,t,r)=>{var n=r(5992).default;function o(){"use strict";e.exports=o=function(){return r},e.exports.__esModule=!0,e.exports.default=e.exports;var t,r={},i=Object.prototype,a=i.hasOwnProperty,s=Object.defineProperty||function(e,t,r){e[t]=r.value},l="function"==typeof Symbol?Symbol:{},u=l.iterator||"@@iterator",c=l.asyncIterator||"@@asyncIterator",d=l.toStringTag||"@@toStringTag";function p(e,t,r){return Object.defineProperty(e,t,{value:r,enumerable:!0,configurable:!0,writable:!0}),e[t]}try{p({},"")}catch(t){p=function(e,t,r){return e[t]=r}}function f(e,t,r,n){var o=t&&t.prototype instanceof O?t:O,i=Object.create(o.prototype),a=new j(n||[]);return s(i,"_invoke",{value:I(e,r,a)}),i}function h(e,t,r){try{return{type:"normal",arg:e.call(t,r)}}catch(e){return{type:"throw",arg:e}}}r.wrap=f;var v="suspendedStart",g="suspendedYield",y="executing",m="completed",b={};function O(){}function E(){}function S(){}var T={};p(T,u,(function(){return this}));var _=Object.getPrototypeOf,w=_&&_(_(P([])));w&&w!==i&&a.call(w,u)&&(T=w);var R=S.prototype=O.prototype=Object.create(T);function A(e){["next","throw","return"].forEach((function(t){p(e,t,(function(e){return this._invoke(t,e)}))}))}function C(e,t){function r(o,i,s,l){var u=h(e[o],e,i);if("throw"!==u.type){var c=u.arg,d=c.value;return d&&"object"==n(d)&&a.call(d,"__await")?t.resolve(d.__await).then((function(e){r("next",e,s,l)}),(function(e){r("throw",e,s,l)})):t.resolve(d).then((function(e){c.value=e,s(c)}),(function(e){return r("throw",e,s,l)}))}l(u.arg)}var o;s(this,"_invoke",{value:function(e,n){function i(){return new t((function(t,o){r(e,n,t,o)}))}return o=o?o.then(i,i):i()}})}function I(e,r,n){var o=v;return function(i,a){if(o===y)throw Error("Generator is already running");if(o===m){if("throw"===i)throw a;return{value:t,done:!0}}for(n.method=i,n.arg=a;;){var s=n.delegate;if(s){var l=x(s,n);if(l){if(l===b)continue;return l}}if("next"===n.method)n.sent=n._sent=n.arg;else if("throw"===n.method){if(o===v)throw o=m,n.arg;n.dispatchException(n.arg)}else"return"===n.method&&n.abrupt("return",n.arg);o=y;var u=h(e,r,n);if("normal"===u.type){if(o=n.done?m:g,u.arg===b)continue;return{value:u.arg,done:n.done}}"throw"===u.type&&(o=m,n.method="throw",n.arg=u.arg)}}}function x(e,r){var n=r.method,o=e.iterator[n];if(o===t)return r.delegate=null,"throw"===n&&e.iterator.return&&(r.method="return",r.arg=t,x(e,r),"throw"===r.method)||"return"!==n&&(r.method="throw",r.arg=new TypeError("The iterator does not provide a '"+n+"' method")),b;var i=h(o,e.iterator,r.arg);if("throw"===i.type)return r.method="throw",r.arg=i.arg,r.delegate=null,b;var a=i.arg;return a?a.done?(r[e.resultName]=a.value,r.next=e.nextLoc,"return"!==r.method&&(r.method="next",r.arg=t),r.delegate=null,b):a:(r.method="throw",r.arg=new TypeError("iterator result is not an object"),r.delegate=null,b)}function L(e){var t={tryLoc:e[0]};1 in e&&(t.catchLoc=e[1]),2 in e&&(t.finallyLoc=e[2],t.afterLoc=e[3]),this.tryEntries.push(t)}function N(e){var t=e.completion||{};t.type="normal",delete t.arg,e.completion=t}function j(e){this.tryEntries=[{tryLoc:"root"}],e.forEach(L,this),this.reset(!0)}function P(e){if(e||""===e){var r=e[u];if(r)return r.call(e);if("function"==typeof e.next)return e;if(!isNaN(e.length)){var o=-1,i=function r(){for(;++o<e.length;)if(a.call(e,o))return r.value=e[o],r.done=!1,r;return r.value=t,r.done=!0,r};return i.next=i}}throw new TypeError(n(e)+" is not iterable")}return E.prototype=S,s(R,"constructor",{value:S,configurable:!0}),s(S,"constructor",{value:E,configurable:!0}),E.displayName=p(S,d,"GeneratorFunction"),r.isGeneratorFunction=function(e){var t="function"==typeof e&&e.constructor;return!!t&&(t===E||"GeneratorFunction"===(t.displayName||t.name))},r.mark=function(e){return Object.setPrototypeOf?Object.setPrototypeOf(e,S):(e.__proto__=S,p(e,d,"GeneratorFunction")),e.prototype=Object.create(R),e},r.awrap=function(e){return{__await:e}},A(C.prototype),p(C.prototype,c,(function(){return this})),r.AsyncIterator=C,r.async=function(e,t,n,o,i){void 0===i&&(i=Promise);var a=new C(f(e,t,n,o),i);return r.isGeneratorFunction(t)?a:a.next().then((function(e){return e.done?e.value:a.next()}))},A(R),p(R,d,"Generator"),p(R,u,(function(){return this})),p(R,"toString",(function(){return"[object Generator]"})),r.keys=function(e){var t=Object(e),r=[];for(var n in t)r.push(n);return r.reverse(),function e(){for(;r.length;){var n=r.pop();if(n in t)return e.value=n,e.done=!1,e}return e.done=!0,e}},r.values=P,j.prototype={constructor:j,reset:function(e){if(this.prev=0,this.next=0,this.sent=this._sent=t,this.done=!1,this.delegate=null,this.method="next",this.arg=t,this.tryEntries.forEach(N),!e)for(var r in this)"t"===r.charAt(0)&&a.call(this,r)&&!isNaN(+r.slice(1))&&(this[r]=t)},stop:function(){this.done=!0;var e=this.tryEntries[0].completion;if("throw"===e.type)throw e.arg;return this.rval},dispatchException:function(e){if(this.done)throw e;var r=this;function n(n,o){return s.type="throw",s.arg=e,r.next=n,o&&(r.method="next",r.arg=t),!!o}for(var o=this.tryEntries.length-1;o>=0;--o){var i=this.tryEntries[o],s=i.completion;if("root"===i.tryLoc)return n("end");if(i.tryLoc<=this.prev){var l=a.call(i,"catchLoc"),u=a.call(i,"finallyLoc");if(l&&u){if(this.prev<i.catchLoc)return n(i.catchLoc,!0);if(this.prev<i.finallyLoc)return n(i.finallyLoc)}else if(l){if(this.prev<i.catchLoc)return n(i.catchLoc,!0)}else{if(!u)throw Error("try statement without catch or finally");if(this.prev<i.finallyLoc)return n(i.finallyLoc)}}}},abrupt:function(e,t){for(var r=this.tryEntries.length-1;r>=0;--r){var n=this.tryEntries[r];if(n.tryLoc<=this.prev&&a.call(n,"finallyLoc")&&this.prev<n.finallyLoc){var o=n;break}}o&&("break"===e||"continue"===e)&&o.tryLoc<=t&&t<=o.finallyLoc&&(o=null);var i=o?o.completion:{};return i.type=e,i.arg=t,o?(this.method="next",this.next=o.finallyLoc,b):this.complete(i)},complete:function(e,t){if("throw"===e.type)throw e.arg;return"break"===e.type||"continue"===e.type?this.next=e.arg:"return"===e.type?(this.rval=this.arg=e.arg,this.method="return",this.next="end"):"normal"===e.type&&t&&(this.next=t),b},finish:function(e){for(var t=this.tryEntries.length-1;t>=0;--t){var r=this.tryEntries[t];if(r.finallyLoc===e)return this.complete(r.completion,r.afterLoc),N(r),b}},catch:function(e){for(var t=this.tryEntries.length-1;t>=0;--t){var r=this.tryEntries[t];if(r.tryLoc===e){var n=r.completion;if("throw"===n.type){var o=n.arg;N(r)}return o}}throw Error("illegal catch attempt")},delegateYield:function(e,r,n){return this.delegate={iterator:P(e),resultName:r,nextLoc:n},"next"===this.method&&(this.arg=t),b}},r}e.exports=o,e.exports.__esModule=!0,e.exports.default=e.exports},5992:e=>{function t(r){return e.exports=t="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(e){return typeof e}:function(e){return e&&"function"==typeof Symbol&&e.constructor===Symbol&&e!==Symbol.prototype?"symbol":typeof e},e.exports.__esModule=!0,e.exports.default=e.exports,t(r)}e.exports=t,e.exports.__esModule=!0,e.exports.default=e.exports},6834:(e,t,r)=>{var n=r(8911)();e.exports=n;try{regeneratorRuntime=n}catch(e){"object"==typeof globalThis?globalThis.regeneratorRuntime=n:Function("r","regeneratorRuntime = r")(n)}},2584:(e,t)=>{var r;!function(){"use strict";var n={}.hasOwnProperty;function o(){for(var e="",t=0;t<arguments.length;t++){var r=arguments[t];r&&(e=a(e,i(r)))}return e}function i(e){if("string"==typeof e||"number"==typeof e)return e;if("object"!=typeof e)return"";if(Array.isArray(e))return o.apply(null,e);if(e.toString!==Object.prototype.toString&&!e.toString.toString().includes("[native code]"))return e.toString();var t="";for(var r in e)n.call(e,r)&&e[r]&&(t=a(t,r));return t}function a(e,t){return t?e?e+" "+t:e+t:e}e.exports?(o.default=o,e.exports=o):void 0===(r=function(){return o}.apply(t,[]))||(e.exports=r)}()},4769:(e,t,r)=>{"use strict";r.r(t),r.d(t,{__addDisposableResource:()=>P,__assign:()=>i,__asyncDelegator:()=>w,__asyncGenerator:()=>_,__asyncValues:()=>R,__await:()=>T,__awaiter:()=>h,__classPrivateFieldGet:()=>L,__classPrivateFieldIn:()=>j,__classPrivateFieldSet:()=>N,__createBinding:()=>g,__decorate:()=>s,__disposeResources:()=>F,__esDecorate:()=>u,__exportStar:()=>y,__extends:()=>o,__generator:()=>v,__importDefault:()=>x,__importStar:()=>I,__makeTemplateObject:()=>A,__metadata:()=>f,__param:()=>l,__propKey:()=>d,__read:()=>b,__rest:()=>a,__runInitializers:()=>c,__setFunctionName:()=>p,__spread:()=>O,__spreadArray:()=>S,__spreadArrays:()=>E,__values:()=>m,default:()=>D});var n=function(e,t){return n=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(e,t){e.__proto__=t}||function(e,t){for(var r in t)Object.prototype.hasOwnProperty.call(t,r)&&(e[r]=t[r])},n(e,t)};function o(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Class extends value "+String(t)+" is not a constructor or null");function r(){this.constructor=e}n(e,t),e.prototype=null===t?Object.create(t):(r.prototype=t.prototype,new r)}var i=function(){return i=Object.assign||function(e){for(var t,r=1,n=arguments.length;r<n;r++)for(var o in t=arguments[r])Object.prototype.hasOwnProperty.call(t,o)&&(e[o]=t[o]);return e},i.apply(this,arguments)};function a(e,t){var r={};for(var n in e)Object.prototype.hasOwnProperty.call(e,n)&&t.indexOf(n)<0&&(r[n]=e[n]);if(null!=e&&"function"==typeof Object.getOwnPropertySymbols){var o=0;for(n=Object.getOwnPropertySymbols(e);o<n.length;o++)t.indexOf(n[o])<0&&Object.prototype.propertyIsEnumerable.call(e,n[o])&&(r[n[o]]=e[n[o]])}return r}function s(e,t,r,n){var o,i=arguments.length,a=i<3?t:null===n?n=Object.getOwnPropertyDescriptor(t,r):n;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)a=Reflect.decorate(e,t,r,n);else for(var s=e.length-1;s>=0;s--)(o=e[s])&&(a=(i<3?o(a):i>3?o(t,r,a):o(t,r))||a);return i>3&&a&&Object.defineProperty(t,r,a),a}function l(e,t){return function(r,n){t(r,n,e)}}function u(e,t,r,n,o,i){function a(e){if(void 0!==e&&"function"!=typeof e)throw new TypeError("Function expected");return e}for(var s,l=n.kind,u="getter"===l?"get":"setter"===l?"set":"value",c=!t&&e?n.static?e:e.prototype:null,d=t||(c?Object.getOwnPropertyDescriptor(c,n.name):{}),p=!1,f=r.length-1;f>=0;f--){var h={};for(var v in n)h[v]="access"===v?{}:n[v];for(var v in n.access)h.access[v]=n.access[v];h.addInitializer=function(e){if(p)throw new TypeError("Cannot add initializers after decoration has completed");i.push(a(e||null))};var g=(0,r[f])("accessor"===l?{get:d.get,set:d.set}:d[u],h);if("accessor"===l){if(void 0===g)continue;if(null===g||"object"!=typeof g)throw new TypeError("Object expected");(s=a(g.get))&&(d.get=s),(s=a(g.set))&&(d.set=s),(s=a(g.init))&&o.unshift(s)}else(s=a(g))&&("field"===l?o.unshift(s):d[u]=s)}c&&Object.defineProperty(c,n.name,d),p=!0}function c(e,t,r){for(var n=arguments.length>2,o=0;o<t.length;o++)r=n?t[o].call(e,r):t[o].call(e);return n?r:void 0}function d(e){return"symbol"==typeof e?e:"".concat(e)}function p(e,t,r){return"symbol"==typeof t&&(t=t.description?"[".concat(t.description,"]"):""),Object.defineProperty(e,"name",{configurable:!0,value:r?"".concat(r," ",t):t})}function f(e,t){if("object"==typeof Reflect&&"function"==typeof Reflect.metadata)return Reflect.metadata(e,t)}function h(e,t,r,n){return new(r||(r=Promise))((function(o,i){function a(e){try{l(n.next(e))}catch(e){i(e)}}function s(e){try{l(n.throw(e))}catch(e){i(e)}}function l(e){var t;e.done?o(e.value):(t=e.value,t instanceof r?t:new r((function(e){e(t)}))).then(a,s)}l((n=n.apply(e,t||[])).next())}))}function v(e,t){var r,n,o,i,a={label:0,sent:function(){if(1&o[0])throw o[1];return o[1]},trys:[],ops:[]};return i={next:s(0),throw:s(1),return:s(2)},"function"==typeof Symbol&&(i[Symbol.iterator]=function(){return this}),i;function s(s){return function(l){return function(s){if(r)throw new TypeError("Generator is already executing.");for(;i&&(i=0,s[0]&&(a=0)),a;)try{if(r=1,n&&(o=2&s[0]?n.return:s[0]?n.throw||((o=n.return)&&o.call(n),0):n.next)&&!(o=o.call(n,s[1])).done)return o;switch(n=0,o&&(s=[2&s[0],o.value]),s[0]){case 0:case 1:o=s;break;case 4:return a.label++,{value:s[1],done:!1};case 5:a.label++,n=s[1],s=[0];continue;case 7:s=a.ops.pop(),a.trys.pop();continue;default:if(!((o=(o=a.trys).length>0&&o[o.length-1])||6!==s[0]&&2!==s[0])){a=0;continue}if(3===s[0]&&(!o||s[1]>o[0]&&s[1]<o[3])){a.label=s[1];break}if(6===s[0]&&a.label<o[1]){a.label=o[1],o=s;break}if(o&&a.label<o[2]){a.label=o[2],a.ops.push(s);break}o[2]&&a.ops.pop(),a.trys.pop();continue}s=t.call(e,a)}catch(e){s=[6,e],n=0}finally{r=o=0}if(5&s[0])throw s[1];return{value:s[0]?s[1]:void 0,done:!0}}([s,l])}}}var g=Object.create?function(e,t,r,n){void 0===n&&(n=r);var o=Object.getOwnPropertyDescriptor(t,r);o&&!("get"in o?!t.__esModule:o.writable||o.configurable)||(o={enumerable:!0,get:function(){return t[r]}}),Object.defineProperty(e,n,o)}:function(e,t,r,n){void 0===n&&(n=r),e[n]=t[r]};function y(e,t){for(var r in e)"default"===r||Object.prototype.hasOwnProperty.call(t,r)||g(t,e,r)}function m(e){var t="function"==typeof Symbol&&Symbol.iterator,r=t&&e[t],n=0;if(r)return r.call(e);if(e&&"number"==typeof e.length)return{next:function(){return e&&n>=e.length&&(e=void 0),{value:e&&e[n++],done:!e}}};throw new TypeError(t?"Object is not iterable.":"Symbol.iterator is not defined.")}function b(e,t){var r="function"==typeof Symbol&&e[Symbol.iterator];if(!r)return e;var n,o,i=r.call(e),a=[];try{for(;(void 0===t||t-- >0)&&!(n=i.next()).done;)a.push(n.value)}catch(e){o={error:e}}finally{try{n&&!n.done&&(r=i.return)&&r.call(i)}finally{if(o)throw o.error}}return a}function O(){for(var e=[],t=0;t<arguments.length;t++)e=e.concat(b(arguments[t]));return e}function E(){for(var e=0,t=0,r=arguments.length;t<r;t++)e+=arguments[t].length;var n=Array(e),o=0;for(t=0;t<r;t++)for(var i=arguments[t],a=0,s=i.length;a<s;a++,o++)n[o]=i[a];return n}function S(e,t,r){if(r||2===arguments.length)for(var n,o=0,i=t.length;o<i;o++)!n&&o in t||(n||(n=Array.prototype.slice.call(t,0,o)),n[o]=t[o]);return e.concat(n||Array.prototype.slice.call(t))}function T(e){return this instanceof T?(this.v=e,this):new T(e)}function _(e,t,r){if(!Symbol.asyncIterator)throw new TypeError("Symbol.asyncIterator is not defined.");var n,o=r.apply(e,t||[]),i=[];return n={},a("next"),a("throw"),a("return",(function(e){return function(t){return Promise.resolve(t).then(e,u)}})),n[Symbol.asyncIterator]=function(){return this},n;function a(e,t){o[e]&&(n[e]=function(t){return new Promise((function(r,n){i.push([e,t,r,n])>1||s(e,t)}))},t&&(n[e]=t(n[e])))}function s(e,t){try{(r=o[e](t)).value instanceof T?Promise.resolve(r.value.v).then(l,u):c(i[0][2],r)}catch(e){c(i[0][3],e)}var r}function l(e){s("next",e)}function u(e){s("throw",e)}function c(e,t){e(t),i.shift(),i.length&&s(i[0][0],i[0][1])}}function w(e){var t,r;return t={},n("next"),n("throw",(function(e){throw e})),n("return"),t[Symbol.iterator]=function(){return this},t;function n(n,o){t[n]=e[n]?function(t){return(r=!r)?{value:T(e[n](t)),done:!1}:o?o(t):t}:o}}function R(e){if(!Symbol.asyncIterator)throw new TypeError("Symbol.asyncIterator is not defined.");var t,r=e[Symbol.asyncIterator];return r?r.call(e):(e=m(e),t={},n("next"),n("throw"),n("return"),t[Symbol.asyncIterator]=function(){return this},t);function n(r){t[r]=e[r]&&function(t){return new Promise((function(n,o){!function(e,t,r,n){Promise.resolve(n).then((function(t){e({value:t,done:r})}),t)}(n,o,(t=e[r](t)).done,t.value)}))}}}function A(e,t){return Object.defineProperty?Object.defineProperty(e,"raw",{value:t}):e.raw=t,e}var C=Object.create?function(e,t){Object.defineProperty(e,"default",{enumerable:!0,value:t})}:function(e,t){e.default=t};function I(e){if(e&&e.__esModule)return e;var t={};if(null!=e)for(var r in e)"default"!==r&&Object.prototype.hasOwnProperty.call(e,r)&&g(t,e,r);return C(t,e),t}function x(e){return e&&e.__esModule?e:{default:e}}function L(e,t,r,n){if("a"===r&&!n)throw new TypeError("Private accessor was defined without a getter");if("function"==typeof t?e!==t||!n:!t.has(e))throw new TypeError("Cannot read private member from an object whose class did not declare it");return"m"===r?n:"a"===r?n.call(e):n?n.value:t.get(e)}function N(e,t,r,n,o){if("m"===n)throw new TypeError("Private method is not writable");if("a"===n&&!o)throw new TypeError("Private accessor was defined without a setter");if("function"==typeof t?e!==t||!o:!t.has(e))throw new TypeError("Cannot write private member to an object whose class did not declare it");return"a"===n?o.call(e,r):o?o.value=r:t.set(e,r),r}function j(e,t){if(null===t||"object"!=typeof t&&"function"!=typeof t)throw new TypeError("Cannot use 'in' operator on non-object");return"function"==typeof e?t===e:e.has(t)}function P(e,t,r){if(null!=t){if("object"!=typeof t&&"function"!=typeof t)throw new TypeError("Object expected.");var n,o;if(r){if(!Symbol.asyncDispose)throw new TypeError("Symbol.asyncDispose is not defined.");n=t[Symbol.asyncDispose]}if(void 0===n){if(!Symbol.dispose)throw new TypeError("Symbol.dispose is not defined.");n=t[Symbol.dispose],r&&(o=n)}if("function"!=typeof n)throw new TypeError("Object not disposable.");o&&(n=function(){try{o.call(this)}catch(e){return Promise.reject(e)}}),e.stack.push({value:t,dispose:n,async:r})}else r&&e.stack.push({async:!0});return t}var k="function"==typeof SuppressedError?SuppressedError:function(e,t,r){var n=new Error(r);return n.name="SuppressedError",n.error=e,n.suppressed=t,n};function F(e){function t(t){e.error=e.hasError?new k(t,e.error,"An error was suppressed during disposal."):t,e.hasError=!0}return function r(){for(;e.stack.length;){var n=e.stack.pop();try{var o=n.dispose&&n.dispose.call(n.value);if(n.async)return Promise.resolve(o).then(r,(function(e){return t(e),r()}))}catch(e){t(e)}}if(e.hasError)throw e.error}()}const D={__extends:o,__assign:i,__rest:a,__decorate:s,__param:l,__metadata:f,__awaiter:h,__generator:v,__createBinding:g,__exportStar:y,__values:m,__read:b,__spread:O,__spreadArrays:E,__spreadArray:S,__await:T,__asyncGenerator:_,__asyncDelegator:w,__asyncValues:R,__makeTemplateObject:A,__importStar:I,__importDefault:x,__classPrivateFieldGet:L,__classPrivateFieldSet:N,__classPrivateFieldIn:j,__addDisposableResource:P,__disposeResources:F}}},d={};function p(e){var t=d[e];if(void 0!==t)return t.exports;var r=d[e]={id:e,loaded:!1,exports:{}};return c[e].call(r.exports,r,r.exports,p),r.loaded=!0,r.exports}p.n=e=>{var t=e&&e.__esModule?()=>e.default:()=>e;return p.d(t,{a:t}),t},p.d=(e,t)=>{for(var r in t)p.o(t,r)&&!p.o(e,r)&&Object.defineProperty(e,r,{enumerable:!0,get:t[r]})},p.g=function(){if("object"==typeof globalThis)return globalThis;try{return this||new Function("return this")()}catch(e){if("object"==typeof window)return window}}(),p.o=(e,t)=>Object.prototype.hasOwnProperty.call(e,t),p.r=e=>{"undefined"!=typeof Symbol&&Symbol.toStringTag&&Object.defineProperty(e,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(e,"__esModule",{value:!0})},p.nmd=e=>(e.paths=[],e.children||(e.children=[]),e);var f={};return(()=>{"use strict";p.r(f),p.d(f,{plugin:()=>HA});var e={};p.r(e),p.d(e,{applyToJS:()=>Ll,cleanJSX:()=>Pl,deepEqual:()=>Rl,deepFreeze:()=>Ul,escapeRegExp:()=>Nl,getFirstDefined:()=>Gl,getLogger:()=>ql,getOpCardinality:()=>wl,isDirtyJSX:()=>kl,isImmutable:()=>Cl,isImmutableList:()=>Il,isJSX:()=>Fl,isJsonCompatible:()=>Bl,isJsonLogic:()=>Dl,isObject:()=>Sl,logger:()=>Kl,mergeArraysSmart:()=>Vl,mergeCustomizerNoArrays:()=>jl,omit:()=>_l,opDefKeysToOmit:()=>El,shallowCopy:()=>Tl,shallowEqual:()=>Al,sleep:()=>Ml,toImmutableList:()=>xl,uuid:()=>ml,widgetDefKeysToOmit:()=>Ol});var t={};p.r(t),p.d(t,{getItemInListValues:()=>au,getListValue:()=>du,getTitleInListValues:()=>su,getValueInListValues:()=>lu,listValuesToArray:()=>iu,makeCustomListValue:()=>ou,mapListValues:()=>uu,searchListValue:()=>cu,toListValue:()=>nu});var r={};p.r(r),p.d(r,{_fixImmutableValue:()=>wu,expandTreePath:()=>pu,expandTreeSubpath:()=>fu,fixEmptyGroupsInTree:()=>yu,fixPathsInTree:()=>gu,getFlatTree:()=>mu,getItemByPath:()=>hu,getLightTree:()=>Eu,getSwitchValues:()=>Su,getTotalReordableNodesCountInTree:()=>bu,getTotalRulesCountInTree:()=>Ou,getTreeBadFields:()=>pf,hasChildren:()=>_u,immutableToJs:()=>Ll,isEmptyTree:()=>Tu,isImmutable:()=>Cl,jsToImmutable:()=>xu,removeIsLockedInTree:()=>vu,toImmutableList:()=>xl});var n={};p.r(n),p.d(n,{SqlString:()=>rc,mongoEmptyValue:()=>oc,spelEscape:()=>ac,spelFixList:()=>ic,spelFormatConcat:()=>sc,spelImportConcat:()=>lc,sqlEmptyValue:()=>nc,stringifyForDisplay:()=>uc,wrapWithBrackets:()=>cc});var o={};p.r(o),p.d(o,{_loadFromJsonLogic:()=>Uu,_loadFromSpel:()=>Vc,checkTree:()=>ff,getTree:()=>Ru,isImmutableTree:()=>Cu,isJsonLogic:()=>Dl,isTree:()=>Iu,isValidTree:()=>df,jsToImmutable:()=>xu,loadFromJsonLogic:()=>Vu,loadFromSpel:()=>Mc,loadTree:()=>Au});var i={};p.r(i),p.d(i,{createListFromArray:()=>Od,createListWithOneElement:()=>bd,defaultConjunction:()=>hd,defaultGroupConjunction:()=>fd,defaultGroupProperties:()=>vd,defaultItemProperties:()=>gd,defaultOperatorOptions:()=>dd,defaultRoot:()=>md,defaultRule:()=>yd,defaultRuleProperties:()=>pd,emptyProperties:()=>Ed,getDefaultField:()=>sd,getDefaultFieldSrc:()=>ud,getDefaultOperator:()=>cd,getDefaultSubField:()=>ld});var a={};p.r(a),p.d(a,{_validateTree:()=>yf,checkTree:()=>ff,getNewValueForFieldOp:()=>Af,getTreeBadFields:()=>pf,isValidTree:()=>df,sanitizeTree:()=>vf,translateValidation:()=>af,validateAndFixTree:()=>gf,validateRange:()=>Rf,validateTree:()=>hf,validateValue:()=>Sf});var s={};p.r(s),p.d(s,{completeFuncValue:()=>If,getCompatibleArgsOnFuncChange:()=>Ff,setArgValue:()=>Pf,setArgValueSrc:()=>kf,setFunc:()=>xf,setFuncDefaultArg:()=>Nf});var l={};p.r(l),p.d(l,{calculateValueType:()=>Bf,completeValue:()=>sh,filterValueSourcesForField:()=>Hf,formatFieldName:()=>Xf,getFieldPartsConfigs:()=>Kf,getFieldPathLabels:()=>Gf,getFirstOperator:()=>Uf,getFuncPathLabels:()=>qf,getOneChildOrDescendant:()=>lh,getOperatorsForField:()=>Vf,getOperatorsForType:()=>Mf,getValueLabel:()=>Wf,getValueSourcesForFieldOp:()=>Yf,getWidgetForFieldOp:()=>Qf,getWidgetsForFieldOp:()=>$f,isEmptyGroupChildren:()=>rh,isEmptyItem:()=>Jf,isEmptyRuleGroupExtPropertiesAndChildren:()=>eh,isEmptyRuleProperties:()=>oh,selectTypes:()=>Df,whatRulePropertiesAreCompleted:()=>ih});var u={};p.r(u),p.d(u,{_getFromConfigCache:()=>Rv,_saveToConfigCache:()=>Av,_widgetDefKeysToOmit:()=>pv,applyJsonLogic:()=>yh,cleanJSX:()=>Pl,compileConfig:()=>Fh,compressConfig:()=>Ph,configKeys:()=>_h,createConfigMemo:()=>Jh,decompressConfig:()=>kh,extendConfig:()=>nv,findExtendedConfigInAllMemos:()=>Xh,getCommonMemo:()=>Qh,getFieldConfig:()=>Iv,getFieldId:()=>wv,getFieldParts:()=>Tv,getFieldPath:()=>Sv,getFieldPathParts:()=>_v,getFieldRawConfig:()=>gv,getFieldSrc:()=>Cv,getFieldWidgetConfig:()=>Lv,getFirstField:()=>Nv,getFuncArgConfig:()=>Ov,getFuncConfig:()=>bv,getFuncSignature:()=>mv,getOperatorConfig:()=>xv,isDirtyJSX:()=>kl,isFieldDescendantOfField:()=>Ev,isJSX:()=>Fl,iterateFields:()=>hv,iterateFuncs:()=>fv,normalizeField:()=>yv});var c={};p.r(c),p.d(c,{_mongodbFormat:()=>ag,_spelFormat:()=>mc,_sqlFormat:()=>mg,elasticSearchFormat:()=>xg,jsonLogicFormat:()=>Gv,mongodbFormat:()=>ig,queryBuilderFormat:()=>kv,queryString:()=>Rd,spelFormat:()=>yc,sqlFormat:()=>yg});var d={};p.r(d),p.d(d,{fixListValuesGroupOrder:()=>qg,getListValue:()=>du,listValueToOption:()=>Bg,mergeListValues:()=>Mg,optionToListValue:()=>Vg,optionsToListValues:()=>Ug,simulateAsyncFetch:()=>Dg});var h={};p.r(h),p.d(h,{Autocomplete:()=>d,ConfigUtils:()=>u,DefaultUtils:()=>i,ExportUtils:()=>n,FuncUtils:()=>s,ListUtils:()=>t,OtherUtils:()=>e,RuleUtils:()=>l,TreeUtils:()=>r,Validation:()=>a,checkTree:()=>ff,clone:()=>ph(),compressConfig:()=>Ph,decompressConfig:()=>kh,getSwitchValues:()=>Su,i18n:()=>sf,isValidTree:()=>df,moment:()=>ju(),sanitizeTree:()=>vf,uuid:()=>ml,validateAndFixTree:()=>gf,validateTree:()=>hf});var v={};p.r(v),p.d(v,{LINEAR_REGRESSION:()=>$g,LOWER:()=>Wg,NOW:()=>Gg,RELATIVE_DATETIME:()=>Kg,UPPER:()=>zg});var g={};p.r(g),p.d(g,{addCaseGroup:()=>Zy,addDefaultCaseGroup:()=>Jy,addGroup:()=>em,addRule:()=>Qy,moveItem:()=>rm,removeGroup:()=>tm,removeRule:()=>Xy,setTree:()=>Yy});var y={};p.r(y),p.d(y,{setConjunction:()=>nm,setLock:()=>im,setNot:()=>om});var m={};p.r(m),p.d(m,{setField:()=>am,setFieldSrc:()=>sm,setFuncValue:()=>dm,setOperator:()=>lm,setOperatorOption:()=>pm,setValue:()=>um,setValueSrc:()=>cm});var b={};p.r(b),p.d(b,{bindActionCreators:()=>qm,isUsingLegacyReactDomRender:()=>Mm,liteShouldComponentUpdate:()=>Vm,pureShouldComponentUpdate:()=>Um,useOnPropsChanged:()=>Bm});var O={};p.r(O),p.d(O,{FuncWidget:()=>MO,ValueFieldWidget:()=>US,VanillaBooleanWidget:()=>BS,VanillaButton:()=>nT,VanillaButtonGroup:()=>iT,VanillaConjs:()=>tT,VanillaDateTimeWidget:()=>$S,VanillaDateWidget:()=>KS,VanillaFieldSelect:()=>eT,VanillaIcon:()=>oT,VanillaMultiSelectWidget:()=>YS,VanillaNumberWidget:()=>JS,VanillaProvider:()=>uT,VanillaSelectWidget:()=>XS,VanillaSliderWidget:()=>ZS,VanillaSwitch:()=>sT,VanillaTextAreaWidget:()=>GS,VanillaTextWidget:()=>qS,VanillaTimeWidget:()=>WS,VanillaValueSources:()=>aT,vanillaConfirm:()=>lT});var E={};p.r(E),p.d(E,{ProximityOperator:()=>pT});var S,T=p(7781),_=p(9728),w=p(6089),R=p(2007);function A(e){return{ulPadding:(0,w.css)({margin:e.spacing(1,0),paddingLeft:e.spacing(5)})}}!function(e){e.Timeseries="time_series",e.Table="table"}(S||(S={}));const C=[{label:"Time series",value:"time_series"},{label:"Table",value:"table"}],I=null!==T.toOption&&void 0!==T.toOption?T.toOption:e=>({label:e,value:e});var x=p(1269);function L(e){return"function"==typeof e}var N,j,P=p(4769),k=(N=function(e){return function(t){e(this),this.message=t?t.length+" errors occurred during unsubscription:\n"+t.map((function(e,t){return t+1+") "+e.toString()})).join("\n  "):"",this.name="UnsubscriptionError",this.errors=t}},j=N((function(e){Error.call(e),e.stack=(new Error).stack})),j.prototype=Object.create(Error.prototype),j.prototype.constructor=j,j);function F(e,t){if(e){var r=e.indexOf(t);0<=r&&e.splice(r,1)}}var D=function(){function e(e){this.initialTeardown=e,this.closed=!1,this._parentage=null,this._finalizers=null}var t;return e.prototype.unsubscribe=function(){var e,t,r,n,o;if(!this.closed){this.closed=!0;var i=this._parentage;if(i)if(this._parentage=null,Array.isArray(i))try{for(var a=(0,P.__values)(i),s=a.next();!s.done;s=a.next())s.value.remove(this)}catch(t){e={error:t}}finally{try{s&&!s.done&&(t=a.return)&&t.call(a)}finally{if(e)throw e.error}}else i.remove(this);var l=this.initialTeardown;if(L(l))try{l()}catch(e){o=e instanceof k?e.errors:[e]}var u=this._finalizers;if(u){this._finalizers=null;try{for(var c=(0,P.__values)(u),d=c.next();!d.done;d=c.next()){var p=d.value;try{M(p)}catch(e){o=null!=o?o:[],e instanceof k?o=(0,P.__spreadArray)((0,P.__spreadArray)([],(0,P.__read)(o)),(0,P.__read)(e.errors)):o.push(e)}}}catch(e){r={error:e}}finally{try{d&&!d.done&&(n=c.return)&&n.call(c)}finally{if(r)throw r.error}}}if(o)throw new k(o)}},e.prototype.add=function(t){var r;if(t&&t!==this)if(this.closed)M(t);else{if(t instanceof e){if(t.closed||t._hasParent(this))return;t._addParent(this)}(this._finalizers=null!==(r=this._finalizers)&&void 0!==r?r:[]).push(t)}},e.prototype._hasParent=function(e){var t=this._parentage;return t===e||Array.isArray(t)&&t.includes(e)},e.prototype._addParent=function(e){var t=this._parentage;this._parentage=Array.isArray(t)?(t.push(e),t):t?[t,e]:e},e.prototype._removeParent=function(e){var t=this._parentage;t===e?this._parentage=null:Array.isArray(t)&&F(t,e)},e.prototype.remove=function(t){var r=this._finalizers;r&&F(r,t),t instanceof e&&t._removeParent(this)},e.EMPTY=((t=new e).closed=!0,t),e}();function M(e){L(e)?e():e.unsubscribe()}D.EMPTY;var V=null,U=null,B=!1,q=!1,G={setTimeout:function(e,t){for(var r=[],n=2;n<arguments.length;n++)r[n-2]=arguments[n];var o=G.delegate;return(null==o?void 0:o.setTimeout)?o.setTimeout.apply(o,(0,P.__spreadArray)([e,t],(0,P.__read)(r))):setTimeout.apply(void 0,(0,P.__spreadArray)([e,t],(0,P.__read)(r)))},clearTimeout:function(e){var t=G.delegate;return((null==t?void 0:t.clearTimeout)||clearTimeout)(e)},delegate:void 0};function K(){}var W=z("C",void 0,void 0);function z(e,t,r){return{kind:e,value:t,error:r}}var $=function(e){function t(t){var r,n=e.call(this)||this;return n.isStopped=!1,t?(n.destination=t,((r=t)instanceof D||r&&"closed"in r&&L(r.remove)&&L(r.add)&&L(r.unsubscribe))&&t.add(n)):n.destination=ee,n}return(0,P.__extends)(t,e),t.create=function(e,t,r){return new X(e,t,r)},t.prototype.next=function(e){this.isStopped?Z(function(e){return z("N",e,void 0)}(e),this):this._next(e)},t.prototype.error=function(e){this.isStopped?Z(z("E",void 0,e),this):(this.isStopped=!0,this._error(e))},t.prototype.complete=function(){this.isStopped?Z(W,this):(this.isStopped=!0,this._complete())},t.prototype.unsubscribe=function(){this.closed||(this.isStopped=!0,e.prototype.unsubscribe.call(this),this.destination=null)},t.prototype._next=function(e){this.destination.next(e)},t.prototype._error=function(e){try{this.destination.error(e)}finally{this.unsubscribe()}},t.prototype._complete=function(){try{this.destination.complete()}finally{this.unsubscribe()}},t}(D),H=Function.prototype.bind;function Y(e,t){return H.call(e,t)}var Q=function(){function e(e){this.partialObserver=e}return e.prototype.next=function(e){var t=this.partialObserver;if(t.next)try{t.next(e)}catch(e){J(e)}},e.prototype.error=function(e){var t=this.partialObserver;if(t.error)try{t.error(e)}catch(e){J(e)}else J(e)},e.prototype.complete=function(){var e=this.partialObserver;if(e.complete)try{e.complete()}catch(e){J(e)}},e}(),X=function(e){function t(t,r,n){var o,i,a=e.call(this)||this;return L(t)||!t?o={next:null!=t?t:void 0,error:null!=r?r:void 0,complete:null!=n?n:void 0}:a&&q?((i=Object.create(t)).unsubscribe=function(){return a.unsubscribe()},o={next:t.next&&Y(t.next,i),error:t.error&&Y(t.error,i),complete:t.complete&&Y(t.complete,i)}):o=t,a.destination=new Q(o),a}return(0,P.__extends)(t,e),t}($);function J(e){B||function(e){G.setTimeout((function(){if(!V)throw e;V(e)}))}(e)}function Z(e,t){var r=U;r&&G.setTimeout((function(){return r(e,t)}))}var ee={closed:!0,next:K,error:function(e){throw e},complete:K},te=function(e){function t(t,r,n,o,i,a){var s=e.call(this,t)||this;return s.onFinalize=i,s.shouldUnsubscribe=a,s._next=r?function(e){try{r(e)}catch(e){t.error(e)}}:e.prototype._next,s._error=o?function(e){try{o(e)}catch(e){t.error(e)}finally{this.unsubscribe()}}:e.prototype._error,s._complete=n?function(){try{n()}catch(e){t.error(e)}finally{this.unsubscribe()}}:e.prototype._complete,s}return(0,P.__extends)(t,e),t.prototype.unsubscribe=function(){var t;if(!this.shouldUnsubscribe||this.shouldUnsubscribe()){var r=this.closed;e.prototype.unsubscribe.call(this),!r&&(null===(t=this.onFinalize)||void 0===t||t.call(this))}},t}($);function re(e,t){return r=function(r,n){var o=0;r.subscribe(new te(n,(function(r){n.next(e.call(t,r,o++))}),void 0,void 0,void 0))},function(e){if(function(e){return L(null==e?void 0:e.lift)}(e))return e.lift((function(e){try{return r(e,this)}catch(e){this.error(e)}}));throw new TypeError("Unable to lift unknown Observable type")};var r}var ne=(e=>(e[e.Comparison=0]="Comparison",e[e.Logical=1]="Logical",e))(ne||{}),oe=(e=>(e[e.Value=0]="Value",e[e.Filter=1]="Filter",e[e.Group=2]="Group",e[e.Column=3]="Column",e[e.Table=4]="Table",e))(oe||{}),ie=(e=>(e.Parenthesis="delimiter.parenthesis.sql",e.Whitespace="white.sql",e.Keyword="keyword.sql",e.Delimiter="delimiter.sql",e.Operator="operator.sql",e.Identifier="identifier.sql",e.IdentifierQuote="identifier.quote.sql",e.Type="type.sql",e.Function="predefined.sql",e.Number="number.sql",e.String="string.sql",e.Variable="variable.sql",e))(ie||{}),ae=(e=>(e.Unknown="unknown",e.SelectKeyword="selectKeyword",e.WithKeyword="withKeyword",e.AfterSelectKeyword="afterSelectKeyword",e.AfterSelectArguments="afterSelectArguments",e.AfterSelectFuncFirstArgument="afterSelectFuncFirstArgument",e.SelectAlias="selectAlias",e.AfterFromKeyword="afterFromKeyword",e.AfterTable="afterTable",e.SchemaFuncFirstArgument="schemaFuncFirstArgument",e.SchemaFuncExtraArgument="schemaFuncExtraArgument",e.FromKeyword="fromKeyword",e.AfterFrom="afterFrom",e.WhereKeyword="whereKeyword",e.WhereComparisonOperator="whereComparisonOperator",e.WhereValue="whereValue",e.AfterWhereFunctionArgument="afterWhereFunctionArgument",e.AfterGroupByFunctionArgument="afterGroupByFunctionArgument",e.AfterWhereValue="afterWhereValue",e.AfterGroupByKeywords="afterGroupByKeywords",e.AfterGroupBy="afterGroupBy",e.AfterOrderByKeywords="afterOrderByKeywords",e.AfterOrderByFunction="afterOrderByFunction",e.AfterOrderByDirection="afterOrderByDirection",e.AfterIsOperator="afterIsOperator",e.AfterIsNotOperator="afterIsNotOperator",e.AfterSchema="afterSchema",e))(ae||{}),se=(e=>(e.Schemas="schemas",e.Tables="tables",e.Columns="columns",e.SelectKeyword="selectKeyword",e.WithKeyword="withKeyword",e.FunctionsWithArguments="functionsWithArguments",e.FromKeyword="fromKeyword",e.WhereKeyword="whereKeyword",e.GroupByKeywords="groupByKeywords",e.OrderByKeywords="orderByKeywords",e.FunctionsWithoutArguments="functionsWithoutArguments",e.LimitKeyword="limitKeyword",e.SortOrderDirectionKeyword="sortOrderDirectionKeyword",e.ComparisonOperators="comparisonOperators",e.LogicalOperators="logicalOperators",e.SelectMacro="selectMacro",e.TableMacro="tableMacro",e.FilterMacro="filterMacro",e.GroupMacro="groupMacro",e.BoolValues="boolValues",e.NullValue="nullValue",e.NotKeyword="notKeyword",e.TemplateVariables="templateVariables",e.StarWildCard="starWildCard",e))(se||{}),le=(e=>(e.High="a",e.MediumHigh="d",e.Medium="g",e.MediumLow="k",e.Low="q",e))(le||{}),ue=(e=>(e[e.Method=0]="Method",e[e.Function=1]="Function",e[e.Constructor=2]="Constructor",e[e.Field=3]="Field",e[e.Variable=4]="Variable",e[e.Class=5]="Class",e[e.Struct=6]="Struct",e[e.Interface=7]="Interface",e[e.Module=8]="Module",e[e.Property=9]="Property",e[e.Event=10]="Event",e[e.Operator=11]="Operator",e[e.Unit=12]="Unit",e[e.Value=13]="Value",e[e.Constant=14]="Constant",e[e.Enum=15]="Enum",e[e.EnumMember=16]="EnumMember",e[e.Keyword=17]="Keyword",e[e.Text=18]="Text",e[e.Color=19]="Color",e[e.File=20]="File",e[e.Reference=21]="Reference",e[e.Customcolor=22]="Customcolor",e[e.Folder=23]="Folder",e[e.TypeParameter=24]="TypeParameter",e[e.User=25]="User",e[e.Issue=26]="Issue",e[e.Snippet=27]="Snippet",e))(ue||{}),ce=(e=>(e[e.KeepWhitespace=1]="KeepWhitespace",e[e.InsertAsSnippet=4]="InsertAsSnippet",e))(ce||{}),de=(e=>(e.Builder="builder",e.Code="code",e))(de||{}),pe=p(8531),fe=p(3241);class he{transformMetricFindResponse(e){const t=[],r=e.fields.find((e=>"__text"===e.name)),n=e.fields.find((e=>"__value"===e.name));if(r&&n)for(let e=0;e<r.values.length;e++)t.push({text:""+r.values[e],value:""+n.values[e]});else for(const r of e.fields)for(const e of r.values)t.push({text:e});return(0,fe.uniqBy)(t,"text")}}var ve,ge,ye=p(5959),me=p.n(ye);function be(){var e=(0,ye.useRef)(!1),t=(0,ye.useCallback)((function(){return e.current}),[]);return(0,ye.useEffect)((function(){return e.current=!0,function(){e.current=!1}}),[]),t}function Oe(e,t,r){void 0===t&&(t=[]),void 0===r&&(r={loading:!1});var n=(0,ye.useRef)(0),o=be(),i=(0,ye.useState)(r),a=i[0],s=i[1],l=(0,ye.useCallback)((function(){for(var t=[],r=0;r<arguments.length;r++)t[r]=arguments[r];var i=++n.current;return a.loading||s((function(e){return(0,P.__assign)((0,P.__assign)({},e),{loading:!0})})),e.apply(void 0,t).then((function(e){return o()&&i===n.current&&s({value:e,loading:!1}),e}),(function(e){return o()&&i===n.current&&s({error:e,loading:!1}),e}))}),t);return[a,l]}function Ee(e,t){void 0===t&&(t=[]);var r=Oe(e,t,{loading:!0}),n=r[0],o=r[1];return(0,ye.useEffect)((function(){o()}),[o]),n}!function(e){e.String="string"}(ve||(ve={})),function(e){e.Property="property",e.Operator="operator",e.Or="or",e.And="and",e.GroupBy="groupBy",e.Function="function",e.FunctionParameter="functionParameter"}(ge||(ge={}));const Se=e=>{if(!e)return!1;const t=e.some((e=>{var t,r;return(null===(t=e.parameters)||void 0===t?void 0:t.length)||(null===(r=e.parameters)||void 0===r?void 0:r.some((e=>e.name)))})),r=e.some((e=>e.name));return t||r};function Te(e){return{type:ge.GroupBy,property:{type:ve.String,name:e}}}function _e(e){return{type:ge.Function,name:e,parameters:[]}}function we(e,t,r){return t in e?Object.defineProperty(e,t,{value:r,enumerable:!0,configurable:!0,writable:!0}):e[t]=r,e}function Re(e){let t=(null==e?void 0:e.editorMode)||de.Builder;var r;void 0===(null==e?void 0:e.editorMode)&&void 0!==(null==e?void 0:e.rawSql)&&(t=de.Code);const n=(o=function(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{},n=Object.keys(r);"function"==typeof Object.getOwnPropertySymbols&&(n=n.concat(Object.getOwnPropertySymbols(r).filter((function(e){return Object.getOwnPropertyDescriptor(r,e).enumerable})))),n.forEach((function(t){we(e,t,r[t])}))}return e}({},e),i=null!=(i={refId:(null==e?void 0:e.refId)||"A",format:void 0!==(null==e?void 0:e.format)?e.format:S.Table,rawSql:(null==e?void 0:e.rawSql)||"",editorMode:t,sql:null!==(r=null==e?void 0:e.sql)&&void 0!==r?r:{columns:[_e()],groupBy:[Te()],limit:50}})?i:{},Object.getOwnPropertyDescriptors?Object.defineProperties(o,Object.getOwnPropertyDescriptors(i)):function(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);r.push.apply(r,n)}return r}(Object(i)).forEach((function(e){Object.defineProperty(o,e,Object.getOwnPropertyDescriptor(i,e))})),o);var o,i;return n}var Ae=p(4221),Ce=p.n(Ae);const Ie=function(){var e=be(),t=function(e){void 0===e&&(e={});var t=(0,ye.useState)(e),r=t[0],n=t[1];return[r,(0,ye.useCallback)((function(e){n((function(t){return Object.assign({},t,e instanceof Function?e(t):e)}))}),[])]}({value:void 0,error:void 0,noUserInteraction:!0}),r=t[0],n=t[1];return[r,(0,ye.useCallback)((function(t){var r,o;if(e())try{if("string"!=typeof t&&"number"!=typeof t){var i=new Error("Cannot copy typeof "+typeof t+" to clipboard, must be a string");return void n({value:t,error:i,noUserInteraction:!0})}if(""===t)return i=new Error("Cannot copy empty string to clipboard."),void n({value:t,error:i,noUserInteraction:!0});o=t.toString(),r=Ce()(o),n({value:o,error:void 0,noUserInteraction:r})}catch(i){n({value:o,error:i,noUserInteraction:r})}}),[])]},xe={RadioButton:{container:"data-testid radio-button"},Breadcrumbs:{breadcrumb:e=>`data-testid ${e} breadcrumb`},TimePicker:{openButton:"data-testid TimePicker Open Button",overlayContent:"data-testid TimePicker Overlay Content",fromField:"data-testid Time Range from field",toField:"data-testid Time Range to field",applyTimeRange:"data-testid TimePicker submit button",copyTimeRange:"data-testid TimePicker copy button",pasteTimeRange:"data-testid TimePicker paste button",calendar:{label:"data-testid Time Range calendar",openButton:"data-testid Open time range calendar",closeButton:"data-testid Close time range Calendar"},absoluteTimeRangeTitle:"data-testid-absolute-time-range-narrow"},DataSourcePermissions:{form:()=>'form[name="addPermission"]',roleType:"Role to add new permission to",rolePicker:"Built-in role picker",permissionLevel:"Permission Level"},DateTimePicker:{input:"data-testid date-time-input"},DataSource:{TestData:{QueryTab:{scenarioSelectContainer:"Test Data Query scenario select container",scenarioSelect:"Test Data Query scenario select",max:"TestData max",min:"TestData min",noise:"TestData noise",seriesCount:"TestData series count",spread:"TestData spread",startValue:"TestData start value",drop:"TestData drop values"}},DataSourceHttpSettings:{urlInput:"data-testid Datasource HTTP settings url"},Jaeger:{traceIDInput:"Trace ID"},Prometheus:{configPage:{connectionSettings:"Data source connection URL",manageAlerts:"prometheus-alerts-manager",scrapeInterval:"data-testid scrape interval",queryTimeout:"data-testid query timeout",defaultEditor:"data-testid default editor",disableMetricLookup:"disable-metric-lookup",prometheusType:"data-testid prometheus type",prometheusVersion:"data-testid prometheus version",cacheLevel:"data-testid cache level",incrementalQuerying:"prometheus-incremental-querying",queryOverlapWindow:"data-testid query overlap window",disableRecordingRules:"disable-recording-rules",customQueryParameters:"data-testid custom query parameters",httpMethod:"data-testid http method",exemplarsAddButton:"data-testid Add exemplar config button",internalLinkSwitch:"data-testid Internal link switch",codeModeMetricNamesSuggestionLimit:"data-testid code mode metric names suggestion limit"},queryEditor:{explain:"data-testid prometheus explain switch wrapper",editorToggle:"data-testid QueryEditorModeToggle",options:"data-testid prometheus options",legend:"data-testid prometheus legend wrapper",format:"data-testid prometheus format",step:"prometheus-step",type:"data-testid prometheus type",exemplars:"prometheus-exemplars",builder:{metricSelect:"data-testid metric select",hints:"data-testid prometheus hints",metricsExplorer:"data-testid metrics explorer",queryAdvisor:"data-testid query advisor"},code:{queryField:"data-testid prometheus query field",metricsCountInfo:"data-testid metrics count disclaimer",metricsBrowser:{openButton:"data-testid open metrics browser",selectMetric:"data-testid select a metric",metricList:"data-testid metric list",labelNamesFilter:"data-testid label names filter",labelValuesFilter:"data-testid label values filter",useQuery:"data-testid use query",useAsRateQuery:"data-testid use as rate query",validateSelector:"data-testid validate selector",clear:"data-testid clear"}}},exemplarMarker:"data-testid Exemplar marker",variableQueryEditor:{queryType:"data-testid query type",labelnames:{metricRegex:"data-testid label names metric regex"},labelValues:{labelSelect:"data-testid label values label select"},metricNames:{metricRegex:"data-testid metric names metric regex"},varQueryResult:"data-testid variable query result",seriesQuery:"data-testid prometheus series query",classicQuery:"data-testid prometheus classic query"},annotations:{minStep:"prometheus-annotation-min-step",title:"data-testid prometheus annotation title",tags:"data-testid prometheus annotation tags",text:"data-testid prometheus annotation text",seriesValueAsTimestamp:"data-testid prometheus annotation series value as timestamp"}}},Menu:{MenuComponent:e=>`${e} menu`,MenuGroup:e=>`${e} menu group`,MenuItem:e=>`${e} menu item`,SubMenu:{container:"data-testid SubMenu container",icon:"data-testid SubMenu icon"}},Panels:{Panel:{title:e=>`data-testid Panel header ${e}`,content:"data-testid panel content",headerItems:e=>`data-testid Panel header item ${e}`,menuItems:e=>`data-testid Panel menu item ${e}`,menu:e=>`data-testid Panel menu ${e}`,containerByTitle:e=>`${e} panel`,headerCornerInfo:e=>`Panel header ${e}`,status:e=>`data-testid Panel status ${e}`,loadingBar:()=>"Panel loading bar",HoverWidget:{container:"data-testid hover-header-container",dragIcon:"data-testid drag-icon"},PanelDataErrorMessage:"data-testid Panel data error message"},Visualization:{Graph:{container:"Graph container",VisualizationTab:{legendSection:"Legend section"},Legend:{legendItemAlias:e=>`gpl alias ${e}`,showLegendSwitch:"gpl show legend"},xAxis:{labels:()=>"div.flot-x-axis > div.flot-tick-label"}},BarGauge:{value:"Bar gauge value",valueV2:"data-testid Bar gauge value"},PieChart:{svgSlice:"data testid Pie Chart Slice"},Text:{container:()=>".markdown-html"},Table:{header:"table header",footer:"table-footer",body:"data-testid table body"}}},VizLegend:{seriesName:e=>`data-testid VizLegend series ${e}`},Drawer:{General:{title:e=>`Drawer title ${e}`,expand:"Drawer expand",contract:"Drawer contract",close:"data-testid Drawer close",rcContentWrapper:()=>".rc-drawer-content-wrapper",subtitle:"data-testid drawer subtitle"},DashboardSaveDrawer:{saveButton:"data-testid Save dashboard drawer button",saveAsButton:"data-testid Save as dashboard drawer button",saveAsTitleInput:"Save dashboard title field"}},PanelEditor:{General:{content:"data-testid Panel editor content"},OptionsPane:{content:"data-testid Panel editor option pane content",select:"Panel editor option pane select",fieldLabel:e=>`${e} field property editor`,fieldInput:e=>`data-testid Panel editor option pane field input ${e}`},DataPane:{content:"data-testid Panel editor data pane content"},applyButton:"data-testid Apply changes and go back to dashboard",toggleVizPicker:"data-testid toggle-viz-picker",toggleVizOptions:"data-testid toggle-viz-options",toggleTableView:"data-testid toggle-table-view",showZoomField:"Map controls Show zoom control field property editor",showAttributionField:"Map controls Show attribution field property editor",showScaleField:"Map controls Show scale field property editor",showMeasureField:"Map controls Show measure tools field property editor",showDebugField:"Map controls Show debug field property editor",measureButton:"show measure tools"},PanelInspector:{Data:{content:"Panel inspector Data content"},Stats:{content:"Panel inspector Stats content"},Json:{content:"data-testid Panel inspector Json content"},Query:{content:"Panel inspector Query content",refreshButton:"Panel inspector Query refresh button",jsonObjectKeys:()=>".json-formatter-key"}},Tab:{title:e=>`data-testid Tab ${e}`,active:()=>'[class*="-activeTabStyle"]'},RefreshPicker:{runButton:"RefreshPicker run button",intervalButton:"RefreshPicker interval button",runButtonV2:"data-testid RefreshPicker run button",intervalButtonV2:"data-testid RefreshPicker interval button"},QueryTab:{content:"Query editor tab content",queryInspectorButton:"Query inspector button",queryHistoryButton:"data-testid query-history-button",addQuery:"data-testid query-tab-add-query",queryGroupTopSection:"data-testid query group top section",addExpression:"data-testid query-tab-add-expression"},QueryHistory:{queryText:"Query text"},QueryEditorRows:{rows:"Query editor row"},QueryEditorRow:{actionButton:e=>`data-testid ${e}`,title:e=>`Query editor row title ${e}`,container:e=>`Query editor row ${e}`},AlertTab:{content:"data-testid Alert editor tab content"},AlertRules:{groupToggle:"data-testid group-collapse-toggle",toggle:"data-testid collapse-toggle",expandedContent:"data-testid expanded-content",previewButton:"data-testid alert-rule preview-button",ruleNameField:"data-testid alert-rule name-field",newFolderButton:"data-testid alert-rule new-folder-button",newFolderNameField:"data-testid alert-rule name-folder-name-field",newFolderNameCreateButton:"data-testid alert-rule name-folder-name-create-button",newEvaluationGroupButton:"data-testid alert-rule new-evaluation-group-button",newEvaluationGroupName:"data-testid alert-rule new-evaluation-group-name",newEvaluationGroupInterval:"data-testid alert-rule new-evaluation-group-interval",newEvaluationGroupCreate:"data-testid alert-rule new-evaluation-group-create-button"},Alert:{alert:e=>`Alert ${e}`,alertV2:e=>`data-testid Alert ${e}`},TransformTab:{content:"data-testid Transform editor tab content",newTransform:e=>`data-testid New transform ${e}`,transformationEditor:e=>`data-testid Transformation editor ${e}`,transformationEditorDebugger:e=>`data-testid Transformation editor debugger ${e}`},Transforms:{card:e=>`data-testid New transform ${e}`,disableTransformationButton:"data-testid Disable transformation button",Reduce:{modeLabel:"data-testid Transform mode label",calculationsLabel:"data-testid Transform calculations label"},SpatialOperations:{actionLabel:"root Action field property editor",locationLabel:"root Location Mode field property editor",location:{autoOption:"Auto location option",coords:{option:"Coords location option",latitudeFieldLabel:"root Latitude field field property editor",longitudeFieldLabel:"root Longitude field field property editor"},geohash:{option:"Geohash location option",geohashFieldLabel:"root Geohash field field property editor"},lookup:{option:"Lookup location option",lookupFieldLabel:"root Lookup field field property editor",gazetteerFieldLabel:"root Gazetteer field property editor"}}},searchInput:"data-testid search transformations",noTransformationsMessage:"data-testid no transformations message",addTransformationButton:"data-testid add transformation button",removeAllTransformationsButton:"data-testid remove all transformations button"},NavBar:{Configuration:{button:"Configuration"},Toggle:{button:"data-testid Toggle menu"},Reporting:{button:"Reporting"}},NavMenu:{Menu:"data-testid navigation mega-menu",item:"data-testid Nav menu item"},NavToolbar:{container:"data-testid Nav toolbar",shareDashboard:"data-testid Share dashboard",markAsFavorite:"data-testid Mark as favorite",editDashboard:{editButton:"data-testid Edit dashboard button",saveButton:"data-testid Save dashboard button",exitButton:"data-testid Exit edit mode button",settingsButton:"data-testid Dashboard settings",addRowButton:"data-testid Add row button",addLibraryPanelButton:"data-testid Add a panel from the panel library button",addVisualizationButton:"data-testid Add new visualization menu item",pastePanelButton:"data-testid Paste panel button",discardChangesButton:"data-testid Discard changes button",discardLibraryPanelButton:"data-testid Discard library panel button",unlinkLibraryPanelButton:"data-testid Unlink library panel button",saveLibraryPanelButton:"data-testid Save library panel button",backToDashboardButton:"data-testid Back to dashboard button"}},PageToolbar:{container:()=>".page-toolbar",item:e=>`${e}`,itemButton:e=>`data-testid ${e}`},QueryEditorToolbarItem:{button:e=>`QueryEditor toolbar item button ${e}`},BackButton:{backArrow:"data-testid Go Back"},OptionsGroup:{group:e=>e?`data-testid Options group ${e}`:"data-testid Options group",toggle:e=>e?`data-testid Options group ${e} toggle`:"data-testid Options group toggle"},PluginVisualization:{item:e=>`Plugin visualization item ${e}`,current:()=>'[class*="-currentVisualizationItem"]'},Select:{option:"data-testid Select option",input:()=>'input[id*="time-options-input"]',singleValue:()=>'div[class*="-singleValue"]'},FieldConfigEditor:{content:"Field config editor content"},OverridesConfigEditor:{content:"Field overrides editor content"},FolderPicker:{container:"Folder picker select container",containerV2:"data-testid Folder picker select container",input:"data-testid folder-picker-input"},ReadonlyFolderPicker:{container:"data-testid Readonly folder picker select container"},DataSourcePicker:{container:"data-testid Data source picker select container",input:()=>'input[id="data-source-picker"]',inputV2:"data-testid Select a data source",dataSourceList:"data-testid Data source list dropdown",advancedModal:{dataSourceList:"data-testid Data source list",builtInDataSourceList:"data-testid Built in data source list"}},TimeZonePicker:{container:"Time zone picker select container",containerV2:"data-testid Time zone picker select container",changeTimeSettingsButton:"data-testid Time zone picker Change time settings button"},WeekStartPicker:{container:"Choose starting day of the week",containerV2:"data-testid Choose starting day of the week",placeholder:"Choose starting day of the week"},TraceViewer:{spanBar:"data-testid SpanBar--wrapper"},QueryField:{container:"data-testid Query field"},QueryBuilder:{queryPatterns:"data-testid Query patterns",labelSelect:"data-testid Select label",inputSelect:"data-testid Select label-input",valueSelect:"data-testid Select value",matchOperatorSelect:"data-testid Select match operator"},ValuePicker:{button:e=>`data-testid Value picker button ${e}`,select:e=>`data-testid Value picker select ${e}`},Search:{section:"Search section",sectionV2:"data-testid Search section",items:"Search items",itemsV2:"data-testid Search items",cards:"data-testid Search cards",collapseFolder:e=>`data-testid Collapse folder ${e}`,expandFolder:e=>`data-testid Expand folder ${e}`,dashboardItem:e=>`${xe.Search.dashboardItems} ${e}`,dashboardCard:e=>`data-testid Search card ${e}`,folderHeader:e=>`data-testid Folder header ${e}`,folderContent:e=>`data-testid Folder content ${e}`,dashboardItems:"data-testid Dashboard search item"},DashboardLinks:{container:"data-testid Dashboard link container",dropDown:"data-testid Dashboard link dropdown",link:"data-testid Dashboard link"},LoadingIndicator:{icon:"data-testid Loading indicator"},CallToActionCard:{button:e=>`Call to action button ${e}`,buttonV2:e=>`data-testid Call to action button ${e}`},DataLinksContextMenu:{singleLink:"data-testid Data link"},CodeEditor:{container:"data-testid Code editor container"},ReactMonacoEditor:{editorLazy:"data-testid ReactMonacoEditor editorLazy"},DashboardImportPage:{textarea:"data-testid-import-dashboard-textarea",submit:"data-testid-load-dashboard"},ImportDashboardForm:{name:"data-testid-import-dashboard-title",submit:"data-testid-import-dashboard-submit"},PanelAlertTabContent:{content:"data-testid Unified alert editor tab content"},VisualizationPreview:{card:e=>`data-testid suggestion-${e}`},ColorSwatch:{name:"data-testid-colorswatch"},DashboardRow:{title:e=>`data-testid dashboard-row-title-${e}`},UserProfile:{profileSaveButton:"data-testid-user-profile-save",preferencesSaveButton:"data-testid-shared-prefs-save",orgsTable:"data-testid-user-orgs-table",sessionsTable:"data-testid-user-sessions-table",extensionPointTabs:"data-testid-extension-point-tabs",extensionPointTab:e=>`data-testid-extension-point-tab-${e}`},FileUpload:{inputField:"data-testid-file-upload-input-field",fileNameSpan:"data-testid-file-upload-file-name"},DebugOverlay:{wrapper:"debug-overlay"},OrgRolePicker:{input:"Role"},AnalyticsToolbarButton:{button:"Dashboard insights"},Variables:{variableOption:"data-testid variable-option",variableLinkWrapper:"data-testid variable-link-wrapper"},Annotations:{annotationsTypeInput:"data-testid annotations-type-input",annotationsChoosePanelInput:"data-testid choose-panels-input",editor:{testButton:"data-testid annotations-test-button",resultContainer:"data-testid annotations-query-result-container"}},Tooltip:{container:"data-testid tooltip"},ReturnToPrevious:{buttonGroup:"data-testid dismissable button group",backButton:"data-testid back",dismissButton:"data-testid dismiss"},SQLQueryEditor:{selectColumn:"data-testid select-column",selectAggregation:"data-testid select-aggregation",selectAlias:"data-testid select-alias",filterConjunction:"data-testid filter-conjunction",filterField:"data-testid filter-field",filterOperator:"data-testid filter-operator",headerTableSelector:"data-testid header-table-selector",headerFilterSwitch:"data-testid header-filter-switch",headerGroupSwitch:"data-testid header-group-switch",headerOrderSwitch:"data-testid header-order-switch",headerPreviewSwitch:"data-testid header-preview-switch"},EntityNotFound:{container:"data-testid entity-not-found"}},Le={pages:{Login:{url:"/login",username:"data-testid Username input field",password:"data-testid Password input field",submit:"data-testid Login button",skip:"data-testid Skip change password button"},Home:{url:"/"},DataSource:{name:"data-testid Data source settings page name input field",delete:"Data source settings page Delete button",readOnly:"data-testid Data source settings page read only message",saveAndTest:"data-testid Data source settings page Save and Test button",alert:"data-testid Data source settings page Alert"},DataSources:{url:"/datasources",dataSources:e=>`Data source list item ${e}`},EditDataSource:{url:e=>`/datasources/edit/${e}`,settings:"Datasource settings page basic settings"},AddDataSource:{url:"/datasources/new",dataSourcePlugins:e=>`Data source plugin item ${e}`,dataSourcePluginsV2:e=>`Add new data source ${e}`},ConfirmModal:{delete:"data-testid Confirm Modal Danger Button"},AddDashboard:{url:"/dashboard/new",itemButton:e=>`data-testid ${e}`,addNewPanel:"data-testid Add new panel",addNewRow:"data-testid Add new row",addNewPanelLibrary:"data-testid Add new panel from panel library"},Dashboard:{url:e=>`/d/${e}`,DashNav:{nav:"Dashboard navigation",navV2:"data-testid Dashboard navigation",publicDashboardTag:"data-testid public dashboard tag",shareButton:"data-testid share-button",scrollContainer:"data-testid Dashboard canvas scroll container",newShareButton:{container:"data-testid new share button",shareLink:"data-testid new share link-button",arrowMenu:"data-testid new share button arrow menu",menu:{container:"data-testid new share button menu",shareInternally:"data-testid new share button share internally",shareExternally:"data-testid new share button share externally",shareSnapshot:"data-testid new share button share snapshot"}},NewExportButton:{container:"data-testid new export button",arrowMenu:"data-testid new export button arrow menu",Menu:{container:"data-testid new export button menu",exportAsJson:"data-testid new export button export as json"}},playlistControls:{prev:"data-testid playlist previous dashboard button",stop:"data-testid playlist stop dashboard button",next:"data-testid playlist next dashboard button"}},Controls:"data-testid dashboard controls",SubMenu:{submenu:"Dashboard submenu",submenuItem:"data-testid template variable",submenuItemLabels:e=>`data-testid Dashboard template variables submenu Label ${e}`,submenuItemValueDropDownValueLinkTexts:e=>`data-testid Dashboard template variables Variable Value DropDown value link text ${e}`,submenuItemValueDropDownDropDown:"Variable options",submenuItemValueDropDownOptionTexts:e=>`data-testid Dashboard template variables Variable Value DropDown option text ${e}`,Annotations:{annotationsWrapper:"data-testid annotation-wrapper",annotationLabel:e=>`data-testid Dashboard annotations submenu Label ${e}`,annotationToggle:e=>`data-testid Dashboard annotations submenu Toggle ${e}`}},Settings:{Actions:{close:"data-testid dashboard-settings-close"},General:{deleteDashBoard:"data-testid Dashboard settings page delete dashboard button",sectionItems:e=>`Dashboard settings section item ${e}`,saveDashBoard:"Dashboard settings aside actions Save button",saveAsDashBoard:"Dashboard settings aside actions Save As button",timezone:"Time zone picker select container",title:"General"},Annotations:{List:{addAnnotationCTA:xe.CallToActionCard.button("Add annotation query"),addAnnotationCTAV2:xe.CallToActionCard.buttonV2("Add annotation query"),annotations:"data-testid list-annotations"},Settings:{name:"data-testid Annotations settings name input"},NewAnnotation:{panelFilterSelect:"data-testid annotations-panel-filter",showInLabel:"data-testid show-in-label",previewInDashboard:"data-testid annotations-preview",delete:"data-testid annotations-delete",apply:"data-testid annotations-apply",enable:"data-testid annotation-enable",hide:"data-testid annotation-hide"}},Variables:{List:{addVariableCTA:xe.CallToActionCard.button("Add variable"),addVariableCTAV2:xe.CallToActionCard.buttonV2("Add variable"),newButton:"Variable editor New variable button",table:"Variable editor Table",tableRowNameFields:e=>`Variable editor Table Name field ${e}`,tableRowDefinitionFields:e=>`Variable editor Table Definition field ${e}`,tableRowArrowUpButtons:e=>`Variable editor Table ArrowUp button ${e}`,tableRowArrowDownButtons:e=>`Variable editor Table ArrowDown button ${e}`,tableRowDuplicateButtons:e=>`Variable editor Table Duplicate button ${e}`,tableRowRemoveButtons:e=>`Variable editor Table Remove button ${e}`},Edit:{General:{headerLink:"Variable editor Header link",modeLabelNew:"Variable editor Header mode New",modeLabelEdit:"Variable editor Header mode Edit",generalNameInput:"Variable editor Form Name field",generalNameInputV2:"data-testid Variable editor Form Name field",generalTypeSelect:"Variable editor Form Type select",generalTypeSelectV2:"data-testid Variable editor Form Type select",generalLabelInput:"Variable editor Form Label field",generalLabelInputV2:"data-testid Variable editor Form Label field",generalHideSelect:"Variable editor Form Hide select",generalHideSelectV2:"data-testid Variable editor Form Hide select",selectionOptionsMultiSwitch:"data-testid Variable editor Form Multi switch",selectionOptionsIncludeAllSwitch:"data-testid Variable editor Form IncludeAll switch",selectionOptionsCustomAllInput:"data-testid Variable editor Form IncludeAll field",previewOfValuesOption:"data-testid Variable editor Preview of Values option",submitButton:"data-testid Variable editor Run Query button",applyButton:"data-testid Variable editor Apply button"},QueryVariable:{queryOptionsDataSourceSelect:xe.DataSourcePicker.inputV2,queryOptionsRefreshSelect:"Variable editor Form Query Refresh select",queryOptionsRefreshSelectV2:"data-testid Variable editor Form Query Refresh select",queryOptionsRegExInput:"Variable editor Form Query RegEx field",queryOptionsRegExInputV2:"data-testid Variable editor Form Query RegEx field",queryOptionsSortSelect:"Variable editor Form Query Sort select",queryOptionsSortSelectV2:"data-testid Variable editor Form Query Sort select",queryOptionsQueryInput:"data-testid Variable editor Form Default Variable Query Editor textarea",valueGroupsTagsEnabledSwitch:"Variable editor Form Query UseTags switch",valueGroupsTagsTagsQueryInput:"Variable editor Form Query TagsQuery field",valueGroupsTagsTagsValuesQueryInput:"Variable editor Form Query TagsValuesQuery field"},ConstantVariable:{constantOptionsQueryInput:"Variable editor Form Constant Query field",constantOptionsQueryInputV2:"data-testid Variable editor Form Constant Query field"},DatasourceVariable:{datasourceSelect:"data-testid datasource variable datasource type"},TextBoxVariable:{textBoxOptionsQueryInput:"Variable editor Form TextBox Query field",textBoxOptionsQueryInputV2:"data-testid Variable editor Form TextBox Query field"},CustomVariable:{customValueInput:"data-testid custom-variable-input"},IntervalVariable:{intervalsValueInput:"data-testid interval variable intervals input",autoEnabledCheckbox:"data-testid interval variable auto value checkbox",stepCountIntervalSelect:"data-testid interval variable step count input",minIntervalInput:"data-testid interval variable mininum interval input"},GroupByVariable:{dataSourceSelect:xe.DataSourcePicker.inputV2,infoText:"data-testid group by variable info text",modeToggle:"data-testid group by variable mode toggle"},AdHocFiltersVariable:{datasourceSelect:xe.DataSourcePicker.inputV2,infoText:"data-testid ad-hoc filters variable info text",modeToggle:"data-testid ad-hoc filters variable mode toggle"}}}},Annotations:{marker:"data-testid annotation-marker"},Rows:{Repeated:{ConfigSection:{warningMessage:"data-testid Repeated rows warning message"}}}},Dashboards:{url:"/dashboards",dashboards:e=>`Dashboard search item ${e}`},SaveDashboardAsModal:{newName:"Save dashboard title field",save:"Save dashboard button"},SaveDashboardModal:{save:"Dashboard settings Save Dashboard Modal Save button",saveVariables:"Dashboard settings Save Dashboard Modal Save variables checkbox",saveTimerange:"Dashboard settings Save Dashboard Modal Save timerange checkbox",saveRefresh:"Dashboard settings Save Dashboard Modal Save refresh checkbox"},SharePanelModal:{linkToRenderedImage:"Link to rendered image"},ShareDashboardModal:{PublicDashboard:{WillBePublicCheckbox:"data-testid public dashboard will be public checkbox",LimitedDSCheckbox:"data-testid public dashboard limited datasources checkbox",CostIncreaseCheckbox:"data-testid public dashboard cost may increase checkbox",PauseSwitch:"data-testid public dashboard pause switch",EnableAnnotationsSwitch:"data-testid public dashboard on off switch for annotations",CreateButton:"data-testid public dashboard create button",DeleteButton:"data-testid public dashboard delete button",CopyUrlInput:"data-testid public dashboard copy url input",CopyUrlButton:"data-testid public dashboard copy url button",SettingsDropdown:"data-testid public dashboard settings dropdown",TemplateVariablesWarningAlert:"data-testid public dashboard disabled template variables alert",UnsupportedDataSourcesWarningAlert:"data-testid public dashboard unsupported data sources alert",NoUpsertPermissionsWarningAlert:"data-testid public dashboard no upsert permissions alert",EnableTimeRangeSwitch:"data-testid public dashboard on off switch for time range",EmailSharingConfiguration:{Container:"data-testid email sharing config container",ShareType:"data-testid public dashboard share type",EmailSharingInput:"data-testid public dashboard email sharing input",EmailSharingInviteButton:"data-testid public dashboard email sharing invite button",EmailSharingList:"data-testid public dashboard email sharing list",DeleteEmail:"data-testid public dashboard delete email button",ReshareLink:"data-testid public dashboard reshare link button"}},SnapshotScene:{url:e=>`/dashboard/snapshot/${e}`,PublishSnapshot:"data-testid publish snapshot button",CopyUrlButton:"data-testid snapshot copy url button",CopyUrlInput:"data-testid snapshot copy url input"}},ShareDashboardDrawer:{ShareExternally:{container:"data-testid share externally drawer container",copyUrlButton:"data-testid share externally copy url button",shareTypeSelect:"data-testid share externally share type select"},ShareSnapshot:{container:"data-testid share snapshot drawer container"}},ExportDashboardDrawer:{ExportAsJson:{container:"data-testid export as Json drawer container",codeEditor:"data-testid export as Json code editor",exportExternallyToggle:"data-testid export externally toggle type select",saveToFileButton:"data-testid save to file button",copyToClipboardButton:"data-testid copy to clipboard button",cancelButton:"data-testid cancel button"}},PublicDashboard:{page:"public-dashboard-page",NotAvailable:{container:"public-dashboard-not-available",title:"public-dashboard-title",pausedDescription:"public-dashboard-paused-description"},footer:"public-dashboard-footer"},PublicDashboardScene:{loadingPage:"public-dashboard-scene-loading-page",page:"public-dashboard-scene-page",controls:"public-dashboard-controls"},RequestViewAccess:{form:"request-view-access-form",recipientInput:"request-view-access-recipient-input",submitButton:"request-view-access-submit-button"},PublicDashboardConfirmAccess:{submitButton:"data-testid confirm-access-submit-button"},Explore:{url:"/explore",General:{container:"data-testid Explore",graph:"Explore Graph",table:"Explore Table",scrollView:"data-testid explorer scroll view"},QueryHistory:{container:"data-testid QueryHistory"}},SoloPanel:{url:e=>`/d-solo/${e}`},PluginsList:{page:"Plugins list page",list:"Plugins list",listItem:"Plugins list item",signatureErrorNotice:"data-testid Unsigned plugins notice"},PluginPage:{page:"Plugin page",signatureInfo:"data-testid Plugin signature info",disabledInfo:"data-testid Plugin disabled info"},PlaylistForm:{name:"Playlist name",interval:"Playlist interval",itemDelete:"data-testid playlist-form-delete-item"},BrowseDashboards:{table:{body:"data-testid browse-dashboards-table",row:e=>`data-testid browse dashboards row ${e}`,checkbox:e=>`data-testid ${e} checkbox`},NewFolderForm:{form:"data-testid new folder form",nameInput:"data-testid new-folder-name-input",createButton:"data-testid new-folder-create-button"}},Search:{url:"/?search=openn",FolderView:{url:"/?search=open&layout=folders"}},PublicDashboards:{ListItem:{linkButton:"public-dashboard-link-button",configButton:"public-dashboard-configuration-button",trashcanButton:"public-dashboard-remove-button",pauseSwitch:"data-testid public dashboard pause switch"}},UserListPage:{tabs:{allUsers:"data-testid all-users-tab",orgUsers:"data-testid org-users-tab",anonUserDevices:"data-testid anon-user-devices-tab",publicDashboardsUsers:"data-testid public-dashboards-users-tab",users:"data-testid users-tab"},org:{url:"/org/users"},admin:{url:"/admin/users"},publicDashboards:{container:"data-testid public-dashboards-users-list"},UserListAdminPage:{container:"data-testid user-list-admin-page"},UsersListPage:{container:"data-testid users-list-page"},UserAnonListPage:{container:"data-testid user-anon-list-page"},UsersListPublicDashboardsPage:{container:"data-testid users-list-public-dashboards-page",DashboardsListModal:{listItem:e=>`data-testid dashboards-list-item-${e}`}}},ProfilePage:{url:"/profile"}},components:xe},Ne=({children:e})=>{const t=(0,R.useStyles2)(je);return me().createElement("div",{className:t.root},e)},je=e=>({root:(0,w.css)({display:"flex",flexWrap:"wrap",alignItems:"center",gap:e.spacing(3),minHeight:e.spacing(4)})});var Pe=Object.defineProperty,ke=Object.defineProperties,Fe=Object.getOwnPropertyDescriptors,De=Object.getOwnPropertySymbols,Me=Object.prototype.hasOwnProperty,Ve=Object.prototype.propertyIsEnumerable,Ue=(e,t,r)=>t in e?Pe(e,t,{enumerable:!0,configurable:!0,writable:!0,value:r}):e[t]=r,Be=(e,t)=>{for(var r in t||(t={}))Me.call(t,r)&&Ue(e,r,t[r]);if(De)for(var r of De(t))Ve.call(t,r)&&Ue(e,r,t[r]);return e},qe=(e,t)=>ke(e,Fe(t)),Ge=(e,t)=>{var r={};for(var n in e)Me.call(e,n)&&t.indexOf(n)<0&&(r[n]=e[n]);if(null!=e&&De)for(var n of De(e))t.indexOf(n)<0&&Ve.call(e,n)&&(r[n]=e[n]);return r};function Ke(e){var t=e,{label:r}=t,n=Ge(t,["label"]);const o=(0,R.useStyles2)($e),[i]=(0,ye.useState)((()=>Math.random().toString(16).slice(2))),a={SelectContainer:We,ValueContainer:ze,SingleValue:ze};return me().createElement("div",{className:o.root},r&&me().createElement("label",{className:o.label,htmlFor:i},r,":"," "),me().createElement(R.Select,qe(Be({openMenuOnFocus:!0,inputId:i},n),{components:a})))}const We=e=>{const{children:t}=e,r=(0,R.useStyles2)($e);return me().createElement(R.SelectContainer,qe(Be({},e),{className:(0,w.cx)(e.className,r.container)}),t)},ze=e=>{const{className:t,children:r}=e,n=(0,R.useStyles2)($e);return me().createElement("div",{className:(0,w.cx)(t,n.valueContainer)},r)},$e=e=>({root:(0,w.css)({display:"flex",fontSize:12,alignItems:"center"}),label:(0,w.css)({color:e.colors.text.secondary,whiteSpace:"nowrap"}),container:(0,w.css)({background:"none",borderColor:"transparent"}),valueContainer:(0,w.css)({display:"flex",alignItems:"center",flex:"initial",color:e.colors.text.secondary,fontSize:12})}),He=({grow:e,shrink:t})=>me().createElement("div",{style:{display:"block",flexGrow:e,flexShrink:t}});var Ye=Object.getOwnPropertySymbols,Qe=Object.prototype.hasOwnProperty,Xe=Object.prototype.propertyIsEnumerable;const Je=e=>{var t=e,{children:r}=t,n=((e,t)=>{var r={};for(var n in e)Qe.call(e,n)&&t.indexOf(n)<0&&(r[n]=e[n]);if(null!=e&&Ye)for(var n of Ye(e))t.indexOf(n)<0&&Xe.call(e,n)&&(r[n]=e[n]);return r})(t,["children"]);const o=(0,R.useStyles2)((0,ye.useCallback)((e=>Ze(e,n)),[n]));return me().createElement("div",{className:o.root},r)},Ze=(e,t)=>{var r,n,o;return{root:(0,w.css)({display:"flex",flexDirection:null!=(r=t.direction)?r:"row",flexWrap:null==(n=t.wrap)||n?"wrap":void 0,alignItems:t.alignItems,gap:e.spacing(null!=(o=t.gap)?o:2),flexGrow:t.flexGrow})}},et=({children:e})=>{const t=(0,R.useStyles2)(tt);return me().createElement("div",{className:t.root},me().createElement(Je,{gap:2},e))},tt=e=>({root:(0,w.css)({padding:e.spacing(1),backgroundColor:e.colors.background.secondary,borderRadius:e.shape.borderRadius(1)})}),rt=({v:e=0,h:t=0,layout:r="block"})=>{const n=(0,R.useStyles2)((0,ye.useCallback)((n=>nt(n,{v:e,h:t,layout:r})),[e,t,r]));return me().createElement("span",{className:(0,w.cx)(n.wrapper)})},nt=(e,t)=>{var r,n;return{wrapper:(0,w.css)([{paddingRight:e.spacing(null!=(r=t.h)?r:0),paddingBottom:e.spacing(null!=(n=t.v)?n:0)},"inline"===t.layout&&{display:"inline-block"},"block"===t.layout&&{display:"block"}])}};var ot=Object.defineProperty,it=Object.getOwnPropertySymbols,at=Object.prototype.hasOwnProperty,st=Object.prototype.propertyIsEnumerable,lt=(e,t,r)=>t in e?ot(e,t,{enumerable:!0,configurable:!0,writable:!0,value:r}):e[t]=r;const ut=e=>{var t;const r=e,{label:n,optional:o,tooltip:i,tooltipInteractive:a,children:s,width:l}=r,u=((e,t)=>{var r={};for(var n in e)at.call(e,n)&&t.indexOf(n)<0&&(r[n]=e[n]);if(null!=e&&it)for(var n of it(e))t.indexOf(n)<0&&st.call(e,n)&&(r[n]=e[n]);return r})(r,["label","optional","tooltip","tooltipInteractive","children","width"]),c=(0,R.useStyles2)((0,ye.useCallback)((e=>ct(e,l)),[l])),d=(null==u?void 0:u.htmlFor)||(null==(t=R.ReactUtils)?void 0:t.getChildId(s)),p=me().createElement(me().Fragment,null,me().createElement("label",{className:c.label,htmlFor:d},n,o&&me().createElement("span",{className:c.optional}," - optional"),i&&me().createElement(R.Tooltip,{placement:"top",content:i,theme:"info",interactive:a},me().createElement(R.Icon,{tabIndex:0,name:"info-circle",size:"sm",className:c.icon}))),me().createElement(rt,{v:.5}));return me().createElement("div",{className:c.root},me().createElement(R.Field,((e,t)=>{for(var r in t||(t={}))at.call(t,r)&&lt(e,r,t[r]);if(it)for(var r of it(t))st.call(t,r)&&lt(e,r,t[r]);return e})({className:c.field,label:p},u),s))},ct=(e,t)=>({root:(0,w.css)({minWidth:e.spacing(null!=t?t:0)}),label:(0,w.css)({fontSize:12,fontWeight:e.typography.fontWeightMedium}),optional:(0,w.css)({fontStyle:"italic",color:e.colors.text.secondary}),field:(0,w.css)({marginBottom:0}),icon:(0,w.css)({color:e.colors.text.secondary,marginLeft:e.spacing(1),":hover":{color:e.colors.text.primary}})});function dt({isOpen:e,onCancel:t,onDiscard:r,onCopy:n}){const o=(0,ye.useRef)(null),i=(0,R.useStyles2)(pt);return(0,ye.useEffect)((()=>{var t;e&&(null===(t=o.current)||void 0===t||t.focus())}),[e]),(0,_.jsxs)(R.Modal,{title:(0,_.jsxs)("div",{className:"modal-header-title",children:[(0,_.jsx)(R.Icon,{name:"exclamation-triangle",size:"lg"}),(0,_.jsx)("span",{className:i.titleText,children:"Warning"})]}),onDismiss:t,isOpen:e,children:[(0,_.jsx)("p",{children:"Builder mode does not display changes made in code. The query builder will display the last changes you made in builder mode."}),(0,_.jsx)("p",{children:"Do you want to copy your code to the clipboard?"}),(0,_.jsxs)(R.Modal.ButtonRow,{children:[(0,_.jsx)(R.Button,{type:"button",variant:"secondary",onClick:t,fill:"outline",children:"Cancel"}),(0,_.jsx)(R.Button,{variant:"destructive",type:"button",onClick:r,ref:o,children:"Discard code and switch"}),(0,_.jsx)(R.Button,{variant:"primary",onClick:n,children:"Copy code and switch"})]})]})}const pt=e=>({titleText:(0,w.css)({paddingLeft:e.spacing(2)})}),ft=()=>!!pe.config.featureToggles.sqlDatasourceDatabaseSelection;function ht(e,t,r,n,o,i,a){try{var s=e[i](a),l=s.value}catch(e){return void r(e)}s.done?t(l):Promise.resolve(l).then(n,o)}function vt(e){return function(){var t=this,r=arguments;return new Promise((function(n,o){var i=e.apply(t,r);function a(e){ht(i,n,o,a,s,"next",e)}function s(e){ht(i,n,o,a,s,"throw",e)}a(void 0)}))}}const gt=({dataset:e,db:t,dialect:r,onChange:n,inputId:o,preconfiguredDataset:i})=>{const a=!!i||"postgres"===r,s=Ee(vt((function*(){return ft()&&a?(n(I(i)),[I(i)]):(e&&n(I(e)),(yield t.datasets()).map(I))})),[]);return(0,ye.useEffect)((()=>{ft()||(e?s.value&&void 0===s.value.find((t=>t.value===e))&&s.value.length>0&&n(s.value[0]):s.value&&s.value[0]&&n(s.value[0]))}),[s.value,n,e]),(0,_.jsx)(R.Select,{"aria-label":"Dataset selector",inputId:o,value:e,options:s.value,onChange:n,disabled:s.loading,isLoading:s.loading,menuShouldPortal:!0})};function yt(e,t,r,n,o,i,a){try{var s=e[i](a),l=s.value}catch(e){return void r(e)}s.done?t(l):Promise.resolve(l).then(n,o)}function mt(e){return function(){var t=this,r=arguments;return new Promise((function(n,o){var i=e.apply(t,r);function a(e){yt(i,n,o,a,s,"next",e)}function s(e){yt(i,n,o,a,s,"throw",e)}a(void 0)}))}}const bt=({db:e,dataset:t,table:r,className:n,onChange:o,inputId:i})=>{const a=Ee(mt((function*(){return t?(yield e.tables(t)).map(T.toOption):[]})),[t]);return(0,_.jsx)(R.Select,{className:n,disabled:a.loading,"aria-label":"Table selector",inputId:i,"data-testid":Le.components.SQLQueryEditor.headerTableSelector,value:r,options:a.value,onChange:o,isLoading:a.loading,menuShouldPortal:!0,placeholder:a.loading?"Loading tables":"Select table"})};function Ot(e,t,r){return t in e?Object.defineProperty(e,t,{value:r,enumerable:!0,configurable:!0,writable:!0}):e[t]=r,e}function Et(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{},n=Object.keys(r);"function"==typeof Object.getOwnPropertySymbols&&(n=n.concat(Object.getOwnPropertySymbols(r).filter((function(e){return Object.getOwnPropertyDescriptor(r,e).enumerable})))),n.forEach((function(t){Ot(e,t,r[t])}))}return e}function St(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);r.push.apply(r,n)}return r}(Object(t)).forEach((function(r){Object.defineProperty(e,r,Object.getOwnPropertyDescriptor(t,r))})),e}const Tt=[{label:"Builder",value:de.Builder},{label:"Code",value:de.Code}];function _t({db:e,dialect:t,isQueryRunnable:r,onChange:n,onQueryRowChange:o,onRunQuery:i,preconfiguredDataset:a,query:s,queryRowFilter:l}){const{editorMode:u}=s,[c,d]=Ie(),[p,f]=(0,ye.useState)(!1),h=e.toRawSql,v=(0,ye.useId)(),g=(0,ye.useCallback)((e=>{var t;e===de.Code&&(0,pe.reportInteraction)("grafana_sql_editor_mode_changed",{datasource:null===(t=s.datasource)||void 0===t?void 0:t.type,selectedEditorMode:de.Code}),u!==de.Code?n(St(Et({},s),{editorMode:e})):f(!0)}),[u,n,s]);return(0,_.jsxs)(_.Fragment,{children:[(0,_.jsxs)(Ne,{children:[(0,_.jsx)(Ke,{label:"Format",value:s.format,placeholder:"Select format",menuShouldPortal:!0,onChange:e=>{var t;const r=St(Et({},s),{format:void 0!==e.value?e.value:S.Table});(0,pe.reportInteraction)("grafana_sql_format_changed",{datasource:null===(t=s.datasource)||void 0===t?void 0:t.type,selectedFormat:r.format}),n(r)},options:C}),u===de.Builder&&(0,_.jsxs)(_.Fragment,{children:[(0,_.jsx)(R.InlineSwitch,{id:`sql-filter-${v}`,label:"Filter","data-testid":Le.components.SQLQueryEditor.headerFilterSwitch,transparent:!0,showLabel:!0,value:l.filter,onChange:e=>{var t;e.target instanceof HTMLInputElement&&((0,pe.reportInteraction)("grafana_sql_filter_toggled",{datasource:null===(t=s.datasource)||void 0===t?void 0:t.type,displayed:e.target.checked}),o(St(Et({},l),{filter:e.target.checked})))}}),(0,_.jsx)(R.InlineSwitch,{id:`sql-group-${v}`,label:"Group","data-testid":Le.components.SQLQueryEditor.headerGroupSwitch,transparent:!0,showLabel:!0,value:l.group,onChange:e=>{var t;e.target instanceof HTMLInputElement&&((0,pe.reportInteraction)("grafana_sql_group_toggled",{datasource:null===(t=s.datasource)||void 0===t?void 0:t.type,displayed:e.target.checked}),o(St(Et({},l),{group:e.target.checked})))}}),(0,_.jsx)(R.InlineSwitch,{id:`sql-order-${v}`,label:"Order","data-testid":Le.components.SQLQueryEditor.headerOrderSwitch,transparent:!0,showLabel:!0,value:l.order,onChange:e=>{var t;e.target instanceof HTMLInputElement&&((0,pe.reportInteraction)("grafana_sql_order_toggled",{datasource:null===(t=s.datasource)||void 0===t?void 0:t.type,displayed:e.target.checked}),o(St(Et({},l),{order:e.target.checked})))}}),(0,_.jsx)(R.InlineSwitch,{id:`sql-preview-${v}`,label:"Preview","data-testid":Le.components.SQLQueryEditor.headerPreviewSwitch,transparent:!0,showLabel:!0,value:l.preview,onChange:e=>{var t;e.target instanceof HTMLInputElement&&((0,pe.reportInteraction)("grafana_sql_preview_toggled",{datasource:null===(t=s.datasource)||void 0===t?void 0:t.type,displayed:e.target.checked}),o(St(Et({},l),{preview:e.target.checked})))}})]}),(0,_.jsx)(He,{grow:1}),r?(0,_.jsx)(R.Button,{icon:"play",variant:"primary",size:"sm",onClick:()=>i(),children:"Run query"}):(0,_.jsx)(R.Tooltip,{theme:"error",content:(0,_.jsxs)(_.Fragment,{children:["Your query is invalid. Check below for details. ",(0,_.jsx)("br",{}),"However, you can still run this query."]}),placement:"top",children:(0,_.jsx)(R.Button,{icon:"exclamation-triangle",variant:"secondary",size:"sm",onClick:()=>i(),children:"Run query"})}),(0,_.jsx)(R.RadioButtonGroup,{options:Tt,size:"sm",value:u,onChange:g}),(0,_.jsx)(dt,{isOpen:p,onCopy:()=>{var e;(0,pe.reportInteraction)("grafana_sql_editor_mode_changed",{datasource:null===(e=s.datasource)||void 0===e?void 0:e.type,selectedEditorMode:de.Builder,type:"copy"}),f(!1),d(s.rawSql),n(St(Et({},s),{rawSql:h(s),editorMode:de.Builder}))},onDiscard:()=>{var e;(0,pe.reportInteraction)("grafana_sql_editor_mode_changed",{datasource:null===(e=s.datasource)||void 0===e?void 0:e.type,selectedEditorMode:de.Builder,type:"discard"}),f(!1),n(St(Et({},s),{rawSql:h(s),editorMode:de.Builder}))},onCancel:()=>{var e;(0,pe.reportInteraction)("grafana_sql_editor_mode_changed",{datasource:null===(e=s.datasource)||void 0===e?void 0:e.type,selectedEditorMode:de.Builder,type:"cancel"}),f(!1)}})]}),u===de.Builder&&(0,_.jsxs)(_.Fragment,{children:[(0,_.jsx)(R.Space,{v:.5}),(0,_.jsxs)(et,{children:["influx"!==t&&!(!ft()&&"postgres"===t)&&(0,_.jsx)(ut,{label:"Dataset",width:25,children:(0,_.jsx)(gt,{db:e,inputId:`sql-dataset-${v}`,dataset:s.dataset,dialect:t,preconfiguredDataset:a,onChange:e=>{if(e.value===s.dataset)return;const t=St(Et({},s),{dataset:e.value,table:void 0,sql:void 0,rawSql:""});n(t)}})}),(0,_.jsx)(ut,{label:"Table",width:25,children:(0,_.jsx)(bt,{db:e,inputId:`sql-tableselect-${v}`,dataset:s.dataset||a,table:s.table,onChange:e=>{if(e.value===s.table)return;const t=St(Et({},s),{table:e.value,sql:void 0,rawSql:""});n(t)}})})]})]})]})}var wt=function(){},Rt="undefined"!=typeof window;const At=Rt?ye.useLayoutEffect:ye.useEffect;var Ct={x:0,y:0,width:0,height:0,top:0,left:0,bottom:0,right:0};const It=Rt&&void 0!==window.ResizeObserver?function(){var e=(0,ye.useState)(null),t=e[0],r=e[1],n=(0,ye.useState)(Ct),o=n[0],i=n[1],a=(0,ye.useMemo)((function(){return new window.ResizeObserver((function(e){if(e[0]){var t=e[0].contentRect,r=t.x,n=t.y,o=t.width,a=t.height,s=t.top,l=t.left,u=t.bottom,c=t.right;i({x:r,y:n,width:o,height:a,top:s,left:l,bottom:u,right:c})}}))}),[]);return At((function(){if(t)return a.observe(t),function(){a.disconnect()}}),[t]),[r,o]}:function(){return[wt,Ct]};let xt;xt="undefined"!=typeof window?window:"undefined"!=typeof self?self:p.g;let Lt=null,Nt=null;const jt=xt.clearTimeout,Pt=xt.setTimeout,kt=xt.cancelAnimationFrame||xt.mozCancelAnimationFrame||xt.webkitCancelAnimationFrame,Ft=xt.requestAnimationFrame||xt.mozRequestAnimationFrame||xt.webkitRequestAnimationFrame;null==kt||null==Ft?(Lt=jt,Nt=function(e){return Pt(e,20)}):(Lt=function([e,t]){kt(e),jt(t)},Nt=function(e){const t=Ft((function(){jt(r),e()})),r=Pt((function(){kt(t),e()}),20);return[t,r]});class Dt extends ye.Component{constructor(...e){super(...e),this.state={height:this.props.defaultHeight||0,scaledHeight:this.props.defaultHeight||0,scaledWidth:this.props.defaultWidth||0,width:this.props.defaultWidth||0},this._autoSizer=null,this._detectElementResize=null,this._parentNode=null,this._resizeObserver=null,this._timeoutId=null,this._onResize=()=>{this._timeoutId=null;const{disableHeight:e,disableWidth:t,onResize:r}=this.props;if(this._parentNode){const n=window.getComputedStyle(this._parentNode)||{},o=parseFloat(n.paddingLeft||"0"),i=parseFloat(n.paddingRight||"0"),a=parseFloat(n.paddingTop||"0"),s=parseFloat(n.paddingBottom||"0"),l=this._parentNode.getBoundingClientRect(),u=l.height-a-s,c=l.width-o-i,d=this._parentNode.offsetHeight-a-s,p=this._parentNode.offsetWidth-o-i;(e||this.state.height===d&&this.state.scaledHeight===u)&&(t||this.state.width===p&&this.state.scaledWidth===c)||(this.setState({height:d,width:p,scaledHeight:u,scaledWidth:c}),"function"==typeof r&&r({height:d,scaledHeight:u,scaledWidth:c,width:p}))}},this._setRef=e=>{this._autoSizer=e}}componentDidMount(){const{nonce:e}=this.props,t=this._autoSizer?this._autoSizer.parentNode:null;if(null!=t&&t.ownerDocument&&t.ownerDocument.defaultView&&t instanceof t.ownerDocument.defaultView.HTMLElement){this._parentNode=t;const r=t.ownerDocument.defaultView.ResizeObserver;null!=r?(this._resizeObserver=new r((()=>{this._timeoutId=setTimeout(this._onResize,0)})),this._resizeObserver.observe(t)):(this._detectElementResize=function(e){let t,r,n,o,i,a,s;const l="undefined"!=typeof document&&document.attachEvent;if(!l){a=function(e){const t=e.__resizeTriggers__,r=t.firstElementChild,n=t.lastElementChild,o=r.firstElementChild;n.scrollLeft=n.scrollWidth,n.scrollTop=n.scrollHeight,o.style.width=r.offsetWidth+1+"px",o.style.height=r.offsetHeight+1+"px",r.scrollLeft=r.scrollWidth,r.scrollTop=r.scrollHeight},i=function(e){return e.offsetWidth!==e.__resizeLast__.width||e.offsetHeight!==e.__resizeLast__.height},s=function(e){if(e.target.className&&"function"==typeof e.target.className.indexOf&&e.target.className.indexOf("contract-trigger")<0&&e.target.className.indexOf("expand-trigger")<0)return;const t=this;a(this),this.__resizeRAF__&&Lt(this.__resizeRAF__),this.__resizeRAF__=Nt((function(){i(t)&&(t.__resizeLast__.width=t.offsetWidth,t.__resizeLast__.height=t.offsetHeight,t.__resizeListeners__.forEach((function(r){r.call(t,e)})))}))};let e=!1,l="";n="animationstart";const u="Webkit Moz O ms".split(" ");let c="webkitAnimationStart animationstart oAnimationStart MSAnimationStart".split(" "),d="";{const t=document.createElement("fakeelement");if(void 0!==t.style.animationName&&(e=!0),!1===e)for(let r=0;r<u.length;r++)if(void 0!==t.style[u[r]+"AnimationName"]){d=u[r],l="-"+d.toLowerCase()+"-",n=c[r],e=!0;break}}r="resizeanim",t="@"+l+"keyframes "+r+" { from { opacity: 0; } to { opacity: 0; } } ",o=l+"animation: 1ms "+r+"; "}return{addResizeListener:function(i,u){if(l)i.attachEvent("onresize",u);else{if(!i.__resizeTriggers__){const l=i.ownerDocument,u=xt.getComputedStyle(i);u&&"static"===u.position&&(i.style.position="relative"),function(r){if(!r.getElementById("detectElementResize")){const n=(t||"")+".resize-triggers { "+(o||"")+'visibility: hidden; opacity: 0; } .resize-triggers, .resize-triggers > div, .contract-trigger:before { content: " "; display: block; position: absolute; top: 0; left: 0; height: 100%; width: 100%; overflow: hidden; z-index: -1; } .resize-triggers > div { background: #eee; overflow: auto; } .contract-trigger:before { width: 200%; height: 200%; }',i=r.head||r.getElementsByTagName("head")[0],a=r.createElement("style");a.id="detectElementResize",a.type="text/css",null!=e&&a.setAttribute("nonce",e),a.styleSheet?a.styleSheet.cssText=n:a.appendChild(r.createTextNode(n)),i.appendChild(a)}}(l),i.__resizeLast__={},i.__resizeListeners__=[],(i.__resizeTriggers__=l.createElement("div")).className="resize-triggers";const c=l.createElement("div");c.className="expand-trigger",c.appendChild(l.createElement("div"));const d=l.createElement("div");d.className="contract-trigger",i.__resizeTriggers__.appendChild(c),i.__resizeTriggers__.appendChild(d),i.appendChild(i.__resizeTriggers__),a(i),i.addEventListener("scroll",s,!0),n&&(i.__resizeTriggers__.__animationListener__=function(e){e.animationName===r&&a(i)},i.__resizeTriggers__.addEventListener(n,i.__resizeTriggers__.__animationListener__))}i.__resizeListeners__.push(u)}},removeResizeListener:function(e,t){if(l)e.detachEvent("onresize",t);else if(e.__resizeListeners__.splice(e.__resizeListeners__.indexOf(t),1),!e.__resizeListeners__.length){e.removeEventListener("scroll",s,!0),e.__resizeTriggers__.__animationListener__&&(e.__resizeTriggers__.removeEventListener(n,e.__resizeTriggers__.__animationListener__),e.__resizeTriggers__.__animationListener__=null);try{e.__resizeTriggers__=!e.removeChild(e.__resizeTriggers__)}catch(e){}}}}}(e),this._detectElementResize.addResizeListener(t,this._onResize)),this._onResize()}}componentWillUnmount(){this._parentNode&&(this._detectElementResize&&this._detectElementResize.removeResizeListener(this._parentNode,this._onResize),null!==this._timeoutId&&clearTimeout(this._timeoutId),this._resizeObserver&&this._resizeObserver.disconnect())}render(){const{children:e,defaultHeight:t,defaultWidth:r,disableHeight:n=!1,disableWidth:o=!1,doNotBailOutOnEmptyChildren:i=!1,nonce:a,onResize:s,style:l={},tagName:u="div",...c}=this.props,{height:d,scaledHeight:p,scaledWidth:f,width:h}=this.state,v={overflow:"visible"},g={};let y=!1;return n||(0===d&&(y=!0),v.height=0,g.height=d,g.scaledHeight=p),o||(0===h&&(y=!0),v.width=0,g.width=h,g.scaledWidth=f),i&&(y=!1),(0,ye.createElement)(u,{ref:this._setRef,style:{...v,...l},...c},!y&&e(g))}}var Mt=Object.defineProperty,Vt=Object.getOwnPropertySymbols,Ut=Object.prototype.hasOwnProperty,Bt=Object.prototype.propertyIsEnumerable,qt=(e,t,r)=>t in e?Mt(e,t,{enumerable:!0,configurable:!0,writable:!0,value:r}):e[t]=r;const Gt=(e,t,r={})=>((e,t)=>{for(var r in t||(t={}))Ut.call(t,r)&&qt(e,r,t[r]);if(Vt)for(var r of Vt(t))Bt.call(t,r)&&qt(e,r,t[r]);return e})({label:e,insertText:e,kind:ue.Field,sortText:le.Medium,range:t},r);var Kt=Object.defineProperty,Wt=Object.defineProperties,zt=Object.getOwnPropertyDescriptors,$t=Object.getOwnPropertySymbols,Ht=Object.prototype.hasOwnProperty,Yt=Object.prototype.propertyIsEnumerable,Qt=(e,t,r)=>t in e?Kt(e,t,{enumerable:!0,configurable:!0,writable:!0,value:r}):e[t]=r,Xt=(e,t)=>{for(var r in t||(t={}))Ht.call(t,r)&&Qt(e,r,t[r]);if($t)for(var r of $t(t))Yt.call(t,r)&&Qt(e,r,t[r]);return e};const Jt=()=>[{id:ae.SelectKeyword,name:ae.SelectKeyword,kind:[se.SelectKeyword]},{id:ae.WithKeyword,name:ae.WithKeyword,kind:[se.WithKeyword]},{id:ae.AfterSelectKeyword,name:ae.AfterSelectKeyword,kind:[se.StarWildCard,se.FunctionsWithArguments,se.Columns,se.SelectMacro]},{id:ae.AfterSelectFuncFirstArgument,name:ae.AfterSelectFuncFirstArgument,kind:[se.Columns]},{id:ae.AfterGroupByFunctionArgument,name:ae.AfterGroupByFunctionArgument,kind:[se.Columns]},{id:ae.AfterWhereFunctionArgument,name:ae.AfterWhereFunctionArgument,kind:[se.Columns]},{id:ae.AfterSelectArguments,name:ae.AfterSelectArguments,kind:[se.Columns]},{id:ae.AfterFromKeyword,name:ae.AfterFromKeyword,kind:[se.Schemas,se.Tables,se.TableMacro]},{id:ae.AfterSchema,name:ae.AfterSchema,kind:[se.Tables,se.TableMacro]},{id:ae.SelectAlias,name:ae.SelectAlias,kind:[se.Columns,se.FunctionsWithArguments]},{id:ae.FromKeyword,name:ae.FromKeyword,kind:[se.FromKeyword]},{id:ae.AfterFrom,name:ae.AfterFrom,kind:[se.WhereKeyword,se.GroupByKeywords,se.OrderByKeywords,se.LimitKeyword]},{id:ae.AfterTable,name:ae.AfterTable,kind:[se.WhereKeyword,se.GroupByKeywords,se.OrderByKeywords,se.LimitKeyword]},{id:ae.WhereKeyword,name:ae.WhereKeyword,kind:[se.Columns,se.FilterMacro,se.TemplateVariables]},{id:ae.WhereComparisonOperator,name:ae.WhereComparisonOperator,kind:[se.ComparisonOperators]},{id:ae.WhereValue,name:ae.WhereValue,kind:[se.FilterMacro,se.TemplateVariables]},{id:ae.AfterWhereValue,name:ae.AfterWhereValue,kind:[se.LogicalOperators,se.GroupByKeywords,se.OrderByKeywords,se.LimitKeyword,se.Columns,se.TemplateVariables]},{id:ae.AfterGroupByKeywords,name:ae.AfterGroupByKeywords,kind:[se.GroupMacro,se.Columns]},{id:ae.AfterGroupBy,name:ae.AfterGroupBy,kind:[se.OrderByKeywords,se.LimitKeyword]},{id:ae.AfterOrderByKeywords,name:ae.AfterOrderByKeywords,kind:[se.Columns]},{id:ae.AfterOrderByFunction,name:ae.AfterOrderByFunction,kind:[se.SortOrderDirectionKeyword,se.LimitKeyword]},{id:ae.AfterOrderByDirection,name:ae.AfterOrderByDirection,kind:[se.LimitKeyword]},{id:ae.AfterIsOperator,name:ae.AfterOrderByDirection,kind:[se.NotKeyword,se.NullValue,se.BoolValues]},{id:ae.AfterIsNotOperator,name:ae.AfterOrderByDirection,kind:[se.NullValue,se.BoolValues]}];class Zt{constructor(e,t,r,n,o){this.type=e,this.value=t,this.range=r,this.previous=n,this.next=o}isKeyword(){return this.type===ie.Keyword}isWhiteSpace(){return this.type===ie.Whitespace}isParenthesis(){return this.type===ie.Parenthesis}isIdentifier(){return this.type===ie.Identifier}isString(){return this.type===ie.String}isNumber(){return this.type===ie.Number}isDoubleQuotedString(){return this.type===ie.Type}isVariable(){return this.type===ie.Variable}isFunction(){return this.type===ie.Function}isOperator(){return this.type===ie.Operator}isTemplateVariable(){return this.type===ie.Variable}is(e,t){const r=this.type===e;return void 0!==t?r&&er(e,this,t):r}getPreviousNonWhiteSpaceToken(){let e=this.previous;for(;null!=e;){if(!e.isWhiteSpace())return e;e=e.previous}return null}getPreviousOfType(e,t){let r=this.previous;for(;null!=r;){const n=r.type===e;if(void 0!==t?n&&er(e,r,t):n)return r;r=r.previous}return null}getPreviousUntil(e,t,r){let n=[],o=this.previous;for(;null!=o;){if(t.some((e=>e===(null==o?void 0:o.type)))){o=o.previous;continue}const i=o.type===e;if(void 0!==r?i&&er(e,o,r):i)return n;o.isWhiteSpace()||n.push(o),o=o.previous}return n}getNextUntil(e,t,r){let n=[],o=this.next;for(;null!=o;){if(t.some((e=>e===(null==o?void 0:o.type)))){o=o.next;continue}const i=o.type===e;if(void 0!==r?i&&er(e,o,r):i)return n;o.isWhiteSpace()||n.push(o),o=o.next}return n}getPreviousKeyword(){let e=this.previous;for(;null!=e;){if(e.isKeyword())return e;e=e.previous}return null}getNextNonWhiteSpaceToken(){let e=this.next;for(;null!=e;){if(!e.isWhiteSpace())return e;e=e.next}return null}getNextOfType(e,t){let r=this.next;for(;null!=r;){const n=r.type===e;if(void 0!==t?n&&er(e,r,t):n)return r;r=r.next}return null}}function er(e,t,r){return e===ie.Keyword||e===ie.Operator?t.value.toLowerCase()===r.toString().toLowerCase():t.value===r}var tr=p(8572);const rr=e=>{var t;const r=(e=>{const t=(e=>{var t;return null!=(t=null==e?void 0:e.getPreviousOfType(ie.Keyword,tr.SELECT))?t:null})(e);return null==t?void 0:t.getNextOfType(ie.Keyword,tr.FROM)})(e),n=null==r?void 0:r.getNextNonWhiteSpaceToken();return(null==n?void 0:n.isVariable())||(null==n?void 0:n.isKeyword())&&(null==(t=n.next)?void 0:t.is(ie.Parenthesis,"("))?null:n},nr=e=>{const t=null==e?void 0:e.value.split(".");return 1===(null==t?void 0:t.length)?{table:t[0]}:2===(null==t?void 0:t.length)?{schema:t[0],table:t[1]}:null},or={id:"editor.action.triggerSuggest",title:""};var ir,ar=new Uint8Array(16);function sr(){if(!ir&&!(ir="undefined"!=typeof crypto&&crypto.getRandomValues&&crypto.getRandomValues.bind(crypto)||"undefined"!=typeof msCrypto&&"function"==typeof msCrypto.getRandomValues&&msCrypto.getRandomValues.bind(msCrypto)))throw new Error("crypto.getRandomValues() not supported. See https://github.com/uuidjs/uuid#getrandomvalues-not-supported");return ir(ar)}const lr=/^(?:[0-9a-f]{8}-[0-9a-f]{4}-[1-5][0-9a-f]{3}-[89ab][0-9a-f]{3}-[0-9a-f]{12}|00000000-0000-0000-0000-000000000000)$/i;for(var ur=[],cr=0;cr<256;++cr)ur.push((cr+256).toString(16).substr(1));const dr=function(e){var t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:0,r=(ur[e[t+0]]+ur[e[t+1]]+ur[e[t+2]]+ur[e[t+3]]+"-"+ur[e[t+4]]+ur[e[t+5]]+"-"+ur[e[t+6]]+ur[e[t+7]]+"-"+ur[e[t+8]]+ur[e[t+9]]+"-"+ur[e[t+10]]+ur[e[t+11]]+ur[e[t+12]]+ur[e[t+13]]+ur[e[t+14]]+ur[e[t+15]]).toLowerCase();if(!function(e){return"string"==typeof e&&lr.test(e)}(r))throw TypeError("Stringified UUID is invalid");return r},pr=function(e,t,r){var n=(e=e||{}).random||(e.rng||sr)();if(n[6]=15&n[6]|64,n[8]=63&n[8]|128,t){r=r||0;for(var o=0;o<16;++o)t[r+o]=n[o];return t}return dr(n)},fr=(e,t,r)=>()=>[{id:se.SelectKeyword,name:se.SelectKeyword,suggestions:(e,t)=>Promise.resolve([{label:"SELECT <column>",insertText:"SELECT $0",insertTextRules:ce.InsertAsSnippet,kind:ue.Snippet,command:or,sortText:le.Medium},{label:"SELECT <column> FROM <table>",insertText:"SELECT $2 FROM $1",insertTextRules:ce.InsertAsSnippet,kind:ue.Snippet,command:or,sortText:le.Medium}])},{id:se.TemplateVariables,name:se.TemplateVariables,suggestions:(e,t)=>{const r=(0,pe.getTemplateSrv)();return r?Promise.resolve(r.getVariables().map((e=>{const t=`$${e.name}`,n=r.replace(t);return{label:t,detail:`(Template Variable) ${n}`,kind:ue.Snippet,documentation:`(Template Variable) ${n}`,insertText:`\\$${e.name} `,insertTextRules:ce.InsertAsSnippet,command:or,sortText:le.Low}}))):Promise.resolve([])}},{id:se.SelectMacro,name:se.SelectMacro,suggestions:(e,t)=>Promise.resolve([...r.list().filter((e=>e.type===oe.Value||e.type===oe.Column)).map(hr)])},{id:se.TableMacro,name:se.TableMacro,suggestions:(e,t)=>Promise.resolve([...r.list().filter((e=>e.type===oe.Table)).map(hr)])},{id:se.GroupMacro,name:se.GroupMacro,suggestions:(e,t)=>Promise.resolve([...r.list().filter((e=>e.type===oe.Group)).map(hr)])},{id:se.FilterMacro,name:se.FilterMacro,suggestions:(e,t)=>Promise.resolve([...r.list().filter((e=>e.type===oe.Filter)).map(hr)])},{id:se.WithKeyword,name:se.WithKeyword,suggestions:(e,t)=>Promise.resolve([{label:"WITH <alias> AS ( ... )",insertText:"WITH $1  AS ( $2 )",insertTextRules:ce.InsertAsSnippet,kind:ue.Snippet,command:or,sortText:le.Medium}])},{id:se.StarWildCard,name:se.StarWildCard,suggestions:(e,t)=>Promise.resolve([{label:"*",insertText:"* $0",insertTextRules:ce.InsertAsSnippet,kind:ue.Field,command:or,sortText:le.High}])},{id:se.FunctionsWithArguments,name:se.FunctionsWithArguments,suggestions:(t,r)=>Promise.resolve([...e.list().map((e=>({label:e.name,insertText:`${e.name}($0)`,documentation:e.description,insertTextRules:ce.InsertAsSnippet,kind:ue.Function,command:or,sortText:le.MediumLow})))])},{id:se.FunctionsWithoutArguments,name:se.FunctionsWithoutArguments,suggestions:(t,r)=>Promise.resolve([...e.list().map((e=>({label:e.name,insertText:`${e.name}()`,documentation:e.description,insertTextRules:ce.InsertAsSnippet,kind:ue.Function,command:or,sortText:le.MediumHigh})))])},{id:se.FromKeyword,name:se.FromKeyword,suggestions:(e,t)=>Promise.resolve([{label:"FROM",insertText:"FROM $0",command:or,insertTextRules:ce.InsertAsSnippet,kind:ue.Keyword}])},{id:se.Schemas,name:se.Schemas,suggestions:(e,t)=>Promise.resolve([])},{id:se.Tables,name:se.Tables,suggestions:(e,t)=>Promise.resolve([])},{id:se.Columns,name:se.Columns,suggestions:(e,t)=>Promise.resolve([])},{id:se.LogicalOperators,name:se.LogicalOperators,suggestions:(e,r)=>Promise.resolve(t.list().filter((e=>e.type===ne.Logical)).map((e=>({label:e.operator,insertText:`${e.operator} `,documentation:e.description,command:or,sortText:le.MediumHigh,kind:ue.Operator}))))},{id:se.WhereKeyword,name:se.WhereKeyword,suggestions:(e,t)=>Promise.resolve([{label:"WHERE",insertText:"WHERE ",command:or,sortText:le.MediumHigh,kind:ue.Keyword}])},{id:se.ComparisonOperators,name:se.ComparisonOperators,suggestions:(e,r)=>Promise.resolve([...t.list().filter((e=>e.type===ne.Comparison)).map((e=>({label:e.operator,insertText:`${e.operator} `,documentation:e.description,command:or,sortText:le.MediumHigh,kind:ue.Operator}))),{label:"IN (...)",insertText:"IN ( $0 )",command:or,sortText:le.Medium,kind:ue.Operator,insertTextRules:ce.InsertAsSnippet},{label:"NOT IN (...)",insertText:"NOT IN ( $0 )",command:or,sortText:le.Medium,kind:ue.Operator,insertTextRules:ce.InsertAsSnippet},{label:"IS",insertText:"IS",command:or,sortText:le.Medium,kind:ue.Operator},{label:"IS NOT",insertText:"IS NOT",command:or,sortText:le.Medium,kind:ue.Operator}])},{id:se.GroupByKeywords,name:se.GroupByKeywords,suggestions:(e,t)=>Promise.resolve([{label:"GROUP BY",insertText:"GROUP BY ",command:or,sortText:le.MediumHigh,kind:ue.Keyword}])},{id:se.OrderByKeywords,name:se.OrderByKeywords,suggestions:(e,t)=>Promise.resolve([{label:"ORDER BY",insertText:"ORDER BY ",command:or,sortText:le.Medium,kind:ue.Keyword},{label:"ORDER BY(ascending)",insertText:"ORDER BY $1 ASC ",command:or,sortText:le.MediumLow,kind:ue.Snippet,insertTextRules:ce.InsertAsSnippet},{label:"ORDER BY(descending)",insertText:"ORDER BY $1 DESC",command:or,sortText:le.MediumLow,kind:ue.Snippet,insertTextRules:ce.InsertAsSnippet}])},{id:se.LimitKeyword,name:se.LimitKeyword,suggestions:(e,t)=>Promise.resolve([{label:"LIMIT",insertText:"LIMIT ",command:or,sortText:le.MediumLow,kind:ue.Keyword}])},{id:se.SortOrderDirectionKeyword,name:se.SortOrderDirectionKeyword,suggestions:(e,t)=>Promise.resolve([tr.ASC,tr.DESC].map((e=>({label:e,insertText:`${e} `,command:or,kind:ue.Keyword}))))},{id:se.NotKeyword,name:se.NotKeyword,suggestions:()=>Promise.resolve([{label:"NOT",insertText:"NOT",command:or,kind:ue.Keyword,sortText:le.High}])},{id:se.BoolValues,name:se.BoolValues,suggestions:()=>Promise.resolve(["TRUE","FALSE"].map((e=>({label:e,insertText:`${e}`,command:or,kind:ue.Keyword,sortText:le.Medium}))))},{id:se.NullValue,name:se.NullValue,suggestions:()=>Promise.resolve(["NULL"].map((e=>({label:e,insertText:`${e}`,command:or,kind:ue.Keyword,sortText:le.Low}))))}];function hr(e){return{label:e.name,insertText:`${"\\"+e.text}${t=e.args,t?"(".concat(t.map(((e,t)=>`\${${t}:${e}}`)).join(", ")).concat(")"):"()"} `,insertTextRules:ce.InsertAsSnippet,kind:ue.Snippet,documentation:e.description,command:or};var t}function vr(){return[{id:ae.SelectKeyword,name:ae.SelectKeyword,resolve:(e,t,r,n)=>Boolean(null===e||e.isWhiteSpace()&&null===e.previous||e.is(ie.Keyword,tr.SELECT)||e.is(ie.Keyword,tr.SELECT)&&null===e.previous||n||e.isIdentifier()&&(n||null===(null==e?void 0:e.previous))||e.isIdentifier()&&tr.SELECT.startsWith(e.value.toLowerCase()))},{id:ae.WithKeyword,name:ae.WithKeyword,resolve:(e,t,r,n)=>Boolean(null===e||e.isWhiteSpace()&&null===e.previous||e.is(ie.Keyword,tr.WITH)&&null===e.previous||e.isIdentifier()&&tr.WITH.toLowerCase().startsWith(e.value.toLowerCase()))},{id:ae.AfterSelectKeyword,name:ae.AfterSelectKeyword,resolve:(e,t,r,n)=>Boolean((null==r?void 0:r.value.toLowerCase())===tr.SELECT)},{id:ae.AfterSelectArguments,name:ae.AfterSelectArguments,resolve:(e,t,r,n)=>Boolean((null==t?void 0:t.value.toLowerCase())===tr.SELECT&&","===(null==r?void 0:r.value))},{id:ae.AfterSelectFuncFirstArgument,name:ae.AfterSelectFuncFirstArgument,resolve:(e,t,r,n)=>Boolean(((null==t?void 0:t.value.toLowerCase())===tr.SELECT||(null==t?void 0:t.value.toLowerCase())===tr.AS)&&((null==r?void 0:r.is(ie.Parenthesis,"("))||(null==e?void 0:e.is(ie.Parenthesis,"()"))))},{id:ae.AfterWhereFunctionArgument,name:ae.AfterWhereFunctionArgument,resolve:(e,t,r,n)=>Boolean((null==t?void 0:t.is(ie.Keyword,tr.WHERE))&&((null==r?void 0:r.is(ie.Parenthesis,"("))||(null==e?void 0:e.is(ie.Parenthesis,"()"))))},{id:ae.AfterGroupBy,name:ae.AfterGroupBy,resolve:(e,t,r,n)=>{var o;return Boolean((null==t?void 0:t.is(ie.Keyword,tr.BY))&&(null==(o=null==t?void 0:t.getPreviousKeyword())?void 0:o.is(ie.Keyword,tr.GROUP))&&((null==r?void 0:r.isIdentifier())||(null==r?void 0:r.isDoubleQuotedString())||(null==r?void 0:r.is(ie.Parenthesis,")"))||(null==r?void 0:r.is(ie.Parenthesis,"()"))))}},{id:ae.SelectAlias,name:ae.SelectAlias,resolve:(e,t,r,n)=>","===(null==r?void 0:r.value)&&(null==t?void 0:t.value.toLowerCase())===tr.AS},{id:ae.FromKeyword,name:ae.FromKeyword,resolve:(e,t,r,n)=>Boolean((null==t?void 0:t.value.toLowerCase())===tr.SELECT&&","!==(null==r?void 0:r.value)||((null==e?void 0:e.isKeyword())||(null==e?void 0:e.isIdentifier()))&&tr.FROM.toLowerCase().startsWith(e.value.toLowerCase()))},{id:ae.AfterFromKeyword,name:ae.AfterFromKeyword,resolve:(e,t,r,n)=>Boolean(!(null==e?void 0:e.value.includes("."))&&(null==r?void 0:r.value.toLowerCase())===tr.FROM)},{id:ae.AfterSchema,name:ae.AfterSchema,resolve:(e,t,r,n)=>((null==e?void 0:e.isWhiteSpace())&&(null==e?void 0:e.next)&&(r=(e=null==e?void 0:e.previous).getPreviousNonWhiteSpaceToken()),Boolean((null==e?void 0:e.isIdentifier())&&(null==e?void 0:e.value.endsWith("."))&&(null==r?void 0:r.value.toLowerCase())===tr.FROM))},{id:ae.AfterFrom,name:ae.AfterFrom,resolve:(e,t,r,n)=>Boolean((null==t?void 0:t.value.toLowerCase())===tr.FROM&&(null==r?void 0:r.isDoubleQuotedString())||(null==t?void 0:t.value.toLowerCase())===tr.FROM&&(null==r?void 0:r.isIdentifier())||(null==t?void 0:t.value.toLowerCase())===tr.FROM&&(null==r?void 0:r.isVariable()))},{id:ae.AfterTable,name:ae.AfterTable,resolve:(e,t,r,n)=>Boolean((null==t?void 0:t.value.toLowerCase())===tr.FROM&&((null==r?void 0:r.isVariable())||""!==(null==r?void 0:r.value)&&(null==r?void 0:r.value.toLowerCase())!==tr.FROM))},{id:ae.WhereKeyword,name:ae.WhereKeyword,resolve:(e,t,r,n)=>Boolean((null==t?void 0:t.value.toLowerCase())===tr.WHERE&&((null==r?void 0:r.isKeyword())||(null==r?void 0:r.is(ie.Parenthesis,"("))||(null==r?void 0:r.is(ie.Operator,tr.AND))))},{id:ae.WhereComparisonOperator,name:ae.WhereComparisonOperator,resolve:(e,t,r,n)=>{var o;return Boolean((null==t?void 0:t.value.toLowerCase())===tr.WHERE&&!(null==(o=null==r?void 0:r.getPreviousNonWhiteSpaceToken())?void 0:o.isOperator())&&!(null==e?void 0:e.is(ie.Delimiter,"."))&&!(null==e?void 0:e.isParenthesis())&&((null==r?void 0:r.isIdentifier())||(null==r?void 0:r.isDoubleQuotedString())))}},{id:ae.WhereValue,name:ae.WhereValue,resolve:(e,t,r,n)=>Boolean((null==t?void 0:t.value.toLowerCase())===tr.WHERE&&(null==r?void 0:r.isOperator()))},{id:ae.AfterWhereValue,name:ae.AfterWhereValue,resolve:(e,t,r,n)=>{var o,i,a;return Boolean((null==t?void 0:t.value.toLowerCase())===tr.WHERE&&((null==r?void 0:r.is(ie.Operator,"and"))||(null==r?void 0:r.is(ie.Operator,"or"))||(null==r?void 0:r.isString())||(null==r?void 0:r.isNumber())||(null==r?void 0:r.is(ie.Parenthesis,")"))||(null==r?void 0:r.is(ie.Parenthesis,"()"))||(null==r?void 0:r.isTemplateVariable())||(null==r?void 0:r.is(ie.IdentifierQuote))&&(null==(o=r.getPreviousNonWhiteSpaceToken())?void 0:o.is(ie.Identifier))&&(null==(a=null==(i=null==r?void 0:r.getPreviousNonWhiteSpaceToken())?void 0:i.getPreviousNonWhiteSpaceToken())?void 0:a.is(ie.IdentifierQuote))))}},{id:ae.AfterGroupByKeywords,name:ae.AfterGroupByKeywords,resolve:(e,t,r,n)=>{var o;return Boolean((null==t?void 0:t.is(ie.Keyword,tr.BY))&&(null==(o=null==t?void 0:t.getPreviousKeyword())?void 0:o.is(ie.Keyword,tr.GROUP))&&((null==r?void 0:r.is(ie.Keyword,tr.BY))||(null==r?void 0:r.is(ie.Delimiter,","))))}},{id:ae.AfterGroupByFunctionArgument,name:ae.AfterGroupByFunctionArgument,resolve:(e,t,r,n)=>{var o;return Boolean((null==t?void 0:t.is(ie.Keyword,tr.BY))&&(null==(o=null==t?void 0:t.getPreviousKeyword())?void 0:o.is(ie.Keyword,tr.GROUP))&&((null==r?void 0:r.is(ie.Parenthesis,"("))||(null==e?void 0:e.is(ie.Parenthesis,"()"))))}},{id:ae.AfterOrderByKeywords,name:ae.AfterOrderByKeywords,resolve:(e,t,r,n)=>{var o;return Boolean((null==r?void 0:r.is(ie.Keyword,tr.BY))&&(null==(o=null==r?void 0:r.getPreviousKeyword())?void 0:o.is(ie.Keyword,tr.ORDER)))}},{id:ae.AfterOrderByFunction,name:ae.AfterOrderByFunction,resolve:(e,t,r,n)=>{var o,i;return Boolean((null==t?void 0:t.is(ie.Keyword,tr.BY))&&(null==(o=null==t?void 0:t.getPreviousKeyword())?void 0:o.is(ie.Keyword,tr.ORDER))&&(null==r?void 0:r.is(ie.Parenthesis))&&(null==(i=null==r?void 0:r.getPreviousNonWhiteSpaceToken())?void 0:i.is(ie.Function)))}},{id:ae.AfterOrderByDirection,name:ae.AfterOrderByDirection,resolve:(e,t,r,n)=>Boolean((null==t?void 0:t.is(ie.Keyword,tr.DESC))||(null==t?void 0:t.is(ie.Keyword,tr.ASC)))},{id:ae.AfterIsOperator,name:ae.AfterIsOperator,resolve:(e,t,r,n)=>Boolean(null==r?void 0:r.is(ie.Operator,"IS"))},{id:ae.AfterIsNotOperator,name:ae.AfterIsNotOperator,resolve:(e,t,r,n)=>{var o;return Boolean((null==r?void 0:r.is(ie.Operator,"NOT"))&&(null==(o=r.getPreviousNonWhiteSpaceToken())?void 0:o.is(ie.Operator,"IS")))}}]}let gr={logger:()=>{}},yr=()=>{};R.attachDebugger&&R.createLogger&&(gr=(0,R.createLogger)("SQLEditor"),yr=gr.logger,(0,R.attachDebugger)("sqleditor",void 0,gr));const mr="column",br=[{id:"$__timeFilter(dateColumn)",name:"$__timeFilter(dateColumn)",text:"$__timeFilter",args:[mr],type:oe.Filter,description:"Will be replaced by a time range filter using the specified column name. For example, dateColumn BETWEEN FROM_UNIXTIME(1494410783) AND FROM_UNIXTIME(1494410983)"},{id:"$__timeFrom()",name:"$__timeFrom()",text:"$__timeFrom",args:[],type:oe.Filter,description:"Will be replaced by the start of the currently active time selection. For example, FROM_UNIXTIME(1494410783)"},{id:"$__timeTo()",name:"$__timeTo()",text:"$__timeTo",args:[],type:oe.Filter,description:"Will be replaced by the end of the currently active time selection. For example, FROM_UNIXTIME(1494410983)"},{id:"$__timeGroup(dateColumn, '5m')",name:"$__timeGroup(dateColumn, '5m')",text:"$__timeGroup",args:[mr,"'5m'"],type:oe.Value,description:"Will be replaced by an expression usable in GROUP BY clause. For example, *cast(cast(UNIX_TIMESTAMP(dateColumn)/(300) as signed)*300 as signed),*"},{id:"$__table",name:"$__table",text:"$__table",args:[],type:oe.Table,description:"Will be replaced by the query table."},{id:"$__column",name:"$__column",text:"$__column",args:[],type:oe.Column,description:"Will be replaced by the query column."}];function Or(e,t){var r,n,o;const i={triggerCharacters:["."," ","$",",","(","'"]};t&&Array.isArray(t.builtinFunctions)&&(i.supportedFunctions=()=>t.builtinFunctions.map((e=>({id:e,name:e}))));const a=[];return(null==(r=null==t?void 0:t.comparisonOperators)?void 0:r.length)&&a.push(...t.comparisonOperators.map((e=>({id:e.toLocaleLowerCase(),operator:e,type:ne.Comparison})))),t.logicalOperators=null!=(n=t.logicalOperators)?n:t.operators,(null==(o=null==t?void 0:t.logicalOperators)?void 0:o.length)&&a.push(...t.logicalOperators.map((e=>({id:e.toLocaleLowerCase(),operator:e,type:ne.Logical})))),i.supportedOperators=()=>a,i.supportedMacros=()=>br,i}const Er={id:"standardSql",extensions:[".sql"],aliases:["sql"],mimetypes:[],loader:()=>Promise.resolve().then(p.bind(p,8572)),completionProvider:Or};var Sr=Object.defineProperty,Tr=Object.defineProperties,_r=Object.getOwnPropertyDescriptors,wr=Object.getOwnPropertySymbols,Rr=Object.prototype.hasOwnProperty,Ar=Object.prototype.propertyIsEnumerable,Cr=(e,t,r)=>t in e?Sr(e,t,{enumerable:!0,configurable:!0,writable:!0,value:r}):e[t]=r,Ir=(e,t)=>{for(var r in t||(t={}))Rr.call(t,r)&&Cr(e,r,t[r]);if(wr)for(var r of wr(t))Ar.call(t,r)&&Cr(e,r,t[r]);return e},xr=(e,t)=>Tr(e,_r(t));const Lr=new Map,Nr=new Map,jr=({children:e,onBlur:t,onChange:r,query:n,language:o={id:"sql"},width:i,height:a})=>{const s=(0,ye.useRef)(null),l=(0,ye.useRef)(),u=(0,ye.useMemo)((()=>{const e=pr(),t=`${o.id}-${e}`;return l.current=t,t}),[o.id]);(0,ye.useEffect)((()=>()=>{l.current&&Nr.delete(l.current),yr(`Removing instance cache ${l.current}`,!1,Nr)}),[]);const c=(0,ye.useCallback)((()=>{s.current&&s.current.getAction("editor.action.formatDocument").run()}),[]);return me().createElement("div",{style:{width:i}},me().createElement(R.CodeEditor,{height:a||"240px",width:i?i-2+"px":void 0,language:u,value:n,onBlur:e=>{r&&r(e,!1),t&&t(e)},showMiniMap:!1,showLineNumbers:!0,onEditorDidMount:(e,t)=>{s.current=e,e.onDidChangeModelContent((t=>{const n=e.getValue();r&&r(n,!1)})),e.addCommand(t.KeyMod.CtrlCmd|t.KeyCode.Enter,(()=>{const t=e.getValue();r&&r(t,!0)})),e.onKeyUp((t=>{84===t.keyCode&&e.trigger(or.id,or.id,{})})),Pr(t,o,u)}}),e&&e({formatQuery:c}))},Pr=async(e,t,r)=>{const n=((e,t)=>{if("sql"!==(null==t?void 0:t.id)&&!t.loader){yr(`Loading language '${null==t?void 0:t.id}' from Monaco registry`,!1);const r=e.languages.getLanguages().find((({id:e})=>e===(null==t?void 0:t.id)));if(!r)throw Error(`Unknown Monaco language ${null==t?void 0:t.id}`);return Ir(Ir({completionProvider:Or},r),t)}return Ir(Ir({},Er),t)})(e,t);if(!n.loader)return;const{language:o,conf:i}=await n.loader(e);if(e.languages.register({id:r}),e.languages.setMonarchTokensProvider(r,Ir({},o)),e.languages.setLanguageConfiguration(r,Ir({},i)),n.formatter&&e.languages.registerDocumentFormattingEditProvider(r,{provideDocumentFormattingEdits:e=>{var r;const n=null==(r=t.formatter)?void 0:r.call(t,e.getValue());return[{range:e.getFullModelRange(),text:n||""}]}}),n.completionProvider){const i=n.completionProvider(e,o);!function(e,t,r){var n;Lr.has(e)||function(e){Lr.has(e)||Lr.set(e,{functions:new T.Registry,operators:new T.Registry,suggestionKinds:new T.Registry(Jt),positionResolvers:new T.Registry(vr),macros:new T.Registry}),Lr.get(e)}(e);const o=Lr.get(e);Nr.has(t)||Nr.set(t,new T.Registry(fr(o.functions,o.operators,o.macros)));const i=Nr.get(t);if(r.supportedFunctions)for(const e of r.supportedFunctions())o.functions.getIfExists(e.id)||o.functions.register(e);if(r.supportedOperators)for(const e of r.supportedOperators())o.operators.getIfExists(e.id)||o.operators.register(xr(Ir({},e),{name:e.id}));if(r.supportedMacros)for(const e of r.supportedMacros())o.macros.getIfExists(e.id)||o.macros.register(xr(Ir({},e),{name:e.id}));if(r.customStatementPlacement)for(const e of r.customStatementPlacement()){const t=o.positionResolvers.getIfExists(e.id);if(t){const r=t.resolve;t.resolve=(...t)=>{const n=e.resolve(...t);return e.overrideDefault?n:r(...t)||n}}else o.positionResolvers.register(xr(Ir({},e),{id:e.id,name:e.id})),o.suggestionKinds.register({id:e.id,name:e.id,kind:[]})}if(r.customSuggestionKinds)for(const e of r.customSuggestionKinds()){if(null==(n=e.applyTo)||n.forEach((t=>{const r=o.suggestionKinds.getIfExists(t);r&&-1===r.kind.indexOf(e.id)&&r.kind.push(e.id)})),e.overrideDefault){const t=i.get(e.id);if(void 0!==t){t.suggestions=e.suggestionsResolver;continue}}i.register({id:e.id,name:e.id,suggestions:e.suggestionsResolver})}if(r.schemas){const e=i.get(se.Schemas),t=e.suggestions;e.suggestions=async(e,n)=>{const o=await t(e,n);if(!r.schemas)return[...o];const i=(await r.schemas.resolve()).map((e=>{var t;return{label:e.name,insertText:`${null!=(t=e.completion)?t:e.name}.`,command:or,kind:ue.Module,sortText:le.High}}));return[...o,...i]}}if(r.tables){const e=i.get(se.Tables),t=e.suggestions;e.suggestions=async(e,n)=>{var o,i,a,s,l;const u=await t(e,n),c=rr(e.currentToken),d=(null!=(i=null==(o=r.tables)?void 0:o.parseName)?i:nr)(c);return[...u,...(null!=(l=await(null==(s=null==(a=r.tables)?void 0:a.resolve)?void 0:s.call(a,d)))?l:[]).map((e=>{var t;return{label:e.name,insertText:`${null!=(t=e.completion)?t:e.name}${e.completion===e.name?" $0":""}`,insertTextRules:ce.InsertAsSnippet,command:or,kind:ue.Field,sortText:le.MediumHigh}}))]}}if(r.columns){const e=i.get(se.Columns),t=e.suggestions;e.suggestions=async(e,n)=>{var o,i,a;const s=await t(e,n),l=rr(e.currentToken);let u;const c=null!=(i=null==(o=r.tables)?void 0:o.parseName)?i:nr;l&&l.value&&(u=c(l));let d=[];if(u){const e=await(null==(a=r.columns)?void 0:a.resolve(u));d=e?e.map((e=>{var t;return{label:e.name,insertText:null!=(t=e.completion)?t:e.name,kind:ue.Field,sortText:le.High,detail:e.type,documentation:e.description}})):[]}return[...s,...d]}}}(t.id,r,i);const a=Lr.get(t.id),s=Nr.get(r),l=async(t,n,o,i)=>{const l=function(e,t,r,n="sql"){var o;let i=null,a=null;const s=e.editor.tokenize(null!=(o=t.getValue())?o:"",n);for(let o=0;o<s.length;o++){const l=s[o];if(!l.length&&a){const e={offset:0,type:ie.Whitespace,language:n,_tokenBrand:void 0};l.push(e)}for(let n=0;n<l.length;n++){const s=l[n];let u=l.length>n+1?l[n+1].offset+1:t.getLineLength(o+1)+1;const c={startLineNumber:o+1,startColumn:0===s.offset?0:s.offset+1,endLineNumber:o+1,endColumn:u},d=t.getValueInRange(c),p=new Zt(s.type,d,c,a,null);e.Range.containsPosition(c,r)&&(i=p),a&&(a.next=p),a=p}}return i}(e,t,n,r),u=function(e,t){var r;const n=null==e?void 0:e.getPreviousNonWhiteSpaceToken(),o=null==e?void 0:e.getPreviousKeyword(),i=null==(r=null==e?void 0:e.getPreviousNonWhiteSpaceToken())?void 0:r.is(ie.Operator,"/"),a=t.list(),s=[];for(const t of a)t.resolve(e,null!=o?o:null,null!=n?n:null,Boolean(i))&&s.push(t.id);return 0===s.length?[ae.Unknown]:s}(l,a.positionResolvers),c=function(e,t){let r=[];for(let n=0;n<e.length;n++){const o=t.getIfExists(e[n]);o&&(r=r.concat(o.kind))}return r}(u,a.suggestionKinds);yr("Statement position",!1,u),yr("Suggestion kinds",!1,c);const d={position:n,currentToken:l,statementPosition:u,kind:c,range:e.Range.fromPositions(n)},p=await(async(e,t,r,n,o)=>{let i=[];const a=(null==t?void 0:t.isWhiteSpace())||(null==t?void 0:t.isParenthesis())||(null==t?void 0:t.isIdentifier())&&t.value.endsWith(".")||!(null==t?void 0:t.range)?e.Range.fromPositions(n.position):null==t?void 0:t.range;for(const t of[...new Set(r)]){const r=o.getIfExists(t);if(r){const t=await r.suggestions((s=Xt({},n),l={range:a},Wt(s,zt(l))),e);i=[...i,...t.map((e=>Gt(e.label,a,Xt({kind:e.kind},e))))]}}var s,l;return Promise.resolve(i)})(e,l,c,d,s);return{suggestions:p}};e.languages.registerCompletionItemProvider(r,xr(Ir({},i),{provideCompletionItems:l}))}};function kr(e,t,r){return t in e?Object.defineProperty(e,t,{value:r,enumerable:!0,configurable:!0,writable:!0}):e[t]=r,e}function Fr({children:e,onChange:t,query:r,width:n,height:o,editorLanguageDefinition:i}){const a=(0,ye.useRef)(r);(0,ye.useEffect)((()=>{a.current=r}),[r]);const s=(0,ye.useCallback)(((e,r)=>{const n=(o=function(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{},n=Object.keys(r);"function"==typeof Object.getOwnPropertySymbols&&(n=n.concat(Object.getOwnPropertySymbols(r).filter((function(e){return Object.getOwnPropertyDescriptor(r,e).enumerable})))),n.forEach((function(t){kr(e,t,r[t])}))}return e}({},a.current),i=null!=(i={rawQuery:!0,rawSql:e})?i:{},Object.getOwnPropertyDescriptors?Object.defineProperties(o,Object.getOwnPropertyDescriptors(i)):function(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);r.push.apply(r,n)}return r}(Object(i)).forEach((function(e){Object.defineProperty(o,e,Object.getOwnPropertyDescriptor(i,e))})),o);var o,i;t(n,r)}),[t]);return(0,_.jsx)(jr,{width:n,height:o,query:r.rawSql,onChange:s,language:i,children:e})}var Dr=p(990);function Mr(e,t,r,n,o,i,a){try{var s=e[i](a),l=s.value}catch(e){return void r(e)}s.done?t(l):Promise.resolve(l).then(n,o)}function Vr(e){return function(){var t=this,r=arguments;return new Promise((function(n,o){var i=e.apply(t,r);function a(e){Mr(i,n,o,a,s,"next",e)}function s(e){Mr(i,n,o,a,s,"throw",e)}a(void 0)}))}}function Ur({db:e,query:t,onValidate:r,range:n}){var o;const[i,a]=(0,ye.useState)(),s=(0,R.useTheme2)(),l=(0,ye.useMemo)((()=>(0,T.getValueFormat)("bytes")),[]),u=(0,ye.useMemo)((()=>({error:(0,w.css)({color:s.colors.error.text,fontSize:s.typography.bodySmall.fontSize,fontFamily:s.typography.fontFamilyMonospace}),valid:(0,w.css)({color:s.colors.success.text}),info:(0,w.css)({color:s.colors.text.secondary})})),[s]),[c,d]=Oe((p=Vr((function*(t){var r;return""===(null===(r=t.rawSql)||void 0===r?void 0:r.trim())?null:yield e.validateQuery(t,n)})),function(e){return p.apply(this,arguments)}),[e]);var p;const[]=(0,Dr.A)(Vr((function*(){const e=yield d(t);return e&&a(e),null})),1e3,[t,d]);if((0,ye.useEffect)((()=>{(null==i?void 0:i.isError)&&r(!1),(null==i?void 0:i.isValid)&&r(!0)}),[i,r]),!c.value&&!c.loading)return null;const f=(null===(o=c.value)||void 0===o?void 0:o.error)?function(e){const t=e.split(":");return t.length>2?t.slice(2).join(":"):e}(c.value.error):"";return(0,_.jsxs)(_.Fragment,{children:[c.loading&&(0,_.jsxs)("div",{className:u.info,children:[(0,_.jsx)(R.Spinner,{inline:!0,size:"xs"})," Validating query..."]}),!c.loading&&c.value&&(0,_.jsxs)(_.Fragment,{children:[(0,_.jsx)(_.Fragment,{children:c.value.isValid&&c.value.statistics&&(0,_.jsxs)("div",{className:u.valid,children:[(0,_.jsx)(R.Icon,{name:"check"})," This query will process"," ",(0,_.jsx)("strong",{children:(0,T.formattedValueToString)(l(c.value.statistics.TotalBytesProcessed))})," ","when run."]})}),(0,_.jsx)(_.Fragment,{children:c.value.isError&&(0,_.jsx)("div",{className:u.error,children:f})})]})]})}function Br(e,t,r){return t in e?Object.defineProperty(e,t,{value:r,enumerable:!0,configurable:!0,writable:!0}):e[t]=r,e}function qr(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{},n=Object.keys(r);"function"==typeof Object.getOwnPropertySymbols&&(n=n.concat(Object.getOwnPropertySymbols(r).filter((function(e){return Object.getOwnPropertyDescriptor(r,e).enumerable})))),n.forEach((function(t){Br(e,t,r[t])}))}return e}function Gr(e){var{showTools:t,onFormatCode:r,onExpand:n,isExpanded:o}=e,i=function(e,t){if(null==e)return{};var r,n,o=function(e,t){if(null==e)return{};var r,n,o={},i=Object.keys(e);for(n=0;n<i.length;n++)r=i[n],t.indexOf(r)>=0||(o[r]=e[r]);return o}(e,t);if(Object.getOwnPropertySymbols){var i=Object.getOwnPropertySymbols(e);for(n=0;n<i.length;n++)r=i[n],t.indexOf(r)>=0||Object.prototype.propertyIsEnumerable.call(e,r)&&(o[r]=e[r])}return o}(e,["showTools","onFormatCode","onExpand","isExpanded"]);const a=(0,R.useTheme2)(),[s,l]=(0,ye.useState)(),u=(0,ye.useMemo)((()=>({container:(0,w.css)({border:`1px solid ${a.colors.border.medium}`,borderTop:"none",padding:a.spacing(.5,.5,.5,.5),display:"flex",flexGrow:1,justifyContent:"space-between",fontSize:a.typography.bodySmall.fontSize}),error:(0,w.css)({color:a.colors.error.text,fontSize:a.typography.bodySmall.fontSize,fontFamily:a.typography.fontFamilyMonospace}),valid:(0,w.css)({color:a.colors.success.text}),info:(0,w.css)({color:a.colors.text.secondary}),hint:(0,w.css)({color:a.colors.text.disabled,whiteSpace:"nowrap",cursor:"help"})})),[a]);let c={};return t||void 0!==s||(c={height:0,padding:0,visibility:"hidden"}),(0,_.jsxs)("div",{className:u.container,style:c,children:[(0,_.jsx)("div",{children:i.onValidate&&(0,_.jsx)(Ur,(d=qr({},i),p={onValidate:e=>{l(e),i.onValidate(e)}},p=null!=p?p:{},Object.getOwnPropertyDescriptors?Object.defineProperties(d,Object.getOwnPropertyDescriptors(p)):function(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);r.push.apply(r,n)}return r}(Object(p)).forEach((function(e){Object.defineProperty(d,e,Object.getOwnPropertyDescriptor(p,e))})),d))}),t&&(0,_.jsx)("div",{children:(0,_.jsxs)(R.HorizontalGroup,{spacing:"sm",children:[r&&(0,_.jsx)(R.IconButton,{onClick:()=>{var e;(0,pe.reportInteraction)("grafana_sql_query_formatted",{datasource:null===(e=i.query.datasource)||void 0===e?void 0:e.type}),r()},name:"brackets-curly",size:"xs",tooltip:"Format query"}),n&&(0,_.jsx)(R.IconButton,{onClick:()=>{var e;(0,pe.reportInteraction)("grafana_sql_editor_expand",{datasource:null===(e=i.query.datasource)||void 0===e?void 0:e.type,expanded:!o}),n(!o)},name:o?"angle-up":"angle-down",size:"xs",tooltip:o?"Collapse editor":"Expand editor"}),(0,_.jsx)(R.Tooltip,{content:"Hit CTRL/CMD+Return to run query",children:(0,_.jsx)(R.Icon,{className:u.hint,name:"keyboard"})})]})})]});var d,p}function Kr({db:e,query:t,onChange:r,onRunQuery:n,onValidate:o,queryToValidate:i,range:a}){const s=(0,R.useTheme2)(),l=(0,R.useStyles2)(Wr),[u,c]=(0,ye.useState)(!1),[d,p]=It(),[f,h]=It(),v=(0,ye.useMemo)((()=>e.getEditorLanguageDefinition()),[e]),g=(n,s)=>(0,_.jsx)(Fr,{editorLanguageDefinition:v,query:t,width:n,height:s?s-p.height:void 0,onChange:r,children:({formatQuery:t})=>(0,_.jsx)("div",{ref:d,children:(0,_.jsx)(Gr,{db:e,query:i,onValidate:o,onFormatCode:t,showTools:!0,range:a,onExpand:c,isExpanded:u})})}),y=(e=!1)=>e?(0,_.jsx)(Dt,{children:({width:e,height:t})=>g(e,t)}):(0,_.jsx)("div",{ref:f,children:g()});return(0,_.jsxs)(_.Fragment,{children:[u?(0,_.jsx)("div",{style:{width:h.width,height:h.height,background:s.colors.background.primary,display:"flex",alignItems:"center",justifyContent:"center"},children:"Editing in expanded code editor"}):y(),u&&(0,_.jsx)(R.Modal,{title:`Query ${t.refId}`,closeOnBackdropClick:!1,closeOnEscape:!1,className:l.modal,contentClassName:l.modalContent,isOpen:u,onDismiss:()=>{var e;(0,pe.reportInteraction)("grafana_sql_editor_expand",{datasource:null===(e=t.datasource)||void 0===e?void 0:e.type,expanded:!1}),c(!1)},children:y(!0)})]})}function Wr(e){return{modal:(0,w.css)({width:"95vw",height:"95vh"}),modalContent:(0,w.css)({height:"100%",paddingTop:0})}}const zr=({children:e})=>me().createElement(Je,{gap:.5,direction:"column"},e);var $r=p(7409);function Hr(e){return $r.Ay.format(e).replace(/(\$ \{ .* \})|(\$ __)|(\$ \w+)/g,(e=>e.replace(/\s/g,"")))}function Yr({rawSql:e,datasourceType:t}){const[r,n]=Ie(),o=(0,R.useStyles2)(Qr),i=(0,_.jsxs)("div",{className:o.labelWrapper,children:[(0,_.jsx)("span",{className:o.label,children:"Preview"}),(0,_.jsx)(R.IconButton,{tooltip:"Copy to clipboard",onClick:()=>(e=>{n(e),(0,pe.reportInteraction)("grafana_sql_preview_copied",{datasource:t})})(e),name:"copy"})]});return(0,_.jsx)(R.Field,{label:i,className:o.grow,children:(0,_.jsx)(R.CodeEditor,{language:"sql",height:80,value:Hr(e),monacoOptions:{scrollbar:{vertical:"hidden"},scrollBeyondLastLine:!1},readOnly:!0,showMiniMap:!1})})}function Qr(e){return{grow:(0,w.css)({flexGrow:1}),label:(0,w.css)({fontSize:12,fontWeight:e.typography.fontWeightMedium}),labelWrapper:(0,w.css)({display:"flex",justifyContent:"space-between",paddingBottom:e.spacing(.5)})}}function Xr(e,t,r){return t in e?Object.defineProperty(e,t,{value:r,enumerable:!0,configurable:!0,writable:!0}):e[t]=r,e}function Jr({query:e,onQueryChange:t,db:r}){const n=(0,ye.useCallback)((n=>{const o=(0,r.toRawSql)({sql:n,dataset:e.dataset,table:e.table,refId:e.refId}),i=(a=function(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{},n=Object.keys(r);"function"==typeof Object.getOwnPropertySymbols&&(n=n.concat(Object.getOwnPropertySymbols(r).filter((function(e){return Object.getOwnPropertyDescriptor(r,e).enumerable})))),n.forEach((function(t){Xr(e,t,r[t])}))}return e}({},e),s=null!=(s={sql:n,rawSql:o})?s:{},Object.getOwnPropertyDescriptors?Object.defineProperties(a,Object.getOwnPropertyDescriptors(s)):function(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);r.push.apply(r,n)}return r}(Object(s)).forEach((function(e){Object.defineProperty(a,e,Object.getOwnPropertyDescriptor(s,e))})),a);var a,s;t(i)}),[r,t,e]);return{onSqlChange:n}}const Zr=me().forwardRef((function({items:e,renderItem:t,onChange:r},n){return me().createElement(Je,null,e.map(((n,o)=>me().createElement("div",{key:o},t(n,(t=>((t,n)=>{const o=[...e];o[t]=n,r(o)})(o,t)),(()=>(t=>{const n=[...e];n.splice(t,1),r(n)})(o)))))),me().createElement(R.Button,{ref:n,onClick:()=>{const t=[...e,{}];r(t)},variant:"secondary",size:"md",icon:"plus","aria-label":"Add",type:"button"}))})),en=({children:e})=>{const t=(0,R.useStyles2)(rn),r=ye.Children.map(e,(e=>(0,ye.isValidElement)(e)&&e.props.invalid?(0,ye.cloneElement)(e,{className:(0,w.cx)(e.props.className,t.invalidChild)}):e));return me().createElement("div",{className:t.root},r)},tn=["","base","hovered","invalid","focused"],rn=()=>({root:(0,w.css)({display:"flex","> *":{"&:not(:first-child)":{marginLeft:-1},"&:first-child":{borderTopRightRadius:0,borderBottomRightRadius:0},"&:last-child":{borderTopLeftRadius:0,borderBottomLeftRadius:0},"&:not(:first-child):not(:last-child)":{borderRadius:0},position:"relative",zIndex:tn.indexOf("base"),"&:hover":{zIndex:tn.indexOf("hovered")},"&:focus-within":{zIndex:tn.indexOf("focused")}}}),invalidChild:(0,w.css)({zIndex:tn.indexOf("invalid")})});var nn=Object.defineProperty,on=Object.defineProperties,an=Object.getOwnPropertyDescriptors,sn=Object.getOwnPropertySymbols,ln=Object.prototype.hasOwnProperty,un=Object.prototype.propertyIsEnumerable,cn=(e,t,r)=>t in e?nn(e,t,{enumerable:!0,configurable:!0,writable:!0,value:r}):e[t]=r;const dn=e=>{var t=e,{className:r}=t,n=((e,t)=>{var r={};for(var n in e)ln.call(e,n)&&t.indexOf(n)<0&&(r[n]=e[n]);if(null!=e&&sn)for(var n of sn(e))t.indexOf(n)<0&&un.call(e,n)&&(r[n]=e[n]);return r})(t,["className"]);const o=(0,R.useStyles2)(pn);return me().createElement(R.Button,(i=((e,t)=>{for(var r in t||(t={}))ln.call(t,r)&&cn(e,r,t[r]);if(sn)for(var r of sn(t))un.call(t,r)&&cn(e,r,t[r]);return e})({},n),a={className:(0,w.cx)(r,o.button)},on(i,an(a))));var i,a},pn=e=>({button:(0,w.css)({paddingLeft:e.spacing(1.5),paddingRight:e.spacing(1.5)})});function fn(e,t,r){return t in e?Object.defineProperty(e,t,{value:r,enumerable:!0,configurable:!0,writable:!0}):e[t]=r,e}function hn({sql:e,columns:t,onSqlChange:r}){const n=(0,ye.useCallback)((t=>{const n=t.map((e=>{var t;return Te(null===(t=e.property)||void 0===t?void 0:t.name)})),o=(i=function(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{},n=Object.keys(r);"function"==typeof Object.getOwnPropertySymbols&&(n=n.concat(Object.getOwnPropertySymbols(r).filter((function(e){return Object.getOwnPropertyDescriptor(r,e).enumerable})))),n.forEach((function(t){fn(e,t,r[t])}))}return e}({},e),a=null!=(a={groupBy:n})?a:{},Object.getOwnPropertyDescriptors?Object.defineProperties(i,Object.getOwnPropertyDescriptors(a)):function(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);r.push.apply(r,n)}return r}(Object(a)).forEach((function(e){Object.defineProperty(i,e,Object.getOwnPropertyDescriptor(a,e))})),i);var i,a;r(o)}),[r,e]);return(0,_.jsx)(Zr,{items:e.groupBy,onChange:n,renderItem:vn({options:t})})}function vn({options:e}){return function(t,r,n){var o;return(0,_.jsxs)(en,{children:[(0,_.jsx)(R.Select,{value:(null===(o=t.property)||void 0===o?void 0:o.name)?(0,T.toOption)(t.property.name):null,"aria-label":"Group by",options:e,menuShouldPortal:!0,onChange:({value:e})=>e&&r(Te(e))}),(0,_.jsx)(dn,{title:"Remove group by column",icon:"times",variant:"secondary",onClick:n})]})}}function gn({fields:e,query:t,onQueryChange:r,db:n}){const{onSqlChange:o}=Jr({query:t,onQueryChange:r,db:n});return(0,_.jsx)(hn,{columns:e,sql:t.sql,onSqlChange:o})}function yn(e,t,r){return t in e?Object.defineProperty(e,t,{value:r,enumerable:!0,configurable:!0,writable:!0}):e[t]=r,e}function mn(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{},n=Object.keys(r);"function"==typeof Object.getOwnPropertySymbols&&(n=n.concat(Object.getOwnPropertySymbols(r).filter((function(e){return Object.getOwnPropertyDescriptor(r,e).enumerable})))),n.forEach((function(t){yn(e,t,r[t])}))}return e}function bn(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);r.push.apply(r,n)}return r}(Object(t)).forEach((function(r){Object.defineProperty(e,r,Object.getOwnPropertyDescriptor(t,r))})),e}const On=[{description:"Sort by ascending",value:"ASC",icon:"sort-amount-up"},{description:"Sort by descending",value:"DESC",icon:"sort-amount-down"}];function En({sql:e,onSqlChange:t,columns:r,showOffset:n}){var o,i;const a=(0,ye.useCallback)((r=>{const n=bn(mn({},e),{orderByDirection:r});t(n)}),[t,e]),s=(0,ye.useCallback)((r=>{const n=bn(mn({},e),{limit:Number.parseInt(r.currentTarget.value,10)});t(n)}),[t,e]),l=(0,ye.useCallback)((r=>{const n=bn(mn({},e),{offset:Number.parseInt(r.currentTarget.value,10)});t(n)}),[t,e]),u=(0,ye.useCallback)((r=>{const n=bn(mn({},e),{orderBy:(o=null==r?void 0:r.value,{type:ge.Property,property:{type:ve.String,name:o}})});var o;null===r&&(n.orderByDirection=void 0),t(n)}),[t,e]);return(0,_.jsxs)(_.Fragment,{children:[(0,_.jsx)(ut,{label:"Order by",width:25,children:(0,_.jsxs)(en,{children:[(0,_.jsx)(R.Select,{"aria-label":"Order by",options:r,value:(null===(o=e.orderBy)||void 0===o?void 0:o.property.name)?(0,T.toOption)(e.orderBy.property.name):null,isClearable:!0,menuShouldPortal:!0,onChange:u}),(0,_.jsx)(R.Space,{h:1.5}),(0,_.jsx)(R.RadioButtonGroup,{options:On,disabled:!(null==e||null===(i=e.orderBy)||void 0===i?void 0:i.property.name),value:e.orderByDirection,onChange:a})]})}),(0,_.jsx)(ut,{label:"Limit",optional:!0,width:25,children:(0,_.jsx)(R.Input,{type:"number",min:0,id:(0,fe.uniqueId)("limit-"),value:e.limit||"",onChange:s})}),n&&(0,_.jsx)(ut,{label:"Offset",optional:!0,width:25,children:(0,_.jsx)(R.Input,{type:"number",id:(0,fe.uniqueId)("offset-"),value:e.offset||"",onChange:l})})]})}function Sn({fields:e,query:t,onQueryChange:r,db:n}){const{onSqlChange:o}=Jr({query:t,onQueryChange:r,db:n});let i=[];if(e){var a,s;const r=null===(s=t.sql)||void 0===s||null===(a=s.columns)||void 0===a?void 0:a.map(((e,t)=>{var r,n;const o=e.name?`${e.name}(${null===(r=e.parameters)||void 0===r?void 0:r.map((e=>e.name))})`:null===(n=e.parameters)||void 0===n?void 0:n.map((e=>e.name));return{value:o,label:`${t+1} - ${o}`}}));i=[{value:"",label:"Selected columns",options:r,expanded:!0},...e]}return(0,_.jsx)(En,{sql:t.sql,onSqlChange:o,columns:i})}const Tn=["AVG","COUNT","MAX","MIN","SUM"],_n=["$__time","$__timeEpoch","$__timeFilter","$__timeFrom","$__timeTo","$__timeGroup","$__timeGroupAlias","$__unixEpochFilter","$__unixEpochNanoFilter","$__unixEpochNanoFrom","$__unixEpochNanoTo","$__unixEpochGroup","$__unixEpochGroupAlias"];function wn(e,t,r){return t in e?Object.defineProperty(e,t,{value:r,enumerable:!0,configurable:!0,writable:!0}):e[t]=r,e}function Rn(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{},n=Object.keys(r);"function"==typeof Object.getOwnPropertySymbols&&(n=n.concat(Object.getOwnPropertySymbols(r).filter((function(e){return Object.getOwnPropertyDescriptor(r,e).enumerable})))),n.forEach((function(t){wn(e,t,r[t])}))}return e}function An(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);r.push.apply(r,n)}return r}(Object(t)).forEach((function(r){Object.defineProperty(e,r,Object.getOwnPropertyDescriptor(t,r))})),e}const Cn={label:"*",value:"*"};function In({sql:e,format:t,columns:r,onSqlChange:n,functions:o}){var i;const a=(0,R.useStyles2)(xn),s=[Cn,...r||[]],l=[];t===S.Timeseries&&(l.push({label:"time",value:"time"}),l.push({label:"value",value:"value"}));const u=(0,ye.useCallback)(((t,r)=>o=>{var i,a;let s=Rn({},t);(null===(i=t.parameters)||void 0===i?void 0:i.length)?s.parameters=t.parameters.map((e=>e.type===ge.FunctionParameter?An(Rn({},e),{name:o.value}):e)):s.parameters=[{type:ge.FunctionParameter,name:o.value}];const l=An(Rn({},e),{columns:null===(a=e.columns)||void 0===a?void 0:a.map(((e,t)=>t===r?s:e))});n(l)}),[n,e]),c=(0,ye.useCallback)(((t,r)=>o=>{var i;const a=An(Rn({},t),{name:null==o?void 0:o.value}),s=An(Rn({},e),{columns:null===(i=e.columns)||void 0===i?void 0:i.map(((e,t)=>t===r?a:e))});n(s)}),[n,e]),d=(0,ye.useCallback)(((t,r)=>o=>{var i;let a=Rn({},t);var s;null!==o?a=An(Rn({},t),{alias:`"${null==o||null===(s=o.value)||void 0===s?void 0:s.trim()}"`}):delete a.alias;const l=An(Rn({},e),{columns:null===(i=e.columns)||void 0===i?void 0:i.map(((e,t)=>t===r?a:e))});n(l)}),[n,e]),p=(0,ye.useCallback)((t=>()=>{const r=[...e.columns];r.splice(t,1);const o=An(Rn({},e),{columns:r});n(o)}),[n,e]),f=(0,ye.useCallback)((()=>{const t=An(Rn({},e),{columns:[...e.columns,_e()]});n(t)}),[n,e]);return(0,_.jsxs)(Je,{gap:2,wrap:!0,direction:"column",children:[null===(i=e.columns)||void 0===i?void 0:i.map(((e,t)=>(0,_.jsx)("div",{children:(0,_.jsxs)(Je,{gap:2,alignItems:"end",children:[(0,_.jsx)(ut,{label:"Column",width:25,children:(0,_.jsx)(R.Select,{value:Ln(e),"data-testid":Le.components.SQLQueryEditor.selectColumn,options:s,inputId:`select-column-${t}-${(0,fe.uniqueId)()}`,menuShouldPortal:!0,allowCustomValue:!0,onChange:u(e,t)})}),(0,_.jsx)(ut,{label:"Aggregation",optional:!0,width:25,children:(0,_.jsx)(R.Select,{value:e.name?(0,T.toOption)(e.name):null,inputId:`select-aggregation-${t}-${(0,fe.uniqueId)()}`,"data-testid":Le.components.SQLQueryEditor.selectAggregation,isClearable:!0,menuShouldPortal:!0,allowCustomValue:!0,options:o,onChange:c(e,t)})}),(0,_.jsx)(ut,{label:"Alias",optional:!0,width:15,children:(0,_.jsx)(R.Select,{value:e.alias?(0,T.toOption)(e.alias):null,inputId:`select-alias-${t}-${(0,fe.uniqueId)()}`,"data-testid":Le.components.SQLQueryEditor.selectAlias,options:l,onChange:d(e,t),isClearable:!0,menuShouldPortal:!0,allowCustomValue:!0})}),(0,_.jsx)(R.Button,{title:"Remove column",type:"button",icon:"trash-alt",variant:"secondary",size:"md",onClick:p(t)})]})},t))),(0,_.jsx)(R.Button,{type:"button",onClick:f,variant:"secondary",title:"Add column",size:"md",icon:"plus",className:a.addButton})]})}const xn=()=>({addButton:(0,w.css)({alignSelf:"flex-start"})});function Ln({parameters:e}){const t=null==e?void 0:e.find((e=>e.type===ge.FunctionParameter));return(null==t?void 0:t.name)?(0,T.toOption)(t.name):null}function Nn({fields:e,query:t,onQueryChange:r,db:n}){var o;const{onSqlChange:i}=Jr({query:t,onQueryChange:r,db:n}),a=[...Tn,...(null===(o=n.functions)||void 0===o?void 0:o.call(n))||[]].map(T.toOption);return(0,_.jsx)(In,{columns:e,sql:t.sql,format:t.format,functions:a,onSqlChange:i})}var jn=p(1777);function Pn(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}function kn(e){return kn="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(e){return typeof e}:function(e){return e&&"function"==typeof Symbol&&e.constructor===Symbol&&e!==Symbol.prototype?"symbol":typeof e},kn(e)}function Fn(e){var t=function(e,t){if("object"!=kn(e)||!e)return e;var r=e[Symbol.toPrimitive];if(void 0!==r){var n=r.call(e,"string");if("object"!=kn(n))return n;throw new TypeError("@@toPrimitive must return a primitive value.")}return String(e)}(e);return"symbol"==kn(t)?t:t+""}function Dn(e,t){for(var r=0;r<t.length;r++){var n=t[r];n.enumerable=n.enumerable||!1,n.configurable=!0,"value"in n&&(n.writable=!0),Object.defineProperty(e,Fn(n.key),n)}}function Mn(e,t,r){return t&&Dn(e.prototype,t),r&&Dn(e,r),Object.defineProperty(e,"prototype",{writable:!1}),e}function Vn(e,t){if(t&&("object"==kn(t)||"function"==typeof t))return t;if(void 0!==t)throw new TypeError("Derived constructors may only return object or undefined");return function(e){if(void 0===e)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return e}(e)}function Un(e){return Un=Object.setPrototypeOf?Object.getPrototypeOf.bind():function(e){return e.__proto__||Object.getPrototypeOf(e)},Un(e)}function Bn(e,t){return Bn=Object.setPrototypeOf?Object.setPrototypeOf.bind():function(e,t){return e.__proto__=t,e},Bn(e,t)}function qn(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Super expression must either be null or a function");e.prototype=Object.create(t&&t.prototype,{constructor:{value:e,writable:!0,configurable:!0}}),Object.defineProperty(e,"prototype",{writable:!1}),t&&Bn(e,t)}function Gn(e,t,r){return(t=Fn(t))in e?Object.defineProperty(e,t,{value:r,enumerable:!0,configurable:!0,writable:!0}):e[t]=r,e}function Kn(e){if(Array.isArray(e))return e}function Wn(e,t){(null==t||t>e.length)&&(t=e.length);for(var r=0,n=Array(t);r<t;r++)n[r]=e[r];return n}function zn(e,t){if(e){if("string"==typeof e)return Wn(e,t);var r={}.toString.call(e).slice(8,-1);return"Object"===r&&e.constructor&&(r=e.constructor.name),"Map"===r||"Set"===r?Array.from(e):"Arguments"===r||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(r)?Wn(e,t):void 0}}function $n(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}function Hn(e,t){return Kn(e)||function(e,t){var r=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=r){var n,o,i,a,s=[],l=!0,u=!1;try{if(i=(r=r.call(e)).next,0===t){if(Object(r)!==r)return;l=!1}else for(;!(l=(n=i.call(r)).done)&&(s.push(n.value),s.length!==t);l=!0);}catch(e){u=!0,o=e}finally{try{if(!l&&null!=r.return&&(a=r.return(),Object(a)!==a))return}finally{if(u)throw o}}return s}}(e,t)||zn(e,t)||$n()}function Yn(e){if("undefined"!=typeof Symbol&&null!=e[Symbol.iterator]||null!=e["@@iterator"])return Array.from(e)}function Qn(e){return function(e){if(Array.isArray(e))return Wn(e)}(e)||Yn(e)||zn(e)||function(){throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}var Xn="delete",Jn=5,Zn=1<<Jn,eo=Zn-1,to={};function ro(e){e&&(e.value=!0)}function no(){}function oo(e){return void 0===e.size&&(e.size=e.__iterate(ao)),e.size}function io(e,t){if("number"!=typeof t){var r=t>>>0;if(""+r!==t||4294967295===r)return NaN;t=r}return t<0?oo(e)+t:t}function ao(){return!0}function so(e,t,r){return(0===e&&!po(e)||void 0!==r&&e<=-r)&&(void 0===t||void 0!==r&&t>=r)}function lo(e,t){return co(e,t,0)}function uo(e,t){return co(e,t,t)}function co(e,t,r){return void 0===e?r:po(e)?t===1/0?t:0|Math.max(0,t+e):void 0===t||t===e?e:0|Math.min(t,e)}function po(e){return e<0||0===e&&1/e==-1/0}var fo="@@__IMMUTABLE_ITERABLE__@@";function ho(e){return Boolean(e&&e[fo])}var vo="@@__IMMUTABLE_KEYED__@@";function go(e){return Boolean(e&&e[vo])}var yo="@@__IMMUTABLE_INDEXED__@@";function mo(e){return Boolean(e&&e[yo])}function bo(e){return go(e)||mo(e)}var Oo=function(e){return ho(e)?e:zo(e)},Eo=function(e){function t(e){return go(e)?e:$o(e)}return e&&(t.__proto__=e),t.prototype=Object.create(e&&e.prototype),t.prototype.constructor=t,t}(Oo),So=function(e){function t(e){return mo(e)?e:Ho(e)}return e&&(t.__proto__=e),t.prototype=Object.create(e&&e.prototype),t.prototype.constructor=t,t}(Oo),To=function(e){function t(e){return ho(e)&&!bo(e)?e:Yo(e)}return e&&(t.__proto__=e),t.prototype=Object.create(e&&e.prototype),t.prototype.constructor=t,t}(Oo);Oo.Keyed=Eo,Oo.Indexed=So,Oo.Set=To;var _o="@@__IMMUTABLE_SEQ__@@";function wo(e){return Boolean(e&&e[_o])}var Ro="@@__IMMUTABLE_RECORD__@@";function Ao(e){return Boolean(e&&e[Ro])}function Co(e){return ho(e)||Ao(e)}var Io="@@__IMMUTABLE_ORDERED__@@";function xo(e){return Boolean(e&&e[Io])}var Lo=0,No=1,jo=2,Po="function"==typeof Symbol&&Symbol.iterator,ko="@@iterator",Fo=Po||ko,Do=function(e){this.next=e};function Mo(e,t,r,n){var o=0===e?t:1===e?r:[t,r];return n?n.value=o:n={value:o,done:!1},n}function Vo(){return{value:void 0,done:!0}}function Uo(e){return!!Array.isArray(e)||!!Go(e)}function Bo(e){return e&&"function"==typeof e.next}function qo(e){var t=Go(e);return t&&t.call(e)}function Go(e){var t=e&&(Po&&e[Po]||e[ko]);if("function"==typeof t)return t}Do.prototype.toString=function(){return"[Iterator]"},Do.KEYS=Lo,Do.VALUES=No,Do.ENTRIES=jo,Do.prototype.inspect=Do.prototype.toSource=function(){return this.toString()},Do.prototype[Fo]=function(){return this};var Ko=Object.prototype.hasOwnProperty;function Wo(e){return!(!Array.isArray(e)&&"string"!=typeof e)||e&&"object"==typeof e&&Number.isInteger(e.length)&&e.length>=0&&(0===e.length?1===Object.keys(e).length:e.hasOwnProperty(e.length-1))}var zo=function(e){function t(e){return null==e?ei():Co(e)?e.toSeq():function(e){var t,r,n=ni(e);if(n)return(r=Go(t=e))&&r===t.entries?n.fromEntrySeq():function(e){var t=Go(e);return t&&t===e.keys}(e)?n.toSetSeq():n;if("object"==typeof e)return new Xo(e);throw new TypeError("Expected Array or collection object of values, or keyed object: "+e)}(e)}return e&&(t.__proto__=e),t.prototype=Object.create(e&&e.prototype),t.prototype.constructor=t,t.prototype.toSeq=function(){return this},t.prototype.toString=function(){return this.__toString("Seq {","}")},t.prototype.cacheResult=function(){return!this._cache&&this.__iterateUncached&&(this._cache=this.entrySeq().toArray(),this.size=this._cache.length),this},t.prototype.__iterate=function(e,t){var r=this._cache;if(r){for(var n=r.length,o=0;o!==n;){var i=r[t?n-++o:o++];if(!1===e(i[1],i[0],this))break}return o}return this.__iterateUncached(e,t)},t.prototype.__iterator=function(e,t){var r=this._cache;if(r){var n=r.length,o=0;return new Do((function(){if(o===n)return{value:void 0,done:!0};var i=r[t?n-++o:o++];return Mo(e,i[0],i[1])}))}return this.__iteratorUncached(e,t)},t}(Oo),$o=function(e){function t(e){return null==e?ei().toKeyedSeq():ho(e)?go(e)?e.toSeq():e.fromEntrySeq():Ao(e)?e.toSeq():ti(e)}return e&&(t.__proto__=e),t.prototype=Object.create(e&&e.prototype),t.prototype.constructor=t,t.prototype.toKeyedSeq=function(){return this},t}(zo),Ho=function(e){function t(e){return null==e?ei():ho(e)?go(e)?e.entrySeq():e.toIndexedSeq():Ao(e)?e.toSeq().entrySeq():ri(e)}return e&&(t.__proto__=e),t.prototype=Object.create(e&&e.prototype),t.prototype.constructor=t,t.of=function(){return t(arguments)},t.prototype.toIndexedSeq=function(){return this},t.prototype.toString=function(){return this.__toString("Seq [","]")},t}(zo),Yo=function(e){function t(e){return(ho(e)&&!bo(e)?e:Ho(e)).toSetSeq()}return e&&(t.__proto__=e),t.prototype=Object.create(e&&e.prototype),t.prototype.constructor=t,t.of=function(){return t(arguments)},t.prototype.toSetSeq=function(){return this},t}(zo);zo.isSeq=wo,zo.Keyed=$o,zo.Set=Yo,zo.Indexed=Ho,zo.prototype[_o]=!0;var Qo=function(e){function t(e){this._array=e,this.size=e.length}return e&&(t.__proto__=e),t.prototype=Object.create(e&&e.prototype),t.prototype.constructor=t,t.prototype.get=function(e,t){return this.has(e)?this._array[io(this,e)]:t},t.prototype.__iterate=function(e,t){for(var r=this._array,n=r.length,o=0;o!==n;){var i=t?n-++o:o++;if(!1===e(r[i],i,this))break}return o},t.prototype.__iterator=function(e,t){var r=this._array,n=r.length,o=0;return new Do((function(){if(o===n)return{value:void 0,done:!0};var i=t?n-++o:o++;return Mo(e,i,r[i])}))},t}(Ho),Xo=function(e){function t(e){var t=Object.keys(e).concat(Object.getOwnPropertySymbols?Object.getOwnPropertySymbols(e):[]);this._object=e,this._keys=t,this.size=t.length}return e&&(t.__proto__=e),t.prototype=Object.create(e&&e.prototype),t.prototype.constructor=t,t.prototype.get=function(e,t){return void 0===t||this.has(e)?this._object[e]:t},t.prototype.has=function(e){return Ko.call(this._object,e)},t.prototype.__iterate=function(e,t){for(var r=this._object,n=this._keys,o=n.length,i=0;i!==o;){var a=n[t?o-++i:i++];if(!1===e(r[a],a,this))break}return i},t.prototype.__iterator=function(e,t){var r=this._object,n=this._keys,o=n.length,i=0;return new Do((function(){if(i===o)return{value:void 0,done:!0};var a=n[t?o-++i:i++];return Mo(e,a,r[a])}))},t}($o);Xo.prototype[Io]=!0;var Jo,Zo=function(e){function t(e){this._collection=e,this.size=e.length||e.size}return e&&(t.__proto__=e),t.prototype=Object.create(e&&e.prototype),t.prototype.constructor=t,t.prototype.__iterateUncached=function(e,t){if(t)return this.cacheResult().__iterate(e,t);var r=qo(this._collection),n=0;if(Bo(r))for(var o;!(o=r.next()).done&&!1!==e(o.value,n++,this););return n},t.prototype.__iteratorUncached=function(e,t){if(t)return this.cacheResult().__iterator(e,t);var r=qo(this._collection);if(!Bo(r))return new Do(Vo);var n=0;return new Do((function(){var t=r.next();return t.done?t:Mo(e,n++,t.value)}))},t}(Ho);function ei(){return Jo||(Jo=new Qo([]))}function ti(e){var t=ni(e);if(t)return t.fromEntrySeq();if("object"==typeof e)return new Xo(e);throw new TypeError("Expected Array or collection object of [k, v] entries, or keyed object: "+e)}function ri(e){var t=ni(e);if(t)return t;throw new TypeError("Expected Array or collection object of values: "+e)}function ni(e){return Wo(e)?new Qo(e):Uo(e)?new Zo(e):void 0}var oi="@@__IMMUTABLE_MAP__@@";function ii(e){return Boolean(e&&e[oi])}function ai(e){return ii(e)&&xo(e)}function si(e){return Boolean(e&&"function"==typeof e.equals&&"function"==typeof e.hashCode)}function li(e,t){if(e===t||e!=e&&t!=t)return!0;if(!e||!t)return!1;if("function"==typeof e.valueOf&&"function"==typeof t.valueOf){if((e=e.valueOf())===(t=t.valueOf())||e!=e&&t!=t)return!0;if(!e||!t)return!1}return!!(si(e)&&si(t)&&e.equals(t))}var ui="function"==typeof Math.imul&&-2===Math.imul(4294967295,2)?Math.imul:function(e,t){var r=65535&(e|=0),n=65535&(t|=0);return r*n+((e>>>16)*n+r*(t>>>16)<<16>>>0)|0};function ci(e){return e>>>1&1073741824|3221225471&e}var di=Object.prototype.valueOf;function pi(e){if(null==e)return fi(e);if("function"==typeof e.hashCode)return ci(e.hashCode(e));var t,r,n,o=(t=e).valueOf!==di&&"function"==typeof t.valueOf?t.valueOf(t):t;if(null==o)return fi(o);switch(typeof o){case"boolean":return o?1108378657:1108378656;case"number":return function(e){if(e!=e||e===1/0)return 0;var t=0|e;for(t!==e&&(t^=4294967295*e);e>4294967295;)t^=e/=4294967295;return ci(t)}(o);case"string":return o.length>Ti?(void 0===(n=Ri[r=o])&&(n=hi(r),wi===_i&&(wi=0,Ri={}),wi++,Ri[r]=n),n):hi(o);case"object":case"function":return function(e){var t;if(bi&&void 0!==(t=mi.get(e)))return t;if(void 0!==(t=e[Si]))return t;if(!gi){if(void 0!==(t=e.propertyIsEnumerable&&e.propertyIsEnumerable[Si]))return t;if(void 0!==(t=function(e){if(e&&e.nodeType>0)switch(e.nodeType){case 1:return e.uniqueID;case 9:return e.documentElement&&e.documentElement.uniqueID}}(e)))return t}if(t=yi(),bi)mi.set(e,t);else{if(void 0!==vi&&!1===vi(e))throw new Error("Non-extensible objects are not allowed as keys.");if(gi)Object.defineProperty(e,Si,{enumerable:!1,configurable:!1,writable:!1,value:t});else if(void 0!==e.propertyIsEnumerable&&e.propertyIsEnumerable===e.constructor.prototype.propertyIsEnumerable)e.propertyIsEnumerable=function(){return this.constructor.prototype.propertyIsEnumerable.apply(this,arguments)},e.propertyIsEnumerable[Si]=t;else{if(void 0===e.nodeType)throw new Error("Unable to set a non-enumerable property on object.");e[Si]=t}}return t}(o);case"symbol":return function(e){var t=Oi[e];return void 0!==t||(t=yi(),Oi[e]=t),t}(o);default:if("function"==typeof o.toString)return hi(o.toString());throw new Error("Value type "+typeof o+" cannot be hashed.")}}function fi(e){return null===e?1108378658:1108378659}function hi(e){for(var t=0,r=0;r<e.length;r++)t=31*t+e.charCodeAt(r)|0;return ci(t)}var vi=Object.isExtensible,gi=function(){try{return Object.defineProperty({},"@",{}),!0}catch(e){return!1}}();function yi(){var e=++Ei;return 1073741824&Ei&&(Ei=0),e}var mi,bi="function"==typeof WeakMap;bi&&(mi=new WeakMap);var Oi=Object.create(null),Ei=0,Si="__immutablehash__";"function"==typeof Symbol&&(Si=Symbol(Si));var Ti=16,_i=255,wi=0,Ri={},Ai=function(e){function t(e,t){this._iter=e,this._useKeys=t,this.size=e.size}return e&&(t.__proto__=e),t.prototype=Object.create(e&&e.prototype),t.prototype.constructor=t,t.prototype.get=function(e,t){return this._iter.get(e,t)},t.prototype.has=function(e){return this._iter.has(e)},t.prototype.valueSeq=function(){return this._iter.valueSeq()},t.prototype.reverse=function(){var e=this,t=ji(this,!0);return this._useKeys||(t.valueSeq=function(){return e._iter.toSeq().reverse()}),t},t.prototype.map=function(e,t){var r=this,n=Ni(this,e,t);return this._useKeys||(n.valueSeq=function(){return r._iter.toSeq().map(e,t)}),n},t.prototype.__iterate=function(e,t){var r=this;return this._iter.__iterate((function(t,n){return e(t,n,r)}),t)},t.prototype.__iterator=function(e,t){return this._iter.__iterator(e,t)},t}($o);Ai.prototype[Io]=!0;var Ci=function(e){function t(e){this._iter=e,this.size=e.size}return e&&(t.__proto__=e),t.prototype=Object.create(e&&e.prototype),t.prototype.constructor=t,t.prototype.includes=function(e){return this._iter.includes(e)},t.prototype.__iterate=function(e,t){var r=this,n=0;return t&&oo(this),this._iter.__iterate((function(o){return e(o,t?r.size-++n:n++,r)}),t)},t.prototype.__iterator=function(e,t){var r=this,n=this._iter.__iterator(No,t),o=0;return t&&oo(this),new Do((function(){var i=n.next();return i.done?i:Mo(e,t?r.size-++o:o++,i.value,i)}))},t}(Ho),Ii=function(e){function t(e){this._iter=e,this.size=e.size}return e&&(t.__proto__=e),t.prototype=Object.create(e&&e.prototype),t.prototype.constructor=t,t.prototype.has=function(e){return this._iter.includes(e)},t.prototype.__iterate=function(e,t){var r=this;return this._iter.__iterate((function(t){return e(t,t,r)}),t)},t.prototype.__iterator=function(e,t){var r=this._iter.__iterator(No,t);return new Do((function(){var t=r.next();return t.done?t:Mo(e,t.value,t.value,t)}))},t}(Yo),xi=function(e){function t(e){this._iter=e,this.size=e.size}return e&&(t.__proto__=e),t.prototype=Object.create(e&&e.prototype),t.prototype.constructor=t,t.prototype.entrySeq=function(){return this._iter.toSeq()},t.prototype.__iterate=function(e,t){var r=this;return this._iter.__iterate((function(t){if(t){Gi(t);var n=ho(t);return e(n?t.get(1):t[1],n?t.get(0):t[0],r)}}),t)},t.prototype.__iterator=function(e,t){var r=this._iter.__iterator(No,t);return new Do((function(){for(;;){var t=r.next();if(t.done)return t;var n=t.value;if(n){Gi(n);var o=ho(n);return Mo(e,o?n.get(0):n[0],o?n.get(1):n[1],t)}}}))},t}($o);function Li(e){var t=Wi(e);return t._iter=e,t.size=e.size,t.flip=function(){return e},t.reverse=function(){var t=e.reverse.apply(this);return t.flip=function(){return e.reverse()},t},t.has=function(t){return e.includes(t)},t.includes=function(t){return e.has(t)},t.cacheResult=zi,t.__iterateUncached=function(t,r){var n=this;return e.__iterate((function(e,r){return!1!==t(r,e,n)}),r)},t.__iteratorUncached=function(t,r){if(t===jo){var n=e.__iterator(t,r);return new Do((function(){var e=n.next();if(!e.done){var t=e.value[0];e.value[0]=e.value[1],e.value[1]=t}return e}))}return e.__iterator(t===No?Lo:No,r)},t}function Ni(e,t,r){var n=Wi(e);return n.size=e.size,n.has=function(t){return e.has(t)},n.get=function(n,o){var i=e.get(n,to);return i===to?o:t.call(r,i,n,e)},n.__iterateUncached=function(n,o){var i=this;return e.__iterate((function(e,o,a){return!1!==n(t.call(r,e,o,a),o,i)}),o)},n.__iteratorUncached=function(n,o){var i=e.__iterator(jo,o);return new Do((function(){var o=i.next();if(o.done)return o;var a=o.value,s=a[0];return Mo(n,s,t.call(r,a[1],s,e),o)}))},n}function ji(e,t){var r=this,n=Wi(e);return n._iter=e,n.size=e.size,n.reverse=function(){return e},e.flip&&(n.flip=function(){var t=Li(e);return t.reverse=function(){return e.flip()},t}),n.get=function(r,n){return e.get(t?r:-1-r,n)},n.has=function(r){return e.has(t?r:-1-r)},n.includes=function(t){return e.includes(t)},n.cacheResult=zi,n.__iterate=function(r,n){var o=this,i=0;return n&&oo(e),e.__iterate((function(e,a){return r(e,t?a:n?o.size-++i:i++,o)}),!n)},n.__iterator=function(n,o){var i=0;o&&oo(e);var a=e.__iterator(jo,!o);return new Do((function(){var e=a.next();if(e.done)return e;var s=e.value;return Mo(n,t?s[0]:o?r.size-++i:i++,s[1],e)}))},n}function Pi(e,t,r,n){var o=Wi(e);return n&&(o.has=function(n){var o=e.get(n,to);return o!==to&&!!t.call(r,o,n,e)},o.get=function(n,o){var i=e.get(n,to);return i!==to&&t.call(r,i,n,e)?i:o}),o.__iterateUncached=function(o,i){var a=this,s=0;return e.__iterate((function(e,i,l){if(t.call(r,e,i,l))return s++,o(e,n?i:s-1,a)}),i),s},o.__iteratorUncached=function(o,i){var a=e.__iterator(jo,i),s=0;return new Do((function(){for(;;){var i=a.next();if(i.done)return i;var l=i.value,u=l[0],c=l[1];if(t.call(r,c,u,e))return Mo(o,n?u:s++,c,i)}}))},o}function ki(e,t,r,n){var o=e.size;if(so(t,r,o))return e;if(void 0===o&&(t<0||r<0))return ki(e.toSeq().cacheResult(),t,r,n);var i,a=lo(t,o),s=uo(r,o)-a;s==s&&(i=s<0?0:s);var l=Wi(e);return l.size=0===i?i:e.size&&i||void 0,!n&&wo(e)&&i>=0&&(l.get=function(t,r){return(t=io(this,t))>=0&&t<i?e.get(t+a,r):r}),l.__iterateUncached=function(t,r){var o=this;if(0===i)return 0;if(r)return this.cacheResult().__iterate(t,r);var s=0,l=!0,u=0;return e.__iterate((function(e,r){if(!l||!(l=s++<a))return u++,!1!==t(e,n?r:u-1,o)&&u!==i})),u},l.__iteratorUncached=function(t,r){if(0!==i&&r)return this.cacheResult().__iterator(t,r);if(0===i)return new Do(Vo);var o=e.__iterator(t,r),s=0,l=0;return new Do((function(){for(;s++<a;)o.next();if(++l>i)return{value:void 0,done:!0};var e=o.next();return n||t===No||e.done?e:Mo(t,l-1,t===Lo?void 0:e.value[1],e)}))},l}function Fi(e,t,r,n){var o=Wi(e);return o.__iterateUncached=function(o,i){var a=this;if(i)return this.cacheResult().__iterate(o,i);var s=!0,l=0;return e.__iterate((function(e,i,u){if(!s||!(s=t.call(r,e,i,u)))return l++,o(e,n?i:l-1,a)})),l},o.__iteratorUncached=function(o,i){var a=this;if(i)return this.cacheResult().__iterator(o,i);var s=e.__iterator(jo,i),l=!0,u=0;return new Do((function(){var e,i,c;do{if((e=s.next()).done)return n||o===No?e:Mo(o,u++,o===Lo?void 0:e.value[1],e);var d=e.value;i=d[0],c=d[1],l&&(l=t.call(r,c,i,a))}while(l);return o===jo?e:Mo(o,i,c,e)}))},o}function Di(e,t,r){var n=Wi(e);return n.__iterateUncached=function(o,i){if(i)return this.cacheResult().__iterate(o,i);var a=0,s=!1;return function e(l,u){l.__iterate((function(i,l){return(!t||u<t)&&ho(i)?e(i,u+1):(a++,!1===o(i,r?l:a-1,n)&&(s=!0)),!s}),i)}(e,0),a},n.__iteratorUncached=function(n,o){if(o)return this.cacheResult().__iterator(n,o);var i=e.__iterator(n,o),a=[],s=0;return new Do((function(){for(;i;){var e=i.next();if(!1===e.done){var l=e.value;if(n===jo&&(l=l[1]),t&&!(a.length<t)||!ho(l))return r?e:Mo(n,s++,l,e);a.push(i),i=l.__iterator(n,o)}else i=a.pop()}return{value:void 0,done:!0}}))},n}function Mi(e,t,r){t||(t=$i);var n=go(e),o=0,i=e.toSeq().map((function(t,n){return[n,t,o++,r?r(t,n,e):t]})).valueSeq().toArray();return i.sort((function(e,r){return t(e[3],r[3])||e[2]-r[2]})).forEach(n?function(e,t){i[t].length=2}:function(e,t){i[t]=e[1]}),n?$o(i):mo(e)?Ho(i):Yo(i)}function Vi(e,t,r){if(t||(t=$i),r){var n=e.toSeq().map((function(t,n){return[t,r(t,n,e)]})).reduce((function(e,r){return Ui(t,e[1],r[1])?r:e}));return n&&n[0]}return e.reduce((function(e,r){return Ui(t,e,r)?r:e}))}function Ui(e,t,r){var n=e(r,t);return 0===n&&r!==t&&(null==r||r!=r)||n>0}function Bi(e,t,r,n){var o=Wi(e),i=new Qo(r).map((function(e){return e.size}));return o.size=n?i.max():i.min(),o.__iterate=function(e,t){for(var r,n=this.__iterator(No,t),o=0;!(r=n.next()).done&&!1!==e(r.value,o++,this););return o},o.__iteratorUncached=function(e,o){var i=r.map((function(e){return e=Oo(e),qo(o?e.reverse():e)})),a=0,s=!1;return new Do((function(){var r;return s||(r=i.map((function(e){return e.next()})),s=n?r.every((function(e){return e.done})):r.some((function(e){return e.done}))),s?{value:void 0,done:!0}:Mo(e,a++,t.apply(null,r.map((function(e){return e.value}))))}))},o}function qi(e,t){return e===t?e:wo(e)?t:e.constructor(t)}function Gi(e){if(e!==Object(e))throw new TypeError("Expected [K, V] tuple: "+e)}function Ki(e){return go(e)?Eo:mo(e)?So:To}function Wi(e){return Object.create((go(e)?$o:mo(e)?Ho:Yo).prototype)}function zi(){return this._iter.cacheResult?(this._iter.cacheResult(),this.size=this._iter.size,this):zo.prototype.cacheResult.call(this)}function $i(e,t){return void 0===e&&void 0===t?0:void 0===e?1:void 0===t?-1:e>t?1:e<t?-1:0}function Hi(e,t){t=t||0;for(var r=Math.max(0,e.length-t),n=new Array(r),o=0;o<r;o++)n[o]=e[o+t];return n}function Yi(e,t){if(!e)throw new Error(t)}function Qi(e){Yi(e!==1/0,"Cannot perform this action with an infinite size.")}function Xi(e){if(Wo(e)&&"string"!=typeof e)return e;if(xo(e))return e.toArray();throw new TypeError("Invalid keyPath: expected Ordered Collection or Array: "+e)}Ci.prototype.cacheResult=Ai.prototype.cacheResult=Ii.prototype.cacheResult=xi.prototype.cacheResult=zi;var Ji=Object.prototype.toString;function Zi(e){if(!e||"object"!=typeof e||"[object Object]"!==Ji.call(e))return!1;var t=Object.getPrototypeOf(e);if(null===t)return!0;for(var r=t,n=Object.getPrototypeOf(t);null!==n;)r=n,n=Object.getPrototypeOf(r);return r===t}function ea(e){return"object"==typeof e&&(Co(e)||Array.isArray(e)||Zi(e))}function ta(e){try{return"string"==typeof e?JSON.stringify(e):String(e)}catch(t){return JSON.stringify(e)}}function ra(e,t){return Co(e)?e.has(t):ea(e)&&Ko.call(e,t)}function na(e,t,r){return Co(e)?e.get(t,r):ra(e,t)?"function"==typeof e.get?e.get(t):e[t]:r}function oa(e){if(Array.isArray(e))return Hi(e);var t={};for(var r in e)Ko.call(e,r)&&(t[r]=e[r]);return t}function ia(e,t){if(!ea(e))throw new TypeError("Cannot update non-data-structure value: "+e);if(Co(e)){if(!e.remove)throw new TypeError("Cannot update immutable value without .remove() method: "+e);return e.remove(t)}if(!Ko.call(e,t))return e;var r=oa(e);return Array.isArray(r)?r.splice(t,1):delete r[t],r}function aa(e,t,r){if(!ea(e))throw new TypeError("Cannot update non-data-structure value: "+e);if(Co(e)){if(!e.set)throw new TypeError("Cannot update immutable value without .set() method: "+e);return e.set(t,r)}if(Ko.call(e,t)&&r===e[t])return e;var n=oa(e);return n[t]=r,n}function sa(e,t,r,n){n||(n=r,r=void 0);var o=la(Co(e),e,Xi(t),0,r,n);return o===to?r:o}function la(e,t,r,n,o,i){var a=t===to;if(n===r.length){var s=a?o:t,l=i(s);return l===s?t:l}if(!a&&!ea(t))throw new TypeError("Cannot update within non-data-structure value in path ["+r.slice(0,n).map(ta)+"]: "+t);var u=r[n],c=a?to:na(t,u,to),d=la(c===to?e:Co(c),c,r,n+1,o,i);return d===c?t:d===to?ia(t,u):aa(a?e?Ba():{}:t,u,d)}function ua(e,t,r){return sa(e,t,to,(function(){return r}))}function ca(e,t){return ua(this,e,t)}function da(e,t){return sa(e,t,(function(){return to}))}function pa(e){return da(this,e)}function fa(e,t,r,n){return sa(e,[t],r,n)}function ha(e,t,r){return 1===arguments.length?e(this):fa(this,e,t,r)}function va(e,t,r){return sa(this,e,t,r)}function ga(){for(var e=[],t=arguments.length;t--;)e[t]=arguments[t];return ma(this,e)}function ya(e){for(var t=[],r=arguments.length-1;r-- >0;)t[r]=arguments[r+1];if("function"!=typeof e)throw new TypeError("Invalid merger function: "+e);return ma(this,t,e)}function ma(e,t,r){for(var n=[],o=0;o<t.length;o++){var i=Eo(t[o]);0!==i.size&&n.push(i)}return 0===n.length?e:0!==e.toSeq().size||e.__ownerID||1!==n.length?e.withMutations((function(e){for(var t=r?function(t,n){fa(e,n,to,(function(e){return e===to?t:r(e,t,n)}))}:function(t,r){e.set(r,t)},o=0;o<n.length;o++)n[o].forEach(t)})):e.constructor(n[0])}function ba(e,t,r){return Oa(e,t,function(e){return function t(r,n,o){return ea(r)&&ea(n)&&(i=n,a=zo(r),s=zo(i),mo(a)===mo(s)&&go(a)===go(s))?Oa(r,[n],t):e?e(r,n,o):n;var i,a,s}}(r))}function Oa(e,t,r){if(!ea(e))throw new TypeError("Cannot merge into non-data-structure value: "+e);if(Co(e))return"function"==typeof r&&e.mergeWith?e.mergeWith.apply(e,[r].concat(t)):e.merge?e.merge.apply(e,t):e.concat.apply(e,t);for(var n=Array.isArray(e),o=e,i=n?So:Eo,a=n?function(t){o===e&&(o=oa(o)),o.push(t)}:function(t,n){var i=Ko.call(o,n),a=i&&r?r(o[n],t,n):t;i&&a===o[n]||(o===e&&(o=oa(o)),o[n]=a)},s=0;s<t.length;s++)i(t[s]).forEach(a);return o}function Ea(){for(var e=[],t=arguments.length;t--;)e[t]=arguments[t];return ba(this,e)}function Sa(e){for(var t=[],r=arguments.length-1;r-- >0;)t[r]=arguments[r+1];return ba(this,t,e)}function Ta(e){for(var t=[],r=arguments.length-1;r-- >0;)t[r]=arguments[r+1];return sa(this,e,Ba(),(function(e){return Oa(e,t)}))}function _a(e){for(var t=[],r=arguments.length-1;r-- >0;)t[r]=arguments[r+1];return sa(this,e,Ba(),(function(e){return ba(e,t)}))}function wa(e){var t=this.asMutable();return e(t),t.wasAltered()?t.__ensureOwner(this.__ownerID):this}function Ra(){return this.__ownerID?this:this.__ensureOwner(new no)}function Aa(){return this.__ensureOwner()}function Ca(){return this.__altered}var Ia=function(e){function t(t){return null==t?Ba():ii(t)&&!xo(t)?t:Ba().withMutations((function(r){var n=e(t);Qi(n.size),n.forEach((function(e,t){return r.set(t,e)}))}))}return e&&(t.__proto__=e),t.prototype=Object.create(e&&e.prototype),t.prototype.constructor=t,t.of=function(){for(var e=[],t=arguments.length;t--;)e[t]=arguments[t];return Ba().withMutations((function(t){for(var r=0;r<e.length;r+=2){if(r+1>=e.length)throw new Error("Missing value for key: "+e[r]);t.set(e[r],e[r+1])}}))},t.prototype.toString=function(){return this.__toString("Map {","}")},t.prototype.get=function(e,t){return this._root?this._root.get(0,void 0,e,t):t},t.prototype.set=function(e,t){return qa(this,e,t)},t.prototype.remove=function(e){return qa(this,e,to)},t.prototype.deleteAll=function(e){var t=Oo(e);return 0===t.size?this:this.withMutations((function(e){t.forEach((function(t){return e.remove(t)}))}))},t.prototype.clear=function(){return 0===this.size?this:this.__ownerID?(this.size=0,this._root=null,this.__hash=void 0,this.__altered=!0,this):Ba()},t.prototype.sort=function(e){return fs(Mi(this,e))},t.prototype.sortBy=function(e,t){return fs(Mi(this,t,e))},t.prototype.map=function(e,t){var r=this;return this.withMutations((function(n){n.forEach((function(o,i){n.set(i,e.call(t,o,i,r))}))}))},t.prototype.__iterator=function(e,t){return new Da(this,e,t)},t.prototype.__iterate=function(e,t){var r=this,n=0;return this._root&&this._root.iterate((function(t){return n++,e(t[1],t[0],r)}),t),n},t.prototype.__ensureOwner=function(e){return e===this.__ownerID?this:e?Ua(this.size,this._root,e,this.__hash):0===this.size?Ba():(this.__ownerID=e,this.__altered=!1,this)},t}(Eo);Ia.isMap=ii;var xa=Ia.prototype;xa[oi]=!0,xa[Xn]=xa.remove,xa.removeAll=xa.deleteAll,xa.setIn=ca,xa.removeIn=xa.deleteIn=pa,xa.update=ha,xa.updateIn=va,xa.merge=xa.concat=ga,xa.mergeWith=ya,xa.mergeDeep=Ea,xa.mergeDeepWith=Sa,xa.mergeIn=Ta,xa.mergeDeepIn=_a,xa.withMutations=wa,xa.wasAltered=Ca,xa.asImmutable=Aa,xa["@@transducer/init"]=xa.asMutable=Ra,xa["@@transducer/step"]=function(e,t){return e.set(t[0],t[1])},xa["@@transducer/result"]=function(e){return e.asImmutable()};var La=function(e,t){this.ownerID=e,this.entries=t};La.prototype.get=function(e,t,r,n){for(var o=this.entries,i=0,a=o.length;i<a;i++)if(li(r,o[i][0]))return o[i][1];return n},La.prototype.update=function(e,t,r,n,o,i,a){for(var s=o===to,l=this.entries,u=0,c=l.length;u<c&&!li(n,l[u][0]);u++);var d=u<c;if(d?l[u][1]===o:s)return this;if(ro(a),(s||!d)&&ro(i),!s||1!==l.length){if(!d&&!s&&l.length>=Ha)return function(e,t,r,n){e||(e=new no);for(var o=new ka(e,pi(r),[r,n]),i=0;i<t.length;i++){var a=t[i];o=o.update(e,0,void 0,a[0],a[1])}return o}(e,l,n,o);var p=e&&e===this.ownerID,f=p?l:Hi(l);return d?s?u===c-1?f.pop():f[u]=f.pop():f[u]=[n,o]:f.push([n,o]),p?(this.entries=f,this):new La(e,f)}};var Na=function(e,t,r){this.ownerID=e,this.bitmap=t,this.nodes=r};Na.prototype.get=function(e,t,r,n){void 0===t&&(t=pi(r));var o=1<<((0===e?t:t>>>e)&eo),i=this.bitmap;return i&o?this.nodes[za(i&o-1)].get(e+Jn,t,r,n):n},Na.prototype.update=function(e,t,r,n,o,i,a){void 0===r&&(r=pi(n));var s=(0===t?r:r>>>t)&eo,l=1<<s,u=this.bitmap,c=!!(u&l);if(!c&&o===to)return this;var d=za(u&l-1),p=this.nodes,f=c?p[d]:void 0,h=Ga(f,e,t+Jn,r,n,o,i,a);if(h===f)return this;if(!c&&h&&p.length>=Ya)return function(e,t,r,n,o){for(var i=0,a=new Array(Zn),s=0;0!==r;s++,r>>>=1)a[s]=1&r?t[i++]:void 0;return a[n]=o,new ja(e,i+1,a)}(e,p,u,s,h);if(c&&!h&&2===p.length&&Ka(p[1^d]))return p[1^d];if(c&&h&&1===p.length&&Ka(h))return h;var v=e&&e===this.ownerID,g=c?h?u:u^l:u|l,y=c?h?$a(p,d,h,v):function(e,t,r){var n=e.length-1;if(r&&t===n)return e.pop(),e;for(var o=new Array(n),i=0,a=0;a<n;a++)a===t&&(i=1),o[a]=e[a+i];return o}(p,d,v):function(e,t,r,n){var o=e.length+1;if(n&&t+1===o)return e[t]=r,e;for(var i=new Array(o),a=0,s=0;s<o;s++)s===t?(i[s]=r,a=-1):i[s]=e[s+a];return i}(p,d,h,v);return v?(this.bitmap=g,this.nodes=y,this):new Na(e,g,y)};var ja=function(e,t,r){this.ownerID=e,this.count=t,this.nodes=r};ja.prototype.get=function(e,t,r,n){void 0===t&&(t=pi(r));var o=(0===e?t:t>>>e)&eo,i=this.nodes[o];return i?i.get(e+Jn,t,r,n):n},ja.prototype.update=function(e,t,r,n,o,i,a){void 0===r&&(r=pi(n));var s=(0===t?r:r>>>t)&eo,l=o===to,u=this.nodes,c=u[s];if(l&&!c)return this;var d=Ga(c,e,t+Jn,r,n,o,i,a);if(d===c)return this;var p=this.count;if(c){if(!d&&--p<Qa)return function(e,t,r,n){for(var o=0,i=0,a=new Array(r),s=0,l=1,u=t.length;s<u;s++,l<<=1){var c=t[s];void 0!==c&&s!==n&&(o|=l,a[i++]=c)}return new Na(e,o,a)}(e,u,p,s)}else p++;var f=e&&e===this.ownerID,h=$a(u,s,d,f);return f?(this.count=p,this.nodes=h,this):new ja(e,p,h)};var Pa=function(e,t,r){this.ownerID=e,this.keyHash=t,this.entries=r};Pa.prototype.get=function(e,t,r,n){for(var o=this.entries,i=0,a=o.length;i<a;i++)if(li(r,o[i][0]))return o[i][1];return n},Pa.prototype.update=function(e,t,r,n,o,i,a){void 0===r&&(r=pi(n));var s=o===to;if(r!==this.keyHash)return s?this:(ro(a),ro(i),Wa(this,e,t,r,[n,o]));for(var l=this.entries,u=0,c=l.length;u<c&&!li(n,l[u][0]);u++);var d=u<c;if(d?l[u][1]===o:s)return this;if(ro(a),(s||!d)&&ro(i),s&&2===c)return new ka(e,this.keyHash,l[1^u]);var p=e&&e===this.ownerID,f=p?l:Hi(l);return d?s?u===c-1?f.pop():f[u]=f.pop():f[u]=[n,o]:f.push([n,o]),p?(this.entries=f,this):new Pa(e,this.keyHash,f)};var ka=function(e,t,r){this.ownerID=e,this.keyHash=t,this.entry=r};ka.prototype.get=function(e,t,r,n){return li(r,this.entry[0])?this.entry[1]:n},ka.prototype.update=function(e,t,r,n,o,i,a){var s=o===to,l=li(n,this.entry[0]);return(l?o===this.entry[1]:s)?this:(ro(a),s?void ro(i):l?e&&e===this.ownerID?(this.entry[1]=o,this):new ka(e,this.keyHash,[n,o]):(ro(i),Wa(this,e,t,pi(n),[n,o])))},La.prototype.iterate=Pa.prototype.iterate=function(e,t){for(var r=this.entries,n=0,o=r.length-1;n<=o;n++)if(!1===e(r[t?o-n:n]))return!1},Na.prototype.iterate=ja.prototype.iterate=function(e,t){for(var r=this.nodes,n=0,o=r.length-1;n<=o;n++){var i=r[t?o-n:n];if(i&&!1===i.iterate(e,t))return!1}},ka.prototype.iterate=function(e,t){return e(this.entry)};var Fa,Da=function(e){function t(e,t,r){this._type=t,this._reverse=r,this._stack=e._root&&Va(e._root)}return e&&(t.__proto__=e),t.prototype=Object.create(e&&e.prototype),t.prototype.constructor=t,t.prototype.next=function(){for(var e=this._type,t=this._stack;t;){var r=t.node,n=t.index++,o=void 0;if(r.entry){if(0===n)return Ma(e,r.entry)}else if(r.entries){if(n<=(o=r.entries.length-1))return Ma(e,r.entries[this._reverse?o-n:n])}else if(n<=(o=r.nodes.length-1)){var i=r.nodes[this._reverse?o-n:n];if(i){if(i.entry)return Ma(e,i.entry);t=this._stack=Va(i,t)}continue}t=this._stack=this._stack.__prev}return{value:void 0,done:!0}},t}(Do);function Ma(e,t){return Mo(e,t[0],t[1])}function Va(e,t){return{node:e,index:0,__prev:t}}function Ua(e,t,r,n){var o=Object.create(xa);return o.size=e,o._root=t,o.__ownerID=r,o.__hash=n,o.__altered=!1,o}function Ba(){return Fa||(Fa=Ua(0))}function qa(e,t,r){var n,o;if(e._root){var i={value:!1},a={value:!1};if(n=Ga(e._root,e.__ownerID,0,void 0,t,r,i,a),!a.value)return e;o=e.size+(i.value?r===to?-1:1:0)}else{if(r===to)return e;o=1,n=new La(e.__ownerID,[[t,r]])}return e.__ownerID?(e.size=o,e._root=n,e.__hash=void 0,e.__altered=!0,e):n?Ua(o,n):Ba()}function Ga(e,t,r,n,o,i,a,s){return e?e.update(t,r,n,o,i,a,s):i===to?e:(ro(s),ro(a),new ka(t,n,[o,i]))}function Ka(e){return e.constructor===ka||e.constructor===Pa}function Wa(e,t,r,n,o){if(e.keyHash===n)return new Pa(t,n,[e.entry,o]);var i,a=(0===r?e.keyHash:e.keyHash>>>r)&eo,s=(0===r?n:n>>>r)&eo,l=a===s?[Wa(e,t,r+Jn,n,o)]:(i=new ka(t,n,o),a<s?[e,i]:[i,e]);return new Na(t,1<<a|1<<s,l)}function za(e){return e=(e=(858993459&(e-=e>>1&1431655765))+(e>>2&858993459))+(e>>4)&252645135,127&(e+=e>>8)+(e>>16)}function $a(e,t,r,n){var o=n?e:Hi(e);return o[t]=r,o}var Ha=Zn/4,Ya=Zn/2,Qa=Zn/4,Xa="@@__IMMUTABLE_LIST__@@";function Ja(e){return Boolean(e&&e[Xa])}var Za=function(e){function t(t){var r=as();if(null==t)return r;if(Ja(t))return t;var n=e(t),o=n.size;return 0===o?r:(Qi(o),o>0&&o<Zn?is(0,o,Jn,null,new ts(n.toArray())):r.withMutations((function(e){e.setSize(o),n.forEach((function(t,r){return e.set(r,t)}))})))}return e&&(t.__proto__=e),t.prototype=Object.create(e&&e.prototype),t.prototype.constructor=t,t.of=function(){return this(arguments)},t.prototype.toString=function(){return this.__toString("List [","]")},t.prototype.get=function(e,t){if((e=io(this,e))>=0&&e<this.size){var r=us(this,e+=this._origin);return r&&r.array[e&eo]}return t},t.prototype.set=function(e,t){return function(e,t,r){if((t=io(e,t))!=t)return e;if(t>=e.size||t<0)return e.withMutations((function(e){t<0?cs(e,t).set(0,r):cs(e,0,t+1).set(t,r)}));t+=e._origin;var n=e._tail,o=e._root,i={value:!1};return t>=ds(e._capacity)?n=ss(n,e.__ownerID,0,t,r,i):o=ss(o,e.__ownerID,e._level,t,r,i),i.value?e.__ownerID?(e._root=o,e._tail=n,e.__hash=void 0,e.__altered=!0,e):is(e._origin,e._capacity,e._level,o,n):e}(this,e,t)},t.prototype.remove=function(e){return this.has(e)?0===e?this.shift():e===this.size-1?this.pop():this.splice(e,1):this},t.prototype.insert=function(e,t){return this.splice(e,0,t)},t.prototype.clear=function(){return 0===this.size?this:this.__ownerID?(this.size=this._origin=this._capacity=0,this._level=Jn,this._root=this._tail=this.__hash=void 0,this.__altered=!0,this):as()},t.prototype.push=function(){var e=arguments,t=this.size;return this.withMutations((function(r){cs(r,0,t+e.length);for(var n=0;n<e.length;n++)r.set(t+n,e[n])}))},t.prototype.pop=function(){return cs(this,0,-1)},t.prototype.unshift=function(){var e=arguments;return this.withMutations((function(t){cs(t,-e.length);for(var r=0;r<e.length;r++)t.set(r,e[r])}))},t.prototype.shift=function(){return cs(this,1)},t.prototype.concat=function(){for(var t=arguments,r=[],n=0;n<arguments.length;n++){var o=t[n],i=e("string"!=typeof o&&Uo(o)?o:[o]);0!==i.size&&r.push(i)}return 0===r.length?this:0!==this.size||this.__ownerID||1!==r.length?this.withMutations((function(e){r.forEach((function(t){return t.forEach((function(t){return e.push(t)}))}))})):this.constructor(r[0])},t.prototype.setSize=function(e){return cs(this,0,e)},t.prototype.map=function(e,t){var r=this;return this.withMutations((function(n){for(var o=0;o<r.size;o++)n.set(o,e.call(t,n.get(o),o,r))}))},t.prototype.slice=function(e,t){var r=this.size;return so(e,t,r)?this:cs(this,lo(e,r),uo(t,r))},t.prototype.__iterator=function(e,t){var r=t?this.size:0,n=os(this,t);return new Do((function(){var o=n();return o===ns?{value:void 0,done:!0}:Mo(e,t?--r:r++,o)}))},t.prototype.__iterate=function(e,t){for(var r,n=t?this.size:0,o=os(this,t);(r=o())!==ns&&!1!==e(r,t?--n:n++,this););return n},t.prototype.__ensureOwner=function(e){return e===this.__ownerID?this:e?is(this._origin,this._capacity,this._level,this._root,this._tail,e,this.__hash):0===this.size?as():(this.__ownerID=e,this.__altered=!1,this)},t}(So);Za.isList=Ja;var es=Za.prototype;es[Xa]=!0,es[Xn]=es.remove,es.merge=es.concat,es.setIn=ca,es.deleteIn=es.removeIn=pa,es.update=ha,es.updateIn=va,es.mergeIn=Ta,es.mergeDeepIn=_a,es.withMutations=wa,es.wasAltered=Ca,es.asImmutable=Aa,es["@@transducer/init"]=es.asMutable=Ra,es["@@transducer/step"]=function(e,t){return e.push(t)},es["@@transducer/result"]=function(e){return e.asImmutable()};var ts=function(e,t){this.array=e,this.ownerID=t};ts.prototype.removeBefore=function(e,t,r){if(r===t?1<<t:0===this.array.length)return this;var n=r>>>t&eo;if(n>=this.array.length)return new ts([],e);var o,i=0===n;if(t>0){var a=this.array[n];if((o=a&&a.removeBefore(e,t-Jn,r))===a&&i)return this}if(i&&!o)return this;var s=ls(this,e);if(!i)for(var l=0;l<n;l++)s.array[l]=void 0;return o&&(s.array[n]=o),s},ts.prototype.removeAfter=function(e,t,r){if(r===(t?1<<t:0)||0===this.array.length)return this;var n,o=r-1>>>t&eo;if(o>=this.array.length)return this;if(t>0){var i=this.array[o];if((n=i&&i.removeAfter(e,t-Jn,r))===i&&o===this.array.length-1)return this}var a=ls(this,e);return a.array.splice(o+1),n&&(a.array[o]=n),a};var rs,ns={};function os(e,t){var r=e._origin,n=e._capacity,o=ds(n),i=e._tail;return function e(a,s,l){return 0===s?function(e,a){var s=a===o?i&&i.array:e&&e.array,l=a>r?0:r-a,u=n-a;return u>Zn&&(u=Zn),function(){if(l===u)return ns;var e=t?--u:l++;return s&&s[e]}}(a,l):function(o,i,a){var s,l=o&&o.array,u=a>r?0:r-a>>i,c=1+(n-a>>i);return c>Zn&&(c=Zn),function(){for(;;){if(s){var r=s();if(r!==ns)return r;s=null}if(u===c)return ns;var n=t?--c:u++;s=e(l&&l[n],i-Jn,a+(n<<i))}}}(a,s,l)}(e._root,e._level,0)}function is(e,t,r,n,o,i,a){var s=Object.create(es);return s.size=t-e,s._origin=e,s._capacity=t,s._level=r,s._root=n,s._tail=o,s.__ownerID=i,s.__hash=a,s.__altered=!1,s}function as(){return rs||(rs=is(0,0,Jn))}function ss(e,t,r,n,o,i){var a,s=n>>>r&eo,l=e&&s<e.array.length;if(!l&&void 0===o)return e;if(r>0){var u=e&&e.array[s],c=ss(u,t,r-Jn,n,o,i);return c===u?e:((a=ls(e,t)).array[s]=c,a)}return l&&e.array[s]===o?e:(i&&ro(i),a=ls(e,t),void 0===o&&s===a.array.length-1?a.array.pop():a.array[s]=o,a)}function ls(e,t){return t&&e&&t===e.ownerID?e:new ts(e?e.array.slice():[],t)}function us(e,t){if(t>=ds(e._capacity))return e._tail;if(t<1<<e._level+Jn){for(var r=e._root,n=e._level;r&&n>0;)r=r.array[t>>>n&eo],n-=Jn;return r}}function cs(e,t,r){void 0!==t&&(t|=0),void 0!==r&&(r|=0);var n=e.__ownerID||new no,o=e._origin,i=e._capacity,a=o+t,s=void 0===r?i:r<0?i+r:o+r;if(a===o&&s===i)return e;if(a>=s)return e.clear();for(var l=e._level,u=e._root,c=0;a+c<0;)u=new ts(u&&u.array.length?[void 0,u]:[],n),c+=1<<(l+=Jn);c&&(a+=c,o+=c,s+=c,i+=c);for(var d=ds(i),p=ds(s);p>=1<<l+Jn;)u=new ts(u&&u.array.length?[u]:[],n),l+=Jn;var f=e._tail,h=p<d?us(e,s-1):p>d?new ts([],n):f;if(f&&p>d&&a<i&&f.array.length){for(var v=u=ls(u,n),g=l;g>Jn;g-=Jn){var y=d>>>g&eo;v=v.array[y]=ls(v.array[y],n)}v.array[d>>>Jn&eo]=f}if(s<i&&(h=h&&h.removeAfter(n,0,s)),a>=p)a-=p,s-=p,l=Jn,u=null,h=h&&h.removeBefore(n,0,a);else if(a>o||p<d){for(c=0;u;){var m=a>>>l&eo;if(m!==p>>>l&eo)break;m&&(c+=(1<<l)*m),l-=Jn,u=u.array[m]}u&&a>o&&(u=u.removeBefore(n,l,a-c)),u&&p<d&&(u=u.removeAfter(n,l,p-c)),c&&(a-=c,s-=c)}return e.__ownerID?(e.size=s-a,e._origin=a,e._capacity=s,e._level=l,e._root=u,e._tail=h,e.__hash=void 0,e.__altered=!0,e):is(a,s,l,u,h)}function ds(e){return e<Zn?0:e-1>>>Jn<<Jn}var ps,fs=function(e){function t(e){return null==e?vs():ai(e)?e:vs().withMutations((function(t){var r=Eo(e);Qi(r.size),r.forEach((function(e,r){return t.set(r,e)}))}))}return e&&(t.__proto__=e),t.prototype=Object.create(e&&e.prototype),t.prototype.constructor=t,t.of=function(){return this(arguments)},t.prototype.toString=function(){return this.__toString("OrderedMap {","}")},t.prototype.get=function(e,t){var r=this._map.get(e);return void 0!==r?this._list.get(r)[1]:t},t.prototype.clear=function(){return 0===this.size?this:this.__ownerID?(this.size=0,this._map.clear(),this._list.clear(),this.__altered=!0,this):vs()},t.prototype.set=function(e,t){return gs(this,e,t)},t.prototype.remove=function(e){return gs(this,e,to)},t.prototype.__iterate=function(e,t){var r=this;return this._list.__iterate((function(t){return t&&e(t[1],t[0],r)}),t)},t.prototype.__iterator=function(e,t){return this._list.fromEntrySeq().__iterator(e,t)},t.prototype.__ensureOwner=function(e){if(e===this.__ownerID)return this;var t=this._map.__ensureOwner(e),r=this._list.__ensureOwner(e);return e?hs(t,r,e,this.__hash):0===this.size?vs():(this.__ownerID=e,this.__altered=!1,this._map=t,this._list=r,this)},t}(Ia);function hs(e,t,r,n){var o=Object.create(fs.prototype);return o.size=e?e.size:0,o._map=e,o._list=t,o.__ownerID=r,o.__hash=n,o.__altered=!1,o}function vs(){return ps||(ps=hs(Ba(),as()))}function gs(e,t,r){var n,o,i=e._map,a=e._list,s=i.get(t),l=void 0!==s;if(r===to){if(!l)return e;a.size>=Zn&&a.size>=2*i.size?(n=(o=a.filter((function(e,t){return void 0!==e&&s!==t}))).toKeyedSeq().map((function(e){return e[0]})).flip().toMap(),e.__ownerID&&(n.__ownerID=o.__ownerID=e.__ownerID)):(n=i.remove(t),o=s===a.size-1?a.pop():a.set(s,void 0))}else if(l){if(r===a.get(s)[1])return e;n=i,o=a.set(s,[t,r])}else n=i.set(t,a.size),o=a.set(a.size,[t,r]);return e.__ownerID?(e.size=n.size,e._map=n,e._list=o,e.__hash=void 0,e.__altered=!0,e):hs(n,o)}fs.isOrderedMap=ai,fs.prototype[Io]=!0,fs.prototype[Xn]=fs.prototype.remove;var ys="@@__IMMUTABLE_STACK__@@";function ms(e){return Boolean(e&&e[ys])}var bs=function(e){function t(e){return null==e?Ts():ms(e)?e:Ts().pushAll(e)}return e&&(t.__proto__=e),t.prototype=Object.create(e&&e.prototype),t.prototype.constructor=t,t.of=function(){return this(arguments)},t.prototype.toString=function(){return this.__toString("Stack [","]")},t.prototype.get=function(e,t){var r=this._head;for(e=io(this,e);r&&e--;)r=r.next;return r?r.value:t},t.prototype.peek=function(){return this._head&&this._head.value},t.prototype.push=function(){var e=arguments;if(0===arguments.length)return this;for(var t=this.size+arguments.length,r=this._head,n=arguments.length-1;n>=0;n--)r={value:e[n],next:r};return this.__ownerID?(this.size=t,this._head=r,this.__hash=void 0,this.__altered=!0,this):Ss(t,r)},t.prototype.pushAll=function(t){if(0===(t=e(t)).size)return this;if(0===this.size&&ms(t))return t;Qi(t.size);var r=this.size,n=this._head;return t.__iterate((function(e){r++,n={value:e,next:n}}),!0),this.__ownerID?(this.size=r,this._head=n,this.__hash=void 0,this.__altered=!0,this):Ss(r,n)},t.prototype.pop=function(){return this.slice(1)},t.prototype.clear=function(){return 0===this.size?this:this.__ownerID?(this.size=0,this._head=void 0,this.__hash=void 0,this.__altered=!0,this):Ts()},t.prototype.slice=function(t,r){if(so(t,r,this.size))return this;var n=lo(t,this.size);if(uo(r,this.size)!==this.size)return e.prototype.slice.call(this,t,r);for(var o=this.size-n,i=this._head;n--;)i=i.next;return this.__ownerID?(this.size=o,this._head=i,this.__hash=void 0,this.__altered=!0,this):Ss(o,i)},t.prototype.__ensureOwner=function(e){return e===this.__ownerID?this:e?Ss(this.size,this._head,e,this.__hash):0===this.size?Ts():(this.__ownerID=e,this.__altered=!1,this)},t.prototype.__iterate=function(e,t){var r=this;if(t)return new Qo(this.toArray()).__iterate((function(t,n){return e(t,n,r)}),t);for(var n=0,o=this._head;o&&!1!==e(o.value,n++,this);)o=o.next;return n},t.prototype.__iterator=function(e,t){if(t)return new Qo(this.toArray()).__iterator(e,t);var r=0,n=this._head;return new Do((function(){if(n){var t=n.value;return n=n.next,Mo(e,r++,t)}return{value:void 0,done:!0}}))},t}(So);bs.isStack=ms;var Os,Es=bs.prototype;function Ss(e,t,r,n){var o=Object.create(Es);return o.size=e,o._head=t,o.__ownerID=r,o.__hash=n,o.__altered=!1,o}function Ts(){return Os||(Os=Ss(0))}Es[ys]=!0,Es.shift=Es.pop,Es.unshift=Es.push,Es.unshiftAll=Es.pushAll,Es.withMutations=wa,Es.wasAltered=Ca,Es.asImmutable=Aa,Es["@@transducer/init"]=Es.asMutable=Ra,Es["@@transducer/step"]=function(e,t){return e.unshift(t)},Es["@@transducer/result"]=function(e){return e.asImmutable()};var _s="@@__IMMUTABLE_SET__@@";function ws(e){return Boolean(e&&e[_s])}function Rs(e){return ws(e)&&xo(e)}function As(e,t){if(e===t)return!0;if(!ho(t)||void 0!==e.size&&void 0!==t.size&&e.size!==t.size||void 0!==e.__hash&&void 0!==t.__hash&&e.__hash!==t.__hash||go(e)!==go(t)||mo(e)!==mo(t)||xo(e)!==xo(t))return!1;if(0===e.size&&0===t.size)return!0;var r=!bo(e);if(xo(e)){var n=e.entries();return t.every((function(e,t){var o=n.next().value;return o&&li(o[1],e)&&(r||li(o[0],t))}))&&n.next().done}var o=!1;if(void 0===e.size)if(void 0===t.size)"function"==typeof e.cacheResult&&e.cacheResult();else{o=!0;var i=e;e=t,t=i}var a=!0,s=t.__iterate((function(t,n){if(r?!e.has(t):o?!li(t,e.get(n,to)):!li(e.get(n,to),t))return a=!1,!1}));return a&&e.size===s}function Cs(e,t){var r=function(r){e.prototype[r]=t[r]};return Object.keys(t).forEach(r),Object.getOwnPropertySymbols&&Object.getOwnPropertySymbols(t).forEach(r),e}function Is(e){if(!e||"object"!=typeof e)return e;if(!ho(e)){if(!ea(e))return e;e=zo(e)}if(go(e)){var t={};return e.__iterate((function(e,r){t[r]=Is(e)})),t}var r=[];return e.__iterate((function(e){r.push(Is(e))})),r}var xs=function(e){function t(t){return null==t?ks():ws(t)&&!xo(t)?t:ks().withMutations((function(r){var n=e(t);Qi(n.size),n.forEach((function(e){return r.add(e)}))}))}return e&&(t.__proto__=e),t.prototype=Object.create(e&&e.prototype),t.prototype.constructor=t,t.of=function(){return this(arguments)},t.fromKeys=function(e){return this(Eo(e).keySeq())},t.intersect=function(e){return(e=Oo(e).toArray()).length?Ns.intersect.apply(t(e.pop()),e):ks()},t.union=function(e){return(e=Oo(e).toArray()).length?Ns.union.apply(t(e.pop()),e):ks()},t.prototype.toString=function(){return this.__toString("Set {","}")},t.prototype.has=function(e){return this._map.has(e)},t.prototype.add=function(e){return js(this,this._map.set(e,e))},t.prototype.remove=function(e){return js(this,this._map.remove(e))},t.prototype.clear=function(){return js(this,this._map.clear())},t.prototype.map=function(e,t){var r=this,n=!1,o=js(this,this._map.mapEntries((function(o){var i=o[1],a=e.call(t,i,i,r);return a!==i&&(n=!0),[a,a]}),t));return n?o:this},t.prototype.union=function(){for(var t=[],r=arguments.length;r--;)t[r]=arguments[r];return 0===(t=t.filter((function(e){return 0!==e.size}))).length?this:0!==this.size||this.__ownerID||1!==t.length?this.withMutations((function(r){for(var n=0;n<t.length;n++)"string"==typeof t[n]?r.add(t[n]):e(t[n]).forEach((function(e){return r.add(e)}))})):this.constructor(t[0])},t.prototype.intersect=function(){for(var t=[],r=arguments.length;r--;)t[r]=arguments[r];if(0===t.length)return this;t=t.map((function(t){return e(t)}));var n=[];return this.forEach((function(e){t.every((function(t){return t.includes(e)}))||n.push(e)})),this.withMutations((function(e){n.forEach((function(t){e.remove(t)}))}))},t.prototype.subtract=function(){for(var t=[],r=arguments.length;r--;)t[r]=arguments[r];if(0===t.length)return this;t=t.map((function(t){return e(t)}));var n=[];return this.forEach((function(e){t.some((function(t){return t.includes(e)}))&&n.push(e)})),this.withMutations((function(e){n.forEach((function(t){e.remove(t)}))}))},t.prototype.sort=function(e){return el(Mi(this,e))},t.prototype.sortBy=function(e,t){return el(Mi(this,t,e))},t.prototype.wasAltered=function(){return this._map.wasAltered()},t.prototype.__iterate=function(e,t){var r=this;return this._map.__iterate((function(t){return e(t,t,r)}),t)},t.prototype.__iterator=function(e,t){return this._map.__iterator(e,t)},t.prototype.__ensureOwner=function(e){if(e===this.__ownerID)return this;var t=this._map.__ensureOwner(e);return e?this.__make(t,e):0===this.size?this.__empty():(this.__ownerID=e,this._map=t,this)},t}(To);xs.isSet=ws;var Ls,Ns=xs.prototype;function js(e,t){return e.__ownerID?(e.size=t.size,e._map=t,e):t===e._map?e:0===t.size?e.__empty():e.__make(t)}function Ps(e,t){var r=Object.create(Ns);return r.size=e?e.size:0,r._map=e,r.__ownerID=t,r}function ks(){return Ls||(Ls=Ps(Ba()))}Ns[_s]=!0,Ns[Xn]=Ns.remove,Ns.merge=Ns.concat=Ns.union,Ns.withMutations=wa,Ns.asImmutable=Aa,Ns["@@transducer/init"]=Ns.asMutable=Ra,Ns["@@transducer/step"]=function(e,t){return e.add(t)},Ns["@@transducer/result"]=function(e){return e.asImmutable()},Ns.__empty=ks,Ns.__make=Ps;var Fs,Ds=function(e){function t(e,r,n){if(!(this instanceof t))return new t(e,r,n);if(Yi(0!==n,"Cannot step a Range by 0"),e=e||0,void 0===r&&(r=1/0),n=void 0===n?1:Math.abs(n),r<e&&(n=-n),this._start=e,this._end=r,this._step=n,this.size=Math.max(0,Math.ceil((r-e)/n-1)+1),0===this.size){if(Fs)return Fs;Fs=this}}return e&&(t.__proto__=e),t.prototype=Object.create(e&&e.prototype),t.prototype.constructor=t,t.prototype.toString=function(){return 0===this.size?"Range []":"Range [ "+this._start+"..."+this._end+(1!==this._step?" by "+this._step:"")+" ]"},t.prototype.get=function(e,t){return this.has(e)?this._start+io(this,e)*this._step:t},t.prototype.includes=function(e){var t=(e-this._start)/this._step;return t>=0&&t<this.size&&t===Math.floor(t)},t.prototype.slice=function(e,r){return so(e,r,this.size)?this:(e=lo(e,this.size),(r=uo(r,this.size))<=e?new t(0,0):new t(this.get(e,this._end),this.get(r,this._end),this._step))},t.prototype.indexOf=function(e){var t=e-this._start;if(t%this._step==0){var r=t/this._step;if(r>=0&&r<this.size)return r}return-1},t.prototype.lastIndexOf=function(e){return this.indexOf(e)},t.prototype.__iterate=function(e,t){for(var r=this.size,n=this._step,o=t?this._start+(r-1)*n:this._start,i=0;i!==r&&!1!==e(o,t?r-++i:i++,this);)o+=t?-n:n;return i},t.prototype.__iterator=function(e,t){var r=this.size,n=this._step,o=t?this._start+(r-1)*n:this._start,i=0;return new Do((function(){if(i===r)return{value:void 0,done:!0};var a=o;return o+=t?-n:n,Mo(e,t?r-++i:i++,a)}))},t.prototype.equals=function(e){return e instanceof t?this._start===e._start&&this._end===e._end&&this._step===e._step:As(this,e)},t}(Ho);function Ms(e,t,r){for(var n=Xi(t),o=0;o!==n.length;)if((e=na(e,n[o++],to))===to)return r;return e}function Vs(e,t){return Ms(this,e,t)}function Us(e,t){return Ms(e,t,to)!==to}function Bs(){Qi(this.size);var e={};return this.__iterate((function(t,r){e[r]=t})),e}Oo.isIterable=ho,Oo.isKeyed=go,Oo.isIndexed=mo,Oo.isAssociative=bo,Oo.isOrdered=xo,Oo.Iterator=Do,Cs(Oo,{toArray:function(){Qi(this.size);var e=new Array(this.size||0),t=go(this),r=0;return this.__iterate((function(n,o){e[r++]=t?[o,n]:n})),e},toIndexedSeq:function(){return new Ci(this)},toJS:function(){return Is(this)},toKeyedSeq:function(){return new Ai(this,!0)},toMap:function(){return Ia(this.toKeyedSeq())},toObject:Bs,toOrderedMap:function(){return fs(this.toKeyedSeq())},toOrderedSet:function(){return el(go(this)?this.valueSeq():this)},toSet:function(){return xs(go(this)?this.valueSeq():this)},toSetSeq:function(){return new Ii(this)},toSeq:function(){return mo(this)?this.toIndexedSeq():go(this)?this.toKeyedSeq():this.toSetSeq()},toStack:function(){return bs(go(this)?this.valueSeq():this)},toList:function(){return Za(go(this)?this.valueSeq():this)},toString:function(){return"[Collection]"},__toString:function(e,t){return 0===this.size?e+t:e+" "+this.toSeq().map(this.__toStringMapper).join(", ")+" "+t},concat:function(){for(var e=[],t=arguments.length;t--;)e[t]=arguments[t];return qi(this,function(e,t){var r=go(e),n=[e].concat(t).map((function(e){return ho(e)?r&&(e=Eo(e)):e=r?ti(e):ri(Array.isArray(e)?e:[e]),e})).filter((function(e){return 0!==e.size}));if(0===n.length)return e;if(1===n.length){var o=n[0];if(o===e||r&&go(o)||mo(e)&&mo(o))return o}var i=new Qo(n);return r?i=i.toKeyedSeq():mo(e)||(i=i.toSetSeq()),(i=i.flatten(!0)).size=n.reduce((function(e,t){if(void 0!==e){var r=t.size;if(void 0!==r)return e+r}}),0),i}(this,e))},includes:function(e){return this.some((function(t){return li(t,e)}))},entries:function(){return this.__iterator(jo)},every:function(e,t){Qi(this.size);var r=!0;return this.__iterate((function(n,o,i){if(!e.call(t,n,o,i))return r=!1,!1})),r},filter:function(e,t){return qi(this,Pi(this,e,t,!0))},partition:function(e,t){return function(e,t,r){var n=go(e),o=[[],[]];e.__iterate((function(i,a){o[t.call(r,i,a,e)?1:0].push(n?[a,i]:i)}));var i=Ki(e);return o.map((function(t){return qi(e,i(t))}))}(this,e,t)},find:function(e,t,r){var n=this.findEntry(e,t);return n?n[1]:r},forEach:function(e,t){return Qi(this.size),this.__iterate(t?e.bind(t):e)},join:function(e){Qi(this.size),e=void 0!==e?""+e:",";var t="",r=!0;return this.__iterate((function(n){r?r=!1:t+=e,t+=null!=n?n.toString():""})),t},keys:function(){return this.__iterator(Lo)},map:function(e,t){return qi(this,Ni(this,e,t))},reduce:function(e,t,r){return zs(this,e,t,r,arguments.length<2,!1)},reduceRight:function(e,t,r){return zs(this,e,t,r,arguments.length<2,!0)},reverse:function(){return qi(this,ji(this,!0))},slice:function(e,t){return qi(this,ki(this,e,t,!0))},some:function(e,t){Qi(this.size);var r=!1;return this.__iterate((function(n,o,i){if(e.call(t,n,o,i))return r=!0,!1})),r},sort:function(e){return qi(this,Mi(this,e))},values:function(){return this.__iterator(No)},butLast:function(){return this.slice(0,-1)},isEmpty:function(){return void 0!==this.size?0===this.size:!this.some((function(){return!0}))},count:function(e,t){return oo(e?this.toSeq().filter(e,t):this)},countBy:function(e,t){return function(e,t,r){var n=Ia().asMutable();return e.__iterate((function(o,i){n.update(t.call(r,o,i,e),0,(function(e){return e+1}))})),n.asImmutable()}(this,e,t)},equals:function(e){return As(this,e)},entrySeq:function(){var e=this;if(e._cache)return new Qo(e._cache);var t=e.toSeq().map(Hs).toIndexedSeq();return t.fromEntrySeq=function(){return e.toSeq()},t},filterNot:function(e,t){return this.filter(Ys(e),t)},findEntry:function(e,t,r){var n=r;return this.__iterate((function(r,o,i){if(e.call(t,r,o,i))return n=[o,r],!1})),n},findKey:function(e,t){var r=this.findEntry(e,t);return r&&r[0]},findLast:function(e,t,r){return this.toKeyedSeq().reverse().find(e,t,r)},findLastEntry:function(e,t,r){return this.toKeyedSeq().reverse().findEntry(e,t,r)},findLastKey:function(e,t){return this.toKeyedSeq().reverse().findKey(e,t)},first:function(e){return this.find(ao,null,e)},flatMap:function(e,t){return qi(this,function(e,t,r){var n=Ki(e);return e.toSeq().map((function(o,i){return n(t.call(r,o,i,e))})).flatten(!0)}(this,e,t))},flatten:function(e){return qi(this,Di(this,e,!0))},fromEntrySeq:function(){return new xi(this)},get:function(e,t){return this.find((function(t,r){return li(r,e)}),void 0,t)},getIn:Vs,groupBy:function(e,t){return function(e,t,r){var n=go(e),o=(xo(e)?fs():Ia()).asMutable();e.__iterate((function(i,a){o.update(t.call(r,i,a,e),(function(e){return(e=e||[]).push(n?[a,i]:i),e}))}));var i=Ki(e);return o.map((function(t){return qi(e,i(t))})).asImmutable()}(this,e,t)},has:function(e){return this.get(e,to)!==to},hasIn:function(e){return Us(this,e)},isSubset:function(e){return e="function"==typeof e.includes?e:Oo(e),this.every((function(t){return e.includes(t)}))},isSuperset:function(e){return(e="function"==typeof e.isSubset?e:Oo(e)).isSubset(this)},keyOf:function(e){return this.findKey((function(t){return li(t,e)}))},keySeq:function(){return this.toSeq().map($s).toIndexedSeq()},last:function(e){return this.toSeq().reverse().first(e)},lastKeyOf:function(e){return this.toKeyedSeq().reverse().keyOf(e)},max:function(e){return Vi(this,e)},maxBy:function(e,t){return Vi(this,t,e)},min:function(e){return Vi(this,e?Qs(e):Js)},minBy:function(e,t){return Vi(this,t?Qs(t):Js,e)},rest:function(){return this.slice(1)},skip:function(e){return 0===e?this:this.slice(Math.max(0,e))},skipLast:function(e){return 0===e?this:this.slice(0,-Math.max(0,e))},skipWhile:function(e,t){return qi(this,Fi(this,e,t,!0))},skipUntil:function(e,t){return this.skipWhile(Ys(e),t)},sortBy:function(e,t){return qi(this,Mi(this,t,e))},take:function(e){return this.slice(0,Math.max(0,e))},takeLast:function(e){return this.slice(-Math.max(0,e))},takeWhile:function(e,t){return qi(this,function(e,t,r){var n=Wi(e);return n.__iterateUncached=function(n,o){var i=this;if(o)return this.cacheResult().__iterate(n,o);var a=0;return e.__iterate((function(e,o,s){return t.call(r,e,o,s)&&++a&&n(e,o,i)})),a},n.__iteratorUncached=function(n,o){var i=this;if(o)return this.cacheResult().__iterator(n,o);var a=e.__iterator(jo,o),s=!0;return new Do((function(){if(!s)return{value:void 0,done:!0};var e=a.next();if(e.done)return e;var o=e.value,l=o[0],u=o[1];return t.call(r,u,l,i)?n===jo?e:Mo(n,l,u,e):(s=!1,{value:void 0,done:!0})}))},n}(this,e,t))},takeUntil:function(e,t){return this.takeWhile(Ys(e),t)},update:function(e){return e(this)},valueSeq:function(){return this.toIndexedSeq()},hashCode:function(){return this.__hash||(this.__hash=function(e){if(e.size===1/0)return 0;var t=xo(e),r=go(e),n=t?1:0;return function(e,t){return t=ui(t,3432918353),t=ui(t<<15|t>>>-15,461845907),t=ui(t<<13|t>>>-13,5),t=ui((t=t+3864292196^e)^t>>>16,2246822507),t=ci((t=ui(t^t>>>13,3266489909))^t>>>16)}(e.__iterate(r?t?function(e,t){n=31*n+Zs(pi(e),pi(t))|0}:function(e,t){n=n+Zs(pi(e),pi(t))|0}:t?function(e){n=31*n+pi(e)|0}:function(e){n=n+pi(e)|0}),n)}(this))}});var qs=Oo.prototype;qs[fo]=!0,qs[Fo]=qs.values,qs.toJSON=qs.toArray,qs.__toStringMapper=ta,qs.inspect=qs.toSource=function(){return this.toString()},qs.chain=qs.flatMap,qs.contains=qs.includes,Cs(Eo,{flip:function(){return qi(this,Li(this))},mapEntries:function(e,t){var r=this,n=0;return qi(this,this.toSeq().map((function(o,i){return e.call(t,[i,o],n++,r)})).fromEntrySeq())},mapKeys:function(e,t){var r=this;return qi(this,this.toSeq().flip().map((function(n,o){return e.call(t,n,o,r)})).flip())}});var Gs=Eo.prototype;Gs[vo]=!0,Gs[Fo]=qs.entries,Gs.toJSON=Bs,Gs.__toStringMapper=function(e,t){return ta(t)+": "+ta(e)},Cs(So,{toKeyedSeq:function(){return new Ai(this,!1)},filter:function(e,t){return qi(this,Pi(this,e,t,!1))},findIndex:function(e,t){var r=this.findEntry(e,t);return r?r[0]:-1},indexOf:function(e){var t=this.keyOf(e);return void 0===t?-1:t},lastIndexOf:function(e){var t=this.lastKeyOf(e);return void 0===t?-1:t},reverse:function(){return qi(this,ji(this,!1))},slice:function(e,t){return qi(this,ki(this,e,t,!1))},splice:function(e,t){var r=arguments.length;if(t=Math.max(t||0,0),0===r||2===r&&!t)return this;e=lo(e,e<0?this.count():this.size);var n=this.slice(0,e);return qi(this,1===r?n:n.concat(Hi(arguments,2),this.slice(e+t)))},findLastIndex:function(e,t){var r=this.findLastEntry(e,t);return r?r[0]:-1},first:function(e){return this.get(0,e)},flatten:function(e){return qi(this,Di(this,e,!1))},get:function(e,t){return(e=io(this,e))<0||this.size===1/0||void 0!==this.size&&e>this.size?t:this.find((function(t,r){return r===e}),void 0,t)},has:function(e){return(e=io(this,e))>=0&&(void 0!==this.size?this.size===1/0||e<this.size:-1!==this.indexOf(e))},interpose:function(e){return qi(this,function(e,t){var r=Wi(e);return r.size=e.size&&2*e.size-1,r.__iterateUncached=function(r,n){var o=this,i=0;return e.__iterate((function(e){return(!i||!1!==r(t,i++,o))&&!1!==r(e,i++,o)}),n),i},r.__iteratorUncached=function(r,n){var o,i=e.__iterator(No,n),a=0;return new Do((function(){return(!o||a%2)&&(o=i.next()).done?o:a%2?Mo(r,a++,t):Mo(r,a++,o.value,o)}))},r}(this,e))},interleave:function(){var e=[this].concat(Hi(arguments)),t=Bi(this.toSeq(),Ho.of,e),r=t.flatten(!0);return t.size&&(r.size=t.size*e.length),qi(this,r)},keySeq:function(){return Ds(0,this.size)},last:function(e){return this.get(-1,e)},skipWhile:function(e,t){return qi(this,Fi(this,e,t,!1))},zip:function(){return qi(this,Bi(this,Xs,[this].concat(Hi(arguments))))},zipAll:function(){return qi(this,Bi(this,Xs,[this].concat(Hi(arguments)),!0))},zipWith:function(e){var t=Hi(arguments);return t[0]=this,qi(this,Bi(this,e,t))}});var Ks=So.prototype;Ks[yo]=!0,Ks[Io]=!0,Cs(To,{get:function(e,t){return this.has(e)?e:t},includes:function(e){return this.has(e)},keySeq:function(){return this.valueSeq()}});var Ws=To.prototype;function zs(e,t,r,n,o,i){return Qi(e.size),e.__iterate((function(e,i,a){o?(o=!1,r=e):r=t.call(n,r,e,i,a)}),i),r}function $s(e,t){return t}function Hs(e,t){return[t,e]}function Ys(e){return function(){return!e.apply(this,arguments)}}function Qs(e){return function(){return-e.apply(this,arguments)}}function Xs(){return Hi(arguments)}function Js(e,t){return e<t?1:e>t?-1:0}function Zs(e,t){return e^t+2654435769+(e<<6)+(e>>2)}Ws.has=qs.includes,Ws.contains=Ws.includes,Ws.keys=Ws.values,Cs($o,Gs),Cs(Ho,Ks),Cs(Yo,Ws);var el=function(e){function t(e){return null==e?ol():Rs(e)?e:ol().withMutations((function(t){var r=To(e);Qi(r.size),r.forEach((function(e){return t.add(e)}))}))}return e&&(t.__proto__=e),t.prototype=Object.create(e&&e.prototype),t.prototype.constructor=t,t.of=function(){return this(arguments)},t.fromKeys=function(e){return this(Eo(e).keySeq())},t.prototype.toString=function(){return this.__toString("OrderedSet {","}")},t}(xs);el.isOrderedSet=Rs;var tl,rl=el.prototype;function nl(e,t){var r=Object.create(rl);return r.size=e?e.size:0,r._map=e,r.__ownerID=t,r}function ol(){return tl||(tl=nl(vs()))}rl[Io]=!0,rl.zip=Ks.zip,rl.zipWith=Ks.zipWith,rl.zipAll=Ks.zipAll,rl.__empty=ol,rl.__make=nl;var il=function(e,t){var r;!function(e){if(Ao(e))throw new Error("Can not call `Record` with an immutable Record as default values. Use a plain javascript object instead.");if(Co(e))throw new Error("Can not call `Record` with an immutable Collection as default values. Use a plain javascript object instead.");if(null===e||"object"!=typeof e)throw new Error("Can not call `Record` with a non-object as default values. Use a plain javascript object instead.")}(e);var n=function(i){var a=this;if(i instanceof n)return i;if(!(this instanceof n))return new n(i);if(!r){r=!0;var s=Object.keys(e),l=o._indices={};o._name=t,o._keys=s,o._defaultValues=e;for(var u=0;u<s.length;u++){var c=s[u];l[c]=u,o[c]?"object"==typeof console&&console.warn&&console.warn("Cannot define "+ll(this)+' with property "'+c+'" since that property name is part of the Record API.'):cl(o,c)}}return this.__ownerID=void 0,this._values=Za().withMutations((function(e){e.setSize(a._keys.length),Eo(i).forEach((function(t,r){e.set(a._indices[r],t===a._defaultValues[r]?void 0:t)}))})),this},o=n.prototype=Object.create(al);return o.constructor=n,t&&(n.displayName=t),n};il.prototype.toString=function(){for(var e,t=ll(this)+" { ",r=this._keys,n=0,o=r.length;n!==o;n++)t+=(n?", ":"")+(e=r[n])+": "+ta(this.get(e));return t+" }"},il.prototype.equals=function(e){return this===e||Ao(e)&&ul(this).equals(ul(e))},il.prototype.hashCode=function(){return ul(this).hashCode()},il.prototype.has=function(e){return this._indices.hasOwnProperty(e)},il.prototype.get=function(e,t){if(!this.has(e))return t;var r=this._indices[e],n=this._values.get(r);return void 0===n?this._defaultValues[e]:n},il.prototype.set=function(e,t){if(this.has(e)){var r=this._values.set(this._indices[e],t===this._defaultValues[e]?void 0:t);if(r!==this._values&&!this.__ownerID)return sl(this,r)}return this},il.prototype.remove=function(e){return this.set(e)},il.prototype.clear=function(){var e=this._values.clear().setSize(this._keys.length);return this.__ownerID?this:sl(this,e)},il.prototype.wasAltered=function(){return this._values.wasAltered()},il.prototype.toSeq=function(){return ul(this)},il.prototype.toJS=function(){return Is(this)},il.prototype.entries=function(){return this.__iterator(jo)},il.prototype.__iterator=function(e,t){return ul(this).__iterator(e,t)},il.prototype.__iterate=function(e,t){return ul(this).__iterate(e,t)},il.prototype.__ensureOwner=function(e){if(e===this.__ownerID)return this;var t=this._values.__ensureOwner(e);return e?sl(this,t,e):(this.__ownerID=e,this._values=t,this)},il.isRecord=Ao,il.getDescriptiveName=ll;var al=il.prototype;function sl(e,t,r){var n=Object.create(Object.getPrototypeOf(e));return n._values=t,n.__ownerID=r,n}function ll(e){return e.constructor.displayName||e.constructor.name||"Record"}function ul(e){return ti(e._keys.map((function(t){return[t,e.get(t)]})))}function cl(e,t){try{Object.defineProperty(e,t,{get:function(){return this.get(t)},set:function(e){Yi(this.__ownerID,"Cannot set on an immutable record."),this.set(t,e)}})}catch(e){}}al[Ro]=!0,al[Xn]=al.remove,al.deleteIn=al.removeIn=pa,al.getIn=Vs,al.hasIn=qs.hasIn,al.merge=ga,al.mergeWith=ya,al.mergeIn=Ta,al.mergeDeep=Ea,al.mergeDeepWith=Sa,al.mergeDeepIn=_a,al.setIn=ca,al.update=ha,al.updateIn=va,al.withMutations=wa,al.asMutable=Ra,al.asImmutable=Aa,al[Fo]=al.entries,al.toJSON=al.toObject=qs.toObject,al.inspect=al.toSource=function(){return this.toString()};var dl,pl=function(e){function t(e,r){if(!(this instanceof t))return new t(e,r);if(this._value=e,this.size=void 0===r?1/0:Math.max(0,r),0===this.size){if(dl)return dl;dl=this}}return e&&(t.__proto__=e),t.prototype=Object.create(e&&e.prototype),t.prototype.constructor=t,t.prototype.toString=function(){return 0===this.size?"Repeat []":"Repeat [ "+this._value+" "+this.size+" times ]"},t.prototype.get=function(e,t){return this.has(e)?this._value:t},t.prototype.includes=function(e){return li(this._value,e)},t.prototype.slice=function(e,r){var n=this.size;return so(e,r,n)?this:new t(this._value,uo(r,n)-lo(e,n))},t.prototype.reverse=function(){return this},t.prototype.indexOf=function(e){return li(this._value,e)?0:-1},t.prototype.lastIndexOf=function(e){return li(this._value,e)?this.size:-1},t.prototype.__iterate=function(e,t){for(var r=this.size,n=0;n!==r&&!1!==e(this._value,t?r-++n:n++,this););return n},t.prototype.__iterator=function(e,t){var r=this,n=this.size,o=0;return new Do((function(){return o===n?{value:void 0,done:!0}:Mo(e,t?n-++o:o++,r._value)}))},t.prototype.equals=function(e){return e instanceof t?li(this._value,e._value):As(this,e)},t}(Ho);function fl(e,t){return hl([],t||vl,e,"",t&&t.length>2?[]:void 0,{"":e})}function hl(e,t,r,n,o,i){if("string"!=typeof r&&!Co(r)&&(Wo(r)||Uo(r)||Zi(r))){if(~e.indexOf(r))throw new TypeError("Cannot convert circular structure to Immutable");e.push(r),o&&""!==n&&o.push(n);var a=t.call(i,n,zo(r).map((function(n,i){return hl(e,t,n,i,o,r)})),o&&o.slice());return e.pop(),o&&o.pop(),a}return r}function vl(e,t){return mo(t)?t.toList():go(t)?t.toMap():t.toSet()}const gl={version:"4.3.7",Collection:Oo,Iterable:Oo,Seq:zo,Map:Ia,OrderedMap:fs,List:Za,Stack:bs,Set:xs,OrderedSet:el,PairSorting:{LeftThenRight:-1,RightThenLeft:1},Record:il,Range:Ds,Repeat:pl,is:li,fromJS:fl,hash:pi,isImmutable:Co,isCollection:ho,isKeyed:go,isIndexed:mo,isAssociative:bo,isOrdered:xo,isValueObject:si,isPlainObject:Zi,isSeq:wo,isList:Ja,isMap:ii,isOrderedMap:ai,isStack:ms,isSet:ws,isOrderedSet:Rs,isRecord:Ao,get:na,getIn:Ms,has:ra,hasIn:Us,merge:function(e){for(var t=[],r=arguments.length-1;r-- >0;)t[r]=arguments[r+1];return Oa(e,t)},mergeDeep:function(e){for(var t=[],r=arguments.length-1;r-- >0;)t[r]=arguments[r+1];return ba(e,t)},mergeWith:function(e,t){for(var r=[],n=arguments.length-2;n-- >0;)r[n]=arguments[n+2];return Oa(t,r,e)},mergeDeepWith:function(e,t){for(var r=[],n=arguments.length-2;n-- >0;)r[n]=arguments[n+2];return ba(t,r,e)},remove:ia,removeIn:da,set:aa,setIn:ua,update:fa,updateIn:sa};var yl=0;const ml=function(){var e=((new Date).getTime().toString(16)+"FF").substr(0,11);return"ssssssss-xxxx-4xxx-yxxx-x".replace(/[xys]/g,(function(e){var t="s"===e?Math.floor(16*Math.random()):15&yl++;return("x"===e?t:3&t|8).toString(16)}))+e};function bl(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);t&&(n=n.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),r.push.apply(r,n)}return r}var Ol=["formatValue","mongoFormatValue","sqlFormatValue","jsonLogic","elasticSearchFormatValue","spelFormatValue","spelImportFuncs","spelImportValue"],El=["formatOp","mongoFormatOp","sqlFormatOp","jsonLogic","spelFormatOp"],Sl=function(e){return"object"===kn(e)&&null!==e&&"[object Object]"===Object.prototype.toString.call(e)},Tl=function(e){if("object"===kn(e)&&null!==e){if(Array.isArray(e))return Qn(e);if(Sl(e))return function(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{};t%2?bl(Object(r),!0).forEach((function(t){Gn(e,t,r[t])})):Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(r)):bl(Object(r)).forEach((function(t){Object.defineProperty(e,t,Object.getOwnPropertyDescriptor(r,t))}))}return e}({},e)}return e},_l=function(e,t){return Object.fromEntries(Object.entries(e).filter((function(e){var r=Hn(e,1)[0];return!t.includes(r)})))},wl=function(e){var t;return null!==(t=null==e?void 0:e.cardinality)&&void 0!==t?t:1},Rl=function(e,t){return e===t||(Ia.isMap(e)?e.equals(t):JSON.stringify(e)==JSON.stringify(t))},Al=function(e,t){var r=arguments.length>2&&void 0!==arguments[2]&&arguments[2];return e===t||(Array.isArray(e)?function(e,t){var r=arguments.length>2&&void 0!==arguments[2]&&arguments[2];if(e===t)return!0;if(!e||!t)return!1;var n=e.length;if(t.length!==n)return!1;for(var o=0;o<n;o++)if(!(r?Al(e[o],t[o],r):e[o]===t[o]))return!1;return!0}(e,t,r):Ia.isMap(e)?e.equals(t):"object"==kn(e)?function(e,t){var r=arguments.length>2&&void 0!==arguments[2]&&arguments[2];if(e===t)return!0;if(!e||!t)return!1;var n=Object.keys(e),o=Object.keys(t),i=n.length;if(o.length!==i)return!1;for(var a=0;a<i;a++){var s=n[a];if(!(r?Al(e[s],t[s],r):e[s]===t[s]))return!1}return!0}(e,t,r):e===t)};var Cl=function(e){return"object"===kn(e)&&null!==e&&"function"==typeof e.toJS},Il=function(e){return Cl(e)&&gl.isList(e)};function xl(e){return Il(e)?e:new gl.List(e)}function Ll(e){return Cl(e)?e.toJS():e}var Nl=function(e){return e.replace(/[.*+?^${}()|[\]\\/]/g,"\\$&")},jl=function(e,t,r,n,o,i){if(Array.isArray(e))return t},Pl=function e(t){var r;if(t instanceof Array)return t.map((function(t,r){return e(t)}));if("object"===kn(t)&&null!==t&&kl(t)){var n,o=_l(t,["$$typeof","_owner","_store","ref","key"]);return o.type&&(o.type="string"==typeof(r=o.type)?r:"function"==typeof r?r.name:r),null!=o&&null!==(n=o.props)&&void 0!==n&&n.children&&(o.props.children=e(o.props.children)),o}return t},kl=function(e){return"object"===kn(e)&&null!==e&&!Array.isArray(e)&&Object.keys(e).includes("type")&&Object.keys(e).includes("props")&&Object.keys(e).includes("key")&&Object.keys(e).includes("ref")&&Object.keys(e).includes("$$typeof")},Fl=function(e){return"object"===kn(e)&&null!==e&&!Array.isArray(e)&&"string"==typeof e.type&&Object.keys(e).includes("props")},Dl=function(e){return"object"===kn(e)&&null!==e&&!Array.isArray(e)&&1===Object.keys(e).length};function Ml(e){return new Promise((function(t){setTimeout(t,e)}))}function Vl(e,t){return e||(e=[]),t||(t=[]),t.map((function(t){return[t,e.indexOf(t)]})).map((function(e,t,r){var n=Hn(e,2),o=n[0];if(-1==n[1]){var i=r.slice(t+1),a=r.slice(0,t).reverse().find((function(e){var t=Hn(e,2);return t[0],-1!=t[1]})),s=i.find((function(e){var t=Hn(e,2);return t[0],-1!=t[1]}));return s?[o,"before",s[0]]:a?[o,"after",a[0]]:[o,"append",null]}return null})).filter((function(e){return null!==e})).reduce((function(e,t){var r=Hn(t,3),n=r[0],o=r[1],i=r[2],a=e.indexOf(i);return-1==e.indexOf(n)&&(a>-1?e.splice(a+("after"==o?1:0),0,n):e.splice("append"==o?1/0:0,0,n)),e}),e.slice())}var Ul=function e(t){"object"!==kn(t)||null===t||kl(t)||(Object.keys(t).forEach((function(r){"__cache"!==r&&e(t[r])})),Object.freeze(t))},Bl=function e(t,r){var n=arguments.length>2&&void 0!==arguments[2]?arguments[2]:{},o=arguments.length>3&&void 0!==arguments[3]?arguments[3]:[];if(Sl(t)){if(t.var)return n[t.var]=r,!0;if(!Sl(r))return!1;for(var i in t)if(!e(t[i],r[i],n,[].concat(Qn(o),[i])))return!1;return!0}if(Array.isArray(t)){if(!Array.isArray(r))return!1;for(var a=0;a<t.length;a++)if(!e(t[a],r[a],n,[].concat(Qn(o),[a])))return!1;return!0}return t===r},ql=function(){var e=arguments.length>0&&void 0!==arguments[0]&&arguments[0];return(null!=e?e:("undefined"!=typeof process&&process.env,0))?console:{error:function(){},log:function(){},warn:function(){},debug:function(){},info:function(){}}},Gl=function(){for(var e,t=arguments.length>0&&void 0!==arguments[0]?arguments[0]:[],r=0;r<t.length;r++){var n=t[r];if(void 0!==n){e=n;break}}return e},Kl=ql(),Wl=p(6834),zl=p.n(Wl),$l=p(8831),Hl=p.n($l),Yl=p(8906),Ql=p.n(Yl),Xl=p(7027),Jl=p.n(Xl);function Zl(e,t){(null==t||t>e.length)&&(t=e.length);for(var r=0,n=new Array(t);r<t;r++)n[r]=e[r];return n}function eu(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);t&&(n=n.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),r.push.apply(r,n)}return r}function tu(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{};t%2?eu(Object(r),!0).forEach((function(t){Gn(e,t,r[t])})):Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(r)):eu(Object(r)).forEach((function(t){Object.defineProperty(e,t,Object.getOwnPropertyDescriptor(r,t))}))}return e}var ru=function(e){return"object"==kn(e)&&null!==e&&!Array.isArray(e)},nu=function(e,t){return null==e||""==e?void 0:ru(e)?tu(tu({},e),{},{title:e.title||e.value}):{value:e,title:void 0!==t?t:""+e}},ou=function(e){var t=nu(e);return ru(t)?tu(tu({},nu(e)),{},{isCustom:!0}):t},iu=function(e){if(Array.isArray(e))return e.map((function(e){return nu(e)}));if(!ru(e))return e;var t=[];for(var r in e){var n=e[r];t.push(nu(r,n))}return t},au=function(e,t){return Array.isArray(e)?e.map((function(e){return nu(e)})).find((function(e){return""+e.value==""+t})):void 0!==e[t]?nu(t,e[t]):void 0},su=function(e,t){if(null==e)return t;var r=au(e,t);return void 0!==r?r.title:t},lu=function(e,t){if(null==e)return t;var r=au(e,t);return void 0!==r?r.value:t},uu=function(e,t){var r=[];if(Array.isArray(e)){var n,o=function(e,t){var r="undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(!r){if(Array.isArray(e)||(r=function(e,t){if(e){if("string"==typeof e)return Zl(e,t);var r=Object.prototype.toString.call(e).slice(8,-1);return"Object"===r&&e.constructor&&(r=e.constructor.name),"Map"===r||"Set"===r?Array.from(e):"Arguments"===r||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(r)?Zl(e,t):void 0}}(e))||t&&e&&"number"==typeof e.length){r&&(e=r);var n=0,o=function(){};return{s:o,n:function(){return n>=e.length?{done:!0}:{done:!1,value:e[n++]}},e:function(e){throw e},f:o}}throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}var i,a=!0,s=!1;return{s:function(){r=r.call(e)},n:function(){var e=r.next();return a=e.done,e},e:function(e){s=!0,i=e},f:function(){try{a||null==r.return||r.return()}finally{if(s)throw i}}}}(e);try{for(o.s();!(n=o.n()).done;){var i=n.value,a=t(nu(i));null!=a&&r.push(a)}}catch(e){o.e(e)}finally{o.f()}}else for(var s in e){var l=t(nu(s,e[s]));null!=l&&r.push(l)}return r},cu=function(e,t){return uu(t,(function(t){return-1!="".concat(t.value).indexOf(e)||-1!=t.title.indexOf(e)?t:null})).filter((function(e){return null!==e})).shift()},du=function(e,t){return uu(t,(function(t){return""+t.value==""+e?t:null})).filter((function(e){return null!==e})).shift()},pu=function(e){for(var t=arguments.length,r=new Array(t>1?t-1:0),n=1;n<t;n++)r[n-1]=arguments[n];return e.interpose("children1").withMutations((function(e){return e.skip(1),e.push.apply(e,r),e}))},fu=function(e){for(var t=arguments.length,r=new Array(t>1?t-1:0),n=1;n<t;n++)r[n-1]=arguments[n];return e.interpose("children1").withMutations((function(e){return e.push.apply(e,r),e}))},hu=function(e,t){var r=new gl.OrderedMap(Gn({},e.get("id"),e)),n=e;return t.forEach((function(e){var t;n=r.get(e),r=null===(t=n)||void 0===t?void 0:t.get("children1")})),n},vu=function(e){var t=e;return function e(r,n){var o=arguments.length>2&&void 0!==arguments[2]&&arguments[2],i=n.push(r.get("id")),a=r.getIn(["properties","isLocked"]);o&&a&&(t=t.deleteIn(pu(i,"properties","isLocked")));var s=r.get("children1");s&&s.map((function(t,r){e(t,i,a||o)}))}(e,new gl.List),t},gu=function(e){var t=e;return function e(r,n,o,i){if(r){var a=r.get("path"),s=r.get("id"),l=s||i||ml(),u=n.push(l);a&&a.equals(u)||(t=t.setIn(pu(u,"path"),u)),s||(t=t.setIn(pu(u,"id"),l));var c=r.get("children1");c&&("Map"===c.constructor.name&&(t=t.setIn(pu(u,"children1"),new gl.OrderedMap(c))),c.map((function(t,r){e(t,u,o+1,r)})))}}(e,new gl.List,0),t},yu=function(e){var t=e;return function e(r,n,o,i){if(!r)return!1;var a=r.get("id")||i,s=n.push(a),l=r.get("children1");if(l){var u=l.map((function(t,r){return e(t,s,o+1,r)})).reduce((function(e,t){return e&&t}),!0);if((0==l.size||u)&&o>0)return t=t.deleteIn(pu(s)),!0}return!1}(e,new gl.List,0),t},mu=function(e){var t=[],r={},n=[],o=0,i=0,a=0,s={};!function l(u,c,d,p,f,h,v,g){var y=u===e,m=u.get("type"),b=u.get("collapsed"),O=u.get("id"),E=u.get("children1"),S=u.getIn(["properties","isLocked"]),T=E?E.map((function(e,t){return t})).valueSeq().toArray():null,_="rule_group"===m,w="rule"===m,R="group"===m,A="case_group"===m,C=!f&&(!E||_),I=(null==T?void 0:T.length)>0,x=c.length?c[c.length-1]:null,L=A?O:v;A&&(n.push(O),i=0,a=0,s={});var N,j=L?n.indexOf(L):null,P=t.length,k=o;y||((N={}).caseNo=j,N.globalNoByType=A?j:s[m]||0,N.indexPath=[].concat(Qn(c.slice(1).map((function(e){return r[e].childNo}))),[g]),w?N.globalLeafNo=i:R&&(N.globalGroupNo=a)),t.push(O),r[O]={node:u,index:P,id:O,type:m,parent:x,parentType:x?r[x].type:null,children:T,childNo:g,caseId:L,caseNo:j,path:c.concat(O),lev:h,isLeaf:!E,isAtomicRule:C,isLocked:S||p,top:d?null:k,isDefaultCase:A?!E:void 0,atomicRulesCountInCase:A?0:void 0,position:N,collapsed:b,_top:P,leaf:!E};var F=0,D=0;d||(o+=1,F+=1,!I||b||_||(D+=1),y||A||(R&&a++,w&&i++,s[m]=(s[m]||0)+1)),v&&C&&r[v].atomicRulesCountInCase++;var M=0,V=0;if(I){var U=0;E.map((function(e,t){if(e){l(e,c.concat(O),d||b,p||S,f||_,h+1,L,U);var n=r[t];M=Math.max(M,n.depth||0),V+=n.height,U++}}))}F+=V,D+=M;var B=t.length-P,q=d?null:k+F;Object.assign(r[O],{depth:E?D:void 0,_height:B,height:F,bottom:q})}(e,[],!1,!1,!1,0,null,null);for(var l=0;l<t.length;l++){var u=l>0?t[l-1]:null,c=l<t.length-1?t[l+1]:null,d=r[t[l]];d.prev=u,d.next=c}return{flat:t,items:r,cases:n}},bu=function(e){if(!e)return-1;var t=0;return function e(r,n,o){var i,a,s;"function"==typeof r.get?(i=r.get("id"),a=r.get("children1"),s=r.get("type")):(i=r.id,a=r.children1,s=r.type),t++,a&&"rule_group"!=s&&a.map((function(t,r){t&&e(t,n.concat(i),o+1)}))}(e,[],0),t-1},Ou=function(e){if(!e)return-1;var t=0;return function e(r,n,o){var i,a,s;"function"==typeof r.get?(i=r.get("id"),a=r.get("children1"),s=r.get("type")):(i=r.id,a=r.children1,s=r.type),"rule"==s||"rule_group"==s?t++:a&&a.map((function(t,r){t&&e(t,n.concat(i),o+1)}))}(e,[],0),t},Eu=function(e){var t=!(arguments.length>1&&void 0!==arguments[1])||arguments[1],r=!(arguments.length>2&&void 0!==arguments[2])||arguments[2],n=e;return function e(n,o){t&&n.path&&delete n.path,t&&!r&&o&&delete n.id;var i=n.properties;i&&null==i.operatorOptions&&delete i.operatorOptions;var a=n.children1;if(a){for(var s in a)a[s]&&e(a[s],s);r&&(n.children1=Object.values(a))}}(e,null),n},Su=function(e){var t=[],r=e.get("children1");return r&&r.map((function(e){var r,n=e.getIn(["properties","value"]);n&&1==n.size?(r=n.get(0),Array.isArray(r)&&0==r.length&&(r=null)):r=null,t=[].concat(Qn(t),[r])})),t},Tu=function(e){return!e.get("children1")||0==e.get("children1").size},_u=function(e,t){return e.getIn(pu(t,"children1")).size>0},wu=function(e){if(null!=e&&e.toJS){var t,r=null==e||null===(t=e.toJS)||void 0===t?void 0:t.call(e);return null!=r&&r.func?e.toOrderedMap():r}return e},Ru=function(e){var t=!(arguments.length>1&&void 0!==arguments[1])||arguments[1],r=!(arguments.length>2&&void 0!==arguments[2])||arguments[2];if(e){var n=e;return n=n.toJS(),Eu(n,t,r)}},Au=function(e){if(Cu(e))return e;if(Iu(e))return gu(xu(e));if("string"==typeof e&&e.startsWith('["~#iM"'))throw new Error("You are trying to load query in obsolete serialization format (Immutable string) which is not supported in versions starting from 2.1.17");if("string"==typeof e)return gu(xu(JSON.parse(e)));throw new Error("Can't load tree!")},Cu=function(e){return Ia.isMap(e)},Iu=function(e){return"object"==kn(e)&&("group"==e.type||"switch_group"==e.type)};function xu(e){var t=fl(e,(function(e,t,r){var n,o=r&&r.length>3&&"value"===r[r.length-1]&&"args"===r[r.length-3],i=r&&r.length>3&&"value"===r[r.length-1]&&"properties"===r[r.length-2];if("properties"==e){n=t.toOrderedMap();for(var a=0;a<2;a++){var s,l,u;null===(null===(s=n.get("value"))||void 0===s||null===(l=(u=s).get)||void 0===l?void 0:l.call(u,a))&&(n=n.setIn(["value",a],void 0))}}else n=o?wu(t):(r?i:"value"==e)&&gl.Iterable.isIndexed(t)?t.map(wu).toList():"asyncListValues"==e?t.toJS():"children1"==e&&gl.Iterable.isIndexed(t)?new gl.OrderedMap(t.map((function(e){return[(null==e?void 0:e.get("id"))||ml(),e]}))):gl.Iterable.isIndexed(t)?t.toList():t.toOrderedMap();return n}));return t}function Lu(e){return Kn(e)||Yn(e)||zn(e)||$n()}var Nu=p(2468),ju=p.n(Nu);function Pu(e,t){var r="undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(!r){if(Array.isArray(e)||(r=function(e,t){if(e){if("string"==typeof e)return ku(e,t);var r=Object.prototype.toString.call(e).slice(8,-1);return"Object"===r&&e.constructor&&(r=e.constructor.name),"Map"===r||"Set"===r?Array.from(e):"Arguments"===r||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(r)?ku(e,t):void 0}}(e))||t&&e&&"number"==typeof e.length){r&&(e=r);var n=0,o=function(){};return{s:o,n:function(){return n>=e.length?{done:!0}:{done:!1,value:e[n++]}},e:function(e){throw e},f:o}}throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}var i,a=!0,s=!1;return{s:function(){r=r.call(e)},n:function(){var e=r.next();return a=e.done,e},e:function(e){s=!0,i=e},f:function(){try{a||null==r.return||r.return()}finally{if(s)throw i}}}}function ku(e,t){(null==t||t>e.length)&&(t=e.length);for(var r=0,n=new Array(t);r<t;r++)n[r]=e[r];return n}function Fu(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);t&&(n=n.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),r.push.apply(r,n)}return r}function Du(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{};t%2?Fu(Object(r),!0).forEach((function(t){Gn(e,t,r[t])})):Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(r)):Fu(Object(r)).forEach((function(t){Object.defineProperty(e,t,Object.getOwnPropertyDescriptor(r,t))}))}return e}var Mu=function(e){return{errors:[],settings:null==e?void 0:e.settings}},Vu=function(e,t){return Uu(e,t,!1)},Uu=function(e,t){var r=!(arguments.length>2&&void 0!==arguments[2])||arguments[2],n=Mu();n.settings={allowUnknownFields:!1,returnErrors:r};var o=nv(t,void 0,!1),i=Bu(o),a=e?qu(e,i,o,["rule","group","switch"],n):void 0,s=a?Au(a):void 0;return r?[s,n.errors]:(n.errors.length&&console.warn("Errors while importing from JsonLogic:",n.errors),s)},Bu=function(e){var t={};for(var r in e.operators){var n=e.operators[r];if("string"==typeof n.jsonLogic){var o=(n._jsonLogicIsRevArgs?"#":"")+n.jsonLogic+"/"+wl(n);t[o]||(t[o]=[]),t[o].push(r)}else if("string"==typeof n.jsonLogic2){var i=n.jsonLogic2+"/"+wl(n);t[i]||(t[i]=[]),t[i].push(r)}}var a={};for(var s in e.conjunctions)a[e.conjunctions[s].jsonLogicConj||s.toLowerCase()]=s;var l,u={},c=Pu(fv(e));try{for(c.s();!(l=c.n()).done;){var d=Hn(l.value,2),p=d[0],f=d[1],h=void 0;f.jsonLogicIsMethod?h="#"+f.jsonLogic:"string"==typeof f.jsonLogic&&(h=f.jsonLogic),h&&(u[h]||(u[h]=[]),u[h].push(p))}}catch(e){c.e(e)}finally{c.f()}var v=e.settings.jsonLogic;return{operators:t,conjunctions:a,funcs:u,varKeys:["var",v.groupVarKey,v.altVarKey]}},qu=function e(t,r,n,o,i){var a,s,l,u=arguments.length>5&&void 0!==arguments[5]&&arguments[5],c=arguments.length>6?arguments[6]:void 0,d=arguments.length>7?arguments[7]:void 0,p=arguments.length>8&&void 0!==arguments[8]?arguments[8]:null;Dl(t)&&(s=t[a=Object.keys(t)[0]],Array.isArray(s)||(s=[s]));var f=i.errors.length,h=n.settings.jsonLogic.lockedOp,v="!"==a&&1==s.length&&s[0]&&Dl(s[0])&&r.varKeys.includes(Object.keys(s[0])[0]),g="!"==a&&!v,y=h&&a==h,m=o.includes("switch");y?l=e(s[0],r,n,o,i,u,c,d,p,!0):g?l=e(s[0],r,n,o,i,!u,c,d,p):o.includes("val")?l=Ku(a,s,r,n,u,i,p)||Wu(a,s,r,n,u,c,i,p)||Gu(t,c,d,n,i):(o.includes("switch")&&(l=Qu(a,s,r,n,u,i,p)),null==l&&o.includes("group")&&(l=zu(a,s,r,n,u,i,p,!1)),null==l&&o.includes("rule")&&(l=Yu(a,s,r,n,u,i,p)),l&&m&&!["group","switch_group"].includes(l.type)&&(l=$u(l,n)));var b=i.errors.length;return"!"!=a&&void 0===l&&b==f&&i.errors.push("Can't parse logic ".concat(JSON.stringify(t))),y&&(l.properties.isLocked=!0),l},Gu=function(e,t,r,n,o){var i;if(void 0===e&&(e=null==t?void 0:t.defaultValue),void 0!==e){r=r||(null==t?void 0:t.mainWidget);var a=n.widgets[r],s=null==t?void 0:t.type;if(!s||a){if(!Dl(e)){if("time"===s&&"number"==typeof e){var l=Math.floor(e/60/60)%24,u=Math.floor(e/60)%60,c=e%60,d=a.valueFormat;if(d){var p=new Date(e);p.setMilliseconds(0),p.setHours(l),p.setMinutes(u),p.setSeconds(c),e=ju()(p).format(d)}else e="".concat(l,":").concat(u,":").concat(c)}if(["date","datetime"].includes(s)&&e&&!(e instanceof Date))try{var f=new Date(e);f instanceof Date&&f.toISOString()===e&&(e=f)}catch(t){o.errors.push("Can't convert value ".concat(e," as Date")),e=void 0}if(e instanceof Date&&t){var h=a.valueFormat;h&&(e=ju()(e).format(h))}var v;if(e&&null!=t&&null!==(i=t.fieldSettings)&&void 0!==i&&i.asyncFetch&&(v=Array.isArray(e)?e:[e]),null!=a&&a.jsonLogicImport)try{e=a.jsonLogicImport.call(n.ctx,e)}catch(t){var g;o.errors.push("Can't import value ".concat(e," using import func of widget ").concat(r,": ").concat(null!==(g=null==t?void 0:t.message)&&void 0!==g?g:t)),e=void 0}return{valueSrc:"value",value:e,valueType:null==a?void 0:a.type,asyncListValues:v}}o.errors.push("Unexpected logic in value: ".concat(JSON.stringify(e)))}else o.errors.push("No widget for type ".concat(s))}},Ku=function(e,t,r,n,o,i){var a=arguments.length>6&&void 0!==arguments[6]?arguments[6]:null;if(r.varKeys.includes(e)&&"string"==typeof t[0]){var s,l=yv(n,t[0],a),u=Iv(n,l);return u||null!==(s=i.settings)&&void 0!==s&&s.allowUnknownFields?{valueSrc:"field",value:l,valueType:null==u?void 0:u.type}:void i.errors.push("No config for field ".concat(l))}},Wu=function(e,t,r,n,o){var i=arguments.length>5&&void 0!==arguments[5]?arguments[5]:null,a=arguments.length>6?arguments[6]:void 0,s=arguments.length>7&&void 0!==arguments[7]?arguments[7]:null;if(e){var l,u,c,d="method"==e;if(d){var p,f,h=Lu(t);p=h[0],l=h[1],f=h.slice(2),u=[p].concat(Qn(f))}else l=e,u=t;var v=(d?"#":"")+l,g=(null==i?void 0:i.type)||(null==i?void 0:i.returnType),y=(r.funcs[v]||[]).filter((function(e){return!i||bv(n,e).returnType==g}));if(y.length)c=y[0];else{var m,b=Gn({},e,t),O=Pu(fv(n));try{for(O.s();!(m=O.n()).done;){var E=Hn(m.value,2),S=E[0],T=E[1];if(T.jsonLogicImport&&(!g||T.returnType==g)){var _=void 0;try{_=T.jsonLogicImport(b)}catch(e){}_&&(c=S,u=_)}}}catch(e){O.e(e)}finally{O.f()}}if(c&&c){var w=bv(n,c),R=Object.keys(w.args||{}),A=u.reduce((function(e,t,o){var i,l=R[o],u=w.args[l];return u&&(i=qu(t,r,n,["val"],a,!1,u,null,s)),void 0!==i?Du(Du({},e),{},Gn({},l,i)):e}),{});for(var C in w.args){var I,x=w.args[C],L=A[C];if(void 0===L)if(void 0!==(L=null==x?void 0:x.defaultValue)&&(L={value:L,valueSrc:null!==(I=L)&&void 0!==I&&I.func?"func":"value",valueType:x.type}),void 0===L){if(null==x||!x.isOptional)return void a.errors.push("No value for arg ".concat(C," of func ").concat(c))}else A[C]=L}return{valueSrc:"func",value:{func:c,args:A},valueType:w.returnType}}}},zu=function(e,t,r,n,o,i){var a,s=arguments.length>6&&void 0!==arguments[6]?arguments[6]:null,l=r.conjunctions[e],u=n.settings.fieldSeparator;if(l){var c=t.map((function(e){return qu(e,r,n,["rule","group"],i,!1,null,null,s)})).filter((function(e){return void 0!==e})).reduce((function(e,t){return Du(Du({},e),{},Gn({},t.id,t))}),{}),d=Object.values(c).map((function(e){var t,r;return"field"==(null==e||null===(t=e.properties)||void 0===t?void 0:t.fieldSrc)&&(null==e||null===(r=e.properties)||void 0===r?void 0:r.field)})).filter((function(e){var t;return null==e||null===(t=e.includes)||void 0===t?void 0:t.call(e,u)})),p=Object.fromEntries((a=d,Array.from(new Set(a))).map((function(e){var t=e.split(u),r=Object.fromEntries(t.slice(0,-1).map((function(e,t,r){return[].concat(Qn(r.slice(0,t)),[e])})).map((function(e){return[e.join(u),Iv(n,e)]})).filter((function(e){var t=Hn(e,2),r=(t[0],t[1]);return"!group"==(null==r?void 0:r.type)})));return[e,Object.keys(r)]}))),f={conjunction:l,not:o},h=ml(),v={},g={};return Object.entries(c).map((function(e){var t=Hn(e,2),r=t[0],o=t[1];if("group"==(null==o?void 0:o.type)||"rule_group"==(null==o?void 0:o.type))v[r]=o;else{var i,a=null==o||null===(i=o.properties)||void 0===i?void 0:i.field,c=p[a]||[],d=c[c.length-1];if(d){var f=v,h=Tv(s,n),y=Tv(d,n);Al(h,y.slice(0,h.length))||(h=[]);var m=d.split(u).slice(h.length).map((function(e,t,r){return[].concat(Qn(h),Qn(r.slice(0,t)),[e]).join(u)})).map((function(e){return{f:e,fc:Iv(n,e)||{}}})).filter((function(e){return"!struct"!=e.fc.type}));m.map((function(e,t){var r=e.f,n=e.fc,o=g[r];o||(o=ml(),g[r]=o,f[o]={type:"rule_group",id:o,children1:{},properties:{conjunction:l,not:!1,field:r,fieldSrc:"field",mode:n.mode}}),f=f[o].children1})),f[r]=o}else o&&(v[r]=o)}})),{type:"group",id:h,children1:v,properties:f}}},$u=function(e,t){var r=arguments.length>2&&void 0!==arguments[2]&&arguments[2];return{type:"group",id:ml(),children1:Gn({},e.id,e),properties:{conjunction:hd(t),not:r}}},Hu=function(e,t,r,n,o,i,a,s){var l,u,c=!(("all"===e||"some"===e)&&Dl(r[1])&&"in"==Object.keys(r[1])[0]&&""===(null===(l=r[1].in[0])||void 0===l?void 0:l.var))&&i.settings.groupOperators.includes(e),d=c?0:t-1;c?d=0:["==","!="].includes(e)&&1==d&&null===r[1]&&(t=1,d=0,r=[r[0]]);var p=e+"/"+d,f=o.operators[(a?"#":"")+p];if(f){var h,v=[];if(["<","<=",">",">="].includes(e)&&3==t)h=r[1],v=[r[0],r[2]];else if(a)h=r[1],v=[r[0]];else{var g=Lu(r);h=g[0],v=g.slice(1)}if(Dl(h)){var y=function(e,t,r,n,o){var i,a,s,l,u=arguments.length>5&&void 0!==arguments[5]?arguments[5]:null,c=arguments.length>6&&void 0!==arguments[6]?arguments[6]:null,d=arguments.length>7?arguments[7]:void 0,p=arguments.length>8&&void 0!==arguments[8]?arguments[8]:null,f=Object.keys(t)[0],h=Object.values(t)[0],v=function(e,t){return function(e,t,r,n,o,i){var a=arguments.length>6&&void 0!==arguments[6]?arguments[6]:null;Array.isArray(t)||(t=[t]);var s=Ku(e,t,r,n,o,i,a);if(s)return{fieldSrc:"field",field:s.value}}(e,t,n,o,u,d,p)||function(e,t,r,n,o){var i=Wu(e,t,r,n,o,arguments.length>5&&void 0!==arguments[5]?arguments[5]:null,arguments.length>6?arguments[6]:void 0,arguments.length>7&&void 0!==arguments[7]?arguments[7]:null);if(i)return{fieldSrc:"func",field:i.value}}(e,t,n,o,u,c,d,p)},g=d.errors.length,y=v(f,h);if(y&&(i=y.field,a=y.fieldSrc),e&&(l=!0,s=r[0],r=[]),"reduce"==f&&Array.isArray(h)&&3==h.length){var m=Hn(h,3),b=m[0],O=m[1],E=m[2];if(Dl(b)&&0==E&&Dl(O)&&Array.isArray(O["+"])&&1==O["+"][0]&&Dl(O["+"][1])&&"accumulator"==O["+"][1].var)if(f=Object.keys(b)[0],h=Object.values(b)[0],"filter"==f){var S=Hn(h,2),T=S[0],_=S[1];if(Dl(T)){var w=v(f=Object.keys(T)[0],h=Object.values(T)[0]);w&&(i=w.field,a=w.fieldSrc,s=_,l=!0)}}else{var R=v(f,h);R&&(i=R.field,a=R.fieldSrc,l=!0)}}var A=d.errors.length;if(i||A!=g||d.errors.push("Unknown LHS ".concat(JSON.stringify(t))),i)return{field:i,fieldSrc:a,having:s,isGroup:l,args:r}}(c,h,v,o,i,null,null,s,n);if(y){var m=y.field,b=y.fieldSrc,O=y.having,E=(y.isGroup,y.args),S=Iv(i,m);if(S||null!==(u=s.settings)&&void 0!==u&&u.allowUnknownFields){var T=f[0];if(f.length>1&&S&&S.operators){if(0==(f=f.filter((function(e){return S.operators.includes(e)}))).length)return void s.errors.push("No corresponding ops for LHS ".concat(m));T=f[0]}return{field:m,fieldSrc:b,fieldConfig:S,opKey:T,args:E,having:O}}s.errors.push("No config for LHS ".concat(m))}}else s.errors.push("Incorrect operands for ".concat(e,": ").concat(JSON.stringify(r)))}},Yu=function e(t,r,n,o,i,a){var s,l=arguments.length>6&&void 0!==arguments[6]?arguments[6]:null,u=arguments.length>7&&void 0!==arguments[7]&&arguments[7];if(t){var c=r.length;if(("all"===t||"some"===t)&&Dl(r[1])){var d,p=Object.keys(r[1])[0],f=""===(null===(d=r[1][p][0])||void 0===d?void 0:d.var);"in"===p&&f&&(r=[r[0],r[1][p][1]],t=t+"-"+p)}var h=function(e,t,r,n,o,i,a){var s=Mu(a),l=Hu(e,t,r,n,o,i,!1,s);if(l||(l=Hu(e,t,r,n,o,i,!0,Mu(a))),l)return l;a.errors.push(s.errors.join("; ")||"Unknown op ".concat(e,"/").concat(t))}(t,c,r,l,n,o,a);if(h){var v,g,y=h.field,m=h.fieldSrc,b=h.fieldConfig,O=h.opKey,E=h.args,S=h.having,T=Iv(o,l),_=o.operators[O],w=!!o.operators[null===(s=_)||void 0===s?void 0:s.reversedOp],R="!group"==b.type,A="!group"==(null==T?void 0:T.type),C=w&&(!!o.settings.reverseOperatorsForNot||R&&!S||!R&&A&&!u),I=i&&C||!1,x=!1;if("!group"==(null==b?void 0:b.type)&&S){for(g=S[v=Object.keys(S)[0]],Array.isArray(g)||(g=[g]);"!"==v&&!("!"==v&&1==g.length&&g[0]&&Dl(g[0])&&n.varKeys.includes(Object.keys(g[0])[0]));)x=!x,g=(S=S["!"])[v=Object.keys(S)[0]];Array.isArray(g)||(g=[g])}I&&(i=!i,O=_.reversedOp,_=o.operators[O]);var L=Qf(o,y,O,null),N=E.map((function(e){return qu(e,n,o,["val"],a,!1,b,L,l)}));if(!N.filter((function(e){return void 0===e})).length){var j,P=null==b?void 0:b.type;if("!group"!==P&&"!struct"!==P||(P=null),"!group"==(null==b?void 0:b.type)&&S){var k;if(void 0!==n.conjunctions[v]?j=zu(v,g,n,o,x,a,y,!0):(j=e(v,g,n,o,x,a,y,!0))&&("rule_group"===j.type&&(null===(k=j.properties)||void 0===k?void 0:k.field)!==y&&(j=function(e,t,r,n){var o=arguments.length>4&&void 0!==arguments[4]?arguments[4]:void 0,i=arguments.length>5&&void 0!==arguments[5]&&arguments[5];if(e)return{type:"rule_group",id:ml(),children1:Gn({},e.id,e),properties:{conjunction:o||fd(n,r),not:i,field:t}}}(j,y,b,o)),Object.assign(j.properties,{conjunction:fd(o,b)})),!j)return;j.type="rule_group",Object.assign(j.properties,{field:y,mode:b.mode,operator:O}),"array"==b.mode&&Object.assign(j.properties,{value:N.map((function(e){return e.value})),valueSrc:N.map((function(e){return e.valueSrc})),valueType:N.map((function(e){return e.valueType}))}),i&&(j=$u(j,o,i))}else if("!group"!=(null==b?void 0:b.type)||S){var F=N.map((function(e){return e.asyncListValues})).filter((function(e){return null!=e})),D=F.length?F[0]:void 0;j={type:"rule",id:ml(),properties:Du({field:y,fieldSrc:m,operator:O,value:N.map((function(e){return e.value})),valueSrc:N.map((function(e){return e.valueSrc})),valueType:N.map((function(e){return e.valueType}))},D?{asyncListValues:D}:{})},(i||u)&&(j=$u(j,o,i))}else j={type:"rule_group",id:ml(),children1:{},properties:{conjunction:fd(o,b),not:!1,mode:b.mode,field:y,operator:O}},"array"===b.mode&&Object.assign(j.properties,{value:N.map((function(e){return e.value})),valueSrc:N.map((function(e){return e.valueSrc})),valueType:N.map((function(e){return e.valueType}))}),i&&(j=$u(j,o,i));return j}}}},Qu=function(e,t,r,n,o,i){var a=arguments.length>6&&void 0!==arguments[6]?arguments[6]:null;if("if"===(null==e?void 0:e.toLowerCase())){var s=Xu(t).map((function(e){var t=Hn(e,2),o=t[0],s=t[1];return[o?qu(o,r,n,["rule","group"],i,!1,null,null,a):null,Zu(n,i,r,s)]})).map((function(e){var t=Hn(e,2),r=t[0],o=t[1];return Ju(r,o,n,i)}));return{type:"switch_group",id:ml(),children1:s,properties:{}}}},Xu=function(e){var t=[];return function e(r){var n=Hn(r,3),o=n[0],i=n[1],a=n[2];t.push([o,i]);var s=Dl(a)?Object.keys(a)[0]:null;"if"===(null==s?void 0:s.toLowerCase())?e(a[s]):t.push([void 0,a])}(e),t},Ju=function(e,t,r,n){var o;return e?(o=Du({},e)).type?("group"!=o.type&&(o=$u(o,r)),o.type="case_group"):(n.errors.push("Unexpected case: ".concat(JSON.stringify(o))),o=void 0):o={id:ml(),type:"case_group",properties:{}},o&&(o.properties=Du(Du({},o.properties),t)),o},Zu=function(e,t,r,n){var o=Iv(e,"!case_value");if(o){var i=o.mainWidget,a=e.widgets[i];if(a){var s=qu(n,r,e,["val","case_val"],t,!1,o,i);if(null!=s){var l=s.value,u=s.valueSrc,c=s.valueType;return{value:[l],valueSrc:[null!=u?u:"value"],valueType:[null!=c?c:null==a?void 0:a.type],field:"!case_value"}}}else t.errors.push("No widget ".concat(i," for case value"))}else t.errors.push("Missing caseValueField in settings")},ec=p(138),tc=p(358),rc=p.n(tc)();rc.trim=function(e){return"'"==e.charAt(0)?e.substring(1,e.length-1):e},rc.escapeLike=function(e){var t=!(arguments.length>1&&void 0!==arguments[1])||arguments[1],r=!(arguments.length>2&&void 0!==arguments[2])||arguments[2],n=rc.escape(e);return"'"+(n=(t?"%":"")+(n=(n=rc.trim(n)).replace(/[%_]/g,"\\$&"))+(r?"%":""))+"'"};var nc=function(e){var t="''",r=null==e?void 0:e.type;return"date"==r?t="'0000-00-00'":"datetime"==r?t="'0000-00-00 00:00'":"time"==r?t="'00:00'":"number"==r&&(t="0"),t},oc=function(e){var t="";return"number"==(null==e?void 0:e.type)&&(t=0),t},ic=function(e){return"".concat(e,".?[true]")},ac=function(e){var t=arguments.length>1&&void 0!==arguments[1]&&arguments[1],r=arguments.length>2&&void 0!==arguments[2]&&arguments[2];if(null==e)return"null";switch(kn(e)){case"boolean":return e?"true":"false";case"number":if(!Number.isFinite(e)||isNaN(e))return;return e+(!Number.isInteger(e)||t?"f":"");case"object":if(Array.isArray(e))return function(e){var t,r,n,o=arguments.length>1&&void 0!==arguments[1]&&arguments[1],i=["int","float"];return e.map((function(e){if(null!=e){if("string"==typeof e)r="String";else{if("number"!=typeof e)throw new Error("spelEscape: Can't use value ".concat(e," in array"));r=Number.isInteger(e)?"int":"float"}if(t){if(t!=r){if(!i.includes(t)||!i.includes(r))throw new Error("spelEscape: Can't use different types in array: found ".concat(t," and ").concat(r));t="float"}}else t=r}})),t||(t="String"),n="float"==t?e.map((function(e){return ac(e,!0)})):e.map((function(e){return ac(e)})),o?"new ".concat(t,"[]{").concat(n.join(", "),"}"):"{".concat(n.join(", "),"}")}(e,r);throw new Error("spelEscape: Object is not supported");default:return function(e){return"'"+e.replace(/'/g,"''")+"'"}(e)}},sc=function(e){return e&&Array.isArray(e)&&e.length?e.map((function(e){return"const"==e.type?ac(e.value):"property"==e.type?""+e.value:"variable"==e.type?"#"+e.value:void 0})).filter((function(e){return null!=e})).join(" + "):"null"},lc=function(e){if(null==e)return[void 0,[]];var t=[],r="case_value"==e.valueType?e.value:e;return[(Array.isArray(r)?r:[r]).map((function(e){return"value"===e.valueSrc?null===e.value?void 0:{type:"const",value:e.value}:"field"===e.valueSrc?{type:e.isVariable?"variable":"property",value:e.value}:void t.push("Unsupported valueSrc ".concat(e.valueSrc," in concatenation"))})).filter((function(e){return null!=e})),t]},uc=function(e){return null==e?"NULL":e.toString()},cc=function(e){return null==e||"("===(null==e?void 0:e[0])&&")"===(null==e?void 0:e[(null==e?void 0:e.length)-1])?e:"("+e+")"};function dc(e,t){var r="undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(!r){if(Array.isArray(e)||(r=function(e,t){if(e){if("string"==typeof e)return pc(e,t);var r=Object.prototype.toString.call(e).slice(8,-1);return"Object"===r&&e.constructor&&(r=e.constructor.name),"Map"===r||"Set"===r?Array.from(e):"Arguments"===r||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(r)?pc(e,t):void 0}}(e))||t&&e&&"number"==typeof e.length){r&&(e=r);var n=0,o=function(){};return{s:o,n:function(){return n>=e.length?{done:!0}:{done:!1,value:e[n++]}},e:function(e){throw e},f:o}}throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}var i,a=!0,s=!1;return{s:function(){r=r.call(e)},n:function(){var e=r.next();return a=e.done,e},e:function(e){s=!0,i=e},f:function(){try{a||null==r.return||r.return()}finally{if(s)throw i}}}}function pc(e,t){(null==t||t>e.length)&&(t=e.length);for(var r=0,n=new Array(t);r<t;r++)n[r]=e[r];return n}function fc(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);t&&(n=n.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),r.push.apply(r,n)}return r}function hc(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{};t%2?fc(Object(r),!0).forEach((function(t){Gn(e,t,r[t])})):Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(r)):fc(Object(r)).forEach((function(t){Object.defineProperty(e,t,Object.getOwnPropertyDescriptor(r,t))}))}return e}var vc="${0}.compareTo(${1})",gc={datetime:!0,time:!0,date:!0},yc=function(e,t){return mc(e,t,!1)},mc=function(e,t){var r=!(arguments.length>2&&void 0!==arguments[2])||arguments[2],n={errors:[]},o=nv(t,void 0,!1),i=bc(e,o,n,null);return r?[i,n.errors]:(n.errors.length&&console.warn("Errors while exporting to SpEL:",n.errors),i)},bc=function(e,t,r){var n=arguments.length>3&&void 0!==arguments[3]?arguments[3]:null;if(e){var o=e.get("type");return"group"===o||"rule_group"===o?Sc(e,t,r,n):"rule"===o?wc(e,t,r,n):"switch_group"==o?Ec(e,t,r,n):"case_group"==o?Oc(e,t,r,n):void 0}},Oc=function(e,t,r){var n=arguments.length>3&&void 0!==arguments[3]?arguments[3]:null,o=e.get("type");if("case_group"==o){var i=e.get("properties")||new Ia,a=Hn(Ac(t,i,r,null,n,"!case_value"),3),s=a[0];return a[1],a[2],[Sc(e,t,r,n),s]}r.errors.push("Unexpected child of type ".concat(o," inside switch"))},Ec=function(e,t,r){e.get("properties")||new Ia;var n=e.get("children1");if(n){var o=n.map((function(e){return Oc(e,t,r,null)})).filter((function(e){return void 0!==e})).valueSeq().toArray();if(o.length){if(1==o.length&&!o[0][0])return o[0][1];for(var i=[],a=0;a<o.length;a++)a==o.length-1||o[a][0]?(i.push(o[a]),a==o.length-1&&o[a][0]&&i.push([void 0,null])):r.errors.push("No condition for case ".concat(a));for(var s="",l="",u=0;u<i.length;u++){var c=Hn(i[u],2),d=c[0],p=c[1];null==p&&(p="null"),null==d&&(d="true"),u!=i.length-1?(s+="(".concat(d," ? ").concat(p," : "),l+=")"):s+="".concat(p)}return s+l}}},Sc=function(e,t,r){var n=arguments.length>3&&void 0!==arguments[3]?arguments[3]:null,o=e.get("type"),i=e.get("properties")||new Ia,a=i.get("mode"),s=e.get("children1")||new Za,l=i.get("field"),u=i.get("conjunction");u||(u=hd(t));var c=t.conjunctions[u],d=i.get("not"),p="rule_group"===o,f=p&&"struct"!=a,h=f?l:n,v=(Iv(t,h)||{}).isSpelArray,g=t.settings.fieldSeparator,y=i.get("operator");y||a&&"some"!=a||(y="some");var m=_c(t,y,l),b=m!=y,O=y&&xv(t,m,l)||null,E=p&&(!m||0==O.cardinality),S=Hn(Ac(t,i,r,m,n,null),3),T=S[0],_=S[1],w=S[2],R=s.map((function(e){return bc(e,t,r,h)})).filter((function(e){return void 0!==e}));if(f&&!E){if(null==T)return}else if(!R.size)return;var A,C=p,I=R.size?c.spelFormatConj.call(t.ctx,R,u,d,C):null;if(f){var x=Ic(r,t,l,n),L=(g||".")+(v?"length":"size()"),N="".concat(x).concat(L),j=I?"".concat(x,".?[").concat(I,"]").concat(L):N;A=Tc(r,t,i,j,E?N:T,m,_,w,b)}else A=I;return A},Tc=function(e,t,r,n,o,i,a,s){var l=arguments.length>8&&void 0!==arguments[8]&&arguments[8],u=r.get("field"),c=xv(t,i,u)||{},d=Iv(t,u)||{},p=r.get("operatorOptions"),f=c.spelFormatOp||function(e,t,r){var n=t.spelOp;if(n){var o,i=n.includes("${0}"),a=gc[r],s=n,l=wl(t);return a?o=function(e,t,r,n,o,i,a,u){var c=vc.replace(/\${(\w+)}/g,(function(t,n){return 0==n?e:l>1?r[n-1]:r}));return"".concat(c," ").concat(s," 0")}:i?o=function(e,t,r,o,i,a,s,u){return n.replace(/\${(\w+)}/g,(function(t,n){return 0==n?e:l>1?r[n-1]:r}))}:0==l?o=function(e,t,r,n,o,i,a,l){return"".concat(e," ").concat(s)}:1==l&&(o=function(e,t,r,n,o,i,a,l){return"".concat(e," ").concat(s," ").concat(r)}),o}}(0,c,s);if(f){var h,v=[n,i,o,a,s,_l(c,El),p,d];return h=f.call.apply(f,[t.ctx].concat(v)),l&&(h=t.settings.spelFormatReverse.call(t.ctx,h)),void 0===h&&e.errors.push("Operator ".concat(i," is not supported for value source ").concat(a)),h}e.errors.push("Operator ".concat(i," is not supported"))},_c=function(e,t,r){if(t){var n=xv(e,t,r)||{},o=n.reversedOp,i=xv(e,o,r)||{},a=n.spelOp||n.spelFormatOp,s=i.spelOp||i.spelFormatOp;if(a||s){if(!a&&s){var l=[o,t];t=l[0],o=l[1];var u=[i,n];n=u[0],i=u[1]}return t}}},wc=function(e,t,r){var n=arguments.length>3&&void 0!==arguments[3]?arguments[3]:null,o=e.get("properties")||new Ia,i=o.get("field"),a=o.get("fieldSrc"),s=o.get("operator");if(null!=i&&null!=s){var l=_c(t,s,i);if(l){var u=l!=s,c=Hn(Ac(t,o,r,l,n,null),3),d=c[0],p=c[1],f=c[2];if(void 0!==d){var h=Rc(r,t,i,a,n);if(void 0!==h)return Tc(r,t,o,h,d,l,p,f,u)}}else r.errors.push("Operator ".concat(s," is not supported"))}},Rc=function(e,t,r,n){var o=arguments.length>4&&void 0!==arguments[4]?arguments[4]:null;return"func"===n?xc(e,t,r,o):Ic(e,t,r,o)},Ac=function(e,t,r,n,o){var i=arguments.length>5&&void 0!==arguments[5]?arguments[5]:null,a=t.get("field"),s=t.get("valueSrc"),l=t.get("valueType");("!case_value"==i||l&&"case_value"==l.get(0))&&(a="!case_value");var u,c=Iv(e,a)||{},d=xv(e,n,a)||{},p=wl(d),f=t.get("value"),h=t.get("asyncListValues"),v=[],g=[];if(null!=f){var y=f.map((function(t,i){var u=s?s.get(i):null,p=l?l.get(i):null,f=sh(t,u,e),y=Qf(e,a,n,u),m=Lv(e,a,n,y,u,{forExport:!0}),b=Cc(r,e,f,u,p,m,c,n,d,o,h);return void 0!==b&&(v.push(u),g.push(p)),b})),m=y.filter((function(e){return void 0===e})).size>0;y.size<p||m||(u=p>1?y.toArray():1==p?y.first():null)}return[u,v.length>1?v:v[0],g.length>1?g:g[0]]},Cc=function(e,t,r,n,o,i,a,s,l){var u=arguments.length>9&&void 0!==arguments[9]?arguments[9]:null,c=arguments.length>10?arguments[10]:void 0;if(void 0!==r){var d;if("field"===n)d=Ic(e,t,r,u);else if("func"===n)d=xc(e,t,r,u);else if("function"==typeof(null==i?void 0:i.spelFormatValue)){var p=i.spelFormatValue,f=[r,hc(hc({},Hl()(a,["fieldSettings","listValues"])),{},{asyncListValues:c}),_l(i,Ol)];if(s&&(f.push(s),f.push(l)),"field"==n){var h=Iv(t,r)||{};f.push(h)}d=p.call.apply(p,[t.ctx].concat(f))}else d=ac(r);return d}},Ic=function(e,t,r){var n=arguments.length>3&&void 0!==arguments[3]?arguments[3]:null;if(r){var o=t.settings.fieldSeparator,i=Iv(t,r)||{},a=Tv(r,t),s=Kf(r,t,n),l=t.settings.formatSpelField,u=Xf(r,t,e,n),c=s.map((function(e){var t,r=Hn(e,3),n=r[0],i=r[1],a=r[2];return a&&(t="!struct"==a.type||"!group"==a.type&&"struct"==a.mode?i.isSpelMap?"map":"class":"!group"==a.type?i.isSpelItemMap?"[map]":"[class]":"class"),{key:n,parent:t,isSpelVariable:null==i?void 0:i.isSpelVariable,fieldSeparator:o}}));return l.call(t.ctx,u,n,a,c,i,t)}},xc=function(e,t,r){var n,o,i=arguments.length>3&&void 0!==arguments[3]?arguments[3]:null,a=null===(n=r.get)||void 0===n?void 0:n.call(r,"func"),s=null===(o=r.get)||void 0===o?void 0:o.call(r,"args"),l=bv(t,a);if(l){var u={},c=[],d=[];for(var p in l.args){var f,h,v=l.args[p],g=Iv(t,v),y=v.defaultValue,m=v.isOptional,b=null!=y&&y.func?"func":"value",O=s?s.get(p):void 0,E=O?O.get("value"):void 0,S=O?O.get("valueSrc"):void 0;"func"!==S&&null!==(f=E)&&void 0!==f&&f.toJS&&(E=E.toJS());var T=O?O.get("asyncListValues"):void 0,_=null===(h=v.spelEscapeForFormat)||void 0===h||h,w=null,R=Qf(t,v,w,S),A=Lv(t,v,w,R,S,{forExport:!0}),C=Cc(e,t,E,S,v.type,A,g,null,null,i,T);if(null!=E&&void 0===C)return void("func"!=S&&e.errors.push("Can't format value of arg ".concat(p," for func ").concat(a)));var I=void 0;if(void 0===C&&!m&&null!=y){var x=Qf(t,v,w,b),L=Lv(t,v,w,x,b,{forExport:!0});if(void 0===(I=Cc(e,t,y,b,v.type,L,g,null,null,i,T)))return void("func"!=b&&e.errors.push("Can't format default value of arg ".concat(p," for func ").concat(a)))}var N=null!=C?C:I;if(void 0!==N){var j;if(c.length){var P,k=dc(c);try{for(k.s();!(P=k.n()).done;){var F=P.value;u[F]=void 0}}catch(e){k.e(e)}finally{k.f()}c=[]}u[p]=_?N:null!==(j=E)&&void 0!==j?j:y}else m||d.push(p),c.push(p)}if(!d.length){var D;if("function"==typeof l.spelFormatFunc){var M=l.spelFormatFunc,V=[u];D=M.call.apply(M,[t.ctx].concat(V))}else if(l.spelFunc){D=l.spelFunc.replace(/\${(\w+)}/g,(function(e,t){var r;return null!==(r=u[t])&&void 0!==r?r:e}));var U,B=Object.keys(l.args||{}).reverse().filter((function(e){return!!l.args[e].isOptional})),q=dc(B);try{for(q.s();!(U=q.n()).done;){var G=U.value;if(null!=u[G])break;D=D.replace(new RegExp("(, )?\\${"+G+"}","g"),"")}}catch(e){q.e(e)}finally{q.f()}D=D.replace(/\${(\w+)}/g,"null")}else e.errors.push("Func ".concat(a," is not supported"));return D}}else e.errors.push("Func ".concat(a," is not defined in config"))};function Lc(e,t){var r="undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(!r){if(Array.isArray(e)||(r=function(e,t){if(e){if("string"==typeof e)return Nc(e,t);var r=Object.prototype.toString.call(e).slice(8,-1);return"Object"===r&&e.constructor&&(r=e.constructor.name),"Map"===r||"Set"===r?Array.from(e):"Arguments"===r||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(r)?Nc(e,t):void 0}}(e))||t&&e&&"number"==typeof e.length){r&&(e=r);var n=0,o=function(){};return{s:o,n:function(){return n>=e.length?{done:!0}:{done:!1,value:e[n++]}},e:function(e){throw e},f:o}}throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}var i,a=!0,s=!1;return{s:function(){r=r.call(e)},n:function(){var e=r.next();return a=e.done,e},e:function(e){s=!0,i=e},f:function(){try{a||null==r.return||r.return()}finally{if(s)throw i}}}}function Nc(e,t){(null==t||t>e.length)&&(t=e.length);for(var r=0,n=new Array(t);r<t;r++)n[r]=e[r];return n}function jc(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);t&&(n=n.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),r.push.apply(r,n)}return r}function Pc(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{};t%2?jc(Object(r),!0).forEach((function(t){Gn(e,t,r[t])})):Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(r)):jc(Object(r)).forEach((function(t){Object.defineProperty(e,t,Object.getOwnPropertyDescriptor(r,t))}))}return e}var kc={number:"number",string:"text",boolean:"boolean",null:"null"},Fc={String:"text"},Dc=function(e){return"object"==kn(e)&&null!==e&&!Array.isArray(e)},Mc=function(e,t){return Vc(e,t,!0)},Vc=function(e,t){var r,n,o=!(arguments.length>2&&void 0!==arguments[2])||arguments[2],i={errors:[]},a=nv(t,void 0,!1),s=qc(a),l=void 0;try{r=ec.SpelExpressionEvaluator.compile(e)._compiledExpression}catch(e){i.errors.push(e)}r&&(n=Uc(r,i),Kl.debug("convertedObj:",n,i),(l=Gc(n,s,a,i))&&"group"!=l.type&&"switch_group"!=l.type&&(l=od(l,a,n.not)),Kl.debug("jsTree:",l));var u=l?Au(l):void 0;return o?[u,i.errors]:(i.errors.length&&console.warn("Errors while importing from SpEL:",i.errors),u)},Uc=function e(t,r){var n,o=arguments.length>2&&void 0!==arguments[2]?arguments[2]:null,i=t.getType(),a=t.getChildren().map((function(n){return e(n,r,t)}));if("op-or"!=i&&"op-and"!=i||(a=a.reduce((function(e,t){var r=t.type!=i||t.not?[t]:t.children;return[].concat(Qn(e),Qn(r))}),[])),"op-not"==i)return 1!=a.length&&r.errors.push("Operator NOT should have 1 child, but got ".concat(a.length,"}")),Pc(Pc({},a[0]),{},{not:!a[0].not});if("compound"==i){var s=(a=a.filter((function(e){return!("selection"==e.type&&1==e.children.length&&"boolean"==e.children[0].type&&1==e.children[0].val)}))).find((function(e){return"selection"==e.type}));s&&1!=s.children.length&&r.errors.push("Selection should have 1 child, but got ".concat(s.children.length));var l=s?s.children[0]:null,u=a[a.length-1],c="method"==u.type&&"size"==u.val.methodName||"!func"==u.type&&"size"==u.methodName,d="property"==u.type&&"length"==u.val,p=a.filter((function(e){return e!==s&&e!==u})),f={type:"compound",children:p};if((c||d)&&null!=Wc(p))return{type:"!aggr",filter:l,source:f};if(a=(a=a.filter((function(e){var t="variable"==e.type&&"this"==e.val,r="variable"==e.type&&"root"==e.val;return!(t||r)}))).map((function(e){return"indexer"==e.type&&1==e.children.length?{type:"indexer",val:e.children[0].val,itype:e.children[0].type}:e})),"!func"==u.type){var h={},v=h;do{var g,y;Object.assign(v,u),a=a.filter((function(e){return e!==u})),"!func"==(null===(y=u=a[a.length-1])||void 0===y?void 0:y.type)?(v.obj={},v=v.obj):a.length>1?v.obj={type:"compound",children:a}:v.obj=u}while("!func"==(null===(g=u)||void 0===g?void 0:g.type));return h}}try{t.getRaw?n=t.getRaw():0==t.getValue.length&&(n=t.getValue())}catch(e){Kl.error("[spel2js] Error in getValue()",e)}if("ternary"==i&&(n=Bc(a)),"object"===kn(n)&&null!==n&&(n.methodName||n.functionName)&&(n.args=n.args.map((function(n){return e(n,r,t)}))),"list"==i&&(n=n.map((function(n){return e(n,r,t)})),!o&&1==n.length))return n[0];if("constructorref"==i){var m=a.find((function(e){return"qualifiedidentifier"==e.type})),b=null==m?void 0:m.val;return b?{type:"!new",cls:b,args:a.filter((function(e){return"qualifiedidentifier"!=e.type}))}:void r.errors.push("Can't find qualifiedidentifier in constructorref children: ".concat(JSON.stringify(a)))}if("typeref"==i){var O=a.find((function(e){return"qualifiedidentifier"==e.type})),E=null==O?void 0:O.val;return E?(a.filter((function(e){return"qualifiedidentifier"!=e.type})),{type:"!type",cls:E}):void r.errors.push("Can't find qualifiedidentifier in typeref children: ".concat(JSON.stringify(a)))}if("function"==i||"method"==i){var S=n,T=S.functionName,_=S.methodName,w=S.args;return{type:"!func",methodName:T||_,isVar:"function"==i,args:w}}return{type:i,children:a,val:n}},Bc=function(e){var t=[];return function e(r){var n=Hn(r,3),o=n[0],i=n[1],a=n[2];t.push([o,i]),"ternary"==(null==a?void 0:a.type)?e(a.children):t.push([void 0,a])}(e),t},qc=function(e){var t={},r=function(r){var n=e.operators[r];if(n.spelOps)n.spelOps.forEach((function(e){var n=e;t[n]||(t[n]=[]),t[n].push(r)}));else if(n.spelOp){var o=n.spelOp;t[o]||(t[o]=[]),t[o].push(r)}else Kl.log("[spel] No spelOp for operator ".concat(r))};for(var n in e.operators)r(n);var o={};for(var i in e.conjunctions)o[e.conjunctions[i].spelConj||i.toLowerCase()]=i;var a,s={},l=Lc(fv(e));try{var u=function(){var e=Hn(a.value,2),t=e[0],r=e[1],n=[],o=r.spelFunc;if("string"==typeof o){var i=Object.keys(r.args||{}).reverse().filter((function(e){return!!r.args[e].isOptional||null!=r.args[e].defaultValue})),l=o.replace(/\${(\w+)}/g,(function(e,t){return"?"})),u=i.reduce((function(e,t){return[].concat(Qn(e),[[t].concat(Qn(e[e.length-1]||[]))])}),[]).map((function(e){return o.replace(/(?:, )?\${(\w+)}/g,(function(t,r){return e.includes(r)?"":t})).replace(/\${(\w+)}/g,(function(e,t){return"?"}))}));n=[l].concat(Qn(u))}var c,d=Lc(n);try{for(d.s();!(c=d.n()).done;){var p=c.value;s[p]||(s[p]=[]),s[p].push(t)}}catch(e){d.e(e)}finally{d.f()}};for(l.s();!(a=l.n()).done;)u()}catch(e){l.e(e)}finally{l.f()}var c={};for(var d in e.widgets){var p=e.widgets[d],f=p.spelImportFuncs;if(p.type,f){var h,v=Lc(f);try{for(v.s();!(h=v.n()).done;){var g=h.value;if("string"==typeof g){var y=g.replace(/\${(\w+)}/g,(function(e,t){return"?"})),m=Qn(g.matchAll(/\${(\w+)}/g)).map((function(e){var t=Hn(e,2);return t[0],t[1]}));c[y]||(c[y]=[]),c[y].push({w:d,argsOrder:m})}}}catch(e){v.e(e)}finally{v.f()}}}var b={};for(var O in e.operators){var E=e.operators[O].spelOp;if(null!=E&&E.includes("${0}")){var S=E.replace(/\${(\w+)}/g,(function(e,t){return"?"})),T=Qn(E.matchAll(/\${(\w+)}/g)).map((function(e){var t=Hn(e,2);return t[0],t[1]}));b[S]||(b[S]=[]),b[S].push({op:O,argsOrder:T})}}return b[vc.replace(/\${(\w+)}/g,(function(e,t){return"?"}))]=[{op:"!compare",argsOrder:["0","1"]}],{operators:t,conjunctions:o,funcs:s,valueFuncs:c,opFuncs:b}},Gc=function e(t,r,n,o){var i,a=arguments.length>4&&void 0!==arguments[4]?arguments[4]:null;if(t){t._groupField=null!==(i=t._groupField)&&void 0!==i?i:null==a?void 0:a._groupField;var s,l=!0;if(0===t.type.indexOf("op-")||"matches"===t.type)s=Kc(t,r,n,o,a);else if("!aggr"==t.type){var u,c=e(t.source,r,n,o,t);t._groupField=null==c?void 0:c.value;var d=e(t.filter,r,n,o,t);"rule"==(null===(u=d)||void 0===u?void 0:u.type)&&(d=od(d,n,t.filter.not)),s={groupFilter:d,groupFieldValue:c},a||(s=void 0,o.errors.push("Unexpected !aggr in root"),l=!1)}else if("ternary"==t.type){var p={};t.val.forEach((function(e){var i=Hn(e,2),a=i[0],s=i[1],l=td(a,s,r,n,o,t);l&&(p[l.id]=l)})),s={type:"switch_group",id:ml(),children1:p,properties:{}}}if(!s&&l&&(s=zc(t,r,n,o,a)),s&&!s.type&&!a){var f=ed(t,r,n,o);f?s=f:(s=void 0,o.errors.push("Can't convert rule of type ".concat(t.type,", it looks like var/literal")))}return s}},Kc=function e(t,r,n,o){var i,a=arguments.length>4&&void 0!==arguments[4]?arguments[4]:null,s=t.type.startsWith("op-")?t.type.slice(3):t.type;if(("minus"==s||"plus"==s)&&1==t.children.length){var l=t.negative;return"minus"==s&&(l=!l),t.children[0].negative=l,Gc(t.children[0],r,n,o,a)}var u="and"==s&&2==t.children.length&&"op-ge"==t.children[0].type&&"op-le"==t.children[1].type,c="or"==s&&2==t.children.length&&"op-lt"==t.children[0].type&&"op-gt"==t.children[1].type;if(u||c){var d=Hn(t.children[0].children,2),p=d[0],f=d[1],h=Hn(t.children[1].children,2),v=h[0],g=h[1];if(Zc(p,v,t,r,n,o,a)){f.val,g.val;var y={type:"op-between",children:[p,f,g],not:c};return y._groupField=null==a?void 0:a._groupField,e(y,r,n,o,a)}}var m=r.operators[s];"eq"==s&&"null"==t.children[1].type?m=["is_null"]:"ne"==s&&"null"==t.children[1].type?m=["is_not_null"]:"le"==s&&"string"==t.children[1].type&&""==t.children[1].val?m=["is_empty"]:"gt"==s&&"string"==t.children[1].type&&""==t.children[1].val?m=["is_not_empty"]:"between"==s&&(m=["between"]);var b=function(){var e,i=t.children.map((function(e){return Gc(e,r,n,o,t)}));return i.length>=2&&"!compare"==(null===(e=i)||void 0===e||null===(e=e[0])||void 0===e?void 0:e.type)&&(i=i[0].children),i};if("and"==s||"or"==s){var O={};b().forEach((function(e){if(e){var t=ml();e.id=t,null!=e.type?O[t]=e:o.errors.push("Bad item in AND/OR: ".concat(JSON.stringify(e)))}})),i={type:"group",id:ml(),children1:O,properties:{conjunction:r.conjunctions[s],not:t.not}}}else if(m){var E,S,T,_=b(),w=_[0],R=_.slice(1),A=null==w||null===(E=w.groupFieldValue)||void 0===E?void 0:E.value,C=null===(S=R)||void 0===S?void 0:S[0],I=m[0];if(m.length>1){var x,L,N=(null===(x=_[0])||void 0===x?void 0:x.valueType)||(null===(L=_[1])||void 0===L?void 0:L.valueType),j=null==w?void 0:w.value,P=m.map((function(e){return{op:e,widget:Qf(n,j,e)}}));if(Kl.warn("[spel] Spel operator ".concat(s," can be mapped to ").concat(m,"."),"widgets:",P,"vals:",_,"valueType=",N),"eq"==s||"ne"==s){var k=P.find((function(e){e.op;var t=e.widget;return t&&"field"!=t}));k&&(I=k.op)}}null!=w&&w.groupFieldValue&&(C&&C.groupFieldValue&&"field"==C.groupFieldValue.valueSrc&&C.groupFieldValue.value==A?(I="all",R=[]):"equal"==I&&"value"==C.valueSrc&&"number"==C.valueType&&0==C.value?(I="none",R=[]):"greater"==I&&"value"==C.valueSrc&&"number"==C.valueType&&0==C.value&&(I="some",R=[]));var F=n.operators[I],D=n.operators[null===(T=F)||void 0===T?void 0:T.reversedOp],M=t.not&&["between"].includes(I),V=!!D&&(!!n.settings.reverseOperatorsForNot||M);(t.not&&V||M)&&(I=F.reversedOp,F=n.operators[I],t.not=!t.not);var U=!!t.not;if(t.not=!1,w)if(w.groupFieldValue)"field"!=w.groupFieldValue.valueSrc&&o.errors.push("Expected group field ".concat(JSON.stringify(w))),i=Jc(w,I,R,n,o);else{"field"!=w.valueSrc&&"func"!=w.valueSrc&&o.errors.push("Expected field/func at LHS, but got ".concat(JSON.stringify(w)));var B=w.value;i=Xc(n,o,B,I,R,t)}U&&("group"!==i.type?i=od(i,n,!0):i.properties.not=!i.properties.not)}else a||(i=ed(t,r,n,o));return i},Wc=function(e){var t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:{},r=arguments.length>2&&void 0!==arguments[2]&&arguments[2],n=!1,o=e.map((function(e){if("variable"==e.type||"property"==e.type||"indexer"==e.type&&"string"==e.itype)return e.val;var o,i;n=!0,r&&(null==t||null===(o=t.errors)||void 0===o||null===(i=o.push)||void 0===i||i.call(o,"Unexpected item in field path compound: ".concat(JSON.stringify(e))))}));return n?void 0:o},zc=function e(t,r,n,o){var i,a,s=arguments.length>4&&void 0!==arguments[4]?arguments[4]:null;if(null!=t){var l=n.settings.fieldSeparator;if(t._groupField=null!==(i=t._groupField)&&void 0!==i?i:null==s?void 0:s._groupField,"variable"==t.type||"property"==t.type){var u=yv(n,t.val,t._groupField),c=Iv(n,u),d="variable"==t.type;return{valueSrc:"field",valueType:null==c?void 0:c.type,isVariable:d,value:u}}if("compound"==t.type){var p=Wc(t.children,o);if(p){var f,h=yv(n,p.join(l),t._groupField),v=Iv(n,h),g="variable"==(null===(f=t.children)||void 0===f||null===(f=f[0])||void 0===f?void 0:f.type);return{valueSrc:"field",valueType:null==v?void 0:v.type,isVariable:g,value:h}}}else{if(kc[t.type]){var y=t.val,m=kc[t.type];return t.negative&&(y=-y),{valueSrc:"value",valueType:m,value:y}}if("!new"==t.type&&Fc[t.cls.at(-1)]){var b=t.args.map((function(i){return e(i,r,n,o,t)})),O=null==b?void 0:b[0],E=Fc[t.cls.at(-1)];return Pc(Pc({},O),{},{valueType:E})}if("list"==t.type){var S,T=t.val.map((function(i){return e(i,r,n,o,t)}));return T.length&&(null===(S=T[0])||void 0===S||S.valueType),{valueSrc:"value",valueType:"multiselect",value:T.map((function(e){return null==e?void 0:e.value}))}}if("op-plus"===t.type&&"ternary"===(null==s?void 0:s.type)&&"case_value"===(null===(a=n.settings.caseValueField)||void 0===a?void 0:a.type))return rd(t,r,n,o)}var _=Hc(t,r,n,o,s);if(void 0!==_)return _;o.errors.push("Can't convert arg of type ".concat(t.type))}},$c=function e(t,r){var n,o=[],i="",a=t.type,s=t.methodName,l=(t.val,t.obj),u=t.args,c=t.isVar,d=t.cls,p=t.children,f=null==p?void 0:p[p.length-1],h=r[r.length-1];if("!func"===a){for(var v=l;v;){var g,y=Hn(e(Pc(Pc({},v),{},{obj:null}),[{}]),2),m=y[0],b=y[1];if("?"!==m){var O={s:h.s,params:Qn(h.params),objs:Qn(h.objs)};h.objs.unshift("?"),h.params.unshift(v),r.push(O),h=r[r.length-1]}h.objs.unshift(m),(g=h.params).unshift.apply(g,Qn(b)),v="!func"===v.type?v.obj:null}var E,S=Lc(r);try{for(S.s();!(E=S.n()).done;){var T,_=E.value;o=[].concat(Qn((null==_?void 0:_.params)||[]),Qn(u||[])),i="",null!=_&&null!==(T=_.objs)&&void 0!==T&&T.length&&(i+=_.objs.join(".")+"."),i+=(c?"#":"")+s,i+="("+(u||[]).map((function(e){return"?"})).join(", ")+")",_.s=i,_.params=o}}catch(e){S.e(e)}finally{S.f()}}else"!new"===a?(o=u||[],i="new ".concat(d.join("."),"(").concat(o.map((function(e){return"?"})).join(", "),")")):"!type"===a?i="T(".concat(d.join("."),")"):"compound"===a&&"property"===f.type&&(n=f.val,["length"].includes(n))?i=p.map((function(t){var r;if(t===f)return t.val;var n=Hn(e(Pc(Pc({},t),{},{obj:null}),[{}]),2),i=n[0],a=n[1];return(r=o).push.apply(r,Qn(a)),i})).join("."):(o=[t],i="?");return h&&(h.s=i,h.params=o),[i,o]},Hc=function(e,t,r,n){var o,i=arguments.length>4&&void 0!==arguments[4]?arguments[4]:null,a=function(o){return Gc(o,t,r,n,e)},s=function(e){var t=[{s:"",params:[],objs:[]}];return $c(e,t),t.map((function(e){return{s:e.s,params:e.params}})).reverse().filter((function(e){var t=e.s;return""!==t&&"?"!==t}))}(e),l=null==s||null===(o=s[0])||void 0===o?void 0:o.s;s.length&&Kl.debug("Signatures for ",e,":",l,s);var u=Yc(e,t,r,n,i,s,a);if(void 0!==u)return u;var c,d,p,f=Qc(e,t,r,n,i,s,a);if(void 0!==f)return f;var h,v=Lc(s);try{var g=function(){var e=h.value,n=e.s,o=e.params,i=t.funcs[n];if(i){c=i[0];var s=(d=bv(r,c)).spelFunc,l=o.map(a),u=Qn(s.matchAll(/\${(\w+)}/g)).map((function(e){var t=Hn(e,2);return t[0],t[1]}));return p=Object.fromEntries(u.map((function(e,t){return[e,l[t]]}))),1}};for(v.s();!(h=v.n()).done&&!g(););}catch(e){v.e(e)}finally{v.f()}if(!c){var y,m=Lc(fv(r));try{for(m.s();!(y=m.n()).done;){var b=Hn(y.value,2),O=b[0],E=b[1];if(E.spelImport){var S=void 0;try{S=E.spelImport(e)}catch(e){}if(S)for(var T in d=bv(r,c=O),p={},S)p[T]=a(S[T])}}}catch(e){m.e(e)}finally{m.f()}}if(c){var _={};for(var w in d.args){var R,A=d.args[w],C=p[w];if(void 0===C)if(void 0===(C=null==A?void 0:A.defaultValue)){if(null==A||!A.isOptional)return void n.errors.push("No value for arg ".concat(w," of func ").concat(c))}else C={value:C,valueSrc:null!==(R=C)&&void 0!==R&&R.func?"func":"value",valueType:A.type};C&&(_[w]=C)}return{valueSrc:"func",value:{func:c,args:_},valueType:d.returnType}}e.methodName&&n.errors.push("Signature ".concat(l," - failed to convert"))},Yc=function(e,t,r,n,o,i,a){var s,l,u,c=[];for(var d in r.widgets){var p=r.widgets[d].spelImportFuncs;if(p)for(var f=0;f<p.length;f++){var h=p[f];if(Dc(h)){var v={};if(Bl(h,e,v)){for(var g in v)v[g]=a(v[g]);c.push({s:"widgets.".concat(d,".spelImportFuncs[").concat(f,"]"),w:d,argsObj:v})}}}}var y,m=Lc(i);try{for(m.s();!(y=m.n()).done;){var b,O=y.value,E=O.s,S=O.params,T=Lc(t.valueFuncs[E]||[]);try{var _=function(){var e=b.value,t=e.w,r=e.argsOrder,n=S.map(a),o=Object.fromEntries(r.map((function(e,t){return[e,n[t]]})));c.push({s:E,w:t,argsObj:o})};for(T.s();!(b=T.n()).done;)_()}catch(e){T.e(e)}finally{T.f()}}}catch(e){m.e(e)}finally{m.f()}for(var w=0,R=c;w<R.length;w++){var A=R[w],C=A.s,I=A.w,x=A.argsObj,L=r.widgets[I],N=L.spelImportValue,j=L.type;for(var P in u=I,l=C,s=[],x)["value"].includes(x[P].valueSrc)||s.push("".concat(P," has unsupported value src ").concat(x[P].valueSrc));var k=x.v.value;if(N&&!s.length){var F=Hn(N.call(r.ctx,x.v,L,x),2);k=F[0],(s=F[1])&&!Array.isArray(s)&&(s=[s])}if(!s.length)return{valueSrc:"value",valueType:j,value:k}}u&&s.length&&n.errors.push("Signature ".concat(l," - looks like convertable to ").concat(u,", but: ").concat(s.join("; ")))},Qc=function(e,t,r,n,o,i,a){var s,l,u,c,d=Lc(i);try{for(d.s();!(c=d.n()).done;){var p,f=c.value,h=f.s,v=f.params,g=Lc(t.opFuncs[h]||[]);try{var y,m=function(){var t,i=p.value,c=i.op,d=i.argsOrder,f=v.map(a);if(l=c,"!compare"===c){if(o.type.startsWith("op-")&&2==o.children.length&&"number"==o.children[1].type&&0===o.children[1].val)return{v:{type:"!compare",children:f}};s.push("Result of compareTo() should be compared to 0")}u=h,s=[];var g=r.operators[l],y=(g.spelOp,g.valueTypes),m=Object.fromEntries(d.map((function(e,t){return[e,f[t]]}))),b=m[0],O=Object.keys(m).filter((function(e){return parseInt(e)>0})).map((function(e){return m[e]})),E=null===(t=f.filter((function(e){return!!e})).find((function(e){return"value"===e.valueSrc})))||void 0===t?void 0:t.valueType;if(y&&E&&!y.includes(E)&&s.push("Op supports types ".concat(y,", but got ").concat(E)),!s.length)return{v:Xc(r,n,b,l,O,e)}};for(g.s();!(p=g.n()).done;)if(y=m())return y.v}catch(e){g.e(e)}finally{g.f()}}}catch(e){d.e(e)}finally{d.f()}l&&s.length&&n.errors.push("Signature ".concat(u," - looks like convertable to ").concat(l,", but: ").concat(s.join("; ")))},Xc=function(e,t,r,n,o,i){var a,s;if(!o.filter((function(e){return void 0===e})).length){var l=null!==(a=r)&&void 0!==a&&a.func?"func":"field";Dc(r)&&r.valueSrc&&(l=r.valueSrc,r=r.value);var u=Iv(e,r);if(u){var c=Iv(e,null==i?void 0:i._groupField),d="!group"==u.type,p=(d&&u.mode,"!group"==(null==c?void 0:c.type)),f=e.operators[n],h=e.operators[null===(s=f)||void 0===s?void 0:s.reversedOp],v=(null==i?void 0:i.not)&&["between"].includes(n),g=!!h&&(!!e.settings.reverseOperatorsForNot||v||!d&&p);((null==i?void 0:i.not)&&g||v)&&(n=f.reversedOp,f=e.operators[n],i.not=!i.not);var y=!(null==i||!i.not),m=Qf(e,r,n),b=e.widgets[m||u.mainWidget],O=o.map((function(e){return e.asyncListValues})).filter((function(e){return null!=e})),E=O.length?O[0]:void 0,S={type:"rule",id:ml(),properties:Pc({field:r,fieldSrc:l,operator:n,value:o.map((function(e){return e.value})),valueSrc:o.map((function(e){return e.valueSrc})),valueType:o.map((function(e){return"value"==e.valueSrc&&((null==b?void 0:b.type)||(null==u?void 0:u.type))||e.valueType}))},E?{asyncListValues:E}:{})};return y&&(S=od(S,e,i.not)),S}t.errors.push("No config for field ".concat(r))}},Jc=function(e,t,r,n,o){var i=e.groupFilter,a=e.groupFieldValue;if("field"!=a.valueSrc)throw"Bad groupFieldValue: ".concat(JSON.stringify(a));var s=a.value,l=Xc(n,o,s,t,r);if(l){var u,c=Iv(n,s),d=null==c?void 0:c.mode;return(u="group"===(null==i?void 0:i.type)?Pc(Pc({},i||{}),{},{type:"rule_group",properties:Pc(Pc(Pc({},l.properties),(null==i?void 0:i.properties)||{}),{},{mode:d})}):Pc(Pc({},l||{}),{},i?{type:"rule_group",children1:[i],properties:Pc(Pc({},l.properties),{},{mode:d})}:{type:"rule_group",properties:Pc(Pc({},l.properties),{},{mode:d})})).id||(u.id=ml()),u}},Zc=function(e,t,r,n,o,i){if(e.type==t.type){if("!aggr"==e.type){var a=Hn([e.source,t.source].map((function(e){return zc(e,n,o,i,r)})),2),s=a[0],l=a[1];return s.value==l.value}var u=Hn([e,t].map((function(e){return zc(e,n,o,i,r)})),2),c=u[0],d=u[1];return c.value==d.value}return!1},ed=function(e,t,r,n){var o={},i=td(null,e,t,r,n);return i&&(o[i.id]=i),{type:"switch_group",id:ml(),children1:o,properties:{}}},td=function(e,t,r,n,o){var i,a=arguments.length>5&&void 0!==arguments[5]?arguments[5]:null,s=nd(n,o,r,t,a);return e?(i=Gc(e,r,n,o,a))&&i.type?("group"!=i.type&&(i=od(i,n)),i.type="case_group"):(o.errors.push("Unexpected case: ".concat(JSON.stringify(i))),i=void 0):i={id:ml(),type:"case_group",properties:{}},i&&(i.properties=Pc(Pc({},i.properties),s)),i},rd=function(e,t,r,n){var o=[];return function i(a){a.map((function(a){if("op-plus"===a.type)i(a.children);else{var s=zc(a,t,r,n,e);s?o.push(s):n.errors.push("Can't convert ".concat(a.type," in concatenation"))}}))}(e.children),{valueSrc:"value",valueType:"case_value",value:o}},nd=function(e,t,r,n){var o,i,a,s,l,u,c=arguments.length>4&&void 0!==arguments[4]?arguments[4]:null,d={},p=Iv(e,"!case_value");"op-plus"===(null==n?void 0:n.type)&&"case_value"===(null===(o=e.settings.caseValueField)||void 0===o?void 0:o.type)?(s="case_value",a=rd(n,r,e,t)):(s=null==p?void 0:p.mainWidget,l=e.widgets[s],(a=zc(n,r,e,t,c))&&"value"===a.valueSrc&&(a.valueType=(null===(u=l)||void 0===u?void 0:u.type)||(null==p?void 0:p.type)||a.valueType));var f=e.widgets[s];if("case_value"===s){var h=null==f?void 0:f.spelImportValue;if(h){var v,g=Hn(h.call(e.ctx,a),2),y=g[0];g[1].map((function(e){return t.errors.push(e)})),null!=y&&(d={value:[y],valueSrc:["value"],valueType:[null!==(v=null==f?void 0:f.type)&&void 0!==v?v:"case_value"],field:"!case_value"})}}else null!=a&&null!=(null===(i=a)||void 0===i?void 0:i.value)&&(d={value:[a.value],valueSrc:[a.valueSrc],valueType:[a.valueType],field:"!case_value"});return d},od=function(e,t){var r=arguments.length>2&&void 0!==arguments[2]&&arguments[2];return{type:"group",id:ml(),children1:Gn({},e.id,e),properties:{conjunction:hd(t),not:r||!1}}};function id(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);t&&(n=n.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),r.push.apply(r,n)}return r}function ad(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{};t%2?id(Object(r),!0).forEach((function(t){Gn(e,t,r[t])})):Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(r)):id(Object(r)).forEach((function(t){Object.defineProperty(e,t,Object.getOwnPropertyDescriptor(r,t))}))}return e}var sd=function(e){var t=!(arguments.length>1&&void 0!==arguments[1])||arguments[1],r=arguments.length>2&&void 0!==arguments[2]?arguments[2]:null,n=e.settings.defaultField,o=(r?ld(e,r):n)||t&&Nv(e,r)||null;return null==o||"string"==typeof o||Cl(o)||(o=xu(o)),o},ld=function(e){var t,r=arguments.length>1&&void 0!==arguments[1]?arguments[1]:null;if(!r)return null;var n=(null==e||null===(t=e.settings)||void 0===t?void 0:t.fieldSeparator)||".",o=Iv(e,r),i=null==o?void 0:o.defaultField;return i&&(i=[].concat(Qn(Tv(r)),[i]).join(n)),i},ud=function(e){var t;return(!(arguments.length>1&&void 0!==arguments[1])||arguments[1])&&(null===(t=e.settings.fieldSources)||void 0===t?void 0:t[0])||"field"},cd=function(e,t){var r=!(arguments.length>2&&void 0!==arguments[2])||arguments[2],n=Iv(e,t),o=(null==n?void 0:n.operators)||[],i=e.settings.defaultOperator;i&&!o.includes(i)&&(i=null);var a=null==n?void 0:n.defaultOperator,s=null==n?void 0:n.ownDefaultOperator,l=r?Uf(e,t):null;return s||i||a||l},dd=function(e,t,r){var n=t?xv(e,t,r):null;return n&&n.options?new gl.Map(n.options&&n.options.defaults||{}):null},pd=function(e){var t,r,n,o=arguments.length>1&&void 0!==arguments[1]?arguments[1]:null,i=arguments.length>2&&void 0!==arguments[2]?arguments[2]:null,a=!(arguments.length>3&&void 0!==arguments[3])||arguments[3],s=arguments.length>4&&void 0!==arguments[4]&&arguments[4],l=null,u=null,c=null,d=e.settings.showErrorMessage;i?(c=null==i||null===(t=i.properties)||void 0===t?void 0:t.fieldSrc,l=null==i||null===(r=i.properties)||void 0===r?void 0:r.field,u=null==i||null===(n=i.properties)||void 0===n?void 0:n.operator):a?(c=(l=sd(e,s,o))?Cl(l)?"func":"field":ud(e),u=cd(e,l,!0)):c=ud(e);var p=new gl.Map({fieldSrc:c,field:l,operator:u,value:new gl.List,valueSrc:new gl.List,operatorOptions:dd(e,u,l)});if(d&&(p=p.set("valueError",new gl.List)),l&&u){var f=Af(e,e,p,l,u,"operator",!1),h=f.newValue,v=f.newValueSrc,g=f.newValueType,y=f.newValueError,m=f.newFieldError;p=p.set("value",h).set("valueSrc",v).set("valueType",g),d&&(p=p.set("valueError",y).set("fieldError",m))}return p},fd=function(e){var t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:null,r=(t=Iv(e,t))&&t.conjunctions||Object.keys(e.conjunctions);return 1==r.length?r[0]:e.settings.defaultGroupConjunction||e.settings.defaultConjunction||r[0]},hd=function(e){return e.settings.defaultConjunction||Object.keys(e.conjunctions)[0]},vd=function(e){var t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:null;return new gl.Map({conjunction:fd(e,t),not:!1})},gd=function(e,t){var r;return t&&"group"==t.type?vd(e,null==t||null===(r=t.properties)||void 0===r?void 0:r.field):pd(e,null,t)},yd=function(e,t){return Gn({},e,new gl.Map({type:"rule",id:e,properties:pd(t)}))},md=function(e){var t=!(arguments.length>1&&void 0!==arguments[1])||arguments[1];return new gl.Map({type:"group",id:ml(),children1:new gl.OrderedMap(t?ad({},yd(ml(),e)):{}),properties:vd(e)})},bd=function(e){return Il(e)?e:Od([e])},Od=function(e){return Il(e)?e:new gl.List(e)},Ed=function(){return new gl.Map};function Sd(e,t){var r="undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(!r){if(Array.isArray(e)||(r=function(e,t){if(e){if("string"==typeof e)return Td(e,t);var r=Object.prototype.toString.call(e).slice(8,-1);return"Object"===r&&e.constructor&&(r=e.constructor.name),"Map"===r||"Set"===r?Array.from(e):"Arguments"===r||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(r)?Td(e,t):void 0}}(e))||t&&e&&"number"==typeof e.length){r&&(e=r);var n=0,o=function(){};return{s:o,n:function(){return n>=e.length?{done:!0}:{done:!1,value:e[n++]}},e:function(e){throw e},f:o}}throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}var i,a=!0,s=!1;return{s:function(){r=r.call(e)},n:function(){var e=r.next();return a=e.done,e},e:function(e){s=!0,i=e},f:function(){try{a||null==r.return||r.return()}finally{if(s)throw i}}}}function Td(e,t){(null==t||t>e.length)&&(t=e.length);for(var r=0,n=new Array(t);r<t;r++)n[r]=e[r];return n}function _d(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);t&&(n=n.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),r.push.apply(r,n)}return r}function wd(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{};t%2?_d(Object(r),!0).forEach((function(t){Gn(e,t,r[t])})):Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(r)):_d(Object(r)).forEach((function(t){Object.defineProperty(e,t,Object.getOwnPropertyDescriptor(r,t))}))}return e}var Rd=function(e,t){var r={errors:[],settings:{isForDisplay:arguments.length>2&&void 0!==arguments[2]&&arguments[2],isDebugMode:arguments.length>3&&void 0!==arguments[3]&&arguments[3]}},n=nv(t,void 0,!1),o=Ad(e,n,r,null);return r.errors.length&&console.warn("Errors while exporting to string:",r.errors),o},Ad=function(e,t,r){var n=arguments.length>3&&void 0!==arguments[3]?arguments[3]:null;if(e){var o=e.get("type");return e.get("children1"),"group"===o||"rule_group"===o?Cd(e,t,r,n):"rule"===o?Id(e,t,r,n):void 0}},Cd=function(e,t,r){var n,o,i=arguments.length>3&&void 0!==arguments[3]?arguments[3]:null,a=r.settings,s=a.isForDisplay,l=a.isDebugMode,u=e.get("type"),c=e.get("properties")||new Ia,d=c.get("mode"),p=e.get("children1")||new Za,f="rule_group"===u,h=f&&"array"==d?c.get("field"):null,v="rule_group"===u?c.get("operator"):null,g=v?null!==(n=null===(o=t.operators[v])||void 0===o?void 0:o.cardinality)&&void 0!==n?n:1:void 0,y=f&&"array"===d&&g>=1,m=c.get("not"),b=p.map((function(e){return Ad(e,t,r,h)})).filter((function(e){return void 0!==e}));if(y||b.size||l){var O=c.get("conjunction");O||(O=hd(t));var E,S=t.conjunctions[O],T=b.size?S.formatConj.call(t.ctx,b,O,m,s):null;if(h){var _=Id(e,t,r,i,!0);if(_){var w,R=_.pop(),A=[T].concat(Qn(_));E=(w=t.settings.formatAggr).call.apply(w,[t.ctx].concat(Qn(A))),R&&(E=t.settings.formatReverse.call(t.ctx,E,null,null,null,null,s))}}else E=T;return l&&null==E&&(E="?"),E}},Id=function(e,t,r){var n=arguments.length>3&&void 0!==arguments[3]?arguments[3]:null,o=arguments.length>4&&void 0!==arguments[4]&&arguments[4],i=r.settings,a=i.isForDisplay,s=i.isDebugMode,l=e.get("properties")||new Ia,u=l.get("field"),c=l.get("fieldSrc"),d=l.get("operator"),p=l.get("operatorOptions");if(null!=u&&null!=d||s){var f=Iv(t,u)||{},h=xv(t,d,u)||{},v=h.reversedOp,g=xv(t,v,u)||{},y=!1,m=h.formatOp;if(!m&&v&&(m=g.formatOp)){y=!0;var b=[v,d];d=b[0],v=b[1];var O=[g,h];h=O[0],g=O[1]}if(s&&!d&&(d="?"),m||(m=function(e,t,r){var n,o=r.settings.isDebugMode,i=(null==t?void 0:t.labelForFormat)||e,a=wl(t);return 0==a?n=function(e,t,r,n,o,a,s,l){return"".concat(e," ").concat(i)}:1==a?n=function(e,t,r,n,a,s,l,u){return o&&"?"===t&&"?"===r?e&&"?"!==e?"".concat(e," ?"):"?":"".concat(e," ").concat(i," ").concat(r)}:2==a&&(n=function(e,t,r,n,o,a,s,l){var u,c,d=null==r||null===(u=r.first)||void 0===u?void 0:u.call(r),p=null==r||null===(c=r.get)||void 0===c?void 0:c.call(r,1);return"".concat(e," ").concat(i," ").concat(d," AND ").concat(p)}),n}(d,h,r)),m){var E="func"===c?Nd(t,r,u,n):Ld(t,r,u,n);if(null!=E){var S=function(e,t,r,n,o){var i,a,s=r.settings,l=(s.isForDisplay,s.isDebugMode),u=t.get("field"),c=t.get("valueSrc"),d=t.get("valueType"),p=Iv(e,u)||{},f=n||t.get("operator"),h=xv(e,f,u)||{},v=wl(h),g=t.get("value"),y=t.get("asyncListValues"),m=[],b=[];return null!=g&&!((a=g.map((function(t,n){var i=c?c.get(n):null,a=d?d.get(n):null,s=l?t:sh(t,i,e),v=Qf(e,u,f,i),g=Lv(e,u,f,v,i,{forExport:!0}),O=xd(e,r,s,i,a,g,p,f,h,o,y);return void 0!==O&&(m.push(i),b.push(a)),O}))).filter((function(e){return void 0===e})).size>0)&&a.size===v&&(i=1==v?a.first():a),l&&!i&&(i=v>1?new Za(Array.from({length:v}).map((function(e,t){var r,n;return null!==(r=null===(n=a)||void 0===n?void 0:n.get(t))&&void 0!==r?r:"?"}))):"?"),[i,m.length>1?m:m[0],b.length>1?b:b[0]]}(t,l,r,d,n),T=Hn(S,3),_=T[0],w=T[1],R=T[2];if(void 0!==_){var A=[E,d,_,w,R,_l(h,El),p,a,f,y];if(o)return A;var C,I=(C=m).call.apply(C,[t.ctx].concat(A));return y&&(I=t.settings.formatReverse.call(t.ctx,I,d,v,h,g,a)),I}}}}},xd=function(e,t,r,n,o,i,a,s,l){var u,c=arguments.length>9&&void 0!==arguments[9]?arguments[9]:null,d=arguments.length>10?arguments[10]:void 0,p=t.settings,f=p.isForDisplay,h=p.isDebugMode;if(void 0===r)return h?"array"===(null==i?void 0:i.jsType)?[]:"?":void 0;if("field"==n)u=Ld(e,t,r,c);else if("func"==n)u=Nd(e,t,r,c);else if("function"==typeof(null==i?void 0:i.formatValue)){var v=i.formatValue,g=[r,wd(wd({},Hl()(a,["fieldSettings","listValues"])),{},{asyncListValues:d}),_l(i,Ol),f];if(s&&(g.push(s),g.push(l)),"field"==n){var y=Iv(e,r)||{};g.push(y)}u=v.call.apply(v,[e.ctx].concat(g))}else u=r;return u},Ld=function(e,t,r){var n=arguments.length>3&&void 0!==arguments[3]?arguments[3]:null,o=!(arguments.length>4&&void 0!==arguments[4])||arguments[4],i=t.settings,a=i.isForDisplay,s=i.isDebugMode,l=e.settings,u=(l.fieldSeparator,l.fieldSeparatorDisplay),c=null;if(r){var d=Iv(e,r)||{},p=Tv(r,e),f=Gf(r,e,o?n:null),h=f?f.join(u):null,v=d.label2||h;c=(0,e.settings.formatField)(Xf(r,e,t,o?n:null,{useTableName:!0}),p,v,d,e,a)}else s&&(c="?");return c},Nd=function(e,t,r){var n,o,i,a=arguments.length>3&&void 0!==arguments[3]?arguments[3]:null,s=t.settings,l=s.isForDisplay,u=s.isDebugMode,c=null==r||null===(n=r.get)||void 0===n?void 0:n.call(r,"func");if(!c)return u?"?()":void 0;var d=null===(o=r.get)||void 0===o?void 0:o.call(r,"args"),p=bv(e,c);if(p||u){var f,h=Tv(c,e),v=h[h.length-1],g=l&&(null==p?void 0:p.label)||v,y={},m=[],b=[],O={},E=Sd(p?Object.keys(p.args||{}):(null==d||null===(i=d.keySeq)||void 0===i?void 0:i.call(d).toArray())||[]);try{for(E.s();!(f=E.n()).done;){var S,T=f.value,_=null==p?void 0:p.args[T],w=Iv(e,_),R=_||{},A=R.defaultValue,C=R.isOptional,I=null!=A&&A.func?"func":"value",x=l&&(null==_?void 0:_.label)||T,L=d?d.get(T):void 0,N=L?L.get("value"):void 0,j=L?L.get("valueSrc"):void 0;"func"!==j&&null!==(S=N)&&void 0!==S&&S.toJS&&(N=N.toJS());var P=L?L.get("asyncListValues"):void 0,k=xd(e,t,N,j,null==_?void 0:_.type,w,_,null,null,a,P);null!=N&&void 0===k&&"func"!=j&&t.errors.push("Can't format value of arg ".concat(T," for func ").concat(c));var F=void 0;if(void 0===k&&!C&&null!=A&&void 0===(F=xd(e,t,A,I,null==_?void 0:_.type,w,_,null,null,a,P)))return void("func"!=I&&t.errors.push("Can't format default value of arg ".concat(T," for func ").concat(c)));var D=null!=k?k:F;if(void 0!==D){if(m.length){var M,V=Sd(T);try{for(V.s();!(M=V.n()).done;){var U=Hn(M.value,2),B=U[0];U[1],y[B]=void 0}}catch(e){V.e(e)}finally{V.f()}m=[]}y[T]=D,O[x]=D}else C||b.push(T),m.push([T,x])}}catch(e){E.e(e)}finally{E.f()}if(!b.length||u){var q=null;if("function"==typeof(null==p?void 0:p.formatFunc)){var G=p.formatFunc,K=[y,l];q=G.call.apply(G,[e.ctx].concat(K))}else{var W=Object.entries(l?O:y).map((function(e){var t=Hn(e,2),r=t[0],n=t[1];return l?"".concat(r,": ").concat(n):"".concat(n)})).join(", ");q="".concat(g,"(").concat(W,")")}return q}}else t.errors.push("Func ".concat(c," is not defined in config"))},jd="EMPTY_GROUP",Pd="EMPTY_RULE_GROUP",kd="EMPTY_QUERY",Fd="EMPTY_CASE",Dd="NO_CONFIG_FOR_FIELD",Md="NO_CONFIG_FOR_OPERATOR",Vd="NO_CONFIG_FOR_FUNCTION",Ud="INVALID_VALUE",Bd="INVALID_FUNC_ARG_VALUE",qd="UNSUPPORTED_FIELD_TYPE",Gd="UNSUPPORTED_OPERATOR_FOR_FIELD",Kd="INVALID_VALUE_SRC",Wd="INCOMPLETE_RULE",zd="INCOMPLETE_LHS",$d="INCOMPLETE_RHS",Hd="BAD_MULTISELECT_VALUES",Yd="BAD_SELECT_VALUE",Qd="INCORRECT_VALUE_TYPE",Xd="INCORRECT_VALUE_JS_TYPE",Jd="VALUE_LENGTH_CONSTRAINT_FAIL",Zd="VALUE_MIN_CONSTRAINT_FAIL",ep="VALUE_MAX_CONSTRAINT_FAIL",tp="NO_CONFIG_FOR_FIELD_VALUE",rp="CANT_COMPARE_FIELD_WITH_ITSELF",np="CANT_COMPARE_FIELD_WITH_FIELD",op="INCORRECT_FIELD_TYPE",ip="UNSUPPORTED_FUNCTION_FOR_FIELD",ap="REQUIRED_FUNCTION_ARG",sp="INCORRECT_FUNCTION_RETURN_TYPE",lp="INVALID_RANGE",up="ITEM_POSITION",cp="ITEM_POSITION_ROOT",dp="ITEM_POSITION_WITH_INDEX_PATH",pp="ITEM_POSITION_IN_CASE",fp="range";const hp={type:"logger",log(e){this.output("log",e)},warn(e){this.output("warn",e)},error(e){this.output("error",e)},output(e,t){console&&console[e]&&console[e].apply(console,t)}};class vp{constructor(e){let t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:{};this.init(e,t)}init(e){let t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:{};this.prefix=t.prefix||"i18next:",this.logger=e||hp,this.options=t,this.debug=t.debug}log(){for(var e=arguments.length,t=new Array(e),r=0;r<e;r++)t[r]=arguments[r];return this.forward(t,"log","",!0)}warn(){for(var e=arguments.length,t=new Array(e),r=0;r<e;r++)t[r]=arguments[r];return this.forward(t,"warn","",!0)}error(){for(var e=arguments.length,t=new Array(e),r=0;r<e;r++)t[r]=arguments[r];return this.forward(t,"error","")}deprecate(){for(var e=arguments.length,t=new Array(e),r=0;r<e;r++)t[r]=arguments[r];return this.forward(t,"warn","WARNING DEPRECATED: ",!0)}forward(e,t,r,n){return n&&!this.debug?null:("string"==typeof e[0]&&(e[0]=`${r}${this.prefix} ${e[0]}`),this.logger[t](e))}create(e){return new vp(this.logger,{prefix:`${this.prefix}:${e}:`,...this.options})}clone(e){return(e=e||this.options).prefix=e.prefix||this.prefix,new vp(this.logger,e)}}var gp=new vp;class yp{constructor(){this.observers={}}on(e,t){return e.split(" ").forEach((e=>{this.observers[e]||(this.observers[e]=new Map);const r=this.observers[e].get(t)||0;this.observers[e].set(t,r+1)})),this}off(e,t){this.observers[e]&&(t?this.observers[e].delete(t):delete this.observers[e])}emit(e){for(var t=arguments.length,r=new Array(t>1?t-1:0),n=1;n<t;n++)r[n-1]=arguments[n];this.observers[e]&&Array.from(this.observers[e].entries()).forEach((e=>{let[t,n]=e;for(let e=0;e<n;e++)t(...r)})),this.observers["*"]&&Array.from(this.observers["*"].entries()).forEach((t=>{let[n,o]=t;for(let t=0;t<o;t++)n.apply(n,[e,...r])}))}}function mp(){let e,t;const r=new Promise(((r,n)=>{e=r,t=n}));return r.resolve=e,r.reject=t,r}function bp(e){return null==e?"":""+e}const Op=/###/g;function Ep(e,t,r){function n(e){return e&&e.indexOf("###")>-1?e.replace(Op,"."):e}function o(){return!e||"string"==typeof e}const i="string"!=typeof t?t:t.split(".");let a=0;for(;a<i.length-1;){if(o())return{};const t=n(i[a]);!e[t]&&r&&(e[t]=new r),e=Object.prototype.hasOwnProperty.call(e,t)?e[t]:{},++a}return o()?{}:{obj:e,k:n(i[a])}}function Sp(e,t,r){const{obj:n,k:o}=Ep(e,t,Object);if(void 0!==n||1===t.length)return void(n[o]=r);let i=t[t.length-1],a=t.slice(0,t.length-1),s=Ep(e,a,Object);for(;void 0===s.obj&&a.length;)i=`${a[a.length-1]}.${i}`,a=a.slice(0,a.length-1),s=Ep(e,a,Object),s&&s.obj&&void 0!==s.obj[`${s.k}.${i}`]&&(s.obj=void 0);s.obj[`${s.k}.${i}`]=r}function Tp(e,t){const{obj:r,k:n}=Ep(e,t);if(r)return r[n]}function _p(e,t,r){for(const n in t)"__proto__"!==n&&"constructor"!==n&&(n in e?"string"==typeof e[n]||e[n]instanceof String||"string"==typeof t[n]||t[n]instanceof String?r&&(e[n]=t[n]):_p(e[n],t[n],r):e[n]=t[n]);return e}function wp(e){return e.replace(/[\-\[\]\/\{\}\(\)\*\+\?\.\\\^\$\|]/g,"\\$&")}var Rp={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;","/":"&#x2F;"};function Ap(e){return"string"==typeof e?e.replace(/[&<>"'\/]/g,(e=>Rp[e])):e}const Cp=[" ",",","?","!",";"],Ip=new class{constructor(e){this.capacity=e,this.regExpMap=new Map,this.regExpQueue=[]}getRegExp(e){const t=this.regExpMap.get(e);if(void 0!==t)return t;const r=new RegExp(e);return this.regExpQueue.length===this.capacity&&this.regExpMap.delete(this.regExpQueue.shift()),this.regExpMap.set(e,r),this.regExpQueue.push(e),r}}(20);function xp(e,t){let r=arguments.length>2&&void 0!==arguments[2]?arguments[2]:".";if(!e)return;if(e[t])return e[t];const n=t.split(r);let o=e;for(let e=0;e<n.length;){if(!o||"object"!=typeof o)return;let t,i="";for(let a=e;a<n.length;++a)if(a!==e&&(i+=r),i+=n[a],t=o[i],void 0!==t){if(["string","number","boolean"].indexOf(typeof t)>-1&&a<n.length-1)continue;e+=a-e+1;break}o=t}return o}function Lp(e){return e&&e.indexOf("_")>0?e.replace("_","-"):e}class Np extends yp{constructor(e){let t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:{ns:["translation"],defaultNS:"translation"};super(),this.data=e||{},this.options=t,void 0===this.options.keySeparator&&(this.options.keySeparator="."),void 0===this.options.ignoreJSONStructure&&(this.options.ignoreJSONStructure=!0)}addNamespaces(e){this.options.ns.indexOf(e)<0&&this.options.ns.push(e)}removeNamespaces(e){const t=this.options.ns.indexOf(e);t>-1&&this.options.ns.splice(t,1)}getResource(e,t,r){let n=arguments.length>3&&void 0!==arguments[3]?arguments[3]:{};const o=void 0!==n.keySeparator?n.keySeparator:this.options.keySeparator,i=void 0!==n.ignoreJSONStructure?n.ignoreJSONStructure:this.options.ignoreJSONStructure;let a;e.indexOf(".")>-1?a=e.split("."):(a=[e,t],r&&(Array.isArray(r)?a.push(...r):"string"==typeof r&&o?a.push(...r.split(o)):a.push(r)));const s=Tp(this.data,a);return!s&&!t&&!r&&e.indexOf(".")>-1&&(e=a[0],t=a[1],r=a.slice(2).join(".")),s||!i||"string"!=typeof r?s:xp(this.data&&this.data[e]&&this.data[e][t],r,o)}addResource(e,t,r,n){let o=arguments.length>4&&void 0!==arguments[4]?arguments[4]:{silent:!1};const i=void 0!==o.keySeparator?o.keySeparator:this.options.keySeparator;let a=[e,t];r&&(a=a.concat(i?r.split(i):r)),e.indexOf(".")>-1&&(a=e.split("."),n=t,t=a[1]),this.addNamespaces(t),Sp(this.data,a,n),o.silent||this.emit("added",e,t,r,n)}addResources(e,t,r){let n=arguments.length>3&&void 0!==arguments[3]?arguments[3]:{silent:!1};for(const n in r)("string"==typeof r[n]||Array.isArray(r[n]))&&this.addResource(e,t,n,r[n],{silent:!0});n.silent||this.emit("added",e,t,r)}addResourceBundle(e,t,r,n,o){let i=arguments.length>5&&void 0!==arguments[5]?arguments[5]:{silent:!1,skipCopy:!1},a=[e,t];e.indexOf(".")>-1&&(a=e.split("."),n=r,r=t,t=a[1]),this.addNamespaces(t);let s=Tp(this.data,a)||{};i.skipCopy||(r=JSON.parse(JSON.stringify(r))),n?_p(s,r,o):s={...s,...r},Sp(this.data,a,s),i.silent||this.emit("added",e,t,r)}removeResourceBundle(e,t){this.hasResourceBundle(e,t)&&delete this.data[e][t],this.removeNamespaces(t),this.emit("removed",e,t)}hasResourceBundle(e,t){return void 0!==this.getResource(e,t)}getResourceBundle(e,t){return t||(t=this.options.defaultNS),"v1"===this.options.compatibilityAPI?{...this.getResource(e,t)}:this.getResource(e,t)}getDataByLanguage(e){return this.data[e]}hasLanguageSomeTranslations(e){const t=this.getDataByLanguage(e);return!!(t&&Object.keys(t)||[]).find((e=>t[e]&&Object.keys(t[e]).length>0))}toJSON(){return this.data}}var jp={processors:{},addPostProcessor(e){this.processors[e.name]=e},handle(e,t,r,n,o){return e.forEach((e=>{this.processors[e]&&(t=this.processors[e].process(t,r,n,o))})),t}};const Pp={};class kp extends yp{constructor(e){let t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:{};var r,n;super(),r=e,n=this,["resourceStore","languageUtils","pluralResolver","interpolator","backendConnector","i18nFormat","utils"].forEach((e=>{r[e]&&(n[e]=r[e])})),this.options=t,void 0===this.options.keySeparator&&(this.options.keySeparator="."),this.logger=gp.create("translator")}changeLanguage(e){e&&(this.language=e)}exists(e){let t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:{interpolation:{}};if(null==e)return!1;const r=this.resolve(e,t);return r&&void 0!==r.res}extractFromKey(e,t){let r=void 0!==t.nsSeparator?t.nsSeparator:this.options.nsSeparator;void 0===r&&(r=":");const n=void 0!==t.keySeparator?t.keySeparator:this.options.keySeparator;let o=t.ns||this.options.defaultNS||[];const i=r&&e.indexOf(r)>-1,a=!(this.options.userDefinedKeySeparator||t.keySeparator||this.options.userDefinedNsSeparator||t.nsSeparator||function(e,t,r){t=t||"",r=r||"";const n=Cp.filter((e=>t.indexOf(e)<0&&r.indexOf(e)<0));if(0===n.length)return!0;const o=Ip.getRegExp(`(${n.map((e=>"?"===e?"\\?":e)).join("|")})`);let i=!o.test(e);if(!i){const t=e.indexOf(r);t>0&&!o.test(e.substring(0,t))&&(i=!0)}return i}(e,r,n));if(i&&!a){const t=e.match(this.interpolator.nestingRegexp);if(t&&t.length>0)return{key:e,namespaces:o};const i=e.split(r);(r!==n||r===n&&this.options.ns.indexOf(i[0])>-1)&&(o=i.shift()),e=i.join(n)}return"string"==typeof o&&(o=[o]),{key:e,namespaces:o}}translate(e,t,r){if("object"!=typeof t&&this.options.overloadTranslationOptionHandler&&(t=this.options.overloadTranslationOptionHandler(arguments)),"object"==typeof t&&(t={...t}),t||(t={}),null==e)return"";Array.isArray(e)||(e=[String(e)]);const n=void 0!==t.returnDetails?t.returnDetails:this.options.returnDetails,o=void 0!==t.keySeparator?t.keySeparator:this.options.keySeparator,{key:i,namespaces:a}=this.extractFromKey(e[e.length-1],t),s=a[a.length-1],l=t.lng||this.language,u=t.appendNamespaceToCIMode||this.options.appendNamespaceToCIMode;if(l&&"cimode"===l.toLowerCase()){if(u){const e=t.nsSeparator||this.options.nsSeparator;return n?{res:`${s}${e}${i}`,usedKey:i,exactUsedKey:i,usedLng:l,usedNS:s,usedParams:this.getUsedParamsDetails(t)}:`${s}${e}${i}`}return n?{res:i,usedKey:i,exactUsedKey:i,usedLng:l,usedNS:s,usedParams:this.getUsedParamsDetails(t)}:i}const c=this.resolve(e,t);let d=c&&c.res;const p=c&&c.usedKey||i,f=c&&c.exactUsedKey||i,h=Object.prototype.toString.apply(d),v=void 0!==t.joinArrays?t.joinArrays:this.options.joinArrays,g=!this.i18nFormat||this.i18nFormat.handleAsObject;if(g&&d&&"string"!=typeof d&&"boolean"!=typeof d&&"number"!=typeof d&&["[object Number]","[object Function]","[object RegExp]"].indexOf(h)<0&&("string"!=typeof v||!Array.isArray(d))){if(!t.returnObjects&&!this.options.returnObjects){this.options.returnedObjectHandler||this.logger.warn("accessing an object - but returnObjects options is not enabled!");const e=this.options.returnedObjectHandler?this.options.returnedObjectHandler(p,d,{...t,ns:a}):`key '${i} (${this.language})' returned an object instead of string.`;return n?(c.res=e,c.usedParams=this.getUsedParamsDetails(t),c):e}if(o){const e=Array.isArray(d),r=e?[]:{},n=e?f:p;for(const e in d)if(Object.prototype.hasOwnProperty.call(d,e)){const i=`${n}${o}${e}`;r[e]=this.translate(i,{...t,joinArrays:!1,ns:a}),r[e]===i&&(r[e]=d[e])}d=r}}else if(g&&"string"==typeof v&&Array.isArray(d))d=d.join(v),d&&(d=this.extendTranslation(d,e,t,r));else{let n=!1,a=!1;const u=void 0!==t.count&&"string"!=typeof t.count,p=kp.hasDefaultValue(t),f=u?this.pluralResolver.getSuffix(l,t.count,t):"",h=t.ordinal&&u?this.pluralResolver.getSuffix(l,t.count,{ordinal:!1}):"",v=u&&!t.ordinal&&0===t.count&&this.pluralResolver.shouldUseIntlApi(),g=v&&t[`defaultValue${this.options.pluralSeparator}zero`]||t[`defaultValue${f}`]||t[`defaultValue${h}`]||t.defaultValue;!this.isValidLookup(d)&&p&&(n=!0,d=g),this.isValidLookup(d)||(a=!0,d=i);const y=(t.missingKeyNoValueFallbackToKey||this.options.missingKeyNoValueFallbackToKey)&&a?void 0:d,m=p&&g!==d&&this.options.updateMissing;if(a||n||m){if(this.logger.log(m?"updateKey":"missingKey",l,s,i,m?g:d),o){const e=this.resolve(i,{...t,keySeparator:!1});e&&e.res&&this.logger.warn("Seems the loaded translations were in flat JSON format instead of nested. Either set keySeparator: false on init or make sure your translations are published in nested format.")}let e=[];const r=this.languageUtils.getFallbackCodes(this.options.fallbackLng,t.lng||this.language);if("fallback"===this.options.saveMissingTo&&r&&r[0])for(let t=0;t<r.length;t++)e.push(r[t]);else"all"===this.options.saveMissingTo?e=this.languageUtils.toResolveHierarchy(t.lng||this.language):e.push(t.lng||this.language);const n=(e,r,n)=>{const o=p&&n!==d?n:y;this.options.missingKeyHandler?this.options.missingKeyHandler(e,s,r,o,m,t):this.backendConnector&&this.backendConnector.saveMissing&&this.backendConnector.saveMissing(e,s,r,o,m,t),this.emit("missingKey",e,s,r,d)};this.options.saveMissing&&(this.options.saveMissingPlurals&&u?e.forEach((e=>{const r=this.pluralResolver.getSuffixes(e,t);v&&t[`defaultValue${this.options.pluralSeparator}zero`]&&r.indexOf(`${this.options.pluralSeparator}zero`)<0&&r.push(`${this.options.pluralSeparator}zero`),r.forEach((r=>{n([e],i+r,t[`defaultValue${r}`]||g)}))})):n(e,i,g))}d=this.extendTranslation(d,e,t,c,r),a&&d===i&&this.options.appendNamespaceToMissingKey&&(d=`${s}:${i}`),(a||n)&&this.options.parseMissingKeyHandler&&(d="v1"!==this.options.compatibilityAPI?this.options.parseMissingKeyHandler(this.options.appendNamespaceToMissingKey?`${s}:${i}`:i,n?d:void 0):this.options.parseMissingKeyHandler(d))}return n?(c.res=d,c.usedParams=this.getUsedParamsDetails(t),c):d}extendTranslation(e,t,r,n,o){var i=this;if(this.i18nFormat&&this.i18nFormat.parse)e=this.i18nFormat.parse(e,{...this.options.interpolation.defaultVariables,...r},r.lng||this.language||n.usedLng,n.usedNS,n.usedKey,{resolved:n});else if(!r.skipInterpolation){r.interpolation&&this.interpolator.init({...r,interpolation:{...this.options.interpolation,...r.interpolation}});const a="string"==typeof e&&(r&&r.interpolation&&void 0!==r.interpolation.skipOnVariables?r.interpolation.skipOnVariables:this.options.interpolation.skipOnVariables);let s;if(a){const t=e.match(this.interpolator.nestingRegexp);s=t&&t.length}let l=r.replace&&"string"!=typeof r.replace?r.replace:r;if(this.options.interpolation.defaultVariables&&(l={...this.options.interpolation.defaultVariables,...l}),e=this.interpolator.interpolate(e,l,r.lng||this.language||n.usedLng,r),a){const t=e.match(this.interpolator.nestingRegexp);s<(t&&t.length)&&(r.nest=!1)}!r.lng&&"v1"!==this.options.compatibilityAPI&&n&&n.res&&(r.lng=this.language||n.usedLng),!1!==r.nest&&(e=this.interpolator.nest(e,(function(){for(var e=arguments.length,n=new Array(e),a=0;a<e;a++)n[a]=arguments[a];return o&&o[0]===n[0]&&!r.context?(i.logger.warn(`It seems you are nesting recursively key: ${n[0]} in key: ${t[0]}`),null):i.translate(...n,t)}),r)),r.interpolation&&this.interpolator.reset()}const a=r.postProcess||this.options.postProcess,s="string"==typeof a?[a]:a;return null!=e&&s&&s.length&&!1!==r.applyPostProcessor&&(e=jp.handle(s,e,t,this.options&&this.options.postProcessPassResolved?{i18nResolved:{...n,usedParams:this.getUsedParamsDetails(r)},...r}:r,this)),e}resolve(e){let t,r,n,o,i,a=arguments.length>1&&void 0!==arguments[1]?arguments[1]:{};return"string"==typeof e&&(e=[e]),e.forEach((e=>{if(this.isValidLookup(t))return;const s=this.extractFromKey(e,a),l=s.key;r=l;let u=s.namespaces;this.options.fallbackNS&&(u=u.concat(this.options.fallbackNS));const c=void 0!==a.count&&"string"!=typeof a.count,d=c&&!a.ordinal&&0===a.count&&this.pluralResolver.shouldUseIntlApi(),p=void 0!==a.context&&("string"==typeof a.context||"number"==typeof a.context)&&""!==a.context,f=a.lngs?a.lngs:this.languageUtils.toResolveHierarchy(a.lng||this.language,a.fallbackLng);u.forEach((e=>{this.isValidLookup(t)||(i=e,!Pp[`${f[0]}-${e}`]&&this.utils&&this.utils.hasLoadedNamespace&&!this.utils.hasLoadedNamespace(i)&&(Pp[`${f[0]}-${e}`]=!0,this.logger.warn(`key "${r}" for languages "${f.join(", ")}" won't get resolved as namespace "${i}" was not yet loaded`,"This means something IS WRONG in your setup. You access the t function before i18next.init / i18next.loadNamespace / i18next.changeLanguage was done. Wait for the callback or Promise to resolve before accessing it!!!")),f.forEach((r=>{if(this.isValidLookup(t))return;o=r;const i=[l];if(this.i18nFormat&&this.i18nFormat.addLookupKeys)this.i18nFormat.addLookupKeys(i,l,r,e,a);else{let e;c&&(e=this.pluralResolver.getSuffix(r,a.count,a));const t=`${this.options.pluralSeparator}zero`,n=`${this.options.pluralSeparator}ordinal${this.options.pluralSeparator}`;if(c&&(i.push(l+e),a.ordinal&&0===e.indexOf(n)&&i.push(l+e.replace(n,this.options.pluralSeparator)),d&&i.push(l+t)),p){const r=`${l}${this.options.contextSeparator}${a.context}`;i.push(r),c&&(i.push(r+e),a.ordinal&&0===e.indexOf(n)&&i.push(r+e.replace(n,this.options.pluralSeparator)),d&&i.push(r+t))}}let s;for(;s=i.pop();)this.isValidLookup(t)||(n=s,t=this.getResource(r,e,s,a))})))}))})),{res:t,usedKey:r,exactUsedKey:n,usedLng:o,usedNS:i}}isValidLookup(e){return!(void 0===e||!this.options.returnNull&&null===e||!this.options.returnEmptyString&&""===e)}getResource(e,t,r){let n=arguments.length>3&&void 0!==arguments[3]?arguments[3]:{};return this.i18nFormat&&this.i18nFormat.getResource?this.i18nFormat.getResource(e,t,r,n):this.resourceStore.getResource(e,t,r,n)}getUsedParamsDetails(){let e=arguments.length>0&&void 0!==arguments[0]?arguments[0]:{};const t=["defaultValue","ordinal","context","replace","lng","lngs","fallbackLng","ns","keySeparator","nsSeparator","returnObjects","returnDetails","joinArrays","postProcess","interpolation"],r=e.replace&&"string"!=typeof e.replace;let n=r?e.replace:e;if(r&&void 0!==e.count&&(n.count=e.count),this.options.interpolation.defaultVariables&&(n={...this.options.interpolation.defaultVariables,...n}),!r){n={...n};for(const e of t)delete n[e]}return n}static hasDefaultValue(e){for(const t in e)if(Object.prototype.hasOwnProperty.call(e,t)&&"defaultValue"===t.substring(0,12)&&void 0!==e[t])return!0;return!1}}function Fp(e){return e.charAt(0).toUpperCase()+e.slice(1)}class Dp{constructor(e){this.options=e,this.supportedLngs=this.options.supportedLngs||!1,this.logger=gp.create("languageUtils")}getScriptPartFromCode(e){if(!(e=Lp(e))||e.indexOf("-")<0)return null;const t=e.split("-");return 2===t.length?null:(t.pop(),"x"===t[t.length-1].toLowerCase()?null:this.formatLanguageCode(t.join("-")))}getLanguagePartFromCode(e){if(!(e=Lp(e))||e.indexOf("-")<0)return e;const t=e.split("-");return this.formatLanguageCode(t[0])}formatLanguageCode(e){if("string"==typeof e&&e.indexOf("-")>-1){const t=["hans","hant","latn","cyrl","cans","mong","arab"];let r=e.split("-");return this.options.lowerCaseLng?r=r.map((e=>e.toLowerCase())):2===r.length?(r[0]=r[0].toLowerCase(),r[1]=r[1].toUpperCase(),t.indexOf(r[1].toLowerCase())>-1&&(r[1]=Fp(r[1].toLowerCase()))):3===r.length&&(r[0]=r[0].toLowerCase(),2===r[1].length&&(r[1]=r[1].toUpperCase()),"sgn"!==r[0]&&2===r[2].length&&(r[2]=r[2].toUpperCase()),t.indexOf(r[1].toLowerCase())>-1&&(r[1]=Fp(r[1].toLowerCase())),t.indexOf(r[2].toLowerCase())>-1&&(r[2]=Fp(r[2].toLowerCase()))),r.join("-")}return this.options.cleanCode||this.options.lowerCaseLng?e.toLowerCase():e}isSupportedCode(e){return("languageOnly"===this.options.load||this.options.nonExplicitSupportedLngs)&&(e=this.getLanguagePartFromCode(e)),!this.supportedLngs||!this.supportedLngs.length||this.supportedLngs.indexOf(e)>-1}getBestMatchFromCodes(e){if(!e)return null;let t;return e.forEach((e=>{if(t)return;const r=this.formatLanguageCode(e);this.options.supportedLngs&&!this.isSupportedCode(r)||(t=r)})),!t&&this.options.supportedLngs&&e.forEach((e=>{if(t)return;const r=this.getLanguagePartFromCode(e);if(this.isSupportedCode(r))return t=r;t=this.options.supportedLngs.find((e=>e===r?e:e.indexOf("-")<0&&r.indexOf("-")<0?void 0:e.indexOf("-")>0&&r.indexOf("-")<0&&e.substring(0,e.indexOf("-"))===r||0===e.indexOf(r)&&r.length>1?e:void 0))})),t||(t=this.getFallbackCodes(this.options.fallbackLng)[0]),t}getFallbackCodes(e,t){if(!e)return[];if("function"==typeof e&&(e=e(t)),"string"==typeof e&&(e=[e]),Array.isArray(e))return e;if(!t)return e.default||[];let r=e[t];return r||(r=e[this.getScriptPartFromCode(t)]),r||(r=e[this.formatLanguageCode(t)]),r||(r=e[this.getLanguagePartFromCode(t)]),r||(r=e.default),r||[]}toResolveHierarchy(e,t){const r=this.getFallbackCodes(t||this.options.fallbackLng||[],e),n=[],o=e=>{e&&(this.isSupportedCode(e)?n.push(e):this.logger.warn(`rejecting language code not found in supportedLngs: ${e}`))};return"string"==typeof e&&(e.indexOf("-")>-1||e.indexOf("_")>-1)?("languageOnly"!==this.options.load&&o(this.formatLanguageCode(e)),"languageOnly"!==this.options.load&&"currentOnly"!==this.options.load&&o(this.getScriptPartFromCode(e)),"currentOnly"!==this.options.load&&o(this.getLanguagePartFromCode(e))):"string"==typeof e&&o(this.formatLanguageCode(e)),r.forEach((e=>{n.indexOf(e)<0&&o(this.formatLanguageCode(e))})),n}}let Mp=[{lngs:["ach","ak","am","arn","br","fil","gun","ln","mfe","mg","mi","oc","pt","pt-BR","tg","tl","ti","tr","uz","wa"],nr:[1,2],fc:1},{lngs:["af","an","ast","az","bg","bn","ca","da","de","dev","el","en","eo","es","et","eu","fi","fo","fur","fy","gl","gu","ha","hi","hu","hy","ia","it","kk","kn","ku","lb","mai","ml","mn","mr","nah","nap","nb","ne","nl","nn","no","nso","pa","pap","pms","ps","pt-PT","rm","sco","se","si","so","son","sq","sv","sw","ta","te","tk","ur","yo"],nr:[1,2],fc:2},{lngs:["ay","bo","cgg","fa","ht","id","ja","jbo","ka","km","ko","ky","lo","ms","sah","su","th","tt","ug","vi","wo","zh"],nr:[1],fc:3},{lngs:["be","bs","cnr","dz","hr","ru","sr","uk"],nr:[1,2,5],fc:4},{lngs:["ar"],nr:[0,1,2,3,11,100],fc:5},{lngs:["cs","sk"],nr:[1,2,5],fc:6},{lngs:["csb","pl"],nr:[1,2,5],fc:7},{lngs:["cy"],nr:[1,2,3,8],fc:8},{lngs:["fr"],nr:[1,2],fc:9},{lngs:["ga"],nr:[1,2,3,7,11],fc:10},{lngs:["gd"],nr:[1,2,3,20],fc:11},{lngs:["is"],nr:[1,2],fc:12},{lngs:["jv"],nr:[0,1],fc:13},{lngs:["kw"],nr:[1,2,3,4],fc:14},{lngs:["lt"],nr:[1,2,10],fc:15},{lngs:["lv"],nr:[1,2,0],fc:16},{lngs:["mk"],nr:[1,2],fc:17},{lngs:["mnk"],nr:[0,1,2],fc:18},{lngs:["mt"],nr:[1,2,11,20],fc:19},{lngs:["or"],nr:[2,1],fc:2},{lngs:["ro"],nr:[1,2,20],fc:20},{lngs:["sl"],nr:[5,1,2,3],fc:21},{lngs:["he","iw"],nr:[1,2,20,21],fc:22}],Vp={1:function(e){return Number(e>1)},2:function(e){return Number(1!=e)},3:function(e){return 0},4:function(e){return Number(e%10==1&&e%100!=11?0:e%10>=2&&e%10<=4&&(e%100<10||e%100>=20)?1:2)},5:function(e){return Number(0==e?0:1==e?1:2==e?2:e%100>=3&&e%100<=10?3:e%100>=11?4:5)},6:function(e){return Number(1==e?0:e>=2&&e<=4?1:2)},7:function(e){return Number(1==e?0:e%10>=2&&e%10<=4&&(e%100<10||e%100>=20)?1:2)},8:function(e){return Number(1==e?0:2==e?1:8!=e&&11!=e?2:3)},9:function(e){return Number(e>=2)},10:function(e){return Number(1==e?0:2==e?1:e<7?2:e<11?3:4)},11:function(e){return Number(1==e||11==e?0:2==e||12==e?1:e>2&&e<20?2:3)},12:function(e){return Number(e%10!=1||e%100==11)},13:function(e){return Number(0!==e)},14:function(e){return Number(1==e?0:2==e?1:3==e?2:3)},15:function(e){return Number(e%10==1&&e%100!=11?0:e%10>=2&&(e%100<10||e%100>=20)?1:2)},16:function(e){return Number(e%10==1&&e%100!=11?0:0!==e?1:2)},17:function(e){return Number(1==e||e%10==1&&e%100!=11?0:1)},18:function(e){return Number(0==e?0:1==e?1:2)},19:function(e){return Number(1==e?0:0==e||e%100>1&&e%100<11?1:e%100>10&&e%100<20?2:3)},20:function(e){return Number(1==e?0:0==e||e%100>0&&e%100<20?1:2)},21:function(e){return Number(e%100==1?1:e%100==2?2:e%100==3||e%100==4?3:0)},22:function(e){return Number(1==e?0:2==e?1:(e<0||e>10)&&e%10==0?2:3)}};const Up=["v1","v2","v3"],Bp=["v4"],qp={zero:0,one:1,two:2,few:3,many:4,other:5};class Gp{constructor(e){let t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:{};this.languageUtils=e,this.options=t,this.logger=gp.create("pluralResolver"),this.options.compatibilityJSON&&!Bp.includes(this.options.compatibilityJSON)||"undefined"!=typeof Intl&&Intl.PluralRules||(this.options.compatibilityJSON="v3",this.logger.error("Your environment seems not to be Intl API compatible, use an Intl.PluralRules polyfill. Will fallback to the compatibilityJSON v3 format handling.")),this.rules=function(){const e={};return Mp.forEach((t=>{t.lngs.forEach((r=>{e[r]={numbers:t.nr,plurals:Vp[t.fc]}}))})),e}()}addRule(e,t){this.rules[e]=t}getRule(e){let t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:{};if(this.shouldUseIntlApi())try{return new Intl.PluralRules(Lp("dev"===e?"en":e),{type:t.ordinal?"ordinal":"cardinal"})}catch(e){return}return this.rules[e]||this.rules[this.languageUtils.getLanguagePartFromCode(e)]}needsPlural(e){let t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:{};const r=this.getRule(e,t);return this.shouldUseIntlApi()?r&&r.resolvedOptions().pluralCategories.length>1:r&&r.numbers.length>1}getPluralFormsOfKey(e,t){let r=arguments.length>2&&void 0!==arguments[2]?arguments[2]:{};return this.getSuffixes(e,r).map((e=>`${t}${e}`))}getSuffixes(e){let t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:{};const r=this.getRule(e,t);return r?this.shouldUseIntlApi()?r.resolvedOptions().pluralCategories.sort(((e,t)=>qp[e]-qp[t])).map((e=>`${this.options.prepend}${t.ordinal?`ordinal${this.options.prepend}`:""}${e}`)):r.numbers.map((r=>this.getSuffix(e,r,t))):[]}getSuffix(e,t){let r=arguments.length>2&&void 0!==arguments[2]?arguments[2]:{};const n=this.getRule(e,r);return n?this.shouldUseIntlApi()?`${this.options.prepend}${r.ordinal?`ordinal${this.options.prepend}`:""}${n.select(t)}`:this.getSuffixRetroCompatible(n,t):(this.logger.warn(`no plural rule found for: ${e}`),"")}getSuffixRetroCompatible(e,t){const r=e.noAbs?e.plurals(t):e.plurals(Math.abs(t));let n=e.numbers[r];this.options.simplifyPluralSuffix&&2===e.numbers.length&&1===e.numbers[0]&&(2===n?n="plural":1===n&&(n=""));const o=()=>this.options.prepend&&n.toString()?this.options.prepend+n.toString():n.toString();return"v1"===this.options.compatibilityJSON?1===n?"":"number"==typeof n?`_plural_${n.toString()}`:o():"v2"===this.options.compatibilityJSON||this.options.simplifyPluralSuffix&&2===e.numbers.length&&1===e.numbers[0]?o():this.options.prepend&&r.toString()?this.options.prepend+r.toString():r.toString()}shouldUseIntlApi(){return!Up.includes(this.options.compatibilityJSON)}}function Kp(e,t,r){let n=arguments.length>3&&void 0!==arguments[3]?arguments[3]:".",o=!(arguments.length>4&&void 0!==arguments[4])||arguments[4],i=function(e,t,r){const n=Tp(e,r);return void 0!==n?n:Tp(t,r)}(e,t,r);return!i&&o&&"string"==typeof r&&(i=xp(e,r,n),void 0===i&&(i=xp(t,r,n))),i}class Wp{constructor(){let e=arguments.length>0&&void 0!==arguments[0]?arguments[0]:{};this.logger=gp.create("interpolator"),this.options=e,this.format=e.interpolation&&e.interpolation.format||(e=>e),this.init(e)}init(){let e=arguments.length>0&&void 0!==arguments[0]?arguments[0]:{};e.interpolation||(e.interpolation={escapeValue:!0});const{escape:t,escapeValue:r,useRawValueToEscape:n,prefix:o,prefixEscaped:i,suffix:a,suffixEscaped:s,formatSeparator:l,unescapeSuffix:u,unescapePrefix:c,nestingPrefix:d,nestingPrefixEscaped:p,nestingSuffix:f,nestingSuffixEscaped:h,nestingOptionsSeparator:v,maxReplaces:g,alwaysFormat:y}=e.interpolation;this.escape=void 0!==t?t:Ap,this.escapeValue=void 0===r||r,this.useRawValueToEscape=void 0!==n&&n,this.prefix=o?wp(o):i||"{{",this.suffix=a?wp(a):s||"}}",this.formatSeparator=l||",",this.unescapePrefix=u?"":c||"-",this.unescapeSuffix=this.unescapePrefix?"":u||"",this.nestingPrefix=d?wp(d):p||wp("$t("),this.nestingSuffix=f?wp(f):h||wp(")"),this.nestingOptionsSeparator=v||",",this.maxReplaces=g||1e3,this.alwaysFormat=void 0!==y&&y,this.resetRegExp()}reset(){this.options&&this.init(this.options)}resetRegExp(){const e=(e,t)=>e&&e.source===t?(e.lastIndex=0,e):new RegExp(t,"g");this.regexp=e(this.regexp,`${this.prefix}(.+?)${this.suffix}`),this.regexpUnescape=e(this.regexpUnescape,`${this.prefix}${this.unescapePrefix}(.+?)${this.unescapeSuffix}${this.suffix}`),this.nestingRegexp=e(this.nestingRegexp,`${this.nestingPrefix}(.+?)${this.nestingSuffix}`)}interpolate(e,t,r,n){let o,i,a;const s=this.options&&this.options.interpolation&&this.options.interpolation.defaultVariables||{};function l(e){return e.replace(/\$/g,"$$$$")}const u=e=>{if(e.indexOf(this.formatSeparator)<0){const o=Kp(t,s,e,this.options.keySeparator,this.options.ignoreJSONStructure);return this.alwaysFormat?this.format(o,void 0,r,{...n,...t,interpolationkey:e}):o}const o=e.split(this.formatSeparator),i=o.shift().trim(),a=o.join(this.formatSeparator).trim();return this.format(Kp(t,s,i,this.options.keySeparator,this.options.ignoreJSONStructure),a,r,{...n,...t,interpolationkey:i})};this.resetRegExp();const c=n&&n.missingInterpolationHandler||this.options.missingInterpolationHandler,d=n&&n.interpolation&&void 0!==n.interpolation.skipOnVariables?n.interpolation.skipOnVariables:this.options.interpolation.skipOnVariables;return[{regex:this.regexpUnescape,safeValue:e=>l(e)},{regex:this.regexp,safeValue:e=>this.escapeValue?l(this.escape(e)):l(e)}].forEach((t=>{for(a=0;o=t.regex.exec(e);){const r=o[1].trim();if(i=u(r),void 0===i)if("function"==typeof c){const t=c(e,o,n);i="string"==typeof t?t:""}else if(n&&Object.prototype.hasOwnProperty.call(n,r))i="";else{if(d){i=o[0];continue}this.logger.warn(`missed to pass in variable ${r} for interpolating ${e}`),i=""}else"string"==typeof i||this.useRawValueToEscape||(i=bp(i));const s=t.safeValue(i);if(e=e.replace(o[0],s),d?(t.regex.lastIndex+=i.length,t.regex.lastIndex-=o[0].length):t.regex.lastIndex=0,a++,a>=this.maxReplaces)break}})),e}nest(e,t){let r,n,o,i=arguments.length>2&&void 0!==arguments[2]?arguments[2]:{};function a(e,t){const r=this.nestingOptionsSeparator;if(e.indexOf(r)<0)return e;const n=e.split(new RegExp(`${r}[ ]*{`));let i=`{${n[1]}`;e=n[0],i=this.interpolate(i,o);const a=i.match(/'/g),s=i.match(/"/g);(a&&a.length%2==0&&!s||s.length%2!=0)&&(i=i.replace(/'/g,'"'));try{o=JSON.parse(i),t&&(o={...t,...o})}catch(t){return this.logger.warn(`failed parsing options string in nesting for key ${e}`,t),`${e}${r}${i}`}return o.defaultValue&&o.defaultValue.indexOf(this.prefix)>-1&&delete o.defaultValue,e}for(;r=this.nestingRegexp.exec(e);){let s=[];o={...i},o=o.replace&&"string"!=typeof o.replace?o.replace:o,o.applyPostProcessor=!1,delete o.defaultValue;let l=!1;if(-1!==r[0].indexOf(this.formatSeparator)&&!/{.*}/.test(r[1])){const e=r[1].split(this.formatSeparator).map((e=>e.trim()));r[1]=e.shift(),s=e,l=!0}if(n=t(a.call(this,r[1].trim(),o),o),n&&r[0]===e&&"string"!=typeof n)return n;"string"!=typeof n&&(n=bp(n)),n||(this.logger.warn(`missed to resolve ${r[1]} for nesting ${e}`),n=""),l&&(n=s.reduce(((e,t)=>this.format(e,t,i.lng,{...i,interpolationkey:r[1].trim()})),n.trim())),e=e.replace(r[0],n),this.regexp.lastIndex=0}return e}}function zp(e){const t={};return function(r,n,o){const i=n+JSON.stringify(o);let a=t[i];return a||(a=e(Lp(n),o),t[i]=a),a(r)}}class $p{constructor(){let e=arguments.length>0&&void 0!==arguments[0]?arguments[0]:{};this.logger=gp.create("formatter"),this.options=e,this.formats={number:zp(((e,t)=>{const r=new Intl.NumberFormat(e,{...t});return e=>r.format(e)})),currency:zp(((e,t)=>{const r=new Intl.NumberFormat(e,{...t,style:"currency"});return e=>r.format(e)})),datetime:zp(((e,t)=>{const r=new Intl.DateTimeFormat(e,{...t});return e=>r.format(e)})),relativetime:zp(((e,t)=>{const r=new Intl.RelativeTimeFormat(e,{...t});return e=>r.format(e,t.range||"day")})),list:zp(((e,t)=>{const r=new Intl.ListFormat(e,{...t});return e=>r.format(e)}))},this.init(e)}init(e){const t=(arguments.length>1&&void 0!==arguments[1]?arguments[1]:{interpolation:{}}).interpolation;this.formatSeparator=t.formatSeparator?t.formatSeparator:t.formatSeparator||","}add(e,t){this.formats[e.toLowerCase().trim()]=t}addCached(e,t){this.formats[e.toLowerCase().trim()]=zp(t)}format(e,t,r){let n=arguments.length>3&&void 0!==arguments[3]?arguments[3]:{};return t.split(this.formatSeparator).reduce(((e,t)=>{const{formatName:o,formatOptions:i}=function(e){let t=e.toLowerCase().trim();const r={};if(e.indexOf("(")>-1){const n=e.split("(");t=n[0].toLowerCase().trim();const o=n[1].substring(0,n[1].length-1);"currency"===t&&o.indexOf(":")<0?r.currency||(r.currency=o.trim()):"relativetime"===t&&o.indexOf(":")<0?r.range||(r.range=o.trim()):o.split(";").forEach((e=>{if(e){const[t,...n]=e.split(":"),o=n.join(":").trim().replace(/^'+|'+$/g,""),i=t.trim();r[i]||(r[i]=o),"false"===o&&(r[i]=!1),"true"===o&&(r[i]=!0),isNaN(o)||(r[i]=parseInt(o,10))}}))}return{formatName:t,formatOptions:r}}(t);if(this.formats[o]){let t=e;try{const a=n&&n.formatParams&&n.formatParams[n.interpolationkey]||{},s=a.locale||a.lng||n.locale||n.lng||r;t=this.formats[o](e,s,{...i,...n,...a})}catch(e){this.logger.warn(e)}return t}return this.logger.warn(`there was no format function for ${o}`),e}),e)}}class Hp extends yp{constructor(e,t,r){let n=arguments.length>3&&void 0!==arguments[3]?arguments[3]:{};super(),this.backend=e,this.store=t,this.services=r,this.languageUtils=r.languageUtils,this.options=n,this.logger=gp.create("backendConnector"),this.waitingReads=[],this.maxParallelReads=n.maxParallelReads||10,this.readingCalls=0,this.maxRetries=n.maxRetries>=0?n.maxRetries:5,this.retryTimeout=n.retryTimeout>=1?n.retryTimeout:350,this.state={},this.queue=[],this.backend&&this.backend.init&&this.backend.init(r,n.backend,n)}queueLoad(e,t,r,n){const o={},i={},a={},s={};return e.forEach((e=>{let n=!0;t.forEach((t=>{const a=`${e}|${t}`;!r.reload&&this.store.hasResourceBundle(e,t)?this.state[a]=2:this.state[a]<0||(1===this.state[a]?void 0===i[a]&&(i[a]=!0):(this.state[a]=1,n=!1,void 0===i[a]&&(i[a]=!0),void 0===o[a]&&(o[a]=!0),void 0===s[t]&&(s[t]=!0)))})),n||(a[e]=!0)})),(Object.keys(o).length||Object.keys(i).length)&&this.queue.push({pending:i,pendingCount:Object.keys(i).length,loaded:{},errors:[],callback:n}),{toLoad:Object.keys(o),pending:Object.keys(i),toLoadLanguages:Object.keys(a),toLoadNamespaces:Object.keys(s)}}loaded(e,t,r){const n=e.split("|"),o=n[0],i=n[1];t&&this.emit("failedLoading",o,i,t),r&&this.store.addResourceBundle(o,i,r,void 0,void 0,{skipCopy:!0}),this.state[e]=t?-1:2;const a={};this.queue.forEach((r=>{!function(e,t,r,n){const{obj:o,k:i}=Ep(e,t,Object);o[i]=o[i]||[],o[i].push(r)}(r.loaded,[o],i),function(e,t){void 0!==e.pending[t]&&(delete e.pending[t],e.pendingCount--)}(r,e),t&&r.errors.push(t),0!==r.pendingCount||r.done||(Object.keys(r.loaded).forEach((e=>{a[e]||(a[e]={});const t=r.loaded[e];t.length&&t.forEach((t=>{void 0===a[e][t]&&(a[e][t]=!0)}))})),r.done=!0,r.errors.length?r.callback(r.errors):r.callback())})),this.emit("loaded",a),this.queue=this.queue.filter((e=>!e.done))}read(e,t,r){let n=arguments.length>3&&void 0!==arguments[3]?arguments[3]:0,o=arguments.length>4&&void 0!==arguments[4]?arguments[4]:this.retryTimeout,i=arguments.length>5?arguments[5]:void 0;if(!e.length)return i(null,{});if(this.readingCalls>=this.maxParallelReads)return void this.waitingReads.push({lng:e,ns:t,fcName:r,tried:n,wait:o,callback:i});this.readingCalls++;const a=(a,s)=>{if(this.readingCalls--,this.waitingReads.length>0){const e=this.waitingReads.shift();this.read(e.lng,e.ns,e.fcName,e.tried,e.wait,e.callback)}a&&s&&n<this.maxRetries?setTimeout((()=>{this.read.call(this,e,t,r,n+1,2*o,i)}),o):i(a,s)},s=this.backend[r].bind(this.backend);if(2!==s.length)return s(e,t,a);try{const r=s(e,t);r&&"function"==typeof r.then?r.then((e=>a(null,e))).catch(a):a(null,r)}catch(e){a(e)}}prepareLoading(e,t){let r=arguments.length>2&&void 0!==arguments[2]?arguments[2]:{},n=arguments.length>3?arguments[3]:void 0;if(!this.backend)return this.logger.warn("No backend was added via i18next.use. Will not load resources."),n&&n();"string"==typeof e&&(e=this.languageUtils.toResolveHierarchy(e)),"string"==typeof t&&(t=[t]);const o=this.queueLoad(e,t,r,n);if(!o.toLoad.length)return o.pending.length||n(),null;o.toLoad.forEach((e=>{this.loadOne(e)}))}load(e,t,r){this.prepareLoading(e,t,{},r)}reload(e,t,r){this.prepareLoading(e,t,{reload:!0},r)}loadOne(e){let t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:"";const r=e.split("|"),n=r[0],o=r[1];this.read(n,o,"read",void 0,void 0,((r,i)=>{r&&this.logger.warn(`${t}loading namespace ${o} for language ${n} failed`,r),!r&&i&&this.logger.log(`${t}loaded namespace ${o} for language ${n}`,i),this.loaded(e,r,i)}))}saveMissing(e,t,r,n,o){let i=arguments.length>5&&void 0!==arguments[5]?arguments[5]:{},a=arguments.length>6&&void 0!==arguments[6]?arguments[6]:()=>{};if(this.services.utils&&this.services.utils.hasLoadedNamespace&&!this.services.utils.hasLoadedNamespace(t))this.logger.warn(`did not save key "${r}" as the namespace "${t}" was not yet loaded`,"This means something IS WRONG in your setup. You access the t function before i18next.init / i18next.loadNamespace / i18next.changeLanguage was done. Wait for the callback or Promise to resolve before accessing it!!!");else if(null!=r&&""!==r){if(this.backend&&this.backend.create){const s={...i,isUpdate:o},l=this.backend.create.bind(this.backend);if(l.length<6)try{let o;o=5===l.length?l(e,t,r,n,s):l(e,t,r,n),o&&"function"==typeof o.then?o.then((e=>a(null,e))).catch(a):a(null,o)}catch(e){a(e)}else l(e,t,r,n,a,s)}e&&e[0]&&this.store.addResource(e[0],t,r,n)}}}function Yp(){return{debug:!1,initImmediate:!0,ns:["translation"],defaultNS:["translation"],fallbackLng:["dev"],fallbackNS:!1,supportedLngs:!1,nonExplicitSupportedLngs:!1,load:"all",preload:!1,simplifyPluralSuffix:!0,keySeparator:".",nsSeparator:":",pluralSeparator:"_",contextSeparator:"_",partialBundledLanguages:!1,saveMissing:!1,updateMissing:!1,saveMissingTo:"fallback",saveMissingPlurals:!0,missingKeyHandler:!1,missingInterpolationHandler:!1,postProcess:!1,postProcessPassResolved:!1,returnNull:!1,returnEmptyString:!0,returnObjects:!1,joinArrays:!1,returnedObjectHandler:!1,parseMissingKeyHandler:!1,appendNamespaceToMissingKey:!1,appendNamespaceToCIMode:!1,overloadTranslationOptionHandler:function(e){let t={};if("object"==typeof e[1]&&(t=e[1]),"string"==typeof e[1]&&(t.defaultValue=e[1]),"string"==typeof e[2]&&(t.tDescription=e[2]),"object"==typeof e[2]||"object"==typeof e[3]){const r=e[3]||e[2];Object.keys(r).forEach((e=>{t[e]=r[e]}))}return t},interpolation:{escapeValue:!0,format:e=>e,prefix:"{{",suffix:"}}",formatSeparator:",",unescapePrefix:"-",nestingPrefix:"$t(",nestingSuffix:")",nestingOptionsSeparator:",",maxReplaces:1e3,skipOnVariables:!0}}}function Qp(e){return"string"==typeof e.ns&&(e.ns=[e.ns]),"string"==typeof e.fallbackLng&&(e.fallbackLng=[e.fallbackLng]),"string"==typeof e.fallbackNS&&(e.fallbackNS=[e.fallbackNS]),e.supportedLngs&&e.supportedLngs.indexOf("cimode")<0&&(e.supportedLngs=e.supportedLngs.concat(["cimode"])),e}function Xp(){}class Jp extends yp{constructor(){let e=arguments.length>0&&void 0!==arguments[0]?arguments[0]:{},t=arguments.length>1?arguments[1]:void 0;var r;if(super(),this.options=Qp(e),this.services={},this.logger=gp,this.modules={external:[]},r=this,Object.getOwnPropertyNames(Object.getPrototypeOf(r)).forEach((e=>{"function"==typeof r[e]&&(r[e]=r[e].bind(r))})),t&&!this.isInitialized&&!e.isClone){if(!this.options.initImmediate)return this.init(e,t),this;setTimeout((()=>{this.init(e,t)}),0)}}init(){var e=this;let t=arguments.length>0&&void 0!==arguments[0]?arguments[0]:{},r=arguments.length>1?arguments[1]:void 0;this.isInitializing=!0,"function"==typeof t&&(r=t,t={}),!t.defaultNS&&!1!==t.defaultNS&&t.ns&&("string"==typeof t.ns?t.defaultNS=t.ns:t.ns.indexOf("translation")<0&&(t.defaultNS=t.ns[0]));const n=Yp();function o(e){return e?"function"==typeof e?new e:e:null}if(this.options={...n,...this.options,...Qp(t)},"v1"!==this.options.compatibilityAPI&&(this.options.interpolation={...n.interpolation,...this.options.interpolation}),void 0!==t.keySeparator&&(this.options.userDefinedKeySeparator=t.keySeparator),void 0!==t.nsSeparator&&(this.options.userDefinedNsSeparator=t.nsSeparator),!this.options.isClone){let t;this.modules.logger?gp.init(o(this.modules.logger),this.options):gp.init(null,this.options),this.modules.formatter?t=this.modules.formatter:"undefined"!=typeof Intl&&(t=$p);const r=new Dp(this.options);this.store=new Np(this.options.resources,this.options);const i=this.services;i.logger=gp,i.resourceStore=this.store,i.languageUtils=r,i.pluralResolver=new Gp(r,{prepend:this.options.pluralSeparator,compatibilityJSON:this.options.compatibilityJSON,simplifyPluralSuffix:this.options.simplifyPluralSuffix}),!t||this.options.interpolation.format&&this.options.interpolation.format!==n.interpolation.format||(i.formatter=o(t),i.formatter.init(i,this.options),this.options.interpolation.format=i.formatter.format.bind(i.formatter)),i.interpolator=new Wp(this.options),i.utils={hasLoadedNamespace:this.hasLoadedNamespace.bind(this)},i.backendConnector=new Hp(o(this.modules.backend),i.resourceStore,i,this.options),i.backendConnector.on("*",(function(t){for(var r=arguments.length,n=new Array(r>1?r-1:0),o=1;o<r;o++)n[o-1]=arguments[o];e.emit(t,...n)})),this.modules.languageDetector&&(i.languageDetector=o(this.modules.languageDetector),i.languageDetector.init&&i.languageDetector.init(i,this.options.detection,this.options)),this.modules.i18nFormat&&(i.i18nFormat=o(this.modules.i18nFormat),i.i18nFormat.init&&i.i18nFormat.init(this)),this.translator=new kp(this.services,this.options),this.translator.on("*",(function(t){for(var r=arguments.length,n=new Array(r>1?r-1:0),o=1;o<r;o++)n[o-1]=arguments[o];e.emit(t,...n)})),this.modules.external.forEach((e=>{e.init&&e.init(this)}))}if(this.format=this.options.interpolation.format,r||(r=Xp),this.options.fallbackLng&&!this.services.languageDetector&&!this.options.lng){const e=this.services.languageUtils.getFallbackCodes(this.options.fallbackLng);e.length>0&&"dev"!==e[0]&&(this.options.lng=e[0])}this.services.languageDetector||this.options.lng||this.logger.warn("init: no languageDetector is used and no lng is defined"),["getResource","hasResourceBundle","getResourceBundle","getDataByLanguage"].forEach((t=>{this[t]=function(){return e.store[t](...arguments)}})),["addResource","addResources","addResourceBundle","removeResourceBundle"].forEach((t=>{this[t]=function(){return e.store[t](...arguments),e}}));const i=mp(),a=()=>{const e=(e,t)=>{this.isInitializing=!1,this.isInitialized&&!this.initializedStoreOnce&&this.logger.warn("init: i18next is already initialized. You should call init just once!"),this.isInitialized=!0,this.options.isClone||this.logger.log("initialized",this.options),this.emit("initialized",this.options),i.resolve(t),r(e,t)};if(this.languages&&"v1"!==this.options.compatibilityAPI&&!this.isInitialized)return e(null,this.t.bind(this));this.changeLanguage(this.options.lng,e)};return this.options.resources||!this.options.initImmediate?a():setTimeout(a,0),i}loadResources(e){let t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:Xp;const r="string"==typeof e?e:this.language;if("function"==typeof e&&(t=e),!this.options.resources||this.options.partialBundledLanguages){if(r&&"cimode"===r.toLowerCase()&&(!this.options.preload||0===this.options.preload.length))return t();const e=[],n=t=>{t&&"cimode"!==t&&this.services.languageUtils.toResolveHierarchy(t).forEach((t=>{"cimode"!==t&&e.indexOf(t)<0&&e.push(t)}))};r?n(r):this.services.languageUtils.getFallbackCodes(this.options.fallbackLng).forEach((e=>n(e))),this.options.preload&&this.options.preload.forEach((e=>n(e))),this.services.backendConnector.load(e,this.options.ns,(e=>{e||this.resolvedLanguage||!this.language||this.setResolvedLanguage(this.language),t(e)}))}else t(null)}reloadResources(e,t,r){const n=mp();return e||(e=this.languages),t||(t=this.options.ns),r||(r=Xp),this.services.backendConnector.reload(e,t,(e=>{n.resolve(),r(e)})),n}use(e){if(!e)throw new Error("You are passing an undefined module! Please check the object you are passing to i18next.use()");if(!e.type)throw new Error("You are passing a wrong module! Please check the object you are passing to i18next.use()");return"backend"===e.type&&(this.modules.backend=e),("logger"===e.type||e.log&&e.warn&&e.error)&&(this.modules.logger=e),"languageDetector"===e.type&&(this.modules.languageDetector=e),"i18nFormat"===e.type&&(this.modules.i18nFormat=e),"postProcessor"===e.type&&jp.addPostProcessor(e),"formatter"===e.type&&(this.modules.formatter=e),"3rdParty"===e.type&&this.modules.external.push(e),this}setResolvedLanguage(e){if(e&&this.languages&&!(["cimode","dev"].indexOf(e)>-1))for(let e=0;e<this.languages.length;e++){const t=this.languages[e];if(!(["cimode","dev"].indexOf(t)>-1)&&this.store.hasLanguageSomeTranslations(t)){this.resolvedLanguage=t;break}}}changeLanguage(e,t){var r=this;this.isLanguageChangingTo=e;const n=mp();this.emit("languageChanging",e);const o=e=>{this.language=e,this.languages=this.services.languageUtils.toResolveHierarchy(e),this.resolvedLanguage=void 0,this.setResolvedLanguage(e)},i=(e,i)=>{i?(o(i),this.translator.changeLanguage(i),this.isLanguageChangingTo=void 0,this.emit("languageChanged",i),this.logger.log("languageChanged",i)):this.isLanguageChangingTo=void 0,n.resolve((function(){return r.t(...arguments)})),t&&t(e,(function(){return r.t(...arguments)}))},a=t=>{e||t||!this.services.languageDetector||(t=[]);const r="string"==typeof t?t:this.services.languageUtils.getBestMatchFromCodes(t);r&&(this.language||o(r),this.translator.language||this.translator.changeLanguage(r),this.services.languageDetector&&this.services.languageDetector.cacheUserLanguage&&this.services.languageDetector.cacheUserLanguage(r)),this.loadResources(r,(e=>{i(e,r)}))};return e||!this.services.languageDetector||this.services.languageDetector.async?!e&&this.services.languageDetector&&this.services.languageDetector.async?0===this.services.languageDetector.detect.length?this.services.languageDetector.detect().then(a):this.services.languageDetector.detect(a):a(e):a(this.services.languageDetector.detect()),n}getFixedT(e,t,r){var n=this;const o=function(e,t){let i;if("object"!=typeof t){for(var a=arguments.length,s=new Array(a>2?a-2:0),l=2;l<a;l++)s[l-2]=arguments[l];i=n.options.overloadTranslationOptionHandler([e,t].concat(s))}else i={...t};i.lng=i.lng||o.lng,i.lngs=i.lngs||o.lngs,i.ns=i.ns||o.ns,""!==i.keyPrefix&&(i.keyPrefix=i.keyPrefix||r||o.keyPrefix);const u=n.options.keySeparator||".";let c;return c=i.keyPrefix&&Array.isArray(e)?e.map((e=>`${i.keyPrefix}${u}${e}`)):i.keyPrefix?`${i.keyPrefix}${u}${e}`:e,n.t(c,i)};return"string"==typeof e?o.lng=e:o.lngs=e,o.ns=t,o.keyPrefix=r,o}t(){return this.translator&&this.translator.translate(...arguments)}exists(){return this.translator&&this.translator.exists(...arguments)}setDefaultNamespace(e){this.options.defaultNS=e}hasLoadedNamespace(e){let t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:{};if(!this.isInitialized)return this.logger.warn("hasLoadedNamespace: i18next was not initialized",this.languages),!1;if(!this.languages||!this.languages.length)return this.logger.warn("hasLoadedNamespace: i18n.languages were undefined or empty",this.languages),!1;const r=t.lng||this.resolvedLanguage||this.languages[0],n=!!this.options&&this.options.fallbackLng,o=this.languages[this.languages.length-1];if("cimode"===r.toLowerCase())return!0;const i=(e,t)=>{const r=this.services.backendConnector.state[`${e}|${t}`];return-1===r||2===r};if(t.precheck){const e=t.precheck(this,i);if(void 0!==e)return e}return!(!this.hasResourceBundle(r,e)&&this.services.backendConnector.backend&&(!this.options.resources||this.options.partialBundledLanguages)&&(!i(r,e)||n&&!i(o,e)))}loadNamespaces(e,t){const r=mp();return this.options.ns?("string"==typeof e&&(e=[e]),e.forEach((e=>{this.options.ns.indexOf(e)<0&&this.options.ns.push(e)})),this.loadResources((e=>{r.resolve(),t&&t(e)})),r):(t&&t(),Promise.resolve())}loadLanguages(e,t){const r=mp();"string"==typeof e&&(e=[e]);const n=this.options.preload||[],o=e.filter((e=>n.indexOf(e)<0&&this.services.languageUtils.isSupportedCode(e)));return o.length?(this.options.preload=n.concat(o),this.loadResources((e=>{r.resolve(),t&&t(e)})),r):(t&&t(),Promise.resolve())}dir(e){if(e||(e=this.resolvedLanguage||(this.languages&&this.languages.length>0?this.languages[0]:this.language)),!e)return"rtl";const t=this.services&&this.services.languageUtils||new Dp(Yp());return["ar","shu","sqr","ssh","xaa","yhd","yud","aao","abh","abv","acm","acq","acw","acx","acy","adf","ads","aeb","aec","afb","ajp","apc","apd","arb","arq","ars","ary","arz","auz","avl","ayh","ayl","ayn","ayp","bbz","pga","he","iw","ps","pbt","pbu","pst","prp","prd","ug","ur","ydd","yds","yih","ji","yi","hbo","men","xmn","fa","jpr","peo","pes","prs","dv","sam","ckb"].indexOf(t.getLanguagePartFromCode(e))>-1||e.toLowerCase().indexOf("-arab")>1?"rtl":"ltr"}static createInstance(){return new Jp(arguments.length>0&&void 0!==arguments[0]?arguments[0]:{},arguments.length>1?arguments[1]:void 0)}cloneInstance(){let e=arguments.length>0&&void 0!==arguments[0]?arguments[0]:{},t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:Xp;const r=e.forkResourceStore;r&&delete e.forkResourceStore;const n={...this.options,...e,isClone:!0},o=new Jp(n);return void 0===e.debug&&void 0===e.prefix||(o.logger=o.logger.clone(e)),["store","services","language"].forEach((e=>{o[e]=this[e]})),o.services={...this.services},o.services.utils={hasLoadedNamespace:o.hasLoadedNamespace.bind(o)},r&&(o.store=new Np(this.store.data,n),o.services.resourceStore=o.store),o.translator=new kp(o.services,n),o.translator.on("*",(function(e){for(var t=arguments.length,r=new Array(t>1?t-1:0),n=1;n<t;n++)r[n-1]=arguments[n];o.emit(e,...r)})),o.init(n,t),o.translator.options=n,o.translator.backendConnector.services.utils={hasLoadedNamespace:o.hasLoadedNamespace.bind(o)},o}toJSON(){return{options:this.options,store:this.store,language:this.language,languages:this.languages,resolvedLanguage:this.resolvedLanguage}}}const Zp=Jp.createInstance();Zp.createInstance=Jp.createInstance,Zp.createInstance,Zp.dir,Zp.init,Zp.loadResources,Zp.reloadResources,Zp.use,Zp.changeLanguage,Zp.getFixedT,Zp.t,Zp.exists,Zp.setDefaultNamespace,Zp.hasLoadedNamespace,Zp.loadNamespaces,Zp.loadLanguages;var ef,tf=(Gn(Gn(Gn(Gn(Gn(Gn(Gn(Gn(Gn(Gn(ef={},jd,"Empty group"),Pd,"No conditions for group field {{field}}"),kd,"Empty query"),Fd,"Empty case"),Dd,"No config for field {{field}}"),"FIXED_OPERATOR","Fixed operator {{from}} to {{to}} for field {{field}}"),Md,"No config for operator {{operator}}"),Vd,"No config for function {{funcKey}}"),Ud,"Invalid value"),Bd,"Invalid value of arg {{argName}} for func {{funcName}}: {{argValidationError}}"),Gn(Gn(Gn(Gn(Gn(Gn(Gn(Gn(Gn(Gn(ef,qd,"Type of field {{field}} is not supported"),Gd,"Operator {{operator}} is not supported for field {{field}}"),Wd,"Incomplete rule"),zd,"Incomplete LHS"),$d,"Incomplete RHS"),Kd,"Invalid value src {{valueSrcs, list}}"),Hd+"_one","Value {{badValues, list}} is not in the list of allowed values"),Hd+"_other","Values {{badValues, list}} are not in the list of allowed values"),Yd,"Value {{value}} is not in the list of allowed values"),Qd,"Value should have type {{wType}}, but got value of type {{valueType}}"),Gn(Gn(Gn(Gn(Gn(Gn(Gn(Gn(Gn(Gn(ef,Xd,"Value should have JS type {{jsType}}, but got value of type {{valueTypeof}}"),Jd,"Value {{value}} should have max length {{fieldSettings.maxLength}} but got {{length}}"),Zd,"Value {{value}} should be greater than or equal to {{fieldSettings.min}}"),Zd+"_"+fp,"Value {{value}} should be from {{fieldSettings.min}} to {{fieldSettings.max}}"),ep,"Value {{value}} should be less than or equal to {{fieldSettings.max}}"),ep+"_"+fp,"Value {{value}} should be from {{fieldSettings.min}} to {{fieldSettings.max}}"),tp,"No config for field {{field}}"),rp,"Can't compare field {{field}} with itself"),np,"Can't compare field {{leftField}} with {{rightField}}"),op,"Field {{field}} is of type {{type}}, but expected {{expected}}"),Gn(Gn(Gn(Gn(Gn(Gn(Gn(Gn(Gn(Gn(ef,ip,"Unsupported function {{funcKey}} for field {{field}}"),ap,"Value of arg {{argName}} for func {{funcName}} is required"),sp,"Function {{funcKey}} should return value of type {{returnType}}, but got {{valueType}}"),lp,"Invalid range"),cp,"Root"),up+"__rule","Leaf #{{globalLeafNo}}"),up+"__group","Group #{{globalGroupNo}}"),up+"__rule_group","Rule-group #{{globalNoByType}}"),up+"__case_group","Case #{{globalNoByType}}"),up+"__rule__deleted","Deleted leaf #{{globalLeafNo}}"),Gn(Gn(Gn(Gn(Gn(ef,up+"__group__deleted","Deleted group #{{globalGroupNo}}"),up+"__rule_group__deleted","Deleted rule-group #{{globalNoByType}}"),up+"__case_group__deleted","Deleted case #{{globalNoByType}}"),pp,"{{str}} in case #{{caseNo}}"),dp,"{{str}} (index path: {{indexPath, list}})")),rf="raqbvalidation",nf="".concat(rf,":"),of=Zp.createInstance();of.init({fallbackLng:"en"}),of.addResources("en",rf,tf);var af=function e(t,r){return null!=t&&t.str?t.str:null!=t&&t.key?e(t.key,t.args):null===r?t:of.t(t.includes(":")?t:nf+t,r)};const sf=of;function lf(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);t&&(n=n.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),r.push.apply(r,n)}return r}function uf(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{};t%2?lf(Object(r),!0).forEach((function(t){Gn(e,t,r[t])})):Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(r)):lf(Object(r)).forEach((function(t){Object.defineProperty(e,t,Object.getOwnPropertyDescriptor(r,t))}))}return e}var cf=function(e){return"object"===kn(e)&&null!==e&&Array.isArray(e)?"array":kn(e)},df=function(e,t){return 0===pf(e,t).length},pf=function(e,t){var r=t.settings.showErrorMessage,n=[];return e&&function e(t,o,i){var a,s,l=t.get("id"),u=t.get("children1"),c=t.getIn(["properties","valueError"]),d=t.getIn(["properties","fieldError"]),p=t.getIn(["properties","field"]),f=null!==(a=null==p||null===(s=p.get)||void 0===s?void 0:s.call(p,"func"))&&void 0!==a?a:p;((null==c?void 0:c.size)>0&&c.filter((function(e){return null!=e})).size>0||!!d)&&r&&n.push(f),u&&u.map((function(t,r){t&&e(t,o.concat(l),i+1)}))}(e,[],0),Array.from(new Set(n))},ff=function(e,t){var r=nv(t,void 0,!0),n={removeEmptyGroups:t.settings.removeEmptyGroupsOnLoad,removeIncompleteRules:t.settings.removeIncompleteRulesOnLoad,removeEmptyRules:t.settings.removeEmptyRulesOnLoad,forceFix:!1},o=yf(e,null,r,r,n),i=o.fixedTree,a=o.allErrors;return o.isSanitized&&a.length&&console.warn("Tree check errors: ",a),i},hf=function(e,t){var r=arguments.length>2&&void 0!==arguments[2]?arguments[2]:{},n=nv(t,void 0,!0),o=uf(uf({},r),{},{removeEmptyGroups:!1,removeEmptyRules:!1,removeIncompleteRules:!1,forceFix:!1});return yf(e,null,n,n,o).allErrors},vf=function(e,t){var r=arguments.length>2&&void 0!==arguments[2]?arguments[2]:{},n=nv(t,void 0,!0),o=uf({removeEmptyGroups:!0,removeEmptyRules:!0,removeIncompleteRules:!0,forceFix:!1},r),i=yf(e,null,n,n,o);return{fixedTree:i.fixedTree,fixedErrors:i.fixedErrors,nonFixedErrors:i.nonFixedErrors,allErrors:i.allErrors}},gf=function(e,t,r,n,o,i,a){void 0===o&&(o=r.settings.removeEmptyGroupsOnLoad),void 0===i&&(i=r.settings.removeEmptyRulesOnLoad),void 0===a&&(a=r.settings.removeIncompleteRulesOnLoad);var s=yf(e,t,r,n,{removeEmptyGroups:o,removeEmptyRules:i,removeIncompleteRules:a,forceFix:!1}),l=s.fixedTree,u=(s.allErrors,s.fixedErrors);return s.nonFixedErrors,s.isSanitized&&u.length&&console.warn("Fixed tree errors: ",u),gu(l)},yf=function(e,t,r,n,o){if(!e)return{fixedTree:e,allErrors:[],fixedErrors:[],nonFixedErrors:[],isSanitized:!1};var i,a,s=o||{},l=s.removeEmptyGroups,u=s.removeEmptyRules,c=s.removeIncompleteRules,d=s.forceFix,p=s.translateErrors,f=void 0===p||p,h=s.includeStringifiedItems,v=void 0===h||h,g=s.stringifyFixedItems,y=void 0!==g&&g,m=s.stringifyItemsUserFriendly,b=void 0===m||m,O=s.includeItemsPositions,E=void 0===O||O,S={errors:{}},T=Of(e,[],null,S,{config:r,oldConfig:n,removeEmptyGroups:l,removeEmptyRules:u,removeIncompleteRules:c,forceFix:d}),_=S.sanitized,w=[];for(var R in E&&(i=mu(T).items),S.errors){var A=S.errors[R],C=A.path,I=A.errors;f&&(I=I.map((function(e){return uf(uf({},e),{},{str:af(e)})})));var x={path:C,errors:I};if(v){var L=hu(y?T:e,C);if(1!==C.length&&"group"!==L.get("type")){var N=Rd(L,r,b,!0);x.itemStr=N}}if(E){var j=i[R],P=!j;if(P&&(a||(a=mu(e).items),j=a[R]),j){var k=uf(uf({},j.position),{},{index:j.index,type:j.type,isDeleted:P});x.itemPosition=k;var F=j.index?up+"__"+j.type+(P?"__deleted":""):cp,D=uf({},k);if(b){for(var M,V=0,U=["caseNo","globalLeafNo","globalGroupNo","globalNoByType"];V<U.length;V++){var B=U[V];null!=D[B]&&(D[B]=D[B]+1)}D.indexPath=null===(M=k.indexPath)||void 0===M?void 0:M.map((function(e){return e+1}))}x.itemPositionStr=af(F,D),j.index&&(j.caseId&&"case_group"!==j.type&&(x.itemPositionStr=af(pp,uf(uf({},D),{},{str:x.itemPositionStr}))),"case_group"!==j.type&&(x.itemPositionStr=af(dp,uf(uf({},D),{},{str:x.itemPositionStr}))))}}w.push(x)}for(var q=[],G=[],K=0,W=w;K<W.length;K++){var z=W[K],$=z.errors.filter((function(e){return!!e.fixed})),H=z.errors.filter((function(e){return!e.fixed&&"EMPTY_QUERY"!==e.key}));$.length&&q.push(uf(uf({},z),{},{errors:$})),H.length&&G.push(uf(uf({},z),{},{errors:H}))}return{fixedTree:T,allErrors:w,fixedErrors:q,nonFixedErrors:G,isSanitized:_}};function mf(e,t,r,n){var o=t.get("id");e.errors[o]||(e.errors[o]={path:[].concat(Qn(r),[o]),errors:[]}),e.errors[o].errors.push(n)}function bf(e,t){var r=t.get("id");e.errors[r]&&e.errors[r].errors.map((function(e){e.fixed=!0}))}function Of(e,t,r,n,o){var i=null==e?void 0:e.get("type");return"group"===i||"rule_group"===i||"case_group"==i||"switch_group"==i?function(e,t,r,n,o){var i,a,s,l,u,c,d=o.removeEmptyGroups,p=o.removeIncompleteRules,f=(o.forceFix,o.config),h=(f.settings.showErrorMessage,e.get("id")),v=e.get("children1"),g=!t.length,y=v,m=e.get("type"),b=e.get("properties"),O=null==b?void 0:b.get("field"),E=null==b?void 0:b.get("mode"),S=null==b||null===(i=b.get)||void 0===i?void 0:i.call(b,"operator"),T="rule_group"===m&&"array"===E,_="case_group"===m,w=_&&null==v,R=S?null!==(a=null===(s=f.operators[S])||void 0===s?void 0:s.cardinality)&&void 0!==a?a:1:void 0,A=_?!w:T?0==R:d,C=T||_;!h&&r&&(h=r,e=e.set("id",h),n.sanitized=!0),C&&(e=Ef(e,t,r,n,o));var I={errors:{}},x=null===(u=v=null===(l=v)||void 0===l?void 0:l.map((function(e,r){return Of(e,t.concat(h),r,I,o)})))||void 0===u?void 0:u.filter((function(e){return null!=e}));d&&(v=x);var L=I.sanitized||(null==y?void 0:y.size)!=(null===(c=v)||void 0===c?void 0:c.size),N=d&&!g;return T&&O&&(N=p),!(null!=x&&x.size)&&A&&(mf(n,e,t,{key:g?kd:_?Fd:T?Pd:jd,args:{field:O},fixed:N}),N&&(bf(n,e),e=void 0)),L&&(n.sanitized=!0),L&&e&&(e=e.set("children1",v)),n.errors=uf(uf({},n.errors),(null==I?void 0:I.errors)||{}),e}(e,t,r,n,o):"rule"===i?Ef(e,t,r,n,o):e}function Ef(e,t,r,n,o){var i=o.removeIncompleteRules,a=o.removeEmptyRules,s=o.forceFix,l=o.config,u=o.oldConfig,c=l.settings.showErrorMessage,d=!c||s,p=e.get("id"),f="case_group"===e.get("type"),h=e.get("properties");if(!h){if(!f)return void mf(n,e,t,{key:Wd,args:{},fixed:i||a});h=new gl.Map}var v=h.get("field")||null;f&&(v="!case_value");var g=h.get("fieldSrc")||null,y=h.get("operator")||null,m=h.get("operatorOptions"),b=h.get("valueSrc"),O=h.get("value"),E=h.get("valueError"),S=h.get("fieldError"),T=function(){var e,t;return{field:(null===(e=v)||void 0===e||null===(t=e.toJS)||void 0===t?void 0:t.call(e))||v,fieldSrc:g,operator:y,operatorOptions:m?m.toJS():{},valueSrc:b?b.toJS():null,value:O?O.toJS():null,valueError:E?E.toJS():null,fieldError:S||null}},_=T();!p&&r&&(p=r,e=e.set("id",p),n.sanitized=!0);var w=v?Iv(l,v):null;v&&!w&&(mf(n,e,t,{key:Dd,args:{field:v},side:"lhs",fixed:i||a}),v=null),null!=v||f||(h=["operator","operatorOptions","valueSrc","value","valueError","fieldError","field"].reduce((function(e,t){return e.delete(t)}),h),y=null),g||!v||f||(g=Cv(v),h=h.set("fieldSrc",g)),"range_between"!==y&&"range_not_between"!==y||(y="range_between"===y?"between":"not_between",h=h.set("operator",y));var R=y?xv(l,y,v):null;y&&!R&&(mf(n,e,t,{key:Md,args:{operator:y},side:"op",fixed:i||a}),y=null);var A=v?Vf(l,v):[];v&&!f&&(null!=A&&A.length?y&&-1==A.indexOf(y)&&("is_empty"===y||"is_not_empty"===y?(y="is_empty"===y?"is_null":"is_not_null",h=h.set("operator",y)):(mf(n,e,t,{key:Gd,args:{operator:y,field:v},side:"lhs",fixed:i||a}),y=null)):(mf(n,e,t,{key:qd,args:{field:v},side:"lhs",fixed:i||a}),y=null)),null!=y||f||(h=["operatorOptions","valueSrc","value","valueError"].reduce((function(e,t){return e.delete(t)}),h)),m=h.get("operatorOptions"),!y||m&&!R.options?(m=null,h=h.delete("operatorOptions")):y&&!m&&R.options&&(m=dd(l,y,v),h=h.set("operatorOptions",m)),b=h.get("valueSrc"),O=h.get("value");var C=Af(l,u,h,v,y,null,d,!0),I=C.newValue,x=C.newValueSrc,L=C.newValueError,N=C.validationErrors,j=C.newFieldError,P=C.fixedField;O=I,b=x,E=L,S=j,v=P,h=(h=(h=h.set("field",v)).set("value",O)).set("valueSrc",b),h=c?h.set("valueError",E).set("fieldError",S):h.delete("valueError").delete("fieldError");var k=T(),F=!Rl(_,k),D=ih(h.toObject(),l),M=f?D.parts.value:D.score>=3;if(F&&(n.sanitized=!0,e=e.set("properties",h)),null==N||N.map((function(r){return mf(n,e,t,r)})),!M)if(f);else{var V=D.score?i:a,U={key:Wd,args:{}};if(D.parts.field){if(!D.parts.value){var B,q,G,K;U.key=$d,U.side="rhs",null!==(B=k.valueSrc)&&void 0!==B&&B[0]&&(null===(q=k.valueSrc)||void 0===q?void 0:q[0])!=(null===(G=_.valueSrc)||void 0===G?void 0:G[0])&&null!=(null===(K=k.value)||void 0===K?void 0:K[0])&&(U.key=Kd,U.args={valueSrcs:k.valueSrc})}}else U.key=zd,U.side="lhs";U.fixed=V,mf(n,e,t,U),V&&(bf(n,e),e=void 0)}return e}var Sf=function(e,t,r,n,o,i,a,s){var l=arguments.length>8&&void 0!==arguments[8]&&arguments[8],u=arguments.length>9&&void 0!==arguments[9]&&arguments[9],c=arguments.length>10&&void 0!==arguments[10]&&arguments[10],d=[],p=o;if(null!=o){var f,h,v,g;if("field"===a){var y=Hn(_f(t,r,o,a,i,s,e,n,l,u),2);p=y[0],d=y[1]}else if("func"===a){var m=Hn(wf(t,r,o,a,i,s,e,n,l,u,c),2);p=m[0],d=m[1]}else if("value"===a||!a){var b=Hn(Tf(r,o,a,i,s,e,n,l,u),2);p=b[0],d=b[1]}var O=!(null!==(f=d)&&void 0!==f&&f.find((function(e){return!e.fixed})));if(r&&!["field","func"].includes(a)&&(null===(h=d)||void 0===h||!h.length||O)){var E=Qf(e,r,n,a),S=n?xv(e,n,r):null,T=Lv(e,r,n,E,a,{forExport:!0}),_="field"===a?Iv(e,o):null,w=T,R=T.validateValue;if("function"==typeof R){var A=[p,w,n,S];"field"===a&&A.push(_);var C,I,x=R.call.apply(R,[e.ctx].concat(A));"object"!==kn(x)||null===x||Array.isArray(x)?"boolean"==typeof x?0==x&&d.push({key:Ud,args:{}}):"string"==typeof x&&d.push({key:x,args:null}):(I=null!==(C=x.error)&&void 0!==C&&C.key?uf({},x.error):{key:x.error,args:null},void 0!==x.fixedValue&&l&&(I.fixed=!0,I.fixedFrom=p,I.fixedTo=x.fixedValue,p=x.fixedValue),d.push(I))}}if(O=!(null!==(v=d)&&void 0!==v&&v.find((function(e){return!e.fixed}))),null!==(g=d)&&void 0!==g&&g.length&&!O&&l){var L=Iv(e,r),N=null==L?void 0:L.fieldSettings,j=null==N?void 0:N.defaultValue;if(void 0!==j){var P=d[d.length-1];P.fixed=!0,P.fixedFrom=p,P.fixedTo=j,p=j,d.map((function(e){e.fixed=!0}))}}}return[p,d]},Tf=function(e,t,r,n,o,i){var a,s,l=arguments.length>6&&void 0!==arguments[6]?arguments[6]:null,u=arguments.length>7&&void 0!==arguments[7]&&arguments[7],c=[],d=t;if(e){var p=Iv(i,e),f=Qf(i,e,l,r),h=i.widgets[f],v=null==h?void 0:h.type,g=null==h?void 0:h.jsType,y=null==p?void 0:p.fieldSettings,m=(null==y?void 0:y.treeValues)||(null==y?void 0:y.listValues),b=!(null==y||!y.asyncFetch),O=m||b;if(n&&v&&n!=v)return c.push({key:Qd,args:{wType:v,valueType:n}}),[t,c];if(g&&(s=g,cf(a=t)!==s&&("number"!==s||isNaN(a)))&&!O)return c.push({key:Xd,args:{jsType:g,valueTypeof:cf(t)}}),[t,c];if(y){var E=o||m;if(E&&!y.allowCustomValues&&"case_value"!==f){var S=function(e,t,r,n,o){var i=gl.List.isList(e)?e.toJS():e instanceof Array?Qn(e):void 0,a=e,s=[];if(i){var l=i.reduce((function(e,r){var n=Hn(e,2),o=n[0],i=n[1],a=au(t,r);return null==a?[o,[].concat(Qn(i),[r])]:[[].concat(Qn(o),[a.value]),i]}),[[],[]]),u=Hn(l,2),c=u[0],d=u[1],p=d.length>0;if(a=(r=r||!0===o)&&p?c:e,d.length){var f=r&&p;s.push({key:Hd,args:{badValues:d,count:d.length},fixed:f,fixedFrom:f?i:void 0,fixedTo:f?a:void 0})}return[a,s]}var h=au(t,e);return null==h?(a=r?null:e,s.push({key:Yd,args:{value:e},fixed:r,fixedFrom:r?e:void 0,fixedTo:r?a:void 0})):a=h.value,[a,s]}(t,E,u,0,i.settings.removeInvalidMultiSelectValuesOnLoad),T=Hn(S,2);d=T[0],c=T[1]}y.maxLength>0&&null!=t&&String(t).length>y.maxLength&&(d=u?String(t).substring(0,y.maxLength):t,c.push({key:Jd,args:{value:t,length:String(t).length,fieldSettings:y},fixed:u,fixedFrom:u?t:void 0,fixedTo:u?d:void 0}));var _=null!=y.min&&null!=y.max?fp:void 0;null!=y.min&&t<y.min&&(d=u?y.min:t,c.push({key:Zd,args:{value:t,fieldSettings:y,context:_},fixed:u,fixedFrom:u?t:void 0,fixedTo:u?d:void 0})),null!=y.max&&t>y.max&&(d=u?y.max:t,c.push({key:ep,args:{value:t,fieldSettings:y,context:_},fixed:u,fixedFrom:u?t:void 0,fixedTo:u?d:void 0}))}}return[d,c]},_f=function(e,t,r,n,o,i,a){var s=arguments.length>7&&void 0!==arguments[7]?arguments[7]:null,l=[],u=a.settings,c=u.fieldSeparator,d=u.canCompareFieldWithField,p="object"==kn(t)&&(null==t?void 0:t._isFuncArg),f=Array.isArray(e)?e.join(c):e,h=Iv(a,e),v=Array.isArray(r)?r.join(c):r,g=Iv(a,r);return g?e&&v===f&&!p?(l.push({key:rp,args:{field:f}}),[r,l]):o&&o!=g.type?(l.push({key:op,args:{field:v,type:g.type,expected:o}}),[r,l]):e&&!p&&d&&!d(f,h,v,g,s)?(l.push({key:np,args:{leftField:f,rightField:v}}),[r,l]):[r]:(l.push({key:tp,args:{field:v}}),[r,l])},wf=function(e,t,r,n,o,i,a){var s,l,u=arguments.length>7&&void 0!==arguments[7]?arguments[7]:null,c=arguments.length>8&&void 0!==arguments[8]&&arguments[8],d=arguments.length>9&&void 0!==arguments[9]&&arguments[9],p=arguments.length>10&&void 0!==arguments[10]&&arguments[10],f=r,h=[];if(!r)return[r];var v=null===(s=r.get)||void 0===s?void 0:s.call(r,"func");if(!v)return[r];var g=Iv(a,t);if(null!=g&&g.funcs&&!g.funcs.includes(v))return h.push({key:ip,args:{funcKey:v,field:t}}),[r,h];var y=bv(a,v);if(!y)return h.push({key:Vd,args:{funcKey:v}}),[r,h];var m=null!==(l=y.label)&&void 0!==l?l:v;if(o&&y.returnType!=o)return h.push({key:sp,args:{funcKey:v,funcName:m,returnType:y.returnType,valueType:o}}),[r,h];for(var b in c=c||p,y.args){var O,E=y.args[b],S=f.get("args"),T=S?S.get(b):void 0,_=Iv(a,E),w=null!==(O=null==_?void 0:_.label)&&void 0!==O?O:b,R=T?T.get("value"):void 0,A=T?T.get("valueSrc"):void 0;if(void 0!==R){var C=Hn(Sf(a,e,_,u,R,E.type,A,i,c,d,p),2),I=C[0],x=C[1],L=!(null!=x&&x.length),N=c&&I!==R,j=c&&!L&&!N&&(d||p);if(N&&(f=f.setIn(["args",b,"value"],I)),j&&(f=f.deleteIn(["args",b]),f=Nf(a,f,y,b)),!L){var P,k,F=null!==(P=null!==(k=x.find((function(e){return!e.fixed&&!e.ignore})))&&void 0!==k?k:x.find((function(e){return!e.fixed})))&&void 0!==P?P:x[0],D=N||j,M=0===x.filter((function(e){return!e.ignore})).length;if(F){var V=af(F);h.push({key:Bd,args:{funcKey:v,funcName:m,argKey:b,argName:w,argValidationError:V,argErrors:x},ignore:M,fixed:D,fixedFrom:D?R:void 0,fixedTo:D?N?I:E.defaultValue:void 0})}}}else if(!E.isOptional&&(d||p)){var U=c&&void 0!==E.defaultValue&&(d||p);d&&h.push({key:ap,args:{funcKey:v,funcName:m,argKey:b,argName:w},fixed:U,fixedTo:U?E.defaultValue:void 0,ignore:!U}),U&&(f=f.deleteIn(["args",b]),f=Nf(a,f,y,b))}}return[f,h]},Rf=function(e,t,r,n,o){var i,a=xv(e,r,t),s=r?wl(a):null,l=o.toJS?o.toJS():o,u=n.toJS?n.toJS():n,c=l.filter((function(e){return"value"==e||null==e})).length==s;if(null!=a&&a.validateValues&&c){var d=l[0],p=Qf(e,t,r,d),f=Lv(e,t,r,p,d),h=null!=f&&f.toJS?u.map((function(t){var r=f.toJS.call(e.ctx,t,f);return r instanceof Date&&(r=r.getTime()),r})):u,v=a.validateValues(h);"boolean"==typeof v&&0==v&&(i={key:lp,args:{jsValues:h,values:u}})}return i},Af=function(e){var t,r,n,o,i=arguments.length>1&&void 0!==arguments[1]?arguments[1]:null,a=arguments.length>2?arguments[2]:void 0,s=arguments.length>3?arguments[3]:void 0,l=arguments.length>4?arguments[4]:void 0,u=arguments.length>5&&void 0!==arguments[5]?arguments[5]:null,c=arguments.length>6&&void 0!==arguments[6]&&arguments[6],d=arguments.length>7&&void 0!==arguments[7]&&arguments[7],p=arguments.length>8&&void 0!==arguments[8]&&arguments[8];i||(i=e);var f=e.settings,h=f.keepInputOnChangeFieldSrc,v=f.convertableWidgets,g=f.clearValueOnChangeField,y=f.clearValueOnChangeOp,m="!case_value"==s,b=a.get("field");!b&&m&&(b=s);var O,E=a.get("fieldType"),S=a.get("fieldSrc"),T=a.get("operator"),_=a.get("value"),w=a.get("valueSrc",new gl.List),R=a.get("valueType",new gl.List),A=a.get("valueError",new gl.List),C=a.get("asyncListValues"),I=m,x=xv(i,T),L=xv(e,l,s),N=m?1:T?wl(x):null,j=m?1:l?wl(L):null,P=Iv(i,b),k=Iv(e,s),F=!b&&E&&h,D=(null==P?void 0:P.type)||E,M=(null==k?void 0:k.type)||!s&&F&&D,V=null==P?void 0:P.listValuesType,U=null==k?void 0:k.listValuesType,B=(null===(t=b)||void 0===t||null===(r=t.get)||void 0===r?void 0:r.call(t,"func"))||b,q=((null===(n=s)||void 0===n||null===(o=n.get)||void 0===o?void 0:o.call(n,"func"))||s)!=B,G=[],K=(b||F)&&(T&&l||I)&&null!=_;if((!D||!M||D!=M||"field"===u&&q&&g||"operator"===u&&y)&&(K=!1),q&&Df.includes(M)&&(U&&U===V||(K=!1)),I||(null!=_&&_.size||!j)&&(null==_||!_.size||j)||(K=!1),"func"===S&&s){var W=Hn(Sf(e,null,null,l,s,M,S,C,c,d,p),2),z=W[0],$=W[1],H=!(null!=$&&$.length),Y=z!==s,Q=!H&&Y&&!$.find((function(e){return!e.fixed})),X=c&&!H&&!Q&&!!u&&s!==b;if(X?s=b:Y&&(s=z),!H){var J=!H&&!Q&&!X,Z=$.find((function(e){return!e.fixed&&!e.ignore}));J&&Z&&(O=af(Z)),$.map((function(e){return G.push(uf(uf({side:"lhs"},e),{},{fixed:e.fixed||X||false}))}))}}for(var ee=0;ee<j;ee++){var te=w.get(ee)||null,re=Qf(i,b,T,te),ne=Qf(e,s,l,te),oe="value"===te?re:Qf(i,b,T,"value"),ie="value"===te?ne:Qf(e,s,l,"value");ie==oe||(v[oe]||[]).includes(ie)||!oe&&F||(K=!1)}T!=l&&[T,l].includes("proximity")&&(K=!1);var ae=w.first(),se=Lv(e,s,l,null,ae),le=Yf(e,s,l,null);!s&&F&&(le=Object.keys(e.settings.valueSourcesInfo));var ue,ce=le[0];1===j&&se&&void 0!==se.type?ue=se.type:1===j&&k&&void 0!==k.type&&(ue="!group"===k.type?"number":k.type);var de=K&&"operator"===u&&1===N&&2===j,pe=[],fe=[],he=[],ve=Array.from({length:j},(function(){return null}));if(K)for(var ge=function(t){var r=_.get(t),n=R.get(t)||null,o=w.get(t)||null;de&&1===t&&(r=void 0!==pe[0]?pe[0]:_.get(0),pe[t]=r,n=R.get(0)||null,o=w.get(0)||null);var i=!o||void 0!==le.find((function(e){return e==o})),a=Hn(Sf(e,s,s,l,r,n,o,C,c,d,p),2),u=a[0],f=a[1],h=!(null!=f&&f.length),v=u!==r,g=!h&&v&&!(null!=f&&f.find((function(e){return!e.fixed}))),y=!(null!=f&&f.find((function(e){return!e.fixed&&!e.ignore}))),m=!i||c&&!h&&!g&&(!y||q);h||null==f||f.map((function(e){return G.push(uf(uf({side:"rhs",delta:t},e),{},{fixed:e.fixed||m}))})),m&&(pe[t]=null,0===t&&delete pe[1]);var b=!h&&!v,O=null==f?void 0:f.find((function(e){return!e.fixed&&!e.ignore}));b&&O&&(ve[t]=af(O)),v&&(pe[t]=u),!de||0!==t||h||v||(de=!1),de&&0===t&&["func","field"].includes(o)&&(de=!1)},ye=0;ye<j;ye++)ge(ye);if(!K)for(var me=0;me<j;me++)if(1===j){var be,Oe=Gl([null==k?void 0:k.defaultValue,null==k||null===(be=k.fieldSettings)||void 0===be?void 0:be.defaultValue,null==se?void 0:se.defaultValue]);pe[me]=Oe,null!=Oe&&Oe.func&&(fe[me]="func")}for(var Ee=0;Ee<j;Ee++){var Se,Te,_e=K&&w.get(Ee)||null,we=K&&R.get(Ee)||null;K&&de&&1===Ee&&(_e=null!==(Se=fe[Ee])&&void 0!==Se?Se:w.get(0),we=null!==(Te=he[Ee])&&void 0!==Te?Te:R.get(0),fe[Ee]=_e,he[Ee]=we),le.includes(_e)||(fe[Ee]=ce),we||(he[Ee]=ue)}var Re=_;(pe.length>0||!K)&&(Re=new gl.List(Array.from({length:j},(function(e,t){return void 0!==pe[t]?pe[t]:K?_.get(t):void 0}))));var Ae=w;(fe.length>0||!K)&&(Ae=new gl.List(Array.from({length:j},(function(e,t){var r;return null!==(r=fe[t])&&void 0!==r?r:K&&w.get(t)||null}))));var Ce=R;(he.length>0||!K)&&(Ce=new gl.List(Array.from({length:j},(function(e,t){var r;return null!==(r=he[t])&&void 0!==r?r:K&&R.get(t)||null}))));var Ie=Rf(e,s,l,Re,Ae);if(Ie){var xe=af(Ie),Le=c&&j>=2,Ne=Re;Le&&(pe[1]=Re.get(0),Re=Re.set(1,pe[1]),ve[1]=ve[0]),!Le&&ve.push(xe),G.push(uf(uf({side:"rhs",delta:-1},Ie),{},{fixed:Le,fixedFrom:Le?[Ne.get(0),Ne.get(1)]:void 0,fixedTo:Le?[Re.get(0),Re.get(1)]:void 0}))}var je=A,Pe=(null==A?void 0:A.size)!==ve.length||ve.filter((function(e,t){return e!=A.get(t)})).length>0;return Pe&&(je=new gl.List(ve)),{canReuseValue:K,newValue:Re,newValueSrc:Ae,newValueType:Ce,operatorCardinality:j,fixedField:s,newValueError:je,newFieldError:O,validationErrors:G}},Cf=function(e){return"object"==kn(e)&&null!==e&&!Array.isArray(e)},If=function(e,t){if(e){var r=e.get("func"),n=r&&bv(t,r);if(n){var o=e,i=!1;for(var a in n.args){var s=n.args[a],l=s.valueSources,u=s.isOptional,c=s.defaultValue,d=Hf(t,l,s),p=o.get("args"),f=1==d.length?d[0]:void 0,h=p?p.get(a):void 0,v=h?h.get("value"):void 0,g=(h?h.get("valueSrc"):void 0)||f;if(void 0!==v){var y=sh(v,g,t);if(void 0===y)return;if(y!==v&&(o=o.setIn(["args",a,"value"],y)),i)return}else if(void 0===c||Cf(c)){if(!u)return;i=!0}else o=(o=o.setIn(["args",a,"value"],jf(s))).setIn(["args",a,"valueSrc"],"value")}return o}}},xf=function(e,t,r,n){var o=r.settings.fieldSeparator;e=e||new gl.Map,Array.isArray(t)&&(t=t.join(o));var i=e.get("func"),a=e.get("args");e=e.set("func",t);var s=t&&bv(r,t),l=t&&mv(r,t),u=i&&mv(r,i),c=Ff(u,l,a,r,n);return e=c.length?Object.keys(l.args).filter((function(e){return!c.includes(e)})).reduce((function(e,t){return e.deleteIn(["args",t])}),e):e.set("args",new gl.Map),Lf(r,e,s)},Lf=function(e,t,r){if(r)for(var n in r.args)t=Nf(e,t,r,n);return t},Nf=function(e,t,r,n){var o=r.args[n],i=o.valueSources,a=o.defaultValue,s=Hf(e,i,o),l=s.length?s[0]:void 0,u=(a?Cf(a)&&a.func?"func":"value":void 0)||l;return t.getIn(["args",n])||(void 0!==a&&(t=t.setIn(["args",n,"value"],jf(o))),u&&(t=t.setIn(["args",n,"valueSrc"],u))),t},jf=function(e){var t=e.defaultValue;return Cf(t)&&!gl.Map.isMap(t)&&t.func?gl.fromJS(t,(function(e,t){return gl.Iterable.isIndexed(t)?t.toList():t.toOrderedMap()})):t},Pf=function(e,t,r,n,o){if(e&&e.get("func")){var i=(e=e.setIn(["args",t,"value"],r)).getIn(["args",t,"valueSrc"]),a=n.valueSources,s=Hf(o,a,n),l=1==s.length?s[0]:void 0;!l&&s.includes("value")&&(l="value"),!i&&l&&(e=e.setIn(["args",t,"valueSrc"],l))}return e},kf=function(e,t,r,n,o){return e&&e.get("func")&&(e=e.setIn(["args",t],new gl.Map({valueSrc:r}))),e},Ff=function(e,t,r,n){var o=arguments.length>4&&void 0!==arguments[4]&&arguments[4];return(null==e?void 0:e.returnType)!=(null==t?void 0:t.returnType)?[]:Object.keys(t.args).filter((function(i,a){var s=t.args[i],l=e.args[i];if(Object.keys(e.args).indexOf(i),!l&&(void 0!==s.defaultValue||s.isOptional))return!0;if((null==l?void 0:l.type)!=s.type)return!1;if(Df.includes(s.type)&&(!l.listValuesType||l.listValuesType!==s.listValuesType))return!1;if(r){var u,c=r.get(i),d=null==c?void 0:c.get("value"),p=null==c?void 0:c.get("valueSrc");if(p&&s.valueSources&&!s.valueSources.includes(p))return!1;var f=Hn(Sf(n,null,s,null,d,s.type,p,null,o,!0),2),h=(f[0],f[1]);if(null!=h&&null!==(u=h.filter((function(e){return!e.fixed})))&&void 0!==u&&u.length)return!1}return!0}))},Df=["select","multiselect","treeselect","treemultiselect"],Mf=function(e,t){var r;return(null===(r=e.types[t])||void 0===r?void 0:r.operators)||null},Vf=function(e,t){var r=Iv(e,t);return r?r.operators:[]},Uf=function(e,t){var r,n=Vf(e,t);return null!==(r=null==n?void 0:n[0])&&void 0!==r?r:null},Bf=function(e,t,r){var n=null;if(e)if("field"===t){var o=Iv(r,e);o&&(n=o.type)}else if("func"===t){var i=e.get("func");if(i){var a=bv(r,i);a&&(n=a.returnType||a.type)}}return n},qf=function(e,t){return Gf(e,t,arguments.length>2&&void 0!==arguments[2]?arguments[2]:null,"funcs","subfields")},Gf=function(e,t){var r=arguments.length>2&&void 0!==arguments[2]?arguments[2]:null,n=arguments.length>3&&void 0!==arguments[3]?arguments[3]:"fields",o=arguments.length>4&&void 0!==arguments[4]?arguments[4]:"subfields";if(!e)return null;var i=t.settings.fieldSeparator,a=Tv(e,t),s=Tv(r,t);return a.slice(s.length).map((function(e,t,r){return r.slice(0,t+1)})).map((function(e){return[].concat(Qn(s),Qn(e)).join(i)})).map((function(e){var r=gv(t,e,n,o);return r&&r.label||Ql()(e.split(i))})).filter((function(e){return null!=e}))},Kf=function(e,t){var r=arguments.length>2&&void 0!==arguments[2]?arguments[2]:null;if(!e)return null;var n=r&&gv(t,r)||null,o=t.settings.fieldSeparator,i=Tv(e,t),a=Ev(e,r,t)?Tv(r,t):[];return i.slice(a.length).map((function(e,t,r){return r.slice(0,t+1)})).map((function(e){return{part:[].concat(Qn(a),Qn(e)).join(o),key:e[e.length-1]}})).map((function(e){var r=e.part;return{key:e.key,cnf:gv(t,r)}})).map((function(e,t,r){return[e.key,e.cnf,t>0?r[t-1].cnf:n]}))},Wf=function(e,t,r,n){var o=arguments.length>5&&void 0!==arguments[5]&&arguments[5],i=Lv(e,t,r,null,arguments.length>4&&void 0!==arguments[4]?arguments[4]:null)||{},a=xv(e,r,t)||{},s=null;if((o?1:a.cardinality)>1){var l=i.valueLabels||a.valueLabels;l&&(s=l[n]),s&&"object"!==kn(s)&&(s={label:s,placeholder:s}),s||(s={label:e.settings.valueLabel+" "+(n+1),placeholder:e.settings.valuePlaceholder+" "+(n+1)})}else{var u=i.valueLabel,c=i.valuePlaceholder;s={label:u||e.settings.valueLabel,placeholder:c||e.settings.valuePlaceholder}}return s};function zf(e,t){var r=arguments.length>2&&void 0!==arguments[2]?arguments[2]:null,n=arguments.length>3&&void 0!==arguments[3]?arguments[3]:null,o=[],i=[];if(!t)return{widgets:o,valueSrcs:i};var a=wv(t),s=a?"".concat(a,"__").concat(r,"__").concat(n):null,l=Rv(e,"_getWidgetsAndSrcsForFieldOp",s);if(l)return l;var u="object"===kn(t)&&(!!t.func&&!!t.arg||t._isFuncArg),c=Iv(e,t),d=r?e.operators[r]:null;if(null!=c&&c.widgets){var p=function(){var a=c.widgets[f];if(!e.widgets[f])return 1;var s=e.widgets[f].valueSrc||"value",l=!0;if("field"===f&&(l=l&&Hf(e,["field"],c).length>0),"func"===f&&(l=l&&Hf(e,["func"],c).length>0),"value"!==n||a.operators||u||"!case_value"===t||(l=!1),a.operators&&r&&(l=l&&-1!=a.operators.indexOf(r)),n&&n!=s&&"const"!==n&&(l=!1),d&&0==d.cardinality&&"value"!==s&&(l=!1),l){var p,h;o.push(f);var v=-1!=(null===(p=c.valueSources)||void 0===p?void 0:p.indexOf(s));-1==(null==d||null===(h=d.valueSources)||void 0===h?void 0:h.indexOf(s))&&(v=!1),v&&!i.find((function(e){return e==s}))&&i.push(s)}};for(var f in c.widgets)p()}var h=function(e){var t=0;return c.preferWidgets?c.preferWidgets.includes(e)&&(t+=10-c.preferWidgets.indexOf(e)):e==c.mainWidget&&(t+=100),"field"===e&&(t-=1),"func"===e&&(t-=2),t};o.sort((function(e,t){return h(t)-h(e)}));var v={widgets:o,valueSrcs:i};return Av(e,"_getWidgetsAndSrcsForFieldOp",s,v),v}var $f=function(e,t,r){return zf(e,t,r,arguments.length>3&&void 0!==arguments[3]?arguments[3]:null).widgets},Hf=function(e,t,r){var n;if(!r)return t;var o=null!==(n=r.type)&&void 0!==n?n:r.returnType;return"!group"===o&&(o="number"),t||(t=Object.keys(e.settings.valueSourcesInfo)),t.filter((function(t){var n=!0;if("field"===t&&e.__fieldsCntByType){var i=r._isFuncArg?0:1;n=n&&e.__fieldsCntByType[o]>i}return"func"===t&&(r.funcs&&(n=n&&r.funcs.length>0),e.__funcsCntByType&&(n=n&&e.__funcsCntByType[o]>0)),n}))},Yf=function(e,t,r){var n=arguments.length>3&&void 0!==arguments[3]?arguments[3]:null,o=zf(e,t,r,null).valueSrcs;return Hf(e,o,n)},Qf=function(e,t,r){var n=zf(e,t,r,arguments.length>3&&void 0!==arguments[3]?arguments[3]:null).widgets,o=null;return n.length&&(o=n[0]),o},Xf=function(e,t,r){var n=arguments.length>3&&void 0!==arguments[3]?arguments[3]:null,o=arguments.length>4&&void 0!==arguments[4]?arguments[4]:{};if(e){var i=Iv(t,e)||{},a=t.settings.fieldSeparator,s=Tv(e,t),l=Array.isArray(e)?e.join(a):e;if(null!=o&&o.useTableName&&i.tableName){var u=Qn(s);u[0]=i.tableName,l=u.join(a)}if(i.fieldName&&(l=i.fieldName),n){Iv(t,n);var c=n;0==l.indexOf(c+a)?l=l.slice((c+a).length):i.fieldName||r.errors.push("Can't cut group ".concat(c," from field ").concat(l))}return l}},Jf=function(e,t){var r=e.get("type"),n=e.getIn(["properties","mode"]);return"rule_group"==r&&"array"==n?Zf(e,t):"group"==r||"rule_group"==r?th(e,t):nh(e,t)},Zf=function(e,t){var r=e.get("children1"),n=e.get("properties");return eh(n.toObject(),r,t)},eh=function(e,t,r){var n,o,i=e.operator,a=0==(null!==(n=null===(o=r.operators[i])||void 0===o?void 0:o.cardinality)&&void 0!==n?n:1),s=!oh(e,r),l=!rh(t,r);return!(s&&(!a||l))},th=function(e,t){var r=e.get("children1");return rh(r,t)},rh=function(e,t){return!((null==e?void 0:e.size)>0&&e.filter((function(e){return!Jf(e,t)})).size>0)},nh=function(e,t){var r=e.get("properties");return oh((null==r?void 0:r.toObject())||{},t)},oh=function(e,t){return!(ih(e,t,!0).score>=3)},ih=function(e,t){var r,n,o,i=e.field,a=e.fieldSrc,s=(e.fieldType,e.operator),l=e.value,u=e.valueSrc,c=(e.valueType,arguments.length>2&&void 0!==arguments[2]&&arguments[2]),d=null!==(r=null===(n=t.operators[s])||void 0===n?void 0:n.cardinality)&&void 0!==r?r:1,p=null!=u&&u.get?u.toJS():u,f={parts:{},score:0};if(f.parts.field=c?null!=i:ah(i,a,t),f.parts.operator=!!s,f.parts.value=(null==l||null===(o=l.filter((function(e,r){return ah(e,null==p?void 0:p[r],t,c)})))||void 0===o?void 0:o.size)>=(c?Math.min(d,1):d),f.score=Object.keys(f.parts).filter((function(e){return!!f.parts[e]})).length,c&&f.score<3){var h=!0;!f.parts.value&&"func"===a&&ah(i,a,t,!1,h)&&f.score++,f.parts.field||null==l||l.map((function(e,r){"func"===(null==p?void 0:p[r])&&ah(e,null==p?void 0:p[r],t,!1,h)&&f.score++}))}return f},ah=function e(t,r,n){var o=arguments.length>3&&void 0!==arguments[3]&&arguments[3],i=!(arguments.length>4&&void 0!==arguments[4])||arguments[4];if(!o&&"func"==r&&t){var a,s=null===(a=t.get)||void 0===a?void 0:a.call(t,"func"),l=bv(n,s);if(l){var u=t.get("args");for(var c in l.args){var d=l.args[c],p=u?u.get(c):void 0,f=p?p.get("value"):void 0,h=p?p.get("valueSrc"):void 0;if(null==f&&void 0===(null==d?void 0:d.defaultValue)&&(null==d||!d.isOptional))return!1;if(null!=f&&!e(f,h,n,!i||o))return!1}return!0}}return null!=t},sh=function(e,t,r){return"func"==t?If(e,r):e},lh=function e(t){var r=t.get("children1");if(1==(null==r?void 0:r.size)){var n=r.first();return"group"===n.get("type")?e(n):n}return null},uh=p(4308),ch=p.n(uh),dh=p(3523),ph=p.n(dh),fh=p(502),hh=p.n(fh);function vh(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);t&&(n=n.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),r.push.apply(r,n)}return r}function gh(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{};t%2?vh(Object(r),!0).forEach((function(t){Gn(e,t,r[t])})):Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(r)):vh(Object(r)).forEach((function(t){Object.defineProperty(e,t,Object.getOwnPropertyDescriptor(r,t))}))}return e}function yh(e,t){return hh().apply(e,t)}var mh={CALL:function(e,t){for(var r=arguments.length,n=new Array(r>2?r-2:0),o=2;o<r;o++)n[o-2]=arguments[o];return e.call.apply(e,[t].concat(n))},JSX:function(e,t){return{type:e,props:t}},mergeObjects:function(e,t){return gh(gh({},e),t)},fromEntries:function(e){return Object.fromEntries(e)},strlen:function(e){return(null==e?void 0:e.length)||0},regexTest:function(e,t,r){return null!=(null==e?void 0:e.match(new RegExp(t,r)))},now:function(){return new Date},date_add:function(e,t,r){return ju()(e).add(t,r).toDate()},toLowerCase:function(e){return e.toLowerCase()},toUpperCase:function(e){return e.toUpperCase()}};function bh(e,t){(null==t||t>e.length)&&(t=e.length);for(var r=0,n=new Array(t);r<t;r++)n[r]=e[r];return n}function Oh(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);t&&(n=n.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),r.push.apply(r,n)}return r}function Eh(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{};t%2?Oh(Object(r),!0).forEach((function(t){Gn(e,t,r[t])})):Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(r)):Oh(Object(r)).forEach((function(t){Object.defineProperty(e,t,Object.getOwnPropertyDescriptor(r,t))}))}return e}function Sh(e,t,r){var n;try{n=hh().apply(e,t)}catch(e){throw e.message="".concat(r.join(".")," :: ").concat(e.message),e}return n}function Th(e,t,r,n){var o;try{o=t.call.apply(t,[e].concat(Qn(r)))}catch(e){throw e.message="".concat(n.join(".")," :: ").concat(e.message),e}return o}!function(){for(var e in mh)t=e,r=mh[e],hh().add_operation(t,r);var t,r}();var _h=["conjunctions","fields","types","operators","widgets","settings","funcs","ctx"],wh={asyncFetch:{type:"f",args:["search","offset"]},labelYes:{type:"r"},labelNo:{type:"r"},marks:{type:"r",isArr:!0},validateValue:{type:"f",args:["val","fieldSettings","op","opDef","rightFieldDef"]}},Rh=Eh(Eh({},wh),{},{factory:{type:"rf"},formatValue:{type:"f",args:["val","fieldDef","wgtDef","isForDisplay","op","opDef","rightFieldDef"]},sqlFormatValue:{type:"f",args:["val","fieldDef","wgtDef","op","opDef","rightFieldDef"]},spelFormatValue:{type:"f",args:["val","fieldDef","wgtDef","op","opDef","rightFieldDef"]},spelImportValue:{type:"f",args:["val","wgtDef","args"]},mongoFormatValue:{type:"f",args:["val","fieldDef","wgtDef","op","opDef"]},elasticSearchFormatValue:{type:"f",args:["queryType","val","op","field","config"]},jsonLogic:{type:"f",args:["val","fieldDef","wgtDef","op","opDef"]},jsonLogicImport:{type:"f",args:["val"]},validateValue:{type:"f",args:["val","fieldSettings","op","opDef","rightFieldDef"]},toJS:{type:"f",args:["val"]}}),Ah={options:{factory:{type:"rf"}},formatOp:{type:"f",args:["field","op","vals","valueSrc","valueType","opDef","operatorOptions","isForDisplay","fieldDef"]},mongoFormatOp:{type:"f",args:["field","op","vals","useExpr","valueSrc","valueType","opDef","operatorOptions","fieldDef"]},sqlFormatOp:{type:"f",args:["field","op","vals","valueSrc","valueType","opDef","operatorOptions","fieldDef"]},spelFormatOp:{type:"f",args:["field","op","vals","valueSrc","valueType","opDef","operatorOptions","fieldDef"]},jsonLogic:{type:"f",ignore:"string",args:["field","op","vals","opDef","operatorOptions","fieldDef"]},elasticSearchQueryType:{type:"f",ignore:"string",args:["valueType"]},textSeparators:{type:"r",isArr:!0}},Ch={widgetProps:Rh,opProps:Ah},Ih=Eh(Eh({},wh),{},{fieldSettings:wh}),xh=Eh(Eh({},wh),{},{fieldSettings:wh,widgets:{x:Ch},mainWidgetProps:Rh}),Lh={locale:{mui:{type:"f",args:[],invokeWith:[],ignore:"jl"}},caseValueField:xh,canCompareFieldWithField:{type:"f",args:["leftField","leftFieldConfig","rightField","rightFieldConfig","op"]},formatReverse:{type:"f",args:["q","op","reversedOp","operatorDefinition","revOperatorDefinition","isForDisplay"]},sqlFormatReverse:{type:"f",args:["q"]},spelFormatReverse:{type:"f",args:["q"]},formatField:{type:"f",args:["field","parts","label2","fieldDefinition","config","isForDisplay"]},formatSpelField:{type:"f",args:["field","parentField","parts","partsExt","fieldDefinition","config"]},formatAggr:{type:"f",args:["whereStr","aggrField","operator","value","valueSrc","valueType","opDef","operatorOptions","isForDisplay","aggrFieldDef"]},normalizeListValues:{type:"f",args:["listValues","type","fieldSettings"]},renderConfirm:{type:"f",args:["props"]},useConfirm:{type:"f",args:[]},renderField:{type:"rf"},renderOperator:{type:"rf"},renderFunc:{type:"rf"},renderConjs:{type:"rf"},renderButton:{type:"rf"},renderIcon:{type:"rf"},renderButtonGroup:{type:"rf"},renderValueSources:{type:"rf"},renderFieldSources:{type:"rf"},renderProvider:{type:"rf"},renderSwitch:{type:"rf"},renderSwitchPrefix:{type:"r"},renderItem:{type:"rf"},renderBeforeWidget:{type:"rf"},renderAfterWidget:{type:"rf"},renderBeforeActions:{type:"rf"},renderAfterActions:{type:"rf"},renderBeforeCaseValue:{type:"rf"},renderAfterCaseValue:{type:"rf"},renderRuleError:{type:"rf"}},Nh={fields:{x:xh},widgets:{x:Rh},conjunctions:{x:{formatConj:{type:"f",args:["children","conj","not","isForDisplay"]},sqlFormatConj:{type:"f",args:["children","conj","not"]},spelFormatConj:{type:"f",args:["children","conj","not","omitBrackets"]}}},operators:{x:Ah},types:{x:{widgets:{x:Ch}}},funcs:{x:Eh(Eh(Eh({},Ih),{renderBrackets:{type:"r",isArr:!0},renderSeps:{type:"r",isArr:!0},jsonLogic:{type:"f",ignore:"string",args:["formattedArgs"]},jsonLogicImport:{type:"f",args:["val"]},spelImport:{type:"f",args:["spel"]},formatFunc:{type:"f",args:["formattedArgs","isForDisplay"]},sqlFormatFunc:{type:"f",args:["formattedArgs"]},mongoFormatFunc:{type:"f",args:["formattedArgs"]},spelFormatFunc:{type:"f",args:["formattedArgs"]}}),{},{args:{x:Eh({},Ih)}})},settings:Lh},jh=function(e){return"object"==kn(e)&&null!==e&&!Array.isArray(e)},Ph=function(e,t){if(e.__fieldNames)throw new Error("Don't apply `compressConfig()` to extended config");var r=Hl()(e,_h);delete r.ctx;for(var n=function e(t,r,n,o){if(jh(t)){if(kl(t)&&(t=Pl(t)),"funcs"===n[0]&&!r){var i=n[n.length-1];(r=gv({funcs:o.BasicFuncs},i,"funcs","subfields")||void 0)&&(t.$$key=i)}if(void 0!==r&&jh(r))for(var a in r)Object.prototype.hasOwnProperty.call(r,a)&&(!Object.keys(t).includes(a)||void 0===t[a]&&void 0!==r[a]?t[a]="$$deleted":(t[a]=e(t[a],r[a],[].concat(Qn(n),[a]),o),void 0===t[a]&&delete t[a]));for(var s in t)if(Object.prototype.hasOwnProperty.call(t,s)){var l;r&&Object.keys(r).includes(s)||(t[s]=e(t[s],null===(l=r)||void 0===l?void 0:l[s],[].concat(Qn(n),[s]),o)),void 0===t[s]&&delete t[s]}0===Object.keys(t).length&&(t=void 0)}else Array.isArray(t)&&t.forEach((function(r,i){t[i]=e(t[i],void 0,[].concat(Qn(n),[i]),o)}));if(void 0===r||!Al(t,r,!0)){if("function"==typeof t)throw new Error("compressConfig: function at ".concat(n.join(".")," should be converted to JsonLogic"));return t}},o=0,i=_h;o<i.length;o++){var a=i[o];if("ctx"===a);else if("fields"===a)r[a]=ph()(r[a]),n(r[a],{},[a]);else if("funcs"===a)for(var s in r[a]=ph()(r[a]||{}),r[a])n(r[a][s],null,[a,s],{BasicFuncs:v});else r[a]=ph()(r[a]),n(r[a],t[a],[a])}return r},kh=function(e,t,r){if(!e.settings.useConfigCompress)throw new Error("Please enable `useConfigCompress` in config settings to use decompressConfig()");for(var n={},o=function e(t,r,n){if(jh(r))for(var o in jh(t)||(t={}),r)Object.prototype.hasOwnProperty.call(r,o)&&("$$deleted"===r[o]?delete t[o]:t[o]=e(t[o],r[o],[].concat(Qn(n),[o])));else t=Array.isArray(r)?ph()(r):r;return t},i=function e(t,r,n){var i=!1;if(jh(t)&&Object.prototype.hasOwnProperty.call(t,"$$key")&&t.$$key){var a=gv({funcs:n.BasicFuncs},t.$$key,"funcs","subfields");if(!a)throw new Error("decompressConfig: basic function not found by key ".concat(t.$$key," at ").concat(r.join(".")));delete t.$$key,t=o(ph()(a),t,r),i=!0}if(!i)if(jh(t))for(var s in t)Object.prototype.hasOwnProperty.call(t,s)&&(t[s]=e(t[s],[].concat(Qn(r),[s]),n));else if(Array.isArray(t)){var l,u=function(e,t){var r="undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(!r){if(Array.isArray(e)||(r=function(e,t){if(e){if("string"==typeof e)return bh(e,t);var r=Object.prototype.toString.call(e).slice(8,-1);return"Object"===r&&e.constructor&&(r=e.constructor.name),"Map"===r||"Set"===r?Array.from(e):"Arguments"===r||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(r)?bh(e,t):void 0}}(e))||t&&e&&"number"==typeof e.length){r&&(e=r);var n=0,o=function(){};return{s:o,n:function(){return n>=e.length?{done:!0}:{done:!1,value:e[n++]}},e:function(e){throw e},f:o}}throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}var i,a=!0,s=!1;return{s:function(){r=r.call(e)},n:function(){var e=r.next();return a=e.done,e},e:function(e){s=!0,i=e},f:function(){try{a||null==r.return||r.return()}finally{if(s)throw i}}}}(t);try{for(u.s();!(l=u.n()).done;){var c=l.value;t[c]=e(t[c],[].concat(Qn(r),[c]),n)}}catch(e){u.e(e)}finally{u.f()}}return t},a=0,s=_h;a<s.length;a++){var l=s[a];"ctx"===l?n[l]=ch()({},t.ctx||{},r||{}):"funcs"===l?(n[l]=ph()(e[l]||{}),i(n[l],[l],{BasicFuncs:v})):"fields"===l?n[l]=ph()(e[l]||{}):(n[l]=ph()(t[l]||{}),o(n[l],e[l]||{},[l]))}return n},Fh=function(e){return e.__compliled||(Dh(e=ph()(e),e,{ctx:e.ctx},Nh,[]),Object.defineProperty(e,"__compliled",{enumerable:!1,writable:!1,value:!0})),e};function Dh(e,t,r,n,o){var i=arguments.length>5&&void 0!==arguments[5]?arguments[5]:[];if(t)for(var a in i.length,n){var s=n[a],l="x"===a?i:[].concat(Qn(i),[a]);if("r"===s.type){var u=t,c=u[a];if(s.isArr)for(var d in c){var p=Uh(c[d],r,[].concat(Qn(l),[d]));p!==c[d]&&(o.push("Compiled ".concat(l.join("."),"[").concat(d,"]")),c[d]=p)}else{var f=Uh(c,r,l,void 0);f!==c&&(o.push("Compiled R ".concat(l.join("."))),u[a]=f)}}else if("rf"===s.type){var h=t,v=h[a],g=Mh(v,r,l,s.ignore);g!==v&&(o.push("Compiled JL-RF ".concat(l.join("."))),h[a]=g)}else if("f"===s.type){var y,m=t,b=m[a],O=Vh(b,r,l,s.args,s.ignore);s.invokeWith&&O&&"function"==typeof O&&(O=(y=O).call.apply(y,[null].concat(Qn(s.invokeWith)))),O!==b&&(o.push("Compiled JL-F ".concat(l.join("."))),m[a]=O)}else if("x"===a)for(var E in t){l=[].concat(Qn(i),[E]);var S=t[E];Dh(e,S,r,s,o,l),S.subfields&&Dh(e,S.subfields,r,n,o,l)}else Dh(e,t[a],r,s,o,l)}}function Mh(e,t,r){return Dl(e)?function(n,o){o=o||(null==t?void 0:t.ctx);var i=Sh(e,{props:n,ctx:o},r);return"string"==typeof i&&(i={type:i,props:n}),Uh(i,{ctx:o},r)}:"string"==typeof e?function(n,o){o=o||(null==t?void 0:t.ctx);var i=e.split(".").reduce((function(e,t){return null==e?void 0:e[t]}),o);return i?Th(this,i,[n,o],r):Uh({type:e,props:n},{ctx:o},r)}:e}function Vh(e,t,r,n){var o=arguments.length>4&&void 0!==arguments[4]?arguments[4]:void 0;return Dl(e)&&"jl"!==o?function(){for(var o=arguments.length,i=new Array(o),a=0;a<o;a++)i[a]=arguments[a];var s=this||(null==t?void 0:t.ctx),l=(n||[]).reduce((function(e,t,r){return Eh(Eh({},e),{},Gn({},t,i[r]))}),{args:i,ctx:s});return Sh(e,l,r)}.bind(null==t?void 0:t.ctx):"string"==typeof e&&"string"!==o?function(){var n=this||(null==t?void 0:t.ctx),o=e.split(".").reduce((function(e,t){return null==e?void 0:e[t]}),n);if(o){for(var i=arguments.length,a=new Array(i),s=0;s<i;s++)a[s]=arguments[s];return Th(this,o,a,r)}throw new Error("".concat(r.join(".")," :: Function ").concat(e," is not found in ctx"))}.bind(null==t?void 0:t.ctx):e}function Uh(e,t,r){var n=arguments.length>3&&void 0!==arguments[3]?arguments[3]:void 0;if(Fl(e)){var o,i=e.type,a=e.props;if("string"!=typeof i)throw new Error("renderReactElement for ".concat(r.join("."),": type should be string"));var s,l=function(e,t){var r;return(null==t||null===(r=t.components)||void 0===r?void 0:r[e])||t.W[e]||t.O[e]}(i,t.ctx)||i.toLowerCase();return void 0!==n&&(a=Eh(Eh({},a),{},{key:n})),null!==(o=a)&&void 0!==o&&o.children&&(s=Uh(a.children,t,r),a=Eh(Eh({},a),{},{children:s})),t.ctx.RCE(l,a)}return e instanceof Array?e.map((function(e,n){return Uh(e,t,r,""+n)})):e}var Bh=p(2815),qh=p.n(Bh),Gh={reverseOperatorsForNot:!1,canShortMongoQuery:!0,formatField:function(e,t,r,n,o,i){return i?r:e},caseValueField:{type:"case_value"},fieldSources:["field"],keepInputOnChangeFieldSrc:!0,fieldItemKeysForSearch:["label","path","altLabel","grouplabel"],listKeysForSearch:["title","value"],valueSourcesInfo:{value:{}},fieldSeparator:".",fieldSeparatorDisplay:".",canReorder:!0,canRegroup:!0,canDeleteLocked:!1,canLeaveEmptyGroup:!0,shouldCreateEmptyGroup:!1,exportPreserveGroups:!1,removeEmptyGroupsOnLoad:!0,removeEmptyRulesOnLoad:!0,removeIncompleteRulesOnLoad:!1,removeInvalidMultiSelectValuesOnLoad:!0,showErrorMessage:!1,setOpOnChangeField:["keep","default"],groupOperators:["some","all","none"],defaultGroupConjunction:"AND",locale:{moment:"en"},valueLabel:"Value",valuePlaceholder:"Value",fieldLabel:"Field",operatorLabel:"Operator",funcLabel:"Function",fieldPlaceholder:"Select field",funcPlaceholder:"Select function",operatorPlaceholder:"Select operator",lockLabel:"Lock",lockedLabel:"Locked",deleteLabel:"Delete",addGroupLabel:"Add group",addCaseLabel:"Add condition",addDefaultCaseLabel:"Add default condition",defaultCaseLabel:"Default:",addRuleLabel:"Add rule",addSubRuleLabel:"Add sub rule",delGroupLabel:"Delete",notLabel:"Not",fieldSourcesPopupTitle:"Select source",valueSourcesPopupTitle:"Select value source",removeRuleConfirmOptions:null,removeGroupConfirmOptions:null};function Kh(e,t){var r="undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(!r){if(Array.isArray(e)||(r=function(e,t){if(e){if("string"==typeof e)return Wh(e,t);var r=Object.prototype.toString.call(e).slice(8,-1);return"Object"===r&&e.constructor&&(r=e.constructor.name),"Map"===r||"Set"===r?Array.from(e):"Arguments"===r||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(r)?Wh(e,t):void 0}}(e))||t&&e&&"number"==typeof e.length){r&&(e=r);var n=0,o=function(){};return{s:o,n:function(){return n>=e.length?{done:!0}:{done:!1,value:e[n++]}},e:function(e){throw e},f:o}}throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}var i,a=!0,s=!1;return{s:function(){r=r.call(e)},n:function(){var e=r.next();return a=e.done,e},e:function(e){s=!0,i=e},f:function(){try{a||null==r.return||r.return()}finally{if(s)throw i}}}}function Wh(e,t){(null==t||t>e.length)&&(t=e.length);for(var r=0,n=new Array(t);r<t;r++)n[r]=e[r];return n}var zh,$h=0,Hh=0,Yh={},Qh=function(){return zh||(zh=Jh({reactIndex:void 0,maxSize:3,canCompile:void 0})),zh},Xh=function(e,t){var r;for(var n in Yh){var o=Yh[n].findExtendedConfig(e,t);if(o){r=o;break}}return r},Jh=function(){var e,t=arguments.length>0&&void 0!==arguments[0]?arguments[0]:{reactIndex:void 0,maxSize:2,canCompile:!0},r=new Map,n=t.maxSize||2,o=++$h,i=function(e,t){r.size+1>n&&r.delete(r.keys().next().value),r.set(e,t)},a=function(e,t){var n,o=Kh(r.keys());try{var i,a=function(){var o=n.value;if(_h.filter((function(t){return o[t]===e[t]})).length===_h.length&&(!t||o.__compliled))return{v:r.get(o)}};for(o.s();!(n=o.n()).done;)if(i=a())return i.v}catch(e){o.e(e)}finally{o.f()}var s,l=Kh(r.values());try{var u,c=function(){var r=s.value;if(_h.filter((function(t){return r[t]===e[t]})).length===_h.length&&(!t||r.__compliled))return{v:r}};for(l.s();!(s=l.n()).done;)if(u=c())return u.v}catch(e){l.e(e)}finally{l.f()}return null};return e={getExtendedConfig:function(e){return r=function(e){return Hl()(e,_h)}(e),a(r)||function(e){var r=nv(e,++Hh,t.canCompile);return i(e,r),r}(r);var r},findExtendedConfig:a,getBasicConfig:function(e){var t,n=Kh(r.keys());try{var o,i=function(){var n=t.value,o=r.get(n);if(0===_h.map((function(t){return o[t]===e[t]})).filter((function(e){return!e})).length)return{v:n}};for(n.s();!(t=n.n()).done;)if(o=i())return o.v}catch(e){n.e(e)}finally{n.f()}return e},clearConfigMemo:function(){r.clear(),delete Yh[o],zh===e&&(zh=void 0)},configId:Hh,storeConfigPair:i,getSize:function(){return r.size},configStore:r,memoId:o,meta:t},void 0===t.reactIndex&&(zh=e),Yh[o]=e,e};function Zh(e,t){var r="undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(!r){if(Array.isArray(e)||(r=function(e,t){if(e){if("string"==typeof e)return ev(e,t);var r=Object.prototype.toString.call(e).slice(8,-1);return"Object"===r&&e.constructor&&(r=e.constructor.name),"Map"===r||"Set"===r?Array.from(e):"Arguments"===r||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(r)?ev(e,t):void 0}}(e))||t&&e&&"number"==typeof e.length){r&&(e=r);var n=0,o=function(){};return{s:o,n:function(){return n>=e.length?{done:!0}:{done:!1,value:e[n++]}},e:function(e){throw e},f:o}}throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}var i,a=!0,s=!1;return{s:function(){r=r.call(e)},n:function(){var e=r.next();return a=e.done,e},e:function(e){s=!0,i=e},f:function(){try{a||null==r.return||r.return()}finally{if(s)throw i}}}}function ev(e,t){(null==t||t>e.length)&&(t=e.length);for(var r=0,n=new Array(t);r<t;r++)n[r]=e[r];return n}function tv(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);t&&(n=n.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),r.push.apply(r,n)}return r}function rv(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{};t%2?tv(Object(r),!0).forEach((function(t){Gn(e,t,r[t])})):Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(r)):tv(Object(r)).forEach((function(t){Object.defineProperty(e,t,Object.getOwnPropertyDescriptor(r,t))}))}return e}var nv=function(e,t){var r=!(arguments.length>2&&void 0!==arguments[2])||arguments[2];if(r=r&&e.settings.useConfigCompress,e.__configId)return e;var n=Xh(e,r);if(n)return n;var o=e;(e=r?e.__compliled?ph()(e):Fh(e):ph()(e)).settings=qh()({},Gh,e.settings,jl),e.__fieldsCntByType={},e.__funcsCntByType={},e.__fieldNames={},function(e,t){for(var r in e)ov(0,e[r],t)}(e.types,e),iv(e.fields,e),av(e.funcs,e);var i=e.settings.caseValueField;i&&sv(i,e,[],!1,!0);var a=e.settings.locale.moment;return a&&ju().locale(a),Object.defineProperty(e,"__configId",{enumerable:!1,writable:!1,value:t||ml()}),e.__cache={},Ul(e),Qh().storeConfigPair(o,e),e};function ov(e,t,r){var n=null,o=null;t.mainWidget=t.mainWidget||Object.keys(t.widgets).filter((function(e){return"field"!=e&&"func"!=e}))[0];var i=t.excludeOperators||[];for(var a in t.widgets){var s=t.widgets[a],l=s.defaultOperator;s.operators&&(n=Vl(n,s.operators.filter((function(e){return!i.includes(e)})))),l&&!i.includes(l)&&(o&&a!==t.mainWidget||(o=l)),a==t.mainWidget&&(s.widgetProps=rv(rv({},t.mainWidgetProps||{}),s.widgetProps||{})),t.widgets[a]=s}t.valueSources||(t.valueSources=Object.keys(r.settings.valueSourcesInfo));var u,c=Zh(t.valueSources);try{for(c.s();!(u=c.n()).done;){var d=u.value;"value"==d||t.widgets[d]||(t.widgets[d]={})}}catch(e){c.e(e)}finally{c.f()}!t.operators&&n&&(t.operators=Array.from(new Set(n))),!t.defaultOperator&&o&&(t.defaultOperator=o)}function iv(e,t){var r=arguments.length>2&&void 0!==arguments[2]?arguments[2]:[];for(var n in e){var o=[].concat(Qn(r),[n]);sv(e[n],t,o),e[n].subfields&&iv(e[n].subfields,t,o)}}function av(e,t){var r,n=arguments.length>2&&void 0!==arguments[2]?arguments[2]:[];if(e){var o=(null==t||null===(r=t.settings)||void 0===r?void 0:r.fieldSeparator)||".";for(var i in e){var a=[].concat(Qn(n),[i]),s=a.join(o),l=e[i];if(l.returnType&&(l.type=l.returnType,t.__funcsCntByType[l.returnType]||(t.__funcsCntByType[l.returnType]=0),t.__funcsCntByType[l.returnType]++),sv(l,t,a,!1),l.args){for(var u in l.args)sv(l.args[u],t,[].concat(Qn(a),[u]),!0);var c,d=!0,p=Zh(Object.keys(l.args).reverse());try{for(p.s();!(c=p.n()).done;){var f=c.value,h=l.args[f];!d&&h.isOptional&&(Kl.info("Arg ".concat(f," for func ").concat(s," can't be optional")),delete h.isOptional),h.isOptional||(d=!1)}}catch(e){p.e(e)}finally{p.f()}}l.subfields&&av(l.subfields,t,[].concat(Qn(n),[i]))}}}function sv(e,t){var r,n=arguments.length>2&&void 0!==arguments[2]?arguments[2]:[],o=arguments.length>3&&void 0!==arguments[3]&&arguments[3],i=arguments.length>4&&void 0!==arguments[4]&&arguments[4],a=t.settings,s=a.showLabels,l=a.fieldSeparator;l=null!==(r=l)&&void 0!==r?r:".";var u=n[n.length-1],c=o?n.slice(0,n.length-1).join(l):n.join(l),d=!!e.returnType,p=e.type||e.returnType,f=t.types[p],h=e.excludeOperators||[],v=(e.operators||(null==f?void 0:f.operators)||[]).filter((function(e){return!h.includes(e)})),g=e.defaultOperator||(null==f?void 0:f.defaultOperator);h.includes(g)&&(g=void 0);var y=!!g&&g==e.defaultOperator;if(y&&(e.ownDefaultOperator=e.defaultOperator),f){o||d||i||(t.__fieldsCntByType[p]||(t.__fieldsCntByType[p]=0),t.__fieldsCntByType[p]++),o&&(e._isFuncArg=!0,e._argKey=u,e._funcKey=c),d&&(e._isFunc=!0,e._funcKey=c),i&&(e._isCaseValue=!0),function(e,t,r){for(var n,o,i=0,a=["listValues","treeValues","allowCustomValues","validateValue"];i<a.length;i++){var s=a[i];e[s]&&(e.fieldSettings||(e.fieldSettings={}),e.fieldSettings[s]=e[s],delete e[s])}null!==(n=e.fieldSettings)&&void 0!==n&&n.listValues&&t.settings.normalizeListValues&&(e.fieldSettings.listValues=t.settings.normalizeListValues.call(t.ctx,e.fieldSettings.listValues,r,e.fieldSettings)),null!==(o=e.fieldSettings)&&void 0!==o&&o.treeValues&&t.settings.normalizeListValues&&(e.fieldSettings.treeValues=t.settings.normalizeListValues.call(t.ctx,e.fieldSettings.treeValues,r,e.fieldSettings))}(e,t,p);var m=["widgets","operators","defaultOperator"];Object.keys(f).filter((function(e){return!m.includes(e)})).map((function(t){e[t]||(e[t]=Tl(f[t]))}));var b=f.excludeOperators||[];e.operators&&(b=b.filter((function(t){return!e.operators.includes(t)}))),e.widgets||(e.widgets={});var O=function(){var t=rv({},e.widgets[E]||{}),r=f.widgets[E]||{};if(!o){var n=t.defaultOperator,i=[].concat(Qn(h),Qn(b)),a=e.preferWidgets&&("field"===E||e.preferWidgets.includes(E))||i.length>0;if(t.operators){var l=t.operators.filter((function(e){return!i.includes(e)}));t.operators=l,v=Vl(v,l)}else if(a&&r.operators){var c=r.operators.filter((function(e){return!i.includes(e)}));t.operators=c,v=Vl(v,c)}n&&!i.includes(n)&&(g&&(y||E!==e.mainWidget)||(g=n))}E===e.mainWidget?t.widgetProps=rv(rv(rv({},r.widgetProps||{}),e.mainWidgetProps||{}),t.widgetProps||{}):t.widgetProps=rv(rv({},r.widgetProps||{}),t.widgetProps||{});var d=Array.from(new Set([].concat(Qn(Object.keys(r.opProps||{})),Qn(Object.keys(t.opProps||{})))));if(d.length){var p,m={},O=Zh(d);try{for(O.s();!(p=O.n()).done;){var S,T,_=p.value;m[_]=rv(rv({},(null===(S=r.opProps)||void 0===S?void 0:S[_])||{}),(null===(T=t.opProps)||void 0===T?void 0:T[_])||{})}}catch(e){O.e(e)}finally{O.f()}t.opProps=m}var w=t,R=w.valueLabel,A=w.valuePlaceholder;o&&(R||(t.valueLabel=e.label||u),A||s||(t.valuePlaceholder=e.label||u)),t=rv(rv({},r),t),e.widgets[E]=t};for(var E in f.widgets)O();if(o||(e.operators||(e.operators=Array.from(new Set(v))),e.defaultOperator||(e.defaultOperator=g)),!o&&!d&&!i){var S=function(e,t){if(!t)return{};var r=e.settings.fieldSeparator,n=Qn(t).reduce((function(t,n,o,i){var a=t.computedPath,s=t.computed,l=t.inGroup,u=[].concat(Qn(i.slice(0,o)),[n]),c=gv(e,u);return"!group"===(null==c?void 0:c.type)&&o<i.length-1?(l=u.join(r),a=[]):null!=c&&c.fieldName?(s=!0,a=[c.fieldName]):a=[].concat(Qn(a),[n]),{computedPath:a,computed:s,inGroup:l}}),{computedPath:[],computed:!1,inGroup:void 0}),o=n.computedPath,i=n.computed,a=n.inGroup;return i?{fieldName:o.join(r),inGroup:a}:{}}(t,n),T=S.fieldName,_=S.inGroup;T&&(e.fieldName=T,t.__fieldNames[T]||(t.__fieldNames[T]=[]),t.__fieldNames[T].push({fullPath:n,inGroup:_}))}}else e.disabled=!0}function lv(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);t&&(n=n.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),r.push.apply(r,n)}return r}function uv(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{};t%2?lv(Object(r),!0).forEach((function(t){Gn(e,t,r[t])})):Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(r)):lv(Object(r)).forEach((function(t){Object.defineProperty(e,t,Object.getOwnPropertyDescriptor(r,t))}))}return e}var cv=zl().mark(fv),dv=zl().mark(hv),pv=Ol;function fv(e){return zl().wrap((function(t){for(;;)switch(t.prev=t.next){case 0:return t.delegateYield(vv(e,e.funcs||{},[]),"t0",1);case 1:case"end":return t.stop()}}),cv)}function hv(e){return zl().wrap((function(t){for(;;)switch(t.prev=t.next){case 0:return t.delegateYield(vv(e,e.fields||{},[]),"t0",1);case 1:case"end":return t.stop()}}),dv)}function vv(e,t,r){var n=arguments.length>3&&void 0!==arguments[3]?arguments[3]:"subfields";return zl().mark((function o(i){var a,s,l;return zl().wrap((function(o){for(;;)switch(o.prev=o.next){case 0:a=(null==e||null===(i=e.settings)||void 0===i?void 0:i.fieldSeparator)||".",o.t0=zl().keys(t);case 2:if((o.t1=o.t0()).done){o.next=13;break}if(s=o.t1.value,!(l=t[s])[n]){o.next=9;break}return o.delegateYield(vv(e,l[n],[].concat(Qn(r),[s]),n),"t2",7);case 7:o.next=11;break;case 9:return o.next=11,[[].concat(Qn(r),[s]).join(a),l];case 11:o.next=2;break;case 13:case"end":return o.stop()}}),o)}))()}var gv=function(e,t){var r,n,o=arguments.length>2&&void 0!==arguments[2]?arguments[2]:"fields",i=arguments.length>3&&void 0!==arguments[3]?arguments[3]:"subfields";if(!t)return null;if("!case_value"===t)return null==e||null===(n=e.settings)||void 0===n?void 0:n.caseValueField;var a=(null==e||null===(r=e.settings)||void 0===r?void 0:r.fieldSeparator)||".",s=Tv(t,e),l=e[o];if(!l)return null;for(var u=l,c=null,d=[],p=0;p<s.length;p++){var f=s[p];d.push(f),c=u[d.join(a)],p<s.length-1&&(c&&c[i]?(u=c[i],d=[]):c=null)}return c},yv=function(e,t){var r,n,o=arguments.length>2&&void 0!==arguments[2]?arguments[2]:null,i=e.settings.fieldSeparator,a=[o].concat(Qn(t.split(i))).filter((function(e){return null!=e})),s=t;return((null===(r=e.__fieldNames[s])||void 0===r||null===(n=r.find)||void 0===n||null===(n=n.call(r,(function(e){var t=e.inGroup;return!t||(null==o?void 0:o.startsWith(t))})))||void 0===n?void 0:n.fullPath)||a).join(i)},mv=function(e,t){if(!t)return null;var r=gv(e,t,"funcs","subfields");if(!r)return null;var n=r.returnType,o=r.args;return{returnType:n,args:Object.fromEntries(Object.entries(o||{}).map((function(e){var t=Hn(e,2),r=t[0],n=t[1];return[r,Hl()(n,["type","valueSources","defaultValue","fieldSettings","isOptional","_funcKey","_argKey","_isFuncArg"])]})))}},bv=function(e,t){return t&&gv(e,t,"funcs","subfields")||null},Ov=function(e,t,r){var n=bv(e,t);return n&&(n.args&&n.args[r]||null)||null},Ev=function(e,t){var r,n=arguments.length>2&&void 0!==arguments[2]?arguments[2]:null;if(!t)return!1;var o=(null==n||null===(r=n.settings)||void 0===r?void 0:r.fieldSeparator)||".",i=Sv(e,n),a=Sv(t,n);return i.startsWith(a+o)},Sv=function(e){var t,r=arguments.length>1&&void 0!==arguments[1]?arguments[1]:null;if("string"==typeof e)return e;var n=(null==r||null===(t=r.settings)||void 0===t?void 0:t.fieldSeparator)||".";return Tv(e,r).join(n)},Tv=function(e){var t,r,n,o=arguments.length>1&&void 0!==arguments[1]?arguments[1]:null;if(!e)return[];if(Array.isArray(e))return e;var i,a=(null==o||null===(t=o.settings)||void 0===t?void 0:t.fieldSeparator)||".";return null!=e&&e.func?Array.isArray(e.func)?e.func:e.func.split(a):null!=e&&null!==(r=e.get)&&void 0!==r&&r.call(e,"func")?null==e||null===(i=e.get)||void 0===i?void 0:i.call(e,"func").split(a):(null==e||null===(n=e.split)||void 0===n?void 0:n.call(e,a))||[]},_v=function(e,t){var r=arguments.length>2&&void 0!==arguments[2]&&arguments[2];if(!e)return null;var n=t.settings.fieldSeparator,o=Tv(e,t);return r?o:o.map((function(e,t,r){return r.slice(0,t+1)})).map((function(e){return e.join(n)}))},wv=function(e){var t;if("string"==typeof e||Array.isArray(e))return"field:".concat(Sv(e));if("object"===kn(e)&&e){if(e._funcKey&&e._argKey)return"arg:".concat(Sv(e._funcKey),"__").concat(e._argKey);if(e._funcKey)return"func:".concat(Sv(e._funcKey));if(e.func&&e.arg)return"arg:".concat(Sv(e.func),"__").concat(e.arg);if(e.func)return"func:".concat(Sv(e.func));if(e.type)return null}return null!=e&&null!==(t=e.get)&&void 0!==t&&t.call(e,"func")?null!=e&&e.get("arg")?"arg:".concat(Sv(e.get("func")),"__").concat(e.get("arg")):"func:".concat(Sv(e.get("func"))):null},Rv=function(e,t,r){var n;return null===(n=e.__cache)||void 0===n||null===(n=n[t])||void 0===n?void 0:n[r]},Av=function(e,t,r,n){e.__cache&&r&&(e.__cache[t]||(e.__cache[t]={}),e.__cache[t][r]=n)},Cv=function(e){var t;if(!e)return null;if("object"===kn(e)){if(!e.func&&e.type)return"field";if(e.func)return e.func&&e.arg?null:"func"}return null!=e&&null!==(t=e.get)&&void 0!==t&&t.call(e,"func")?null!=e&&e.get("arg")?null:"func":"field"},Iv=function(e,t){var r;if(!t)return null;if("object"==kn(t)){if(!t.func&&t.type)return t;if(t.func)return t.func&&t.arg?Ov(e,t.func,t.arg):bv(e,t.func)}return null!=t&&null!==(r=t.get)&&void 0!==r&&r.call(t,"func")?null!=t&&t.get("arg")?Ov(e,t.get("func"),t.get("arg")):bv(e,t.get("func")):gv(e,t)||null},xv=function(e,t){var r=arguments.length>2&&void 0!==arguments[2]?arguments[2]:null;if(!t)return null;var n=e.operators[t];if(r){var o,i,a=wv(r),s=a?"".concat(a,"__").concat(t):null,l=Rv(e,"getOperatorConfig",s);if(l)return l;var u=Iv(e,r),c=Qf(e,r,t,null),d=e.widgets[c]||{},p=(u&&u.widgets?u.widgets[c]:{})||{},f=(null===(o=d.opProps)||void 0===o?void 0:o[t])||{},h=(null===(i=p.opProps)||void 0===i?void 0:i[t])||{},v=uv(uv(uv({},n),f),h);return Av(e,"getOperatorConfig",s,v),v}return n},Lv=function(e,t){var r,n=arguments.length>2&&void 0!==arguments[2]?arguments[2]:null,o=arguments.length>3&&void 0!==arguments[3]?arguments[3]:null,i=arguments.length>4&&void 0!==arguments[4]?arguments[4]:null,a=arguments.length>5&&void 0!==arguments[5]?arguments[5]:{};if(!t)return null;var s=Iv(e,t),l=wv(t);o||(o=Qf(e,t,n,i));var u=l?"".concat(l,"__").concat(n,"__").concat(o,"__").concat(i):null,c=Rv(e,"getFieldWidgetConfig",u);if(c)return c;var d=e.widgets[o]||{},p=(null==s||null===(r=s.widgets)||void 0===r?void 0:r[o])||{},f=p.widgetProps||{},h="value"!==i&&i?{}:null==s?void 0:s.fieldSettings,v=uv(uv(uv(uv({},d),p),f),h);return Av(e,"getFieldWidgetConfig",u,v),a.forExport&&(v=_l(v,"factory")),v},Nv=function(e){var t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:null,r=e.settings.fieldSeparator,n=Tv(t,e),o=t?gv(e,t):e,i=null,a=[];do{var s,l=o===e?e.fields:null===(s=o)||void 0===s?void 0:s.subfields;if(!l||!Object.keys(l).length){o=i=null;break}i=Object.keys(l)[0],a.push(i),o=l[i]}while("!struct"==o.type||"!group"==o.type);return(n||[]).concat(a).join(r)};function jv(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);t&&(n=n.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),r.push.apply(r,n)}return r}function Pv(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{};t%2?jv(Object(r),!0).forEach((function(t){Gn(e,t,r[t])})):Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(r)):jv(Object(r)).forEach((function(t){Object.defineProperty(e,t,Object.getOwnPropertyDescriptor(r,t))}))}return e}var kv=function(e,t){var r={usedFields:[]},n=Fv(e,t,r);if(n)return Pv(Pv({},n),r)},Fv=function(e,t,r){if(e){var n=e.get("type"),o=e.get("children1");return("group"===n||"rule_group"===n)&&o&&o.size?Dv(e,t,r):"rule"===n?Mv(e,t,r):void 0}},Dv=function(e,t,r){var n=e.get("properties")||new Ia,o=e.get("children1"),i=e.get("id"),a=o.map((function(e){return Fv(e,t,r)})).filter((function(e){return void 0!==e}));if(a.size){var s=n.get("conjunction");s||(s=hd(t));var l=n.get("not");return{id:i,rules:a.toList(),condition:s.toUpperCase(),not:l}}},Mv=function(e,t,r){var n,o=e.get("properties")||new Ia,i=e.get("id"),a=o.get("operator"),s=o.get("operatorOptions"),l=o.get("field"),u=o.get("value"),c=o.get("valueSrc"),d=o.get("valueType"),p=u.filter((function(e){return void 0===e})).size>0;if(null!=l&&null!=a&&!p){var f=Iv(t,l)||{},h=xv(t,a,l)||{},v=f.type||"undefined",g=wl(h),y=t.types[f.type]||{},m=Xf(l,t,r);if(!(u.size<g)){-1==r.usedFields.indexOf(l)&&r.usedFields.push(l),u=u.toArray(),c=c.toArray(),d=(null===(n=d)||void 0===n?void 0:n.toArray())||[];for(var b=[],O=0;O<u.length;O++){var E={type:d[O],value:u[O]};if(b.push(E),"field"==c[O]){var S=u[O];-1==r.usedFields.indexOf(S)&&r.usedFields.push(S)}}var T=s?s.toJS():null;T&&!Object.keys(T).length&&(T=null);var _={id:i,fieldName:m,type:v,input:y.mainWidget,operator:a};return T&&(_.operatorOptions=T),_.values=b,_}}};function Vv(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);t&&(n=n.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),r.push.apply(r,n)}return r}function Uv(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{};t%2?Vv(Object(r),!0).forEach((function(t){Gn(e,t,r[t])})):Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(r)):Vv(Object(r)).forEach((function(t){Object.defineProperty(e,t,Object.getOwnPropertyDescriptor(r,t))}))}return e}function Bv(e,t){var r="undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(!r){if(Array.isArray(e)||(r=function(e,t){if(e){if("string"==typeof e)return qv(e,t);var r=Object.prototype.toString.call(e).slice(8,-1);return"Object"===r&&e.constructor&&(r=e.constructor.name),"Map"===r||"Set"===r?Array.from(e):"Arguments"===r||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(r)?qv(e,t):void 0}}(e))||t&&e&&"number"==typeof e.length){r&&(e=r);var n=0,o=function(){};return{s:o,n:function(){return n>=e.length?{done:!0}:{done:!1,value:e[n++]}},e:function(e){throw e},f:o}}throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}var i,a=!0,s=!1;return{s:function(){r=r.call(e)},n:function(){var e=r.next();return a=e.done,e},e:function(e){s=!0,i=e},f:function(){try{a||null==r.return||r.return()}finally{if(s)throw i}}}}function qv(e,t){(null==t||t>e.length)&&(t=e.length);for(var r=0,n=new Array(t);r<t;r++)n[r]=e[r];return n}var Gv=function(e,t){var r,n={usedFields:[],errors:[]},o=nv(t,void 0,!1),i=Kv(e,o,n,!1,!0),a=n.errors,s=n.usedFields,l=(o.settings.fieldSeparator,{}),u=Bv(s);try{for(u.s();!(r=u.n()).done;)for(var c=r.value,d=Tv(c,t),p=(Iv(o,c),l),f=0;f<d.length;f++){var h=d[f],v=Iv(o,d.slice(0,f+1))||{};f!=d.length-1?"!group"==v.type&&"struct"!=v.mode?(p[h]||(p[h]=[{}]),p=p[h][0]):(p[h]||(p[h]={}),p=p[h]):p[h]||(p[h]=null)}}catch(e){u.e(e)}finally{u.f()}return{errors:a,logic:i,data:l}},Kv=function(e,t,r){var n=arguments.length>3&&void 0!==arguments[3]&&arguments[3],o=arguments.length>4&&void 0!==arguments[4]&&arguments[4],i=arguments.length>5&&void 0!==arguments[5]?arguments[5]:null;if(e){var a,s=e.get("type"),l=(e.get("properties")||new Ia).get("isLocked"),u=t.settings.jsonLogic.lockedOp;return"group"===s||"rule_group"===s?a=Wv(e,t,r,n,o,i):"rule"===s?a=zv(e,t,r,n,i):"switch_group"==s?a=$v(e,t,r,n):"case_group"==s&&(a=Hv(e,t,r,n,i)),l&&a&&u&&(a=Gn({},u,a)),a}},Wv=function(e,t,r){var n,o,i,a,s,l,u=arguments.length>3&&void 0!==arguments[3]&&arguments[3],c=arguments.length>4&&void 0!==arguments[4]&&arguments[4],d=arguments.length>5&&void 0!==arguments[5]?arguments[5]:null,p=e.get("type"),f=e.get("properties")||new Ia,h=f.get("mode"),v=e.get("children1")||new Za,g=f.get("field"),y=Iv(t,g),m=f.get("conjunction");m||(m=hd(t));var b=t.conjunctions[m].jsonLogicConj||m.toLowerCase(),O=!!f.get("not"),E="rule_group"===p&&!c,S=E&&"struct"!=h,T=S?g:d,_=f.get("operator"),w=_&&xv(t,_,g)||null,R=Yv(t,f,r,_,d),A=E&&(!_||0==(null===(n=w)||void 0===n?void 0:n.cardinality)),C=E&&(null==v?void 0:v.size)>0,I=(E&&null!=v&&v.size,O),x=!1;C?(x=O,I=u):u&&(I=!I);var L=!1,N=null===(o=w)||void 0===o?void 0:o.reversedOp,j=xv(t,N,g),P=!(null!==(i=w)&&void 0!==i&&i.jsonLogic||null===(a=j)||void 0===a||!a.jsonLogic),k=!(null===(s=j)||void 0===s||!s.jsonLogic),F=null===(l=lh(e))||void 0===l?void 0:l.get("type");if(!!t.settings.reverseOperatorsForNot&&(!E&&I&&"rule"===F||x&&1===(null==v?void 0:v.size))&&(C?x=!x:I=!I,L=!0),I&&E&&k&&(t.settings.reverseOperatorsForNot||P)){I=!I;var D=[N,_];_=D[0],N=D[1];var M=[j,w];w=M[0],j=M[1]}var V=v.map((function(e){return Kv(e,t,r,L,!1,T)})).filter((function(e){return void 0!==e})),U=!!t.settings.exportPreserveGroups;if(S&&!A){if(null==R)return}else if(!V.size&&!U)return;var B={};if(1!=V.size||c||U?B[b]=V.toList().toJS():B=V.first(),x&&(B={"!":B}),S){var q=Jv(r,t,g,d);if(A)B=Gn({},_||"some",[q,B]);else{var G=V.size?{filter:[q,B]}:q;B=Zv(t,f,{reduce:[G,{"+":[1,{var:"accumulator"}]},0]},R,_,null,y)}}return I&&(B={"!":B}),B},zv=function(e,t,r){var n,o,i,a,s,l,u=arguments.length>3&&void 0!==arguments[3]&&arguments[3],c=arguments.length>4&&void 0!==arguments[4]?arguments[4]:null,d=e.get("properties")||new Ia,p=d.get("field"),f=d.get("fieldSrc"),h=d.get("operator"),v=d.get("operatorOptions");if((v=v?v.toJS():null)&&!Object.keys(v).length&&(v=null),null!=p&&null!=h){var g=Iv(t,p),y=xv(t,h,p),m=null===(n=y)||void 0===n?void 0:n.reversedOp,b=xv(t,m,p);if(null!==(o=y)&&void 0!==o&&o.jsonLogic||null!==(i=b)&&void 0!==i&&i.jsonLogic){var O=u,E=!(null!==(a=y)&&void 0!==a&&a.jsonLogic||null===(s=b)||void 0===s||!s.jsonLogic),S=!(null===(l=b)||void 0===l||!l.jsonLogic)&&(!!t.settings.reverseOperatorsForNot||E);if(O&&S||E){O=!O;var T=[m,h];h=T[0],m=T[1];var _=[b,y];y=_[0],b=_[1]}var w=Yv(t,d,r,h,c);if(void 0!==w){var R="func"===f?Xv(r,t,p,c):Jv(r,t,p,c);if(void 0!==R)return Zv(t,d,R,w,h,v,g,O)}}else r.errors.push("Operator ".concat(h," is not supported"))}},$v=function(e,t,r){var n=arguments.length>3&&void 0!==arguments[3]&&arguments[3],o=e.get("children1");if(o){for(var i=o.map((function(e){return Hv(e,t,r,n,null)})).filter((function(e){return void 0!==e})).valueSeq().toArray(),a=[],s=0;s<i.length;s++)s===i.length-1||i[s][0]?(a.push(i[s]),s===i.length-1&&i[s][0]&&a.push([void 0,null])):r.errors.push("No condition for case ".concat(s));if(a.length){if(1===a.length){var l=Hn(a[0],2),u=(l[0],l[1]);return null==u&&(u=null),u}for(var c={if:[]},d=c.if,p=Hn(a[a.length-1],2),f=(p[0],p[1]),h=0;h<a.length-1;h++){var v=h===a.length-2,g=Hn(a[h],2),y=g[0],m=g[1];null==m&&(m=null),null==y&&(y=!0),d.push(y),d.push(m),v?d.push(f):(d.push({if:[]}),d=d[d.length-1].if)}return c}}},Hv=function(e,t,r){var n=arguments.length>3&&void 0!==arguments[3]&&arguments[3],o=arguments.length>4&&void 0!==arguments[4]?arguments[4]:null,i=e.get("type");if("case_group"==i){var a=e.get("properties")||new Ia;return[Wv(e,t,r,n,o),Yv(t,a,r,null,o,"!case_value")]}r.errors.push("Unexpected child of type ".concat(i," inside switch"))},Yv=function(e,t,r,n,o){var i=arguments.length>5&&void 0!==arguments[5]?arguments[5]:null,a=t.get("field"),s=t.get("valueSrc"),l=t.get("valueType");("!case_value"==i||l&&"case_value"==l.get(0))&&(a="!case_value");var u=Iv(e,a),c=xv(e,n,a),d=wl(c),p=t.get("value"),f=t.get("asyncListValues");if(null!=p){var h=[],v=[],g=r.usedFields,y=p.map((function(t,i){var d=s?s.get(i):null,p=l?l.get(i):null,g=sh(t,d,e),y=Qf(e,a,n,d),m=Lv(e,a,n,y,d,{forExport:!0}),b=Qv(r,e,g,d,p,m,u,n,c,o,f);return void 0!==b&&(h.push(d),v.push(p)),b})),m=y.filter((function(e){return void 0===e})).size>0;if(!(y.size<d||m))return d>1?y.toArray():1==d?y.first():null;r.usedFields=g}},Qv=function(e,t,r,n,o,i,a,s,l){var u=arguments.length>9&&void 0!==arguments[9]?arguments[9]:null,c=arguments.length>10?arguments[10]:void 0;if(void 0!==r){var d;if("field"==n)d=Jv(e,t,r,u);else if("func"==n)d=Xv(e,t,r,u);else if("function"==typeof(null==i?void 0:i.jsonLogic)){var p=i.jsonLogic,f=[r,Uv(Uv({},a?Hl()(a,["fieldSettings","listValues"]):{}),{},{asyncListValues:c}),_l(i,Ol)];s&&(f.push(s),f.push(l)),d=p.call.apply(p,[t.ctx].concat(f))}else d=r;return d}},Xv=function(e,t,r){var n,o,i=arguments.length>3&&void 0!==arguments[3]?arguments[3]:null,a=null===(n=r.get)||void 0===n?void 0:n.call(r,"func"),s=null===(o=r.get)||void 0===o?void 0:o.call(r,"args"),l=bv(t,a),u=Tv(a,t),c=u[u.length-1];if(l)if(null!=l&&l.jsonLogic){var d={},p=[],f=[];for(var h in l.args){var v,g=l.args[h],y=Iv(t,g),m=g.defaultValue,b=g.isOptional,O=null!=m&&m.func?"func":"value",E=s?s.get(h):void 0,S=E?E.get("value"):void 0,T=E?E.get("valueSrc"):void 0;"func"!==T&&null!==(v=S)&&void 0!==v&&v.toJS&&(S=S.toJS());var _=null,w=Qf(t,g,_,T),R=Lv(t,g,_,w,T,{forExport:!0}),A=Qv(e,t,S,T,g.type,R,y,null,null,i);if(null!=S&&void 0===A)return void("func"!=T&&e.errors.push("Can't format value of arg ".concat(h," for func ").concat(a)));var C=void 0;if(void 0===A&&!b&&null!=m){var I=Qf(t,g,_,O),x=Lv(t,g,_,I,O,{forExport:!0});if(void 0===(C=Qv(e,t,m,O,g.type,x,y,null,null,i)))return void("func"!=O&&e.errors.push("Can't format default value of arg ".concat(h," for func ").concat(a)))}var L=null!=A?A:C;if(void 0!==L){if(p.length){var N,j=Bv(p);try{for(j.s();!(N=j.n()).done;)d[N.value]=void 0}catch(e){j.e(e)}finally{j.f()}p=[]}d[h]=L}else b||f.push(h),p.push(h)}if(!f.length){var P,k=Object.values(d);if("function"==typeof l.jsonLogic){var F=l.jsonLogic,D=[d];P=F.call.apply(F,[t.ctx].concat(D))}else{var M=l.jsonLogic||c;if(l.jsonLogicIsMethod){var V=k[0],U=k.slice(1);P=U.length?{method:[V,M,U]}:{method:[V,M]}}else P=Gn({},M,k)}return P}}else e.errors.push("Func ".concat(a," is not supported"));else e.errors.push("Func ".concat(a," is not defined in config"))},Jv=function(e,t,r){var n,o=arguments.length>3&&void 0!==arguments[3]?arguments[3]:null,i=t.settings,a=i.fieldSeparator,s=i.jsonLogic;if(r){Array.isArray(r)&&(r=r.join(a));var l=Iv(t,r)||{},u=Xf(r,t,e,o);n=Gn({},l.jsonLogicVar||("!group"==l.type?s.groupVarKey:"var"),u),-1==e.usedFields.indexOf(r)&&e.usedFields.push(r)}return n},Zv=function(e,t,r,n,o){var i=arguments.length>5&&void 0!==arguments[5]?arguments[5]:null,a=arguments.length>6&&void 0!==arguments[6]?arguments[6]:null,s=arguments.length>7&&void 0!==arguments[7]&&arguments[7],l=t.get("field"),u=xv(e,o,l)||{},c="function"==typeof u.jsonLogic?u.jsonLogic:function(e,t,r,n){var o,i=e,a=wl(t),s=null!==(o=t._jsonLogicIsRevArgs)&&void 0!==o&&o;"string"==typeof t.jsonLogic&&(i=t.jsonLogic);var l=["<","<=",">",">="],u=["==","!="];return function(e,t,o,c,d){return 0==a&&u.includes(i)?Gn({},i,[r,null]):0==a?Gn({},i,r):1==a&&s?Gn({},i,[n,r]):1==a?Gn({},i,[r,n]):2==a&&l.includes(i)?Gn({},i,[n[0],r,n[1]]):Gn({},i,[r].concat(Qn(n)))}}(o,u,r,n),d=[r,o,n,_l(u,El),i,a],p=c.call.apply(c,[e.ctx].concat(d));return s&&(p={"!":p}),p};function eg(e,t){var r="undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(!r){if(Array.isArray(e)||(r=function(e,t){if(e){if("string"==typeof e)return tg(e,t);var r=Object.prototype.toString.call(e).slice(8,-1);return"Object"===r&&e.constructor&&(r=e.constructor.name),"Map"===r||"Set"===r?Array.from(e):"Arguments"===r||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(r)?tg(e,t):void 0}}(e))||t&&e&&"number"==typeof e.length){r&&(e=r);var n=0,o=function(){};return{s:o,n:function(){return n>=e.length?{done:!0}:{done:!1,value:e[n++]}},e:function(e){throw e},f:o}}throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}var i,a=!0,s=!1;return{s:function(){r=r.call(e)},n:function(){var e=r.next();return a=e.done,e},e:function(e){s=!0,i=e},f:function(){try{a||null==r.return||r.return()}finally{if(s)throw i}}}}function tg(e,t){(null==t||t>e.length)&&(t=e.length);for(var r=0,n=new Array(t);r<t;r++)n[r]=e[r];return n}function rg(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);t&&(n=n.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),r.push.apply(r,n)}return r}function ng(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{};t%2?rg(Object(r),!0).forEach((function(t){Gn(e,t,r[t])})):Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(r)):rg(Object(r)).forEach((function(t){Object.defineProperty(e,t,Object.getOwnPropertyDescriptor(r,t))}))}return e}var og=function(e){return"object"==kn(e)&&null!==e&&!Array.isArray(e)},ig=function(e,t){return ag(e,t,!1)},ag=function(e,t){var r=!(arguments.length>2&&void 0!==arguments[2])||arguments[2],n={errors:[]},o=nv(t,void 0,!1),i=sg([],e,o,n);return r?[i,n.errors]:(n.errors.length&&console.warn("Errors while exporting to MongoDb:",n.errors),i)},sg=function(e,t,r,n){var o=arguments.length>4&&void 0!==arguments[4]&&arguments[4],i=!(arguments.length>5&&void 0!==arguments[5])||arguments[5],a=arguments.length>6&&void 0!==arguments[6]?arguments[6]:void 0,s=arguments.length>7&&void 0!==arguments[7]?arguments[7]:void 0;if(t){var l=t.get("type");return"group"===l||"rule_group"===l?lg(e,t,r,n,o,i,a,s):"rule"===l?ug(e,t,r,n,o,i,a,s):void 0}},lg=function(e,t,r,n){var o,i,a,s,l,u,c,d,p=arguments.length>4&&void 0!==arguments[4]&&arguments[4],f=t.get("type"),h=t.get("properties")||new Ia,v=!!h.get("not"),g=t.get("children1")||new Za,y=r.settings,m=y.canShortMongoQuery,b=y.fieldSeparator,O=e.filter((function(e){return"rule_group"==e.get("type")})).length>0,E=e.filter((function(e){return"rule_group"==e.get("type")})).map((function(e){return e.get("properties").get("field")})).slice(-1).pop(),S=O&&E,T="rule_group"===f,_=T?h.get("field"):null,w=T?h.get("operator"):null,R=w&&xv(r,w,_)||null,A=w?null!==(o=null===(i=R)||void 0===i?void 0:i.cardinality)&&void 0!==o?o:1:void 0,C=Xf(_,r,n,S),I=(Iv(r,_)||{}).mode,x=_&&"array"===I&&A>=1,L=T&&(null==g?void 0:g.size)>0,N=(T&&null!=g&&g.size,!1),j=v,P=!1;L?(P=v,j=p):p&&(j=!j);var k=null===(a=R)||void 0===a?void 0:a.reversedOp,F=xv(r,k,_),D=!(null!==(s=R)&&void 0!==s&&s.mongoFormatOp||null===(l=F)||void 0===l||!l.mongoFormatOp),M=!(null===(u=F)||void 0===u||!u.mongoFormatOp),V=null===(c=lh(t))||void 0===c?void 0:c.get("type");if(!!r.settings.reverseOperatorsForNot&&(!T&&j&&"rule"===V||P&&1===(null==g?void 0:g.size))&&(L?P=!P:j=!j,N=!0),j&&T&&M&&(r.settings.reverseOperatorsForNot||D)){j=!j;var U=[k,w];w=U[0],k=U[1];var B=[F,R];R=B[0],F=B[1]}var q=h.get("conjunction");q||(q=hd(r));var G=r.conjunctions[q];if(G){var K=G.reversedConj;j&&"or"===(null===(d=q)||void 0===d?void 0:d.toLowerCase())&&K&&!T&&r.settings.canShortMongoQuery&&r.settings.reverseOperatorsForNot&&(q=K,G=r.conjunctions[q],j=!j,N=!0);var W=G.mongoConj,z=g.map((function(o){return sg([].concat(Qn(e),[t]),o,r,n,N,"array"!=I,"array"==I?function(e){return"$$el".concat(b).concat(e)}:void 0)})).filter((function(e){return void 0!==e}));if(x||z.size){var $;if(1==z.size)$=z.first();else if(z.size>1){var H=z.toList().toJS();m&&"$and"==W&&($=H.reduce((function(e,t){if(e){for(var r in t){if("$"==r[0]){e=void 0;break}if(null==e[r])e[r]=t[r];else{var n=e[r],o=t[r];if(og(n)||(n={$eq:n}),og(o)||(o={$eq:o}),Object.keys(n)[0]==Object.keys(o)[0]){e=void 0;break}e[r]=Object.assign({},n,o)}}return e}}),{})),$||($=Gn({},W,H))}if(_)if("array"==I){var Y={$size:{$ifNull:["$"+C,[]]}},Q=$?{$size:{$ifNull:[{$filter:{input:"$"+C,as:"el",cond:$}},[]]}}:Y;$={$expr:$=sg(e,t.set("type","rule"),r,n,P,!1,(function(e){return Q}),Y)}}else $=Gn({},C,{$elemMatch:$});return j&&($={$not:$}),$}}},ug=function(e,t,r,n){var o,i,a,s,l,u,c,d=arguments.length>4&&void 0!==arguments[4]&&arguments[4],p=!(arguments.length>5&&void 0!==arguments[5])||arguments[5],f=arguments.length>6&&void 0!==arguments[6]?arguments[6]:void 0,h=arguments.length>7&&void 0!==arguments[7]?arguments[7]:void 0,v=t.get("properties")||new Ia,g=e.filter((function(e){return"rule_group"==e.get("type")})).length>0,y=e.filter((function(e){return"rule_group"==e.get("type")})).map((function(e){return e.get("properties").get("field")})).slice(-1).pop(),m=g&&y,b=v.get("operator"),O=v.get("operatorOptions"),E=v.get("field"),S=v.get("fieldSrc"),T=v.get("value"),_=v.get("valueSrc"),w=v.get("valueType"),R=v.get("asyncListValues");if(null!=E&&null!=b&&void 0!==T){var A=Iv(r,E),C=xv(r,b,E),I=null===(o=C)||void 0===o?void 0:o.reversedOp,x=xv(r,I,E),L=wl(C);if(null!==(i=C)&&void 0!==i&&i.mongoFormatOp||null!==(a=x)&&void 0!==a&&a.mongoFormatOp){var N,j=d,P=!(null!==(s=C)&&void 0!==s&&s.mongoFormatOp||null===(l=x)||void 0===l||!l.mongoFormatOp);if(null!==(u=x)&&void 0!==u&&u.mongoFormatOp&&(r.settings.reverseOperatorsForNot||P)&&j||P){var k=[I,b];b=k[0],I=k[1];var F=[x,C];C=F[0],x=F[1],j=!j}var D=!1;if("func"==S){var M=Hn(pg(n,r,E,m),2);N=M[0],D=M[1]}else N=Xf(E,r,n,m),f&&(D=!0,N=f(N));if(null!=N){var V,U=[],B=[];if(null!=T){var q=T.map((function(e,t){var o=_?_.get(t):null,i=w?w.get(t):null,a=sh(e,o,r),s=Qf(r,E,b,o),l=Lv(r,E,b,s,o,{forExport:!0}),u=Hn(cg(n,r,a,o,i,l,A,m,b,C,R),2),c=u[0],d=u[1];return void 0!==c&&(D=D||d,U.push(o),B.push(i)),c})),G=q.filter((function(e){return void 0===e})).size>0;if(q.size<L||G)return;V=L>1?q.toArray():1==L?q.first():null}var K=D&&p,W=null===(c=C)||void 0===c?void 0:c.mongoFormatOp,z=[N,b,void 0!==h&&null==V?h:V,D,U.length>1?U:U[0],B.length>1?B:B[0],_l(C,El),O,A],$=W.call.apply(W,[r.ctx].concat(z));return K&&($={$expr:$}),j&&($={$not:$}),$}}else n.errors.push("Operator ".concat(b," is not supported"))}},cg=function(e,t,r,n,o,i,a,s,l,u,c){if(void 0===r)return[void 0,!1];var d,p=!1;if("field"==n){var f=Hn(dg(e,t,r,s),2);d=f[0],p=f[1]}else if("func"==n){var h=Hn(pg(e,t,r,s),2);d=h[0],p=h[1]}else if("function"==typeof(null==i?void 0:i.mongoFormatValue)){var v=i.mongoFormatValue,g=[r,ng(ng({},a?Hl()(a,["fieldSettings","listValues"]):{}),{},{asyncListValues:c}),_l(i,Ol)];l&&(g.push(l),g.push(u)),d=v.call.apply(v,[t.ctx].concat(g))}else d=r;return[d,p]},dg=function(e,t,r,n){var o,i=t.settings.fieldSeparator;if(r){var a=Iv(t,r)||{},s=Tv(r,t),l=Gf(r,t),u=l?l.join(i):null;o="$"+(0,t.settings.formatField)(Xf(r,t,e,n),s,u,a,t,!1)}return[o,!0]},pg=function(e,t,r,n){var o,i,a,s=null===(o=r.get)||void 0===o?void 0:o.call(r,"func"),l=null===(i=r.get)||void 0===i?void 0:i.call(r,"args"),u=bv(t,s);if(!u)return e.errors.push("Func ".concat(s," is not defined in config")),[void 0,!1];var c=Tv(s,t),d=c[c.length-1],p=u.mongoFunc||d,f=u.mongoArgsAsObject,h={},v=0,g=void 0,y=[],m=[];for(var b in u.args){var O;v++;var E=u.args[b],S=Iv(t,E),T=E.defaultValue,_=E.isOptional,w=null!=T&&T.func?"func":"value",R=l?l.get(b):void 0,A=R?R.get("value"):void 0,C=R?R.get("valueSrc"):void 0;"func"!==C&&null!==(O=A)&&void 0!==O&&O.toJS&&(A=A.toJS());var I=R?R.get("asyncListValues"):void 0,x=null,L=Qf(t,E,x,C),N=Lv(t,E,x,L,C,{forExport:!0}),j=Hn(cg(e,t,A,C,E.type,N,S,n,null,null,I),2),P=j[0];if(j[1],null!=A&&void 0===P)return"func"!=C&&e.errors.push("Can't format value of arg ".concat(b," for func ").concat(s)),[void 0,!1];var k=void 0;if(void 0===P&&!_&&null!=T){var F=Qf(t,E,x,w),D=Lv(t,E,x,F,w,{forExport:!0}),M=Hn(cg(e,t,T,w,E.type,D,S,n,null,null,I),2);if(k=M[0],M[1],void 0===k)return"func"!=w&&e.errors.push("Can't format default value of arg ".concat(b," for func ").concat(s)),[void 0,!1]}var V=null!=P?P:k;if(void 0!==V){if(y.length){var U,B=eg(y);try{for(B.s();!(U=B.n()).done;)h[U.value]=void 0}catch(e){B.e(e)}finally{B.f()}y=[]}h[b]=V,g=V}else _||m.push(b),y.push(b)}if(m.length)return[void 0,!1];if("function"==typeof u.mongoFormatFunc){var q=u.mongoFormatFunc,G=[h];a=q.call.apply(q,[t.ctx].concat(G))}else{if(null===u.mongoFormatFunc)return e.errors.push("Functon ".concat(p," is not supported")),[void 0,!1];a=Gn({},p,f?h:1==v&&void 0!==g?g:Object.values(h))}return[a,!0]};function fg(e,t){var r="undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(!r){if(Array.isArray(e)||(r=function(e,t){if(e){if("string"==typeof e)return hg(e,t);var r=Object.prototype.toString.call(e).slice(8,-1);return"Object"===r&&e.constructor&&(r=e.constructor.name),"Map"===r||"Set"===r?Array.from(e):"Arguments"===r||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(r)?hg(e,t):void 0}}(e))||t&&e&&"number"==typeof e.length){r&&(e=r);var n=0,o=function(){};return{s:o,n:function(){return n>=e.length?{done:!0}:{done:!1,value:e[n++]}},e:function(e){throw e},f:o}}throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}var i,a=!0,s=!1;return{s:function(){r=r.call(e)},n:function(){var e=r.next();return a=e.done,e},e:function(e){s=!0,i=e},f:function(){try{a||null==r.return||r.return()}finally{if(s)throw i}}}}function hg(e,t){(null==t||t>e.length)&&(t=e.length);for(var r=0,n=new Array(t);r<t;r++)n[r]=e[r];return n}function vg(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);t&&(n=n.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),r.push.apply(r,n)}return r}function gg(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{};t%2?vg(Object(r),!0).forEach((function(t){Gn(e,t,r[t])})):Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(r)):vg(Object(r)).forEach((function(t){Object.defineProperty(e,t,Object.getOwnPropertyDescriptor(r,t))}))}return e}var yg=function(e,t){return mg(e,t,!1)},mg=function(e,t){var r=!(arguments.length>2&&void 0!==arguments[2])||arguments[2],n={errors:[]},o=nv(t,void 0,!1),i=bg(e,o,n);return r?[i,n.errors]:(n.errors.length&&console.warn("Errors while exporting to SQL:",n.errors),i)},bg=function(e,t,r){if(e){var n=e.get("type");return e.get("children1"),"group"===n||"rule_group"===n?Og(e,t,r):"rule"===n?Eg(e,t,r):void 0}},Og=function(e,t,r){var n=e.get("type"),o=e.get("properties")||new Ia,i=e.get("children1")||new Za,a="rule_group"===n?o.get("field"):null;"array"==(Iv(t,a)||{}).mode&&r.errors.push("Aggregation is not supported for ".concat(a));var s=o.get("not"),l=i.map((function(e){return bg(e,t,r)})).filter((function(e){return void 0!==e}));if(l.size){var u=o.get("conjunction");return u||(u=hd(t)),t.conjunctions[u].sqlFormatConj.call(t.ctx,l,u,s)}},Eg=function(e,t,r){var n=e.get("properties")||new Ia,o=n.get("field"),i=n.get("fieldSrc"),a=n.get("operator"),s=n.get("operatorOptions"),l=n.get("valueSrc"),u=n.get("valueType"),c=n.get("value"),d=n.get("asyncListValues");if(null!=o&&null!=a){var p=Iv(t,o)||{},f=xv(t,a,o)||{},h=f.reversedOp,v=xv(t,h,o)||{},g=wl(f),y=!1,m=f.sqlOp||f.sqlFormatOp,b=v.sqlOp||v.sqlFormatOp;if(m||b){if(!m&&b){y=!0;var O=[h,a];a=O[0],h=O[1];var E=[v,f];f=E[0],v=E[1]}var S,T=[],_=[];if(null!=c){var w=c.map((function(e,n){var i=l?l.get(n):null,s=u?u.get(n):null,c=sh(e,i,t),h=Qf(t,o,a,i),v=Lv(t,o,a,h,i,{forExport:!0}),g=Sg(r,t,c,i,s,v,p,a,f,d);return void 0!==g&&(T.push(i),_.push(s)),g}));if(w.filter((function(e){return void 0===e})).size>0||w.size<g)return;S=1==g?w.first():w}var R=f.sqlFormatOp||function(e,t){var r,n=t.sqlOp||e,o=wl(t);return 0==o?r=function(e,t,r,o,i,a,s,l){return"".concat(e," ").concat(n)}:1==o?r=function(e,t,r,o,i,a,s,l){return"".concat(e," ").concat(n," ").concat(r)}:2==o&&(r=function(e,t,r,o,i,a,s,l){var u,c,d=null==r||null===(u=r.first)||void 0===u?void 0:u.call(r),p=null==r||null===(c=r.get)||void 0===c?void 0:c.call(r,1);return"".concat(e," ").concat(n," ").concat(d," AND ").concat(p)}),r}(a,f);if(R){var A="func"==i?_g(r,t,o):Tg(r,t,o);if(null!=A){var C,I=[A,a,S,T.length>1?T:T[0],_.length>1?_:_[0],_l(f,El),s,p];if(C=R.call.apply(R,[t.ctx].concat(I)),y&&(C=t.settings.sqlFormatReverse.call(t.ctx,C)),void 0!==C)return C;r.errors.push("Operator ".concat(a," is not supported for value source ").concat(T.join(", ")))}}else r.errors.push("Operator ".concat(a," is not supported"))}else r.errors.push("Operator ".concat(a," is not supported"))}},Sg=function(e,t,r,n,o,i,a,s,l,u){if(void 0!==r){var c;if("field"==n)c=Tg(e,t,r);else if("func"==n)c=_g(e,t,r);else if("function"==typeof(null==i?void 0:i.sqlFormatValue)){var d=i.sqlFormatValue,p=[r,gg(gg({},Hl()(a,["fieldSettings","listValues"])),{},{asyncListValues:u}),_l(i,Ol)];if(s&&(p.push(s),p.push(l)),"field"==n){var f=Iv(t,r)||{};p.push(f)}c=d.call.apply(d,[t.ctx].concat(p))}else c=Array.isArray(r)?r.map((function(e){return rc.escape(e)})):rc.escape(r);return c}},Tg=function(e,t,r){if(r){var n=t.settings.fieldSeparator,o=Iv(t,r)||{},i=Tv(r,t),a=Gf(r,t),s=a?a.join(n):null;return(0,t.settings.formatField)(Xf(r,t,e,null,{useTableName:!0}),i,s,o,t)}},_g=function(e,t,r){var n,o,i=null===(n=r.get)||void 0===n?void 0:n.call(r,"func"),a=null===(o=r.get)||void 0===o?void 0:o.call(r,"args"),s=bv(t,i);if(s){var l=Tv(i,t),u=l[l.length-1],c=s.sqlFunc||u,d={},p=[],f=[];for(var h in s.args){var v,g=s.args[h],y=Iv(t,g),m=g.defaultValue,b=g.isOptional,O=null!=m&&m.func?"func":"value",E=a?a.get(h):void 0,S=E?E.get("value"):void 0,T=E?E.get("valueSrc"):void 0;"func"!==T&&null!==(v=S)&&void 0!==v&&v.toJS&&(S=S.toJS());var _=E?E.get("asyncListValues"):void 0,w=Sg(e,t,S,T,g.type,y,g,null,null,_);if(null!=S&&void 0===w)return void("func"!=T&&e.errors.push("Can't format value of arg ".concat(h," for func ").concat(i)));var R=void 0;if(void 0===w&&!b&&null!=m&&void 0===(R=Sg(e,t,m,O,g.type,y,g,null,null,_)))return void("func"!=O&&e.errors.push("Can't format default value of arg ".concat(h," for func ").concat(i)));var A=null!=w?w:R;if(void 0!==A){if(p.length){var C,I=fg(h);try{for(I.s();!(C=I.n()).done;)d[C.value]=void 0}catch(e){I.e(e)}finally{I.f()}p=[]}d[h]=A}else b||f.push(h),p.push(h)}if(!f.length){var x;if("function"==typeof s.sqlFormatFunc){var L=s.sqlFormatFunc,N=[d];x=L.call.apply(L,[t.ctx].concat(N))}else{var j=Object.entries(d).map((function(e){var t=Hn(e,2);return t[0],t[1]})).join(", ");x="".concat(c,"(").concat(j,")")}return x}}else e.errors.push("Func ".concat(i," is not defined in config"))};function wg(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);t&&(n=n.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),r.push.apply(r,n)}return r}function Rg(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{};t%2?wg(Object(r),!0).forEach((function(t){Gn(e,t,r[t])})):Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(r)):wg(Object(r)).forEach((function(t){Object.defineProperty(e,t,Object.getOwnPropertyDescriptor(r,t))}))}return e}function Ag(e,t,r,n,o,i){if(e&&r&&null!=t){var a=r,s=n.operators[a];if(s){var l=s.elasticSearchQueryType,u=!1;!l&&s.reversedOp&&(u=!0,a=s.reversedOp,l=(s=n.operators[a]).elasticSearchQueryType);var c=Qf(n,e,a,o),d=n.widgets[c];if(d){var p,f,h=d.elasticSearchFormatValue;if(p="function"==typeof l?l(c):l)return f="function"==typeof h?h(p,t,a,e,n):function(e,t,r,n,o,i){var a=function(e,t){return e}(n);switch(e){case"filter":return{script:o.operators[r].elasticSearchScript(n,t)};case"exists":return{field:n};case"match":return Gn({},a,t[0]);case"term":return Gn({},n,i===Cg?{value:t[0]}:t[0]);case"geo_bounding_box":return Gn({},n,function(e){if(null==e)return null;var t=e.split(",").map(Number);return{top_left:{lat:t[0],lon:t[1]},bottom_right:{lat:t[2],lon:t[3]}}}(t[0]));case"range":return Gn({},n,function(e,t){if(e.length>1)return{gte:"".concat(e[0]),lte:"".concat(e[1])};var r=e[0];switch(t){case"on_date":case"not_on_date":case"equal":case"select_equals":case"not_equal":return{gte:"".concat(r,"||/d"),lte:"".concat(r,"||+1d")};case"less_or_equal":return{lte:"".concat(r)};case"greater_or_equal":return{gte:"".concat(r)};case"less":return{lt:"".concat(r)};case"greater":return{gt:"".concat(r)};default:return}}(t,r));case"wildcard":return Gn({},n,function(e){return{value:"*"+e+"*"}}(t[0]));case"regexp":return Gn({},n,function(e){return{value:e}}(t[0]));default:return}}(p,t,a,e,n,i),u?{bool:{must_not:Gn({},p,Rg({},f))}}:Gn({},p,Rg({},f))}}}}var Cg="ES_7_SYNTAX",Ig="ES_6_SYNTAX";function xg(e,t){var r=arguments.length>2&&void 0!==arguments[2]?arguments[2]:Ig,n=nv(t,void 0,!1);if(e){var o=e.get("type"),i=e.get("properties")||new Map;if("rule"===o&&i.get("field")){var a,s,l,u=i.get("operator"),c=i.get("field"),d=i.get("fieldSrc"),p=null===(a=i.get("value"))||void 0===a?void 0:a.toJS(),f=(null===(s=i.get("valueType"))||void 0===s||s.get(0),null===(l=i.get("valueSrc"))||void 0===l?void 0:l.get(0));if("func"===f||"func"==d)return;return p&&Array.isArray(p[0])?p[0].map((function(e){return Ag(c,[e],u,n,f,r)})):Ag(c,p,u,n,f,r)}if("group"===o||"rule_group"===o){var h=i.get("not"),v=i.get("conjunction");return v||(v=hd(n)),function(e,t,r,n,o,i){if(e&&e.size){var a=e.valueSeq().toArray(),s=function(e,t){switch(e){case"AND":return t?"must_not":"must";case"OR":return t?"should_not":"should";case"NOT":return t?"must":"must_not";default:return}}(t,r),l=a.map((function(e){return n(e,o,i)})).filter((function(e){return void 0!==e}));if(l.length)return{bool:Gn({},s,l.flat(1/0))}}}(e.get("children1"),v,h,xg,n,r)}}}function Lg(e,t){if(null==e)return{};var r,n,o=function(e,t){if(null==e)return{};var r={};for(var n in e)if({}.hasOwnProperty.call(e,n)){if(t.includes(n))continue;r[n]=e[n]}return r}(e,t);if(Object.getOwnPropertySymbols){var i=Object.getOwnPropertySymbols(e);for(n=0;n<i.length;n++)r=i[n],t.includes(r)||{}.propertyIsEnumerable.call(e,r)&&(o[r]=e[r])}return o}function Ng(e,t,r,n,o,i,a){try{var s=e[i](a),l=s.value}catch(e){return void r(e)}s.done?t(l):Promise.resolve(l).then(n,o)}var jg=["title","value","disabled","groupTitle","grouplabel","renderTitle","children","label","isCustom","isHidden"];function Pg(e,t){(null==t||t>e.length)&&(t=e.length);for(var r=0,n=new Array(t);r<t;r++)n[r]=e[r];return n}function kg(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);t&&(n=n.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),r.push.apply(r,n)}return r}function Fg(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{};t%2?kg(Object(r),!0).forEach((function(t){Gn(e,t,r[t])})):Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(r)):kg(Object(r)).forEach((function(t){Object.defineProperty(e,t,Object.getOwnPropertyDescriptor(r,t))}))}return e}var Dg=function(e){var t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:0,r=arguments.length>2&&void 0!==arguments[2]?arguments[2]:1e3;return function(){var n,o=(n=zl().mark((function n(o,i,a){var s,l,u,c,d,p;return zl().wrap((function(n){for(;;)switch(n.prev=n.next){case 0:if(s=null!=(null==a?void 0:a.pageSize)?a.pageSize:t,l=iu(e).filter((function(e){var t=e.title,r=e.value;return null==o||-1!=t.toUpperCase().indexOf(o.toUpperCase())||-1!="".concat(r).toUpperCase().indexOf(o.toUpperCase())})),s&&Math.ceil(l.length/s),u=i||0,s&&Math.ceil(u/s),c=s?l.slice(u,u+s):l,d=s?u+c.length:null,p=!!s&&d<l.length,!r){n.next=11;break}return n.next=11,Ml(r);case 11:return n.abrupt("return",{values:c,hasMore:p});case 12:case"end":return n.stop()}}),n)})),function(){var e=this,t=arguments;return new Promise((function(r,o){var i=n.apply(e,t);function a(e){Ng(i,r,o,a,s,"next",e)}function s(e){Ng(i,r,o,a,s,"throw",e)}a(void 0)}))});return function(e,t,r){return o.apply(this,arguments)}}()},Mg=function(e,t){var r=arguments.length>2&&void 0!==arguments[2]&&arguments[2],n=arguments.length>3&&void 0!==arguments[3]&&arguments[3];if(!t)return e;var o=e||[],i=t.filter((function(e){return null==o.find((function(t){return""+t.value==""+e.value}))})).map((function(e){return n?Fg(Fg({},e),{},{isHidden:!0}):e}));return r?[].concat(Qn(i),Qn(o)):[].concat(Qn(o),Qn(i))},Vg=function(e,t,r){var n,o=null==e||""==e?void 0:null!==(n=null==e?void 0:e.value)&&void 0!==n?n:e,i=du(o,t),a=r&&!i?ou(o):void 0,s=i||a;return[o,s?[s]:void 0]},Ug=function(e,t,r){var n=e.map((function(e,n){var o,i=null==e||""==e?void 0:null!==(o=null==e?void 0:e.value)&&void 0!==o?o:e,a=du(i,t),s=r&&!a?ou(i):void 0;return a||s})).filter((function(e){return null!=e})),o=n.map((function(e){var t;return null!==(t=null==e?void 0:e.value)&&void 0!==t?t:e}));return o.length||(o=void 0),[o,n]},Bg=function(e){if(null==e)return null;var t=e.title,r=e.value,n=e.disabled,o=e.groupTitle,i=e.grouplabel,a=e.renderTitle,s=e.children,l=e.label,u=e.isCustom,c=e.isHidden,d=Lg(e,jg),p={value:r,title:t||l||s};return n&&(p.disabled=n),u&&(p.isCustom=u),c&&(p.isHidden=c),(o||i)&&(p.groupTitle=o||i),a&&(p.renderTitle=a),Fg(Fg({},p),d)},qg=function(e){var t,r=[],n=[],o=function(e,t){var r="undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(!r){if(Array.isArray(e)||(r=function(e,t){if(e){if("string"==typeof e)return Pg(e,t);var r=Object.prototype.toString.call(e).slice(8,-1);return"Object"===r&&e.constructor&&(r=e.constructor.name),"Map"===r||"Set"===r?Array.from(e):"Arguments"===r||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(r)?Pg(e,t):void 0}}(e))||t&&e&&"number"==typeof e.length){r&&(e=r);var n=0,o=function(){};return{s:o,n:function(){return n>=e.length?{done:!0}:{done:!1,value:e[n++]}},e:function(e){throw e},f:o}}throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}var i,a=!0,s=!1;return{s:function(){r=r.call(e)},n:function(){var e=r.next();return a=e.done,e},e:function(e){s=!0,i=e},f:function(){try{a||null==r.return||r.return()}finally{if(s)throw i}}}}(e);try{var i=function(){var e=t.value,o=function(e,t){if(e.findLastIndex)return e.findLastIndex(t);var r=Qn(e).reverse().findIndex(t);return-1==r?-1:e.length-1-r}(r,(function(t){var r,n;return(null!==(r=t.groupTitle)&&void 0!==r?r:"")==(null!==(n=e.groupTitle)&&void 0!==n?n:"")}));null==e.groupTitle||n.includes(e.groupTitle)||(n.push(e.groupTitle),1===n.length&&(r=r.map((function(e){return Fg(Fg({},e),{},{groupTitle:""})})))),null==e.groupTitle&&n.length&&(e=Fg(Fg({},e),{},{groupTitle:""})),-1!=o?r.splice(o+1,0,e):r.push(e)};for(o.s();!(t=o.n()).done;)i()}catch(e){o.e(e)}finally{o.f()}return r},Gg={label:"Now",returnType:"datetime",jsonLogic:"now",jsonLogicCustomOps:{now:{}},spelFunc:"T(java.time.LocalDateTime).now()",sqlFormatFunc:function(){return"NOW()"},mongoFormatFunc:function(){return new Date},formatFunc:function(){return"NOW"}},Kg={label:"Relative",returnType:"datetime",renderBrackets:["",""],renderSeps:["","",""],spelFormatFunc:function(e){var t=e.date,r=e.op,n=e.val,o=e.dim,i=r+(o.charAt(0).toUpperCase()+o.slice(1)+"s");return"".concat(t,".").concat(i,"(").concat(n,")")},spelImport:function(e){var t,r,n,o,i=null===(t=e.methodName)||void 0===t?void 0:t.match(/^(minus|plus)(\w+)s$/);if(i&&(o=i[2].toLowerCase(),r=i[1],["minus","plus"].includes(r)&&["day","week","month","year"].includes(o)))return r={type:"string",val:r},o={type:"string",val:o},n=e.args[0],{date:e.obj,op:r,val:n,dim:o}},jsonLogic:function(e){var t=e.date,r=e.op;return{date_add:[t,e.val*("minus"==r?-1:1),e.dim]}},jsonLogicImport:function(e){var t=e.date_add[0],r=Math.abs(e.date_add[1]);return[t,e.date_add[1]>=0?"plus":"minus",r,e.date_add[2]]},jsonLogicCustomOps:{date_add:{}},sqlFormatFunc:function(e){var t=e.date,r=e.op,n=e.val,o=e.dim;return"DATE_ADD(".concat(t,", INTERVAL ").concat(parseInt(n)*("minus"==r?-1:1)," ").concat(o.replace(/^'|'$/g,""),")")},mongoFormatFunc:null,formatFunc:function(e){var t=e.date,r=e.op,n=e.val,o=e.dim;return n?"".concat(t," ").concat("minus"==r?"-":"+"," ").concat(n," ").concat(o):t},args:{date:{label:"Date",type:"datetime",defaultValue:{func:"NOW",args:[]},valueSources:["func","field","value"],spelEscapeForFormat:!0},op:{label:"Op",type:"select",defaultValue:"plus",valueSources:["value"],mainWidgetProps:{customProps:{showSearch:!1}},fieldSettings:{listValues:{plus:"+",minus:"-"}},spelEscapeForFormat:!1},val:{label:"Value",type:"number",fieldSettings:{min:0},defaultValue:0,valueSources:["value"],spelEscapeForFormat:!1},dim:{label:"Dimension",type:"select",defaultValue:"day",valueSources:["value"],mainWidgetProps:{customProps:{showSearch:!1}},fieldSettings:{listValues:{day:"day",week:"week",month:"month",year:"year"}},spelEscapeForFormat:!1}}},Wg={label:"Lowercase",mongoFunc:"$toLower",jsonLogic:"toLowerCase",spelFunc:"${str}.toLowerCase()",jsonLogicCustomOps:{toLowerCase:{}},returnType:"text",args:{str:{label:"String",type:"text",valueSources:["value","field","func"]}}},zg={label:"Uppercase",mongoFunc:"$toUpper",jsonLogic:"toUpperCase",spelFunc:"${str}.toUpperCase()",jsonLogicCustomOps:{toUpperCase:{}},returnType:"text",args:{str:{label:"String",type:"text",valueSources:["value","field","func"]}}},$g={label:"Linear regression",returnType:"number",formatFunc:function(e,t){var r=e.coef,n=e.bias,o=e.val;return"(".concat(r," * ").concat(o," + ").concat(n,")")},sqlFormatFunc:function(e){var t=e.coef,r=e.bias,n=e.val;return"(".concat(t," * ").concat(n," + ").concat(r,")")},spelFormatFunc:function(e){var t=e.coef,r=e.bias,n=e.val;return"(".concat(t," * ").concat(n," + ").concat(r,")")},spelImport:function(e){var t,r;if("op-plus"===e.type){var n=Hn(e.children,2);if(r=n[0],t=n[1],"op-multiply"===r.type){var o=Hn(r.children,2);return{coef:o[0],val:o[1],bias:t}}}},mongoFormatFunc:function(e){var t=e.coef,r=e.bias;return{$sum:[{$multiply:[t,e.val]},r]}},jsonLogic:function(e){var t=e.coef,r=e.bias;return{"+":[{"*":[t,e.val]},r]}},jsonLogicImport:function(e){return[e["+"][0]["*"][0],e["+"][0]["*"][1],e["+"][1]]},renderBrackets:["",""],renderSeps:[" * "," + "],args:{coef:{label:"Coef",type:"number",defaultValue:1,valueSources:["value"]},val:{label:"Value",type:"number",valueSources:["value","field"]},bias:{label:"Bias",type:"number",defaultValue:0,valueSources:["value"]}}},Hg={utils:{SqlString:rc,moment:ju(),mongoFormatOp1:function(e,t,r,n,o,i,a,s,l,u,c,d){var p="string"!=typeof n||n.startsWith("$")?n:"$"+n,f=t(i,d);if(void 0!==f)return r?a||e&&"$eq"!=e?a?{$not:Gn({},e,[p,f])}:Gn({},n,{$not:Gn({},e,f)}):Gn({},n,{$ne:f}):a||e&&"$eq"!=e?a?Gn({},e,[p,f]):Gn({},n,Gn({},e,f)):Gn({},n,f)},mongoFormatOp2:function(e,t,r,n,o,i,a,s,l,u,c){var d="string"!=typeof r||r.startsWith("$")?r:"$"+r;return t?i?{$not:{$and:[Gn({},e[0],[d,o[0]]),Gn({},e[1],[d,o[1]])]}}:Gn({},r,{$not:Gn(Gn({},e[0],o[0]),e[1],o[1])}):i?{$and:[Gn({},e[0],[d,o[0]]),Gn({},e[1],[d,o[1]])]}:Gn({},r,Gn(Gn({},e[0],o[0]),e[1],o[1]))},mongoEmptyValue:oc,escapeRegExp:Nl,sqlEmptyValue:nc,stringifyForDisplay:uc,getTitleInListValues:su,spelEscape:ac,spelFixList:ic,wrapWithBrackets:cc}};const Yg=Hg;function Qg(e,t){(null==t||t>e.length)&&(t=e.length);for(var r=0,n=new Array(t);r<t;r++)n[r]=e[r];return n}function Xg(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);t&&(n=n.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),r.push.apply(r,n)}return r}function Jg(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{};t%2?Xg(Object(r),!0).forEach((function(t){Gn(e,t,r[t])})):Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(r)):Xg(Object(r)).forEach((function(t){Object.defineProperty(e,t,Object.getOwnPropertyDescriptor(r,t))}))}return e}var Zg={equal:{label:"==",labelForFormat:"==",sqlOp:"=",spelOp:"==",spelOps:["==","eq"],reversedOp:"not_equal",formatOp:function(e,t,r,n,o,i,a,s,l){var u=s?"=":i.label;return"boolean"==o&&s?"No"==r?"NOT ".concat(e):"".concat(e):"".concat(e," ").concat(u," ").concat(r)},mongoFormatOp:function(){for(var e,t=arguments.length,r=new Array(t),n=0;n<t;n++)r[n]=arguments[n];return(e=this.utils).mongoFormatOp1.apply(e,["$eq",function(e){return e},!1].concat(r))},jsonLogic:"==",elasticSearchQueryType:"term"},not_equal:{isNotOp:!0,label:"!=",labelForFormat:"!=",sqlOp:"<>",spelOp:"!=",spelOps:["!=","ne"],reversedOp:"equal",formatOp:function(e,t,r,n,o,i,a,s,l){return"boolean"==o&&s?"No"==r?"".concat(e):"NOT ".concat(e):"".concat(e," ").concat(i.label," ").concat(r)},mongoFormatOp:function(){for(var e,t=arguments.length,r=new Array(t),n=0;n<t;n++)r[n]=arguments[n];return(e=this.utils).mongoFormatOp1.apply(e,["$ne",function(e){return e},!1].concat(r))},jsonLogic:"!="},less:{label:"<",labelForFormat:"<",sqlOp:"<",spelOp:"<",spelOps:["<","lt"],reversedOp:"greater_or_equal",mongoFormatOp:function(){for(var e,t=arguments.length,r=new Array(t),n=0;n<t;n++)r[n]=arguments[n];return(e=this.utils).mongoFormatOp1.apply(e,["$lt",function(e){return e},!1].concat(r))},jsonLogic:"<",elasticSearchQueryType:"range"},less_or_equal:{label:"<=",labelForFormat:"<=",sqlOp:"<=",spelOp:"<=",spelOps:["<=","le"],reversedOp:"greater",mongoFormatOp:function(){for(var e,t=arguments.length,r=new Array(t),n=0;n<t;n++)r[n]=arguments[n];return(e=this.utils).mongoFormatOp1.apply(e,["$lte",function(e){return e},!1].concat(r))},jsonLogic:"<=",elasticSearchQueryType:"range"},greater:{label:">",labelForFormat:">",sqlOp:">",spelOp:">",spelOps:[">","gt"],reversedOp:"less_or_equal",mongoFormatOp:function(){for(var e,t=arguments.length,r=new Array(t),n=0;n<t;n++)r[n]=arguments[n];return(e=this.utils).mongoFormatOp1.apply(e,["$gt",function(e){return e},!1].concat(r))},jsonLogic:">",elasticSearchQueryType:"range"},greater_or_equal:{label:">=",labelForFormat:">=",sqlOp:">=",spelOp:">=",spelOps:[">=","ge"],reversedOp:"less",mongoFormatOp:function(){for(var e,t=arguments.length,r=new Array(t),n=0;n<t;n++)r[n]=arguments[n];return(e=this.utils).mongoFormatOp1.apply(e,["$gte",function(e){return e},!1].concat(r))},jsonLogic:">=",elasticSearchQueryType:"range"},like:{label:"Contains",labelForFormat:"Contains",reversedOp:"not_like",sqlOp:"LIKE",spelOp:"${0}.contains(${1})",valueTypes:["text"],mongoFormatOp:function(){for(var e,t=this,r=arguments.length,n=new Array(r),o=0;o<r;o++)n[o]=arguments[o];return(e=this.utils).mongoFormatOp1.apply(e,["$regex",function(e){return"string"==typeof e?t.utils.escapeRegExp(e):void 0},!1].concat(n))},jsonLogic:"in",_jsonLogicIsRevArgs:!0,valueSources:["value"],elasticSearchQueryType:"regexp"},not_like:{isNotOp:!0,label:"Not contains",reversedOp:"like",labelForFormat:"Not Contains",sqlOp:"NOT LIKE",mongoFormatOp:function(){for(var e,t=this,r=arguments.length,n=new Array(r),o=0;o<r;o++)n[o]=arguments[o];return(e=this.utils).mongoFormatOp1.apply(e,["$regex",function(e){return"string"==typeof e?t.utils.escapeRegExp(e):void 0},!0].concat(n))},valueSources:["value"]},starts_with:{label:"Starts with",labelForFormat:"Starts with",sqlOp:"LIKE",spelOp:"${0}.startsWith(${1})",mongoFormatOp:function(){for(var e,t=this,r=arguments.length,n=new Array(r),o=0;o<r;o++)n[o]=arguments[o];return(e=this.utils).mongoFormatOp1.apply(e,["$regex",function(e){return"string"==typeof e?"^"+t.utils.escapeRegExp(e):void 0},!1].concat(n))},jsonLogic:void 0,valueSources:["value"]},ends_with:{label:"Ends with",labelForFormat:"Ends with",sqlOp:"LIKE",spelOp:"${0}.endsWith(${1})",mongoFormatOp:function(){for(var e,t=this,r=arguments.length,n=new Array(r),o=0;o<r;o++)n[o]=arguments[o];return(e=this.utils).mongoFormatOp1.apply(e,["$regex",function(e){return"string"==typeof e?t.utils.escapeRegExp(e)+"$":void 0},!1].concat(n))},jsonLogic:void 0,valueSources:["value"]},between:{label:"Between",labelForFormat:"BETWEEN",sqlOp:"BETWEEN",cardinality:2,formatOp:function(e,t,r,n,o,i,a,s){var l=r.first(),u=r.get(1);return s?"".concat(e," BETWEEN ").concat(l," AND ").concat(u):"".concat(e," >= ").concat(l," && ").concat(e," <= ").concat(u)},spelFormatOp:function(e,t,r,n,o,i,a,s){var l=r[0],u=r[1];return"".concat(e," >= ").concat(l," && ").concat(e," <= ").concat(u)},mongoFormatOp:function(){for(var e,t=arguments.length,r=new Array(t),n=0;n<t;n++)r[n]=arguments[n];return(e=this.utils).mongoFormatOp2.apply(e,[["$gte","$lte"],!1].concat(r))},valueLabels:["Value from","Value to"],textSeparators:[null,"and"],reversedOp:"not_between",jsonLogic:"<=",validateValues:function(e){return null!=e[0]&&null!=e[1]?e[0]<=e[1]:null},elasticSearchQueryType:function(e){return"time"===e?"filter":"range"}},not_between:{isNotOp:!0,label:"Not between",labelForFormat:"NOT BETWEEN",sqlOp:"NOT BETWEEN",cardinality:2,formatOp:function(e,t,r,n,o,i,a,s){var l=r.first(),u=r.get(1);return s?"".concat(e," NOT BETWEEN ").concat(l," AND ").concat(u):"(".concat(e," < ").concat(l," || ").concat(e," > ").concat(u,")")},spelFormatOp:function(e,t,r,n,o,i,a,s){var l=r[0],u=r[1];return"(".concat(e," < ").concat(l," || ").concat(e," > ").concat(u,")")},mongoFormatOp:function(){for(var e,t=arguments.length,r=new Array(t),n=0;n<t;n++)r[n]=arguments[n];return(e=this.utils).mongoFormatOp2.apply(e,[["$gte","$lte"],!0].concat(r))},valueLabels:["Value from","Value to"],textSeparators:[null,"and"],reversedOp:"between",validateValues:function(e){return null!=e[0]&&null!=e[1]?e[0]<=e[1]:null}},is_empty:{label:"Is empty",labelForFormat:"IS EMPTY",cardinality:0,reversedOp:"is_not_empty",formatOp:function(e,t,r,n,o,i,a,s){return s?"".concat(e," IS EMPTY"):"!".concat(e)},sqlFormatOp:function(e,t,r,n,o,i,a,s){var l=this.utils.sqlEmptyValue(s);return"COALESCE(".concat(e,", ").concat(l,") = ").concat(l)},spelFormatOp:function(e,t,r,n,o,i,a,s){return"".concat(e," <= ''")},mongoFormatOp:function(){for(var e,t=this,r=arguments.length,n=new Array(r),o=0;o<r;o++)n[o]=arguments[o];return(e=this.utils).mongoFormatOp1.apply(e,["$in",function(e,r){return[t.utils.mongoEmptyValue(r),null]},!1].concat(n))},jsonLogic:"!"},is_not_empty:{isNotOp:!0,label:"Is not empty",labelForFormat:"IS NOT EMPTY",cardinality:0,reversedOp:"is_empty",formatOp:function(e,t,r,n,o,i,a,s){return s?"".concat(e," IS NOT EMPTY"):"!!".concat(e)},sqlFormatOp:function(e,t,r,n,o,i,a,s){var l=this.utils.sqlEmptyValue(s);return"COALESCE(".concat(e,", ").concat(l,") <> ").concat(l)},spelFormatOp:function(e,t,r,n,o,i,a,s){return"".concat(e," > ''")},mongoFormatOp:function(){for(var e,t=this,r=arguments.length,n=new Array(r),o=0;o<r;o++)n[o]=arguments[o];return(e=this.utils).mongoFormatOp1.apply(e,["$nin",function(e,r){return[t.utils.mongoEmptyValue(r),null]},!1].concat(n))},jsonLogic:"!!",elasticSearchQueryType:"exists"},is_null:{label:"Is null",labelForFormat:"IS NULL",sqlOp:"IS NULL",cardinality:0,reversedOp:"is_not_null",formatOp:function(e,t,r,n,o,i,a,s){return s?"".concat(e," IS NULL"):"!".concat(e)},spelFormatOp:function(e,t,r,n,o,i,a,s){return"".concat(e," == null")},mongoFormatOp:function(){for(var e,t=arguments.length,r=new Array(t),n=0;n<t;n++)r[n]=arguments[n];return(e=this.utils).mongoFormatOp1.apply(e,["$eq",function(e){return null},!1].concat(r))},jsonLogic:"=="},is_not_null:{label:"Is not null",labelForFormat:"IS NOT NULL",sqlOp:"IS NOT NULL",cardinality:0,reversedOp:"is_null",formatOp:function(e,t,r,n,o,i,a,s){return s?"".concat(e," IS NOT NULL"):"!!".concat(e)},spelFormatOp:function(e,t,r,n,o,i,a,s){return"".concat(e," != null")},mongoFormatOp:function(){for(var e,t=arguments.length,r=new Array(t),n=0;n<t;n++)r[n]=arguments[n];return(e=this.utils).mongoFormatOp1.apply(e,["$ne",function(e){return null},!1].concat(r))},jsonLogic:"!=",elasticSearchQueryType:"exists"},select_equals:{label:"==",labelForFormat:"==",sqlOp:"=",formatOp:function(e,t,r,n,o,i,a,s){var l=s?"=":"==";return"".concat(e," ").concat(l," ").concat(r)},spelOp:"==",spelOps:["==","eq"],mongoFormatOp:function(){for(var e,t=arguments.length,r=new Array(t),n=0;n<t;n++)r[n]=arguments[n];return(e=this.utils).mongoFormatOp1.apply(e,["$eq",function(e){return e},!1].concat(r))},reversedOp:"select_not_equals",jsonLogic:"==",elasticSearchQueryType:"term"},select_not_equals:{isNotOp:!0,label:"!=",labelForFormat:"!=",sqlOp:"<>",formatOp:function(e,t,r,n,o,i,a,s){return"".concat(e," != ").concat(r)},spelOp:"!=",spelOps:["!=","ne"],mongoFormatOp:function(){for(var e,t=arguments.length,r=new Array(t),n=0;n<t;n++)r[n]=arguments[n];return(e=this.utils).mongoFormatOp1.apply(e,["$ne",function(e){return e},!1].concat(r))},reversedOp:"select_equals",jsonLogic:"!="},select_any_in:{label:"Any in",labelForFormat:"IN",sqlOp:"IN",formatOp:function(e,t,r,n,o,i,a,s){return"value"==n?"".concat(e," IN (").concat(r.join(", "),")"):"".concat(e," IN (").concat(r,")")},sqlFormatOp:function(e,t,r,n,o,i,a,s){return"value"==n?"".concat(e," IN (").concat(r.join(", "),")"):void 0},valueTypes:["multiselect"],spelOp:"${1}.contains(${0})",mongoFormatOp:function(){for(var e,t=arguments.length,r=new Array(t),n=0;n<t;n++)r[n]=arguments[n];return(e=this.utils).mongoFormatOp1.apply(e,["$in",function(e){return e},!1].concat(r))},reversedOp:"select_not_any_in",jsonLogic:"in",elasticSearchQueryType:"term"},select_not_any_in:{isNotOp:!0,label:"Not in",labelForFormat:"NOT IN",sqlOp:"NOT IN",formatOp:function(e,t,r,n,o,i,a,s){return"value"==n?"".concat(e," NOT IN (").concat(r.join(", "),")"):"".concat(e," NOT IN (").concat(r,")")},sqlFormatOp:function(e,t,r,n,o,i,a,s){return"value"==n?"".concat(e," NOT IN (").concat(r.join(", "),")"):void 0},mongoFormatOp:function(){for(var e,t=arguments.length,r=new Array(t),n=0;n<t;n++)r[n]=arguments[n];return(e=this.utils).mongoFormatOp1.apply(e,["$nin",function(e){return e},!1].concat(r))},reversedOp:"select_any_in"},multiselect_contains:{label:"Contains",labelForFormat:"CONTAINS",formatOp:function(e,t,r,n,o,i,a,s){return"value"==n?"".concat(e," CONTAINS [").concat(r.join(", "),"]"):"".concat(e," CONTAINS ").concat(r)},reversedOp:"multiselect_not_contains",jsonLogic2:"some-in",jsonLogic:function(e,t,r){return{some:[e,{in:[{var:""},r]}]}},spelOp:"T(CollectionUtils).containsAny(${0}, ${1})",elasticSearchQueryType:"term",mongoFormatOp:function(){for(var e,t=arguments.length,r=new Array(t),n=0;n<t;n++)r[n]=arguments[n];return(e=this.utils).mongoFormatOp1.apply(e,["$in",function(e){return e},!1].concat(r))}},multiselect_not_contains:{isNotOp:!0,label:"Not contains",labelForFormat:"NOT CONTAINS",formatOp:function(e,t,r,n,o,i,a,s){return"value"==n?"".concat(e," NOT CONTAINS [").concat(r.join(", "),"]"):"".concat(e," NOT CONTAINS ").concat(r)},reversedOp:"multiselect_contains"},multiselect_equals:{label:"Equals",labelForFormat:"==",sqlOp:"=",formatOp:function(e,t,r,n,o,i,a,s){var l=s?"=":"==";return"value"==n?"".concat(e," ").concat(l," [").concat(r.join(", "),"]"):"".concat(e," ").concat(l," ").concat(r)},sqlFormatOp:function(e,t,r,n,o,i,a,s){var l=this;return"value"==n?"".concat(e," = '").concat(r.map((function(e){return l.utils.SqlString.trim(e)})).join(","),"'"):void 0},spelOp:"${0}.equals(${1})",mongoFormatOp:function(){for(var e,t=arguments.length,r=new Array(t),n=0;n<t;n++)r[n]=arguments[n];return(e=this.utils).mongoFormatOp1.apply(e,["$eq",function(e){return e},!1].concat(r))},reversedOp:"multiselect_not_equals",jsonLogic2:"all-in",jsonLogic:function(e,t,r){return{all:[e,{in:[{var:""},r]}]}},elasticSearchQueryType:"term"},multiselect_not_equals:{isNotOp:!0,label:"Not equals",labelForFormat:"!=",sqlOp:"<>",formatOp:function(e,t,r,n,o,i,a,s){return"value"==n?"".concat(e," != [").concat(r.join(", "),"]"):"".concat(e," != ").concat(r)},sqlFormatOp:function(e,t,r,n,o,i,a,s){var l=this;return"value"==n?"".concat(e," != '").concat(r.map((function(e){return l.utils.SqlString.trim(e)})).join(","),"'"):void 0},mongoFormatOp:function(){for(var e,t=arguments.length,r=new Array(t),n=0;n<t;n++)r[n]=arguments[n];return(e=this.utils).mongoFormatOp1.apply(e,["$ne",function(e){return e},!1].concat(r))},reversedOp:"multiselect_equals"},proximity:{label:"Proximity search",cardinality:2,valueLabels:[{label:"Word 1",placeholder:"Enter first word"},{label:"Word 2",placeholder:"Enter second word"}],textSeparators:[],formatOp:function(e,t,r,n,o,i,a,s){var l=r.first(),u=r.get(1),c=null==a?void 0:a.get("proximity");return"".concat(e," ").concat(l," NEAR/").concat(c," ").concat(u)},sqlFormatOp:function(e,t,r,n,o,i,a,s){var l=r.first(),u=r.get(1),c=this.utils.SqlString.trim(l),d=this.utils.SqlString.trim(u),p=null==a?void 0:a.get("proximity");return"CONTAINS(".concat(e,", 'NEAR((").concat(c,", ").concat(d,"), ").concat(p,")')")},mongoFormatOp:void 0,jsonLogic:void 0,options:{optionLabel:"Near",optionTextBefore:"Near",optionPlaceholder:"Select words between",minProximity:2,maxProximity:10,defaults:{proximity:2}}},some:{label:"Some",labelForFormat:"SOME",cardinality:0,jsonLogic:"some",spelFormatOp:function(e){return"".concat(e," > 0")},mongoFormatOp:function(){for(var e,t=arguments.length,r=new Array(t),n=0;n<t;n++)r[n]=arguments[n];return(e=this.utils).mongoFormatOp1.apply(e,["$gt",function(e){return 0},!1].concat(r))}},all:{label:"All",labelForFormat:"ALL",cardinality:0,jsonLogic:"all",spelFormatOp:function(e,t,r){return"".concat(e," == ").concat(r)},mongoFormatOp:function(){for(var e,t=arguments.length,r=new Array(t),n=0;n<t;n++)r[n]=arguments[n];return(e=this.utils).mongoFormatOp1.apply(e,["$eq",function(e){return e},!1].concat(r))}},none:{label:"None",labelForFormat:"NONE",cardinality:0,jsonLogic:"none",spelFormatOp:function(e){return"".concat(e," == 0")},mongoFormatOp:function(){for(var e,t=arguments.length,r=new Array(t),n=0;n<t;n++)r[n]=arguments[n];return(e=this.utils).mongoFormatOp1.apply(e,["$eq",function(e){return 0},!1].concat(r))}}},ey={text:{type:"text",jsType:"string",valueSrc:"value",valueLabel:"String",valuePlaceholder:"Enter string",formatValue:function(e,t,r,n){return n?this.utils.stringifyForDisplay(e):JSON.stringify(e)},spelFormatValue:function(e,t,r,n,o){return this.utils.spelEscape(e)},sqlFormatValue:function(e,t,r,n,o){return"LIKE"==o.sqlOp||"NOT LIKE"==o.sqlOp?this.utils.SqlString.escapeLike(e,"starts_with"!=n,"ends_with"!=n):this.utils.SqlString.escape(e)},toJS:function(e,t){return e},mongoFormatValue:function(e,t,r){return e}},textarea:{type:"text",jsType:"string",valueSrc:"value",valueLabel:"Text",valuePlaceholder:"Enter text",formatValue:function(e,t,r,n){return n?this.utils.stringifyForDisplay(e):JSON.stringify(e)},sqlFormatValue:function(e,t,r,n,o){return"LIKE"==o.sqlOp||"NOT LIKE"==o.sqlOp?this.utils.SqlString.escapeLike(e,"starts_with"!=n,"ends_with"!=n):this.utils.SqlString.escape(e)},spelFormatValue:function(e){return this.utils.spelEscape(e)},toJS:function(e,t){return e},mongoFormatValue:function(e,t,r){return e},fullWidth:!0},number:{type:"number",jsType:"number",valueSrc:"value",valueLabel:"Number",valuePlaceholder:"Enter number",valueLabels:[{label:"Number from",placeholder:"Enter number from"},{label:"Number to",placeholder:"Enter number to"}],formatValue:function(e,t,r,n){return n?this.utils.stringifyForDisplay(e):JSON.stringify(e)},sqlFormatValue:function(e,t,r,n,o){return this.utils.SqlString.escape(e)},spelFormatValue:function(e,t,r){var n=r.step&&!Number.isInteger(r.step);return this.utils.spelEscape(e,n)},toJS:function(e,t){return e},mongoFormatValue:function(e,t,r){return e}},slider:{type:"number",jsType:"number",valueSrc:"value",valueLabel:"Number",valuePlaceholder:"Enter number or move slider",formatValue:function(e,t,r,n){return n?this.utils.stringifyForDisplay(e):JSON.stringify(e)},sqlFormatValue:function(e,t,r,n,o){return this.utils.SqlString.escape(e)},spelFormatValue:function(e){return this.utils.spelEscape(e)},toJS:function(e,t){return e},mongoFormatValue:function(e,t,r){return e}},select:{type:"select",jsType:"string",valueSrc:"value",valueLabel:"Value",valuePlaceholder:"Select value",formatValue:function(e,t,r,n){var o=this.utils.getTitleInListValues(t.fieldSettings.listValues||t.asyncListValues,e);return n?this.utils.stringifyForDisplay(o):JSON.stringify(e)},sqlFormatValue:function(e,t,r,n,o){return this.utils.SqlString.escape(e)},spelFormatValue:function(e){return this.utils.spelEscape(e)},toJS:function(e,t){return e},mongoFormatValue:function(e,t,r){return e}},multiselect:{type:"multiselect",jsType:"array",valueSrc:"value",valueLabel:"Values",valuePlaceholder:"Select values",formatValue:function(e,t,r,n){var o=this,i=e.map((function(e){return o.utils.getTitleInListValues(t.fieldSettings.listValues||t.asyncListValues,e)}));return n?i.map(this.utils.stringifyForDisplay):e.map(JSON.stringify)},sqlFormatValue:function(e,t,r,n,o){var i=this;return e.map((function(e){return i.utils.SqlString.escape(e)}))},spelFormatValue:function(e,t,r,n,o){var i=o&&o.spelOp&&o.spelOp.startsWith("${1}"),a=this.utils.spelEscape(e);return i&&(a=this.utils.spelFixList(a)),a},toJS:function(e,t){return e},mongoFormatValue:function(e,t,r){return e}},date:{type:"date",jsType:"string",valueSrc:"value",dateFormat:"DD.MM.YYYY",valueFormat:"YYYY-MM-DD",valueLabel:"Date",valuePlaceholder:"Enter date",valueLabels:[{label:"Date from",placeholder:"Enter date from"},{label:"Date to",placeholder:"Enter date to"}],formatValue:function(e,t,r,n){var o=this.utils.moment(e,r.valueFormat);return n?o.format(r.dateFormat):JSON.stringify(e)},sqlFormatValue:function(e,t,r,n,o){var i=this.utils.moment(e,r.valueFormat);return this.utils.SqlString.escape(i.format("YYYY-MM-DD"))},spelFormatValue:function(e,t,r,n,o){var i=this.utils.moment(e,r.valueFormat).format("YYYY-MM-DD");return"T(java.time.LocalDate).parse('".concat(i,"', T(java.time.format.DateTimeFormatter).ofPattern('").concat("yyyy-MM-dd","'))")},spelImportFuncs:[{obj:{cls:["java","time","LocalDate"]},methodName:"parse",args:[{var:"v"},{obj:{cls:["java","time","format","DateTimeFormatter"]},methodName:"ofPattern",args:[{var:"fmt"}]}]}],spelImportValue:function(e,t,r){var n,o,i,a;if(!t)return[void 0,"No widget def to get value format"];if(null!=r&&null!==(n=r.fmt)&&void 0!==n&&null!==(n=n.value)&&void 0!==n&&null!==(o=n.includes)&&void 0!==o&&o.call(n," ")||null!==(i=r.fmt)&&void 0!==i&&null!==(i=i.value)&&void 0!==i&&null!==(a=i.toLowerCase)&&void 0!==a&&a.call(i).includes("hh:mm"))return[void 0,"Invalid date format ".concat(JSON.stringify(r.fmt))];var s=this.utils.moment(e.value,this.utils.moment.ISO_8601);return s.isValid()?[s.format(null==t?void 0:t.valueFormat),[]]:[void 0,"Invalid date"]},jsonLogic:function(e,t,r){return this.utils.moment(e,r.valueFormat).toDate()},toJS:function(e,t){var r=this.utils.moment(e,t.valueFormat);return r.isValid()?r.toDate():void 0},mongoFormatValue:function(e,t,r){var n=this.utils.moment(e,r.valueFormat);return n.isValid()?n.toDate():void 0}},time:{type:"time",jsType:"string",valueSrc:"value",timeFormat:"HH:mm",valueFormat:"HH:mm:ss",use12Hours:!1,valueLabel:"Time",valuePlaceholder:"Enter time",valueLabels:[{label:"Time from",placeholder:"Enter time from"},{label:"Time to",placeholder:"Enter time to"}],formatValue:function(e,t,r,n){var o=this.utils.moment(e,r.valueFormat);return n?o.format(r.timeFormat):JSON.stringify(e)},sqlFormatValue:function(e,t,r,n,o){var i=this.utils.moment(e,r.valueFormat);return this.utils.SqlString.escape(i.format("HH:mm:ss"))},spelFormatValue:function(e,t,r,n,o){var i=this.utils.moment(e,r.valueFormat).format("HH:mm:ss");return"T(java.time.LocalTime).parse('".concat(i,"')")},spelImportFuncs:["T(java.time.LocalTime).parse(${v})"],spelImportValue:function(e,t,r){var n,o,i;if(!t)return[void 0,"No widget def to get value format"];if(null!=r&&r.fmt&&(null===(n=r.fmt)||void 0===n||null===(n=n.value)||void 0===n||null===(o=n.toLowerCase)||void 0===o||!o.call(n).includes("hh:mm")||null!==(i=r.fmt)&&void 0!==i&&null!==(i=i.value)&&void 0!==i&&i.includes(" ")))return[void 0,"Invalid time format ".concat(JSON.stringify(r.fmt))];var a=this.utils.moment(e.value,"HH:mm:ss");return a.isValid()?[a.format(null==t?void 0:t.valueFormat),[]]:[void 0,"Invalid date"]},jsonLogic:function(e,t,r){var n=this.utils.moment(e,r.valueFormat);return 60*n.get("hour")*60+60*n.get("minute")+n.get("second")},toJS:function(e,t){var r=this.utils.moment(e,t.valueFormat);return r.isValid()?60*r.get("hour")*60+60*r.get("minute")+r.get("second"):void 0},mongoFormatValue:function(e,t,r){var n=this.utils.moment(e,r.valueFormat);return 60*n.get("hour")*60+60*n.get("minute")+n.get("second")},elasticSearchFormatValue:function(e,t,r,n){return{script:{script:{source:"doc[".concat(n,"][0].getHour() >== params.min && doc[").concat(n,"][0].getHour() <== params.max"),params:{min:t[0],max:t[1]}}}}}},datetime:{type:"datetime",jsType:"string",valueSrc:"value",timeFormat:"HH:mm",dateFormat:"DD.MM.YYYY",valueFormat:"YYYY-MM-DD HH:mm:ss",use12Hours:!1,valueLabel:"Datetime",valuePlaceholder:"Enter datetime",valueLabels:[{label:"Datetime from",placeholder:"Enter datetime from"},{label:"Datetime to",placeholder:"Enter datetime to"}],formatValue:function(e,t,r,n){var o=this.utils.moment(e,r.valueFormat);return n?o.format(r.dateFormat+" "+r.timeFormat):JSON.stringify(e)},sqlFormatValue:function(e,t,r,n,o){var i=this.utils.moment(e,r.valueFormat);return this.utils.SqlString.escape(i.toDate())},spelFormatValue:function(e,t,r,n,o){var i=this.utils.moment(e,r.valueFormat).format("YYYY-MM-DD HH:mm:ss");return"T(java.time.LocalDateTime).parse('".concat(i,"', T(java.time.format.DateTimeFormatter).ofPattern('").concat("yyyy-MM-dd HH:mm:ss","'))")},spelImportFuncs:[{obj:{cls:["java","time","LocalDateTime"]},methodName:"parse",args:[{var:"v"},{obj:{cls:["java","time","format","DateTimeFormatter"]},methodName:"ofPattern",args:[{var:"fmt"}]}]}],spelImportValue:function(e,t,r){var n,o;if(!t)return[void 0,"No widget def to get value format"];if(null==r||null===(n=r.fmt)||void 0===n||null===(n=n.value)||void 0===n||null===(o=n.includes)||void 0===o||!o.call(n," "))return[void 0,"Invalid datetime format ".concat(JSON.stringify(r.fmt))];var i=this.utils.moment(e.value,this.utils.moment.ISO_8601);return i.isValid()?[i.format(null==t?void 0:t.valueFormat),[]]:[void 0,"Invalid date"]},jsonLogic:function(e,t,r){return this.utils.moment(e,r.valueFormat).toDate()},toJS:function(e,t){var r=this.utils.moment(e,t.valueFormat);return r.isValid()?r.toDate():void 0},mongoFormatValue:function(e,t,r){var n=this.utils.moment(e,r.valueFormat);return n.isValid()?n.toDate():void 0}},boolean:{type:"boolean",jsType:"boolean",valueSrc:"value",labelYes:"Yes",labelNo:"No",formatValue:function(e,t,r,n){return n?e?"Yes":"No":JSON.stringify(!!e)},sqlFormatValue:function(e,t,r,n,o){return this.utils.SqlString.escape(e)},spelFormatValue:function(e,t,r,n,o){return this.utils.spelEscape(e)},defaultValue:!1,toJS:function(e,t){return e},mongoFormatValue:function(e,t,r){return e}},field:{valueSrc:"field",formatValue:function(e,t,r,n,o,i,a){return n&&a.label||e},sqlFormatValue:function(e,t,r,n,o,i){return e},spelFormatValue:function(e,t,r,n,o){return e},valueLabel:"Field to compare",valuePlaceholder:"Select field to compare"},func:{valueSrc:"func",valueLabel:"Function",valuePlaceholder:"Select function"},case_value:{valueSrc:"value",type:"case_value",spelFormatValue:function(e){return this.utils.spelEscape(""===e?null:e)},spelImportValue:function(e){return[e.value,[]]},jsonLogic:function(e){return""===e?null:e}}},ty=Jg(Jg({},Gh),{},{convertableWidgets:{number:["slider","rangeslider"],slider:["number","rangeslider"],rangeslider:["number","slider"],text:["textarea"],textarea:["text"]},formatSpelField:function(e,t,r,n,o,i){var a=this,s=n.map((function(e,t){var r=e.key,n=e.parent,o=e.fieldSeparator;return 0==t?"[map]"==n?"#this[".concat(a.utils.spelEscape(r),"]"):r:"map"==n||"[map]"==n?"[".concat(a.utils.spelEscape(r),"]"):"".concat(o).concat(r)})).join("");return o.fieldName&&(s=e),o.isSpelVariable&&(s="#"+s),s},sqlFormatReverse:function(e){if(null!=e)return"NOT"+this.utils.wrapWithBrackets(e)},spelFormatReverse:function(e){if(null!=e)return"!"+this.utils.wrapWithBrackets(e)},formatReverse:function(e,t,r,n,o,i){if(null!=e)return i?"NOT "+this.utils.wrapWithBrackets(e):"!"+this.utils.wrapWithBrackets(e)},formatAggr:function(e,t,r,n,o,i,a,s,l,u){var c=a.labelForFormat,d=a.cardinality;if(0==d){var p=e?" HAVE ".concat(e):"";return"".concat(c," OF ").concat(t).concat(p)}if(null==d||1==d){var f=e?" WHERE ".concat(e):"";return"COUNT OF ".concat(t).concat(f," ").concat(c," ").concat(n)}if(2==d){var h=e?" WHERE ".concat(e):"",v=n.first(),g=n.get(1);return"COUNT OF ".concat(t).concat(h," ").concat(c," ").concat(v," AND ").concat(g)}},jsonLogic:{groupVarKey:"var",altVarKey:"var",lockedOp:"locked"},canCompareFieldWithField:function(e,t,r,n){return!0},valueSourcesInfo:{value:{label:"Value"},field:{label:"Field",widget:"field"},func:{label:"Function",widget:"func"}}}),ry=function(e,t){var r,n=!(arguments.length>2&&void 0!==arguments[2])||arguments[2],o={rangeslider:iy,treeselect:ay,treemultiselect:sy,rangeable__date:oy("date","date")},i=function(e,t){var r="undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(!r){if(Array.isArray(e)||(r=function(e,t){if(e){if("string"==typeof e)return Qg(e,t);var r=Object.prototype.toString.call(e).slice(8,-1);return"Object"===r&&e.constructor&&(r=e.constructor.name),"Map"===r||"Set"===r?Array.from(e):"Arguments"===r||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(r)?Qg(e,t):void 0}}(e))||t&&e&&"number"==typeof e.length){r&&(e=r);var n=0,o=function(){};return{s:o,n:function(){return n>=e.length?{done:!0}:{done:!1,value:e[n++]}},e:function(e){throw e},f:o}}throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}var i,a=!0,s=!1;return{s:function(){r=r.call(e)},n:function(){var e=r.next();return a=e.done,e},e:function(e){s=!0,i=e},f:function(){try{a||null==r.return||r.return()}finally{if(s)throw i}}}}(t);try{for(i.s();!(r=i.n()).done;){var a=r.value,s=o[a];if(!s)throw new Error("Can't ".concat(n?"add":"remove"," mixin ").concat(a));e=s(e,n)}}catch(e){i.e(e)}finally{i.f()}return e},ny=function(e,t){return ry(e,t,!0)},oy=function(e,t){return function(r){var n=!(arguments.length>1&&void 0!==arguments[1])||arguments[1],o=r.types;return o=Jg(Jg({},o),{},Gn({},e,Jg(Jg({},o[e]),{},{widgets:Jg({},o[e].widgets)}))),n?o[e].widgets[t]=Jg({opProps:{between:{isSpecialRange:!0,textSeparators:[null,null]},not_between:{isSpecialRange:!0,textSeparators:[null,null]}}},o[e].widgets[t]):delete o[e].widgets[t],Jg(Jg({},r),{},{types:o})}},iy=function(e){var t=!(arguments.length>1&&void 0!==arguments[1])||arguments[1],r=e.widgets,n=e.types;return r=Jg({},r),t?r.rangeslider=Jg({type:"number",jsType:"number",valueSrc:"value",valueLabel:"Range",valuePlaceholder:"Select range",valueLabels:[{label:"Number from",placeholder:"Enter number from"},{label:"Number to",placeholder:"Enter number to"}],formatValue:function(e,t,r,n){return n?this.utils.stringifyForDisplay(e):JSON.stringify(e)},sqlFormatValue:function(e,t,r,n,o){return this.utils.SqlString.escape(e)},spelFormatValue:function(e){return this.utils.spelEscape(e)},singleWidget:"slider",toJS:function(e,t){return e}},r.rangeslider):delete r.rangeslider,n=Jg(Jg({},n),{},{number:Jg(Jg({},n.number),{},{widgets:Jg({},n.number.widgets)})}),t?n.number.widgets.rangeslider=Jg({opProps:{between:{isSpecialRange:!0},not_between:{isSpecialRange:!0}},operators:["between","not_between","is_null","is_not_null"]},n.number.widgets.rangeslider):delete n.number.widgets.rangeslider,Jg(Jg({},e),{},{widgets:r,types:n})},ay=function(e){var t=!(arguments.length>1&&void 0!==arguments[1])||arguments[1],r=e.widgets,n=e.types;return r=Jg({},r),t?r.treeselect=Jg({type:"treeselect",jsType:"string",valueSrc:"value",valueLabel:"Value",valuePlaceholder:"Select value",formatValue:function(e,t,r,n){var o=t.fieldSettings.treeValues||t.fieldSettings.listValues||t.asyncListValues,i=this.utils.getTitleInListValues(o,e);return n?this.utils.stringifyForDisplay(i):JSON.stringify(e)},sqlFormatValue:function(e,t,r,n,o){return this.utils.SqlString.escape(e)},spelFormatValue:function(e){return this.utils.spelEscape(e)},toJS:function(e,t){return e}},r.treeselect):delete r.treeselect,n=Jg({},n),t?n.treeselect=Jg({mainWidget:"treeselect",defaultOperator:"select_equals",widgets:{treeselect:{operators:["select_equals","select_not_equals"]},treemultiselect:{operators:["select_any_in","select_not_any_in"]}}},n.treeselect):delete n.treeselect,Jg(Jg({},e),{},{widgets:r,types:n})},sy=function(e){var t=!(arguments.length>1&&void 0!==arguments[1])||arguments[1],r=e.widgets,n=e.types;return r=Jg({},r),t?r.treemultiselect=Jg({type:"treemultiselect",jsType:"array",valueSrc:"value",valueLabel:"Values",valuePlaceholder:"Select values",formatValue:function(e,t,r,n){var o=this,i=t.fieldSettings.treeValues||t.fieldSettings.listValues||t.asyncListValues,a=e.map((function(e){return o.utils.getTitleInListValues(i,e)}));return n?a.map(this.utils.stringifyForDisplay):e.map(JSON.stringify)},sqlFormatValue:function(e,t,r,n,o){var i=this;return e.map((function(e){return i.utils.SqlString.escape(e)}))},spelFormatValue:function(e){return this.utils.spelEscape(e)},toJS:function(e,t){return e}},r.treemultiselect):delete r.treemultiselect,n=Jg({},n),t?n.treemultiselect=Jg({defaultOperator:"multiselect_equals",widgets:{treemultiselect:{operators:["multiselect_equals","multiselect_not_equals"]}}},n.treemultiselect):delete n.treemultiselect,Jg(Jg({},e),{},{widgets:r,types:n})},ly={addMixins:ny,removeMixins:function(e,t){return ry(e,t,!1)}},uy={conjunctions:{AND:{label:"And",mongoConj:"$and",jsonLogicConj:"and",sqlConj:"AND",spelConj:"and",spelConjs:["and","&&"],reversedConj:"OR",formatConj:function(e,t,r,n){var o=e.size>1?e.join(" "+(n?"AND":"&&")+" "):e.first();return(e.size>1||r)&&(o=this.utils.wrapWithBrackets(o)),r&&(o="NOT "+o),o},sqlFormatConj:function(e,t,r){var n=e.size>1?e.join(" AND "):e.first();return(e.size>1||r)&&(n=this.utils.wrapWithBrackets(n)),r&&(n="NOT "+n),n},spelFormatConj:function(e,t,r,n){r&&(n=!1);var o=e.size>1?e.join(" && "):e.first();return(e.size>1||r)&&!n&&(o=this.utils.wrapWithBrackets(o)),r&&(o="!"+o),o}},OR:{label:"Or",mongoConj:"$or",jsonLogicConj:"or",sqlConj:"OR",spelConj:"or",spelConjs:["or","||"],reversedConj:"AND",formatConj:function(e,t,r,n){return e.size>1?(r?"NOT ":"")+"("+e.join(" "+(n?"OR":"||")+" ")+")":(r?"NOT (":"")+e.first()+(r?")":"")},sqlFormatConj:function(e,t,r){return e.size>1?(r?"NOT ":"")+"("+e.join(" OR ")+")":(r?"NOT (":"")+e.first()+(r?")":"")},spelFormatConj:function(e,t,r,n){return r&&(n=!1),e.size>1?(r?"!":"")+(n?"":"(")+e.join(" || ")+(n?"":")"):(r?"!(":"")+e.first()+(r?")":"")}}},operators:Zg,widgets:ey,types:{text:{defaultOperator:"equal",mainWidget:"text",widgets:{text:{operators:["equal","not_equal","like","not_like","starts_with","ends_with","proximity","is_empty","is_not_empty","is_null","is_not_null"],widgetProps:{},opProps:{}},textarea:{operators:["equal","not_equal","like","not_like","starts_with","ends_with","is_empty","is_not_empty","is_null","is_not_null"],widgetProps:{},opProps:{}},field:{operators:["equal","not_equal","proximity"]}}},number:{defaultOperator:"equal",mainWidget:"number",widgets:{number:{operators:["equal","not_equal","less","less_or_equal","greater","greater_or_equal","between","not_between","is_null","is_not_null"]},slider:{operators:["equal","not_equal","less","less_or_equal","greater","greater_or_equal","is_null","is_not_null"]}}},date:{defaultOperator:"equal",widgets:{date:{operators:["equal","not_equal","less","less_or_equal","greater","greater_or_equal","between","not_between","is_null","is_not_null"]}}},time:{defaultOperator:"equal",widgets:{time:{operators:["equal","not_equal","less","less_or_equal","greater","greater_or_equal","between","not_between","is_null","is_not_null"]}}},datetime:{defaultOperator:"equal",widgets:{datetime:{operators:["equal","not_equal","less","less_or_equal","greater","greater_or_equal","between","not_between","is_null","is_not_null"]}}},select:{mainWidget:"select",defaultOperator:"select_equals",widgets:{select:{operators:["select_equals","select_not_equals","is_null","is_not_null"]},multiselect:{operators:["select_any_in","select_not_any_in","is_null","is_not_null"]}}},multiselect:{defaultOperator:"multiselect_equals",widgets:{multiselect:{operators:["multiselect_contains","multiselect_not_contains","multiselect_equals","multiselect_not_equals","is_null","is_not_null"]}}},boolean:{defaultOperator:"equal",widgets:{boolean:{operators:["equal","not_equal","is_null","is_not_null"],widgetProps:{}},field:{operators:["equal","not_equal"]}}},"!group":{defaultOperator:"some",mainWidget:"number",widgets:{number:{widgetProps:{min:0},operators:["some","all","none","equal","not_equal","less","less_or_equal","greater","greater_or_equal","between","not_between"],opProps:{equal:{label:"Count =="},not_equal:{label:"Count !="},less:{label:"Count <"},less_or_equal:{label:"Count <="},greater:{label:"Count >"},greater_or_equal:{label:"Count >="},between:{label:"Count between"},not_between:{label:"Count not between"}}}}},case_value:{mainWidget:"case_value",widgets:{case_value:{widgetProps:{}}}}},settings:ty,ctx:Yg};const cy=uy=ny(uy,["rangeslider","treeselect","treemultiselect"]);var dy="ADD_GROUP",py="ADD_CASE_GROUP",fy="REMOVE_GROUP",hy="SET_CONJUNCTION",vy="SET_NOT",gy="ADD_RULE",yy="REMOVE_RULE",my="SET_FIELD",by="SET_FIELD_SRC",Oy="SET_OPERATOR",Ey="SET_VALUE",Sy="SET_VALUE_SRC",Ty="SET_FUNC_VALUE",_y="SET_OPERATOR_OPTION",wy="SET_LOCK",Ry="SET_TREE",Ay="MOVE_ITEM",Cy="after",Iy="before",xy="append",Ly="prepend",Ny="SET_DRAG_PROGRESS",jy="SET_DRAG_START",Py="SET_DRAG_END",ky=p(1612),Fy=p.n(ky);function Dy(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);t&&(n=n.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),r.push.apply(r,n)}return r}function My(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{};t%2?Dy(Object(r),!0).forEach((function(t){Gn(e,t,r[t])})):Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(r)):Dy(Object(r)).forEach((function(t){Object.defineProperty(e,t,Object.getOwnPropertyDescriptor(r,t))}))}return e}function Vy(e,t){var r="undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(!r){if(Array.isArray(e)||(r=function(e,t){if(e){if("string"==typeof e)return Uy(e,t);var r=Object.prototype.toString.call(e).slice(8,-1);return"Object"===r&&e.constructor&&(r=e.constructor.name),"Map"===r||"Set"===r?Array.from(e):"Arguments"===r||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(r)?Uy(e,t):void 0}}(e))||t&&e&&"number"==typeof e.length){r&&(e=r);var n=0,o=function(){};return{s:o,n:function(){return n>=e.length?{done:!0}:{done:!1,value:e[n++]}},e:function(e){throw e},f:o}}throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}var i,a=!0,s=!1;return{s:function(){r=r.call(e)},n:function(){var e=r.next();return a=e.done,e},e:function(e){s=!0,i=e},f:function(){try{a||null==r.return||r.return()}finally{if(s)throw i}}}}function Uy(e,t){(null==t||t>e.length)&&(t=e.length);for(var r=0,n=new Array(t);r<t;r++)n[r]=e[r];return n}var By=function(e,t,r,n,o,i){var a,s=arguments.length>6&&void 0!==arguments[6]?arguments[6]:null,l=arguments.length>7&&void 0!==arguments[7]?arguments[7]:{};if(!e.getIn(pu(t)))return e;var u=(null==o||null===(a=o.get)||void 0===a?void 0:a.call(o,"id"))||n,c=i.settings.shouldCreateEmptyGroup,d=t.push(u),p=!c,f=!(null==l||!l.isDefaultCase),h=e;return(e=qy(e,t,r,u,vd(i).merge(fl(o)||{}),i,s))!==h&&(s||f||(e=e.setIn(pu(d,"children1"),new gl.OrderedMap),p&&(e=qy(e,d,"rule",ml(),pd(i),i))),e=gu(e)),e},qy=function(e,t,r,n,o,i){var a,s=arguments.length>6&&void 0!==arguments[6]?arguments[6]:null;if("switch_group"===r)throw new Error("Can't add switch_group programmatically");var l=e.getIn(pu(t));if(!l)return e;var u,c,d=(null==o||null===(a=o.get)||void 0===a?void 0:a.call(o,"id"))||n,p=i.settings,f=p.maxNumberOfCases,h=p.maxNumberOfRules,v=p.maxNesting,g="switch_group"===e.get("type"),y=g?e.getIn(pu(t.take(2))):null,m=pu(t,"children1"),b=e.getIn(m),O=!!b&&b.size,E=O?b.size:null;"case_group"===r?(u=E,c=f):"group"===r?(u=t.size,c=v):"rule_group"===(null==l?void 0:l.get("type"))||(u=Ou(g?y:e),c=h);var S=!c||!u||u<c,T={type:r,id:d,properties:o};$y(i,T,s);var _="case_group"===r&&O&&null==b.last().get("children1");if(S){var w=new gl.OrderedMap(Gn({},d,new gl.Map(T)));if(O)if(_){var R=b.last(),A=new gl.OrderedMap(Gn(Gn({},d,new gl.Map(T)),R.get("id"),R));e=(e=e.deleteIn(pu(m,"children1",R.get("id")))).mergeIn(m,A)}else e=e.mergeIn(m,w);else e=e.setIn(m,w);e=gu(e)}return e},Gy=function(e,t){return e=e.deleteIn(pu(t)),gu(e)},Ky=function(e,t,r,n,o){var i,a,s,l,u=arguments.length>5&&void 0!==arguments[5]?arguments[5]:{},c=e.getIn(pu(t));if(!c)return{state:e};var d=u.isEndValue,p=u.canDropArgs;if(!r)return{state:e=Gy(e,t)};var f=n.settings,h=f.fieldSeparator,v=f.setOpOnChangeField,g=f.showErrorMessage;Array.isArray(r)&&(r=r.join(h));var y=c.get("type"),m=c.get("properties"),b="rule_group"==y,O=null==m?void 0:m.get("fieldSrc"),E=Iv(n,r);if(!E)return console.warn("No config for LHS ".concat(r)),{state:e};var S=E.type;"!group"!==S&&"!struct"!==S||(S=null);var T=null==m?void 0:m.get("operator"),_=null==m?void 0:m.get("operatorOptions"),w=null==m?void 0:m.get("field"),R="!group"==E.type,A=R&&"array"==E.mode,C=b!=R,I=E&&-1!==(null===(i=E.operators)||void 0===i?void 0:i.indexOf(T))?T:null,x="func"===O&&(null==w||null===(a=w.get)||void 0===a?void 0:a.call(w,"func"))===(null===(s=r)||void 0===s||null===(l=s.get)||void 0===l?void 0:l.call(s,"func"))&&!!I,L=null,N="func"===O?Mf(n,S):Vf(n,r);if(N&&1==N.length)L=N[0];else if(x)L=I;else if(N&&N.length>1){var j,P=Vy(v);try{for(P.s();!(j=P.n()).done;){var k=j.value;if("keep"!=k||C?"default"==k?L=cd(n,r,!1):"first"==k&&(L=Uf(n,r)):L=I,L)break}}catch(e){P.e(e)}finally{P.f()}}if(!R&&!E.operators)return console.warn("Type ".concat(E.type," is not supported")),{state:e};b&&!R&&(e=(e=(e=e.setIn(pu(t,"type"),"rule")).deleteIn(pu(t,"children1"))).setIn(pu(t,"properties"),new gl.OrderedMap)),m||(e=e.setIn(pu(t,"properties"),new gl.OrderedMap));var F=!g;if(R){e=e.setIn(pu(t,"type"),"rule_group");var D=Af(n,n,m,r,L,"field",F,d,p),M=(D.canReuseValue,D.newValue),V=D.newValueSrc,U=D.newValueType,B=D.operatorCardinality,q=vd(n,E).merge({field:r,fieldSrc:"field",mode:E.mode});A&&(q=q.merge({operator:L,value:M,valueSrc:V,valueType:U})),e=(e=e.setIn(pu(t,"children1"),new gl.OrderedMap)).setIn(pu(t,"properties"),q),E.initialEmptyWhere&&1==B||(e=qy(e,t,"rule",ml(),pd(n,r),n)),e=gu(e)}else e=e.updateIn(pu(t,"properties"),(function(e){return e.withMutations((function(e){var t=Af(n,n,e,r,L,"field",F,d,p),o=t.canReuseValue,i=t.newValue,a=t.newValueSrc,s=t.newValueType,l=t.newValueError,u=t.newFieldError,c=t.fixedField,f=r;c!==r&&(f=c),g&&(e=(e=e.set("fieldError",u)).set("valueError",l));var h=o?_:dd(n,L,f);return e=e.set("field",f).delete("fieldType").set("fieldSrc",O).set("operator",L).set("operatorOptions",h).set("value",i).set("valueSrc",a).set("valueType",s),o||(e=e.delete("asyncListValues")),e}))}));return{state:e}},Wy=function(e,t,r,n,o,i,a){var s=arguments.length>7&&void 0!==arguments[7]?arguments[7]:{};if(!e.getIn(pu(t)))return{state:e};var l=s.canDropArgs,u=s.isEndValue,c=i.settings,d=c.fieldSeparator,p=c.showErrorMessage,f=e.getIn(pu(t,"properties","valueSrc",r+""))||null;"field"===f&&Array.isArray(n)&&(n=n.join(d));var h=e.getIn(pu(t,"properties","field"))||null,v=e.getIn(pu(t,"properties","operator"))||null,g=xv(i,v,h),y=v?wl(g):null,m=o||Bf(n,f,i),b=Hn(Sf(i,h,h,v,n,m,f,a,!p,u,l),2),O=b[0],E=b[1],S=null==E?void 0:E.find((function(e){return!e.fixed&&!e.ignore})),T=S?af(S):null,_=O!==n;_&&(n=O),e=zy(e,t,i,y);var w=Array.from({length:y},(function(o,i){return i==r?n:e.getIn(pu(t,"properties","value",i+""))||null})),R=Array.from({length:y},(function(r,n){return e.getIn(pu(t,"properties","valueSrc",n+""))||null})),A=Rf(i,h,v,w,R),C=A?af(A):null;return(!!p||!T&&!C||_)&&(e=e.deleteIn(pu(t,"properties","asyncListValues")),void 0===n?e=(e=e.setIn(pu(t,"properties","value",r),void 0)).setIn(pu(t,"properties","valueType",r),null):(a&&(e=e.setIn(pu(t,"properties","asyncListValues"),a)),e=(e=e.setIn(pu(t,"properties","value",r),n)).setIn(pu(t,"properties","valueType",r),m))),p&&(e.getIn(pu(t,"properties","valueError"))||(e=e.setIn(pu(t,"properties","valueError"),new gl.List(new Array(y)))),e=e.setIn(pu(t,"properties","valueError",r),T),y>=2&&(e=e.setIn(pu(t,"properties","valueError",y),C))),{state:e}},zy=function(e,t,r,n){if(!n){var o=e.getIn(pu(t,"properties","field"))||null,i=e.getIn(pu(t,"properties","operator"))||null,a=xv(r,i,o);n=i?wl(a):null}for(var s=0,l=["value","valueType","valueError","valueSrc"];s<l.length;s++){var u=l[s];e.getIn(pu(t,"properties",u))||(e=e.setIn(pu(t,"properties",u),new gl.List(n?Array.from({length:n}):[])))}return e},$y=function e(t,r,n){n&&Array.isArray(n)&&(r.children1=new gl.OrderedMap(n.reduce((function(r,n){var o,i=null!==(o=n.id)&&void 0!==o?o:ml(),a=My(My({},n),{},{properties:gd(t,n).merge(fl(n.properties)||{}),id:i});return e(t,a,a.children1),My(My({},r),{},Gn({},i,new gl.Map(a)))}),{})))},Hy={dragging:{id:null,x:null,y:null,w:null,h:null},mousePos:{},dragStart:{id:null}},Yy=function(e,t){return{type:Ry,tree:t,config:e}},Qy=function(e,t,r){var n=arguments.length>5&&void 0!==arguments[5]?arguments[5]:null;return{type:gy,ruleType:arguments.length>3&&void 0!==arguments[3]?arguments[3]:"rule",children:arguments.length>4&&void 0!==arguments[4]?arguments[4]:null,path:xl(t),id:ml(),properties:pd(e,n).merge(fl(r)||{}),config:e}},Xy=function(e,t){return{type:yy,path:xl(t),config:e}},Jy=function(e,t,r){var n=arguments.length>3&&void 0!==arguments[3]?arguments[3]:null;return{type:py,path:xl(t),children:n,id:ml(),properties:vd(e).merge(fl(r)||{}),config:e,meta:{isDefaultCase:!0}}},Zy=function(e,t,r){var n=arguments.length>3&&void 0!==arguments[3]?arguments[3]:null;return{type:py,path:xl(t),children:n,id:ml(),properties:vd(e).merge(fl(r)||{}),config:e}},em=function(e,t,r){var n=arguments.length>3&&void 0!==arguments[3]?arguments[3]:null;return{type:dy,path:xl(t),children:n,id:ml(),properties:vd(e).merge(fl(r)||{}),config:e}},tm=function(e,t){return{type:fy,path:xl(t),config:e}},rm=function(e,t,r,n){return{type:Ay,fromPath:xl(t),toPath:xl(r),placement:n,config:e}},nm=function(e,t,r){return{type:hy,path:xl(t),conjunction:r}},om=function(e,t,r){return{type:vy,path:xl(t),not:r}},im=function(e,t,r){return{type:wy,path:xl(t),lock:r}},am=function(e,t,r,n,o){return{type:my,path:xl(t),field:r,config:e,asyncListValues:n,_meta:o}},sm=function(e,t,r){return{type:by,path:xl(t),srcKey:r,config:e}},lm=function(e,t,r){return{type:Oy,path:xl(t),operator:r,config:e}},um=function(e,t,r,n,o,i,a){return{type:Ey,path:xl(t),delta:r,value:n,valueType:o,asyncListValues:i,config:e,_meta:a}},cm=function(e,t,r,n,o){return{type:Sy,path:xl(t),delta:r,srcKey:n,config:e,_meta:o}},dm=function(e,t,r,n,o,i,a,s,l){return{type:Ty,path:xl(t),delta:r,parentFuncs:n,argKey:o,value:i,valueType:a,asyncListValues:s,config:e,_meta:l}},pm=function(e,t,r,n){return{type:_y,path:xl(t),name:r,value:n,config:e}};function fm(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);t&&(n=n.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),r.push.apply(r,n)}return r}function hm(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{};t%2?fm(Object(r),!0).forEach((function(t){Gn(e,t,r[t])})):Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(r)):fm(Object(r)).forEach((function(t){Object.defineProperty(e,t,Object.getOwnPropertyDescriptor(r,t))}))}return e}var vm=hm(hm(hm({},h),{},{Export:c,Import:o,ConfigMixins:ly},c),o),gm=p(7028),ym=p.n(gm);const mm=function(e,t,r,n,o){var i=My({tree:t},Hy);return function(){var t,a,s=arguments.length>0&&void 0!==arguments[0]?arguments[0]:i,l=arguments.length>1?arguments[1]:void 0,u=null!==(t=null!==(a=null==o?void 0:o())&&void 0!==a?a:null==l?void 0:l.config)&&void 0!==t?t:e,c={},d=function(e,t){if(!e||!e.type)return null;var r,n=[Ry,jy,Ny,Py],o=Fy()(Jl()(e,["config","asyncListValues"]),Ll),i=e.path&&function(e,t){return e.getIn(pu(t,"properties","field"))||null}(t.tree,e.path)||e.field;return i&&(null!==(r=i)&&void 0!==r&&r.toJS&&(i=i.toJS()),o.affectedField=i),(n.includes(e.type)||0==e.type.indexOf("@@redux"))&&(o=null),o}(l,s);switch(null==l?void 0:l.type){case Ry:var p=r(u,l.tree);c.tree=p;break;case py:c.tree=By(s.tree,l.path,"case_group",l.id,l.properties,u,l.children,l.meta);break;case dy:c.tree=By(s.tree,l.path,"group",l.id,l.properties,u,l.children,l.meta);break;case fy:c.tree=function(e,t,r){if(!e.getIn(pu(t)))return e;e=Gy(e,t);var n=r.settings.canLeaveEmptyGroup,o=t.slice(0,-1);return _u(e,o)||n||(e=yu(e),!Tu(e)||n)||(e=qy(e,new gl.List,"rule",ml(),pd(r,void 0,void 0,!1,!1),r)),gu(e)}(s.tree,l.path,u);break;case gy:c.tree=qy(s.tree,l.path,l.ruleType,l.id,l.properties,u,l.children);break;case yy:c.tree=function(e,t,r){if(!e.getIn(pu(t)))return e;e=Gy(e,t);var n=r.settings.canLeaveEmptyGroup,o=t.pop(),i=e.getIn(pu(o)),a=i.getIn(["properties","field"]),s=i.getIn(["properties","operator"]),l=a?Iv(r,a):null,u=s?xv(r,s,a):null,c=a&&s&&0!=u.cardinality,d="rule_group"==i.get("type"),p=!_u(e,o),f=d?c&&l.initialEmptyWhere:n;return p&&!f&&(d&&(e=e.deleteIn(pu(o))),e=yu(e),Tu(e)&&!n)&&(e=qy(e,new gl.List,"rule",ml(),pd(r,void 0,void 0,!1,!1),r)),gu(e)}(s.tree,l.path,u);break;case hy:c.tree=function(e,t,r){return e.getIn(pu(t))?e=e.setIn(pu(t,"properties","conjunction"),r):e}(s.tree,l.path,l.conjunction);break;case vy:c.tree=function(e,t,r){return e.getIn(pu(t))?e=e.setIn(pu(t,"properties","not"),r):e}(s.tree,l.path,l.not);break;case my:var f=Ky(s.tree,l.path,l.field,u,l.asyncListValues,l._meta).state;c.tree=f;break;case by:c.tree=function(e,t,r,n){var o=e.getIn(pu(t));if(!o)return e;var i=n.settings.keepInputOnChangeFieldSrc,a=o.get("properties"),s=null==a?void 0:a.get("field"),l=null==a?void 0:a.get("fieldType"),u=Iv(n,s),c=(null==u?void 0:u.type)||l;c&&"!group"!==c&&"!struct"!==c||(c=null);var d=!Df.includes(c);return(e=i&&!Jf(o,n)&&d?(e=(e=e.setIn(pu(t,"properties","field"),null)).deleteIn(pu(t,"properties","fieldError"))).setIn(pu(t,"properties","fieldType"),c):e.setIn(pu(t,"properties"),pd(n,null,null,!1))).setIn(pu(t,"properties","fieldSrc"),r)}(s.tree,l.path,l.srcKey,u);break;case wy:c.tree=function(e,t,r){return e.getIn(pu(t))?e=vu(e.setIn(pu(t,"properties","isLocked"),r)):e}(s.tree,l.path,l.lock);break;case Oy:c.tree=function(e,t,r,n){var o=e.getIn(pu(t));if(!o)return e;var i=n.settings.showErrorMessage,a=o.get("properties"),s=o.get("children1"),l=a.get("field"),u=(a.get("fieldSrc"),Iv(n,l)),c="!group"==(null==u?void 0:u.type),d=xv(n,r,l),p=d?wl(d):null;return e=e.updateIn(pu(t,"properties"),(function(e){return e.withMutations((function(e){var t=e.get("field"),o=e.get("operatorOptions"),a=(e.get("value",new gl.List),e.get("valueSrc",new gl.List),e.get("operator"),Af(n,n,e,t,r,"operator",!0)),s=a.canReuseValue,l=a.newValue,u=a.newValueSrc,c=a.newValueType,d=a.newValueError;i&&(e=e.set("valueError",d));var p=s?o:dd(n,r,t);return s||(e=e.delete("asyncListValues")),e.set("operator",r).set("operatorOptions",p).set("value",l).set("valueSrc",u).set("valueType",c)}))})),c&&0==p&&0==s.size&&(e=qy(e,t,"rule",ml(),pd(n,l),n)),e}(s.tree,l.path,l.operator,u);break;case Ey:var h=Wy(s.tree,l.path,l.delta,l.value,l.valueType,u,l.asyncListValues,l._meta).state;c.tree=h;break;case Ty:var v=function(e,t,r,n,o,i,a,s,l){var u=arguments.length>9&&void 0!==arguments[9]?arguments[9]:{},c=t.getIn(pu(r));if(!c)return t;var d,p=-1===n,f=c.get("properties"),h=f.get("field"),v=f.get("value"),g=[],y=p?h:v.getIn([n]),m=Vy(o||[]);try{for(m.s();!(d=m.n()).done;){var b=Hn(d.value,2),O=b[0],E=b[1];if(g.push([O,E,y]),O!==y.get("func")){var S=g.map((function(e){var t=Hn(e,2),r=t[0],n=t[1];return"".concat(r,"(").concat(n,")")})).join("/")||"root";throw new Error("In ".concat(p?"LHS":"RHS"," for path ").concat(S," expected func key ").concat(O," but got ").concat(parent.get("func")))}y=y.getIn(["args",E,"value"])}}catch(e){m.e(e)}finally{m.f()}if(i){var T=y.get("func"),_=bv(e,T).args[i];y="!valueSrc"===s?kf(y,i,a,_,e):Pf(y,i,a,_,e)}else y=xf(y,a,e,!0),u.canDropArgs=!0;for(var w=y;g.length;){var R=Hn(g.pop(),3),A=R[0],C=R[1],I=R[2],x=bv(e,A).args[C];w=Pf(I,C,w,x,e)}return p?Ky(t,r,w,e,l,u):Wy(t,r,n,w,void 0,e,l,u)}(u,s.tree,l.path,l.delta,l.parentFuncs,l.argKey,l.value,l.valueType,l.asyncListValues,l._meta),g=v.state;c.tree=g;break;case Sy:c.tree=function(e,t,r,n,o){if(!e.getIn(pu(t)))return e;var i=o.settings.showErrorMessage,a=e.getIn(pu(t,"properties","field"))||null,s=e.getIn(pu(t,"properties","operator"))||null,l=xv(o,s,a),u=s?wl(l):null;if(e=(e=(e=(e=zy(e,t,o,u)).setIn(pu(t,"properties","value",r+""),void 0)).setIn(pu(t,"properties","valueType",r+""),null)).deleteIn(pu(t,"properties","asyncListValues")),i&&(e=e.setIn(pu(t,"properties","valueError",r),null),l.validateValues&&(e=e.setIn(pu(t,"properties","valueError",u),null))),e=void 0===n?e.setIn(pu(t,"properties","valueSrc",r+""),null):e.setIn(pu(t,"properties","valueSrc",r+""),n),n){var c=e.getIn(pu(t,"properties")),d=Af(o,o,c,a,s,"valueSrc",!0),p=d.canReuseValue,f=d.newValue,h=d.newValueSrc,v=d.newValueType;d.newValueError,p||h.get(r)!=n||(e=(e=e.setIn(pu(t,"properties","value",r+""),f.get(r))).setIn(pu(t,"properties","valueType",r+""),v.get(r)))}return e}(s.tree,l.path,l.delta,l.srcKey,u,l._meta);break;case _y:c.tree=function(e,t,r,n){return e.getIn(pu(t))?e.setIn(pu(t,"properties","operatorOptions",r),n):e}(s.tree,l.path,l.name,l.value);break;case Ay:c.tree=function(e,t,r,n,o){var i=hu(e,t),a=t.pop(),s=t.size>1?hu(e,a):null,l=s?s.get("children1"):null,u=hu(e,r),c=n==xy||n==Ly?r:r.pop(),d=n==xy||n==Ly?u:r.size>1?hu(e,c):null,p=d?d.get("children1"):null;if(!s||!d||!i)return e;var f=s.get("id")==d.get("id"),h=c.size<a.size&&Rl(c.toArray(),a.toArray().slice(0,c.size)),v=c.size>a.size&&Rl(a.toArray(),c.toArray().slice(0,a.size)),g=null,y=null;h?g=gl.List(a.toArray().slice(c.size)):v&&(y=gl.List(c.toArray().slice(a.size)));var m=p,b=l;return v||(b=b.delete(i.get("id"))),f?m=b:h&&(m=m.updateIn(fu(g,"children1"),(function(e){return b}))),n==Iy||n==Cy?m=gl.OrderedMap().withMutations((function(e){var t,r=Vy(m.entries());try{for(r.s();!(t=r.n()).done;){var o=Hn(t.value,2),a=o[0],s=o[1];a==(null==u?void 0:u.get("id"))&&n==Iy&&e.set(i.get("id"),i),e.set(a,s),a==(null==u?void 0:u.get("id"))&&n==Cy&&e.set(i.get("id"),i)}}catch(e){r.e(e)}finally{r.f()}})):n==xy?m=m.merge(gl.OrderedMap(Gn({},i.get("id"),i))):n==Ly&&(m=gl.OrderedMap(Gn({},i.get("id"),i)).merge(m)),v&&(b=(b=b.updateIn(fu(y,"children1"),(function(e){return m}))).delete(i.get("id"))),f||h||(e=e.updateIn(pu(a,"children1"),(function(e){return b}))),v||(e=e.updateIn(pu(c,"children1"),(function(e){return m}))),gu(e)}(s.tree,l.fromPath,l.toPath,l.placement);break;case jy:c.dragStart=l.dragStart,c.dragging=l.dragging,c.mousePos=l.mousePos;break;case Ny:c.mousePos=l.mousePos,c.dragging=l.dragging;break;case Py:c.tree=function(e,t){return t.settings.canLeaveEmptyGroup||(e=yu(e)),e}(s.tree,u),c=My(My({},c),Hy)}return d&&(c.__lastAction=d),n&&c.tree&&s.tree&&n(s.tree),My(My(My({},s),{__lastAction:void 0}),c)}},bm=me().createContext();var Om=p(7694),Em=p(200),Sm="after",Tm="before",_m="append",wm="prepend",Rm=function(e,t){return{type:"SET_DRAG_PROGRESS",mousePos:e,dragging:t}},Am=function(e,t,r){return{type:"SET_DRAG_START",dragStart:e,dragging:t,mousePos:r}},Cm=function(){return{type:"SET_DRAG_END"}},Im=g,xm=y,Lm=m,Nm=function(e,t,r){if(!t||!e||e.length<=t)return e;var n=e.substr(0,t-1);return(r?n.substr(0,n.lastIndexOf(" ")):n)+"..."},jm=function(e,t){return e===t||(null==e?void 0:e.equals(t))},Pm=function(e,t){var r=arguments.length>2&&void 0!==arguments[2]&&arguments[2];return e===t||(Array.isArray(e)?function(e,t){var r=arguments.length>2&&void 0!==arguments[2]&&arguments[2];if(e===t)return!0;if(!e||!t)return!1;var n=e.length;if(t.length!==n)return!1;for(var o=0;o<n;o++)if(!(r?Pm(e[o],t[o],r):e[o]===t[o]))return!1;return!0}(e,t,r):e&&"function"==typeof e.equals?e.equals(t):"object"===kn(e)?function(e,t){var r=arguments.length>2&&void 0!==arguments[2]&&arguments[2];if(e===t)return!0;if(!e||!t)return!1;var n=Object.keys(e),o=Object.keys(t),i=n.length;if(o.length!==i)return!1;for(var a=0;a<i;a++){var s=n[a];if(!(r?Pm(e[s],t[s],r):e[s]===t[s]))return!1}return!0}(e,t,r):e===t)},km=function(){var e=arguments.length>0&&void 0!==arguments[0]&&arguments[0];return(null!=e?e:("undefined"!=typeof process&&process.env,0))?console:{error:function(){},log:function(){},warn:function(){},debug:function(){},info:function(){}}}(),Fm=vm.Validation.validateAndFixTree,Dm=function e(t){if(t){var r,n=(r=t)._reactRootContainer?"root":Object.getOwnPropertyNames(r).filter((function(e){return e.startsWith("__reactContainer")})).length>0?"container":void 0;return void 0!==n?n:e(t.parentNode)}},Mm=function(e){return"root"===Dm(e)},Vm=function(e,t){return function(r,n){var o=e.props,i=e.state,a=r!=o||n!=i;if(a&&i==n&&o!=r){var s=[];for(var l in r){var u=r[l]!=o[l];u&&("ignore"==t[l]?u=!1:"shallow_deep"==t[l]?u=!Pm(r[l],o[l],!0):"shallow"==t[l]?u=!Pm(r[l],o[l]):"function"==typeof t[l]&&(u=t[l](r[l],o[l],r,o))),u&&s.push(l)}s.length||(a=!1)}return a}},Um=function(e){return function(t,r){return!Pm(e.props,t)||!Pm(e.state,r)}},Bm=function(e){if(e.shouldComponentUpdate||(e.shouldComponentUpdate=Um(e)),16==(r=me().version.split(".").map(parseInt.bind(null,10)))[0]&&r[1]<3||r[0]<16)e.componentWillReceiveProps=function(t){e.onPropsChanged(t)};else{var t=e.shouldComponentUpdate;e.shouldComponentUpdate=function(r,n){return!Pm(e.props,r)&&e.onPropsChanged(r),t.call(e,r,n)}.bind(e)}var r},qm=function(e,t,r){return Fy()(e,(function(e){return function(){for(var n=arguments.length,o=new Array(n),i=0;i<n;i++)o[i]=arguments[i];return r(e.apply(void 0,[t].concat(o)))}}))};function Gm(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);t&&(n=n.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),r.push.apply(r,n)}return r}function Km(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{};t%2?Gm(Object(r),!0).forEach((function(t){Gn(e,t,r[t])})):Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(r)):Gm(Object(r)).forEach((function(t){Object.defineProperty(e,t,Object.getOwnPropertyDescriptor(r,t))}))}return e}function Wm(e,t,r){return t=Un(t),Vn(e,zm()?Reflect.construct(t,r||[],Un(e).constructor):t.apply(e,r))}function zm(){try{var e=!Boolean.prototype.valueOf.call(Reflect.construct(Boolean,[],(function(){})))}catch(e){}return(zm=function(){return!!e})()}var $m=function(e){function t(e){var r;Pn(this,t),(r=Wm(this,t,[e])).shouldComponentUpdate=Vm(r,{tree:function(e){return e!==r.oldValidatedTree||r.oldValidatedTree!==r.validatedTree}}),Bm(r),r._updateActions(e),r.validatedTree=e.getMemoizedTree(e.config,e.tree,void 0,e.sanitizeTree),r.oldValidatedTree=r.validatedTree;var n=e.getBasicConfig(e.config);return e.onInit&&e.onInit(r.validatedTree,n,void 0,r.actions),r}return qn(t,e),Mn(t,[{key:"_updateActions",value:function(e){var t=e.config,r=e.dispatch;this.actions=qm(Km(Km(Km({},Im),xm),Lm),t,r)}},{key:"onPropsChanged",value:function(e){var t=e.onChange,r=this.props.config,n=e.tree,o=(this.props.tree,e.config);if(this.oldValidatedTree=this.validatedTree,this.validatedTree=n,r!==o&&(this._updateActions(e),this.validatedTree=e.getMemoizedTree(o,n,r)),!jm(this.validatedTree,this.oldValidatedTree)){var i=e.getBasicConfig(o);t&&t(this.validatedTree,i,e.__lastAction,this.actions)}}},{key:"render",value:function(){var e=this.props,t=e.config,r=e.renderBuilder,n=e.dispatch;return r({tree:this.validatedTree,actions:this.actions,config:t,dispatch:n})}}])}(ye.Component);$m.propTypes={config:ym().object.isRequired,onChange:ym().func,onInit:ym().func,renderBuilder:ym().func,tree:ym().any};var Hm=(0,Em.connect)((function(e){return{tree:e.tree,__lastAction:e.__lastAction}}),null,null,{context:bm})($m);Hm.displayName="ConnectedQuery";const Ym=Hm;function Qm(e,t,r){return t=Un(t),Vn(e,Xm()?Reflect.construct(t,r||[],Un(e).constructor):t.apply(e,r))}function Xm(){try{var e=!Boolean.prototype.valueOf.call(Reflect.construct(Boolean,[],(function(){})))}catch(e){}return(Xm=function(){return!!e})()}var Jm=vm.DefaultUtils.defaultRoot,Zm=vm.ConfigUtils.createConfigMemo,eb=function(e){function t(e,r){var n,o,i;Pn(this,t),(i=Qm(this,t,[e,r])).setLastTree=function(e){i.prevTree&&(i.prevprevTree=i.prevTree),i.prevTree=e},i.getConfig=function(){return i.config},i.shouldComponentUpdate=Vm(i,{value:function(e,t){return!1}}),Bm(i);var a=Zm({reactIndex:null!==(n=null===(o=i._reactInternals)||void 0===o?void 0:o.index)&&void 0!==n?n:-1,maxSize:2,canCompile:!0}),s=a.getExtendedConfig,l=a.getBasicConfig,u=a.clearConfigMemo;i.getMemoizedConfig=s,i.getBasicConfig=l,i.clearConfigMemo=u,i.getMemoizedTree=function(){var e,t,r;return function(n,o){var i=arguments.length>2&&void 0!==arguments[2]?arguments[2]:void 0,a=!(arguments.length>3&&void 0!==arguments[3])||arguments[3];return o?n.__configId===r&&(jm(o,e)||jm(o,t))?t:(r=n.__configId,e=o,t=!1===a?Fm(o,null,n,i||n,!1,!1,!1):Fm(o,null,n,i||n)):null}}();var c=i.getMemoizedConfig(e),d=c.settings.shouldCreateEmptyGroup,p=Jm(c,!d),f=!!e.value,h=e.value||p,v=i.getMemoizedTree(c,h,void 0,f),g=mm(c,v,i.getMemoizedTree,i.setLastTree,i.getConfig),y=(0,Om.createStore)(g);return i.config=c,i.state={store:y},i.QueryWrapper=function(e){return c.settings.renderProvider(e,c.ctx)},i}return qn(t,e),Mn(t,[{key:"componentWillUnmount",value:function(){this.clearConfigMemo()}},{key:"onPropsChanged",value:function(e){var t=this.props,r=this.config,n=this.getMemoizedConfig(e),o=r!==n,i=this.state.store.getState().tree,a=!jm(e.value,this.props.value)&&!jm(e.value,i),s=a?e.value||Jm(e):i,l=a&&!jm(e.value,this.prevTree)&&!jm(e.value,this.prevprevTree);if(this.sanitizeTree=l||o,o&&(t.settings.renderProvider!==e.settings.renderProvider&&(this.QueryWrapper=function(e){return n.settings.renderProvider(e,n.ctx)}),this.config=n),a||o){var u=this.getMemoizedTree(n,s,r,this.sanitizeTree);this.state.store.dispatch(Im.setTree(n,u))}}},{key:"render",value:function(){var e=this.props,t=e.renderBuilder,r=e.get_children,n=e.onChange,o=e.onInit,i=this.state.store,a=this.config,s=this.QueryWrapper;return me().createElement(s,{config:a},me().createElement(Em.Provider,{store:i,context:bm},me().createElement(Ym,{config:a,getMemoizedTree:this.getMemoizedTree,getBasicConfig:this.getBasicConfig,sanitizeTree:this.sanitizeTree,onChange:n,onInit:o,renderBuilder:t||r})))}}])}(ye.Component);function tb(){return tb=Object.assign?Object.assign.bind():function(e){for(var t=1;t<arguments.length;t++){var r=arguments[t];for(var n in r)({}).hasOwnProperty.call(r,n)&&(e[n]=r[n])}return e},tb.apply(null,arguments)}eb.propTypes={conjunctions:ym().object.isRequired,fields:ym().object.isRequired,types:ym().object.isRequired,operators:ym().object.isRequired,widgets:ym().object.isRequired,settings:ym().object.isRequired,ctx:ym().object.isRequired,onChange:ym().func,onInit:ym().func,renderBuilder:ym().func,value:ym().any};var rb=p(2584),nb=p.n(rb);function ob(e,t,r){return t=Un(t),Vn(e,ib()?Reflect.construct(t,r||[],Un(e).constructor):t.apply(e,r))}function ib(){try{var e=!Boolean.prototype.valueOf.call(Reflect.construct(Boolean,[],(function(){})))}catch(e){}return(ib=function(){return!!e})()}var ab=vm.ConfigUtils.getFieldConfig;function sb(e,t,r){return t=Un(t),Vn(e,lb()?Reflect.construct(t,r||[],Un(e).constructor):t.apply(e,r))}function lb(){try{var e=!Boolean.prototype.valueOf.call(Reflect.construct(Boolean,[],(function(){})))}catch(e){}return(lb=function(){return!!e})()}var ub=vm.clone,cb=vm.TreeUtils.getFlatTree,db=!1,pb=["isDraggingTempo","isDraggingMe","dragging"];function fb(e,t,r){return t=Un(t),Vn(e,hb()?Reflect.construct(t,r||[],Un(e).constructor):t.apply(e,r))}function hb(){try{var e=!Boolean.prototype.valueOf.call(Reflect.construct(Boolean,[],(function(){})))}catch(e){}return(hb=function(){return!!e})()}const vb=function(e){return function(t){var r;return r=function(r){function n(e){var t;return Pn(this,n),(t=fb(this,n,[e])).handleDraggerMouseDown=function(e){var r=t.props.id,n=t.wrapper.current;t.props.onDragStart&&t.props.onDragStart(r,n,e)},t.wrapper=me().createRef(),t}return qn(n,r),Mn(n,[{key:"render",value:function(){var r=this.props,n=r.isDraggingTempo,o=r.isDraggingMe,i=r.dragging,a=Lg(r,pb),s=a.isTrueLocked,l={};o&&n&&(db||(l={top:i.y,left:i.x,width:i.w}));var u=nb()(e,"group-or-rule",o&&n?"qb-draggable":null,o&&!n?"qb-placeholder":null,s?"locked":null);return me().createElement("div",{className:u,style:l,ref:this.wrapper,"data-id":this.props.id},me().createElement(t,tb({handleDraggerMouseDown:this.handleDraggerMouseDown,isDraggingMe:o,isDraggingTempo:n},a)))}}])}(ye.PureComponent),r.propTypes={isDraggingTempo:ym().bool,isDraggingMe:ym().bool,onDragStart:ym().func,dragging:ym().object,isLocked:ym().bool,isTrueLocked:ym().bool},r}};var gb=p(3790),yb=p.n(gb),mb=p(350),bb=p.n(mb);function Ob(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);t&&(n=n.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),r.push.apply(r,n)}return r}function Eb(e,t,r){return t=Un(t),Vn(e,Sb()?Reflect.construct(t,r||[],Un(e).constructor):t.apply(e,r))}function Sb(){try{var e=!Boolean.prototype.valueOf.call(Reflect.construct(Boolean,[],(function(){})))}catch(e){}return(Sb=function(){return!!e})()}var Tb=vm.ConfigUtils,_b=Tb.getFieldConfig,wb=Tb.getOperatorConfig,Rb=function(e){function t(e){var r;return Pn(this,t),(r=Eb(this,t,[e])).shouldComponentUpdate=Vm(r,{selectedField:function(e,t){return!1}}),Bm(r),r.onPropsChanged(e),r}return qn(t,e),Mn(t,[{key:"onPropsChanged",value:function(e){var t=this.props;(!this.meta||["config","selectedField","selectedFieldSrc","selectedFieldType","selectedOperator"].map((function(r){return e[r]!==t[r]})).filter((function(e){return e})).length>0)&&(this.meta=this.getMeta(e))}},{key:"getMeta",value:function(e){var t,r=e.config,n=e.selectedField,o=e.selectedFieldType,i=e.selectedOperator,a=_b(r,n),s=Qn((null==a?void 0:a.operators)||(null===(t=r.types[o])||void 0===t?void 0:t.operators)||[]);n||s.includes(i)||s.push(i);var l=Fy()(bb()(r.operators,(function(e,t){return-1!==(null==s?void 0:s.indexOf(t))})),(function(e,t){return wb(r,t,n)})),u=this.buildOptions(r,l,s),c=l[i]||{},d=i?[i]:null;return{placeholder:this.props.config.settings.operatorPlaceholder,items:u,selectedKey:i,selectedKeys:d,selectedPath:d,selectedLabel:c.label,selectedAltLabel:c.label2||c.tooltip,selectedOpts:c,fieldConfig:a}}},{key:"buildOptions",value:function(e,t,r){return t&&r?yb()(t).sort((function(e,t){return r.indexOf(e)-r.indexOf(t)})).map((function(e){var r=t[e];return{key:e,path:e,label:r.label,altLabel:r.label2,tooltip:r.tooltip}})):null}},{key:"render",value:function(){var e=this.props,t=e.config,r=e.customProps,n=e.setOperator,o=e.readonly,i=e.id,a=e.groupId,s=t.settings.renderOperator,l=function(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{};t%2?Ob(Object(r),!0).forEach((function(t){Gn(e,t,r[t])})):Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(r)):Ob(Object(r)).forEach((function(t){Object.defineProperty(e,t,Object.getOwnPropertyDescriptor(r,t))}))}return e}({id:i,groupId:a,config:t,customProps:r,readonly:o,setField:n},this.meta);return l.items?s(l,t.ctx):null}}])}(ye.Component);Rb.propTypes={id:ym().string,groupId:ym().string,config:ym().object.isRequired,selectedField:ym().any,selectedFieldId:ym().string,selectedFieldType:ym().string,selectedFieldSrc:ym().string,selectedOperator:ym().string,readonly:ym().bool,setOperator:ym().func.isRequired};var Ab=["children"],Cb=function(e){var t=e.children,r=Lg(e,Ab);return me().createElement("div",r,t)},Ib=function(){},xb=function(){return me().createElement("svg",{xmlns:"http://www.w3.org/2000/svg",viewBox:"0 0 24 24",fill:"gray",width:"18px",height:"18px"},me().createElement("path",{d:"M0 0h24v24H0V0z",fill:"none"}),me().createElement("path",{d:"M3 18h18v-2H3v2zm0-5h18v-2H3v2zm0-7v2h18V6H3z"}))},Lb=function(e){return function(t){var r=t.config.settings.useConfirm,n=r?r.call(t.config.ctx,t.config.ctx):null;return me().createElement(e,tb({},t,{confirmFn:n}))}},Nb=function(e){var t=e.id,r=e.isLHS,n=e.delta;return[t,r?"L":"R",r?-1:n||0,(e.parentFuncs||[]).map((function(e){var t=Hn(e,2),r=t[0],n=t[1];return"".concat(r,"(").concat(n,")")})).join("/")].join(":")},jb=function(e,t){var r;return"function"==typeof t?(r=function(r){return null==t?void 0:t(r,e.ctx)}).displayName=t.name:r=t,r};function Pb(e,t,r){return t=Un(t),Vn(e,kb()?Reflect.construct(t,r||[],Un(e).constructor):t.apply(e,r))}function kb(){try{var e=!Boolean.prototype.valueOf.call(Reflect.construct(Boolean,[],(function(){})))}catch(e){}return(kb=function(){return!!e})()}var Fb=function(e){function t(){return Pn(this,t),Pb(this,t,arguments)}return qn(t,e),Mn(t,[{key:"render",value:function(){var e=this.props,t=e.config,r=e.selectedField,n=e.selectedFieldSrc,o=e.selectedFieldType,i=e.selectedOperator,a=e.setOperator,s=e.selectedFieldId,l=e.showOperator,u=e.showOperatorLabel,c=e.selectedFieldWidgetConfig,d=e.readonly,p=e.id,f=e.groupId;return[l&&me().createElement(Cb,{key:"operators-for-"+s,className:"rule--operator"},t.settings.showLabels&&me().createElement("label",{className:"rule--label"},t.settings.operatorLabel),me().createElement(Rb,{key:"operator",config:t,selectedField:r,selectedFieldSrc:n,selectedFieldType:o,selectedFieldId:s,selectedOperator:i,setOperator:a,readonly:d,id:p,groupId:f})),u&&me().createElement(Cb,{key:"operators-for-"+s,className:"rule--operator"},me().createElement("div",{className:"rule--operator-wrapper"},t.settings.showLabels?me().createElement("label",{className:"rule--label"}," "):null,me().createElement("div",{className:"rule--operator-text-wrapper"},me().createElement("span",{className:"rule--operator-text"},c.operatorInlineLabel))))]}}])}(ye.PureComponent);function Db(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);t&&(n=n.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),r.push.apply(r,n)}return r}function Mb(e,t,r){return t=Un(t),Vn(e,Vb()?Reflect.construct(t,r||[],Un(e).constructor):t.apply(e,r))}function Vb(){try{var e=!Boolean.prototype.valueOf.call(Reflect.construct(Boolean,[],(function(){})))}catch(e){}return(Vb=function(){return!!e})()}var Ub=vm.RuleUtils.getFieldPathLabels,Bb=vm.ConfigUtils,qb=Bb.getFieldConfig,Gb=Bb.getFieldParts,Kb=Bb.getFieldPathParts,Wb=function(e){function t(e){var r;return Pn(this,t),(r=Mb(this,t,[e])).setField=function(e,t){var n=arguments.length>2&&void 0!==arguments[2]?arguments[2]:{},o=r.props.id;if(!n.widgetId){var i=[o,"L",-1].join(":");n.widgetId=i}r.props.setField(e,t,n)},Bm(r),r.onPropsChanged(e),r}return qn(t,e),Mn(t,[{key:"onPropsChanged",value:function(e){var t=this.props;(!this.meta||["selectedField","selectedFieldSrc","selectedFieldType","config","parentField"].map((function(r){return e[r]!==t[r]})).filter((function(e){return e})).length>0)&&(this.meta=this.getMeta(e))}},{key:"getMeta",value:function(e){var t=e.selectedField,r=e.selectedFieldType,n=e.config,o=e.parentField,i=t,a=n.settings,s=a.maxLabelsLength,l=a.fieldSeparatorDisplay,u=a.fieldPlaceholder,c=(a.fieldSeparator,!!t),d=c?null:Nm(u,s),p=c?qb(n,i):null,f=p||{},h=Kb(i,n),v=Kb(i,n,!0),g=this.getFieldLabel(p,i,n),y=Ub(i,n),m=y?y.join(l):null;(m==g||o)&&(m=null);var b=f.label2||f.tooltip,O=Gb(o,n),E=o?qb(n,o):null,S=o?E&&E.subfields:n.fields,T=!c&&r,_=this.buildOptions(O,n,S,T,O),w=T?"Please select field":null;return i&&"object"===kn(i)&&(i=void 0),{placeholder:d,items:_,parentField:o,selectedKey:i,selectedKeys:h,selectedPath:v,selectedLabel:g,selectedOpts:f,selectedAltLabel:b,selectedFullLabel:m,errorText:w}}},{key:"getFieldLabel",value:function(e,t,r){if(!t)return null;var n=r.settings.maxLabelsLength,o=Gb(t,r),i=(null==e?void 0:e.label)||Ql()(o);return Nm(i,n)}},{key:"buildOptions",value:function(e,t,r){var n=this,o=arguments.length>3&&void 0!==arguments[3]?arguments[3]:void 0,i=arguments.length>4&&void 0!==arguments[4]?arguments[4]:null,a=arguments.length>5&&void 0!==arguments[5]?arguments[5]:null;if(!r)return null;var s=t.settings,l=s.fieldSeparator,u=s.fieldSeparatorDisplay,c=null!=i&&i.length?i.join(l)+l:"",d=function e(t){return Object.keys(t||{}).reduce((function(r,n){var i=t[n];return"!struct"===i.type?r+e(i.subfields):r+(i.type===o?1:0)}),0)};return yb()(r).map((function(s){var l=[].concat(Qn(null!=i?i:[]),[s]),p=r[s],f=n.getFieldLabel(p,l,t),h=Ub(l,t).join(u);(h==f||null!=e&&e.length)&&(h=null);var v=p.label2,g=p.tooltip,y=p.disabled;if(!p.hideForSelect){if("!struct"==p.type){var m=n.buildOptions(e,t,p.subfields,o,l,{label:f,tooltip:g}),b=d(p.subfields)>0;return{disabled:y,key:s,path:c+s,label:f,fullLabel:h,altLabel:v,tooltip:g,items:m,matchesType:b}}var O=void 0!==o?p.type===o:void 0;return{disabled:y,key:s,path:c+s,label:f,fullLabel:h,altLabel:v,tooltip:g,grouplabel:null==a?void 0:a.label,group:a,matchesType:O}}})).filter((function(e){return!!e}))}},{key:"render",value:function(){var e=this.props,t=e.config,r=e.customProps,n=e.setFieldSrc,o=e.readonly,i=e.id,a=e.groupId,s=t.settings.renderField,l=function(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{};t%2?Db(Object(r),!0).forEach((function(t){Gn(e,t,r[t])})):Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(r)):Db(Object(r)).forEach((function(t){Object.defineProperty(e,t,Object.getOwnPropertyDescriptor(r,t))}))}return e}({id:i,groupId:a,config:t,customProps:r,readonly:o,setField:this.setField,setFieldSrc:n},this.meta);return s(l,t.ctx)}}])}(ye.Component);function zb(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);t&&(n=n.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),r.push.apply(r,n)}return r}function $b(e,t,r){return t=Un(t),Vn(e,Hb()?Reflect.construct(t,r||[],Un(e).constructor):t.apply(e,r))}function Hb(){try{var e=!Boolean.prototype.valueOf.call(Reflect.construct(Boolean,[],(function(){})))}catch(e){}return(Hb=function(){return!!e})()}Wb.propTypes={id:ym().string,groupId:ym().string,config:ym().object.isRequired,selectedField:ym().any,selectedFieldSrc:ym().string,selectedFieldType:ym().string,parentField:ym().string,customProps:ym().object,readonly:ym().bool,setField:ym().func.isRequired,setFieldSrc:ym().func};var Yb=vm.clone,Qb=vm.ConfigUtils,Xb=Qb.getFieldConfig,Jb=Qb.getFuncConfig,Zb=Qb.getFieldParts,eO=Qb.getFieldPathParts,tO=vm.RuleUtils,rO=tO.getFuncPathLabels,nO=tO.getWidgetForFieldOp,oO=vm.OtherUtils.shallowEqual,iO=function(e){function t(e){var r;return Pn(this,t),r=$b(this,t,[e]),Bm(r),r.onPropsChanged(e),r}return qn(t,e),Mn(t,[{key:"onPropsChanged",value:function(e){var t=this.props,r=!this.items||["config","field","fieldType","fieldSrc","operator","isFuncArg","isLHS","parentFuncs"].map((function(r){return"parentFuncs"===r?!oO(e[r],t[r],!0):e[r]!==t[r]})).filter((function(e){return e})).length>0;(!this.meta||["config","field","fieldType","fieldSrc","value","isLHS"].map((function(r){return e[r]!==t[r]})).filter((function(e){return e})).length>0)&&(this.meta=this.getMeta(e)),r&&(this.items=this.getItems(e,this.meta))}},{key:"getItems",value:function(e,t){var r=e.config,n=e.field,o=e.fieldType,i=e.isLHS,a=e.operator,s=e.parentFuncs,l=e.fieldDefinition,u=e.isFuncArg,c=t.lookingForFieldType,d=r.settings.canUseFuncForField,p=this.filterFuncs(r,r.funcs,n,o,i,a,d,s,u,l);return this.buildOptions(r,p,c)}},{key:"getMeta",value:function(e){var t=e.config,r=(e._field,e.fieldType),n=e.value,o=e.isLHS,i=e.isFuncArg,a=t.settings,s=a.funcPlaceholder,l=a.fieldSeparatorDisplay,u=n,c=!!n,d=c?null:s,p=c?Jb(t,u):null,f=p||{},h=eO(u,t),v=eO(u,t,!0),g=this.getFuncLabel(p,u,t),y=rO(u,t),m=y?y.join(l):null;m==g&&(m=null);var b=o&&!i&&!c&&r;return{placeholder:d,selectedKey:u,selectedKeys:h,selectedPath:v,selectedLabel:g,selectedOpts:f,selectedFullLabel:m,errorText:b?"Please select function":null,lookingForFieldType:b}}},{key:"filterFuncs",value:function(e,t,r,n,o,i,a,s,l,u){t=Yb(t);var c,d=e.settings.fieldSeparator,p=Xb(e,r),f=p,h=nO(e,r,i,"value");return h&&e.widgets[h],l?(f=u,c=null==u?void 0:u.type):p?c=p.type:o||(c=n),function t(n,o){for(var l in n){var u=n[l].subfields,h=(o||[]).concat(l),v=h.join(d),g=Jb(e,v);if("!struct"==g.type)0==t(u,h)&&delete n[l];else{var y,m=!c||g.returnType==c;null!==(y=f)&&void 0!==y&&y.funcs&&(m=m&&f.funcs.includes(v)),a&&(m=m&&a(r,p,v,g,i)),!g.allowSelfNesting&&s&&s.map((function(e){var t=Hn(e,2),r=t[0];return t[1],r})).includes(v)&&(m=!1),m||delete n[l]}}return yb()(n).length}(t,[]),t}},{key:"buildOptions",value:function(e,t){var r=this,n=arguments.length>2&&void 0!==arguments[2]?arguments[2]:void 0,o=arguments.length>3&&void 0!==arguments[3]?arguments[3]:null,i=arguments.length>4&&void 0!==arguments[4]?arguments[4]:null;if(!t)return null;var a=e.settings,s=a.fieldSeparator,l=a.fieldSeparatorDisplay,u=null!=o&&o.length?o.join(s)+s:"",c=function e(t){return Object.keys(t||{}).reduce((function(r,o){var i=t[o];return"!struct"===i.type?r+e(i.subfields):r+(i.type===n?1:0)}),0)};return yb()(t).map((function(a){var s=[].concat(Qn(null!=o?o:[]),[a]),d=t[a],p=r.getFuncLabel(d,s,e),f=rO(s,e).join(l);f==p&&(f=null);var h=d.tooltip;if("!struct"==d.type){var v=r.buildOptions(e,d.subfields,n,s,{label:p,tooltip:h}),g=c(d.subfields)>0;return{key:a,path:u+a,label:p,fullLabel:f,tooltip:h,items:v,matchesType:g}}var y=void 0!==n?d.returnType===n:void 0;return{key:a,path:u+a,label:p,fullLabel:f,tooltip:h,grouplabel:null==i?void 0:i.label,group:i,matchesType:y}}))}},{key:"getFuncLabel",value:function(e,t,r){if(!t)return null;var n=r.settings.maxLabelsLength,o=Zb(t,r),i=(null==e?void 0:e.label)||Ql()(o);return Nm(i,n)}},{key:"render",value:function(){var e=this.props,t=e.config,r=e.customProps,n=e.setValue,o=e.readonly,i=e.id,a=e.groupId,s=t.settings.renderFunc,l=function(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{};t%2?zb(Object(r),!0).forEach((function(t){Gn(e,t,r[t])})):Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(r)):zb(Object(r)).forEach((function(t){Object.defineProperty(e,t,Object.getOwnPropertyDescriptor(r,t))}))}return e}({config:t,customProps:r,readonly:o,setField:n,items:this.items,id:i,groupId:a},this.meta);return s(l,t.ctx)}}])}(ye.Component);iO.propTypes={id:ym().string,groupId:ym().string,config:ym().object.isRequired,field:ym().any,fieldType:ym().string,fieldSrc:ym().string,operator:ym().string,customProps:ym().object,value:ym().string,setValue:ym().func.isRequired,readonly:ym().bool,parentFuncs:ym().array,fieldDefinition:ym().object,isFuncArg:ym().bool,isLHS:ym().bool};var aO=p(2285),sO=p.n(aO),lO=["widgetFactory"],uO=["factory"];function cO(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);t&&(n=n.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),r.push.apply(r,n)}return r}function dO(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{};t%2?cO(Object(r),!0).forEach((function(t){Gn(e,t,r[t])})):Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(r)):cO(Object(r)).forEach((function(t){Object.defineProperty(e,t,Object.getOwnPropertyDescriptor(r,t))}))}return e}var pO=vm.ListUtils.getTitleInListValues,fO=vm.ConfigUtils._widgetDefKeysToOmit,hO=vm.TreeUtils,vO=hO._fixImmutableValue,gO=hO.isImmutable,yO=(0,ye.memo)((function(e){var t=e.widgetFactory,r=Lg(e,lO),n=r.config,o=r.isFuncArg,i=r.fieldDefinition||{},a=i.fieldSettings,s=i.defaultValue,l=i.valueSources,u=o&&1==(null==l?void 0:l.length)&&"const"===(null==l?void 0:l[0]),c=(null==a?void 0:a.treeValues)||(null==a?void 0:a.listValues);return u&&s?"boolean"==typeof s?s?r.labelYes||"YES":r.labelNo||"NO":c?Array.isArray(s)?s.map((function(e){return pO(c,e)||e})).join(", "):pO(c,s)||s:""+s:t?t(r,n.ctx):"?"}));yO.displayName="WidgetFactoryMemo";var mO=function(e){var t=e.delta,r=e.isFuncArg,n=e.valueSrc,o=e.value,i=e.valueError,a=e.fieldError,s=e.asyncListValues,l=e.isSpecialRange,u=e.fieldDefinition,c=e.widget,d=e.widgetDefinition,p=e.widgetValueLabel,f=e.valueLabels,h=e.textSeparators,v=e.setValue,g=e.setFuncValue,y=e.config,m=e.field,b=e.fieldSrc,O=e.fieldPath,E=e.fieldType,S=e.isLHS,T=e.operator,_=e.readonly,w=e.parentField,R=e.parentFuncs,A=e.id,C=e.groupId,I=e.widgetId,x=d.factory,L=Lg(d,uO),N=o?o.map((function(e){return vO(e)})):void 0,j=(0,ye.useMemo)((function(){if(l){var e=[null==N?void 0:N.get(0),null==N?void 0:N.get(1)];return void 0===e[0]&&void 0===e[1]&&(e=void 0),e}return null==N?void 0:N.get(t)}),[l,o]),P=(0,ye.useMemo)((function(){return i?l?[i.get(0),i.get(1),i.get(2)]:null==i?void 0:i.get(t):null}),[l,o]),k=S?a:P,F=(u||{}).fieldSettings,D=p.label,M=p.placeholder,V=f?f.placeholder:null,U=gO(m)?null:m,B=Jl()(dO(dO(dO({},L),F),{},{config:y,field:U,fieldPath:O,fieldSrc:b,fieldType:E,isLHS:S,parentField:w,parentFuncs:R,fieldDefinition:u,operator:T,delta:t,isSpecialRange:l,isFuncArg:r,value:j,valueSrc:n,valueError:P,fieldError:a,errorMessage:k,label:D,placeholder:M,placeholders:V,textSeparators:h,setValue:v,setFuncValue:g,readonly:_,asyncListValues:s,id:A,groupId:C,widgetId:I,widgetFactory:x,widget:c}),[].concat(Qn(fO),["toJS"]));return me().createElement(yO,tb({widgetFactory:x},B))};mO.displayName="WidgetFactory";const bO=mO;function OO(e,t,r){return t=Un(t),Vn(e,EO()?Reflect.construct(t,r||[],Un(e).constructor):t.apply(e,r))}function EO(){try{var e=!Boolean.prototype.valueOf.call(Reflect.construct(Boolean,[],(function(){})))}catch(e){}return(EO=function(){return!!e})()}var SO=vm.ConfigUtils,TO=SO.getFieldConfig,_O=SO.getOperatorConfig,wO=SO.getFieldWidgetConfig,RO=vm.RuleUtils,AO=RO.getValueSourcesForFieldOp,CO=RO.getWidgetForFieldOp,IO=RO.getValueLabel,xO=vm.DefaultUtils.createListWithOneElement,LO=vm.OtherUtils.shallowEqual,NO=(vm.TreeUtils.isImmutable,{cardinality:1}),jO=function(e){function t(e){var r;return Pn(this,t),(r=OO(this,t,[e]))._setValue=function(e,t,n,o,i,a){var s=arguments.length>6&&void 0!==arguments[6]?arguments[6]:{};if(s.widgetId||(s.widgetId=o),e&&Array.isArray(i)){var l=[r.props.value.get(0),r.props.value.get(1)];l[0]!=i[0]&&r.props.setValue(0,i[0],n,a,s),l[1]!=i[1]&&r.props.setValue(1,i[1],n,a,s)}else r.props.setValue(t,i,n,a,s)},r._setValueSrc=function(e,t,n){var o={widgetId:t};r.props.setValueSrc(e,n,o)},r.renderWidget=function(e,t,r){var n=r.config,o=r.isFuncArg,i=r.leftField,a=r.operator,s=r.value,l=r.valueError,u=r.fieldError,c=r.readonly,d=r.parentField,p=r.parentFuncs,f=r.id,h=r.groupId,v=r.fieldSrc,g=r.fieldType,y=r.isLHS,m=r.setFuncValue,b=n.settings,O=t.widgets,E=t.iValues,S=t.aField,T=t.valueSources,_=o?E:s,w=o?i:S,R=O[e],A=R.valueSrc,C=R.valueLabel,I=R.widgetId,x=T.length>1&&!c,L=b.showLabels?me().createElement("label",{key:"label-"+I,className:"rule--label"},C.label):null;return me().createElement("div",{key:"wrapper-"+I,className:nb()("func"===A?"widget--func":"widget--widget",x?"widget--has-valuerscs":"widget--has-no-valuerscs")},"func"===A?null:L,me().createElement(bO,tb({key:I,id:f,groupId:h,widgetId:I,valueSrc:A,delta:e,value:_,valueError:l,fieldError:u,isFuncArg:o,isLHS:y},Hl()(t,["isSpecialRange","fieldDefinition","asyncListValues"]),Hl()(O[e],["widget","widgetDefinition","widgetValueLabel","valueLabels","textSeparators","setValue"]),{setFuncValue:m,config:n,field:w,fieldSrc:v,fieldType:g,parentField:d,parentFuncs:p,operator:a,readonly:c})))},r.renderValueSources=function(e,t,n){var o=n.config,i=n.isFuncArg,a=n.leftField,s=n.operator,l=n.readonly,u=o.settings,c=t.valueSources,d=t.widgets,p=t.aField,f=t.valueSourcesOptions,h=i?a:p,v=d[e],g=v.valueSrc,y=v.setValueSrc,m=r.ValueSources,b=u.showLabels?me().createElement("label",{className:"rule--label"}," "):null;return c.length>1&&!l&&me().createElement("div",{key:"wrapper-valuesrc-"+e,className:"widget--valuesrc"},b,me().createElement(m,{key:"valuesrc-"+e,delta:e,valueSources:f,valueSrc:g,config:o,field:h,operator:s,setValueSrc:y,readonly:l,title:u.valueSourcesPopupTitle}))},r.renderSep=function(e,t,r){var n=r.config,o=t.widgets,i=n.settings,a=o[e].sepText,s=i.showLabels?me().createElement("label",{className:"rule--label"}," "):null;return a&&me().createElement("div",{key:"widget-separators-"+e,className:nb()("widget--sep",0==e&&"widget--sep-first")},s,me().createElement("span",null,a))},r.renderWidgetDelta=function(e){return[r.renderSep(e,r.meta,r.props),r.renderValueSources(e,r.meta,r.props),r.renderWidget(e,r.meta,r.props)]},Bm(r),r.onPropsChanged(e),r}return qn(t,e),Mn(t,[{key:"onPropsChanged",value:function(e){var t=this.props,r=!this.ValueSources||(null==t?void 0:t.config)!==(null==e?void 0:e.config),n=["config","id","parentFuncs","field","fieldId","fieldSrc","fieldType","fieldFunc","fieldArg","leftField","operator","valueSrc","asyncListValues","isLHS","isFuncArg","isForRuleGroup","isCaseValue","value"].filter((function(r){return"parentFuncs"===r?!LO(e[r],t[r],!0):"field"===r?e.fieldId!==t.fieldId:e[r]!==t[r]}));if((!this.meta||n.length>0)&&(this.meta=this.getMeta(e,n)),r){var o=e.config,i=o.settings.renderValueSources;this.ValueSources=jb(o,i)}}},{key:"getMeta",value:function(e){var t,r,n,o,i=this,a=e.config,s=e.field,l=(e.fieldSrc,e.fieldType),u=e.fieldFunc,c=e.fieldArg,d=e.operator,p=e.valueSrc,f=e.value,h=e.isForRuleGroup,v=e.isCaseValue,g=e.isFuncArg,y=(e.leftField,e.asyncListValues),m=e.parentFuncs,b=e.isLHS,O=e.id,E=arguments.length>1&&void 0!==arguments[1]?arguments[1]:[],S=a.settings.valueSourcesInfo,T=g?{func:u,arg:c}:s,_=!s&&l,w=p,R=f;(g||h||v)&&(w=xO(p),R=xO(f));var A=TO(a,T);!A&&_&&(A=a.types[l]);var C,I=CO(a,T,d);!I&&_&&(I=null===(C=a.types[l])||void 0===C?void 0:C.mainWidget);var x=g?NO:_O(a,d,T);if((null==A||null==x)&&!v)return null;var L,N,j=null==x?void 0:x.isSpecialRange,P=j&&("field"===(null===(t=w)||void 0===t?void 0:t.get(0))||"field"===(null===(r=w)||void 0===r?void 0:r.get(1))),k=j&&!P,F=k?1:null!==(N=null==(L=x)?void 0:L.cardinality)&&void 0!==N?N:1;if(0===F)return null;var D=null===(n=this.meta)||void 0===n?void 0:n.valueSources,M=null===(o=this.meta)||void 0===o?void 0:o.valueSourcesOptions;D&&!["field","operator","config","fieldDefinition","isForRuleGroup"].filter((function(e){return E.includes(e)})).length||(D=AO(a,T,d,A),h&&(D=["value"]),T||(D=Object.keys(S)),M=D.map((function(e){return[e,{label:S[e].label}]})));var V=sO()(0,F).map((function(e){var t,r,n,o,s=null===(t=i.meta)||void 0===t||null===(t=t.widgets)||void 0===t?void 0:t[e],l=(null===(r=w)||void 0===r?void 0:r.get(e))||null,u=CO(a,T,d,l),c=wO(a,T,d,u,l);P&&(u=c.singleWidget,c=wO(a,T,d,u,l)),!c&&_&&(u=["func","field"].includes(l)?l:I,c=a.widgets[u]);var p=null===(n=c)||void 0===n?void 0:n.type,f=IO(a,T,d,e,l,k),h=IO(a,T,d,e,null,k),v=null!=x&&x.textSeparators?null==x?void 0:x.textSeparators[e]:null,g=null,y=null;j&&(g={placeholder:[(g=[IO(a,T,d,0),IO(a,T,d,1)])[0].placeholder,g[1].placeholder],label:[g[0].label,g[1].label]},y=null==x?void 0:x.textSeparators);var E=Nb({id:O,isLHS:b,delta:e,parentFuncs:m}),S=E+":VS",R=null==s?void 0:s.setValueSrc;R&&(null==s?void 0:s.widgetId)===E||(R=i._setValueSrc.bind(i,e,S));var A=null==s?void 0:s.setValue;return A&&(null==s?void 0:s.widgetId)===E&&(null==s?void 0:s.widgetType)===p&&(null===(o=i.meta)||void 0===o?void 0:o.isSpecialRange)===j||(A=i._setValue.bind(i,j,e,p,E)),{valueSrc:l,valueLabel:f,widget:u,sepText:v,widgetDefinition:c,widgetValueLabel:h,valueLabels:g,textSeparators:y,setValueSrc:R,setValue:A,widgetId:E,widgetType:p}}));return{defaultWidget:I,fieldDefinition:A,operatorDefinition:x,isSpecialRange:k,cardinality:F,valueSources:D,valueSourcesOptions:M,widgets:V,iValues:R,aField:T,asyncListValues:y}}},{key:"render",value:function(){if(!this.meta)return null;var e=this.meta,t=e.defaultWidget,r=e.cardinality;if(!t)return null;var n=t;return me().createElement(Cb,{className:"rule--widget rule--widget--".concat(n.toUpperCase()),key:"widget-col-"+n},sO()(0,r).map(this.renderWidgetDelta))}}])}(ye.Component);function PO(e,t,r){return t=Un(t),Vn(e,kO()?Reflect.construct(t,r||[],Un(e).constructor):t.apply(e,r))}function kO(){try{var e=!Boolean.prototype.valueOf.call(Reflect.construct(Boolean,[],(function(){})))}catch(e){}return(kO=function(){return!!e})()}jO.propTypes={config:ym().object.isRequired,value:ym().any,valueSrc:ym().any,valueError:ym().any,fieldError:ym().string,field:ym().any,fieldSrc:ym().string,fieldType:ym().string,fieldId:ym().string,operator:ym().string,readonly:ym().bool,asyncListValues:ym().array,id:ym().string,groupId:ym().string,setValue:ym().func,setValueSrc:ym().func,setFuncValue:ym().func,isFuncArg:ym().bool,fieldFunc:ym().string,fieldArg:ym().string,leftField:ym().any,isForRuleGroup:ym().bool,parentField:ym().string,parentFuncs:ym().array,isLHS:ym().bool,isCaseValue:ym().bool};var FO=vm.ConfigUtils.getFuncConfig,DO=vm.OtherUtils.shallowEqual,MO=function(e){function t(e){var r;return Pn(this,t),(r=PO(this,t,[e])).setFunc=function(e){var t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:{},n=r.props,o=n.isLHS,i=n.delta,a=n.parentFuncs,s=n.id;if(!t.widgetId){var l=Nb({id:s,isLHS:o,delta:i,parentFuncs:a});t.widgetId=l}r.props.setFuncValue(o?-1:i||0,a,null,e,"!func",void 0,t)},r.setArgValue=function(e,t,n,o,i){var a=r.props,s=(a.config,a.delta),l=a.isLHS,u=a.parentFuncs;r.props.setFuncValue(l?-1:s||0,u,e,t,n,o,i)},r.setArgValueSrc=function(e,t,n){var o=r.props,i=(o.config,o.delta),a=o.isLHS,s=o.parentFuncs;r.props.setFuncValue(a?-1:i||0,s,e,t,"!valueSrc",void 0,n)},r.renderFuncSelect=function(){var e,t,n=r.props,o=n.config,i=n.field,a=n.fieldType,s=n.fieldSrc,l=n.isLHS,u=n.operator,c=n.customProps,d=n.value,p=n.readonly,f=n.parentFuncs,h=n.id,v=n.groupId,g=n.isFuncArg,y=n.fieldDefinition,m={value:null!==(e=null==d||null===(t=d.get)||void 0===t?void 0:t.call(d,"func"))&&void 0!==e?e:null,setValue:r.setFunc,config:o,field:i,fieldType:a,fieldSrc:s,isLHS:l,operator:u,customProps:c,readonly:p,parentFuncs:f,isFuncArg:g,fieldDefinition:y,id:h,groupId:v},b=o.settings,O=b.showLabels,E=b.funcLabel,S=O?me().createElement("label",{className:"rule--label"},E):null;return me().createElement(Cb,{key:"func",className:"rule--func"},S,me().createElement(iO,m))},r.renderArgLabel=function(e,t){var n=t.valueSources,o=t.type,i=t.showPrefix,a=t.label,s=r.props.config,l=n&&1==n.length&&"const"==n[0];return s.settings.showLabels||"boolean"!=o&&!l||!i?null:me().createElement(Cb,{className:"rule--func--arg-label"},a||e)},r.renderArgLabelSep=function(e,t){var n=t.valueSources,o=t.type,i=t.showPrefix,a=r.props.config,s=n&&1==n.length&&"const"==n[0];return a.settings.showLabels||"boolean"!=o&&!s||!i?null:me().createElement(Cb,{className:"rule--func--arg-label-sep"},":")},r.renderArgVal=function(e,t,n){var o=r.props,i=o.config,a=o.field,s=o.fieldType,l=o.fieldSrc,u=o.isLHS,c=(o.operator,o.value),d=o.readonly,p=o.parentFuncs,f=o.id,h=o.groupId,v=o.fieldError,g=o.valueError,y=o.setFuncValue,m=c?c.getIn(["args",t]):null,b=m?m.get("value"):void 0,O=1==n.valueSources.length?n.valueSources[0]:void 0,E={config:i,fieldFunc:e,fieldArg:t,leftField:a,fieldType:s,fieldSrc:l,fieldError:v,valueError:g,isLHS:u,operator:null,value:b,valueSrc:m?m.get("valueSrc")||O||"value":O,setValue:r.setArgValue,setValueSrc:r.setArgValueSrc,setFuncValue:y,funcKey:e,argKey:t,argDefinition:n,readonly:d,parentFuncs:p,id:f,groupId:h};return me().createElement(Cb,{className:"rule--func--arg-value"},me().createElement(VO,E))},r.renderArgSep=function(e,t,r,n){var o=n.renderSeps;return r?me().createElement(Cb,{className:"rule--func--arg-sep"},o?o[r-1]:", "):null},r.renderBracketBefore=function(e){var t=e.renderBrackets;return me().createElement(Cb,{key:"before_args",className:"rule--func--bracket-before"},t?t[0]:"(")},r.renderBracketAfter=function(e){var t=e.renderBrackets;return me().createElement(Cb,{key:"after_args",className:"rule--func--bracket-after"},t?t[1]:")")},r.renderFuncArgs=function(){var e=r.meta,t=e.funcDefinition,n=e.funcKey;if(!n)return null;var o=(t||{}).args;return o?me().createElement(me().Fragment,null,r.renderBracketBefore(t),me().createElement(Cb,{key:"args-".concat(n),className:"rule--func--args rule--func--".concat(n,"--args")},Object.keys(o).map((function(e,i){return me().createElement(Cb,{key:"arg-".concat(e,"-").concat(i),className:"rule--func--arg rule--func--".concat(n,"--arg--").concat(e)},r.renderArgSep(e,o[e],i,t),r.renderArgLabel(e,o[e]),r.renderArgLabelSep(e,o[e]),r.renderArgVal(n,e,o[e]))}))),r.renderBracketAfter(t)):null},Bm(r),r.onPropsChanged(e),r}return qn(t,e),Mn(t,[{key:"onPropsChanged",value:function(e){var t=this.props;(!this.meta||["config","field","operator","value","fieldSrc","fieldType","isLHS"].map((function(r){return"parentFuncs"===r?!DO(e[r],t[r],!0):e[r]!==t[r]})).filter((function(e){return e})).length>0)&&(this.meta=this.getMeta(e))}},{key:"getMeta",value:function(e){var t,r,n=e.config,o=(e.field,e.operator,e.value),i=null!==(t=null==o||null===(r=o.get)||void 0===r?void 0:r.call(o,"func"))&&void 0!==t?t:null;return{funcDefinition:i?FO(n,i):null,funcKey:i}}},{key:"render",value:function(){var e=this.props.parentFuncs,t=e?e.map((function(e){var t=Hn(e,2),r=t[0],n=t[1];return"".concat(r,"_").concat(n)})).join("-"):"root",r=(null==e?void 0:e.length)||0;return me().createElement(Cb,{className:"rule--func--wrapper rule--func--wrapper--under-".concat(t," rule--func--wrapper--lev-").concat(r)},this.renderFuncSelect(),this.renderFuncArgs())}}])}(ye.Component);MO.propTypes={id:ym().string,groupId:ym().string,config:ym().object.isRequired,field:ym().any,fieldSrc:ym().string,fieldType:ym().string,fieldError:ym().string,operator:ym().string,customProps:ym().object,value:ym().object,setValue:ym().func.isRequired,setFuncValue:ym().func,readonly:ym().bool,parentFuncs:ym().array,fieldDefinition:ym().object,isFuncArg:ym().bool,isLHS:ym().bool,valueError:ym().string};var VO=function(e){function t(e){var r;return Pn(this,t),(r=PO(this,t,[e])).setValue=function(e,t,n,o,i){var a=r.props;(0,a.setValue)(a.argKey,t,n,o,i)},r.setValueSrc=function(e,t,n){var o=r.props;(0,o.setValueSrc)(o.argKey,t,n)},Bm(r),r.onPropsChanged(e),r}return qn(t,e),Mn(t,[{key:"onPropsChanged",value:function(e){var t=this.props;(!this.meta||["parentFuncs","funcKey","argKey"].map((function(r){return"parentFuncs"===r?!DO(e[r],t[r],!0):e[r]!==t[r]})).filter((function(e){return e})).length>0)&&(this.meta=this.getMeta(e))}},{key:"getMeta",value:function(e){var t=e.parentFuncs,r=e.funcKey,n=e.argKey;return{parentFuncs:[].concat(Qn(t||[]),[[r,n]])}}},{key:"render",value:function(){var e=this.meta.parentFuncs;return me().createElement(jO,tb({},this.props,{setValue:this.setValue,setValueSrc:this.setValueSrc,isFuncArg:!0,parentFuncs:e}))}}])}(ye.Component);function UO(e,t,r){return t=Un(t),Vn(e,BO()?Reflect.construct(t,r||[],Un(e).constructor):t.apply(e,r))}function BO(){try{var e=!Boolean.prototype.valueOf.call(Reflect.construct(Boolean,[],(function(){})))}catch(e){}return(BO=function(){return!!e})()}VO.propTypes={funcKey:ym().string.isRequired,argKey:ym().string.isRequired,setValue:ym().func.isRequired,setValueSrc:ym().func.isRequired,readonly:ym().bool,isLHS:ym().bool,parentFuncs:ym().array,id:ym().string,groupId:ym().string};var qO=function(e){function t(e){var r;return Pn(this,t),(r=UO(this,t,[e])).renderField=function(){var e=r.props,t=e.config,n=e.classname,o=e.selectedField,i=e.selectedFieldSrc,a=e.selectedFieldType,s=e.setField,l=e.setFuncValue,u=e.parentField,c=e.readonly,d=e.id,p=e.groupId,f=e.fieldError,h=e.valueError;if(!["func","field"].includes(i))return"?";var v="func"===i?me().createElement(MO,{isLHS:!0,config:t,value:o,fieldSrc:i,fieldType:a,fieldError:f,valueError:h,parentField:u,setValue:s,setFuncValue:l,readonly:c,id:d,groupId:p,key:"field-func-"+d}):me().createElement(Wb,{config:t,selectedField:o,selectedFieldSrc:i,selectedFieldType:a,parentField:u,setField:s,customProps:t.settings.customFieldSelectProps,readonly:c,id:d,groupId:p,key:"field-"+d}),g="func"===i?t.settings.funcLabel:t.settings.fieldLabel,y=t.settings.showLabels&&"func"!==i&&me().createElement("label",{className:"rule--label"},g);return me().createElement("div",{key:i,className:n},y,v)},r.renderFieldSources=function(){if(!r.meta)return null;var e=r.props,t=e.config,n=e.readonly,o=e.selectedFieldSrc,i=e.setFieldSrc,a=e.id,s=r.meta.fieldSourcesOptions,l=t.settings,u=r.ValueSources,c=l.showLabels?me().createElement("label",{className:"rule--label"}," "):null;return s.length>1&&!n&&me().createElement("div",{key:"fieldsrc",className:"rule--fieldsrc"},c,me().createElement(u,{key:"fieldsrc-"+a,valueSources:s,valueSrc:o,config:t,setValueSrc:i,readonly:n,title:l.fieldSourcesPopupTitle}))},Bm(r),r.onPropsChanged(e),r}return qn(t,e),Mn(t,[{key:"onPropsChanged",value:function(e){var t=this.props,r=!this.ValueSources||(null==t?void 0:t.config)!==(null==e?void 0:e.config);if((!this.meta||["config"].map((function(r){return e[r]!==t[r]})).filter((function(e){return e})).length>0)&&(this.meta=this.getMeta(e)),r){var n=e.config,o=n.settings.renderValueSources;this.ValueSources=function(e){return o(e,n.ctx)}}}},{key:"getMeta",value:function(e){var t=e.config.settings,r=t.valueSourcesInfo;return{fieldSourcesOptions:t.fieldSources.map((function(e){return[e,{label:r[e].label}]}))}}},{key:"render",value:function(){var e=this.props,t=(e.classname,e.canSelectFieldSource),r=t&&this.renderFieldSources(),n=this.renderField();return t?me().createElement(Cb,{className:"rule--field-wrapper"},r,n):n}}])}(ye.Component),GO=["factory"];function KO(e,t,r){return t=Un(t),Vn(e,WO()?Reflect.construct(t,r||[],Un(e).constructor):t.apply(e,r))}function WO(){try{var e=!Boolean.prototype.valueOf.call(Reflect.construct(Boolean,[],(function(){})))}catch(e){}return(WO=function(){return!!e})()}var zO=vm.ConfigUtils.getOperatorConfig,$O=function(e){function t(){return Pn(this,t),KO(this,t,arguments)}return qn(t,e),Mn(t,[{key:"render",value:function(){if(!this.props.selectedOperator)return null;var e=zO(this.props.config,this.props.selectedOperator,this.props.selectedField);if(void 0===e.options)return null;var t=e.options,r=t.factory,n=Lg(t,GO),o=r(Object.assign({},n,{config:this.props.config,field:this.props.selectedField,fieldSrc:this.props.selectedFieldSrc,operator:this.props.selectedOperator,options:this.props.operatorOptions,setOption:this.props.setOperatorOption,readonly:this.props.readonly}),this.props.config.ctx),i=this.props.selectedOperator;return me().createElement("div",{className:"rule--operator rule--operator--".concat(i.toUpperCase())},o)}}])}(ye.PureComponent);function HO(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);t&&(n=n.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),r.push.apply(r,n)}return r}function YO(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{};t%2?HO(Object(r),!0).forEach((function(t){Gn(e,t,r[t])})):Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(r)):HO(Object(r)).forEach((function(t){Object.defineProperty(e,t,Object.getOwnPropertyDescriptor(r,t))}))}return e}function QO(e,t,r){return t=Un(t),Vn(e,XO()?Reflect.construct(t,r||[],Un(e).constructor):t.apply(e,r))}function XO(){try{var e=!Boolean.prototype.valueOf.call(Reflect.construct(Boolean,[],(function(){})))}catch(e){}return(XO=function(){return!!e})()}$O.propTypes={config:ym().object.isRequired,operatorOptions:ym().any.isRequired,selectedField:ym().any,selectedFieldSrc:ym().string,selectedOperator:ym().string.isRequired,readonly:ym().bool,setOperatorOption:ym().func.isRequired};var JO=vm.ConfigUtils,ZO=JO.getFieldConfig,eE=JO.getOperatorConfig,tE=JO.getFieldWidgetConfig,rE=JO.getFieldId,nE=vm.RuleUtils.isEmptyRuleProperties,oE=function(e){function t(e){var r;return Pn(this,t),r=QO(this,t,[e]),Bm(r),r.removeSelf=r.removeSelf.bind(r),r.setLock=r.setLock.bind(r),r.onPropsChanged(e),r}return qn(t,e),Mn(t,[{key:"onPropsChanged",value:function(e){var t=this,r=this.props,n=!this.Icon||(null==r?void 0:r.config)!==(null==e?void 0:e.config);if((!this.meta||["selectedField","selectedFieldSrc","selectedFieldType","selectedOperator","config","reordableNodesCnt","isLocked"].map((function(t){return e[t]!==r[t]})).filter((function(e){return e})).length>0)&&(this.meta=this.getMeta(e)),n){var o=e.config,i=o.settings,a=i.renderIcon,s=i.renderButton,l=i.renderButtonGroup,u=i.renderSwitch,c=i.renderBeforeWidget,d=i.renderAfterWidget,p=i.renderRuleError;this.Icon=jb(o,a),this.Btn=jb(o,s),this.BtnGrp=jb(o,l),this.Switch=jb(o,u),this.BeforeWidget=jb(o,c),this.AfterWidget=jb(o,d),this.RuleError=jb(o,p)}this.doRemove=function(){t.props.removeSelf()}}},{key:"getMeta",value:function(e){var t=e.selectedField,r=e.selectedFieldType,n=e.selectedOperator,o=e.config,i=e.reordableNodesCnt,a=e.isLocked,s=o.settings.keepInputOnChangeFieldSrc,l=rE(t,o),u=ZO(o,t),c=u&&"!struct"===u.type,d=!!t||s&&r,p=d&&n,f=eE(o,n,t),h=f&&null!=f.options,v=tE(o,t,n,null,null)||{},g=v.hideOperator;return{selectedFieldId:l,selectedFieldWidgetConfig:v,showDragIcon:o.settings.canReorder&&i>1&&!a,showOperator:d&&!g,showOperatorLabel:d&&g&&v.operatorInlineLabel,showWidget:p&&!c,showOperatorOptions:p&&h}}},{key:"setLock",value:function(e){this.props.setLock(e)}},{key:"removeSelf",value:function(){var e=this.props,t=e.confirmFn,r=e.config,n=r.settings,o=n.renderConfirm,i=n.removeRuleConfirmOptions;i&&!this.isEmptyCurrentRule()?o.call(r.ctx,YO(YO({},i),{},{onOk:this.doRemove,onCancel:null,confirmFn:t}),r.ctx):this.doRemove()}},{key:"_buildWidgetProps",value:function(e,t){var r=e.selectedField,n=e.selectedFieldSrc,o=e.selectedFieldType,i=e.selectedOperator,a=e.operatorOptions,s=e.value,l=e.valueType,u=e.valueSrc,c=e.asyncListValues,d=e.valueError,p=e.fieldError,f=e.parentField;return{field:r,fieldSrc:n,fieldType:o,fieldId:t.selectedFieldId,operator:i,operatorOptions:a,value:s,valueType:l,valueSrc:u,asyncListValues:c,valueError:d,fieldError:p,parentField:f}}},{key:"isEmptyCurrentRule",value:function(){var e=this.props.config,t=this._buildWidgetProps(this.props,this.meta);return nE(t,e)}},{key:"renderField",value:function(){var e=this.props,t=e.config,r=e.isLocked,n=e.parentField,o=e.groupId,i=e.id,a=e.selectedFieldSrc,s=e.selectedField,l=e.selectedFieldType,u=e.setField,c=e.setFuncValue,d=e.setFieldSrc,p=e.fieldError,f=t.settings.immutableFieldsMode,h=this.meta.selectedFieldId;return me().createElement(qO,{key:"field",classname:nb()("func"==a?"rule--field--func":"rule--field"),config:t,canSelectFieldSource:!n,selectedField:s,selectedFieldSrc:a,selectedFieldType:l,selectedFieldId:h,fieldError:p,setField:f?Ib:u,setFuncValue:f?Ib:c,setFieldSrc:f?Ib:d,parentField:n,readonly:f||r,id:i,groupId:o})}},{key:"renderOperator",value:function(){var e=this.props,t=e.config,r=e.isLocked,n=this.meta,o=n.selectedFieldId,i=n.selectedFieldWidgetConfig,a=n.showOperator,s=n.showOperatorLabel,l=t.settings.immutableOpsMode;return me().createElement(Fb,{key:"operator",config:t,selectedField:this.props.selectedField,selectedFieldSrc:this.props.selectedFieldSrc,selectedFieldType:this.props.selectedFieldType,selectedFieldId:o,selectedOperator:this.props.selectedOperator,setOperator:l?Ib:this.props.setOperator,showOperator:a,showOperatorLabel:s,selectedFieldWidgetConfig:i,readonly:l||r,id:this.props.id,groupId:this.props.groupId})}},{key:"renderWidget",value:function(){var e=this.props,t=e.config,r=e.isLocked,n=this.meta.showWidget,o=t.settings.immutableValuesMode;if(!n)return null;var i=me().createElement(jO,tb({key:"values"},this._buildWidgetProps(this.props,this.meta),{config:t,setValue:o?Ib:this.props.setValue,setValueSrc:o?Ib:this.props.setValueSrc,setFuncValue:o?Ib:this.props.setFuncValue,readonly:o||r,id:this.props.id,groupId:this.props.groupId}));return me().createElement(Cb,{key:"widget-for-"+this.props.selectedOperator,className:"rule--value"},i)}},{key:"renderOperatorOptions",value:function(){var e=this.props.config,t=this.meta.showOperatorOptions,r=e.settings,n=r.immutableOpsMode,o=r.immutableValuesMode;if(!t)return null;var i=me().createElement($O,{key:"operatorOptions",selectedField:this.props.selectedField,selectedOperator:this.props.selectedOperator,operatorOptions:this.props.operatorOptions,setOperatorOption:n?Ib:this.props.setOperatorOption,config:e,readonly:o});return me().createElement(Cb,{key:"op-options-for-"+this.props.selectedOperator,className:"rule--operator-options"},i)}},{key:"renderBeforeWidget",value:function(){var e=this.BeforeWidget;return e?me().createElement(Cb,{key:"before-widget-for-"+this.props.selectedOperator,className:"rule--before-widget"},me().createElement(e,this.props)):null}},{key:"renderAfterWidget",value:function(){var e=this.AfterWidget;return e?me().createElement(Cb,{key:"after-widget-for-"+this.props.selectedOperator,className:"rule--after-widget"},me().createElement(e,this.props)):null}},{key:"renderError",value:function(){var e=this.props,t=e.config,r=e.valueError,n=e.fieldError,o=t.settings.showErrorMessage,i=this.RuleError,a=[n].concat(Qn((null==r?void 0:r.toArray())||[])).filter((function(e){return!!e})).shift()||null;return o&&a&&me().createElement("div",{className:"rule--error"},i?me().createElement(i,{error:a}):a)}},{key:"renderDrag",value:function(){var e=this.props.handleDraggerMouseDown,t=this.meta.showDragIcon,r=this.Icon,n=me().createElement(r,{type:"drag"});return t&&me().createElement("div",{key:"rule-drag-icon",onMouseDown:e,className:"qb-drag-handler rule--drag-handler"},n)}},{key:"renderDel",value:function(){var e=this.props,t=e.config,r=e.isLocked,n=t.settings,o=n.deleteLabel,i=n.immutableGroupsMode,a=n.canDeleteLocked,s=this.Icon,l=this.Btn;return!i&&(!r||r&&a)&&me().createElement(l,{key:"rule-del",type:"delRule",onClick:this.removeSelf,label:o,config:t,renderIcon:s})}},{key:"renderLock",value:function(){var e=this.props,t=e.config,r=e.isLocked,n=e.isTrueLocked,o=e.id,i=t.settings,a=i.lockLabel,s=i.lockedLabel,l=i.showLock,u=this.Switch;return l&&!(r&&!n)&&me().createElement(u,{key:"rule-lock",type:"lock",id:o,value:r,setValue:this.setLock,label:a,checkedLabel:s,hideLabel:!0,config:t})}},{key:"render",value:function(){var e=this.meta,t=e.showOperatorOptions,r=e.selectedFieldWidgetConfig,n=this.props,o=n.valueSrc,i=n.value,a=n.config,s="value"==(null==o?void 0:o.first())&&!t&&1==i.size&&r.fullWidth,l=this.BtnGrp,u=[this.renderField(),this.renderOperator(),this.renderBeforeWidget(),this.renderWidget(),this.renderAfterWidget(),this.renderOperatorOptions()],c=me().createElement("div",{key:"rule-body",className:nb()("rule--body",s&&"can--shrink--value")},u),d=this.renderError(),p=this.renderDrag(),f=this.renderLock(),h=this.renderDel();return me().createElement(me().Fragment,null,p,me().createElement("div",{key:"rule-body-wrapper",className:"rule--body--wrapper"},c,d),me().createElement("div",{key:"rule-header-wrapper",className:"rule--header"},me().createElement(l,{key:"rule-header-group",config:a},f,h)))}}])}(ye.Component);oE.propTypes={id:ym().string.isRequired,groupId:ym().string,selectedField:ym().any,selectedFieldSrc:ym().string,selectedFieldType:ym().string,selectedOperator:ym().string,operatorOptions:ym().object,config:ym().object.isRequired,value:ym().any,valueSrc:ym().any,valueType:ym().any,asyncListValues:ym().array,isDraggingMe:ym().bool,isDraggingTempo:ym().bool,parentField:ym().string,valueError:ym().any,fieldError:ym().string,isLocked:ym().bool,isTrueLocked:ym().bool,handleDraggerMouseDown:ym().func,setField:ym().func,setFieldSrc:ym().func,setOperator:ym().func,setOperatorOption:ym().func,setLock:ym().func,removeSelf:ym().func,setValue:ym().func,setValueSrc:ym().func,setFuncValue:ym().func,reordableNodesCnt:ym().number,totalRulesCnt:ym().number,parentReordableNodesCnt:ym().number};const iE=function(e){var t=(0,Em.connect)((function(e){return{dragging:e.dragging}}),null,null,{context:bm})(function(e){var t;return t=function(t){function r(e){var t;return Pn(this,r),(t=ob(this,r,[e])).dummyFn=function(){},t.removeSelf=function(){t.props.actions.removeRule(t.props.path)},t.setLock=function(){var e=arguments.length>0&&void 0!==arguments[0]?arguments[0]:null;t.props.actions.setLock(t.props.path,e)},t.setField=function(e,r,n){t.props.actions.setField(t.props.path,e,r,n)},t.setFieldSrc=function(e){t.props.actions.setFieldSrc(t.props.path,e)},t.setOperator=function(e){t.props.actions.setOperator(t.props.path,e)},t.setOperatorOption=function(e,r){t.props.actions.setOperatorOption(t.props.path,e,r)},t.setValue=function(e,r,n,o,i){t.props.actions.setValue(t.props.path,e,r,n,o,i)},t.setValueSrc=function(e,r,n){t.props.actions.setValueSrc(t.props.path,e,r,n)},t.setFuncValue=function(e,r,n,o,i,a,s){t.props.actions.setFuncValue(t.props.path,e,r,n,o,i,a,s)},t.pureShouldComponentUpdate=Um(t),t.dummyFn.isDummyFn=!0,t}return qn(r,t),Mn(r,[{key:"shouldComponentUpdate",value:function(e,t){var r=this.props,n=this.state,o=this.pureShouldComponentUpdate(e,t);if(o&&n==t&&r!=e){var i=(e.dragging.id||r.dragging.id)==e.id,a=[];for(var s in e){var l=e[s]!=r[s];"dragging"!=s||i||(l=!1),l&&a.push(s)}a.length||(o=!1)}return o}},{key:"render",value:function(){var t=this.props.dragging.id==this.props.id,r=ab(this.props.config,this.props.field),n=this.props.fieldType||(null==r?void 0:r.type)||null,o=this.props.config.settings.showErrorMessage,i=(r&&r.type,!t&&this.props.isDraggingTempo),a=this.props,s=a.valueError,l=null!=([a.fieldError].concat(Qn((null==s?void 0:s.toArray())||[])).filter((function(e){return!!e})).shift()||null)&&o;return me().createElement("div",{className:nb()("group-or-rule-container","rule-container",l?"rule-with-error":null),"data-id":this.props.id},[t?me().createElement(e,{key:"dragging",id:this.props.id,groupId:this.props.groupId,isDraggingMe:!0,isDraggingTempo:!0,dragging:this.props.dragging,setField:this.dummyFn,setFieldSrc:this.dummyFn,setFuncValue:this.dummyFn,setOperator:this.dummyFn,setOperatorOption:this.dummyFn,setLock:this.dummyFn,removeSelf:this.dummyFn,setValue:this.dummyFn,setValueSrc:this.dummyFn,selectedField:this.props.field||null,selectedFieldSrc:this.props.fieldSrc||"field",selectedFieldType:n,parentField:this.props.parentField||null,selectedOperator:this.props.operator||null,value:this.props.value||null,valueSrc:this.props.valueSrc||null,valueType:this.props.valueType||null,valueError:this.props.valueError||null,fieldError:this.props.fieldError||null,operatorOptions:this.props.operatorOptions,config:this.props.config,reordableNodesCnt:this.props.reordableNodesCnt,totalRulesCnt:this.props.totalRulesCnt,asyncListValues:this.props.asyncListValues,isLocked:this.props.isLocked,isTrueLocked:this.props.isTrueLocked,parentReordableNodesCnt:this.props.parentReordableNodesCnt}):null,me().createElement(e,{key:this.props.id,id:this.props.id,groupId:this.props.groupId,isDraggingMe:t,isDraggingTempo:i,onDragStart:this.props.onDragStart,setLock:i?this.dummyFn:this.setLock,removeSelf:i?this.dummyFn:this.removeSelf,setField:i?this.dummyFn:this.setField,setFieldSrc:i?this.dummyFn:this.setFieldSrc,setFuncValue:i?this.dummyFn:this.setFuncValue,setOperator:i?this.dummyFn:this.setOperator,setOperatorOption:i?this.dummyFn:this.setOperatorOption,setValue:i?this.dummyFn:this.setValue,setValueSrc:i?this.dummyFn:this.setValueSrc,selectedField:this.props.field||null,selectedFieldSrc:this.props.fieldSrc||"field",selectedFieldType:n,parentField:this.props.parentField||null,selectedOperator:this.props.operator||null,value:this.props.value||null,valueSrc:this.props.valueSrc||null,valueType:this.props.valueType||null,valueError:this.props.valueError||null,fieldError:this.props.fieldError||null,operatorOptions:this.props.operatorOptions,config:this.props.config,reordableNodesCnt:this.props.reordableNodesCnt,totalRulesCnt:this.props.totalRulesCnt,asyncListValues:this.props.asyncListValues,isLocked:this.props.isLocked,isTrueLocked:this.props.isTrueLocked,parentReordableNodesCnt:this.props.parentReordableNodesCnt})])}}])}(ye.Component),t.propTypes={id:ym().string.isRequired,groupId:ym().string,config:ym().object.isRequired,path:ym().any.isRequired,operator:ym().string,field:ym().any,fieldSrc:ym().string,fieldType:ym().string,actions:ym().object.isRequired,onDragStart:ym().func,value:ym().any,valueSrc:ym().any,asyncListValues:ym().array,valueError:ym().any,fieldError:ym().string,operatorOptions:ym().object,reordableNodesCnt:ym().number,parentField:ym().string,isLocked:ym().bool,isTrueLocked:ym().bool,dragging:ym().object,isDraggingTempo:ym().bool},t}(e));return t.displayName="ConnectedRuleContainer",t}(vb("rule")(Lb(oE)));var aE=p(3547),sE=p.n(aE);function lE(e,t,r){return t=Un(t),Vn(e,uE()?Reflect.construct(t,r||[],Un(e).constructor):t.apply(e,r))}function uE(){try{var e=!Boolean.prototype.valueOf.call(Reflect.construct(Boolean,[],(function(){})))}catch(e){}return(uE=function(){return!!e})()}var cE=vm.DefaultUtils.defaultGroupConjunction;const dE=function(e,t){var r=(0,Em.connect)((function(e){return{dragging:e.dragging}}),null,null,{context:bm})(function(e,t){var r;return r=function(r){function n(e){var r;return Pn(this,n),(r=lE(this,n,[e]))._selectedConjunction=function(e){return(e=e||r.props).conjunction||cE(e.config,e.field)},r.setConjunction=function(){var e=arguments.length>0&&void 0!==arguments[0]?arguments[0]:null;r.props.actions.setConjunction(r.props.path,e)},r.setNot=function(){var e=arguments.length>0&&void 0!==arguments[0]?arguments[0]:null;r.props.actions.setNot(r.props.path,e)},r.setLock=function(){var e=arguments.length>0&&void 0!==arguments[0]?arguments[0]:null;r.props.actions.setLock(r.props.path,e)},r.dummyFn=function(){},r.removeSelf=function(){r.props.actions.removeGroup(r.props.path)},r.addGroup=function(){r.props.actions.addGroup(r.props.path)},r.addCaseGroup=function(){r.props.actions.addCaseGroup(r.props.path)},r.addDefaultCaseGroup=function(){r.props.actions.addDefaultCaseGroup(r.props.path)},r.addRule=function(){var e="rule_group"==t?r.props.field:null;r.props.actions.addRule(r.props.path,void 0,void 0,void 0,e)},r.setField=function(e,t,n){r.props.actions.setField(r.props.path,e,t,n)},r.setOperator=function(e){r.props.actions.setOperator(r.props.path,e)},r.setValue=function(e,t,n,o,i){r.props.actions.setValue(r.props.path,e,t,n,o,i)},r.setValueSrc=function(e,t,n){r.props.actions.setValueSrc(r.props.path,e,t,n)},r.setFuncValue=function(e,t,n,o,i,a,s){r.props.actions.setFuncValue(r.props.path,e,t,n,o,i,a,s)},r.pureShouldComponentUpdate=Um(r),Bm(r),r.selectedConjunction=r._selectedConjunction(e),r.conjunctionOptions=r._getConjunctionOptions(e),r.dummyFn.isDummyFn=!0,r}return qn(n,r),Mn(n,[{key:"shouldComponentUpdate",value:function(e,t){var r=this.props,n=this.state,o=this.pureShouldComponentUpdate(e,t);if(o&&n==t&&r!=e){var i=(e.dragging.id||r.dragging.id)==e.id,a=[];for(var s in e){var l=e[s]!=r[s];"dragging"!=s||i||(l=!1),l&&a.push(s)}a.length||(o=!1)}return o}},{key:"onPropsChanged",value:function(e){var t=e.config,r=(e.id,e.conjunction),n=this.props.config,o=this.props.conjunction;n==t&&o==r||(this.selectedConjunction=this._selectedConjunction(e),this.conjunctionOptions=this._getConjunctionOptions(e))}},{key:"_getConjunctionOptions",value:function(e){var t=this;return Fy()(e.config.conjunctions,(function(r,n){return{id:"conjunction-".concat(e.id,"-").concat(n),name:"conjunction[".concat(e.id,"]"),key:n,label:r.label,checked:n===t._selectedConjunction(e)}}))}},{key:"render",value:function(){var t=this.props.config.settings.showErrorMessage,r=this.props.dragging.id==this.props.id,n=this.props.path.size,o=this.props.config.settings.maxNesting,i=!r&&this.props.isDraggingTempo,a=this.props.fieldType||null,s=this.props.valueError,l=null!=(Qn((null==s?void 0:s.toArray())||[]).filter((function(e){return!!e})).shift()||null)&&t,u=void 0===o||n<o,c=1==n;return me().createElement("div",{className:nb()("group-or-rule-container","group-container",l?"group-with-error":null),"data-id":this.props.id},[r?me().createElement(e,{key:"dragging",id:this.props.id,groupId:this.props.groupId,isDraggingMe:!0,isDraggingTempo:!0,dragging:this.props.dragging,isRoot:c,allowFurtherNesting:u,conjunctionOptions:this.conjunctionOptions,not:this.props.not,selectedConjunction:this.selectedConjunction,setConjunction:this.dummyFn,setNot:this.dummyFn,setLock:this.dummyFn,removeSelf:this.dummyFn,addGroup:this.dummyFn,addCaseGroup:this.dummyFn,addDefaultCaseGroup:this.dummyFn,addRule:this.dummyFn,setField:this.dummyFn,setFuncValue:this.dummyFn,setOperator:this.dummyFn,setValue:this.dummyFn,setValueSrc:this.dummyFn,value:this.props.value||null,valueError:this.props.valueError||null,valueSrc:this.props.valueSrc||null,config:this.props.config,children1:this.props.children1,actions:this.props.actions,reordableNodesCnt:this.props.reordableNodesCnt,totalRulesCnt:this.props.totalRulesCnt,selectedField:this.props.field||null,selectedFieldSrc:this.props.fieldSrc||"field",selectedFieldType:a,parentField:this.props.parentField||null,selectedOperator:this.props.operator||null,isLocked:this.props.isLocked,isTrueLocked:this.props.isTrueLocked,parentReordableNodesCnt:this.props.parentReordableNodesCnt}):null,me().createElement(e,{key:this.props.id,id:this.props.id,groupId:this.props.groupId,isDraggingMe:r,isDraggingTempo:i,onDragStart:this.props.onDragStart,isRoot:c,allowFurtherNesting:u,conjunctionOptions:this.conjunctionOptions,not:this.props.not,selectedConjunction:this.selectedConjunction,setConjunction:i?this.dummyFn:this.setConjunction,setNot:i?this.dummyFn:this.setNot,setLock:i?this.dummyFn:this.setLock,removeSelf:i?this.dummyFn:this.removeSelf,addGroup:i?this.dummyFn:this.addGroup,addCaseGroup:i?this.dummyFn:this.addCaseGroup,addDefaultCaseGroup:i?this.dummyFn:this.addDefaultCaseGroup,addRule:i?this.dummyFn:this.addRule,setField:i?this.dummyFn:this.setField,setFuncValue:i?this.dummyFn:this.setFuncValue,setOperator:i?this.dummyFn:this.setOperator,setValue:i?this.dummyFn:this.setValue,setValueSrc:i?this.dummyFn:this.setValueSrc,value:this.props.value||null,valueError:this.props.valueError||null,valueSrc:this.props.valueSrc||null,config:this.props.config,children1:this.props.children1,actions:this.props.actions,reordableNodesCnt:this.props.reordableNodesCnt,totalRulesCnt:this.props.totalRulesCnt,selectedField:this.props.field||null,selectedFieldSrc:this.props.fieldSrc||"field",selectedFieldType:a,parentField:this.props.parentField||null,selectedOperator:this.props.operator||null,isLocked:this.props.isLocked,isTrueLocked:this.props.isTrueLocked,parentReordableNodesCnt:this.props.parentReordableNodesCnt})])}}])}(ye.Component),r.propTypes={config:ym().object.isRequired,actions:ym().object.isRequired,path:ym().any.isRequired,id:ym().string.isRequired,groupId:ym().string,not:ym().bool,conjunction:ym().string,children1:ym().any,onDragStart:ym().func,reordableNodesCnt:ym().number,field:ym().any,fieldSrc:ym().string,fieldType:ym().string,parentField:ym().string,value:ym().any,valueSrc:ym().any,valueError:ym().any,isLocked:ym().bool,isTrueLocked:ym().bool,dragging:ym().object,isDraggingTempo:ym().bool},r}(e,t));return r.displayName="ConnectedGroupContainer",r};function pE(e,t,r){return t=Un(t),Vn(e,fE()?Reflect.construct(t,r||[],Un(e).constructor):t.apply(e,r))}function fE(){try{var e=!Boolean.prototype.valueOf.call(Reflect.construct(Boolean,[],(function(){})))}catch(e){}return(fE=function(){return!!e})()}var hE={topLeft:"group--actions--tl",topCenter:"group--actions--tc",topRight:"group--actions--tr",bottomLeft:"group--actions--bl",bottomCenter:"group--actions--bc",bottomRight:"group--actions--br"},vE=function(e){function t(){return Pn(this,t),pE(this,t,arguments)}return qn(t,e),Mn(t,[{key:"render",value:function(){var e=this.props,t=e.config,r=e.addRule,n=e.addGroup,o=e.removeSelf,i=e.setLock,a=e.isLocked,s=e.isTrueLocked,l=e.id,u=e.canAddGroup,c=e.canAddRule,d=e.canDeleteGroup,p=t.settings,f=p.immutableGroupsMode,h=p.addRuleLabel,v=p.addGroupLabel,g=p.delGroupLabel,y=p.groupActionsPosition,m=p.renderButton,b=p.renderIcon,O=p.renderSwitch,E=p.renderButtonGroup,S=p.lockLabel,T=p.lockedLabel,_=p.showLock,w=p.canDeleteLocked,R=function(e){return b(e,t.ctx)},A=function(e){return m(e,t.ctx)},C=function(e){return O(e,t.ctx)},I=function(e){return E(e,t.ctx)},x=hE[y||"topRight"],L=_&&!(a&&!s)&&me().createElement(C,{type:"lock",id:l,value:a,setValue:i,label:S,checkedLabel:T,config:t}),N=!f&&c&&!a&&me().createElement(A,{type:"addRule",onClick:r,label:h,readonly:a,config:t,renderIcon:R}),j=!f&&u&&!a&&me().createElement(A,{type:"addGroup",onClick:n,label:v,readonly:a,config:t,renderIcon:R}),P=!f&&d&&(!a||a&&w)&&me().createElement(A,{type:"delGroup",onClick:o,label:g,config:t,renderIcon:R});return me().createElement("div",{className:"group--actions ".concat(x)},me().createElement(I,{config:t},L,N,j,P))}}])}(ye.PureComponent);function gE(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);t&&(n=n.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),r.push.apply(r,n)}return r}function yE(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{};t%2?gE(Object(r),!0).forEach((function(t){Gn(e,t,r[t])})):Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(r)):gE(Object(r)).forEach((function(t){Object.defineProperty(e,t,Object.getOwnPropertyDescriptor(r,t))}))}return e}function mE(e,t,r){return t=Un(t),Vn(e,bE()?Reflect.construct(t,r||[],Un(e).constructor):t.apply(e,r))}function bE(){try{var e=!Boolean.prototype.valueOf.call(Reflect.construct(Boolean,[],(function(){})))}catch(e){}return(bE=function(){return!!e})()}var OE=vm.RuleUtils.isEmptyGroupChildren,EE=function(e){function t(e){var r;return Pn(this,t),(r=mE(this,t,[e])).childrenClassName=function(){return""},r.renderBeforeActions=function(){var e=r.BeforeActions;return null==e?null:me().createElement(e,tb({key:"group-actions-before"},r.props))},r.renderAfterActions=function(){var e=r.AfterActions;return null==e?null:me().createElement(e,tb({key:"group-actions-after"},r.props))},Bm(r),r.onPropsChanged(e),r.removeSelf=r.removeSelf.bind(r),r.setLock=r.setLock.bind(r),r.renderItem=r.renderItem.bind(r),r}return qn(t,e),Mn(t,[{key:"onPropsChanged",value:function(e){var t=this,r=this.props;if(!this.Icon||(null==r?void 0:r.config)!==(null==e?void 0:e.config)){var n=e.config,o=n.settings,i=o.renderIcon,a=o.renderConjs,s=o.renderBeforeActions,l=o.renderAfterActions;this.Icon=jb(n,i),this.Conjs=jb(n,a),this.BeforeActions=jb(n,s),this.AfterActions=jb(n,l)}this.doRemove=function(){t.props.removeSelf()}}},{key:"isGroupTopPosition",value:function(){return sE()(this.props.config.settings.groupActionsPosition||"topRight","top")}},{key:"setLock",value:function(e){this.props.setLock(e)}},{key:"removeSelf",value:function(){var e=this.props,t=e.confirmFn,r=e.config,n=r.settings,o=n.renderConfirm,i=n.removeGroupConfirmOptions;i&&!this.isEmptyCurrentGroup()?o.call(r.ctx,yE(yE({},i),{},{onOk:this.doRemove,onCancel:null,confirmFn:t}),r.ctx):this.doRemove()}},{key:"isEmptyCurrentGroup",value:function(){var e=this.props,t=e.children1,r=e.config;return OE(t,r)}},{key:"showNot",value:function(){return this.props.config.settings.showNot}},{key:"showConjs",value:function(){var e=this.props,t=e.conjunctionOptions;return e.children1,e.config,Object.keys(t).length>1||this.showNot()}},{key:"isNoChildren",value:function(){var e=this.props.children1;return!e||0==e.size}},{key:"isOneChild",value:function(){var e=this.props.children1;return!e||e.size<2}},{key:"renderChildrenWrapper",value:function(){return this.props.children1&&me().createElement("div",{key:"group-children",className:nb()("group--children",this.showConjs()?"":"hide--conjs",this.isOneChild()?"hide--line":"",this.isOneChild()?"one--child":"",this.childrenClassName())},this.renderChildren())}},{key:"renderHeaderWrapper",value:function(){var e=this.isGroupTopPosition();return me().createElement("div",{key:"group-header",className:nb()("group--header",this.isOneChild()?"one--child":"",this.showConjs()?"":"hide--conjs",this.isOneChild()?"hide--line":"",this.isNoChildren()?"no--children":"")},this.renderHeader(),e&&this.renderBeforeActions(),e&&this.renderActions(),e&&this.renderAfterActions())}},{key:"renderFooterWrapper",value:function(){return!this.isGroupTopPosition()&&me().createElement("div",{key:"group-footer",className:"group--footer"},this.renderBeforeActions(),this.renderActions(),this.renderAfterActions())}},{key:"renderActions",value:function(){var e=this.props,t=e.config,r=e.addRule,n=e.addGroup,o=e.isLocked,i=e.isTrueLocked,a=e.id;return me().createElement(vE,{key:"group-actions",config:t,addRule:r,addGroup:n,canAddGroup:this.canAddGroup(),canAddRule:this.canAddRule(),canDeleteGroup:this.canDeleteGroup(),removeSelf:this.removeSelf,setLock:this.setLock,isLocked:o,isTrueLocked:i,id:a})}},{key:"canAddGroup",value:function(){return this.props.allowFurtherNesting}},{key:"canAddRule",value:function(){var e=this.props.config.settings.maxNumberOfRules,t=this.props.totalRulesCnt;return!e||t<e}},{key:"canDeleteGroup",value:function(){return!this.props.isRoot}},{key:"renderChildren",value:function(){var e=this.props.children1;return e?e.valueSeq().toArray().map(this.renderItem):null}},{key:"renderItem",value:function(e){if(e){var t=this.props,r=t.config,n=t.actions,o=t.onDragStart,i=t.isLocked,a="group"==e.get("type")&&null!=e.getIn(["properties","field"])?"rule_group":e.get("type");return me().createElement(mS,tb({},this.extraPropsForItem(e),{key:e.get("id"),id:e.get("id"),groupId:t.id,path:e.get("path"),type:a,properties:e.get("properties"),config:r,actions:n,children1:e.get("children1"),reordableNodesCnt:this.reordableNodesCntForItem(e),totalRulesCnt:this.totalRulesCntForItem(e),parentReordableNodesCnt:this.reordableNodesCnt(),onDragStart:o,isDraggingTempo:this.props.isDraggingTempo,isParentLocked:i}))}}},{key:"extraPropsForItem",value:function(e){return{}}},{key:"reordableNodesCnt",value:function(){return this.props.isLocked?0:this.props.reordableNodesCnt}},{key:"totalRulesCntForItem",value:function(e){return this.props.totalRulesCnt}},{key:"reordableNodesCntForItem",value:function(e){return this.props.isLocked?0:this.reordableNodesCnt()}},{key:"showDragIcon",value:function(){var e=this.props,t=e.config,r=e.isRoot,n=e.isLocked,o=this.reordableNodesCnt();return t.settings.canReorder&&!r&&o>1&&!n}},{key:"renderDrag",value:function(){var e=this.props.handleDraggerMouseDown,t=this.Icon,r=me().createElement(t,{type:"drag"});return this.showDragIcon()&&me().createElement("div",{key:"group-drag-icon",onMouseDown:e,className:"qb-drag-handler group--drag-handler"},r)}},{key:"conjunctionOptions",value:function(){return this.props.conjunctionOptions}},{key:"renderConjs",value:function(){var e=this.props,t=e.config,r=e.children1,n=e.id,o=e.selectedConjunction,i=e.setConjunction,a=e.not,s=e.setNot,l=e.isLocked,u=t.settings,c=u.immutableGroupsMode,d=(u.renderConjs,u.showNot,u.notLabel),p=this.conjunctionOptions();if(!this.showConjs())return null;if(!r||!r.size)return null;var f={disabled:this.isOneChild(),readonly:c||l,selectedConjunction:o,setConjunction:c?Ib:i,conjunctionOptions:p,config:t,not:a||!1,id:n,setNot:c?Ib:s,notLabel:d,showNot:this.showNot(),isLocked:l},h=this.Conjs;return me().createElement(h,tb({key:"group-conjs"},f))}},{key:"renderHeader",value:function(){return me().createElement("div",{key:"group-conjunctions",className:"group--conjunctions"},this.renderConjs(),this.renderDrag())}},{key:"render",value:function(){return me().createElement(me().Fragment,null,this.renderHeaderWrapper(),this.renderChildrenWrapper(),this.renderFooterWrapper())}}])}(ye.Component);EE.propTypes={reordableNodesCnt:ym().number,conjunctionOptions:ym().object.isRequired,allowFurtherNesting:ym().bool.isRequired,isRoot:ym().bool.isRequired,not:ym().bool,selectedConjunction:ym().string,config:ym().object.isRequired,id:ym().string.isRequired,groupId:ym().string,path:ym().any,children1:ym().any,isDraggingMe:ym().bool,isDraggingTempo:ym().bool,isLocked:ym().bool,isTrueLocked:ym().bool,handleDraggerMouseDown:ym().func,onDragStart:ym().func,addRule:ym().func.isRequired,addGroup:ym().func.isRequired,removeSelf:ym().func.isRequired,setConjunction:ym().func.isRequired,setNot:ym().func.isRequired,setLock:ym().func.isRequired,actions:ym().object.isRequired};const SE=dE(vb("group")(Lb(EE)),"group");function TE(){return TE="undefined"!=typeof Reflect&&Reflect.get?Reflect.get.bind():function(e,t,r){var n=function(e,t){for(;!{}.hasOwnProperty.call(e,t)&&null!==(e=Un(e)););return e}(e,t);if(n){var o=Object.getOwnPropertyDescriptor(n,t);return o.get?o.get.call(arguments.length<3?e:r):o.value}},TE.apply(null,arguments)}function _E(e,t,r){return t=Un(t),Vn(e,wE()?Reflect.construct(t,r||[],Un(e).constructor):t.apply(e,r))}function wE(){try{var e=!Boolean.prototype.valueOf.call(Reflect.construct(Boolean,[],(function(){})))}catch(e){}return(wE=function(){return!!e})()}var RE=function(e){function t(){return Pn(this,t),_E(this,t,arguments)}return qn(t,e),Mn(t,[{key:"render",value:function(){var e=this.props,t=e.config,r=e.addRule,n=e.canAddRule,o=e.canDeleteGroup,i=e.removeSelf,a=e.setLock,s=e.isLocked,l=e.isTrueLocked,u=e.id,c=t.settings,d=c.immutableGroupsMode,p=c.addRuleLabel,f=c.delGroupLabel,h=c.renderButton,v=c.renderIcon,g=c.renderSwitch,y=c.renderButtonGroup,m=c.lockLabel,b=c.lockedLabel,O=c.showLock,E=c.canDeleteLocked,S=function(e){return v(e,t.ctx)},T=function(e){return h(e,t.ctx)},_=function(e){return g(e,t.ctx)},w=function(e){return y(e,t.ctx)},R=O&&!(s&&!l)&&me().createElement(_,{type:"lock",id:u,value:s,setValue:a,label:m,checkedLabel:b,hideLabel:!0,config:t}),A=!d&&n&&!s&&me().createElement(T,{type:"addRuleGroup",onClick:r,label:p,readonly:s,config:t,renderIcon:S}),C=!d&&o&&(!s||s&&E)&&me().createElement(T,{type:"delRuleGroup",onClick:i,label:f,config:t,renderIcon:S});return me().createElement("div",{className:"group--actions"},me().createElement(w,{config:t},R,A,C))}}])}(ye.PureComponent);function AE(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);t&&(n=n.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),r.push.apply(r,n)}return r}function CE(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{};t%2?AE(Object(r),!0).forEach((function(t){Gn(e,t,r[t])})):Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(r)):AE(Object(r)).forEach((function(t){Object.defineProperty(e,t,Object.getOwnPropertyDescriptor(r,t))}))}return e}function IE(e,t,r){return t=Un(t),Vn(e,xE()?Reflect.construct(t,r||[],Un(e).constructor):t.apply(e,r))}function xE(){try{var e=!Boolean.prototype.valueOf.call(Reflect.construct(Boolean,[],(function(){})))}catch(e){}return(xE=function(){return!!e})()}var LE=function(e){function t(e){var r;return Pn(this,t),(r=IE(this,t,[e])).childrenClassName=function(){return"rule_group--children"},r.renderHeaderWrapper=function(){return null},r.renderFooterWrapper=function(){return null},r.renderConjs=function(){return null},r.canAddGroup=function(){return!1},r.canAddRule=function(){return!0},r.canDeleteGroup=function(){return!1},r}return qn(t,e),Mn(t,[{key:"onPropsChanged",value:function(e){TE(Un(t.prototype),"onPropsChanged",this).call(this,e)}},{key:"reordableNodesCntForItem",value:function(e){if(this.props.isLocked)return 0;var t=this.props.children1;return(null==t?void 0:t.size)||0}},{key:"renderChildrenWrapper",value:function(){return me().createElement(me().Fragment,null,this.renderDrag(),this.renderField(),this.renderActions(),TE(Un(t.prototype),"renderChildrenWrapper",this).call(this))}},{key:"renderField",value:function(){var e=this.props,t=e.config,r=e.selectedField,n=e.selectedFieldSrc,o=e.selectedFieldType,i=e.setField,a=e.setFuncValue,s=e.setFieldSrc,l=e.parentField,u=e.id,c=e.groupId,d=e.isLocked,p=t.settings.immutableFieldsMode;return me().createElement(qO,{key:"field",classname:"group--field",config:t,canSelectFieldSource:!1,selectedField:r,selectedFieldSrc:n,selectedFieldType:o,setField:i,setFuncValue:a,setFieldSrc:s,parentField:l,readonly:p||d,id:u,groupId:c})}},{key:"renderActions",value:function(){var e=this.props,t=e.config,r=e.addRule,n=e.isLocked,o=e.isTrueLocked,i=e.id;return me().createElement(RE,{config:t,addRule:r,canAddRule:this.canAddRule(),canDeleteGroup:this.canDeleteGroup(),removeSelf:this.removeSelf,setLock:this.setLock,isLocked:n,isTrueLocked:o,id:i})}},{key:"extraPropsForItem",value:function(e){return{parentField:this.props.selectedField}}}])}(EE);LE.propTypes=CE(CE({},EE.propTypes),{},{selectedField:ym().any,selectedFieldSrc:ym().string,parentField:ym().string,setField:ym().func,setFieldSrc:ym().func});const NE=dE(vb("group rule_group")(Lb(LE)),"rule_group");function jE(e,t,r){return t=Un(t),Vn(e,PE()?Reflect.construct(t,r||[],Un(e).constructor):t.apply(e,r))}function PE(){try{var e=!Boolean.prototype.valueOf.call(Reflect.construct(Boolean,[],(function(){})))}catch(e){}return(PE=function(){return!!e})()}var kE=function(e){function t(){return Pn(this,t),jE(this,t,arguments)}return qn(t,e),Mn(t,[{key:"render",value:function(){var e=this.props,t=e.config,r=e.addRule,n=e.canAddRule,o=e.canDeleteGroup,i=e.removeSelf,a=e.setLock,s=e.isLocked,l=e.isTrueLocked,u=e.id,c=t.settings,d=c.immutableGroupsMode,p=c.addSubRuleLabel,f=c.delGroupLabel,h=c.renderButton,v=c.renderIcon,g=c.renderSwitch,y=c.renderButtonGroup,m=c.lockLabel,b=c.lockedLabel,O=c.showLock,E=c.canDeleteLocked,S=function(e){return v(e,t.ctx)},T=function(e){return h(e,t.ctx)},_=function(e){return g(e,t.ctx)},w=function(e){return y(e,t.ctx)},R=O&&!(s&&!l)&&me().createElement(_,{type:"lock",id:u,value:s,setValue:a,label:m,checkedLabel:b,config:t}),A=!d&&n&&!s&&me().createElement(T,{type:"addRuleGroupExt",onClick:r,label:p,readonly:s,config:t,renderIcon:S}),C=!d&&o&&(!s||s&&E)&&me().createElement(T,{type:"delRuleGroup",onClick:i,label:f,config:t,renderIcon:S});return me().createElement("div",{className:"group--actions group--actions--tr"},me().createElement(w,{config:t},R,A,C))}}])}(ye.PureComponent);function FE(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);t&&(n=n.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),r.push.apply(r,n)}return r}function DE(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{};t%2?FE(Object(r),!0).forEach((function(t){Gn(e,t,r[t])})):Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(r)):FE(Object(r)).forEach((function(t){Object.defineProperty(e,t,Object.getOwnPropertyDescriptor(r,t))}))}return e}function ME(e,t){(null==t||t>e.length)&&(t=e.length);for(var r=0,n=new Array(t);r<t;r++)n[r]=e[r];return n}function VE(e,t,r){return t=Un(t),Vn(e,UE()?Reflect.construct(t,r||[],Un(e).constructor):t.apply(e,r))}function UE(){try{var e=!Boolean.prototype.valueOf.call(Reflect.construct(Boolean,[],(function(){})))}catch(e){}return(UE=function(){return!!e})()}var BE=vm.ConfigUtils,qE=BE.getFieldConfig,GE=BE.getFieldWidgetConfig,KE=vm.RuleUtils.isEmptyRuleGroupExtPropertiesAndChildren,WE=function(e){function t(e){var r;return Pn(this,t),(r=VE(this,t,[e])).childrenClassName=function(){return"rule_group_ext--children"},r.renderFooterWrapper=function(){return null},r.canAddGroup=function(){return!1},r.canAddRule=function(){return!0},r.canDeleteGroup=function(){return!0},r}return qn(t,e),Mn(t,[{key:"onPropsChanged",value:function(e){TE(Un(t.prototype),"onPropsChanged",this).call(this,e)}},{key:"renderHeaderWrapper",value:function(){return me().createElement("div",{key:"group-header",className:nb()("group--header",this.isOneChild()?"one--child":"",this.isOneChild()?"hide--line":"",this.isNoChildren()?"no--children":"",this.showDragIcon()?"with--drag":"hide--drag",!this.showConjs()||this.isOneChild()&&!this.showNot()?"hide--conjs":"with--conjs")},this.renderHeader(),this.renderGroupField(),this.renderActions())}},{key:"renderHeader",value:function(){return me().createElement("div",{className:"group--conjunctions"},this.renderConjs(),this.renderDrag())}},{key:"renderGroupField",value:function(){return me().createElement("div",{className:"group--field--count--rule"},this.renderField(),this.renderOperator(),this.renderWidget(),this.renderError())}},{key:"renderError",value:function(){var e=this.props,t=e.config,r=e.valueError,n=t.settings,o=n.renderRuleError,i=n.showErrorMessage,a=Qn((null==r?void 0:r.toArray())||[]).filter((function(e){return!!e})).shift()||null;return i&&a&&me().createElement("div",{className:"rule_group--error"},o?o({error:a},t.ctx):a)}},{key:"showNot",value:function(){var e=this.props,t=e.config,r=e.selectedField,n=(e.selectedOperator,qE(t,r)||{});return null!=n.showNot?n.showNot:t.settings.showNot}},{key:"conjunctionOptions",value:function(){var e=this.props,r=e.config,n=e.selectedField,o=(e.selectedOperator,qE(r,n)||{}),i=TE(Un(t.prototype),"conjunctionOptions",this).call(this);if(o.conjunctions){var a,s={},l=function(e,t){var r="undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(!r){if(Array.isArray(e)||(r=function(e,t){if(e){if("string"==typeof e)return ME(e,t);var r=Object.prototype.toString.call(e).slice(8,-1);return"Object"===r&&e.constructor&&(r=e.constructor.name),"Map"===r||"Set"===r?Array.from(e):"Arguments"===r||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(r)?ME(e,t):void 0}}(e))||t&&e&&"number"==typeof e.length){r&&(e=r);var n=0,o=function(){};return{s:o,n:function(){return n>=e.length?{done:!0}:{done:!1,value:e[n++]}},e:function(e){throw e},f:o}}throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}var i,a=!0,s=!1;return{s:function(){r=r.call(e)},n:function(){var e=r.next();return a=e.done,e},e:function(e){s=!0,i=e},f:function(){try{a||null==r.return||r.return()}finally{if(s)throw i}}}}(o.conjunctions);try{for(l.s();!(a=l.n()).done;){var u=a.value,c=i[u];c&&(s[u]=c)}}catch(e){l.e(e)}finally{l.f()}i=s}return i}},{key:"renderField",value:function(){var e=this.props,t=e.config,r=e.selectedField,n=e.selectedFieldSrc,o=e.selectedFieldType,i=e.setField,a=e.setFieldSrc,s=e.setFuncValue,l=e.parentField,u=e.id,c=e.groupId,d=e.isLocked,p=t.settings.immutableFieldsMode;return me().createElement(qO,{key:"field",classname:"rule--field",config:t,canSelectFieldSource:!1,selectedField:r,selectedFieldSrc:n,selectedFieldType:o,setField:i,setFuncValue:s,setFieldSrc:a,parentField:l,readonly:p||d,id:u,groupId:c})}},{key:"renderOperator",value:function(){var e=this.props,t=e.config,r=e.selectedField,n=e.selectedFieldSrc,o=e.selectedOperator,i=(e.setField,e.setOperator),a=e.isLocked,s=t.settings.immutableFieldsMode,l=GE(t,r,o)||{},u=l.hideOperator,c=r&&u&&l.operatorInlineLabel,d=r&&!u;return me().createElement(Fb,{key:"operator",classname:"group--operator",config:t,selectedField:r,selectedFieldSrc:n,selectedOperator:o,setOperator:i,showOperator:d,showOperatorLabel:c,selectedFieldWidgetConfig:l,readonly:s||a,id:this.props.id,groupId:this.props.groupId})}},{key:"isEmptyCurrentGroup",value:function(){var e=this.props,t=e.children1,r=e.config,n=this._buildWidgetProps(this.props);return KE(n,t,r)}},{key:"_buildWidgetProps",value:function(e){var t=e.selectedField,r=e.selectedFieldSrc,n=e.selectedFieldType,o=e.selectedOperator,i=e.operatorOptions,a=e.value,s=e.valueType,l=(e.valueSrc,e.asyncListValues,e.valueError);return e.fieldError,{field:t,fieldSrc:r,fieldType:n,operator:o,operatorOptions:i,value:a,valueType:s,valueSrc:["value"],valueError:l,fieldError:null,parentField:e.parentField}}},{key:"renderWidget",value:function(){var e=this.props,t=e.config,r=e.selectedField,n=e.selectedOperator,o=e.isLocked,i=t.settings.immutableValuesMode;if(!r||!n)return null;var a=me().createElement(jO,tb({key:"values",isForRuleGroup:!0},this._buildWidgetProps(this.props),{config:t,setValue:i?Ib:this.props.setValue,setValueSrc:Ib,readonly:i||o,id:this.props.id,groupId:this.props.groupId}));return me().createElement(Cb,{key:"widget-for-"+this.props.selectedOperator,className:"rule--value"},a)}},{key:"renderActions",value:function(){var e=this.props,t=e.config,r=e.addRule,n=e.isLocked,o=e.isTrueLocked,i=e.id;return me().createElement(kE,{config:t,addRule:r,canAddRule:this.canAddRule(),canDeleteGroup:this.canDeleteGroup(),removeSelf:this.removeSelf,setLock:this.setLock,isLocked:n,isTrueLocked:o,id:i})}},{key:"reordableNodesCntForItem",value:function(e){if(this.props.isLocked)return 0;var t=this.props.children1;return(null==t?void 0:t.size)||0}},{key:"extraPropsForItem",value:function(e){return{parentField:this.props.selectedField}}}])}(EE);WE.propTypes=DE(DE({},EE.propTypes),{},{selectedField:ym().any,selectedFieldSrc:ym().string,selectedOperator:ym().string,value:ym().any,parentField:ym().string,setField:ym().func,setFieldSrc:ym().func,setOperator:ym().func,setValue:ym().func,valueError:ym().any});const zE=dE(vb("group rule_group_ext")(Lb(WE)),"rule_group");function $E(e,t,r){return t=Un(t),Vn(e,HE()?Reflect.construct(t,r||[],Un(e).constructor):t.apply(e,r))}function HE(){try{var e=!Boolean.prototype.valueOf.call(Reflect.construct(Boolean,[],(function(){})))}catch(e){}return(HE=function(){return!!e})()}var YE={topLeft:"group--actions--tl",topCenter:"group--actions--tc",topRight:"group--actions--tr",bottomLeft:"group--actions--bl",bottomCenter:"group--actions--bc",bottomRight:"group--actions--br"},QE=function(e){function t(){return Pn(this,t),$E(this,t,arguments)}return qn(t,e),Mn(t,[{key:"render",value:function(){var e=this.props,t=e.config,r=e.addCaseGroup,n=e.addDefaultCaseGroup,o=e.setLock,i=e.isLocked,a=e.isTrueLocked,s=e.id,l=e.canAddGroup,u=e.canAddDefault,c=t.settings,d=c.immutableGroupsMode,p=c.addCaseLabel,f=c.addDefaultCaseLabel,h=c.groupActionsPosition,v=c.renderButton,g=c.renderIcon,y=c.renderSwitch,m=c.renderButtonGroup,b=c.lockLabel,O=c.lockedLabel,E=c.showLock,S=function(e){return g(e,t.ctx)},T=function(e){return v(e,t.ctx)},_=function(e){return y(e,t.ctx)},w=function(e){return m(e,t.ctx)},R=YE[h||"topRight"],A=E&&!(i&&!a)&&me().createElement(_,{type:"lock",id:s,value:i,setValue:o,label:b,checkedLabel:O,config:t}),C=!d&&l&&!i&&me().createElement(T,{type:"addCaseGroup",onClick:r,label:p,readonly:i,config:t,renderIcon:S}),I=!d&&u&&!i&&me().createElement(T,{type:"addDefaultCaseGroup",onClick:n,label:f,readonly:i,config:t,renderIcon:S});return me().createElement("div",{className:"group--actions ".concat(R)},me().createElement(w,{config:t},A,C,I))}}])}(ye.PureComponent);function XE(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);t&&(n=n.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),r.push.apply(r,n)}return r}function JE(e,t,r){return t=Un(t),Vn(e,ZE()?Reflect.construct(t,r||[],Un(e).constructor):t.apply(e,r))}function ZE(){try{var e=!Boolean.prototype.valueOf.call(Reflect.construct(Boolean,[],(function(){})))}catch(e){}return(ZE=function(){return!!e})()}var eS=vm.TreeUtils,tS=eS.getTotalReordableNodesCountInTree,rS=eS.getTotalRulesCountInTree,nS=function(e){function t(e){var r;return Pn(this,t),(r=JE(this,t,[e])).childrenClassName=function(){return"switch_group--children"},r.renderFooterWrapper=function(){return null},r.hasDefaultCase=function(){var e;return(null===(e=r.props.children1)||void 0===e?void 0:e.size)&&r.props.children1.filter((function(e){return null==e.get("children1")})).size>0},r}return qn(t,e),Mn(t,[{key:"onPropsChanged",value:function(e){TE(Un(t.prototype),"onPropsChanged",this).call(this,e)}},{key:"canAddGroup",value:function(){var e,t=this.props.config.settings.maxNumberOfCases,r=(null===(e=this.props.children1)||void 0===e?void 0:e.size)||0;return!t||r<t}},{key:"canAddRule",value:function(){return!1}},{key:"reordableNodesCnt",value:function(){var e,t=(null===(e=this.props.children1)||void 0===e?void 0:e.size)||0;return this.hasDefaultCase()&&t--,t}},{key:"totalRulesCntForItem",value:function(e){return rS(e)}},{key:"reordableNodesCntForItem",value:function(e){var t;if(this.props.isLocked)return 0;var r=this.props.config.settings,n=r.canLeaveEmptyCase,o=r.canRegroupCases,i=(null===(t=this.props.children1)||void 0===t?void 0:t.size)||0;this.hasDefaultCase()&&i--;var a=tS(e);return 1==a&&o&&n&&i>1&&(a=111),a}},{key:"renderHeaderWrapper",value:function(){return me().createElement("div",{key:"group-header",className:nb()("group--header",this.isOneChild()?"one--child":"",this.isOneChild()?"hide--line":"",this.isNoChildren()?"no--children":"",this.showDragIcon()?"with--drag":"hide--drag")},this.renderHeader(),this.renderActions())}},{key:"renderHeader",value:function(){return me().createElement("div",{className:"group--conjunctions"},this.renderConjs(),this.renderDrag())}},{key:"renderConjs",value:function(){return this.props.config.settings.renderSwitchPrefix||null}},{key:"showNot",value:function(){return!1}},{key:"renderActions",value:function(){var e=this.props,t=e.config,r=e.addCaseGroup,n=e.addDefaultCaseGroup,o=e.isLocked,i=e.isTrueLocked,a=e.id;return me().createElement(QE,{config:t,addCaseGroup:r,addDefaultCaseGroup:n,canAddDefault:!this.hasDefaultCase(),canAddGroup:this.canAddGroup(),setLock:this.setLock,isLocked:o,isTrueLocked:i,id:a})}}])}(EE);nS.propTypes=function(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{};t%2?XE(Object(r),!0).forEach((function(t){Gn(e,t,r[t])})):Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(r)):XE(Object(r)).forEach((function(t){Object.defineProperty(e,t,Object.getOwnPropertyDescriptor(r,t))}))}return e}({},EE.propTypes);const oS=dE(vb("group switch_group")(Lb(nS)),"switch_group");function iS(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);t&&(n=n.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),r.push.apply(r,n)}return r}function aS(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{};t%2?iS(Object(r),!0).forEach((function(t){Gn(e,t,r[t])})):Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(r)):iS(Object(r)).forEach((function(t){Object.defineProperty(e,t,Object.getOwnPropertyDescriptor(r,t))}))}return e}function sS(e,t,r){return t=Un(t),Vn(e,lS()?Reflect.construct(t,r||[],Un(e).constructor):t.apply(e,r))}function lS(){try{var e=!Boolean.prototype.valueOf.call(Reflect.construct(Boolean,[],(function(){})))}catch(e){}return(lS=function(){return!!e})()}var uS=function(e){function t(e){var r;return Pn(this,t),(r=sS(this,t,[e])).childrenClassName=function(){return"case_group--children"},r.renderFooterWrapper=function(){return null},r}return qn(t,e),Mn(t,[{key:"onPropsChanged",value:function(e){var r=this.props,n=!this.renderBeforeCaseValue||(null==r?void 0:r.config)!==(null==e?void 0:e.config);if(TE(Un(t.prototype),"onPropsChanged",this).call(this,e),n){var o=e.config,i=o.settings,a=i.renderBeforeCaseValue,s=i.renderAfterCaseValue,l=i.renderRuleError;this.BeforeCaseValue=jb(o,a),this.AfterCaseValue=jb(o,s),this.RuleError=jb(o,l)}}},{key:"isDefaultCase",value:function(){return null==this.props.children1}},{key:"reordableNodesCnt",value:function(){return this.props.parentReordableNodesCnt}},{key:"reordableNodesCntForItem",value:function(e){return this.props.isLocked?0:this.props.reordableNodesCnt}},{key:"totalRulesCntForItem",value:function(e){return this.props.totalRulesCnt}},{key:"showDragIcon",value:function(){return!this.isDefaultCase()&&TE(Un(t.prototype),"showDragIcon",this).call(this)}},{key:"renderHeaderWrapper",value:function(){return me().createElement("div",{key:"group-header",className:nb()("group--header",this.isOneChild()?"one--child":"",this.isOneChild()?"hide--line":"",this.isNoChildren()?"no--children":"",this.showDragIcon()?"with--drag":"hide--drag",!this.showConjs()||this.isOneChild()&&!this.showNot()?"hide--conjs":"with--conjs")},this.renderHeaderLeft(),this.renderHeaderCenter(),this.renderActions())}},{key:"renderChildrenWrapper",value:function(){return this.isDefaultCase()?null:me().createElement("div",{className:"case_group--body"},this.renderCondition(),this.renderBeforeValue(),this.renderValue(),this.renderAfterValue())}},{key:"renderHeaderLeft",value:function(){return this.isDefaultCase()?this.props.config.settings.defaultCaseLabel||"":me().createElement("div",{className:"group--conjunctions"},this.renderConjs(),this.renderDrag(),this.renderError())}},{key:"renderCondition",value:function(){return this.isDefaultCase()?null:TE(Un(t.prototype),"renderChildrenWrapper",this).call(this)}},{key:"renderHeaderCenter",value:function(){return this.isDefaultCase()?me().createElement("div",null,this.renderValue(),this.renderError()):null}},{key:"canAddGroup",value:function(){return!this.isDefaultCase()&&TE(Un(t.prototype),"canAddGroup",this).call(this)}},{key:"canAddRule",value:function(){return!this.isDefaultCase()&&TE(Un(t.prototype),"canAddRule",this).call(this)}},{key:"renderBeforeValue",value:function(){var e=this.BeforeCaseValue;return null==e?null:me().createElement(e,tb({key:"values-before"},this.props))}},{key:"renderAfterValue",value:function(){var e=this.AfterCaseValue;return null==e?null:me().createElement(e,tb({key:"values-after"},this.props))}},{key:"renderError",value:function(){var e=this.props,t=e.config,r=e.valueError,n=t.settings.showErrorMessage,o=this.RuleError,i=Qn((null==r?void 0:r.toArray())||[]).filter((function(e){return!!e})).shift()||null;return n&&i&&me().createElement("div",{className:"rule--error"},o?me().createElement(o,{error:i}):i)}},{key:"renderValue",value:function(){var e=this.props,t=e.config,r=e.isLocked,n=e.value,o=e.valueSrc,i=e.valueError,a=e.setValue,s=e.setValueSrc,l=e.setFuncValue,u=e.id,c=t.settings.immutableValuesMode,d=me().createElement(jO,{key:"values",isCaseValue:!0,field:"!case_value",operator:null,value:n,valueSrc:null!=o?o:"value",valueError:i,fieldError:null,config:t,setValue:c?Ib:a,setValueSrc:c?Ib:s,setFuncValue:c?Ib:l,readonly:c||r,id:u,groupId:null});return me().createElement(Cb,{className:"case_group--value"},d)}},{key:"renderActions",value:function(){var e=this.props,t=e.config,r=e.addGroup,n=e.addRule,o=e.isLocked,i=e.isTrueLocked,a=e.id;return me().createElement(vE,{config:t,addGroup:r,addRule:n,canAddRule:this.canAddRule(),canAddGroup:this.canAddGroup(),canDeleteGroup:this.canDeleteGroup(),removeSelf:this.removeSelf,setLock:this.setLock,isLocked:o,isTrueLocked:i,id:a})}},{key:"isEmptyCurrentGroup",value:function(){var e=this.props.value,r=e&&e.size?e.get(0):null,n=null!=r&&(!Array.isArray(r)||r.length>0);return TE(Un(t.prototype),"isEmptyCurrentGroup",this).call(this)&&!n}}])}(EE);uS.propTypes=aS(aS({},EE.propTypes),{},{parentReordableNodesCnt:ym().number,value:ym().any,setValue:ym().func});const cS=dE(vb("group case_group")(Lb(uS)),"case_group");var dS=["type"];function pS(e,t,r){return t=Un(t),Vn(e,fS()?Reflect.construct(t,r||[],Un(e).constructor):t.apply(e,r))}function fS(){try{var e=!Boolean.prototype.valueOf.call(Reflect.construct(Boolean,[],(function(){})))}catch(e){}return(fS=function(){return!!e})()}function hS(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);t&&(n=n.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),r.push.apply(r,n)}return r}function vS(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{};t%2?hS(Object(r),!0).forEach((function(t){Gn(e,t,r[t])})):Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(r)):hS(Object(r)).forEach((function(t){Object.defineProperty(e,t,Object.getOwnPropertyDescriptor(r,t))}))}return e}var gS=function(e){var t,r=(null===(t=e.properties)||void 0===t?void 0:t.toObject())||{},n=vS({},r);return e.isParentLocked&&(n.isLocked=!0),r.isLocked&&(n.isTrueLocked=!0),n},yS={rule:function(e){return me().createElement(iE,tb({},gS(e),{id:e.id,groupId:e.groupId,path:e.path,actions:e.actions,reordableNodesCnt:e.reordableNodesCnt,totalRulesCnt:e.totalRulesCnt,config:e.config,onDragStart:e.onDragStart,isDraggingTempo:e.isDraggingTempo,parentField:e.parentField,parentReordableNodesCnt:e.parentReordableNodesCnt}))},group:function(e){return me().createElement(SE,tb({},gS(e),{id:e.id,groupId:e.groupId,path:e.path,actions:e.actions,config:e.config,reordableNodesCnt:e.reordableNodesCnt,totalRulesCnt:e.totalRulesCnt,onDragStart:e.onDragStart,isDraggingTempo:e.isDraggingTempo,children1:e.children1,parentField:null,parentReordableNodesCnt:e.parentReordableNodesCnt}))},rule_group:function(e){return me().createElement(NE,tb({},gS(e),{id:e.id,groupId:e.groupId,path:e.path,actions:e.actions,config:e.config,reordableNodesCnt:e.reordableNodesCnt,totalRulesCnt:e.totalRulesCnt,onDragStart:e.onDragStart,isDraggingTempo:e.isDraggingTempo,children1:e.children1,parentField:e.parentField,parentReordableNodesCnt:e.parentReordableNodesCnt}))},rule_group_ext:function(e){return me().createElement(zE,tb({},gS(e),{id:e.id,groupId:e.groupId,path:e.path,actions:e.actions,config:e.config,reordableNodesCnt:e.reordableNodesCnt,totalRulesCnt:e.totalRulesCnt,onDragStart:e.onDragStart,isDraggingTempo:e.isDraggingTempo,children1:e.children1,parentField:e.parentField,parentReordableNodesCnt:e.parentReordableNodesCnt}))},switch_group:function(e){return me().createElement(oS,tb({},gS(e),{id:e.id,groupId:e.groupId,path:e.path,actions:e.actions,config:e.config,reordableNodesCnt:e.reordableNodesCnt,totalRulesCnt:e.totalRulesCnt,onDragStart:e.onDragStart,isDraggingTempo:e.isDraggingTempo,children1:e.children1,parentField:null,parentReordableNodesCnt:e.parentReordableNodesCnt}))},case_group:function(e){return me().createElement(cS,tb({},gS(e),{id:e.id,groupId:e.groupId,path:e.path,actions:e.actions,config:e.config,reordableNodesCnt:e.reordableNodesCnt,totalRulesCnt:e.totalRulesCnt,onDragStart:e.onDragStart,isDraggingTempo:e.isDraggingTempo,children1:e.children1,parentField:null,parentReordableNodesCnt:e.parentReordableNodesCnt}))}},mS=function(e){function t(){return Pn(this,t),pS(this,t,arguments)}return qn(t,e),Mn(t,[{key:"render",value:function(){var e,t=this.props,r=t.type,n=Lg(t,dS),o="array"==(null===(e=n.properties)||void 0===e?void 0:e.get("mode"))?"_ext":"",i=n.config.settings.renderItem,a=yS[r+o];return i?i(vS(vS({},n),{},{type:r,itemComponent:a}),n.config.ctx):a?a(n):null}}])}(ye.PureComponent);function bS(e,t,r){return t=Un(t),Vn(e,OS()?Reflect.construct(t,r||[],Un(e).constructor):t.apply(e,r))}function OS(){try{var e=!Boolean.prototype.valueOf.call(Reflect.construct(Boolean,[],(function(){})))}catch(e){}return(OS=function(){return!!e})()}mS.propTypes={config:ym().object.isRequired,id:ym().string.isRequired,groupId:ym().string,type:ym().oneOf(["rule","group","rule_group","switch_group","case_group"]).isRequired,path:ym().any.isRequired,properties:ym().any,children1:ym().any,actions:ym().object.isRequired,reordableNodesCnt:ym().number,onDragStart:ym().func,parentField:ym().string,isDraggingTempo:ym().bool,isParentLocked:ym().bool};var ES=vm.TreeUtils,SS=ES.getTotalReordableNodesCountInTree,TS=ES.getTotalRulesCountInTree,_S=vm.DefaultUtils,wS=_S.createListWithOneElement,RS=_S.emptyProperties,AS=function(e){function t(e){var r;return Pn(this,t),(r=bS(this,t,[e])).pureShouldComponentUpdate=Um(r),r._updPath(e),r}return qn(t,e),Mn(t,[{key:"shouldComponentUpdate",value:function(e,t){return this.pureShouldComponentUpdate(e,t)}},{key:"_updPath",value:function(e){var t=e.tree.get("id");this.path=wS(t)}},{key:"render",value:function(){var e=this.props,t=e.tree,r=e.config,n=e.actions,o=e.onDragStart,i=t.get("type"),a="switch_group"==i,s=a?null:SS(t),l=a?null:TS(t),u=t.get("id");return me().createElement(mS,{key:u,id:u,path:this.path,type:i,properties:t.get("properties")||RS(),config:r,actions:n,children1:t.get("children1")||RS(),reordableNodesCnt:s,totalRulesCnt:l,parentReordableNodesCnt:0,onDragStart:o})}}])}(ye.Component);AS.propTypes={tree:ym().any.isRequired,config:ym().object.isRequired,actions:ym().object.isRequired,onDragStart:ym().func};const CS=function(e){var t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:null,r=(0,Em.connect)((function(e){return{dragging:e.dragging,dragStart:e.dragStart,mousePos:e.mousePos}}),{setDragStart:Am,setDragProgress:Rm,setDragEnd:Cm},null,{context:bm})(function(e){var t,r=arguments.length>1&&void 0!==arguments[1]?arguments[1]:null;return t=function(t){function n(e){var t;return Pn(this,n),(t=sb(this,n,[e]))._getEventTarget=function(e,t){return e&&e.__mocked_window||document.body||window},t.onDragStart=function(e,r,n){var o=r.closest(".query-builder");void 0===t._isUsingLegacyReactDomRender&&(t._isUsingLegacyReactDomRender=Mm(o)),document.body.classList.add("qb-dragging"),o.classList.add("qb-dragging");var i,a=o.closest(".query-builder-container")||o,s=(a=t._getScrollParent(a)||document.body).scrollTop,l=(t._getDraggableNodeEl(o),t._getPlaceholderNodeEl(o),o.querySelectorAll(".group--children")),u=l.length?l[0]:null;u&&(i=window.getComputedStyle(u,null).getPropertyValue("padding-left"),i=parseInt(i));var c={id:e,x:r.offsetLeft,y:r.offsetTop,w:r.offsetWidth,h:r.offsetHeight,itemInfo:t.tree.items[e],paddingLeft:i},d={id:e,x:r.offsetLeft,y:r.offsetTop,scrollTop:s,clientX:n.clientX,clientY:n.clientY,itemInfo:ub(t.tree.items[e]),treeEl:o,treeElContainer:a},p={clientX:n.clientX,clientY:n.clientY},f=t._getEventTarget(n,d);t.eventTarget=f,f.addEventListener("mousemove",t.onDrag),f.addEventListener("mouseup",t.onDragEnd),t.props.setDragStart(d,c,p)},t.onDrag=function(e){var n=!(arguments.length>1&&void 0!==arguments[1])||arguments[1],o=Object.assign({},t.props.dragging),i=t.props.dragStart,a=o.paddingLeft,s=i.treeElContainer.scrollTop;if(o.itemInfo=t.tree.items[o.id],o.itemInfo){var l={clientX:e.clientX,clientY:e.clientY},u={clientX:i.clientX,clientY:i.clientY};if(e.__mock_dom){var c=i.treeEl,d=t._getDraggableNodeEl(c),p=t._getPlaceholderNodeEl(c);e.__mock_dom({treeEl:c,dragEl:d,plhEl:p})}if(!i.plX){var f=i.treeEl,h=t._getPlaceholderNodeEl(f);h&&(i.plX=h.getBoundingClientRect().left+window.scrollX,i.plY=h.getBoundingClientRect().top+window.scrollY)}var v=i.x,g=i.y,y=i.clientX,m=i.clientY,b=i.scrollTop,O={x:v+(e.clientX-y),y:g+(e.clientY-m)+(s-b)};o.x=O.x,o.y=O.y,o.paddingLeft=a,o.mousePos=l,o.startMousePos=u,t.props.setDragProgress(l,o),n&&t.handleDrag(o,e,r)||e.preventDefault&&e.preventDefault()}},t.onDragEnd=function(){var e=t.props.dragStart.treeEl;t.props.setDragEnd(),e.classList.remove("qb-dragging"),document.body.classList.remove("qb-dragging"),t._cacheEls={};var r=t.eventTarget||t._getEventTarget();r.removeEventListener("mousemove",t.onDrag),r.removeEventListener("mouseup",t.onDragEnd)},t.pureShouldComponentUpdate=Um(t),Bm(t),t.onPropsChanged(e),t}return qn(n,t),Mn(n,[{key:"onPropsChanged",value:function(e){this.tree=cb(e.tree)}},{key:"shouldComponentUpdate",value:function(e,t){var r=this.props,n=this.state,o=this.pureShouldComponentUpdate(e,t);if(o&&n==t&&r!=e){var i=[];for(var a in e)e[a]!=r[a]&&"dragging"!=a&&"mousePos"!=a&&i.push(a);i.length||(o=!1)}return o}},{key:"componentDidUpdate",value:function(e,t){var r=this.props.dragging,n=this.props.dragStart;if(db=!1,n&&n.id&&(r.itemInfo=this.tree.items[r.id],r.itemInfo&&(r.itemInfo.index!=n.itemInfo.index||r.itemInfo.parent!=n.itemInfo.parent))){var o=n.treeEl,i=n.treeElContainer,a=this._getPlaceholderNodeEl(o,!0);if(a){var s=a.getBoundingClientRect().left+window.scrollX,l=a.getBoundingClientRect().top+window.scrollY,u=n.plX,c=n.plY,d=i.scrollTop;n.plX=s,n.plY=l,n.itemInfo=ub(r.itemInfo),n.y=a.offsetTop,n.x=a.offsetLeft,n.clientY+=l-c,n.clientX+=s-u,i!=document.body&&(n.scrollTop=d),this.onDrag(this.props.mousePos,!1)}}}},{key:"_getNodeElById",value:function(e,t){var r=arguments.length>2&&void 0!==arguments[2]&&arguments[2];if(null==t)return null;this._cacheEls||(this._cacheEls={});var n=this._cacheEls[t];return n&&document.contains(n)&&!r||(n=e.querySelector('.group-or-rule-container[data-id="'+t+'"]'),this._cacheEls[t]=n),n}},{key:"_getDraggableNodeEl",value:function(e){var t=arguments.length>1&&void 0!==arguments[1]&&arguments[1];this._cacheEls||(this._cacheEls={});var r=this._cacheEls.draggable;if(r&&document.contains(r)&&!t)return r;var n=e.getElementsByClassName("qb-draggable");return r=n.length?n[0]:null,this._cacheEls.draggable=r,r}},{key:"_getPlaceholderNodeEl",value:function(e){var t=arguments.length>1&&void 0!==arguments[1]&&arguments[1];this._cacheEls||(this._cacheEls={});var r=this._cacheEls.placeholder;if(r&&document.contains(r)&&!t)return r;var n=e.getElementsByClassName("qb-placeholder");return r=n.length?n[0]:null,this._cacheEls.placeholder=r,r}},{key:"_isScrollable",value:function(e){var t=window.getComputedStyle(e)["overflow-y"];return("scroll"===t||"auto"===t)&&e.scrollHeight>e.offsetHeight}},{key:"_getScrollParent",value:function(e){return null==e?null:e===document.body||this._isScrollable(e)?e:this._getScrollParent(e.parentNode)}},{key:"handleDrag",value:function(e,t,r){var n,o,i,a,s=this,l=e.itemInfo,u=e.paddingLeft,c=null,d=this.props.dragStart.treeEl,p=e.id,f=this._getDraggableNodeEl(d),h=this._getPlaceholderNodeEl(d);if(f&&h){if(n=f.getBoundingClientRect(),!(o=h.getBoundingClientRect()).width)return;var v={hrz:0,vrt:0};n.top<o.top?v.vrt=-1:n.bottom>o.bottom&&(v.vrt=1),n.left>o.left?v.hrz=1:n.left<o.left&&(v.hrz=-1);var g,y={x:(a=d.getBoundingClientRect()).left+(a.right-a.left)/2,y:v.vrt>=0?n.bottom:n.top};if(t.__mocked_hov_container)g=t.__mocked_hov_container;else{var m=document.elementFromPoint(y.x,y.y-1);if(!(g=m?m.closest(".group-or-rule-container"):null)&&m&&m.classList.contains("query-builder-container")){var b,O=null==m||null===(b=m.firstChild)||void 0===b?void 0:b.firstChild;O&&O.classList.contains("group-or-rule-container")&&(g=O)}}if(g){var E=g.classList.contains("group-container"),S=g.getAttribute("data-id"),T=g,_=!1,w=!1;if(T){var R=(i=T.getBoundingClientRect()).bottom-i.top,A=this.tree.items[S];if(!A)throw new Error("There is an issue with rendering. If you use Next.js, please check getServerSideProps() method.");var C=null,I=null,x=null,L=null;if(0==v.vrt)x=l,(I=h)&&(C=I.getBoundingClientRect());else if(E){if(v.vrt>0){var N=g.getElementsByClassName("group--header"),j=N.length?N[0]:null;if(j){var P=j.getBoundingClientRect(),k=P.bottom-P.top;n.bottom-P.top>3*k/4&&A.top>e.itemInfo.top&&(x=A,C=P,I=j,w=!0)}}else v.vrt<0&&A.lev>=l.lev&&i.bottom-n.top>=2&&A.top<e.itemInfo.top&&(x=A,C=i,I=T,_=!0);(v.vrt<0?i.bottom-n.top>R-5:n.bottom-i.top>R-5)&&(w||_||(x=A,C=i,I=T),L=A)}else(v.vrt<0?i.bottom-n.top>R/2:n.bottom-i.top>R/2)&&(x=A,C=i,I=T);var F=x&&x.id==p;if(C){var D=n.left-a.left,M=(C.left,a.left,Math.max(0,Math.round(D/u))),V=[],U=[];if(F);else{if(E&&(_?V.push([_m,x,x.lev+1]):w&&V.push([wm,x,x.lev+1]),L)){var B=0==L.lev,q="case_group"==L.type&&"case_group"!=l.type,G=L.prev&&this.tree.items[L.prev].caseId,K=L.next&&this.tree.items[L.next].caseId;l.caseId==G&&(G=null),l.caseId==K&&(K=null);var W=G&&this.tree.items[G],z=K&&this.tree.items[K];v.vrt>0?B?U.push([_m,L,L.lev+1]):q&&z?U.push([wm,z,z.lev+1]):U.push([Sm,L,L.lev]):v.vrt<0&&(B?U.push([wm,L,L.lev+1]):q&&W?U.push([_m,W,W.lev+1]):U.push([Tm,L,L.lev]))}_||w||(v.vrt<0?V.push([Tm,x,x.lev]):v.vrt>0&&V.push([Sm,x,x.lev]))}var $=function(e){var t=e[1],r=l.caseId?s.tree.items[l.caseId]:null,n=t.caseId?s.tree.items[t.caseId]:null;return[].concat(Qn(e),[r,n])};V=V.map($),U=U.map($);var H=null,Y=(V=V.filter((function(e){var t=e[0],r=e[1];if((t==Tm||t==Sm)&&null==r.parent)return!1;if(r.collapsed&&(t==_m||t==wm))return!1;var n=r.id==l.id;if(!n)for(var o=r;o.parent;)if((o=s.tree.items[o.parent]).id==l.id){n=!0;break}return!n})).map((function(e){var t=e[0],r=e[1],n=(e[2],e[3],e[4],null);return(n=t==_m||t==wm?r:s.tree.items[r.parent])&&null==n.parent&&(n=null),e[5]=n,e}))).filter((function(e){return s.canMove(l,e[1],e[0],e[3],e[4],e[5],r)}));0==Y.length&&U.length>0&&(Y=U.filter((function(e){return s.canMove(l,e[1],e[0],e[3],e[4],e[5],r)})));var Q=Y.map((function(e){return e[2]})),X=l.lev,J=Q.concat(X),Z=null;-1!=J.indexOf(M)?Z=M:M>Math.max.apply(Math,Qn(J))?Z=Math.max.apply(Math,Qn(J)):M<Math.min.apply(Math,Qn(J))&&(Z=Math.min.apply(Math,Qn(J))),H=Y.find((function(e){return e[2]==Z})),F||H||!Y.length||(H=Y[0]),c=H}}}else km.log("out of tree bounds!")}return!!c&&(this.move(l,c[1],c[0],c[3]),!0)}},{key:"canMove",value:function(e,t,r,n,o,i,a){if(!e||!t)return!1;if(e.id===t.id)return!1;var s=this.props.config.settings,l=s.canRegroup,u=s.canRegroupCases,c=s.maxNesting,d=s.maxNumberOfRules,p=s.canLeaveEmptyCase,f=(i?i.lev+1:t.lev)+(e.depth||0),h=r==Tm||r==Sm,v=r==wm||r==_m,g=h&&1==t.lev||v&&0==t.lev,y=e.parent!=t.parent,m=v||y,b="case_group"==e.type&&!g||"rule_group"==e.parentType||"rule_group"==t.type||"rule_group"==t.parentType||"case_group"!=e.type&&"case_group"==t.type&&h||"case_group"!=e.type&&"switch_group"==t.type||!u&&e.caseId!=t.caseId,O=t.isLocked||e.isLocked||i&&i.isLocked;if(c&&f>c)return!1;if(m&&(!l||b||O))return!1;if("case_group"!=e.type&&e.caseId!=t.caseId){var E=!!n&&2==n._height,S=o?o.atomicRulesCountInCase+1:0;if(d&&S>d)return!1;if(E&&!p)return!1}if("case_group"==e.type&&(e.isDefaultCase||t.isDefaultCase||"switch_group"==t.type&&r==_m))return!1;var T=!0;return a&&(T=a(e.node.toJS(),t.node.toJS(),r,i?i.node.toJS():null)),T}},{key:"move",value:function(e,t,r,n){this._isUsingLegacyReactDomRender||(db=!0),this.props.actions.moveItem(e.path,t.path,r)}},{key:"render",value:function(){return me().createElement(e,tb({},this.props,{onDragStart:this.onDragStart}))}}])}(ye.Component),t.propTypes={tree:ym().any.isRequired,actions:ym().object.isRequired},t}(e,t));return r.displayName="ConnectedSortableContainer",r}(AS);function IS(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);t&&(n=n.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),r.push.apply(r,n)}return r}function xS(e,t,r){return t=Un(t),Vn(e,LS()?Reflect.construct(t,r||[],Un(e).constructor):t.apply(e,r))}function LS(){try{var e=!Boolean.prototype.valueOf.call(Reflect.construct(Boolean,[],(function(){})))}catch(e){}return(LS=function(){return!!e})()}var NS=vm.clone,jS=vm.ConfigUtils,PS=jS.getFieldConfig,kS=jS.getFieldParts,FS=jS.getFieldPathParts,DS=vm.RuleUtils,MS=DS.getFieldPathLabels,VS=DS.getWidgetForFieldOp,US=function(e){function t(e){var r;return Pn(this,t),r=xS(this,t,[e]),Bm(r),r.onPropsChanged(e),r}return qn(t,e),Mn(t,[{key:"onPropsChanged",value:function(e){var t=this.props,r=!this.items||["config","field","fieldSrc","fieldType","operator","isFuncArg","parentField"].map((function(r){return e[r]!==t[r]})).filter((function(e){return e})).length>0,n=!this.meta||["config","field","fieldSrc","fieldType","operator","value","placeholder","isFuncArg","parentField"].map((function(r){return e[r]!==t[r]})).filter((function(e){return e})).length>0;r&&(this.items=this.getItems(e)),n&&(this.meta=this.getMeta(e))}},{key:"getItems",value:function(e){var t=e.config,r=e.field,n=e.fieldType,o=e.operator,i=e.parentField,a=e.isFuncArg,s=e.fieldDefinition,l=t.settings.canCompareFieldWithField,u=kS(i,t),c=i?PS(t,i):null,d=i?null==c?void 0:c.subfields:t.fields,p=this.filterFields(t,d,r,i,u,o,l,a,s,n);return this.buildOptions(u,t,p,u)}},{key:"getMeta",value:function(e){var t,r=e.config,n=e.field,o=(e.fieldType,e.operator,e.value),i=e.placeholder,a=e.isFuncArg,s=e.parentField,l=r.settings,u=l.fieldPlaceholder,c=l.fieldSeparatorDisplay,d=o,p=!!o,f=n?PS(r,n):{},h=null==f||null===(t=f.widgets)||void 0===t?void 0:t.field,v=(null==h?void 0:h.widgetProps)||{},g=p?null:a&&i||v.valuePlaceholder||u,y=p?PS(r,d):null,m=y||{},b=FS(d,r),O=FS(d,r,!0),E=this.getFieldLabel(y,d,r),S=MS(d,r),T=S?S.join(c):null;return(T==E||s)&&(T=null),{placeholder:g,selectedKey:d,selectedKeys:b,selectedPath:O,selectedLabel:E,selectedOpts:m,selectedAltLabel:m.label2||m.tooltip,selectedFullLabel:T}}},{key:"filterFields",value:function(e,t,r,n,o,i,a,s,l,u){t=NS(t);var c,d=e.settings.fieldSeparator,p=PS(e,r),f=VS(e,r,i,"value");return e.widgets[f],c=s?null==l?void 0:l.type:p?p.type:u,function t(n,o){for(var l in n){var u=n[l].subfields,f=(o||[]).concat(l),h=f.join(d),v=PS(e,h);if(v)if("!struct"==v.type||"!group"==v.type)0==t(u,f)&&delete n[l];else{var g=!(c&&v.type!=c||!s&&h==r),y=a||e.settings.canCompareFieldWithField;y&&(g=g&&y(r,p,h,v,i)),g||delete n[l]}else delete n[l]}return yb()(n).length}(t,o||[]),t}},{key:"buildOptions",value:function(e,t,r){var n=this,o=arguments.length>3&&void 0!==arguments[3]?arguments[3]:null,i=arguments.length>4&&void 0!==arguments[4]?arguments[4]:null;if(!r)return null;var a=t.settings,s=a.fieldSeparator,l=a.fieldSeparatorDisplay,u=null!=o&&o.length?o.join(s)+s:"";return yb()(r).map((function(a){var s=[].concat(Qn(null!=o?o:[]),[a]),c=r[a],d=n.getFieldLabel(c,s,t),p=MS(s,t).join(l);(p==d||e)&&(p=null);var f=c.label2,h=c.tooltip;if(!c.hideForCompare)return"!struct"==c.type||"!group"==c.type?{key:a,path:u+a,label:d,fullLabel:p,altLabel:f,tooltip:h,items:n.buildOptions(e,t,c.subfields,s,{label:d,tooltip:h})}:{key:a,path:u+a,label:d,fullLabel:p,altLabel:f,tooltip:h,grouplabel:null==i?void 0:i.label,group:i}})).filter((function(e){return!!e}))}},{key:"getFieldLabel",value:function(e,t,r){if(!t)return null;var n=r.settings.maxLabelsLength,o=kS(t,r),i=(null==e?void 0:e.label)||Ql()(o);return Nm(i,n)}},{key:"render",value:function(){var e=this.props,t=e.config,r=e.customProps,n=e.setValue,o=e.readonly,i=e.id,a=e.groupId,s=t.settings.renderField,l=function(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{};t%2?IS(Object(r),!0).forEach((function(t){Gn(e,t,r[t])})):Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(r)):IS(Object(r)).forEach((function(t){Object.defineProperty(e,t,Object.getOwnPropertyDescriptor(r,t))}))}return e}({isValueField:!0,config:t,customProps:r,setField:n,readonly:o,items:this.items,id:i,groupId:a},this.meta);return s(l,t.ctx)}}])}(ye.Component);US.propTypes={id:ym().string,groupId:ym().string,setValue:ym().func.isRequired,config:ym().object.isRequired,field:ym().any,fieldSrc:ym().string,fieldType:ym().string,value:ym().string,operator:ym().string,customProps:ym().object,readonly:ym().bool,parentField:ym().string,fieldDefinition:ym().object,isFuncArg:ym().bool};const BS=function(e){var t=e.value,r=e.setValue,n=(e.config,e.labelYes),o=e.labelNo,i=e.readonly,a=(e.widgetId,e.customProps),s=void 0===a?{}:a,l=s.radioYes||{},u=s.radioNo||{},c=function(e){return r("true"==e.target.value)};return me().createElement(me().Fragment,null,me().createElement("input",tb({type:"radio",value:!0,checked:!!t,disabled:i,onChange:c},l))," ",n,me().createElement("input",tb({type:"radio",value:!1,checked:!t,disabled:i,onChange:c},u))," ",o)},qS=function(e){var t=e.value,r=e.setValue,n=(e.config,e.readonly),o=e.placeholder,i=e.maxLength,a=e.customProps,s=t||"";return me().createElement("input",tb({type:"text",value:s,placeholder:o,disabled:n,onChange:function(e){var t=e.target.value;""===t&&(t=void 0),r(t)},maxLength:i},a))},GS=function(e){var t=e.value,r=e.setValue,n=(e.config,e.readonly),o=e.placeholder,i=e.maxLength,a=(e.maxRows,e.fullWidth),s=e.customProps,l=t||"";return me().createElement("textarea",tb({value:l,placeholder:o,disabled:n,onChange:function(e){var t=e.target.value;""===t&&(t=void 0),r(t)},maxLength:i,style:{width:a?"100%":void 0}},s))};vm.moment;const KS=function(e){var t=e.value,r=e.setValue,n=(e.config,e.valueFormat,e.readonly),o=e.customProps;return me().createElement("input",tb({type:"date",value:t||"",disabled:n,onChange:function(e){var t=e.target.value;""==t&&(t=void 0),r(t)}},o))},WS=function(e){var t=e.value,r=e.setValue,n=(e.config,e.valueFormat,e.use12Hours,e.readonly),o=e.customProps;return me().createElement("input",tb({type:"time",value:t||"",disabled:n,onChange:function(e){var t=e.target.value;""==t&&(t=void 0),r(t)}},o))};var zS=vm.moment;const $S=function(e){var t,r=e.value,n=e.setValue,o=(e.config,e.valueFormat),i=(e.use12Hours,e.readonly),a=e.customProps;return t=r?zS(r).format("YYYY-MM-DDTHH:mm"):"",me().createElement("input",tb({type:"datetime-local",value:t,disabled:i,onChange:function(e){var t=e.target.value;t=""==t?void 0:zS(new Date(t)).format(o),n(t)}},a))};var HS=vm.ListUtils.mapListValues;const YS=function(e){var t=e.listValues,r=e.value,n=e.setValue,o=(e.allowCustomValues,e.readonly),i=e.customProps;return me().createElement("select",tb({multiple:!0,onChange:function(e){return n(function(e){for(var t=[],r=e.options,n=0;n<r.length;n++){var o=r[n];o.selected&&t.push(o.value)}return t.length||(t=void 0),t}(e.target))},value:r,disabled:o},Jl()(i,["showSearch","input","showCheckboxes"])),HS(t,(function(e){var t=e.title,r=e.value;return me().createElement("option",{key:r,value:r},t)})))};var QS=vm.ListUtils.mapListValues;const XS=function(e){var t=e.listValues,r=e.value,n=e.setValue,o=(e.allowCustomValues,e.readonly),i=e.customProps,a=null!=r;return me().createElement("select",tb({onChange:function(e){return n(e.target.value)},value:a?r:"",disabled:o},Jl()(i,["showSearch","input"])),!a&&me().createElement("option",{disabled:!0,value:""}),QS(t,(function(e){var t=e.title,r=e.value;return me().createElement("option",{key:r,value:r},t)})))},JS=function(e){var t=e.value,r=e.setValue,n=(e.config,e.readonly),o=e.min,i=e.max,a=e.step,s=e.placeholder,l=e.customProps,u=null==t?"":t;return me().createElement("input",tb({type:"number",value:u,placeholder:s,disabled:n,min:o,max:i,step:a,onChange:function(e){var t=e.target.value;t=""===t||null===t?void 0:Number(t),r(t)}},l))},ZS=function(e){var t=e.value,r=e.setValue,n=(e.config,e.readonly),o=e.min,i=e.max,a=e.step,s=e.placeholder,l=e.customProps,u=void 0===l?{}:l,c=u.input||{},d=u.slider||u,p=function(e){var t=e.target.value;t=""===t||null===t?void 0:Number(t),r(t)},f=null==t?"":t;return me().createElement("div",{style:{display:"inline-flex"}},me().createElement("input",tb({key:"number",type:"number",value:f,placeholder:s,disabled:n,min:o,max:i,step:a,onChange:p},c)),me().createElement("input",tb({key:"range",type:"range",value:f,disabled:n,min:o,max:i,step:a,onChange:p},d)))},eT=function(e){var t=e.items,r=e.setField,n=e.selectedKey,o=e.readonly,i=e.errorText,a=null!=n;return me().createElement("select",{onChange:function(e){return r(e.target.value)},value:a?n:"",disabled:o,style:{color:i?"red":null}},!a&&me().createElement("option",{disabled:!0,value:""}),function e(t){return t.map((function(t){var r=t.items,n=t.path,o=t.label,i=t.disabled,a=t.matchesType;if(r)return me().createElement("optgroup",{disabled:i,key:n,label:o},e(r));var s=a?{fontWeight:"bold"}:{};return me().createElement("option",{disabled:i,key:n,value:n,style:s},o)}))}(t))},tT=function(e){var t,r=e.id,n=e.not,o=e.setNot,i=e.conjunctionOptions,a=e.setConjunction,s=e.disabled,l=e.readonly,u=e.config,c=e.showNot,d=e.notLabel,p=Object.keys(i).length,f=s,h=u.settings.forceShowConj||p>1&&!f,v=function(e){return a(e.target.value)};return[c&&(t="not",[me().createElement("input",{key:r+t,type:"checkbox",id:r+t,checked:n,disabled:l,onChange:function(e){return o(e.target.checked)}}),me().createElement("label",{key:r+t+"label",htmlFor:r+t},d||"NOT")]),h&&Object.keys(i).map((function(e){var t=i[e],r=t.id,n=t.name,o=t.label,u=t.checked,c=a.isDummyFn?"__dummy":"";return!l&&!s||u?[me().createElement("input",{key:r+c,type:"radio",id:r+c,name:n+c,checked:u,disabled:l||s,value:e,onChange:v}),me().createElement("label",{key:r+c+"label",htmlFor:r+c},o)]:null}))]};var rT={addRuleGroup:"+",addRuleGroupExt:"+",delGroup:"x",delRuleGroup:"x",delRule:"x"};const nT=function(e){var t=e.type,r=e.label,n=e.onClick,o=e.readonly,i=r||rT[t];return me().createElement("button",{onClick:n,type:"button",disabled:o},i)},oT=function(e){var t=e.type,r={}[t]||null;return r||"drag"!==t||(r=me().createElement(xb,null)),r},iT=function(e){var t=e.children;return e.config,me().createElement(me().Fragment,null,t)},aT=function(e){e.config;var t=e.valueSources,r=e.valueSrc,n=(e.title,e.setValueSrc),o=e.readonly;return me().createElement("select",{onChange:function(e){return n(e.target.value)},value:r||"",disabled:o},function(e){return e.map((function(e){var t=Hn(e,2),r=t[0],n=t[1];return me().createElement("option",{key:r,value:r},n.label)}))}(t))},sT=function(e){var t=e.value,r=e.setValue,n=e.label,o=e.id,i=(e.config,e.type);return[me().createElement("input",{key:o+i,type:"checkbox",id:o+i,checked:!!t,onChange:function(e){return r(e.target.checked)}}),me().createElement("label",{key:o+i+"label",htmlFor:o+i},n)]},lT=function(e){var t=e.onOk,r=(e.okText,e.cancelText,e.title);confirm(r)&&t()};var uT=function(e){return e.config,e.children};function cT(e,t,r){return t=Un(t),Vn(e,dT()?Reflect.construct(t,r||[],Un(e).constructor):t.apply(e,r))}function dT(){try{var e=!Boolean.prototype.valueOf.call(Reflect.construct(Boolean,[],(function(){})))}catch(e){}return(dT=function(){return!!e})()}var pT=function(e){function t(){var e;Pn(this,t);for(var r=arguments.length,n=new Array(r),o=0;o<r;o++)n[o]=arguments[o];return(e=cT(this,t,[].concat(n))).handleChange=function(t){e.props.setOption("proximity",parseInt(t))},e}return qn(t,e),Mn(t,[{key:"render",value:function(){var e=this.props,t=e.defaults,r=e.options,n=e.config,o=e.optionLabel,i=e.optionPlaceholder,a=e.customProps,s=e.minProximity,l=e.maxProximity,u=e.optionTextBefore,c=e.readonly,d=n.settings,p=n.widgets,f=n.ctx,h=t?t.proximity:void 0,v=d.showLabels,g=r.get("proximity",h),y=sO()(s,l+1).map((function(e){return{title:e,value:e}})),m=p.select.factory,b=function(e){return m(e,f)};return me().createElement("div",{className:"operator--PROXIMITY"},me().createElement("div",{className:"operator--options"},v&&me().createElement("label",{className:"rule--label"},o),!v&&u&&me().createElement("div",{className:"operator--options--sep"},me().createElement("span",null,u)),me().createElement(b,tb({config:n,value:g,listValues:y,setValue:this.handleChange,readonly:c,placeholder:i},a))),me().createElement("div",{className:"operator--widgets"},this.props.children))}}])}(ye.PureComponent);function fT(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);t&&(n=n.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),r.push.apply(r,n)}return r}function hT(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{};t%2?fT(Object(r),!0).forEach((function(t){Gn(e,t,r[t])})):Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(r)):fT(Object(r)).forEach((function(t){Object.defineProperty(e,t,Object.getOwnPropertyDescriptor(r,t))}))}return e}pT.propTypes={config:ym().object.isRequired,setOption:ym().func.isRequired,options:ym().any.isRequired,minProximity:ym().number,maxProximity:ym().number,optionPlaceholder:ym().string,optionTextBefore:ym().string,optionLabel:ym().string,customProps:ym().object,readonly:ym().bool},pT.defaultProps={customProps:{},minProximity:2,maxProximity:10,optionPlaceholder:"Select words between",optionLabel:"Words between",optionTextBefore:null};var vT={conjunctions:hT({},cy.conjunctions),operators:hT(hT({},cy.operators),{},{proximity:hT(hT({},cy.operators.proximity),{},{options:hT(hT({},cy.operators.proximity.options),{},{factory:function(e,t){return(0,t.RCE)(t.O.ProximityOperator,e)}})})}),widgets:{text:hT(hT({},cy.widgets.text),{},{factory:function(e,t){return(0,t.RCE)(t.W.VanillaTextWidget,e)}}),textarea:hT(hT({},cy.widgets.textarea),{},{factory:function(e,t){return(0,t.RCE)(t.W.VanillaTextAreaWidget,e)}}),number:hT(hT({},cy.widgets.number),{},{factory:function(e,t){return(0,t.RCE)(t.W.VanillaNumberWidget,e)}}),slider:hT(hT({},cy.widgets.slider),{},{factory:function(e,t){return(0,t.RCE)(t.W.VanillaSliderWidget,e)}}),select:hT(hT({},cy.widgets.select),{},{factory:function(e,t){return(0,t.RCE)(t.W.VanillaSelectWidget,e)}}),multiselect:hT(hT({},cy.widgets.multiselect),{},{factory:function(e,t){return(0,t.RCE)(t.W.VanillaMultiSelectWidget,e)}}),date:hT(hT({},cy.widgets.date),{},{factory:function(e,t){return(0,t.RCE)(t.W.VanillaDateWidget,e)}}),time:hT(hT({},cy.widgets.time),{},{factory:function(e,t){return(0,t.RCE)(t.W.VanillaTimeWidget,e)}}),datetime:hT(hT({},cy.widgets.datetime),{},{factory:function(e,t){return(0,t.RCE)(t.W.VanillaDateTimeWidget,e)}}),boolean:hT(hT({},cy.widgets.boolean),{},{factory:function(e,t){return(0,t.RCE)(t.W.VanillaBooleanWidget,e)}}),field:hT(hT({},cy.widgets.field),{},{factory:function(e,t){return(0,t.RCE)(t.W.ValueFieldWidget,e)},customProps:{showSearch:!0}}),func:hT(hT({},cy.widgets.func),{},{factory:function(e,t){return(0,t.RCE)(t.W.FuncWidget,e)},customProps:{}}),case_value:hT(hT({},cy.widgets.case_value),{},{factory:function(e,t){return(0,t.RCE)(t.W.VanillaTextWidget,e)}})},types:hT(hT({},cy.types),{},{select:hT(hT({},cy.types.select),{},{widgets:hT(hT({},cy.types.select.widgets),{},{select:hT(hT({},cy.types.select.widgets.select),{},{widgetProps:{customProps:{showSearch:!0}}})})})}),settings:hT(hT({},cy.settings),{},{renderField:function(e,t){return(0,t.RCE)(t.W.VanillaFieldSelect,e)},renderOperator:function(e,t){return(0,t.RCE)(t.W.VanillaFieldSelect,e)},renderFunc:function(e,t){return(0,t.RCE)(t.W.VanillaFieldSelect,e)},renderConjs:function(e,t){return(0,t.RCE)(t.W.VanillaConjs,e)},renderSwitch:function(e,t){return(0,t.RCE)(t.W.VanillaSwitch,e)},renderButton:function(e,t){return(0,t.RCE)(t.W.VanillaButton,e)},renderIcon:function(e,t){return(0,t.RCE)(t.W.VanillaIcon,e)},renderButtonGroup:function(e,t){return(0,t.RCE)(t.W.VanillaButtonGroup,e)},renderProvider:function(e,t){return(0,t.RCE)(t.W.VanillaProvider,e)},renderValueSources:function(e,t){return(0,t.RCE)(t.W.VanillaValueSources,e)},renderFieldSources:function(e,t){return(0,t.RCE)(t.W.VanillaValueSources,e)},renderConfirm:function(e,t){return(0,t.W.vanillaConfirm)(e)},renderSwitchPrefix:"IF",renderBeforeCaseValue:function(e,t){return(0,t.RCE)("span",{children:[" then "]})},customFieldSelectProps:{showSearch:!0},defaultSliderWidth:"200px",defaultSelectWidth:"200px",defaultSearchWidth:"100px",defaultMaxRows:5,renderSize:"small",maxLabelsLength:100,showLock:!1,showNot:!0,forceShowConj:!1,groupActionsPosition:"topRight"}),ctx:hT(hT({},cy.ctx),{},{W:hT({},O),O:hT({},E),RCE:function(e,t){return me().createElement(e,t)}})};const gT=vT=vm.ConfigMixins.removeMixins(vT,["rangeslider","treeselect","treemultiselect"]);p(9517);var yT=vm.Autocomplete,mT=(yT.mergeListValues,yT.listValueToOption,yT.optionToListValue,yT.optionsToListValues,yT.fixListValuesGroupOrder,vm.ListUtils);function bT(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);t&&(n=n.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),r.push.apply(r,n)}return r}function OT(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{};t%2?bT(Object(r),!0).forEach((function(t){Gn(e,t,r[t])})):Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(r)):bT(Object(r)).forEach((function(t){Object.defineProperty(e,t,Object.getOwnPropertyDescriptor(r,t))}))}return e}mT.mapListValues,mT.listValuesToArray,mT.getListValue,mT.makeCustomListValue,mT.searchListValue,mT.getItemInListValues;const ET=OT(OT({},vm),{},{ReactUtils:b,DragIcon:xb});function ST(e,t,r){return t in e?Object.defineProperty(e,t,{value:r,enumerable:!0,configurable:!0,writable:!0}):e[t]=r,e}function TT(){return TT=Object.assign||function(e){for(var t=1;t<arguments.length;t++){var r=arguments[t];for(var n in r)Object.prototype.hasOwnProperty.call(r,n)&&(e[n]=r[n])}return e},TT.apply(this,arguments)}function _T(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{},n=Object.keys(r);"function"==typeof Object.getOwnPropertySymbols&&(n=n.concat(Object.getOwnPropertySymbols(r).filter((function(e){return Object.getOwnPropertyDescriptor(r,e).enumerable})))),n.forEach((function(t){ST(e,t,r[t])}))}return e}function wT(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);r.push.apply(r,n)}return r}(Object(t)).forEach((function(r){Object.defineProperty(e,r,Object.getOwnPropertyDescriptor(t,r))})),e}const RT={id:ET.uuid(),type:"group"},AT="timeFilter",CT=[AT],IT=wT(_T({},gT.widgets),{text:wT(_T({},gT.widgets.text),{factory:function(e){return(0,_.jsx)(R.Input,{value:(null==e?void 0:e.value)||"",placeholder:null==e?void 0:e.placeholder,onChange:t=>null==e?void 0:e.setValue(t.currentTarget.value)})}}),number:wT(_T({},gT.widgets.number),{factory:function(e){return(0,_.jsx)(R.Input,{value:null==e?void 0:e.value,placeholder:null==e?void 0:e.placeholder,type:"number",onChange:t=>null==e?void 0:e.setValue(Number.parseInt(t.currentTarget.value,10))})}}),datetime:wT(_T({},gT.widgets.datetime),{factory:function(e){if("macros"===(null==e?void 0:e.operator))return(0,_.jsx)(R.Select,{id:e.id,"aria-label":"Macros value selector",menuShouldPortal:!0,options:CT.map(T.toOption),value:null==e?void 0:e.value,onChange:t=>e.setValue(t.value)});const t=(0,T.dateTime)(null==e?void 0:e.value).isValid()?(0,T.dateTime)(null==e?void 0:e.value).utc():void 0;return(0,_.jsx)(R.DateTimePicker,{onChange:t=>{null==e||e.setValue(null==t?void 0:t.format(gT.widgets.datetime.valueFormat))},date:t})},sqlFormatValue:(e,t,r,n,o,i)=>{if("macros"===n)return CT.includes(e)?e:void 0;if("string"==typeof gT.widgets.datetime.sqlFormatValue||"object"==typeof gT.widgets.datetime.sqlFormatValue)return;const a=gT.widgets.datetime.sqlFormatValue;return(null==a?void 0:a.call(gT.ctx,e,t,r,n,o,i))||""}})}),xT=wT(_T({},gT.settings),{canRegroup:!1,maxNesting:1,canReorder:!1,showNot:!1,addRuleLabel:"Add",deleteLabel:"Remove",renderConjs:function(e){return(0,_.jsx)(R.Select,{id:null==e?void 0:e.id,"aria-label":"Conjunction","data-testid":Le.components.SQLQueryEditor.filterConjunction,menuShouldPortal:!0,options:(null==e?void 0:e.conjunctionOptions)?Object.keys(null==e?void 0:e.conjunctionOptions).map(T.toOption):void 0,value:null==e?void 0:e.selectedConjunction,onChange:t=>null==e?void 0:e.setConjunction(t.value)})},renderField:function(e){var t;const r=(null==e||null===(t=e.config)||void 0===t?void 0:t.fields)||{};return(0,_.jsx)(R.Select,{id:null==e?void 0:e.id,width:25,"aria-label":"Field","data-testid":Le.components.SQLQueryEditor.filterField,menuShouldPortal:!0,options:null==e?void 0:e.items.map((e=>{var t,n;const o=null===(n=r[e.key].mainWidgetProps)||void 0===n||null===(t=n.customProps)||void 0===t?void 0:t.icon;return{label:e.label,value:e.key,icon:o}})),value:null==e?void 0:e.selectedKey,onChange:t=>{null==e||e.setField(t.label)}})},renderButton:function(e){return(0,_.jsx)(R.Button,{type:"button",title:`${null==e?void 0:e.label} filter`,onClick:null==e?void 0:e.onClick,variant:"secondary",size:"md",icon:"Add"===(null==e?void 0:e.label)?"plus":"times"})},renderOperator:function(e){return(0,_.jsx)(R.Select,{options:null==e?void 0:e.items.map((e=>({label:e.label,value:e.key}))),"aria-label":"Operator","data-testid":Le.components.SQLQueryEditor.filterOperator,menuShouldPortal:!0,value:null==e?void 0:e.selectedKey,onChange:t=>{null==e||e.setField(t.value||"")}})}}),LT=function(e){const t=TT({},function(e){if(null==e)throw new TypeError("Cannot destructure "+e);return e}(e.operators));return wT(_T({},t),{select_any_in:wT(_T({},t.select_any_in),{sqlFormatOp:(e,r,n,o,i,a,s,l)=>(()=>{const e=t.select_any_in.sqlFormatOp;return MT(e)?e:DT})()(e,r,VT(n),o,i,a,s,l)}),select_not_any_in:wT(_T({},t.select_not_any_in),{sqlFormatOp:(e,r,n,o,i,a,s,l)=>(()=>{const e=t.select_not_any_in.sqlFormatOp;return MT(e)?e:DT})()(e,r,VT(n),o,i,a,s,l)}),macros:{label:"Macros",sqlFormatOp:(e,t,r)=>r===AT?`$__timeFilter(${e})`:r}})}(gT),NT=gT.types.text.widgets.text,jT=[...NT.operators||[],"select_any_in","select_not_any_in"],PT=wT(_T({},NT),{operators:jT}),kT=wT(_T({},gT.types),{text:wT(_T({},gT.types.text),{widgets:wT(_T({},gT.types.text.widgets),{text:PT})}),datetime:wT(_T({},gT.types.datetime),{widgets:wT(_T({},gT.types.datetime.widgets),{datetime:wT(_T({},gT.types.datetime.widgets.datetime),{operators:["macros",...gT.types.datetime.widgets.datetime.operators||[]]})})})}),FT=wT(_T({},gT),{widgets:IT,settings:xT,operators:LT,types:kT}),DT=()=>"",MT=e=>"function"==typeof e;function VT(e){return(0,fe.isString)(e)?e.split(","):e}function UT(e,t,r){return t in e?Object.defineProperty(e,t,{value:r,enumerable:!0,configurable:!0,writable:!0}):e[t]=r,e}function BT(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{},n=Object.keys(r);"function"==typeof Object.getOwnPropertySymbols&&(n=n.concat(Object.getOwnPropertySymbols(r).filter((function(e){return Object.getOwnPropertyDescriptor(r,e).enumerable})))),n.forEach((function(t){UT(e,t,r[t])}))}return e}function qT(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);r.push.apply(r,n)}return r}(Object(t)).forEach((function(r){Object.defineProperty(e,r,Object.getOwnPropertyDescriptor(t,r))})),e}function GT({sql:e,config:t,onSqlChange:r}){const[n,o]=(0,ye.useState)(),i=(0,ye.useMemo)((()=>BT({},FT,t)),[t]);(0,ye.useEffect)((()=>{if(!n){var t;const r=ET.checkTree(ET.loadTree(null!==(t=e.whereJsonTree)&&void 0!==t?t:RT),i);o(r)}}),[i,e.whereJsonTree,n]),(0,ye.useEffect)((()=>{e.whereJsonTree||o(ET.checkTree(ET.loadTree(RT),i))}),[i,e.whereJsonTree]);const a=(0,ye.useCallback)(((t,n)=>{o(t);const i=qT(BT({},e),{whereJsonTree:ET.getTree(t),whereString:ET.sqlFormat(t,n)});r(i)}),[r,e]);return n?(0,_.jsx)(eb,qT(BT({},i),{value:n,onChange:a,renderBuilder:e=>(0,_.jsx)(CS,BT({},e))})):null}function KT(e){return`\n    display: flex;\n    gap: 8px;\n    flex-direction: ${e};`}function WT(e,t,r,n,o,i,a){try{var s=e[i](a),l=s.value}catch(e){return void r(e)}s.done?t(l):Promise.resolve(l).then(n,o)}function zT(e){return function(){var t=this,r=arguments;return new Promise((function(n,o){var i=e.apply(t,r);function a(e){WT(i,n,o,a,s,"next",e)}function s(e){WT(i,n,o,a,s,"throw",e)}a(void 0)}))}}function $T({query:e,fields:t,onQueryChange:r,db:n}){const o=(0,jn.A)(zT((function*(){return function(e){const t={};for(const r of e)t[r.value]={type:r.raqbFieldType||"text",valueSources:["value"],mainWidgetProps:{customProps:{icon:r.icon}}};return t}(t)})),[t]),{onSqlChange:i}=Jr({query:e,onQueryChange:r,db:n});return(0,_.jsx)(GT,{config:{fields:o.value||{}},sql:e.sql,onSqlChange:e=>{!function(e,t){var r,n;t.some((t=>(t=>{var r,n;return"multi"in t&&t.multi&&((null===(r=e.whereString)||void 0===r?void 0:r.includes(`\${${t.name}}`))||(null===(n=e.whereString)||void 0===n?void 0:n.includes(`$${t.name}`)))})(t)))&&(e.whereString=null===(r=e.whereString)||void 0===r?void 0:r.replaceAll("')",")"),e.whereString=null===(n=e.whereString)||void 0===n?void 0:n.replaceAll("('","("))}(e,(0,pe.getTemplateSrv)().getVariables()),i(e)}},JSON.stringify(o.value))}function HT(e,t,r,n,o,i,a){try{var s=e[i](a),l=s.value}catch(e){return void r(e)}s.done?t(l):Promise.resolve(l).then(n,o)}function YT(e){return function(){var t=this,r=arguments;return new Promise((function(n,o){var i=e.apply(t,r);function a(e){HT(i,n,o,a,s,"next",e)}function s(e){HT(i,n,o,a,s,"throw",e)}a(void 0)}))}}w.injectGlobal`
  .group--header {
    ${KT("row")}
  }

  .group-or-rule {
    ${KT("column")}
    .rule {
      flex-direction: row;
    }
  }

  .rule--body {
    ${KT("row")}
  }

  .group--children {
    ${KT("column")}
  }

  .group--conjunctions:empty {
    display: none;
  }
`;const QT=({query:e,db:t,queryRowFilter:r,onChange:n,onValidate:o,range:i})=>{var a;const s=Ee(YT((function*(){return yield t.fields(e)})),[t,e.dataset,e.table]);return(0,_.jsxs)(_.Fragment,{children:[(0,_.jsxs)(zr,{children:[(0,_.jsx)(et,{children:(0,_.jsx)(Nn,{fields:s.value||[],query:e,onQueryChange:n,db:t})}),r.filter&&(0,_.jsx)(et,{children:(0,_.jsx)(ut,{label:"Filter by column value",optional:!0,children:(0,_.jsx)($T,{fields:s.value||[],query:e,onQueryChange:n,db:t})})}),r.group&&(0,_.jsx)(et,{children:(0,_.jsx)(ut,{label:"Group by column",children:(0,_.jsx)(gn,{fields:s.value||[],query:e,onQueryChange:n,db:t})})}),r.order&&(0,_.jsx)(et,{children:(0,_.jsx)(Sn,{fields:s.value||[],query:e,onQueryChange:n,db:t})}),r.preview&&e.rawSql&&(0,_.jsx)(et,{children:(0,_.jsx)(Yr,{rawSql:e.rawSql,datasourceType:null===(a=e.datasource)||void 0===a?void 0:a.type})})]}),(0,_.jsx)(Gr,{db:t,query:e,onValidate:o,range:i})]})};function XT(e,t,r,n,o,i,a){try{var s=e[i](a),l=s.value}catch(e){return void r(e)}s.done?t(l):Promise.resolve(l).then(n,o)}function JT(e){return function(){var t=this,r=arguments;return new Promise((function(n,o){var i=e.apply(t,r);function a(e){XT(i,n,o,a,s,"next",e)}function s(e){XT(i,n,o,a,s,"throw",e)}a(void 0)}))}}function ZT(e,t,r){return t in e?Object.defineProperty(e,t,{value:r,enumerable:!0,configurable:!0,writable:!0}):e[t]=r,e}function e_({datasource:e,query:t,onChange:r,onRunQuery:n,range:o,queryHeaderProps:i}){var a,s,l,u,c,d;const[p,f]=(0,ye.useState)(!0),h=e.getDB(),{preconfiguredDatabase:v}=e;var g;const y=null!==(g=null==i?void 0:i.dialect)&&void 0!==g?g:"other",{loading:m,error:b}=Ee(JT((function*(){return()=>{void 0!==e.getDB(e.id).init&&e.getDB(e.id).init()}})),[e]),O=Re(t),[E,S]=(0,ye.useState)({filter:!!(null===(a=O.sql)||void 0===a?void 0:a.whereString),group:!!(null===(u=O.sql)||void 0===u||null===(l=u.groupBy)||void 0===l||null===(s=l[0])||void 0===s?void 0:s.property.name),order:!!(null===(d=O.sql)||void 0===d||null===(c=d.orderBy)||void 0===c?void 0:c.property.name),preview:!0}),[T,w]=(0,ye.useState)(O);(0,ye.useEffect)((()=>()=>{void 0!==e.getDB(e.id).dispose&&e.getDB(e.id).dispose()}),[e]);const A=(0,ye.useCallback)((e=>{t_(e)&&n&&n()}),[n]),C=(e,t=!0)=>{var n,o,i,a;w(e),r(e),Se(null===(n=e.sql)||void 0===n?void 0:n.columns)&&(null===(o=e.sql)||void 0===o?void 0:o.columns.some((e=>e.name)))&&!E.group&&S((i=function(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{},n=Object.keys(r);"function"==typeof Object.getOwnPropertySymbols&&(n=n.concat(Object.getOwnPropertySymbols(r).filter((function(e){return Object.getOwnPropertyDescriptor(r,e).enumerable})))),n.forEach((function(t){ZT(e,t,r[t])}))}return e}({},E),a=null!=(a={group:!0})?a:{},Object.getOwnPropertyDescriptors?Object.defineProperties(i,Object.getOwnPropertyDescriptors(a)):function(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);r.push.apply(r,n)}return r}(Object(a)).forEach((function(e){Object.defineProperty(i,e,Object.getOwnPropertyDescriptor(a,e))})),i)),t&&A(e)};return m||b?null:(0,_.jsxs)(_.Fragment,{children:[(0,_.jsx)(_t,{db:h,preconfiguredDataset:v,onChange:e=>{w(e),r(e)},onRunQuery:n,onQueryRowChange:S,queryRowFilter:E,query:O,isQueryRunnable:p,dialect:y}),(0,_.jsx)(R.Space,{v:.5}),O.editorMode!==de.Code&&(0,_.jsx)(QT,{db:h,query:O,onChange:e=>C(e,!1),queryRowFilter:E,onValidate:f,range:o}),O.editorMode===de.Code&&(0,_.jsx)(Kr,{db:h,query:O,queryToValidate:T,onChange:C,onRunQuery:n,onValidate:f,range:o})]})}const t_=e=>Boolean(e.rawSql);function r_(e,t,r){return t in e?Object.defineProperty(e,t,{value:r,enumerable:!0,configurable:!0,writable:!0}):e[t]=r,e}function n_(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{},n=Object.keys(r);"function"==typeof Object.getOwnPropertySymbols&&(n=n.concat(Object.getOwnPropertySymbols(r).filter((function(e){return Object.getOwnPropertyDescriptor(r,e).enumerable})))),n.forEach((function(t){r_(e,t,r[t])}))}return e}function o_(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);r.push.apply(r,n)}return r}(Object(t)).forEach((function(r){Object.defineProperty(e,r,Object.getOwnPropertyDescriptor(t,r))})),e}function i_(e){const t="string"==typeof e.rawQuery?e.rawQuery:null;if(!t)return e;var r;const n=Re(o_(n_({refId:"Annotation"},null!==(r=e.target)&&void 0!==r?r:{}),{rawSql:t}));return o_(n_({},e),{rawQuery:void 0,workspace:void 0,subscription:void 0,queryType:void 0,target:n})}function a_(e,t,r,n,o,i,a){try{var s=e[i](a),l=s.value}catch(e){return void r(e)}s.done?t(l):Promise.resolve(l).then(n,o)}function s_(e){return function(){var t=this,r=arguments;return new Promise((function(n,o){var i=e.apply(t,r);function a(e){a_(i,n,o,a,s,"next",e)}function s(e){a_(i,n,o,a,s,"throw",e)}a(void 0)}))}}function l_(e,t,r){return t in e?Object.defineProperty(e,t,{value:r,enumerable:!0,configurable:!0,writable:!0}):e[t]=r,e}function u_(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{},n=Object.keys(r);"function"==typeof Object.getOwnPropertySymbols&&(n=n.concat(Object.getOwnPropertySymbols(r).filter((function(e){return Object.getOwnPropertyDescriptor(r,e).enumerable})))),n.forEach((function(t){l_(e,t,r[t])}))}return e}function c_(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);r.push.apply(r,n)}return r}(Object(t)).forEach((function(r){Object.defineProperty(e,r,Object.getOwnPropertyDescriptor(t,r))})),e}class d_ extends pe.DataSourceWithBackend{getResponseParser(){return this.responseParser}interpolateVariablesInQueries(e,t){let r=e;return e&&e.length>0&&(r=e.map((e=>c_(u_({},e),{datasource:this.getRef(),rawSql:this.templateSrv.replace(e.rawSql,t,this.interpolateVariable),rawQuery:!0})))),r}filterQuery(e){return!e.hide}applyTemplateVariables(e,t){return{refId:e.refId,datasource:this.getRef(),rawSql:this.templateSrv.replace(e.rawSql,t,this.interpolateVariable),format:e.format}}query(e){if(ft()){const t=this.checkForDatabaseIssue(e);if(t){const e=new Error(t);return(0,x.throwError)((()=>e))}}return e.targets.forEach((t=>{var r;e.app!==T.CoreApp.Dashboard&&e.app!==T.CoreApp.PanelViewer&&(0,pe.reportInteraction)("grafana_sql_query_executed",{datasource:null===(r=t.datasource)||void 0===r?void 0:r.type,editorMode:t.editorMode,format:t.format,app:e.app})})),super.query(e)}checkForDatabaseIssue(e){if("postgres"===this.type&&!this.preconfiguredDatabase)return"You do not currently have a default database configured for this data source. Postgres requires a default\n             database with which to connect. Please configure one through the Data Sources Configuration page, or if you\n             are using a provisioning file, update that configuration file with a default database.";if(e.app!==T.CoreApp.Explore&&this.preconfiguredDatabase)for(const t of e.targets)if(t.editorMode===de.Builder&&t.dataset!==this.preconfiguredDatabase)return"The configuration for this panel's data source has been modified. The previous database used in this panel's\n                   saved query is no longer available. Please update the query to use the new database option.\n                   Previous query parameters will be preserved until the query is updated."}metricFindQuery(e,t){var r=this;return s_((function*(){const n=null==t?void 0:t.range;if(null==n)return[];let o="tempvar";t&&t.variable&&t.variable.name&&(o=t.variable.name);const i=u_({},null==t?void 0:t.scopedVars,(0,T.getSearchFilterScopedVar)({query:e,wildcardChar:"%",options:t})),a=r.templateSrv.replace(e,i,r.interpolateVariable),s={refId:o,datasource:r.getRef(),rawSql:a,format:S.Table};let l;try{l=yield r.runMetaQuery(s,n)}catch(e){throw console.error(e),new Error("error when executing the sql query")}return r.getResponseParser().transformMetricFindResponse(l)}))()}runSql(e,t){var r=this;return s_((function*(){const n=(0,T.getDefaultTimeRange)(),o=yield r.runMetaQuery({rawSql:e,format:S.Table,refId:null==t?void 0:t.refId},n);return new T.DataFrameView(o)}))()}runMetaQuery(e,t){const r=e.refId||"meta",n=[c_(u_({},e),{datasource:e.datasource||this.getRef(),refId:r})];return(0,x.lastValueFrom)((0,pe.getBackendSrv)().fetch({url:"/api/ds/query",method:"POST",headers:this.getRequestHeaders(),data:{from:t.from.valueOf().toString(),to:t.to.valueOf().toString(),queries:n},requestId:r}).pipe(re((e=>{var t;return null!==(t=(0,pe.toDataQueryResponse)(e,n).data[0])&&void 0!==t?t:{fields:[]}}))))}targetContainsTemplate(e){let t=e.rawSql;return _n.forEach((e=>{t=(null==t?void 0:t.replace(e,""))||""})),this.templateSrv.containsTemplate(t)}constructor(e,t=(0,pe.getTemplateSrv)()){super(e),l_(this,"templateSrv",void 0),l_(this,"id",void 0),l_(this,"responseParser",void 0),l_(this,"name",void 0),l_(this,"interval",void 0),l_(this,"db",void 0),l_(this,"preconfiguredDatabase",void 0),l_(this,"interpolateVariable",void 0),this.templateSrv=t,this.interpolateVariable=(e,t)=>"string"==typeof e?t.multi||t.includeAll?this.getQueryModel().quoteLiteral(e):String(e).replace(/'/g,"''"):"number"==typeof e?e:Array.isArray(e)?e.map((e=>this.getQueryModel().quoteLiteral(e))).join(","):e,this.name=e.name,this.responseParser=new he,this.id=e.id;const r=e.jsonData||{};var n;this.interval=r.timeInterval||"1m",this.db=this.getDB(),this.preconfiguredDatabase=null!==(n=r.database)&&void 0!==n?n:"",this.annotations={prepareAnnotation:i_,QueryEditor:e_}}}var p_=Object.defineProperty,f_=Object.defineProperties,h_=Object.getOwnPropertyDescriptors,v_=Object.getOwnPropertySymbols,g_=Object.prototype.hasOwnProperty,y_=Object.prototype.propertyIsEnumerable,m_=(e,t,r)=>t in e?p_(e,t,{enumerable:!0,configurable:!0,writable:!0,value:r}):e[t]=r,b_=(e,t)=>{for(var r in t||(t={}))g_.call(t,r)&&m_(e,r,t[r]);if(v_)for(var r of v_(t))y_.call(t,r)&&m_(e,r,t[r]);return e};const O_=({children:e,title:t,description:r,isCollapsible:n=!1,isInitiallyOpen:o=!0,kind:i="section",className:a})=>{const{colors:s,typography:l,spacing:u}=(0,R.useTheme2)(),[c,d]=(0,ye.useState)(!n||o),p=c?"angle-up":"angle-down",f="sub-section"===i,h=`${c?"Collapse":"Expand"} section ${t}`,v={header:(0,w.css)({display:"flex",justifyContent:"space-between",alignItems:"center"}),title:(0,w.css)({margin:0}),subtitle:(0,w.css)({margin:0,fontWeight:l.fontWeightRegular}),descriptionText:(0,w.css)((g=b_({marginTop:u(f?.25:.5),marginBottom:0},l.bodySmall),y={color:s.text.secondary},f_(g,h_(y)))),content:(0,w.css)({marginTop:u(2)})};var g,y;return me().createElement("div",{className:a},me().createElement("div",{className:v.header},"section"===i?me().createElement("h3",{className:v.title},t):me().createElement("h6",{className:v.subtitle},t),n&&me().createElement(R.IconButton,{name:p,onClick:()=>d(!c),type:"button",size:"xl","aria-label":h})),r&&me().createElement("p",{className:v.descriptionText},r),c&&me().createElement("div",{className:v.content},e))};var E_=Object.defineProperty,S_=Object.defineProperties,T_=Object.getOwnPropertyDescriptors,__=Object.getOwnPropertySymbols,w_=Object.prototype.hasOwnProperty,R_=Object.prototype.propertyIsEnumerable,A_=(e,t,r)=>t in e?E_(e,t,{enumerable:!0,configurable:!0,writable:!0,value:r}):e[t]=r;const C_=e=>{var t,r=e,{children:n}=r,o=((e,t)=>{var r={};for(var n in e)w_.call(e,n)&&t.indexOf(n)<0&&(r[n]=e[n]);if(null!=e&&__)for(var n of __(e))t.indexOf(n)<0&&R_.call(e,n)&&(r[n]=e[n]);return r})(r,["children"]);return me().createElement(O_,(t=((e,t)=>{for(var r in t||(t={}))w_.call(t,r)&&A_(e,r,t[r]);if(__)for(var r of __(t))R_.call(t,r)&&A_(e,r,t[r]);return e})({},o),S_(t,T_({kind:"sub-section"}))),n)};var I_=p(8145),x_=(p(9874),p(3238)),L_=p.n(x_);let N_=null;const j_=new WeakMap;function P_(){return(0,ye.useContext)(N_||T.ThemeContext)}function k_(e,...t){const r=P_();let n=j_.get(e);return n||(n=L_()(e,{maxSize:10}),j_.set(e,n)),n(r,...t)}function F_(e){return F_="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(e){return typeof e}:function(e){return e&&"function"==typeof Symbol&&e.constructor===Symbol&&e!==Symbol.prototype?"symbol":typeof e},F_(e)}var D_=/^\s+/,M_=/\s+$/;function V_(e,t){if(t=t||{},(e=e||"")instanceof V_)return e;if(!(this instanceof V_))return new V_(e,t);var r=function(e){var t,r,n,o={r:0,g:0,b:0},i=1,a=null,s=null,l=null,u=!1,c=!1;return"string"==typeof e&&(e=function(e){e=e.replace(D_,"").replace(M_,"").toLowerCase();var t,r=!1;if(rw[e])e=rw[e],r=!0;else if("transparent"==e)return{r:0,g:0,b:0,a:0,format:"name"};return(t=vw.rgb.exec(e))?{r:t[1],g:t[2],b:t[3]}:(t=vw.rgba.exec(e))?{r:t[1],g:t[2],b:t[3],a:t[4]}:(t=vw.hsl.exec(e))?{h:t[1],s:t[2],l:t[3]}:(t=vw.hsla.exec(e))?{h:t[1],s:t[2],l:t[3],a:t[4]}:(t=vw.hsv.exec(e))?{h:t[1],s:t[2],v:t[3]}:(t=vw.hsva.exec(e))?{h:t[1],s:t[2],v:t[3],a:t[4]}:(t=vw.hex8.exec(e))?{r:sw(t[1]),g:sw(t[2]),b:sw(t[3]),a:dw(t[4]),format:r?"name":"hex8"}:(t=vw.hex6.exec(e))?{r:sw(t[1]),g:sw(t[2]),b:sw(t[3]),format:r?"name":"hex"}:(t=vw.hex4.exec(e))?{r:sw(t[1]+""+t[1]),g:sw(t[2]+""+t[2]),b:sw(t[3]+""+t[3]),a:dw(t[4]+""+t[4]),format:r?"name":"hex8"}:!!(t=vw.hex3.exec(e))&&{r:sw(t[1]+""+t[1]),g:sw(t[2]+""+t[2]),b:sw(t[3]+""+t[3]),format:r?"name":"hex"}}(e)),"object"==F_(e)&&(gw(e.r)&&gw(e.g)&&gw(e.b)?(t=e.r,r=e.g,n=e.b,o={r:255*iw(t,255),g:255*iw(r,255),b:255*iw(n,255)},u=!0,c="%"===String(e.r).substr(-1)?"prgb":"rgb"):gw(e.h)&&gw(e.s)&&gw(e.v)?(a=uw(e.s),s=uw(e.v),o=function(e,t,r){e=6*iw(e,360),t=iw(t,100),r=iw(r,100);var n=Math.floor(e),o=e-n,i=r*(1-t),a=r*(1-o*t),s=r*(1-(1-o)*t),l=n%6;return{r:255*[r,a,i,i,s,r][l],g:255*[s,r,r,a,i,i][l],b:255*[i,i,s,r,r,a][l]}}(e.h,a,s),u=!0,c="hsv"):gw(e.h)&&gw(e.s)&&gw(e.l)&&(a=uw(e.s),l=uw(e.l),o=function(e,t,r){var n,o,i;function a(e,t,r){return r<0&&(r+=1),r>1&&(r-=1),r<1/6?e+6*(t-e)*r:r<.5?t:r<2/3?e+(t-e)*(2/3-r)*6:e}if(e=iw(e,360),t=iw(t,100),r=iw(r,100),0===t)n=o=i=r;else{var s=r<.5?r*(1+t):r+t-r*t,l=2*r-s;n=a(l,s,e+1/3),o=a(l,s,e),i=a(l,s,e-1/3)}return{r:255*n,g:255*o,b:255*i}}(e.h,a,l),u=!0,c="hsl"),e.hasOwnProperty("a")&&(i=e.a)),i=ow(i),{ok:u,format:e.format||c,r:Math.min(255,Math.max(o.r,0)),g:Math.min(255,Math.max(o.g,0)),b:Math.min(255,Math.max(o.b,0)),a:i}}(e);this._originalInput=e,this._r=r.r,this._g=r.g,this._b=r.b,this._a=r.a,this._roundA=Math.round(100*this._a)/100,this._format=t.format||r.format,this._gradientType=t.gradientType,this._r<1&&(this._r=Math.round(this._r)),this._g<1&&(this._g=Math.round(this._g)),this._b<1&&(this._b=Math.round(this._b)),this._ok=r.ok}function U_(e,t,r){e=iw(e,255),t=iw(t,255),r=iw(r,255);var n,o,i=Math.max(e,t,r),a=Math.min(e,t,r),s=(i+a)/2;if(i==a)n=o=0;else{var l=i-a;switch(o=s>.5?l/(2-i-a):l/(i+a),i){case e:n=(t-r)/l+(t<r?6:0);break;case t:n=(r-e)/l+2;break;case r:n=(e-t)/l+4}n/=6}return{h:n,s:o,l:s}}function B_(e,t,r){e=iw(e,255),t=iw(t,255),r=iw(r,255);var n,o,i=Math.max(e,t,r),a=Math.min(e,t,r),s=i,l=i-a;if(o=0===i?0:l/i,i==a)n=0;else{switch(i){case e:n=(t-r)/l+(t<r?6:0);break;case t:n=(r-e)/l+2;break;case r:n=(e-t)/l+4}n/=6}return{h:n,s:o,v:s}}function q_(e,t,r,n){var o=[lw(Math.round(e).toString(16)),lw(Math.round(t).toString(16)),lw(Math.round(r).toString(16))];return n&&o[0].charAt(0)==o[0].charAt(1)&&o[1].charAt(0)==o[1].charAt(1)&&o[2].charAt(0)==o[2].charAt(1)?o[0].charAt(0)+o[1].charAt(0)+o[2].charAt(0):o.join("")}function G_(e,t,r,n){return[lw(cw(n)),lw(Math.round(e).toString(16)),lw(Math.round(t).toString(16)),lw(Math.round(r).toString(16))].join("")}function K_(e,t){t=0===t?0:t||10;var r=V_(e).toHsl();return r.s-=t/100,r.s=aw(r.s),V_(r)}function W_(e,t){t=0===t?0:t||10;var r=V_(e).toHsl();return r.s+=t/100,r.s=aw(r.s),V_(r)}function z_(e){return V_(e).desaturate(100)}function $_(e,t){t=0===t?0:t||10;var r=V_(e).toHsl();return r.l+=t/100,r.l=aw(r.l),V_(r)}function H_(e,t){t=0===t?0:t||10;var r=V_(e).toRgb();return r.r=Math.max(0,Math.min(255,r.r-Math.round(-t/100*255))),r.g=Math.max(0,Math.min(255,r.g-Math.round(-t/100*255))),r.b=Math.max(0,Math.min(255,r.b-Math.round(-t/100*255))),V_(r)}function Y_(e,t){t=0===t?0:t||10;var r=V_(e).toHsl();return r.l-=t/100,r.l=aw(r.l),V_(r)}function Q_(e,t){var r=V_(e).toHsl(),n=(r.h+t)%360;return r.h=n<0?360+n:n,V_(r)}function X_(e){var t=V_(e).toHsl();return t.h=(t.h+180)%360,V_(t)}function J_(e,t){if(isNaN(t)||t<=0)throw new Error("Argument to polyad must be a positive number");for(var r=V_(e).toHsl(),n=[V_(e)],o=360/t,i=1;i<t;i++)n.push(V_({h:(r.h+i*o)%360,s:r.s,l:r.l}));return n}function Z_(e){var t=V_(e).toHsl(),r=t.h;return[V_(e),V_({h:(r+72)%360,s:t.s,l:t.l}),V_({h:(r+216)%360,s:t.s,l:t.l})]}function ew(e,t,r){t=t||6,r=r||30;var n=V_(e).toHsl(),o=360/r,i=[V_(e)];for(n.h=(n.h-(o*t>>1)+720)%360;--t;)n.h=(n.h+o)%360,i.push(V_(n));return i}function tw(e,t){t=t||6;for(var r=V_(e).toHsv(),n=r.h,o=r.s,i=r.v,a=[],s=1/t;t--;)a.push(V_({h:n,s:o,v:i})),i=(i+s)%1;return a}V_.prototype={isDark:function(){return this.getBrightness()<128},isLight:function(){return!this.isDark()},isValid:function(){return this._ok},getOriginalInput:function(){return this._originalInput},getFormat:function(){return this._format},getAlpha:function(){return this._a},getBrightness:function(){var e=this.toRgb();return(299*e.r+587*e.g+114*e.b)/1e3},getLuminance:function(){var e,t,r,n=this.toRgb();return e=n.r/255,t=n.g/255,r=n.b/255,.2126*(e<=.03928?e/12.92:Math.pow((e+.055)/1.055,2.4))+.7152*(t<=.03928?t/12.92:Math.pow((t+.055)/1.055,2.4))+.0722*(r<=.03928?r/12.92:Math.pow((r+.055)/1.055,2.4))},setAlpha:function(e){return this._a=ow(e),this._roundA=Math.round(100*this._a)/100,this},toHsv:function(){var e=B_(this._r,this._g,this._b);return{h:360*e.h,s:e.s,v:e.v,a:this._a}},toHsvString:function(){var e=B_(this._r,this._g,this._b),t=Math.round(360*e.h),r=Math.round(100*e.s),n=Math.round(100*e.v);return 1==this._a?"hsv("+t+", "+r+"%, "+n+"%)":"hsva("+t+", "+r+"%, "+n+"%, "+this._roundA+")"},toHsl:function(){var e=U_(this._r,this._g,this._b);return{h:360*e.h,s:e.s,l:e.l,a:this._a}},toHslString:function(){var e=U_(this._r,this._g,this._b),t=Math.round(360*e.h),r=Math.round(100*e.s),n=Math.round(100*e.l);return 1==this._a?"hsl("+t+", "+r+"%, "+n+"%)":"hsla("+t+", "+r+"%, "+n+"%, "+this._roundA+")"},toHex:function(e){return q_(this._r,this._g,this._b,e)},toHexString:function(e){return"#"+this.toHex(e)},toHex8:function(e){return function(e,t,r,n,o){var i=[lw(Math.round(e).toString(16)),lw(Math.round(t).toString(16)),lw(Math.round(r).toString(16)),lw(cw(n))];return o&&i[0].charAt(0)==i[0].charAt(1)&&i[1].charAt(0)==i[1].charAt(1)&&i[2].charAt(0)==i[2].charAt(1)&&i[3].charAt(0)==i[3].charAt(1)?i[0].charAt(0)+i[1].charAt(0)+i[2].charAt(0)+i[3].charAt(0):i.join("")}(this._r,this._g,this._b,this._a,e)},toHex8String:function(e){return"#"+this.toHex8(e)},toRgb:function(){return{r:Math.round(this._r),g:Math.round(this._g),b:Math.round(this._b),a:this._a}},toRgbString:function(){return 1==this._a?"rgb("+Math.round(this._r)+", "+Math.round(this._g)+", "+Math.round(this._b)+")":"rgba("+Math.round(this._r)+", "+Math.round(this._g)+", "+Math.round(this._b)+", "+this._roundA+")"},toPercentageRgb:function(){return{r:Math.round(100*iw(this._r,255))+"%",g:Math.round(100*iw(this._g,255))+"%",b:Math.round(100*iw(this._b,255))+"%",a:this._a}},toPercentageRgbString:function(){return 1==this._a?"rgb("+Math.round(100*iw(this._r,255))+"%, "+Math.round(100*iw(this._g,255))+"%, "+Math.round(100*iw(this._b,255))+"%)":"rgba("+Math.round(100*iw(this._r,255))+"%, "+Math.round(100*iw(this._g,255))+"%, "+Math.round(100*iw(this._b,255))+"%, "+this._roundA+")"},toName:function(){return 0===this._a?"transparent":!(this._a<1)&&(nw[q_(this._r,this._g,this._b,!0)]||!1)},toFilter:function(e){var t="#"+G_(this._r,this._g,this._b,this._a),r=t,n=this._gradientType?"GradientType = 1, ":"";if(e){var o=V_(e);r="#"+G_(o._r,o._g,o._b,o._a)}return"progid:DXImageTransform.Microsoft.gradient("+n+"startColorstr="+t+",endColorstr="+r+")"},toString:function(e){var t=!!e;e=e||this._format;var r=!1,n=this._a<1&&this._a>=0;return t||!n||"hex"!==e&&"hex6"!==e&&"hex3"!==e&&"hex4"!==e&&"hex8"!==e&&"name"!==e?("rgb"===e&&(r=this.toRgbString()),"prgb"===e&&(r=this.toPercentageRgbString()),"hex"!==e&&"hex6"!==e||(r=this.toHexString()),"hex3"===e&&(r=this.toHexString(!0)),"hex4"===e&&(r=this.toHex8String(!0)),"hex8"===e&&(r=this.toHex8String()),"name"===e&&(r=this.toName()),"hsl"===e&&(r=this.toHslString()),"hsv"===e&&(r=this.toHsvString()),r||this.toHexString()):"name"===e&&0===this._a?this.toName():this.toRgbString()},clone:function(){return V_(this.toString())},_applyModification:function(e,t){var r=e.apply(null,[this].concat([].slice.call(t)));return this._r=r._r,this._g=r._g,this._b=r._b,this.setAlpha(r._a),this},lighten:function(){return this._applyModification($_,arguments)},brighten:function(){return this._applyModification(H_,arguments)},darken:function(){return this._applyModification(Y_,arguments)},desaturate:function(){return this._applyModification(K_,arguments)},saturate:function(){return this._applyModification(W_,arguments)},greyscale:function(){return this._applyModification(z_,arguments)},spin:function(){return this._applyModification(Q_,arguments)},_applyCombination:function(e,t){return e.apply(null,[this].concat([].slice.call(t)))},analogous:function(){return this._applyCombination(ew,arguments)},complement:function(){return this._applyCombination(X_,arguments)},monochromatic:function(){return this._applyCombination(tw,arguments)},splitcomplement:function(){return this._applyCombination(Z_,arguments)},triad:function(){return this._applyCombination(J_,[3])},tetrad:function(){return this._applyCombination(J_,[4])}},V_.fromRatio=function(e,t){if("object"==F_(e)){var r={};for(var n in e)e.hasOwnProperty(n)&&(r[n]="a"===n?e[n]:uw(e[n]));e=r}return V_(e,t)},V_.equals=function(e,t){return!(!e||!t)&&V_(e).toRgbString()==V_(t).toRgbString()},V_.random=function(){return V_.fromRatio({r:Math.random(),g:Math.random(),b:Math.random()})},V_.mix=function(e,t,r){r=0===r?0:r||50;var n=V_(e).toRgb(),o=V_(t).toRgb(),i=r/100;return V_({r:(o.r-n.r)*i+n.r,g:(o.g-n.g)*i+n.g,b:(o.b-n.b)*i+n.b,a:(o.a-n.a)*i+n.a})},V_.readability=function(e,t){var r=V_(e),n=V_(t);return(Math.max(r.getLuminance(),n.getLuminance())+.05)/(Math.min(r.getLuminance(),n.getLuminance())+.05)},V_.isReadable=function(e,t,r){var n,o,i,a,s,l=V_.readability(e,t);switch(o=!1,(i=r,"AA"!==(a=((i=i||{level:"AA",size:"small"}).level||"AA").toUpperCase())&&"AAA"!==a&&(a="AA"),"small"!==(s=(i.size||"small").toLowerCase())&&"large"!==s&&(s="small"),n={level:a,size:s}).level+n.size){case"AAsmall":case"AAAlarge":o=l>=4.5;break;case"AAlarge":o=l>=3;break;case"AAAsmall":o=l>=7}return o},V_.mostReadable=function(e,t,r){var n,o,i,a,s=null,l=0;o=(r=r||{}).includeFallbackColors,i=r.level,a=r.size;for(var u=0;u<t.length;u++)(n=V_.readability(e,t[u]))>l&&(l=n,s=V_(t[u]));return V_.isReadable(e,s,{level:i,size:a})||!o?s:(r.includeFallbackColors=!1,V_.mostReadable(e,["#fff","#000"],r))};var rw=V_.names={aliceblue:"f0f8ff",antiquewhite:"faebd7",aqua:"0ff",aquamarine:"7fffd4",azure:"f0ffff",beige:"f5f5dc",bisque:"ffe4c4",black:"000",blanchedalmond:"ffebcd",blue:"00f",blueviolet:"8a2be2",brown:"a52a2a",burlywood:"deb887",burntsienna:"ea7e5d",cadetblue:"5f9ea0",chartreuse:"7fff00",chocolate:"d2691e",coral:"ff7f50",cornflowerblue:"6495ed",cornsilk:"fff8dc",crimson:"dc143c",cyan:"0ff",darkblue:"00008b",darkcyan:"008b8b",darkgoldenrod:"b8860b",darkgray:"a9a9a9",darkgreen:"006400",darkgrey:"a9a9a9",darkkhaki:"bdb76b",darkmagenta:"8b008b",darkolivegreen:"556b2f",darkorange:"ff8c00",darkorchid:"9932cc",darkred:"8b0000",darksalmon:"e9967a",darkseagreen:"8fbc8f",darkslateblue:"483d8b",darkslategray:"2f4f4f",darkslategrey:"2f4f4f",darkturquoise:"00ced1",darkviolet:"9400d3",deeppink:"ff1493",deepskyblue:"00bfff",dimgray:"696969",dimgrey:"696969",dodgerblue:"1e90ff",firebrick:"b22222",floralwhite:"fffaf0",forestgreen:"228b22",fuchsia:"f0f",gainsboro:"dcdcdc",ghostwhite:"f8f8ff",gold:"ffd700",goldenrod:"daa520",gray:"808080",green:"008000",greenyellow:"adff2f",grey:"808080",honeydew:"f0fff0",hotpink:"ff69b4",indianred:"cd5c5c",indigo:"4b0082",ivory:"fffff0",khaki:"f0e68c",lavender:"e6e6fa",lavenderblush:"fff0f5",lawngreen:"7cfc00",lemonchiffon:"fffacd",lightblue:"add8e6",lightcoral:"f08080",lightcyan:"e0ffff",lightgoldenrodyellow:"fafad2",lightgray:"d3d3d3",lightgreen:"90ee90",lightgrey:"d3d3d3",lightpink:"ffb6c1",lightsalmon:"ffa07a",lightseagreen:"20b2aa",lightskyblue:"87cefa",lightslategray:"789",lightslategrey:"789",lightsteelblue:"b0c4de",lightyellow:"ffffe0",lime:"0f0",limegreen:"32cd32",linen:"faf0e6",magenta:"f0f",maroon:"800000",mediumaquamarine:"66cdaa",mediumblue:"0000cd",mediumorchid:"ba55d3",mediumpurple:"9370db",mediumseagreen:"3cb371",mediumslateblue:"7b68ee",mediumspringgreen:"00fa9a",mediumturquoise:"48d1cc",mediumvioletred:"c71585",midnightblue:"191970",mintcream:"f5fffa",mistyrose:"ffe4e1",moccasin:"ffe4b5",navajowhite:"ffdead",navy:"000080",oldlace:"fdf5e6",olive:"808000",olivedrab:"6b8e23",orange:"ffa500",orangered:"ff4500",orchid:"da70d6",palegoldenrod:"eee8aa",palegreen:"98fb98",paleturquoise:"afeeee",palevioletred:"db7093",papayawhip:"ffefd5",peachpuff:"ffdab9",peru:"cd853f",pink:"ffc0cb",plum:"dda0dd",powderblue:"b0e0e6",purple:"800080",rebeccapurple:"663399",red:"f00",rosybrown:"bc8f8f",royalblue:"4169e1",saddlebrown:"8b4513",salmon:"fa8072",sandybrown:"f4a460",seagreen:"2e8b57",seashell:"fff5ee",sienna:"a0522d",silver:"c0c0c0",skyblue:"87ceeb",slateblue:"6a5acd",slategray:"708090",slategrey:"708090",snow:"fffafa",springgreen:"00ff7f",steelblue:"4682b4",tan:"d2b48c",teal:"008080",thistle:"d8bfd8",tomato:"ff6347",turquoise:"40e0d0",violet:"ee82ee",wheat:"f5deb3",white:"fff",whitesmoke:"f5f5f5",yellow:"ff0",yellowgreen:"9acd32"},nw=V_.hexNames=function(e){var t={};for(var r in e)e.hasOwnProperty(r)&&(t[e[r]]=r);return t}(rw);function ow(e){return e=parseFloat(e),(isNaN(e)||e<0||e>1)&&(e=1),e}function iw(e,t){(function(e){return"string"==typeof e&&-1!=e.indexOf(".")&&1===parseFloat(e)})(e)&&(e="100%");var r=function(e){return"string"==typeof e&&-1!=e.indexOf("%")}(e);return e=Math.min(t,Math.max(0,parseFloat(e))),r&&(e=parseInt(e*t,10)/100),Math.abs(e-t)<1e-6?1:e%t/parseFloat(t)}function aw(e){return Math.min(1,Math.max(0,e))}function sw(e){return parseInt(e,16)}function lw(e){return 1==e.length?"0"+e:""+e}function uw(e){return e<=1&&(e=100*e+"%"),e}function cw(e){return Math.round(255*parseFloat(e)).toString(16)}function dw(e){return sw(e)/255}var pw,fw,hw,vw=(fw="[\\s|\\(]+("+(pw="(?:[-\\+]?\\d*\\.\\d+%?)|(?:[-\\+]?\\d+%?)")+")[,|\\s]+("+pw+")[,|\\s]+("+pw+")\\s*\\)?",hw="[\\s|\\(]+("+pw+")[,|\\s]+("+pw+")[,|\\s]+("+pw+")[,|\\s]+("+pw+")\\s*\\)?",{CSS_UNIT:new RegExp(pw),rgb:new RegExp("rgb"+fw),rgba:new RegExp("rgba"+hw),hsl:new RegExp("hsl"+fw),hsla:new RegExp("hsla"+hw),hsv:new RegExp("hsv"+fw),hsva:new RegExp("hsva"+hw),hex3:/^#?([0-9a-fA-F]{1})([0-9a-fA-F]{1})([0-9a-fA-F]{1})$/,hex6:/^#?([0-9a-fA-F]{2})([0-9a-fA-F]{2})([0-9a-fA-F]{2})$/,hex4:/^#?([0-9a-fA-F]{1})([0-9a-fA-F]{1})([0-9a-fA-F]{1})([0-9a-fA-F]{1})$/,hex8:/^#?([0-9a-fA-F]{2})([0-9a-fA-F]{2})([0-9a-fA-F]{2})([0-9a-fA-F]{2})$/});function gw(e){return!!vw.CSS_UNIT.exec(e)}function yw(e){return{outline:"2px dotted transparent",outlineOffset:"2px",boxShadow:`0 0 0 2px ${e.colors.background.canvas}, 0 0 0px 4px ${e.colors.primary.main}`,transitionTimingFunction:"cubic-bezier(0.19, 1, 0.22, 1)",transitionDuration:"0.2s",transitionProperty:"outline, outline-offset, box-shadow"}}const mw=e=>(0,w.css)({"&:focus":yw(e)}),bw=(e,t=!1)=>{const r=t?e.colors.error.border:e.components.input.borderColor,n=t?e.colors.error.shade:e.components.input.borderHover,o=e.components.input.background,i=e.components.input.text,a=e.isDark?"#2e2f35":"#bab4ca";return(0,w.cx)(Ow(e),(0,w.css)({background:o,lineHeight:e.typography.body.lineHeight,fontSize:e.typography.size.md,color:i,border:`1px solid ${r}`,"&:-webkit-autofill, &:-webkit-autofill:hover":{boxShadow:`inset 0 0 0 1px rgba(255, 255, 255, 0), inset 0 0 0 100px ${o}!important`,WebkitTextFillColor:`${i} !important`,borderColor:a},"&:-webkit-autofill:focus":{boxShadow:`0 0 0 2px ${e.colors.background.primary}, 0 0 0px 4px ${e.colors.primary.main}, inset 0 0 0 1px rgba(255, 255, 255, 0), inset 0 0 0 100px ${o}!important`,WebkitTextFillColor:`${i} !important`},"&:hover":{borderColor:n},"&:focus":{outline:"none"},"&:disabled":{backgroundColor:e.colors.action.disabledBackground,color:e.colors.action.disabledText,border:`1px solid ${e.colors.action.disabledBackground}`,"&:hover":{borderColor:r}},"&::placeholder":{color:e.colors.text.disabled,opacity:1}}))},Ow=e=>(0,w.css)({padding:e.spacing(0,1,0,1)});var Ew=function(e){return e.split(/ ?; ?/).reduce((function(e,t){var r=function(e,t){var r="function"==typeof Symbol&&e[Symbol.iterator];if(!r)return e;var n,o,i=r.call(e),a=[];try{for(;(void 0===t||t-- >0)&&!(n=i.next()).done;)a.push(n.value)}catch(e){o={error:e}}finally{try{n&&!n.done&&(r=i.return)&&r.call(i)}finally{if(o)throw o.error}}return a}(t.split(/ ?: ?/),2),n=r[0],o=r[1];return n&&o&&(e[n.replace(/-(\w)/g,(function(e,t){return t.toUpperCase()}))]=Number.isNaN(Number(o))?o:Number(o)),e}),{})},Sw=["br","col","colgroup","dl","hr","iframe","img","input","link","menuitem","meta","ol","param","select","table","tbody","tfoot","thead","tr","ul","wbr"],Tw={"accept-charset":"acceptCharset",acceptcharset:"acceptCharset",accesskey:"accessKey",allowfullscreen:"allowFullScreen",autocapitalize:"autoCapitalize",autocomplete:"autoComplete",autocorrect:"autoCorrect",autofocus:"autoFocus",autoplay:"autoPlay",autosave:"autoSave",cellpadding:"cellPadding",cellspacing:"cellSpacing",charset:"charSet",class:"className",classid:"classID",classname:"className",colspan:"colSpan",contenteditable:"contentEditable",contextmenu:"contextMenu",controlslist:"controlsList",crossorigin:"crossOrigin",dangerouslysetinnerhtml:"dangerouslySetInnerHTML",datetime:"dateTime",defaultchecked:"defaultChecked",defaultvalue:"defaultValue",enctype:"encType",for:"htmlFor",formmethod:"formMethod",formaction:"formAction",formenctype:"formEncType",formnovalidate:"formNoValidate",formtarget:"formTarget",frameborder:"frameBorder",hreflang:"hrefLang",htmlfor:"htmlFor",httpequiv:"httpEquiv","http-equiv":"httpEquiv",icon:"icon",innerhtml:"innerHTML",inputmode:"inputMode",itemid:"itemID",itemprop:"itemProp",itemref:"itemRef",itemscope:"itemScope",itemtype:"itemType",keyparams:"keyParams",keytype:"keyType",marginwidth:"marginWidth",marginheight:"marginHeight",maxlength:"maxLength",mediagroup:"mediaGroup",minlength:"minLength",nomodule:"noModule",novalidate:"noValidate",playsinline:"playsInline",radiogroup:"radioGroup",readonly:"readOnly",referrerpolicy:"referrerPolicy",rowspan:"rowSpan",spellcheck:"spellCheck",srcdoc:"srcDoc",srclang:"srcLang",srcset:"srcSet",tabindex:"tabIndex",typemustmatch:"typeMustMatch",usemap:"useMap",accentheight:"accentHeight","accent-height":"accentHeight",alignmentbaseline:"alignmentBaseline","alignment-baseline":"alignmentBaseline",allowreorder:"allowReorder",arabicform:"arabicForm","arabic-form":"arabicForm",attributename:"attributeName",attributetype:"attributeType",autoreverse:"autoReverse",basefrequency:"baseFrequency",baselineshift:"baselineShift","baseline-shift":"baselineShift",baseprofile:"baseProfile",calcmode:"calcMode",capheight:"capHeight","cap-height":"capHeight",clippath:"clipPath","clip-path":"clipPath",clippathunits:"clipPathUnits",cliprule:"clipRule","clip-rule":"clipRule",colorinterpolation:"colorInterpolation","color-interpolation":"colorInterpolation",colorinterpolationfilters:"colorInterpolationFilters","color-interpolation-filters":"colorInterpolationFilters",colorprofile:"colorProfile","color-profile":"colorProfile",colorrendering:"colorRendering","color-rendering":"colorRendering",contentscripttype:"contentScriptType",contentstyletype:"contentStyleType",diffuseconstant:"diffuseConstant",dominantbaseline:"dominantBaseline","dominant-baseline":"dominantBaseline",edgemode:"edgeMode",enablebackground:"enableBackground","enable-background":"enableBackground",externalresourcesrequired:"externalResourcesRequired",fillopacity:"fillOpacity","fill-opacity":"fillOpacity",fillrule:"fillRule","fill-rule":"fillRule",filterres:"filterRes",filterunits:"filterUnits",floodopacity:"floodOpacity","flood-opacity":"floodOpacity",floodcolor:"floodColor","flood-color":"floodColor",fontfamily:"fontFamily","font-family":"fontFamily",fontsize:"fontSize","font-size":"fontSize",fontsizeadjust:"fontSizeAdjust","font-size-adjust":"fontSizeAdjust",fontstretch:"fontStretch","font-stretch":"fontStretch",fontstyle:"fontStyle","font-style":"fontStyle",fontvariant:"fontVariant","font-variant":"fontVariant",fontweight:"fontWeight","font-weight":"fontWeight",glyphname:"glyphName","glyph-name":"glyphName",glyphorientationhorizontal:"glyphOrientationHorizontal","glyph-orientation-horizontal":"glyphOrientationHorizontal",glyphorientationvertical:"glyphOrientationVertical","glyph-orientation-vertical":"glyphOrientationVertical",glyphref:"glyphRef",gradienttransform:"gradientTransform",gradientunits:"gradientUnits",horizadvx:"horizAdvX","horiz-adv-x":"horizAdvX",horizoriginx:"horizOriginX","horiz-origin-x":"horizOriginX",imagerendering:"imageRendering","image-rendering":"imageRendering",kernelmatrix:"kernelMatrix",kernelunitlength:"kernelUnitLength",keypoints:"keyPoints",keysplines:"keySplines",keytimes:"keyTimes",lengthadjust:"lengthAdjust",letterspacing:"letterSpacing","letter-spacing":"letterSpacing",lightingcolor:"lightingColor","lighting-color":"lightingColor",limitingconeangle:"limitingConeAngle",markerend:"markerEnd","marker-end":"markerEnd",markerheight:"markerHeight",markermid:"markerMid","marker-mid":"markerMid",markerstart:"markerStart","marker-start":"markerStart",markerunits:"markerUnits",markerwidth:"markerWidth",maskcontentunits:"maskContentUnits",maskunits:"maskUnits",numoctaves:"numOctaves",overlineposition:"overlinePosition","overline-position":"overlinePosition",overlinethickness:"overlineThickness","overline-thickness":"overlineThickness",paintorder:"paintOrder","paint-order":"paintOrder","panose-1":"panose1",pathlength:"pathLength",patterncontentunits:"patternContentUnits",patterntransform:"patternTransform",patternunits:"patternUnits",pointerevents:"pointerEvents","pointer-events":"pointerEvents",pointsatx:"pointsAtX",pointsaty:"pointsAtY",pointsatz:"pointsAtZ",preservealpha:"preserveAlpha",preserveaspectratio:"preserveAspectRatio",primitiveunits:"primitiveUnits",refx:"refX",refy:"refY",renderingintent:"renderingIntent","rendering-intent":"renderingIntent",repeatcount:"repeatCount",repeatdur:"repeatDur",requiredextensions:"requiredExtensions",requiredfeatures:"requiredFeatures",shaperendering:"shapeRendering","shape-rendering":"shapeRendering",specularconstant:"specularConstant",specularexponent:"specularExponent",spreadmethod:"spreadMethod",startoffset:"startOffset",stddeviation:"stdDeviation",stitchtiles:"stitchTiles",stopcolor:"stopColor","stop-color":"stopColor",stopopacity:"stopOpacity","stop-opacity":"stopOpacity",strikethroughposition:"strikethroughPosition","strikethrough-position":"strikethroughPosition",strikethroughthickness:"strikethroughThickness","strikethrough-thickness":"strikethroughThickness",strokedasharray:"strokeDasharray","stroke-dasharray":"strokeDasharray",strokedashoffset:"strokeDashoffset","stroke-dashoffset":"strokeDashoffset",strokelinecap:"strokeLinecap","stroke-linecap":"strokeLinecap",strokelinejoin:"strokeLinejoin","stroke-linejoin":"strokeLinejoin",strokemiterlimit:"strokeMiterlimit","stroke-miterlimit":"strokeMiterlimit",strokewidth:"strokeWidth","stroke-width":"strokeWidth",strokeopacity:"strokeOpacity","stroke-opacity":"strokeOpacity",suppresscontenteditablewarning:"suppressContentEditableWarning",suppresshydrationwarning:"suppressHydrationWarning",surfacescale:"surfaceScale",systemlanguage:"systemLanguage",tablevalues:"tableValues",targetx:"targetX",targety:"targetY",textanchor:"textAnchor","text-anchor":"textAnchor",textdecoration:"textDecoration","text-decoration":"textDecoration",textlength:"textLength",textrendering:"textRendering","text-rendering":"textRendering",underlineposition:"underlinePosition","underline-position":"underlinePosition",underlinethickness:"underlineThickness","underline-thickness":"underlineThickness",unicodebidi:"unicodeBidi","unicode-bidi":"unicodeBidi",unicoderange:"unicodeRange","unicode-range":"unicodeRange",unitsperem:"unitsPerEm","units-per-em":"unitsPerEm",unselectable:"unselectable",valphabetic:"vAlphabetic","v-alphabetic":"vAlphabetic",vectoreffect:"vectorEffect","vector-effect":"vectorEffect",vertadvy:"vertAdvY","vert-adv-y":"vertAdvY",vertoriginx:"vertOriginX","vert-origin-x":"vertOriginX",vertoriginy:"vertOriginY","vert-origin-y":"vertOriginY",vhanging:"vHanging","v-hanging":"vHanging",videographic:"vIdeographic","v-ideographic":"vIdeographic",viewbox:"viewBox",viewtarget:"viewTarget",vmathematical:"vMathematical","v-mathematical":"vMathematical",wordspacing:"wordSpacing","word-spacing":"wordSpacing",writingmode:"writingMode","writing-mode":"writingMode",xchannelselector:"xChannelSelector",xheight:"xHeight","x-height":"xHeight",xlinkactuate:"xlinkActuate","xlink:actuate":"xlinkActuate",xlinkarcrole:"xlinkArcrole","xlink:arcrole":"xlinkArcrole",xlinkhref:"xlinkHref","xlink:href":"xlinkHref",xlinkrole:"xlinkRole","xlink:role":"xlinkRole",xlinkshow:"xlinkShow","xlink:show":"xlinkShow",xlinktitle:"xlinkTitle","xlink:title":"xlinkTitle",xlinktype:"xlinkType","xlink:type":"xlinkType",xmlbase:"xmlBase","xml:base":"xmlBase",xmllang:"xmlLang","xml:lang":"xmlLang","xml:space":"xmlSpace",xmlnsxlink:"xmlnsXlink","xmlns:xlink":"xmlnsXlink",xmlspace:"xmlSpace",ychannelselector:"yChannelSelector",zoomandpan:"zoomAndPan",onblur:"onBlur",onchange:"onChange",onclick:"onClick",oncontextmenu:"onContextMenu",ondoubleclick:"onDoubleClick",ondrag:"onDrag",ondragend:"onDragEnd",ondragenter:"onDragEnter",ondragexit:"onDragExit",ondragleave:"onDragLeave",ondragover:"onDragOver",ondragstart:"onDragStart",ondrop:"onDrop",onerror:"onError",onfocus:"onFocus",oninput:"onInput",oninvalid:"onInvalid",onkeydown:"onKeyDown",onkeypress:"onKeyPress",onkeyup:"onKeyUp",onload:"onLoad",onmousedown:"onMouseDown",onmouseenter:"onMouseEnter",onmouseleave:"onMouseLeave",onmousemove:"onMouseMove",onmouseout:"onMouseOut",onmouseover:"onMouseOver",onmouseup:"onMouseUp",onscroll:"onScroll",onsubmit:"onSubmit",ontouchcancel:"onTouchCancel",ontouchend:"onTouchEnd",ontouchmove:"onTouchMove",ontouchstart:"onTouchStart",onwheel:"onWheel"},_w=function(){return _w=Object.assign||function(e){for(var t,r=1,n=arguments.length;r<n;r++)for(var o in t=arguments[r])Object.prototype.hasOwnProperty.call(t,o)&&(e[o]=t[o]);return e},_w.apply(this,arguments)},ww=function(e,t){var r="function"==typeof Symbol&&e[Symbol.iterator];if(!r)return e;var n,o,i=r.call(e),a=[];try{for(;(void 0===t||t-- >0)&&!(n=i.next()).done;)a.push(n.value)}catch(e){o={error:e}}finally{try{n&&!n.done&&(r=i.return)&&r.call(i)}finally{if(o)throw o.error}}return a},Rw=function(e,t,r){if(r||2===arguments.length)for(var n,o=0,i=t.length;o<i;o++)!n&&o in t||(n||(n=Array.prototype.slice.call(t,0,o)),n[o]=t[o]);return e.concat(n||Array.prototype.slice.call(t))};function Aw(e,t){var r;if(void 0===t&&(t={}),!(e&&e instanceof Node))return null;var n,o=t.actions,i=void 0===o?[]:o,a=t.index,s=void 0===a?0:a,l=t.level,u=void 0===l?0:l,c=t.randomKey,d=e,p="".concat(u,"-").concat(s),f=[];if(c&&0===u&&(p="".concat(function(e){void 0===e&&(e=6);for(var t="",r=e;r>0;--r)t+="0123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ"[Math.round(61*Math.random())];return t}(),"-").concat(p)),Array.isArray(i)&&i.forEach((function(t){t.condition(d,p,u)&&("function"==typeof t.pre&&((d=t.pre(d,p,u))instanceof Node||(d=e)),"function"==typeof t.post&&f.push(t.post(d,p,u)))})),f.length)return f;switch(d.nodeType){case 1:return ye.createElement((n=d.nodeName,/[a-z]+[A-Z]+[a-z]+/.test(n)?n:n.toLowerCase()),function(e,t){var r={key:t};if(e instanceof Element){var n=e.getAttribute("class");n&&(r.className=n),Rw([],ww(e.attributes),!1).forEach((function(e){switch(e.name){case"class":break;case"style":r[e.name]=Ew(e.value);break;case"allowfullscreen":case"allowpaymentrequest":case"async":case"autofocus":case"autoplay":case"checked":case"controls":case"default":case"defer":case"disabled":case"formnovalidate":case"hidden":case"ismap":case"itemscope":case"loop":case"multiple":case"muted":case"nomodule":case"novalidate":case"open":case"readonly":case"required":case"reversed":case"selected":case"typemustmatch":r[Tw[e.name]||e.name]=!0;break;default:r[Tw[e.name]||e.name]=e.value}}))}return r}(d,p),function(e,t,r){var n=Rw([],ww(e),!1).map((function(e,n){return Aw(e,_w(_w({},r),{index:n,level:t+1}))})).filter(Boolean);return n.length?n:null}(d.childNodes,u,t));case 3:var h=(null===(r=d.nodeValue)||void 0===r?void 0:r.toString())||"";if(/^\s+$/.test(h)&&!/[\u00A0\u202F]/.test(h))return null;if(!d.parentNode)return h;var v=d.parentNode.nodeName.toLowerCase();return Sw.includes(v)?(/\S/.test(h)&&console.warn("A textNode is not allowed inside '".concat(v,"'. Your text \"").concat(h,'" will be ignored')),null):h;default:return null}}function Cw(e,t){return void 0===t&&(t={}),"string"==typeof e?function(e,t){if(void 0===t&&(t={}),!e||"string"!=typeof e)return null;var r=t.nodeOnly,n=void 0!==r&&r,o=t.selector,i=void 0===o?"body > *":o,a=t.type,s=void 0===a?"text/html":a;try{var l=(new DOMParser).parseFromString(e,s).querySelector(i);if(!(l instanceof Node))throw new TypeError("Error parsing input");return n?l:Aw(l,t)}catch(e){}return null}(e,t):e instanceof Node?Aw(e,t):null}var Iw=p(9083),xw={FAILED:"failed",LOADED:"loaded",LOADING:"loading",PENDING:"pending",READY:"ready",UNSUPPORTED:"unsupported"};function Lw(){return Iw.canUseDOM}var Nw,jw=(Nw=function(e,t){return Nw=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(e,t){e.__proto__=t}||function(e,t){for(var r in t)Object.prototype.hasOwnProperty.call(t,r)&&(e[r]=t[r])},Nw(e,t)},function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Class extends value "+String(t)+" is not a constructor or null");function r(){this.constructor=e}Nw(e,t),e.prototype=null===t?Object.create(t):(r.prototype=t.prototype,new r)}),Pw=function(){return Pw=Object.assign||function(e){for(var t,r=1,n=arguments.length;r<n;r++)for(var o in t=arguments[r])Object.prototype.hasOwnProperty.call(t,o)&&(e[o]=t[o]);return e},Pw.apply(this,arguments)},kw=function(e,t){var r="function"==typeof Symbol&&e[Symbol.iterator];if(!r)return e;var n,o,i=r.call(e),a=[];try{for(;(void 0===t||t-- >0)&&!(n=i.next()).done;)a.push(n.value)}catch(e){o={error:e}}finally{try{n&&!n.done&&(r=i.return)&&r.call(i)}finally{if(o)throw o.error}}return a},Fw=Object.create(null),Dw=function(e){function t(t){var r=e.call(this,t)||this;return Object.defineProperty(r,"isInitialized",{enumerable:!0,configurable:!0,writable:!0,value:!1}),Object.defineProperty(r,"isActive",{enumerable:!0,configurable:!0,writable:!0,value:!1}),Object.defineProperty(r,"hash",{enumerable:!0,configurable:!0,writable:!0,value:void 0}),Object.defineProperty(r,"handleLoad",{enumerable:!0,configurable:!0,writable:!0,value:function(e,t){void 0===t&&(t=!1),r.isActive&&r.setState({content:e,hasCache:t,status:xw.LOADED},r.getElement)}}),Object.defineProperty(r,"handleError",{enumerable:!0,configurable:!0,writable:!0,value:function(e){var t=r.props.onError,n="Browser does not support SVG"===e.message?xw.UNSUPPORTED:xw.FAILED;r.isActive&&r.setState({status:n},(function(){"function"==typeof t&&t(e)}))}}),Object.defineProperty(r,"request",{enumerable:!0,configurable:!0,writable:!0,value:function(){var e=r.props,t=e.cacheRequests,n=e.fetchOptions,o=e.src;try{return t&&(Fw[o]={content:"",status:xw.LOADING}),fetch(o,n).then((function(e){var t=e.headers.get("content-type"),r=kw((t||"").split(/ ?; ?/),1)[0];if(e.status>299)throw new Error("Not found");if(!["image/svg+xml","text/plain"].some((function(e){return r.includes(e)})))throw new Error("Content type isn't valid: ".concat(r));return e.text()})).then((function(e){var n=r.props.src;if(o===n){if(r.handleLoad(e),t){var i=Fw[o];i&&(i.content=e,i.status=xw.LOADED)}}else Fw[o].status===xw.LOADING&&delete Fw[o]})).catch((function(e){r.handleError(e),t&&Fw[o]&&delete Fw[o]}))}catch(e){return r.handleError(new Error(e.message))}}}),r.state={content:"",element:null,hasCache:!!t.cacheRequests&&!!Fw[t.src],status:xw.PENDING},r.hash=t.uniqueHash||function(e){for(var t,r="abcdefghijklmnopqrstuvwxyz",n="".concat(r).concat(r.toUpperCase()).concat("1234567890"),o="",i=0;i<8;i++)o+=(t=n)[Math.floor(Math.random()*t.length)];return o}(),r}return jw(t,e),Object.defineProperty(t.prototype,"componentDidMount",{enumerable:!1,configurable:!0,writable:!0,value:function(){if(this.isActive=!0,Lw()&&!this.isInitialized){var e=this.state.status,t=this.props.src;try{if(e===xw.PENDING){if(!function(){if(!document)return!1;var e=document.createElement("div");e.innerHTML="<svg />";var t=e.firstChild;return!!t&&"http://www.w3.org/2000/svg"===t.namespaceURI}()||"undefined"==typeof window||null===window)throw new Error("Browser does not support SVG");if(!t)throw new Error("Missing src");this.load()}}catch(e){this.handleError(e)}this.isInitialized=!0}}}),Object.defineProperty(t.prototype,"componentDidUpdate",{enumerable:!1,configurable:!0,writable:!0,value:function(e,t){if(Lw()){var r=this.state,n=r.hasCache,o=r.status,i=this.props,a=i.onLoad,s=i.src;if(t.status!==xw.READY&&o===xw.READY&&a&&a(s,n),e.src!==s){if(!s)return void this.handleError(new Error("Missing src"));this.load()}}}}),Object.defineProperty(t.prototype,"componentWillUnmount",{enumerable:!1,configurable:!0,writable:!0,value:function(){this.isActive=!1}}),Object.defineProperty(t.prototype,"getNode",{enumerable:!1,configurable:!0,writable:!0,value:function(){var e=this.props,t=e.description,r=e.title;try{var n=Cw(this.processSVG(),{nodeOnly:!0});if(!(n&&n instanceof SVGSVGElement))throw new Error("Could not convert the src to a DOM Node");var o=this.updateSVGAttributes(n);if(t){var i=o.querySelector("desc");i&&i.parentNode&&i.parentNode.removeChild(i);var a=document.createElementNS("http://www.w3.org/2000/svg","desc");a.innerHTML=t,o.prepend(a)}if(void 0!==r){var s=o.querySelector("title");if(s&&s.parentNode&&s.parentNode.removeChild(s),r){var l=document.createElementNS("http://www.w3.org/2000/svg","title");l.innerHTML=r,o.prepend(l)}}return o}catch(e){return this.handleError(e)}}}),Object.defineProperty(t.prototype,"getElement",{enumerable:!1,configurable:!0,writable:!0,value:function(){try{var e=Cw(this.getNode());if(!e||!ye.isValidElement(e))throw new Error("Could not convert the src to a React element");this.setState({element:e,status:xw.READY})}catch(e){this.handleError(new Error(e.message))}}}),Object.defineProperty(t.prototype,"load",{enumerable:!1,configurable:!0,writable:!0,value:function(){var e=this;this.isActive&&this.setState({content:"",element:null,hasCache:!1,status:xw.LOADING},(function(){var t=e.props,r=t.cacheRequests,n=t.src,o=r&&Fw[n];if(o&&o.status===xw.LOADED)e.handleLoad(o.content,!0);else{var i,a=n.match(/data:image\/svg[^,]*?(;base64)?,(.*)/);a?i=a[1]?window.atob(a[2]):decodeURIComponent(a[2]):n.includes("<svg")&&(i=n),i?e.handleLoad(i):e.request()}}))}}),Object.defineProperty(t.prototype,"updateSVGAttributes",{enumerable:!1,configurable:!0,writable:!0,value:function(e){var t=this,r=this.props,n=r.baseURL,o=void 0===n?"":n,i=r.uniquifyIDs,a=["id","href","xlink:href","xlink:role","xlink:arcrole"],s=["href","xlink:href"];return i?(function(e,t,r){if(r||2===arguments.length)for(var n,o=0,i=t.length;o<i;o++)!n&&o in t||(n||(n=Array.prototype.slice.call(t,0,o)),n[o]=t[o]);return e.concat(n||Array.prototype.slice.call(t))}([],kw(e.children),!1).map((function(e){if(e.attributes&&e.attributes.length){var r=Object.values(e.attributes).map((function(e){var r=e,n=e.value.match(/url\((.*?)\)/);return n&&n[1]&&(r.value=e.value.replace(n[0],"url(".concat(o).concat(n[1],"__").concat(t.hash,")"))),r}));a.forEach((function(e){var n,o,i=r.find((function(t){return t.name===e}));i&&(n=e,o=i.value,!s.includes(n)||!o||o.includes("#"))&&(i.value="".concat(i.value,"__").concat(t.hash))}))}return e.children.length?t.updateSVGAttributes(e):e})),e):e}}),Object.defineProperty(t.prototype,"processSVG",{enumerable:!1,configurable:!0,writable:!0,value:function(){var e=this.state.content,t=this.props.preProcessor;return t?t(e):e}}),Object.defineProperty(t.prototype,"render",{enumerable:!1,configurable:!0,writable:!0,value:function(){var e=this.state,t=e.element,r=e.status,n=this.props,o=n.children,i=void 0===o?null:o,a=n.innerRef,s=n.loader,l=void 0===s?null:s,u=function(e){for(var t=[],r=1;r<arguments.length;r++)t[r-1]=arguments[r];var n={};for(var o in e)({}).hasOwnProperty.call(e,o)&&(t.includes(o)||(n[o]=e[o]));return n}(this.props,"baseURL","cacheRequests","children","description","fetchOptions","innerRef","loader","onError","onLoad","preProcessor","src","title","uniqueHash","uniquifyIDs");return Lw()?t?ye.cloneElement(t,Pw({ref:a},u)):[xw.UNSUPPORTED,xw.FAILED].includes(r)?i:l:l}}),Object.defineProperty(t,"defaultProps",{enumerable:!0,configurable:!0,writable:!0,value:{cacheRequests:!0,uniquifyIDs:!1}}),t}(ye.PureComponent);const Mw=Dw;p(627),Object.create(null);const Vw=/&(?:amp|#38|lt|#60|gt|#62|apos|#39|quot|#34|nbsp|#160|copy|#169|reg|#174|hellip|#8230|#x2F|#47);/g,Uw={"&amp;":"&","&#38;":"&","&lt;":"<","&#60;":"<","&gt;":">","&#62;":">","&apos;":"'","&#39;":"'","&quot;":'"',"&#34;":'"',"&nbsp;":" ","&#160;":" ","&copy;":"©","&#169;":"©","&reg;":"®","&#174;":"®","&hellip;":"…","&#8230;":"…","&#x2F;":"/","&#47;":"/"},Bw=e=>Uw[e];let qw,Gw={bindI18n:"languageChanged",bindI18nStore:"",transEmptyNodeValue:"",transSupportBasicHtmlNodes:!0,transWrapTextNodes:"",transKeepBasicHtmlNodesFor:["br","strong","i","p"],useSuspense:!0,unescape:e=>e.replace(Vw,Bw)};const Kw={type:"3rdParty",init(e){!function(){let e=arguments.length>0&&void 0!==arguments[0]?arguments[0]:{};Gw={...Gw,...e}}(e.options.react),function(e){qw=e}(e)}};(0,ye.createContext)();const Ww=Zp.t,zw=(0,w.keyframes)({"0%":{transform:"rotate(0deg)"},"100%":{transform:"rotate(359deg)"}}),$w=["grafana","favorite","heart-break","heart","panel-add","library-panel","circle-mono"];function Hw(e,t){return(null==e?void 0:e.startsWith("gf-"))?"custom":$w.includes(e)?"mono":"default"===t?"unicons":"solid"===t?"solid":"mono"}let Yw;function Qw(){if(Yw)return Yw;const e="undefined"!=typeof window&&window.__grafana_public_path__;return Yw=e?e+"img/icons/":"public/img/icons/",Yw}function Xw(e,t,r){return t in e?Object.defineProperty(e,t,{value:r,enumerable:!0,configurable:!0,writable:!0}):e[t]=r,e}const Jw=e=>({icon:(0,w.css)({display:"inline-block",fill:"currentColor",flexShrink:0,label:"Icon",lineHeight:0,verticalAlign:"middle"}),orange:(0,w.css)({fill:e.v1.palette.orange}),spin:(0,w.css)({[e.transitions.handleMotion("no-preference","reduce")]:{animation:`${zw} 2s infinite linear`}})}),Zw=ye.forwardRef(((e,t)=>{var{size:r="md",type:n="default",name:o,className:i,style:a,title:s=""}=e,l=function(e,t){if(null==e)return{};var r,n,o=function(e,t){if(null==e)return{};var r,n,o={},i=Object.keys(e);for(n=0;n<i.length;n++)r=i[n],t.indexOf(r)>=0||(o[r]=e[r]);return o}(e,t);if(Object.getOwnPropertySymbols){var i=Object.getOwnPropertySymbols(e);for(n=0;n<i.length;n++)r=i[n],t.indexOf(r)>=0||Object.prototype.propertyIsEnumerable.call(e,r)&&(o[r]=e[r])}return o}(e,["size","type","name","className","style","title"]);const u=k_(Jw);(0,T.isIconName)(o)||console.warn("Icon component passed an invalid icon name",o);const c="fa fa-spinner"===o?"spinner":o,d=Qw(),p=function(e){switch(e){case"xs":return 12;case"sm":return 14;case"md":return 16;case"lg":return 18;case"xl":return 24;case"xxl":return 36;case"xxxl":return 48}}(r),f=p,h=o.startsWith("gf-bar-align")?16:o.startsWith("gf-interp")?30:p,v=`${d}${Hw(c,n)}/${c}.svg`,g=(0,w.cx)(u.icon,i,"mono"===n?{[u.orange]:"favorite"===o}:"",{[u.spin]:"spinner"===c});return(0,_.jsx)(Mw,function(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{},n=Object.keys(r);"function"==typeof Object.getOwnPropertySymbols&&(n=n.concat(Object.getOwnPropertySymbols(r).filter((function(e){return Object.getOwnPropertyDescriptor(r,e).enumerable})))),n.forEach((function(t){Xw(e,t,r[t])}))}return e}({"aria-hidden":!(void 0!==l.tabIndex||s||l["aria-label"]||l["aria-labelledby"]||l["aria-describedby"]),innerRef:t,src:v,width:h,height:f,title:s,className:g,style:a},l))}));Zw.displayName="Icon";const eR=({className:e,inline:t=!1,iconClassName:r,style:n,size:o="md"})=>{const i=k_(tR),a=k_(rR,o),s=window.matchMedia("(prefers-reduced-motion: reduce)").matches?"hourglass":"spinner";if("string"!=typeof o||!["xs","sm","md","lg","xl","xxl","xxxl"].includes(o)){const r=`${Qw()}${Hw(s,"default")}/${s}.svg`;return(0,_.jsx)("div",{"data-testid":"Spinner",style:n,className:(0,w.cx)({[i.inline]:t},a.wrapper,e),children:(0,_.jsx)(Mw,{src:r,width:o,height:o,className:(0,w.cx)(i.spin,a.icon,e),style:n})})}return(0,_.jsx)("div",{"data-testid":"Spinner",style:n,className:(0,w.cx)({[i.inline]:t},e),children:(0,_.jsx)(Zw,{className:(0,w.cx)(i.spin,r),name:s,size:o,"aria-label":("grafana-ui.spinner.aria-label","Loading","object"!=typeof Zp.options.resources&&Zp.use(Kw).init({resources:{},returnEmptyString:!1,lng:"en-US"}),Ww("grafana-ui.spinner.aria-label","Loading",undefined))})})},tR=e=>({inline:(0,w.css)({display:"inline-block"}),spin:(0,w.css)({[e.transitions.handleMotion("no-preference")]:{animation:`${zw} 2s infinite linear`}})}),rR=(e,t)=>({wrapper:(0,w.css)({fontSize:"string"==typeof t?t:`${t}px`}),icon:(0,w.css)({display:"inline-block",fill:"currentColor",flexShrink:0,label:"Icon",lineHeight:0,verticalAlign:"middle"})});function nR(e,t,r){return t in e?Object.defineProperty(e,t,{value:r,enumerable:!0,configurable:!0,writable:!0}):e[t]=r,e}function oR(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{},n=Object.keys(r);"function"==typeof Object.getOwnPropertySymbols&&(n=n.concat(Object.getOwnPropertySymbols(r).filter((function(e){return Object.getOwnPropertyDescriptor(r,e).enumerable})))),n.forEach((function(t){nR(e,t,r[t])}))}return e}const iR=(0,ye.forwardRef)(((e,t)=>{const{className:r,addonAfter:n,addonBefore:o,prefix:i,suffix:a,invalid:s,loading:l,width:u=0}=e,c=function(e,t){if(null==e)return{};var r,n,o=function(e,t){if(null==e)return{};var r,n,o={},i=Object.keys(e);for(n=0;n<i.length;n++)r=i[n],t.indexOf(r)>=0||(o[r]=e[r]);return o}(e,t);if(Object.getOwnPropertySymbols){var i=Object.getOwnPropertySymbols(e);for(n=0;n<i.length;n++)r=i[n],t.indexOf(r)>=0||Object.prototype.propertyIsEnumerable.call(e,r)&&(o[r]=e[r])}return o}(e,["className","addonAfter","addonBefore","prefix","suffix","invalid","loading","width"]),[d,p]=(0,I_.A)(),[f,h]=(0,I_.A)(),v=P_(),g=aR({theme:v,invalid:!!s,width:u});return(0,_.jsxs)("div",{className:(0,w.cx)(g.wrapper,r),"data-testid":"input-wrapper",children:[!!o&&(0,_.jsx)("div",{className:g.addon,children:o}),(0,_.jsxs)("div",{className:g.inputWrapper,children:[i&&(0,_.jsx)("div",{className:g.prefix,ref:d,children:i}),(0,_.jsx)("input",(y=oR({ref:t,className:g.input},c),m={style:{paddingLeft:i?p.width+12:void 0,paddingRight:a||l?h.width+12:void 0}},m=null!=m?m:{},Object.getOwnPropertyDescriptors?Object.defineProperties(y,Object.getOwnPropertyDescriptors(m)):function(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);r.push.apply(r,n)}return r}(Object(m)).forEach((function(e){Object.defineProperty(y,e,Object.getOwnPropertyDescriptor(m,e))})),y)),(a||l)&&(0,_.jsxs)("div",{className:g.suffix,ref:f,children:[l&&(0,_.jsx)(eR,{className:g.loadingIndicator,inline:!0}),a]})]}),!!n&&(0,_.jsx)("div",{className:g.addon,children:n})]});var y,m}));iR.displayName="Input";const aR=(sR=({theme:e,invalid:t=!1,width:r})=>{const n="28px",o=(0,w.css)({position:"absolute",top:0,zIndex:1,display:"flex",alignItems:"center",justifyContent:"center",flexGrow:0,flexShrink:0,fontSize:e.typography.size.md,height:"100%",minWidth:n,color:e.colors.text.secondary});return{wrapper:(0,w.cx)((0,w.css)({label:"input-wrapper",display:"flex",width:r?e.spacing(r):"100%",height:e.spacing(e.components.height.md),borderRadius:e.shape.radius.default,"&:hover":{"> .prefix, .suffix, .input":{borderColor:t?e.colors.error.border:e.colors.primary.border},"input[type='number']":{appearance:"textfield"},"input[type='number']::-webkit-inner-spin-button, input[type='number']::-webkit-outer-spin-button":{WebkitAppearance:"inner-spin-button !important",opacity:1}}})),inputWrapper:(0,w.css)({label:"input-inputWrapper",position:"relative",flexGrow:1,zIndex:1,"&:not(:first-child):last-child":{"> input":{borderLeft:"none",borderTopLeftRadius:0,borderBottomLeftRadius:0}},"&:first-child:not(:last-child)":{"> input":{borderRight:"none",borderTopRightRadius:0,borderBottomRightRadius:0}},"&:not(:first-child):not(:last-child)":{"> input":{borderRight:"none",borderTopRightRadius:0,borderBottomRightRadius:0,borderTopLeftRadius:0,borderBottomLeftRadius:0}},input:{"&:not(:first-child)":{paddingLeft:n},"&:not(:last-child)":{paddingRight:n},"&[readonly]":{cursor:"default"}}}),input:(0,w.cx)(mw(e),bw(e,t),(0,w.css)({label:"input-input",position:"relative",zIndex:0,flexGrow:1,borderRadius:e.shape.radius.default,height:"100%",width:"100%"})),inputDisabled:(0,w.css)({backgroundColor:e.colors.action.disabledBackground,color:e.colors.action.disabledText,border:`1px solid ${e.colors.action.disabledBackground}`,"&:focus":{boxShadow:"none"}}),addon:(0,w.css)({label:"input-addon",display:"flex",justifyContent:"center",alignItems:"center",flexGrow:0,flexShrink:0,position:"relative","&:first-child":{borderTopRightRadius:0,borderBottomRightRadius:0,"> :last-child":{borderTopRightRadius:0,borderBottomRightRadius:0}},"&:last-child":{borderTopLeftRadius:0,borderBottomLeftRadius:0,"> :first-child":{borderTopLeftRadius:0,borderBottomLeftRadius:0}},"> *:focus":{zIndex:2}}),prefix:(0,w.cx)(o,(0,w.css)({label:"input-prefix",paddingLeft:e.spacing(1),paddingRight:e.spacing(.5),borderRight:"none",borderTopRightRadius:0,borderBottomRightRadius:0})),suffix:(0,w.cx)(o,(0,w.css)({label:"input-suffix",paddingLeft:e.spacing(1),paddingRight:e.spacing(1),marginBottom:"-2px",borderLeft:"none",borderTopLeftRadius:0,borderBottomLeftRadius:0,right:0})),loadingIndicator:(0,w.css)({"& + *":{marginLeft:e.spacing(.5)}})}},L_()(sR));var sR;function lR({value:e,defaultValue:t,onChange:r,width:n}){const[o,i]=(0,ye.useState)(!1);return(0,_.jsx)(iR,{type:"number",placeholder:String(t),value:o?"":e,onChange:e=>{var n;if(""===(null===(n=e.currentTarget.value)||void 0===n?void 0:n.trim()))i(!0),r(t);else{i(!1);const t=Number(e.currentTarget.value);Number.isNaN(t)||r(t)}},width:n})}function uR(e,t,r){return t in e?Object.defineProperty(e,t,{value:r,enumerable:!0,configurable:!0,writable:!0}):e[t]=r,e}function cR(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{},n=Object.keys(r);"function"==typeof Object.getOwnPropertySymbols&&(n=n.concat(Object.getOwnPropertySymbols(r).filter((function(e){return Object.getOwnPropertyDescriptor(r,e).enumerable})))),n.forEach((function(t){uR(e,t,r[t])}))}return e}const dR=e=>{const{onOptionsChange:t,options:r}=e,n=r.jsonData,o=void 0!==n.maxIdleConnsAuto&&n.maxIdleConnsAuto,i=e=>{const o=(i=cR({},r),a=null!=(a={jsonData:cR({},n,e)})?a:{},Object.getOwnPropertyDescriptors?Object.defineProperties(i,Object.getOwnPropertyDescriptors(a)):function(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);r.push.apply(r,n)}return r}(Object(a)).forEach((function(e){Object.defineProperty(i,e,Object.getOwnPropertyDescriptor(a,e))})),i);var i,a;return t(o)},a=e=>t=>{i({[e]:t})};return(0,_.jsxs)(C_,{title:"Connection limits",children:[(0,_.jsx)(R.Field,{label:(0,_.jsx)(R.Label,{children:(0,_.jsxs)(Je,{gap:.5,children:[(0,_.jsx)("span",{children:"Max open"}),(0,_.jsx)(R.Tooltip,{content:(0,_.jsxs)("span",{children:["The maximum number of open connections to the database. If ",(0,_.jsx)("i",{children:"Max idle connections"})," is greater than 0 and the ",(0,_.jsx)("i",{children:"Max open connections"})," is less than ",(0,_.jsx)("i",{children:"Max idle connections"}),", then",(0,_.jsx)("i",{children:"Max idle connections"})," will be reduced to match the ",(0,_.jsx)("i",{children:"Max open connections"})," limit. If set to 0, there is no limit on the number of open connections."]}),children:(0,_.jsx)(R.Icon,{name:"info-circle",size:"sm"})})]})}),children:(0,_.jsx)(lR,{value:n.maxOpenConns,defaultValue:pe.config.sqlConnectionLimits.maxOpenConns,onChange:e=>{var t;t=e,i(o&&t?{maxOpenConns:t,maxIdleConns:t}:{maxOpenConns:t})},width:40})}),(0,_.jsx)(R.Field,{label:(0,_.jsx)(R.Label,{children:(0,_.jsxs)(Je,{gap:.5,children:[(0,_.jsx)("span",{children:"Auto max idle"}),(0,_.jsx)(R.Tooltip,{content:(0,_.jsxs)("span",{children:["If enabled, automatically set the number of ",(0,_.jsx)("i",{children:"Maximum idle connections"})," to the same value as",(0,_.jsx)("i",{children:" Max open connections"}),". If the number of maximum open connections is not set it will be set to the default (",pe.config.sqlConnectionLimits.maxIdleConns,")."]}),children:(0,_.jsx)(R.Icon,{name:"info-circle",size:"sm"})})]})}),children:(0,_.jsx)(R.Switch,{value:o,onChange:()=>{let e,t;o?(t=n.maxOpenConns,e=n.maxIdleConns):void 0!==n.maxOpenConns&&(t=n.maxOpenConns,e=n.maxOpenConns),i({maxIdleConnsAuto:!o,maxIdleConns:e,maxOpenConns:t})}})}),(0,_.jsx)(R.Field,{label:(0,_.jsx)(R.Label,{children:(0,_.jsxs)(Je,{gap:.5,children:[(0,_.jsx)("span",{children:"Max idle"}),(0,_.jsx)(R.Tooltip,{content:(0,_.jsxs)("span",{children:["The maximum number of connections in the idle connection pool.If ",(0,_.jsx)("i",{children:"Max open connections"})," is greater than 0 but less than the ",(0,_.jsx)("i",{children:"Max idle connections"}),", then the ",(0,_.jsx)("i",{children:"Max idle connections"})," ","will be reduced to match the ",(0,_.jsx)("i",{children:"Max open connections"})," limit. If set to 0, no idle connections are retained."]}),children:(0,_.jsx)(R.Icon,{name:"info-circle",size:"sm"})})]})}),children:o?(0,_.jsx)(R.InlineLabel,{width:40,children:r.jsonData.maxIdleConns}):(0,_.jsx)(lR,{value:n.maxIdleConns,defaultValue:pe.config.sqlConnectionLimits.maxIdleConns,onChange:e=>{a("maxIdleConns")(e)},width:40})}),(0,_.jsx)(R.Field,{label:(0,_.jsx)(R.Label,{children:(0,_.jsxs)(Je,{gap:.5,children:[(0,_.jsx)("span",{children:"Max lifetime"}),(0,_.jsx)(R.Tooltip,{content:(0,_.jsx)("span",{children:"The maximum amount of time in seconds a connection may be reused. If set to 0, connections are reused forever."}),children:(0,_.jsx)(R.Icon,{name:"info-circle",size:"sm"})})]})}),children:(0,_.jsx)(lR,{value:n.connMaxLifetime,defaultValue:pe.config.sqlConnectionLimits.connMaxLifetime,onChange:e=>{a("connMaxLifetime")(e)},width:40})})]})},pR=()=>{const e=(0,R.useStyles2)(fR);return(0,_.jsx)("hr",{className:e.horizontalDivider})},fR=e=>({horizontalDivider:(0,w.css)({borderTop:`1px solid ${e.colors.border.weak}`,margin:e.spacing(2,0),width:"100%"})}),hR=e=>{const{editorProps:t,showCACert:r,showKeyPair:n=!0}=e,{secureJsonFields:o}=t.options;return(0,_.jsxs)(_.Fragment,{children:[n?(0,_.jsx)(R.Field,{label:(0,_.jsx)(R.Label,{children:(0,_.jsxs)(R.Stack,{gap:.5,children:[(0,_.jsx)("span",{children:"TLS/SSL Client Certificate"}),(0,_.jsx)(R.Tooltip,{content:(0,_.jsx)("span",{children:"To authenticate with an TLS/SSL client certificate, provide the client certificate here."}),children:(0,_.jsx)(R.Icon,{name:"info-circle",size:"sm"})})]})}),children:(0,_.jsx)(R.SecretTextArea,{placeholder:"-----BEGIN CERTIFICATE-----",cols:45,rows:7,isConfigured:o&&o.tlsClientCert,onChange:(0,T.onUpdateDatasourceSecureJsonDataOption)(t,"tlsClientCert"),onReset:()=>{(0,T.updateDatasourcePluginResetOption)(t,"tlsClientCert")}})}):null,r?(0,_.jsx)(R.Field,{label:(0,_.jsx)(R.Label,{children:(0,_.jsxs)(R.Stack,{gap:.5,children:[(0,_.jsx)("span",{children:"TLS/SSL Root Certificate"}),(0,_.jsx)(R.Tooltip,{content:(0,_.jsx)("span",{children:"If the selected TLS/SSL mode requires a server root certificate, provide it here."}),children:(0,_.jsx)(R.Icon,{name:"info-circle",size:"sm"})})]})}),children:(0,_.jsx)(R.SecretTextArea,{placeholder:"-----BEGIN CERTIFICATE-----",cols:45,rows:7,isConfigured:o&&o.tlsCACert,onChange:(0,T.onUpdateDatasourceSecureJsonDataOption)(t,"tlsCACert"),onReset:()=>{(0,T.updateDatasourcePluginResetOption)(t,"tlsCACert")}})}):null,n?(0,_.jsx)(R.Field,{label:(0,_.jsx)(R.Label,{children:(0,_.jsxs)(R.Stack,{gap:.5,children:[(0,_.jsx)("span",{children:"TLS/SSL Client Key"}),(0,_.jsx)(R.Tooltip,{content:(0,_.jsx)("span",{children:"To authenticate with a client TLS/SSL certificate, provide the key here."}),children:(0,_.jsx)(R.Icon,{name:"info-circle",size:"sm"})})]})}),children:(0,_.jsx)(R.SecretTextArea,{placeholder:"-----BEGIN RSA PRIVATE KEY-----",cols:45,rows:7,isConfigured:o&&o.tlsClientKey,onChange:(0,T.onUpdateDatasourceSecureJsonDataOption)(t,"tlsClientKey"),onReset:()=>{(0,T.updateDatasourcePluginResetOption)(t,"tlsClientKey")}})}):null]})},vR=(0,pe.createMonitoringLogger)("features.plugins.sql");function gR(e,t,r){return t in e?Object.defineProperty(e,t,{value:r,enumerable:!0,configurable:!0,writable:!0}):e[t]=r,e}function yR(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{},n=Object.keys(r);"function"==typeof Object.getOwnPropertySymbols&&(n=n.concat(Object.getOwnPropertySymbols(r).filter((function(e){return Object.getOwnPropertyDescriptor(r,e).enumerable})))),n.forEach((function(t){gR(e,t,r[t])}))}return e}function mR(e,t){return t=null!=t?t:{},Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):function(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);r.push.apply(r,n)}return r}(Object(t)).forEach((function(r){Object.defineProperty(e,r,Object.getOwnPropertyDescriptor(t,r))})),e}function bR(e,t,r){return t in e?Object.defineProperty(e,t,{value:r,enumerable:!0,configurable:!0,writable:!0}):e[t]=r,e}const OR={dialect:"postgres"};var ER=Object.defineProperty,SR=Object.defineProperties,TR=Object.getOwnPropertyDescriptors,_R=Object.getOwnPropertySymbols,wR=Object.prototype.hasOwnProperty,RR=Object.prototype.propertyIsEnumerable,AR=(e,t,r)=>t in e?ER(e,t,{enumerable:!0,configurable:!0,writable:!0,value:r}):e[t]=r,CR=(e,t)=>{for(var r in t||(t={}))wR.call(t,r)&&AR(e,r,t[r]);if(_R)for(var r of _R(t))RR.call(t,r)&&AR(e,r,t[r]);return e};const IR=({dataSourceName:e,docsLink:t,hasRequiredFields:r=!0,className:n})=>{const o=(0,R.useTheme2)(),i={container:(0,w.css)({p:{margin:0},"p + p":{marginTop:o.spacing(2)}}),text:(0,w.css)((a=CR({},o.typography.body),s={color:o.colors.text.secondary,a:(0,w.css)({color:o.colors.text.link,textDecoration:"underline","&:hover":{textDecoration:"none"}})},SR(a,TR(s))))};var a,s;return me().createElement("div",{className:(0,w.cx)(i.container,n)},me().createElement("p",{className:i.text},"Before you can use the ",e," data source, you must configure it below or in the config file. For detailed instructions,"," ",me().createElement("a",{href:t,target:"_blank",rel:"noreferrer"},"view the documentation"),"."),r&&me().createElement("p",{className:i.text},me().createElement("i",null,"Fields marked with * are required")))};var xR=Object.defineProperty,LR=Object.defineProperties,NR=Object.getOwnPropertyDescriptors,jR=Object.getOwnPropertySymbols,PR=Object.prototype.hasOwnProperty,kR=Object.prototype.propertyIsEnumerable,FR=(e,t,r)=>t in e?xR(e,t,{enumerable:!0,configurable:!0,writable:!0,value:r}):e[t]=r;const DR=e=>{var t,r=e,{children:n}=r,o=((e,t)=>{var r={};for(var n in e)PR.call(e,n)&&t.indexOf(n)<0&&(r[n]=e[n]);if(null!=e&&jR)for(var n of jR(e))t.indexOf(n)<0&&kR.call(e,n)&&(r[n]=e[n]);return r})(r,["children"]);return me().createElement(O_,(t=((e,t)=>{for(var r in t||(t={}))PR.call(t,r)&&FR(e,r,t[r]);if(jR)for(var r of jR(t))kR.call(t,r)&&FR(e,r,t[r]);return e})({},o),LR(t,NR({kind:"section"}))),n)};var MR,VR;!function(e){e.disable="disable",e.require="require",e.verifyCA="verify-ca",e.verifyFull="verify-full"}(MR||(MR={})),function(e){e.filePath="file-path",e.fileContent="file-content"}(VR||(VR={}));var UR=p(1510);const BR=p.n(UR)(),qR=function(e,t){!function(e,t,r){var n=(0,ye.useRef)(void 0);n.current&&r(t,n.current)||(n.current=t),(0,ye.useEffect)(e,n.current)}(e,t,BR)};var GR,KR,WR,zR,$R,HR,YR,QR,XR,JR,ZR,eA,tA,rA,nA,oA,iA,aA,sA,lA,uA,cA,dA,pA,fA,hA,vA,gA,yA,mA,bA,OA,EA,SA,TA,_A,wA,RA,AA,CA,IA;function xA(e,t,r){return t in e?Object.defineProperty(e,t,{value:r,enumerable:!0,configurable:!0,writable:!0}):e[t]=r,e}!function(e){e.AlertStates="alertStates",e.Annotations="annotations",e.Series="series"}(GR||(GR={})),function(e){e.Linear="linear",e.Quad="quad"}(KR||(KR={})),function(e){e.Clamped="clamped",e.Mod="mod"}(WR||(WR={})),function(e){e.Field="field",e.Fixed="fixed",e.Template="template"}(zR||(zR={})),function(e){e.Field="field",e.Fixed="fixed",e.Mapping="mapping"}($R||($R={})),function(e){e.Auto="auto",e.Coords="coords",e.Geohash="geohash",e.Lookup="lookup"}(HR||(HR={})),function(e){e.Count="count",e.Size="size"}(YR||(YR={})),function(e){e.auto="auto",e.ge="ge",e.le="le",e.unknown="unknown"}(QR||(QR={})),function(e){e.Ascending="Ascending",e.Descending="Descending"}(XR||(XR={})),function(e){e.Auto="auto",e.Bottom="bottom",e.Hidden="hidden",e.Left="left",e.Right="right",e.Top="top"}(JR||(JR={})),function(e){e.Series="series",e.Text="text"}(ZR||(ZR={})),function(e){e.Always="always",e.Auto="auto",e.Never="never"}(eA||(eA={})),function(e){e.Bars="bars",e.Line="line",e.Points="points"}(tA||(tA={})),function(e){e.Constant="constant",e.NegativeY="negative-Y"}(rA||(rA={})),function(e){e.Linear="linear",e.Smooth="smooth",e.StepAfter="stepAfter",e.StepBefore="stepBefore"}(nA||(nA={})),function(e){e.Linear="linear",e.Log="log",e.Ordinal="ordinal",e.Symlog="symlog"}(oA||(oA={})),function(e){e.Hue="hue",e.None="none",e.Opacity="opacity",e.Scheme="scheme"}(iA||(iA={})),function(e){e.None="none",e.Normal="normal",e.Percent="percent"}(aA||(aA={})),function(e){e[e.After=1]="After",e[e.Before=-1]="Before",e[e.Center=0]="Center"}(sA||(sA={})),function(e){e[e.Horizontal=0]="Horizontal",e[e.Vertical=1]="Vertical"}(lA||(lA={})),function(e){e[e.Down=-1]="Down",e[e.Left=-1]="Left",e[e.Right=1]="Right",e[e.Up=1]="Up"}(uA||(uA={})),function(e){e.Area="area",e.Dashed="dashed",e.DashedAndArea="dashed+area",e.Line="line",e.LineAndArea="line+area",e.Off="off",e.Series="series"}(cA||(cA={})),function(e){e.Hidden="hidden",e.List="list",e.Table="table"}(dA||(dA={})),function(e){e.Auto="auto",e.Horizontal="horizontal",e.Vertical="vertical"}(pA||(pA={})),function(e){e.Background="background",e.BackgroundSolid="background_solid",e.None="none",e.Value="value"}(fA||(fA={})),function(e){e.Area="area",e.Line="line",e.None="none"}(hA||(hA={})),function(e){e.Auto="auto",e.Center="center"}(vA||(vA={})),function(e){e.Auto="auto",e.Name="name",e.None="none",e.Value="value",e.ValueAndName="value_and_name"}(gA||(gA={})),function(e){e.Inverted="inverted",e.SameAsValue="same_as_value",e.Standard="standard"}(yA||(yA={})),function(e){e.Multi="multi",e.None="none",e.Single="single"}(mA||(mA={})),function(e){e.Ascending="asc",e.Descending="desc",e.None="none"}(bA||(bA={})),function(e){e.Basic="basic",e.Gradient="gradient",e.Lcd="lcd"}(OA||(OA={})),function(e){e.Color="color",e.Hidden="hidden",e.Text="text"}(EA||(EA={})),function(e){e.Auto="auto",e.Left="left",e.Top="top"}(SA||(SA={})),function(e){e.Auto="auto",e.Manual="manual"}(TA||(TA={})),function(e){e.Auto="auto",e.BasicGauge="basic",e.ColorBackground="color-background",e.ColorBackgroundSolid="color-background-solid",e.ColorText="color-text",e.Custom="custom",e.DataLinks="data-links",e.Gauge="gauge",e.GradientGauge="gradient-gauge",e.Image="image",e.JSONView="json-view",e.LcdGauge="lcd-gauge",e.Sparkline="sparkline"}(_A||(_A={})),function(e){e.Basic="basic",e.Gradient="gradient"}(wA||(wA={})),function(e){e.Auto="auto",e.Lg="lg",e.Md="md",e.Sm="sm"}(RA||(RA={})),function(e){e.CSV="csv",e.Date="date",e.Distributed="distributed",e.DoubleQuote="doublequote",e.Glob="glob",e.HTML="html",e.JSON="json",e.Lucene="lucene",e.PercentEncode="percentencode",e.Pipe="pipe",e.QueryParam="queryparam",e.Raw="raw",e.Regex="regex",e.SQLString="sqlstring",e.SingleQuote="singlequote",e.Text="text",e.UriEncode="uriencode"}(AA||(AA={})),function(e){e.exact="exact",e.none="none",e.numbers="numbers",e.signature="signature"}(CA||(CA={})),function(e){e.EQ="eq",e.GT="gt",e.GTE="gte",e.LT="lt",e.LTE="lte",e.NEQ="neq"}(IA||(IA={}));class LA{interpolate(){var e;return(null===(e=this.templateSrv)||void 0===e?void 0:e.replace(this.target.rawSql,this.scopedVars,AA.SQLString))||""}quoteLiteral(e){return"'"+e.replace(/'/g,"''")+"'"}constructor(e,t,r){xA(this,"target",void 0),xA(this,"templateSrv",void 0),xA(this,"scopedVars",void 0),this.target=Re(e||{refId:"A"}),this.templateSrv=t,this.scopedVars=r}}function NA(e,t,r,n,o,i,a){try{var s=e[i](a),l=s.value}catch(e){return void r(e)}s.done?t(l):Promise.resolve(l).then(n,o)}function jA(e){return function(){var t=this,r=arguments;return new Promise((function(n,o){var i=e.apply(t,r);function a(e){NA(i,n,o,a,s,"next",e)}function s(e){NA(i,n,o,a,s,"throw",e)}a(void 0)}))}}function PA(e,t,r){return t in e?Object.defineProperty(e,t,{value:r,enumerable:!0,configurable:!0,writable:!0}):e[t]=r,e}const kA=({getColumns:e,getTables:t})=>(r,n)=>{return o=function(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{},n=Object.keys(r);"function"==typeof Object.getOwnPropertySymbols&&(n=n.concat(Object.getOwnPropertySymbols(r).filter((function(e){return Object.getOwnPropertyDescriptor(r,e).enumerable})))),n.forEach((function(t){PA(e,t,r[t])}))}return e}({},n&&Or(0,n)),i=null!=(i={tables:{resolve:jA((function*(){return yield t.current()}))},columns:{resolve:(a=jA((function*(t){return yield e.current({table:null==t?void 0:t.table,refId:"A"})})),function(e){return a.apply(this,arguments)})}})?i:{},Object.getOwnPropertyDescriptors?Object.defineProperties(o,Object.getOwnPropertyDescriptors(i)):function(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);r.push.apply(r,n)}return r}(Object(i)).forEach((function(e){Object.defineProperty(o,e,Object.getOwnPropertyDescriptor(i,e))})),o;var o,i,a};function FA(){return(FA=jA((function*(e,t){const r=yield e.fields(t);return r.length>0?r.map((e=>({name:e.value,type:e.value,description:e.value}))):[]}))).apply(this,arguments)}function DA(){return(DA=jA((function*(e){var t;return(yield null===(t=e.lookup)||void 0===t?void 0:t.call(e))||[]}))).apply(this,arguments)}function MA(e){switch(e){case"boolean":return{raqbFieldType:"boolean",icon:"toggle-off"};case"bit":case"bit varying":case"character":case"character varying":case"text":default:return{raqbFieldType:"text",icon:"text"};case"smallint":case"integer":case"bigint":case"decimal":case"numeric":case"real":case"double precision":case"serial":case"bigserial":case"smallserial":return{raqbFieldType:"number",icon:"calculator-alt"};case"date":return{raqbFieldType:"date",icon:"clock-nine"};case"time":case"time with time zone":case"time without time zone":case"interval":return{raqbFieldType:"time",icon:"clock-nine"};case"timestamp":case"timestamp with time zone":case"timestamp without time zone":return{raqbFieldType:"datetime",icon:"clock-nine"}}}function VA({sql:e,table:t}){var r,n,o,i;let a="";return e&&Se(e.columns)?(a+=`SELECT ${e.columns.map((e=>{let t="";var r;if(e.name&&e.alias)t+=`${e.name}(${null===(r=e.parameters)||void 0===r?void 0:r.map((e=>`${e.name}`))}) AS ${e.alias}`;else if(e.name){var n;t+=`${e.name}(${null===(n=e.parameters)||void 0===n?void 0:n.map((e=>`${e.name}`))})`}else if(e.alias){var o;t+=`${null===(o=e.parameters)||void 0===o?void 0:o.map((e=>`${e.name}`))} AS ${e.alias}`}else{var i;t+=`${null===(i=e.parameters)||void 0===i?void 0:i.map((e=>`${e.name}`))}`}return t})).join(", ")} `,t&&(a+=`FROM ${t} `),e.whereString&&(a+=`WHERE ${e.whereString} `),(null===(n=e.groupBy)||void 0===n||null===(r=n[0])||void 0===r?void 0:r.property.name)&&(a+=`GROUP BY ${e.groupBy.map((e=>e.property.name)).filter((e=>!(0,fe.isEmpty)(e))).join(", ")} `),(null===(o=e.orderBy)||void 0===o?void 0:o.property.name)&&(a+=`ORDER BY ${e.orderBy.property.name} `),(null===(i=e.orderBy)||void 0===i?void 0:i.property.name)&&e.orderByDirection&&(a+=`${e.orderByDirection} `),void 0!==e.limit&&e.limit>=0&&(a+=`LIMIT ${e.limit} `),a):a}function UA(e,t,r,n,o,i,a){try{var s=e[i](a),l=s.value}catch(e){return void r(e)}s.done?t(l):Promise.resolve(l).then(n,o)}function BA(e){return function(){var t=this,r=arguments;return new Promise((function(n,o){var i=e.apply(t,r);function a(e){UA(i,n,o,a,s,"next",e)}function s(e){UA(i,n,o,a,s,"throw",e)}a(void 0)}))}}function qA(e,t,r){return t in e?Object.defineProperty(e,t,{value:r,enumerable:!0,configurable:!0,writable:!0}):e[t]=r,e}function GA(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{},n=Object.keys(r);"function"==typeof Object.getOwnPropertySymbols&&(n=n.concat(Object.getOwnPropertySymbols(r).filter((function(e){return Object.getOwnPropertyDescriptor(r,e).enumerable})))),n.forEach((function(t){qA(e,t,r[t])}))}return e}class KA extends d_{getQueryModel(e,t,r){return new LA(e,t,r)}getVersion(){var e=this;return BA((function*(){var t;const r=null===(t=(yield e.runSql("SELECT current_setting('server_version_num')::int/100 as version")).fields.version)||void 0===t?void 0:t.values;return r?r[0].toString():""}))()}getTimescaleDBVersion(){var e=this;return BA((function*(){var t;const r=null===(t=(yield e.runSql("SELECT extversion FROM pg_extension WHERE extname = 'timescaledb'")).fields.extversion)||void 0===t?void 0:t.values;if(r)return r[0]}))()}fetchTables(){var e=this;return BA((function*(){var t,r;return null!==(r=null===(t=(yield e.runSql("select quote_ident(table_name) as \"table\" from information_schema.tables\n    where quote_ident(table_schema) not in ('information_schema',\n                             'pg_catalog',\n                             '_timescaledb_cache',\n                             '_timescaledb_catalog',\n                             '_timescaledb_internal',\n                             '_timescaledb_config',\n                             'timescaledb_information',\n                             'timescaledb_experimental')\n      and \n          quote_ident(table_schema) IN (\n          SELECT\n            CASE WHEN trim(s[i]) = '\"$user\"' THEN user ELSE trim(s[i]) END\n          FROM\n            generate_series(\n              array_lower(string_to_array(current_setting('search_path'),','),1),\n              array_upper(string_to_array(current_setting('search_path'),','),1)\n            ) as i,\n            string_to_array(current_setting('search_path'),',') s\n          )",{refId:"tables"})).fields.table)||void 0===t?void 0:t.values.flat())&&void 0!==r?r:[]}))()}getSqlLanguageDefinition(e){if(void 0!==this.sqlLanguageDefinition)return this.sqlLanguageDefinition;const t={getColumns:{current:t=>function(e,t){return FA.apply(this,arguments)}(e,t)},getTables:{current:()=>function(e){return DA.apply(this,arguments)}(e)}};return this.sqlLanguageDefinition={id:"pgsql",completionProvider:kA(t),formatter:Hr},this.sqlLanguageDefinition}fetchFields(e){var t=this;return BA((function*(){const{table:r}=e;if(void 0===r)return[];const n=yield t.runSql(function(e){return`select quote_ident(column_name) as "column", data_type as "type"\n    from information_schema.columns\n    where quote_ident(table_name) = ${"'"+e.replace(/'/g,"''")+"'"};\n    `}(r),{refId:"columns"}),o=[];for(let e=0;e<n.length;e++){const t=n.fields.column.values[e],r=n.fields.type.values[e];o.push(GA({label:t,value:t,type:r},MA(r)))}return o}))()}getDB(){if(void 0!==this.db)return this.db;var e,t=this,r=this;return{init:()=>Promise.resolve(!0),datasets:()=>Promise.resolve([]),tables:()=>this.fetchTables(),getEditorLanguageDefinition:()=>this.getSqlLanguageDefinition(this.db),fields:(e=BA((function*(e){return(null==e?void 0:e.table)?t.fetchFields(e):[]})),function(t){return e.apply(this,arguments)}),validateQuery:e=>Promise.resolve({isError:!1,isValid:!0,query:e,error:"",rawSql:e.rawSql}),dsID:()=>this.id,toRawSql:VA,lookup:BA((function*(){return(yield r.fetchTables()).map((e=>({name:e,completion:e})))}))}}constructor(e){super(e),qA(this,"sqlLanguageDefinition",void 0)}}function WA(e,t,r,n,o,i,a){try{var s=e[i](a),l=s.value}catch(e){return void r(e)}s.done?t(l):Promise.resolve(l).then(n,o)}function zA(e,t,r){return t in e?Object.defineProperty(e,t,{value:r,enumerable:!0,configurable:!0,writable:!0}):e[t]=r,e}const $A=[{label:"9.0",value:900},{label:"9.1",value:901},{label:"9.2",value:902},{label:"9.3",value:903},{label:"9.4",value:904},{label:"9.5",value:905},{label:"9.6",value:906},{label:"10",value:1e3},{label:"11",value:1100},{label:"12",value:1200},{label:"13",value:1300},{label:"14",value:1400},{label:"15",value:1500}],HA=new T.DataSourcePlugin(KA).setQueryEditor((function(e){return(0,_.jsx)(e_,(t=function(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{},n=Object.keys(r);"function"==typeof Object.getOwnPropertySymbols&&(n=n.concat(Object.getOwnPropertySymbols(r).filter((function(e){return Object.getOwnPropertyDescriptor(r,e).enumerable})))),n.forEach((function(t){bR(e,t,r[t])}))}return e}({},e),r=null!=(r={queryHeaderProps:OR})?r:{},Object.getOwnPropertyDescriptors?Object.defineProperties(t,Object.getOwnPropertyDescriptors(r)):function(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);r.push.apply(r,n)}return r}(Object(r)).forEach((function(e){Object.defineProperty(t,e,Object.getOwnPropertyDescriptor(r,e))})),t));var t,r})).setQueryEditorHelp((function(){const e=(0,R.useStyles2)(A);return(0,_.jsxs)("div",{children:[(0,_.jsx)("h2",{children:"PostgreSQL cheat sheet"}),"Time series:",(0,_.jsxs)("ul",{className:e.ulPadding,children:[(0,_.jsxs)("li",{children:["return column named ",(0,_.jsx)("i",{children:"time"})," (UTC in seconds or timestamp)"]}),(0,_.jsx)("li",{children:"return column(s) with numeric datatype as values"})]}),"Optional:",(0,_.jsxs)("ul",{className:e.ulPadding,children:[(0,_.jsxs)("li",{children:["return column named ",(0,_.jsx)("i",{children:"metric"})," to represent the series name."]}),(0,_.jsx)("li",{children:"If multiple value columns are returned the metric column is used as prefix."}),(0,_.jsx)("li",{children:"If no column named metric is found the column name of the value column is used as series name"})]}),(0,_.jsx)("p",{children:"Resultsets of time series queries need to be sorted by time."}),"Table:",(0,_.jsx)("ul",{className:e.ulPadding,children:(0,_.jsx)("li",{children:"return any set of columns"})}),"Macros:",(0,_.jsxs)("ul",{className:e.ulPadding,children:[(0,_.jsx)("li",{children:'$__time(column) -> column as "time"'}),(0,_.jsx)("li",{children:'$__timeEpoch -> extract(epoch from column) as "time"'}),(0,_.jsx)("li",{children:"$__timeFilter(column) -> column BETWEEN '2017-04-21T05:01:17Z' AND '2017-04-21T05:01:17Z'"}),(0,_.jsx)("li",{children:"$__unixEpochFilter(column) -> column >= 1492750877 AND column <= 1492750877"}),(0,_.jsx)("li",{children:"$__unixEpochNanoFilter(column) -> column >= 1494410783152415214 AND column <= 1494497183142514872"}),(0,_.jsx)("li",{children:"$__timeGroup(column,'5m'[, fillvalue]) -> (extract(epoch from column)/300)::bigint*300 by setting fillvalue grafana will fill in missing values according to the interval fillvalue can be either a literal value, NULL or previous; previous will fill in the previous seen value or NULL if none has been seen yet"}),(0,_.jsx)("li",{children:"$__timeGroupAlias(column,'5m') -> (extract(epoch from column)/300)::bigint*300 AS \"time\""}),(0,_.jsx)("li",{children:"$__unixEpochGroup(column,'5m') -> floor(column/300)*300"}),(0,_.jsx)("li",{children:"$__unixEpochGroupAlias(column,'5m') -> floor(column/300)*300 AS \"time\""})]}),(0,_.jsx)("p",{children:"Example of group by and order by with $__timeGroup:"}),(0,_.jsx)("pre",{children:(0,_.jsxs)("code",{children:["SELECT $__timeGroup(date_time_col, '1h'), sum(value) as value ",(0,_.jsx)("br",{}),"FROM yourtable",(0,_.jsx)("br",{}),"GROUP BY time",(0,_.jsx)("br",{}),"ORDER BY time",(0,_.jsx)("br",{})]})}),"Or build your own conditionals using these macros which just return the values:",(0,_.jsxs)("ul",{className:e.ulPadding,children:[(0,_.jsx)("li",{children:"$__timeFrom() -> '2017-04-21T05:01:17Z'"}),(0,_.jsx)("li",{children:"$__timeTo() -> '2017-04-21T05:01:17Z'"}),(0,_.jsx)("li",{children:"$__unixEpochFrom() -> 1492750877"}),(0,_.jsx)("li",{children:"$__unixEpochTo() -> 1492750877"}),(0,_.jsx)("li",{children:"$__unixEpochNanoFrom() -> 1494410783152415214"}),(0,_.jsx)("li",{children:"$__unixEpochNanoTo() -> 1494497183142514872"})]})]})})).setConfigEditor((e=>{const[t,r]=(0,ye.useState)($A),[n,o]=(0,ye.useState)(!0);(function({props:e,setVersionOptions:t}){const[r,n]=(0,ye.useState)(!1),{options:o,onOptionsChange:i}=e;qR((()=>{const e=(a=function*(){if(r){const e=yield(0,pe.getDataSourceSrv)().get(o.name);if(e instanceof KA){const r=yield e.getVersion(),n=parseInt(r,10);n>=906&&!o.jsonData.timescaledb&&(yield e.getTimescaleDBVersion())&&(0,T.updateDatasourcePluginJsonDataOption)({options:o,onOptionsChange:i},"timescaledb",!0);const a=Math.trunc(n/100),s=n%100;let l=String(a);n<1e3&&(l=String(a)+"."+String(s)),$A.find((e=>e.value===n))||t((e=>[...e,{label:l,value:n}])),void 0!==o.jsonData.postgresVersion&&o.jsonData.postgresVersion===n||(0,T.updateDatasourcePluginJsonDataOption)({options:o,onOptionsChange:i},"postgresVersion",n)}}else{const e=yield(0,pe.getBackendSrv)().put(`/api/datasources/${o.id}`,o);n(!0),(0,T.updateDatasourcePluginOption)({options:o,onOptionsChange:i},"version",e.datasource.version)}},s=function(){var e=this,t=arguments;return new Promise((function(r,n){var o=a.apply(e,t);function i(e){WA(o,r,n,i,s,"next",e)}function s(e){WA(o,r,n,i,s,"throw",e)}i(void 0)}))},function(){return s.apply(this,arguments)});var a,s;(function(e){var t,r;return e.url&&e.jsonData.database&&e.user&&((null===(t=e.secureJsonData)||void 0===t?void 0:t.password)||(null===(r=e.secureJsonFields)||void 0===r?void 0:r.password))&&(e.jsonData.sslmode===MR.disable||e.jsonData.sslCertFile&&e.jsonData.sslKeyFile&&e.jsonData.sslRootCertFile)&&!e.jsonData.postgresVersion&&!e.readOnly})(o)&&e()}),[o,r,t])})({props:e,setVersionOptions:r}),function({onOptionsChange:e,options:t}){(0,ye.useEffect)((()=>{const r=t.jsonData;let n=yR({},t),o=!1;if(t.database&&(vR.logDebug(`Migrating from options.database with value ${t.database} for ${t.name}`),n.database="",n.jsonData=mR(yR({},r),{database:t.database}),o=!0),void 0===r.maxOpenConns&&void 0===r.maxIdleConns&&void 0===r.maxIdleConnsAuto){const{maxOpenConns:e,maxIdleConns:t}=pe.config.sqlConnectionLimits;vR.logDebug(`Setting default max open connections to ${e} and setting max idle connection to ${t}`),n.jsonData=mR(yR({},n.jsonData),{maxOpenConns:e,maxIdleConns:t,maxIdleConnsAuto:!0}),o=!0}if(void 0===r.connMaxLifetime){const{connMaxLifetime:e}=pe.config.sqlConnectionLimits;n.jsonData=mR(yR({},n.jsonData),{connMaxLifetime:e}),o=!0}o&&e(n)}),[e,t])}(e);const{options:i,onOptionsChange:a}=e,s=i.jsonData,l=[{value:MR.disable,label:"disable"},{value:MR.require,label:"require"},{value:MR.verifyCA,label:"verify-ca"},{value:MR.verifyFull,label:"verify-full"}],u=[{value:VR.filePath,label:"File system path"},{value:VR.fileContent,label:"Certificate content"}],c=t=>r=>{(0,T.updateDatasourcePluginJsonDataOption)(e,t,r.value)},d=e=>t=>{a(function(e){for(var t=1;t<arguments.length;t++){var r=null!=arguments[t]?arguments[t]:{},n=Object.keys(r);"function"==typeof Object.getOwnPropertySymbols&&(n=n.concat(Object.getOwnPropertySymbols(r).filter((function(e){return Object.getOwnPropertyDescriptor(r,e).enumerable})))),n.forEach((function(t){zA(e,t,r[t])}))}return e}({},i,{[e]:t.currentTarget.value}))},p=40;return(0,_.jsxs)(_.Fragment,{children:[(0,_.jsx)(IR,{dataSourceName:"Postgres",docsLink:"https://grafana.com/docs/grafana/latest/datasources/postgres/",hasRequiredFields:!0}),(0,_.jsx)(pR,{}),(0,_.jsxs)(R.Collapse,{collapsible:!0,label:"User Permissions",isOpen:n,onToggle:()=>o((e=>!e)),children:["The database user should only be granted SELECT permissions on the specified database & tables you want to query. ",(0,_.jsx)("br",{}),"Grafana does not validate that queries are safe so queries can contain any SQL statement. For example, statements like ",(0,_.jsx)("code",{children:"DELETE FROM user;"})," and ",(0,_.jsx)("code",{children:"DROP TABLE user;"})," would be executed. ",(0,_.jsx)("br",{}),"To protect against this we ",(0,_.jsx)("strong",{children:"Highly"})," recommend you create a specific PostgreSQL user with restricted permissions. Check out the docs for more information."]}),(0,_.jsx)(pR,{}),(0,_.jsxs)(DR,{title:"Connection",children:[(0,_.jsx)(R.Field,{label:"Host URL",required:!0,children:(0,_.jsx)(R.Input,{width:p,name:"host",type:"text",value:i.url||"",placeholder:"localhost:5432",onChange:d("url")})}),(0,_.jsx)(R.Field,{label:"Database name",required:!0,children:(0,_.jsx)(R.Input,{width:p,name:"database",value:s.database||"",placeholder:"Database",onChange:(0,T.onUpdateDatasourceJsonDataOption)(e,"database")})})]}),(0,_.jsx)(pR,{}),(0,_.jsxs)(DR,{title:"Authentication",children:[(0,_.jsx)(R.Field,{label:"Username",required:!0,children:(0,_.jsx)(R.Input,{width:p,value:i.user||"",placeholder:"Username",onChange:d("user")})}),(0,_.jsx)(R.Field,{label:"Password",required:!0,children:(0,_.jsx)(R.SecretInput,{width:p,placeholder:"Password",isConfigured:i.secureJsonFields&&i.secureJsonFields.password,onReset:()=>{(0,T.updateDatasourcePluginResetOption)(e,"password")},onBlur:(0,T.onUpdateDatasourceSecureJsonDataOption)(e,"password")})}),(0,_.jsx)(R.Field,{label:(0,_.jsx)(R.Label,{children:(0,_.jsxs)(Je,{gap:.5,children:[(0,_.jsx)("span",{children:"TLS/SSL Mode"}),(0,_.jsx)(R.Tooltip,{content:(0,_.jsx)("span",{children:"This option determines whether or with what priority a secure TLS/SSL TCP/IP connection will be negotiated with the server"}),children:(0,_.jsx)(R.Icon,{name:"info-circle",size:"sm"})})]})}),children:(0,_.jsx)(R.Select,{options:l,value:s.sslmode||MR.require,onChange:c("sslmode"),width:p})}),i.jsonData.sslmode!==MR.disable?(0,_.jsx)(R.Field,{label:(0,_.jsx)(R.Label,{children:(0,_.jsxs)(Je,{gap:.5,children:[(0,_.jsx)("span",{children:"TLS/SSL Method"}),(0,_.jsx)(R.Tooltip,{content:(0,_.jsxs)("span",{children:["This option determines how TLS/SSL certifications are configured. Selecting"," ",(0,_.jsx)("i",{children:"File system path"})," will allow you to configure certificates by specifying paths to existing certificates on the local file system where Grafana is running. Be sure that the file is readable by the user executing the Grafana process.",(0,_.jsx)("br",{}),(0,_.jsx)("br",{}),"Selecting ",(0,_.jsx)("i",{children:"Certificate content"})," will allow you to configure certificates by specifying its content. The content will be stored encrypted in Grafana's database. When connecting to the database the certificates will be written as files to Grafana's configured data path on the local file system."]}),children:(0,_.jsx)(R.Icon,{name:"info-circle",size:"sm"})})]})}),children:(0,_.jsx)(R.Select,{options:u,value:s.tlsConfigurationMethod||VR.filePath,onChange:c("tlsConfigurationMethod"),width:p})}):null]}),s.sslmode!==MR.disable?(0,_.jsxs)(_.Fragment,{children:[(0,_.jsx)(pR,{}),(0,_.jsx)(DR,{title:"TLS/SSL Auth Details",children:s.tlsConfigurationMethod===VR.fileContent?(0,_.jsx)(hR,{showCACert:s.sslmode===MR.verifyCA||s.sslmode===MR.verifyFull,editorProps:e,labelWidth:p}):(0,_.jsxs)(_.Fragment,{children:[(0,_.jsx)(R.Field,{label:(0,_.jsx)(R.Label,{children:(0,_.jsxs)(Je,{gap:.5,children:[(0,_.jsx)("span",{children:"TLS/SSL Root Certificate"}),(0,_.jsx)(R.Tooltip,{content:(0,_.jsx)("span",{children:"If the selected TLS/SSL mode requires a server root certificate, provide the path to the file here."}),children:(0,_.jsx)(R.Icon,{name:"info-circle",size:"sm"})})]})}),children:(0,_.jsx)(R.Input,{value:s.sslRootCertFile||"",onChange:(0,T.onUpdateDatasourceJsonDataOption)(e,"sslRootCertFile"),placeholder:"TLS/SSL root cert file",width:p})}),(0,_.jsx)(R.Field,{label:(0,_.jsx)(R.Label,{children:(0,_.jsxs)(Je,{gap:.5,children:[(0,_.jsx)("span",{children:"TLS/SSL Client Certificate"}),(0,_.jsx)(R.Tooltip,{content:(0,_.jsx)("span",{children:"To authenticate with an TLS/SSL client certificate, provide the path to the file here. Be sure that the file is readable by the user executing the grafana process."}),children:(0,_.jsx)(R.Icon,{name:"info-circle",size:"sm"})})]})}),children:(0,_.jsx)(R.Input,{value:s.sslCertFile||"",onChange:(0,T.onUpdateDatasourceJsonDataOption)(e,"sslCertFile"),placeholder:"TLS/SSL client cert file",width:p})}),(0,_.jsx)(R.Field,{label:(0,_.jsx)(R.Label,{children:(0,_.jsxs)(Je,{gap:.5,children:[(0,_.jsx)("span",{children:"TLS/SSL Client Key"}),(0,_.jsx)(R.Tooltip,{content:(0,_.jsxs)("span",{children:["To authenticate with a client TLS/SSL certificate, provide the path to the corresponding key file here. Be sure that the file is ",(0,_.jsx)("i",{children:"only"})," readable by the user executing the grafana process."]}),children:(0,_.jsx)(R.Icon,{name:"info-circle",size:"sm"})})]})}),children:(0,_.jsx)(R.Input,{value:s.sslKeyFile||"",onChange:(0,T.onUpdateDatasourceJsonDataOption)(e,"sslKeyFile"),placeholder:"TLS/SSL client key file",width:p})})]})})]}):null,(0,_.jsx)(pR,{}),(0,_.jsxs)(DR,{title:"Additional settings",isCollapsible:!0,children:[(0,_.jsxs)(C_,{title:"PostgreSQL Options",children:[(0,_.jsx)(R.Field,{label:(0,_.jsx)(R.Label,{children:(0,_.jsxs)(Je,{gap:.5,children:[(0,_.jsx)("span",{children:"Version"}),(0,_.jsx)(R.Tooltip,{content:(0,_.jsx)("span",{children:"This option controls what functions are available in the PostgreSQL query builder"}),children:(0,_.jsx)(R.Icon,{name:"info-circle",size:"sm"})})]})}),children:(0,_.jsx)(R.Select,{value:s.postgresVersion||903,onChange:c("postgresVersion"),options:t,width:p})}),(0,_.jsx)(R.Field,{label:(0,_.jsx)(R.Label,{children:(0,_.jsxs)(Je,{gap:.5,children:[(0,_.jsx)("span",{children:"Min time interval"}),(0,_.jsx)(R.Tooltip,{content:(0,_.jsxs)("span",{children:["A lower limit for the auto group by time interval. Recommended to be set to write frequency, for example",(0,_.jsx)("code",{children:"1m"})," if your data is written every minute."]}),children:(0,_.jsx)(R.Icon,{name:"info-circle",size:"sm"})})]})}),children:(0,_.jsx)(R.Input,{placeholder:"1m",value:s.timeInterval||"",onChange:(0,T.onUpdateDatasourceJsonDataOption)(e,"timeInterval"),width:p})}),(0,_.jsx)(R.Field,{label:(0,_.jsx)(R.Label,{children:(0,_.jsxs)(Je,{gap:.5,children:[(0,_.jsx)("span",{children:"TimescaleDB"}),(0,_.jsx)(R.Tooltip,{content:(0,_.jsxs)("span",{children:["TimescaleDB is a time-series database built as a PostgreSQL extension. If enabled, Grafana will use",(0,_.jsx)("code",{children:"time_bucket"})," in the ",(0,_.jsx)("code",{children:"$__timeGroup"})," macro and display TimescaleDB specific aggregate functions in the query builder."]}),children:(0,_.jsx)(R.Icon,{name:"info-circle",size:"sm"})})]})}),children:(0,_.jsx)(R.Switch,{value:s.timescaledb||!1,onChange:t=>{(0,T.updateDatasourcePluginJsonDataOption)(e,"timescaledb",t.currentTarget.checked)},width:p})})]}),(0,_.jsx)(dR,{options:i,onOptionsChange:a}),pe.config.secureSocksDSProxyEnabled&&(0,_.jsx)(R.SecureSocksProxySettings,{options:i,onOptionsChange:a})]})]})}))})(),f})()));
//# sourceMappingURL=module.js.map